-- Created		01/12/2004
-- Modified:	18/10/2019
-- Project		Paghe Open
-- Model		Blob (Db)
-- Company		Iubar.it (http://www.iubar.it)
-- Author		ing. Andrea Borgogelli Avveduti (info@iubar.it)
-- Version:		01.45.00
-- Database		Firebird

/******************************************************************************/
/****                                DB                                    ****/
/******************************************************************************/

CREATE DATABASE 'localhost:C:\Users\Iubar\AppData\Local\Temp\fdb\blob.fdb'
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 4096
DEFAULT CHARACTER SET UTF8;

SET ECHO OFF ;

/******************************************************************************/
/****                                Domains                               ****/
/******************************************************************************/

Create Domain Note As Varchar(500);
Create Domain IdUser As Varchar(50);


/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


Create Table Documento  (
	IdDocumento Integer NOT NULL,
	IdRevisione Smallint NOT NULL,
	IdTipoDocumento Smallint,
	IdTipoFile Smallint,
	IdCategoria1 Smallint,
	IdStato Smallint,
	Descrizione Note,
	AutoreIdAnagrafica Integer,
	AutoreUser IdUser,
	ArchiviazioneData Date,
	RevisoreIdAnagrafica Integer,
	RevisoreUser IdUser,
	RevisioneData Date,
	Dati blob sub_type 0 segment size 80,
	NomeFile Varchar(300),
	PercorsoFile Varchar(300),
	PercorsoUpload Varchar(300),
	IdRiferimento1 Integer,
	IdRiferimento2 Integer,
	IdRiferimento3 Integer,
	IdRiferimento4 Integer,
	IdRiferimento5 Integer,
	RiferimentoMese Smallint,
	RiferimentoAnno Integer,
	RiferimentoData Date,
	Note Varchar(2000),
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_Documento Primary Key (IdDocumento,IdRevisione)
);

Create Table TipoFile  (
	IdTipoFile Smallint NOT NULL,
	Descrizione Varchar(200),
	Estensione Varchar(4),
Constraint pk_TipoFile Primary Key (IdTipoFile)
);

Create Table DbInfo  (
	Id Smallint NOT NULL,
	Descrizione Varchar(200),
	Valore Note,
 Primary Key (Id)
);

Create Table TipoDocumento  (
	IdTipoDocumento Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoDocumento Primary Key (IdTipoDocumento)
);

Create Table Categoria1  (
	IdCategoria1 Smallint NOT NULL,
	IdCategoria2 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Categoria1 Primary Key (IdCategoria1)
);

Create Table Gategoria2  (
	IdCategoria2 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Gategoria2 Primary Key (IdCategoria2)
);

Create Table RelazioneDocumento  (
	IdDocumento1 Integer NOT NULL,
	IdRevisione1 Smallint NOT NULL,
	IdDocumento2 Integer NOT NULL,
	IdRevisione2 Smallint NOT NULL,
Constraint pk_RelazioneDocumento Primary Key (IdDocumento1,IdRevisione1,IdDocumento2,IdRevisione2)
);

Create Table Archivio_Documento  (
	IdArchivio Integer NOT NULL,
	IdDocumento Integer NOT NULL,
	IdRevisione Smallint NOT NULL,
Constraint pk_Archivio_Documento Primary Key (IdArchivio,IdDocumento,IdRevisione)
);

Create Table TagDocumento  (
	IdDocumento Integer NOT NULL,
	IdRevisione Smallint NOT NULL,
	IdTag Smallint NOT NULL,
	Tag Note,
Constraint pk_TagDocumento Primary Key (IdDocumento,IdRevisione,IdTag)
);

Create Table TipoTag  (
	IdTag Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoTag Primary Key (IdTag)
);

Create Table TagArchivio  (
	IdArchivio Integer NOT NULL,
	IdTag Smallint NOT NULL,
	Tag Note,
Constraint pk_TagArchivio Primary Key (IdArchivio,IdTag)
);

Create Table Archivio  (
	IdArchivio Integer NOT NULL,
	PercorsoFile Varchar(300),
	RiferimentoData Date,
	IdRiferimento1 Integer,
	IdRiferimento2 Integer,
	IdRiferimento3 Integer,
	IdRiferimento4 Integer,
	IdRiferimento5 Integer,
	RiferimentoMese Smallint,
	RiferimentoAnno Integer,
	AutoreIdAnagrafica Integer,
	AutoreUser IdUser,
	CreazioneData Date,
	Note Note,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_Archivio Primary Key (IdArchivio)
);

Create Table Stato  (
	IdStato Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Stato Primary Key (IdStato)
);


COMMIT WORK;


/******************************************************************************/
/****                                Indexes                               ****/
/******************************************************************************/

Alter Table RelazioneDocumento add Constraint Relationship6 Foreign Key (IdDocumento1,IdRevisione1) references Documento (IdDocumento,IdRevisione) on update no action on delete no action ;
Alter Table RelazioneDocumento add Constraint Relationship7 Foreign Key (IdDocumento2,IdRevisione2) references Documento (IdDocumento,IdRevisione) on update no action on delete no action ;
Alter Table Archivio_Documento add Constraint Relationship8 Foreign Key (IdDocumento,IdRevisione) references Documento (IdDocumento,IdRevisione) on update no action on delete no action ;
Alter Table TagDocumento add Constraint Relationship11 Foreign Key (IdDocumento,IdRevisione) references Documento (IdDocumento,IdRevisione) on update no action on delete no action ;
Alter Table Documento add Constraint Relationship3 Foreign Key (IdTipoFile) references TipoFile (IdTipoFile) on update no action on delete no action ;
Alter Table Documento add Constraint Relationship2 Foreign Key (IdTipoDocumento) references TipoDocumento (IdTipoDocumento) on update no action on delete no action ;
Alter Table Documento add Constraint Relationship5 Foreign Key (IdCategoria1) references Categoria1 (IdCategoria1) on update no action on delete no action ;
Alter Table Categoria1 add Constraint Relationship4 Foreign Key (IdCategoria2) references Gategoria2 (IdCategoria2) on update no action on delete no action ;
Alter Table TagDocumento add Constraint Relationship13 Foreign Key (IdTag) references TipoTag (IdTag) on update no action on delete no action ;
Alter Table TagArchivio add Constraint Relationship15 Foreign Key (IdTag) references TipoTag (IdTag) on update no action on delete no action ;
Alter Table TagArchivio add Constraint Relationship18 Foreign Key (IdArchivio) references Archivio (IdArchivio) on update no action on delete no action ;
Alter Table Archivio_Documento add Constraint Relationship19 Foreign Key (IdArchivio) references Archivio (IdArchivio) on update no action on delete no action ;
Alter Table Documento add Constraint Relationship20 Foreign Key (IdStato) references Stato (IdStato) on update no action on delete no action ;


COMMIT WORK;


/******************************************************************************/
/****                                Exceptions                            ****/
/******************************************************************************/

Create Exception except_del_p 'Children still exist in child table. Cannot delete parent.';
Create Exception except_ins_ch 'Parent does not exist. Cannot create child.';
Create Exception except_upd_ch 'Parent does not exist. Cannot update child.';
Create Exception except_upd_p 'Children still exist in child table. Cannot update parent.';
Create Exception except_ins_ch_card 'Maximum cardinality exceeded. Cannot insert into child.';
Create Exception except_upd_ch_card 'Maximum cardinality exceeded. Cannot update child.';



/******************************************************************************/
/****                                Done                                  ****/
/******************************************************************************/

COMMIT WORK;

/******************************************************************************/
/****                                Data                                  ****/
/******************************************************************************/

UPDATE OR INSERT INTO DBINFO (ID, DESCRIZIONE, VALORE) VALUES (1, 'Versione del db', '01.45.00');
INSERT INTO DBINFO (ID, DESCRIZIONE, VALORE) VALUES (2, 'Data installazione', CURRENT_DATE);
UPDATE OR INSERT INTO DBINFO (ID, DESCRIZIONE, VALORE) VALUES (4, 'Richiede client versione minima', '01.97.00');

/*
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES (40, 'Documento Word', 'doc');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES (41, 'Foglio Excel', 'xls');
*/

INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('0', 'Sconosciuto', '');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('1', 'Documento Pdf', 'pdf');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('11', 'Documento OpenDocument', 'odt');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('12', 'Foglio OpenDocument', 'ods');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('30', 'Documento Xml', 'xml');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('31', 'File Xfdf', 'xfdf');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('50', 'Testo semplice', 'txt');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('51', 'File Doc', 'doc');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('52', 'File Docx', 'docx');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('53', 'File Xls', 'xls');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('54', 'File Xlsx', 'xlsx');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('55', 'File Jpeg', 'jpeg');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('56', 'File Jpg', 'jpg');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('57', 'File Png', 'png');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('58', 'File Bmp', 'bmp');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('59', 'File Gif', 'gif');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('60', 'File Ods', 'ods');
INSERT INTO TIPOFILE (IDTIPOFILE, DESCRIZIONE, ESTENSIONE) VALUES ('61', 'File Odt', 'odt');

INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('0', 'Sconosciuto');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('1', 'Cedolino');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('21', 'F24 Cartaceo');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('24', 'F24 Telematico Entratel (singola sede aziendale)');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('25', 'F24 Telematico Entratel (multi aziendale)');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('27', 'F24 Telematico CBI (singola sede aziendale)');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('28', 'F24 Telematico CBI (multi aziendale)');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('40', '770 Cartaceo');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('41', '770 Telematico Entratel (singola azienda)');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('42', '770 Telematico Entratel (multi aziendale)');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('51', 'CU lavoratore Cartaceo');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('52', 'CU datore Cartaceo');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('53', 'CU Telematico');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('60', 'Bonifici Sepa');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('61', 'UniEmens');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('62', 'Mut');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('63', 'Dmag');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('70', 'Report');
INSERT INTO TIPODOCUMENTO (IDTIPODOCUMENTO, DESCRIZIONE) VALUES ('80', 'Altri documenti');

COMMIT WORK;


INSERT INTO STATO (IDSTATO, DESCRIZIONE) VALUES ('0', 'Sconosciuto');
INSERT INTO STATO (IDSTATO, DESCRIZIONE) VALUES ('1', 'Protetto (ovvero non sovrascrivibile)');


/******************************************************************************/
/****                                Done                                  ****/
/******************************************************************************/

COMMIT WORK;