-- Created		01/12/2004
-- Modified:	18/10/2019
-- Project		Paghe Open
-- Model		Common (Db)
-- Company		Iubar.it (http://www.iubar.it)
-- Author		ing. Andrea Borgogelli Avveduti (info@iubar.it)
-- Version:		01.45.00
-- Database		Firebird

/******************************************************************************/
/****                                DB                                    ****/
/******************************************************************************/

CREATE DATABASE 'localhost:C:\Users\Iubar\AppData\Local\Temp\fdb\common.fdb'
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 4096
DEFAULT CHARACTER SET UTF8;

SET ECHO OFF ;

/******************************************************************************/
/****                                Domains                               ****/
/******************************************************************************/

Create Domain Currency As Decimal(15,6);
Create Domain Percentage As Decimal(7,6);
Create Domain Booleanint As Smallint CHECK (value is null or value in (0, 1));
Create Domain Arithmetic As Decimal(6,2);
Create Domain Note As Varchar(500);
Create Domain Note2 As Varchar(2000);
Create Domain Arithmetic2 As Decimal(16,6);



/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


Create Table F24_Concessione  (
	IdConcessione Integer NOT NULL,
	Concessione Varchar(200),
Constraint pk_F24_Concessione Primary Key (IdConcessione)
);

Create Table F24_TipoAltroEnte  (
	IdEnte Smallint NOT NULL,
	IdEnte2 Varchar(4) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_F24_TipoAltroEnte Primary Key (IdEnte)
);

Create Table F24_OLD_Erel  (
	Tributo Varchar(5) NOT NULL,
	Modalita Varchar(5),
	Tipo Varchar(50),
	Riferimento Varchar(5),
	RiferimentoAnno Varchar(10),
	Ufficio Varchar(3),
	Atto Varchar(3),
	Descrizione Varchar(400),
Constraint pk_F24_OLD_Erel Primary Key (Tributo)
);

Create Table F24_OLD_AccisaMonopolioAltro  (
	Tributo Varchar(5) NOT NULL,
	Provincia Varchar(3),
	Codice Varchar(100),
	Mese Varchar(2),
	Anno Varchar(5),
	Descrizione Varchar(200),
Constraint pk_F24_OLD_AccisaMonopolioAltro Primary Key (Tributo)
);

Create Table F24_AccisaEnte  (
	IdEnte Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_F24_AccisaEnte Primary Key (IdEnte)
);

Create Table F24_OLD_IciTributoComunale  (
	Tributo Varchar(5) NOT NULL,
	Modalita Varchar(5),
	Tipo Varchar(50),
	Riferimento Varchar(5),
	RiferimentoAnno Varchar(10),
	Ufficio Varchar(3),
	Atto Varchar(3),
	Descrizione Varchar(400),
Constraint pk_F24_OLD_IciTributoComunale Primary Key (Tributo)
);

Create Table F24_OLD_ContributoInpdap  (
	Codice Varchar(5) NOT NULL,
	Descrizione Varchar(200),
	TipoInizio Varchar(400),
	TipoFine Varchar(400),
Constraint pk_F24_OLD_ContributoInpdap Primary Key (Codice)
);

Create Table F24_OLD_CausaleInps  (
	Causale Varchar(200) NOT NULL,
	TipoSoggetto Varchar(120),
	MatricolaInps Varchar(40),
	InizioRiferimento Varchar(400),
	FineRiferimento Varchar(400),
	Modalita Varchar(3),
Constraint pk_F24_OLD_CausaleInps Primary Key (Causale)
);

Create Table F24_OLD_Tributo36  (
	Tributo Varchar(5) NOT NULL,
	Modalita Varchar(3),
	Tipo Varchar(20),
	Riferimento Varchar(5),
	RiferimentoAnno Varchar(5),
	CodUfficio Varchar(5),
	CodAtto Varchar(3),
	Descrizione Varchar(200),
Constraint pk_F24_OLD_Tributo36 Primary Key (Tributo)
);

Create Table F24_OLD_CausaleEnpals  (
	Codice Varchar(5) NOT NULL,
	Descrizione Varchar(400),
	TipoInizio Varchar(400),
	TipoFine Varchar(400),
Constraint pk_F24_OLD_CausaleEnpals Primary Key (Codice)
);

Create Table F24_UfficioFinanziario  (
	IdUfficio Integer NOT NULL,
	IdTipo Varchar(2) NOT NULL,
	Codice Varchar(4) NOT NULL,
	Denominazione Varchar(200),
	DataAttivazione Date,
	DataSoppressione Date,
	Provincia Varchar(200),
	Ambito Integer,
Constraint pk_F24_UfficioFinanziario Primary Key (IdUfficio)
);

Create Table M770_StatoSocPeriodoImposta  (
	IdStatoSoc Smallint NOT NULL,
	Descrizione Varchar(400),
Constraint pk_M770_StatoSocPeriodoImposta Primary Key (IdStatoSoc)
);

Create Table M770_CausaleConguaglio  (
	IdCausa Smallint NOT NULL,
	Descrizione Varchar(400),
Constraint pk_M770_CausaleConguaglio Primary Key (IdCausa)
);

Create Table M770_CategoriaParticolare  (
	IdCategoria Varchar(2) NOT NULL,
	Descrizione Varchar(400),
Constraint pk_M770_CategoriaParticolare Primary Key (IdCategoria)
);

Create Table M770_StatoServizio  (
	IdStatoSer Smallint NOT NULL,
	Descrizione Varchar(400),
Constraint pk_M770_StatoServizio Primary Key (IdStatoSer)
);

Create Table M770_TipoCessazione  (
	IdTipo Smallint NOT NULL,
	Descrizione Varchar(400),
Constraint pk_M770_TipoCessazione Primary Key (IdTipo)
);

Create Table F24_EnteLocale  (
	IdEnte Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_F24_EnteLocale Primary Key (IdEnte)
);

Create Table F24_TipoUffFinanziario  (
	IdTipo Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_F24_TipoUffFinanziario Primary Key (IdTipo)
);

Create Table F24_OLD_CausaleInpdai  (
	Codice Varchar(5) NOT NULL,
	Descrizione Varchar(50),
	InizioRiferimento Varchar(400),
	FineRiferimento Varchar(400),
Constraint pk_F24_OLD_CausaleInpdai Primary Key (Codice)
);

Create Table F24_TributoErario  (
	IdTributo Integer NOT NULL,
	Tributo Varchar(4) NOT NULL,
	Tipo Varchar(100),
	Descrizione Varchar(300),
	Modalita Varchar(1),
	Riferimento Varchar(8),
	RiferimentoDa Varchar(8),
	RiferimentoA Varchar(8),
	Flag1 Varchar(1),
	Flag2 Varchar(2),
	Flag3 Varchar(1),
Constraint pk_F24_TributoErario Primary Key (IdTributo)
);

Create Table F24_TributoIvaUe  (
	Tributo Varchar(4) NOT NULL,
	Descrizione Varchar(200),
	Tipo Varchar(1),
	Riferimento Varchar(8),
	DataA Varchar(8),
	DataDa Varchar(8),
Constraint pk_F24_TributoIvaUe Primary Key (Tributo)
);

Create Table F24_TributoEnteLocale  (
	Tributo Varchar(4) NOT NULL,
	Tipo Varchar(50),
	Descrizione Varchar(200),
	Flag1 Varchar(1),
	Riferimento Varchar(8),
	DataDa Varchar(8),
	DataA Varchar(8),
	Flag2 Varchar(1),
	Flag3 Varchar(1),
	Flag4 Varchar(1),
Constraint pk_F24_TributoEnteLocale Primary Key (Tributo)
);

Create Table F24_TributoRegione  (
	Tributo Varchar(4) NOT NULL,
	Tipo Varchar(100),
	Descrizione Varchar(200),
	Flag1 Varchar(1),
	Riferimento Varchar(8),
	DataDa Varchar(8),
	DataA Varchar(8),
	Flag2 Varchar(1),
	Flag3 Varchar(1),
Constraint pk_F24_TributoRegione Primary Key (Tributo)
);

Create Table F24_TributoAccisa  (
	Tributo Varchar(4) NOT NULL,
	IdEnte Varchar(2) NOT NULL,
	Descrizione Varchar(200),
	Flag1 Varchar(20),
	Flag2 Varchar(1),
	Flag3 Varchar(1),
	Flag4 Varchar(1),
	RiferimentoDa Varchar(8),
	RiferimentoA Varchar(8),
Constraint pk_F24_TributoAccisa Primary Key (Tributo)
);

Create Table F24_CausaleAltroEnte  (
	Causale Varchar(4) NOT NULL,
	IdEnte Smallint NOT NULL,
	Flag1 Varchar(1),
	Flag2 Varchar(1),
	Flag3 Varchar(1),
	Descrizione Varchar(200),
Constraint pk_F24_CausaleAltroEnte Primary Key (Causale)
);

Create Table F24_TipoTributoErario  (
	IdTipo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_F24_TipoTributoErario Primary Key (IdTipo)
);

Create Table F24_Ufficio  (
	IdUfficio Varchar(3) NOT NULL,
	Gruppo Varchar(1),
	Descrizione Varchar(200),
	Oggetto Varchar(200),
Constraint pk_F24_Ufficio Primary Key (IdUfficio)
);

Create Table F24_CausaleInps  (
	Causale Varchar(4) NOT NULL,
	Formato Varchar(3),
	Descrizione Varchar(200),
Constraint pk_F24_CausaleInps Primary Key (Causale)
);

Create Table M770_PercentualeSgravio  (
	IdCodice Smallint NOT NULL,
	Descrizione Varchar(200),
	Percentuale Decimal(6,4),
Constraint pk_M770_PercentualeSgravio Primary Key (IdCodice)
);

Create Table DbInfo  (
	Id Smallint NOT NULL,
	Descrizione Varchar(200),
	Valore Note,
 Primary Key (Id)
);

Create Table Consiglio  (
	IdConsiglio Integer NOT NULL,
	Titolo Varchar(200),
	Descrizione Varchar(2000),
	IdApp Smallint,
	IdStato Smallint,
Constraint pk_Consiglio Primary Key (IdConsiglio)
);

Create Table Help  (
	IdHelp Integer NOT NULL,
	Titolo Varchar(200),
	Link Varchar(200),
	Descrizione Note2,
	IdApp Smallint,
	IdStato Smallint,
	IdTipo Smallint,
Constraint pk_Help Primary Key (IdHelp)
);

Create Table Misura  (
	IdMisura Smallint NOT NULL,
	Descrizione Varchar(100),
	Simbolo Varchar(10),
Constraint pk_Misura Primary Key (IdMisura)
);

Create Table HelpContestualeLivello1  (
	IdLivello1 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_HelpContestualeLivello1 Primary Key (IdLivello1)
);

Create Table HelpContestuale  (
	IdLivello1 Smallint NOT NULL,
	IdLivello2 Smallint NOT NULL,
	IdLivello3 Smallint NOT NULL,
	Descrizione Varchar(200),
	Url Varchar(200),
	IdStato Smallint,
Constraint pk_HelpContestuale Primary Key (IdLivello1,IdLivello2,IdLivello3)
);

Create Table HelpContestualeLivello2  (
	IdLivello1 Smallint NOT NULL,
	IdLivello2 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_HelpContestualeLivello2 Primary Key (IdLivello1,IdLivello2)
);

Create Table Enpals_TipoAttivita  (
	IdTipoAttivita Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Enpals_TipoAttivita Primary Key (IdTipoAttivita)
);

Create Table Enpals_TipoLavoratore  (
	IdTipoLavoratore Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Enpals_TipoLavoratore Primary Key (IdTipoLavoratore)
);

Create Table Enpals_Grupporetribuzione  (
	IdGruppo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Enpals_Grupporetribuzione Primary Key (IdGruppo)
);

Create Table Enpals_Tiporetribuzione  (
	IdTipoRetribuzione Varchar(3) NOT NULL,
	IdGruppo Smallint,
	Descrizione Note,
	FonteAmministrativa Varchar(200),
	FonteNormativa Varchar(200),
	Note Note,
Constraint pk_Enpals_Tiporetribuzione Primary Key (IdTipoRetribuzione)
);

Create Table Enpals_Gruppoagevolazione  (
	IdGruppo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Enpals_Gruppoagevolazione Primary Key (IdGruppo)
);

Create Table Enpals_TipoAgevolazione  (
	IdTipoAgevolazione Varchar(2) NOT NULL,
	IdGruppo Smallint,
	Descrizione Varchar(1000),
	FonteNormativa Varchar(200),
	FonteAmministrativa Varchar(200),
	Modalita Varchar(200),
Constraint pk_Enpals_TipoAgevolazione Primary Key (IdTipoAgevolazione)
);

Create Table Enpals_GruppoAliquota  (
	IdGruppo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Enpals_GruppoAliquota Primary Key (IdGruppo)
);

Create Table Enpals_TipoAliquota  (
	IdTipoAliquota Varchar(3) NOT NULL,
	IdGruppo Smallint,
	Descrizione Varchar(200),
	FonteNormativa Varchar(200),
	FonteAmministrativa Varchar(200),
Constraint pk_Enpals_TipoAliquota Primary Key (IdTipoAliquota)
);

Create Table Enpals_Aliquota  (
	IdTipoAliquota Varchar(3) NOT NULL,
	CodCausale Varchar(20),
	AliquotaDatore Percentage,
	AliquotaLavoratore Percentage,
Constraint pk_Enpals_Aliquota Primary Key (IdTipoAliquota)
);

Create Table Enpals_TipoRapporto  (
	IdTipoRapporto Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Enpals_TipoRapporto Primary Key (IdTipoRapporto)
);

Create Table Inpdap_FondoPensione  (
	IdFondo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inpdap_FondoPensione Primary Key (IdFondo)
);

Create Table Inpdap_TipoFornitore  (
	IdTipoFornitore Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Inpdap_TipoFornitore Primary Key (IdTipoFornitore)
);

Create Table Inpdap_CompartoCcnl  (
	IdComparto Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inpdap_CompartoCcnl Primary Key (IdComparto)
);

Create Table Inpdap_FormaGiuridica  (
	IdFormaGiuridica Smallint NOT NULL,
	Descrizione Varchar(200),
	Residenti Smallint,
Constraint pk_Inpdap_FormaGiuridica Primary Key (IdFormaGiuridica)
);

Create Table Inpdap_TipoImpiego  (
	IdTipoImpiego Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Inpdap_TipoImpiego Primary Key (IdTipoImpiego)
);

Create Table Inpdap_Tiposervizio  (
	IdTipoServizio Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Inpdap_Tiposervizio Primary Key (IdTipoServizio)
);

Create Table Inpdap_TipoPartTime  (
	IdTipoPartTime Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inpdap_TipoPartTime Primary Key (IdTipoPartTime)
);

Create Table Inpdap_TipoMaggiorazione  (
	IdTipoMaggiorazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inpdap_TipoMaggiorazione Primary Key (IdTipoMaggiorazione)
);

Create Table Inpdap_TipoCessazione  (
	IdTipoCessazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inpdap_TipoCessazione Primary Key (IdTipoCessazione)
);

Create Table Enpals  (
	IdDichiarazione Integer NOT NULL,
	IdDocumento Integer,
	IdExport Integer,
Constraint pk_Enpals Primary Key (IdDichiarazione)
);

Create Table Inpdap  (
	IdDichiarazione Integer NOT NULL,
	IdDocumento Integer,
Constraint pk_Inpdap Primary Key (IdDichiarazione)
);

Create Table Prospetto_Contabile  (
	Codice Varchar(10) NOT NULL,
	Descrizione Varchar(200),
	Tipo Varchar(4),
Constraint pk_Prospetto_Contabile Primary Key (Codice)
);

Create Table ParcellaElemento  (
	IdParcella Integer NOT NULL,
	IdListino Smallint NOT NULL,
	IdTipoServizio Smallint NOT NULL,
	Qnt Smallint,
	DataModifica Date,
Constraint pk_ParcellaElemento Primary Key (IdParcella,IdListino,IdTipoServizio)
);

Create Table TipoServizio  (
	IdTipoServizio Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoServizio Primary Key (IdTipoServizio)
);

Create Table ListinoPrezzo  (
	IdListino Smallint NOT NULL,
	IdTipoServizio Smallint NOT NULL,
	Prezzo Currency,
Constraint pk_ListinoPrezzo Primary Key (IdListino,IdTipoServizio)
);

Create Table Cliente  (
	IdCliente Integer NOT NULL,
	IdListino Smallint,
Constraint pk_Cliente Primary Key (IdCliente)
);

Create Table Listino  (
	IdListino Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Listino Primary Key (IdListino)
);

Create Table StatoParcella  (
	IdStatoParcella Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_StatoParcella Primary Key (IdStatoParcella)
);

Create Table Parcella  (
	IdParcella Integer NOT NULL,
	IdStatoParcella Smallint,
	IdCliente Integer,
	DataParcella Date,
Constraint pk_Parcella Primary Key (IdParcella)
);

Create Table M770_CausalePagamento  (
	IdCausalePagamento Varchar(1) NOT NULL,
	Descrizione Varchar(600),
Constraint pk_M770_CausalePagamento Primary Key (IdCausalePagamento)
);

COMMIT WORK;


/******************************************************************************/
/****                                Indexes                               ****/
/******************************************************************************/


Alter Table F24_CausaleAltroEnte add Constraint Relationship626 Foreign Key (IdEnte) references F24_TipoAltroEnte (IdEnte) on update no action on delete no action ;
Alter Table F24_TributoAccisa add Constraint Relationship625 Foreign Key (IdEnte) references F24_AccisaEnte (IdEnte) on update no action on delete no action ;
Alter Table F24_UfficioFinanziario add Constraint Relationship627 Foreign Key (IdTipo) references F24_TipoUffFinanziario (IdTipo) on update no action on delete no action ;
Alter Table HelpContestualeLivello2 add Constraint Relationship630 Foreign Key (IdLivello1) references HelpContestualeLivello1 (IdLivello1) on update no action on delete no action ;
Alter Table HelpContestuale add Constraint Relationship629 Foreign Key (IdLivello1,IdLivello2) references HelpContestualeLivello2 (IdLivello1,IdLivello2) on update no action on delete no action ;
Alter Table Enpals_Tiporetribuzione add Constraint Relationship631 Foreign Key (IdGruppo) references Enpals_Grupporetribuzione (IdGruppo) on update no action on delete no action ;
Alter Table Enpals_TipoAgevolazione add Constraint Relationship632 Foreign Key (IdGruppo) references Enpals_Gruppoagevolazione (IdGruppo) on update no action on delete no action ;
Alter Table Enpals_TipoAliquota add Constraint Relationship633 Foreign Key (IdGruppo) references Enpals_GruppoAliquota (IdGruppo) on update no action on delete no action ;
Alter Table ListinoPrezzo add Constraint Relationship635 Foreign Key (IdTipoServizio) references TipoServizio (IdTipoServizio) on update no action on delete no action ;
Alter Table ParcellaElemento add Constraint Relationship650 Foreign Key (IdListino,IdTipoServizio) references ListinoPrezzo (IdListino,IdTipoServizio) on update no action on delete no action ;
Alter Table Parcella add Constraint Relationship648 Foreign Key (IdCliente) references Cliente (IdCliente) on update no action on delete no action ;
Alter Table ListinoPrezzo add Constraint Relationship637 Foreign Key (IdListino) references Listino (IdListino) on update no action on delete no action ;
Alter Table Cliente add Constraint Relationship646 Foreign Key (IdListino) references Listino (IdListino) on update no action on delete no action ;
Alter Table Parcella add Constraint Relationship645 Foreign Key (IdStatoParcella) references StatoParcella (IdStatoParcella) on update no action on delete no action ;
Alter Table ParcellaElemento add Constraint Relationship647 Foreign Key (IdParcella) references Parcella (IdParcella) on update no action on delete no action ;


COMMIT WORK;


/******************************************************************************/
/****                                Exceptions                            ****/
/******************************************************************************/

Create Exception except_del_p 'Children still exist in child table. Cannot delete parent.';
Create Exception except_ins_ch 'Parent does not exist. Cannot create child.';
Create Exception except_upd_ch 'Parent does not exist. Cannot update child.';
Create Exception except_upd_p 'Children still exist in child table. Cannot update parent.';
Create Exception except_ins_ch_card 'Maximum cardinality exceeded. Cannot insert into child.';
Create Exception except_upd_ch_card 'Maximum cardinality exceeded. Cannot update child.';

/******************************************************************************/
/****                                Done                                  ****/
/******************************************************************************/

COMMIT WORK;