-- Created		01/12/2004
-- Modified:	18/10/2019
-- Project		Paghe Open
-- Model		Anagrafica (Data)
-- Company		Iubar.it (http://www.iubar.it)
-- Author		ing. Andrea Borgogelli Avveduti (info@iubar.it)
-- Version:		01.45.00
-- Database		Firebird


/******************************************************************************/
/****                                CONNECTION                            ****/
/******************************************************************************/

CONNECT 'localhost:C:\Users\Iubar\AppData\Local\Temp\fdb\anag.fdb'
USER 'SYSDBA' PASSWORD 'masterkey';

/******************************************************************************/
/****                                DATA                                  ****/
/******************************************************************************/


UPDATE OR INSERT INTO DBINFO (ID, DESCRIZIONE, VALORE) VALUES (1, 'Versione del db', '01.45.00');
INSERT INTO DBINFO (ID, DESCRIZIONE, VALORE) VALUES (2, 'Data installazione', CURRENT_DATE);
UPDATE OR INSERT INTO DBINFO (ID, DESCRIZIONE, VALORE) VALUES (4, 'Richiede client versione minima', '01.97.00');

COMMIT WORK;

INSERT INTO TIPOANAGRAFICA (IDTIPOANAGRAFICA, DESCRIZIONE) VALUES (1, 'Persone Fisiche');
INSERT INTO TIPOANAGRAFICA (IDTIPOANAGRAFICA, DESCRIZIONE) VALUES (2, 'Persone Giuridiche');
INSERT INTO TIPOANAGRAFICA (IDTIPOANAGRAFICA, DESCRIZIONE) VALUES (3, 'Utente');
INSERT INTO TIPOANAGRAFICA (IDTIPOANAGRAFICA, DESCRIZIONE) VALUES (4, 'Mittenti');
INSERT INTO TIPOANAGRAFICA (IDTIPOANAGRAFICA, DESCRIZIONE) VALUES (5, 'Imprese');

COMMIT WORK;

INSERT INTO TIPOOCCUPAZIONE (IDTIPOOCCUPAZIONE, DESCRIZIONE) VALUES (0, 'Non specificato');
INSERT INTO TIPOOCCUPAZIONE (IDTIPOOCCUPAZIONE, DESCRIZIONE) VALUES (1, 'Lavoratore');
INSERT INTO TIPOOCCUPAZIONE (IDTIPOOCCUPAZIONE, DESCRIZIONE) VALUES (2, 'Studente');
INSERT INTO TIPOOCCUPAZIONE (IDTIPOOCCUPAZIONE, DESCRIZIONE) VALUES (3, 'Pensionato');
INSERT INTO TIPOOCCUPAZIONE (IDTIPOOCCUPAZIONE, DESCRIZIONE) VALUES (4, 'Apprendista');

COMMIT WORK;

INSERT INTO RUOLO (IDRUOLO, DESCRIZIONE, NOTE) VALUES (0, 'Nessuno' , NULL);
INSERT INTO RUOLO (IDRUOLO, DESCRIZIONE, NOTE) VALUES (1, 'Personalizzato' , NULL);
INSERT INTO RUOLO (IDRUOLO, DESCRIZIONE, NOTE) VALUES (2, 'Amministratore' , NULL);
INSERT INTO RUOLO (IDRUOLO, DESCRIZIONE, NOTE) VALUES (3, 'Utente avanzato', NULL);
INSERT INTO RUOLO (IDRUOLO, DESCRIZIONE, NOTE) VALUES (4, 'Utente', NULL);
INSERT INTO RUOLO (IDRUOLO, DESCRIZIONE, NOTE) VALUES (5, 'Solo lettura', NULL);

COMMIT WORK;

INSERT INTO TIPOPERSONAFISICA (IDTIPOPERSONAFISICA, DESCRIZIONE) VALUES (0, 'Sconosciuto');
INSERT INTO TIPOPERSONAFISICA (IDTIPOPERSONAFISICA, DESCRIZIONE) VALUES (1, 'Utente');

COMMIT WORK;

/* Inizio utente di default */

	INSERT INTO ANAGRAFICA (IDANAGRAFICA, IDTIPOANAGRAFICA, IMPRESA) VALUES (0, 1, 0);

	COMMIT WORK;

	INSERT INTO PERSONAFISICA (IDANAGRAFICA, IDTIPOPERSONAFISICA, SESSO, NOME, COGNOME, CF) VALUES (0, 1, NULL, 'Sconosciuto', 'Sconosciuto', '0000000000000000');

	COMMIT WORK;

	INSERT INTO UTENTE (USERNAME, IDANAGRAFICA, PWDHASH, EMAIL, CREAZIONEDATA, ULTIMOACCESSO, IDRUOLO, ATTIVO) VALUES (0, 0, '', '', '01.01.1900', NULL, 2, 1);

	COMMIT WORK;

/* Fine utente di default */

INSERT INTO TIPOLAVORATORE (IDTIPOLAVORATORE, DESCRIZIONE) VALUES (0, 'Sconosciuto');
INSERT INTO TIPOLAVORATORE (IDTIPOLAVORATORE, DESCRIZIONE) VALUES (1, 'Subordinato');
INSERT INTO TIPOLAVORATORE (IDTIPOLAVORATORE, DESCRIZIONE) VALUES (2, 'Parasubordinato');

COMMIT WORK;

INSERT INTO TIPOLAVORATORE2 (IDTIPOLAVORATORE2, DESCRIZIONE) VALUES ('0', 'Non specificato');
INSERT INTO TIPOLAVORATORE2 (IDTIPOLAVORATORE2, DESCRIZIONE) VALUES ('1', 'Impiegato');
INSERT INTO TIPOLAVORATORE2 (IDTIPOLAVORATORE2, DESCRIZIONE) VALUES ('2', 'Operaio');
INSERT INTO TIPOLAVORATORE2 (IDTIPOLAVORATORE2, DESCRIZIONE) VALUES ('3', 'Intermedio');

COMMIT WORK;

/*
INSERT INTO TITOLODISTUDIO (IDTITOLODISTUDIO, DESCRIZIONE) VALUES (0, 'Sconosciuto');
INSERT INTO TITOLODISTUDIO (IDTITOLODISTUDIO, DESCRIZIONE) VALUES (1, 'Licenza elementare');
INSERT INTO TITOLODISTUDIO (IDTITOLODISTUDIO, DESCRIZIONE) VALUES (2, 'Licenza scuola media');
INSERT INTO TITOLODISTUDIO (IDTITOLODISTUDIO, DESCRIZIONE) VALUES (3, 'Licenza scuola media superiore');
INSERT INTO TITOLODISTUDIO (IDTITOLODISTUDIO, DESCRIZIONE) VALUES (4, 'Diploma di laurea triennale oppure laurea di primo livello');
INSERT INTO TITOLODISTUDIO (IDTITOLODISTUDIO, DESCRIZIONE) VALUES (5, 'Diploma di laurea quinquennale, oppure specialistico oppure magistrale');
INSERT INTO TITOLODISTUDIO (IDTITOLODISTUDIO, DESCRIZIONE) VALUES (6, 'Dottorato di ricerca oppure PhD');
INSERT INTO TITOLODISTUDIO (IDTITOLODISTUDIO, DESCRIZIONE) VALUES (7, 'Titolo di studio estero non riconosciuto');

COMMIT WORK;

*/

INSERT INTO SESSO (IDSESSO, SESSO) VALUES (1, 'M');
INSERT INTO SESSO (IDSESSO, SESSO) VALUES (2, 'F');

COMMIT WORK;

INSERT INTO STATOCIVILE (IDSTATOCIVILE, DESCRIZIONE) VALUES (1, 'Celibe/Nubile');
INSERT INTO STATOCIVILE (IDSTATOCIVILE, DESCRIZIONE) VALUES (2, 'Coniugato/a');
INSERT INTO STATOCIVILE (IDSTATOCIVILE, DESCRIZIONE) VALUES (3, 'Vedovo/a');
INSERT INTO STATOCIVILE (IDSTATOCIVILE, DESCRIZIONE) VALUES (4, 'Coniugato/a ma legalmente ed effettivamente separato/a');
INSERT INTO STATOCIVILE (IDSTATOCIVILE, DESCRIZIONE) VALUES (5, 'Celibe/Nubile (dopo annullamento, scioglimento o cessazione effetti civili del matrimonio)');
INSERT INTO STATOCIVILE (IDSTATOCIVILE, DESCRIZIONE) VALUES (6, 'Deceduto');

COMMIT WORK;

INSERT INTO AE_ENTELOCALE (IDENTELOCALE, TERRITORIO) VALUES (3, 'Per i comuni della provincia autonoma di BOLZANO');
INSERT INTO AE_ENTELOCALE (IDENTELOCALE, TERRITORIO) VALUES (7, 'Per i comuni della regione FRIULI VENEZIA GUILIA');
INSERT INTO AE_ENTELOCALE (IDENTELOCALE, TERRITORIO) VALUES (18, 'Per i comuni della provincia autonoma di TRENTO');
INSERT INTO AE_ENTELOCALE (IDENTELOCALE, TERRITORIO) VALUES (20, 'Per i comuni della regione VALLE D''AOSTA');
INSERT INTO AE_ENTELOCALE (IDENTELOCALE, TERRITORIO) VALUES (99, 'Per i RESTANTI COMUNI');

COMMIT WORK;

INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('BA', 'Bari');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('BO', 'Bologna');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('CA', 'Cagliari');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('CT', 'Catania');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('FI', 'Firenze');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('GE', 'Genova');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('MI', 'Milano');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('NA', 'Napoli');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('PA', 'Palermo');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('RM', 'Roma');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('S1', 'Saint Vincent');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('S2', 'San Remo');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('TO', 'Torino');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('TS', 'Trieste');
INSERT INTO SEDEENPALS (IDSEDEENPALS, DENOMINAZIONE) VALUES ('VE', 'Venezia');

COMMIT WORK;

INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41100', 'AGRIGENTO', 'VIA ACRONE, S.N.C.', '92100', 'AGRIGENTO', 'AG', '084');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11332', 'ALBA', 'VIA RATTAZZI, 10', '12051', 'ALBA', 'CN', '004');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11100', 'ALESSANDRIA 1', 'VIA ANTONIO GRAMSCI, 2', '15100', 'ALESSANDRIA', 'AL', '006');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11110', 'ALESSANDRIA 2', 'VIA ANTONIO GRAMSCI, 2', '15100', 'ALESSANDRIA', 'AL', '006');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34141', 'COT - ALTAMURA', 'VIA BRESSO, 21', '70022', 'ALTAMURA', 'BA', '072');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23100', 'ANCONA 1', 'PIAZZA S.MARIA, 5', '60100', 'ANCONA', 'AN', '042');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23110', 'ANCONA 2', 'VIA DELLA LOGGIA, 54', '60100', 'ANCONA', 'AN', '042');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('12100', 'AOSTA', 'CORSO PADRE LORENZO, 18', '11100', 'AOSTA', 'AO', '007');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21100', 'AREZZO 1', 'P.ZZA GUIDO MONACO, 8', '52100', 'AREZZO', 'AR', '051');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21110', 'AREZZO 2', 'P.ZZA GUIDO MONACO, 8', '52100', 'AREZZO', 'AR', '051');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23200', 'ASCOLI PICENO 1', 'VIA D.ANGELINI, 35', '63100', 'ASCOLI PICENO', 'AP', '044');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23210', 'ASCOLI PICENO 2', 'VIA D.ANGELINI, 35', '63100', 'ASCOLI PICENO', 'AP', '044');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11200', 'ASTI', 'VIA A. GOITO, 2', '14100', 'ASTI', 'AT', '005');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21230', 'AULLA', 'L.GO GIROMINI, 7/10', '54011', 'AULLA', 'MS', '045');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33100', 'AVELLINO', 'VIA JANNACCONE, 12/14', '83100', 'AVELLINO', 'AV', '064');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33310', 'AVERSA', 'P.ZZA BERNINI PAL.CENTER', '81031', 'AVERSA', 'CE', '061');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('31210', 'AVEZZANO', 'VIA LIGURIA, 26', '67051', 'AVEZZANO', 'AQ', '066');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34100', 'BARI 1', 'LUNGOMARE TRIESTE, 29', '70126', 'BARI', 'BA', '072');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34160', 'BARI 2', 'VIA POSITANO, 2', '70121', 'BARI', 'BA', '072');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34110', 'BARLETTA', 'VIA A. VESPUCCI,1', '70051', 'BARLETTA', 'BA', '072');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15700', 'BASSANO D. GRAPPA', 'VIA ORAZIO MARINALI, 79', '36061', 'BASSANO D. GRAPPA', 'VI', '024');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33530', 'BATTIPAGLIA', 'SS 19 PAL. JEMMA VIA BARATTA', '84091', 'BATTIPAGLIA', 'SA', '065');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15100', 'BELLUNO', 'VIALE FANTUZZI, 24', '32100', 'BELLUNO', 'BL', '025');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33200', 'BENEVENTO', 'P.ZZA RISORGIMENTO , 15', '82100', 'BENEVENTO', 'BN', '062');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13100', 'BERGAMO 1', 'VIA MATRIS DOMINI, 14', '24100', 'BERGAMO', 'BG', '016');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13110', 'BERGAMO 4', 'VIA MATRIS DOMINI, 14', '24100', 'BERGAMO', 'BG', '016');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13140', 'BERGAMO 5', 'VIA MATRIS DOMINI, 14', '24100', 'BERGAMO', 'BG', '016');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11620', 'BIELLA', 'VIA R. CARACCIO, 24/26', '13051', 'BIELLA', 'BI', '096');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18100', 'BOLOGNA 1', 'VIA GRAMSCI, 4', '40121', 'BOLOGNA', 'BO', '037');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18110', 'BOLOGNA 2', 'VIA GRAMSCI, 4', '40121', 'BOLOGNA', 'BO', '037');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18140', 'BOLOGNA 3', 'VIA AMENDOLA, 5', '40121', 'BOLOGNA', 'BO', '037');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('14100', 'BOLZANO', 'V.LE EUROPA, 31', '39100', 'BOLZANO', 'BZ', '021');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21334', 'BORGO S. LORENZO', 'P.ZZA S.G. BOSCO ANG. XX SETT.', '50032', 'BORGO S. LORENZO', 'FI', '048');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13232', 'BRENO (BS-PALAZZOLO)', 'VIA FOPPO, 18/A', '25043', 'BRENO', 'BS', '017');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13200', 'BRESCIA 1', 'VIA CEFALONIA, 52', '25125', 'BRESCIA', 'BS', '017');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13210', 'BRESCIA 2', 'VIA CEFALONIA, 52', '25125', 'BRESCIA', 'BS', '017');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13260', 'BRESCIA 5', 'VIA CEFALONIA, 52', '25125', 'BRESCIA', 'BS', '017');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('14110', 'BRESSANONE', 'VIA JULIUS DURST, 2/A', '39042', 'BRESSANONE', 'BZ', '021');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34200', 'BRINDISI', 'VIA PALESTRO, 4', '72100', 'BRINDISI', 'BR', '074');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13920', 'BUSTO ARSIZIO', 'VIA DUCA D AOSTA, 7', '21052', 'BUSTO ARSIZIO', 'VA', '012');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('42100', 'CAGLIARI 1', 'VIA SONNINO, 96', '09100', 'CAGLIARI', 'CA', '092');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('42140', 'CAGLIARI 2', 'VIA TEMPIO, 30/32', '09127', 'CAGLIARI', 'CA', '092');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('42110', 'CAGLIARI 3', 'VIA LANUSEI, 24', '09100', 'CAGLIARI', 'CA', '092');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41302', 'CALTAGIRONE', 'VIA PIETRO NOVELLI, 36', '95041', 'CALTAGIRONE', 'CT', '087');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41200', 'CALTANISSETTA', 'VIA ROSSO DI S.SECONDO, 47', '93100', 'CALTANISSETTA', 'CL', '085');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('32100', 'CAMPOBASSO', 'VIA GARIBALDI, 2/C', '86100', 'CAMPOBASSO', 'CB', '070');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('42130', 'CARBONIA', 'VIA TRIESTE, 2', '09013', 'CARBONIA', 'CA', '092');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17431', 'CARCARE', 'VIA NAZ.LE PIEMONTE, 48/B', '17043', 'CARCARE', 'SV', '009');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21200', 'CARRARA', 'VIA DON MINZONI, 5', '54100', 'CARRARA', 'MS', '045');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11130', 'CASALE MONFERRATO', 'VIA B. BUOZZI, 18/B', '15033', 'CASALE MONFERRATO', 'AL', '006');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18130', 'CASALECCHIO DI RENO', 'VIA ISONZO, 14', '40033', 'CASALECCHIO DI RENO', 'BO', '037');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34402', 'CASARANO', 'PIAZZA MALTA', '73042', 'CASARANO', 'LE', '075');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33300', 'CASERTA 1', 'VIA FERRARECCE P/LE INAIL', '81100', 'CASERTA', 'CE', '061');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24110', 'CASSINO', 'P.ZA LABRIOLA, 49', '03043', 'CASSINO', 'FR', '060');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33420', 'CASTELL.DI STABIA', 'VIALE EUROPA, 230', '80053', 'CASTELL.DI STABIA', 'NA', '063');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36230', 'CASTROVILLARI', 'VIA SILVIO SARACENI, 9', '87012', 'CASTROVILLARI', 'CS', '078');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41300', 'CATANIA 1', 'VIA S. EUPLIO, 168', '95124', 'CATANIA', 'CT', '087');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41310', 'CATANIA 2', 'VIA CIFALI, 76/A', '95124', 'CATANIA', 'CT', '087');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36100', 'CATANZARO 1', 'VIA VITTORIO VENETO, 38', '88100', 'CATANZARO', 'CZ', '079');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('16301', 'CERVIGNANO DEL FRIULI', 'VIA ROMA, 97', '33052', 'CERVIGNANO DEL FRIULI', 'UD', '030');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18330', 'CESENA', 'VIA GUARNERI, 309 CASE FINALI', '47023', 'CESENA', 'FC', '040');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17160', 'CHIAVARI', 'VIA COLONNELLO FRANCESCHI', '16043', 'CHIAVARI', 'GE', '010');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('31100', 'CHIETI', 'VIA BELTRANDO SPAVENTA, 25', '66100', 'CHIETI', 'CH', '069');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11523', 'CHIVASSO', 'VIA BORIS BRADAC 43', '10034', 'CHIVASSO', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11581', 'CIRIÈ', 'C/O INPS V. ROBARONZINO, 4', '10073', 'CIRIÈ', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('22131', 'CITTÀ DI CASTELLO', 'VIA PIERO DELLA FRANCESCA', '06012', 'CITTÀ DI CASTELLO', 'PG', '054');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15202', 'CITTADELLA', 'BORGO PADOVA 33', '35013', 'CITTADELLA', 'PD', '028');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24530', 'CIVITA CASTELLANA', 'VIA CORCHIANO', '01033', 'CIVITA CASTELLANA', 'VT', '056');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23331', 'CIVITANOVA MARCHE', 'VIA DE AMICIS, 45', '62012', 'CIVITANOVA MARCHE', 'MC', '043');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24442', 'CIVITAVECCHIA', 'VIA VANVITELLI- T.RE EUROPA', '00053', 'CIVITAVECCHIA', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13300', 'COMO 1', 'VIA PETRARCA, 4-4/A', '22100', 'COMO', 'CO', '013');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13310', 'COMO 2', 'VIA PETRARCA, 4-4/A', '22100', 'COMO', 'CO', '013');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15401', 'CONEGLIANO', 'VIALE ITALIA, 194', '31015', 'CONEGLIANO', 'TV', '026');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36200', 'COSENZA', 'VIA ISONZO, 48/A', '87100', 'COSENZA', 'CS', '078');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13430', 'CREMA', 'V.LE SANTA MARIA, 6', '26013', 'CREMA', 'CR', '019');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13400', 'CREMONA', 'VIA DANTE, 23/A-21/A', '26100', 'CREMONA', 'CR', '019');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36400', 'CROTONE', 'VIA G. MANNA, 7', '88900', 'CROTONE', 'KR', '101');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11300', 'CUNEO 1', 'VIA ANTONIO BASSIGNANO, 21', '12100', 'CUNEO', 'CN', '004');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11310', 'CUNEO 3', 'VIA ANTONIO BASSIGNANO, 21', '12100', 'CUNEO', 'CN', '004');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11730', 'DOMODOSSOLA', 'P.ZA G. MATTEOTTI, 38', '28845', 'DOMODOSSOLA', 'VB', '103');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21330', 'EMPOLI', 'VIA AMENDOLA, 12', '50053', 'EMPOLI', 'FI', '048');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41400', 'ENNA', 'VIA ROMA, 439/441', '94100', 'ENNA', 'EN', '086');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23132', 'FABRIANO', 'V.LE SERAFINI 69/C', '60044', 'FABRIANO', 'AN', '042');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18730', 'FAENZA', 'L.GO FARINI, 4', '48018', 'FAENZA', 'RA', '039');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23401', 'FANO', 'VIA TOGLIATTI, 13', '61032', 'FANO', 'PU', '041');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23230', 'FERMO', 'VIA OTTORINO RESPIGHI', '63023', 'FERMO', 'AP', '044');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18200', 'FERRARA 1', 'VIALE CAVOUR, 96/104', '44100', 'FERRARA', 'FE', '038');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18210', 'FERRARA 2', 'VIALE CAVOUR, 96/104', '44100', 'FERRARA', 'FE', '038');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21300', 'FIRENZE 1', 'VIA DELLE PORTE NUOVE, 61', '50144', 'FIRENZE', 'FI', '048');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21310', 'FIRENZE 2', 'VIA DELLE PORTE NUOVE, 61', '50144', 'FIRENZE', 'FI', '048');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21340', 'FIRENZE 3', 'VIA DELLA SCALA, 52', '50123', 'FIRENZE', 'FI', '048');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21360', 'FIRENZE 4', 'VIA DELLE PORTE NUOVE, 61', '50144', 'FIRENZE', 'FI', '048');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34300', 'FOGGIA', 'VIA GRAMSCI, 19', '71100', 'FOGGIA', 'FG', '071');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('22110', 'FOLIGNO', 'VIA NAZARIO SAURO, 4', '06034', 'FOLIGNO', 'PG', '054');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18300', 'FORLI 1', 'VIALE DELLA LIBERTA, 1', '47100', 'FORLI', 'FC', '040');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18310', 'FORLI 2', 'VIALE DELLA LIBERTA, 1', '47100', 'FORLI', 'FC', '040');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24230', 'FORMIA', 'VIA CONDOTTO S.N.C.', '04023', 'FORMIA', 'LT', '059');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24100', 'FROSINONE 1', 'VIA G.MARCONI, 31', '03100', 'FROSINONE', 'FR', '060');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13921', 'GALLARATE', 'CORSO SEMPIONE,3 7/39', '21013', 'GALLARATE', 'VA', '012');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13230', 'GARDONE', 'P.ZA MARTIRI DELLA LIBERTÀ, 2', '25063', 'GARDONE', 'BS', '017');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17101', 'GENOVA SAMPIERDARENA', 'VIA MOLTENI 5B', '16149', 'GE. SAMPIERDARENA', 'GE', '010');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17100', 'GENOVA 1', 'VIA G.D ANNUNZIO, 76-78', '16121', 'GENOVA', 'GE', '010');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17110', 'GENOVA 2', 'VIA G.D ANNUNZIO, 76-78', '16121', 'GENOVA', 'GE', '010');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17140', 'GENOVA 3', 'VIA G.D ANNUNZIO, 76-78', '16121', 'GENOVA', 'GE', '010');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('16100', 'GORIZIA', 'VIA ROMA, 20', '34170', 'GORIZIA', 'GO', '031');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11700', 'VERBANO-CUSIO OSSOLA', 'CORSO MARCONI, 99', '28900', 'GRAVELLONA', 'VB', '103');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21400', 'GROSSETO', 'VIA MAMELI, 13', '58100', 'GROSSETO', 'GR', '053');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18160', 'IMOLA', 'VIALE A. COSTA, 74', '40026', 'IMOLA', 'BO', '037');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17200', 'IMPERIA', 'VIALE MATTEOTTI, 167', '18100', 'IMPERIA', 'IM', '008');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('32200', 'ISERNIA', 'CORSO RISORGIMENTO, IV TRAV.', '86170', 'ISERNIA', 'IS', '094');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11520', 'IVREA', 'CORSO COSTANTINO NIGRA, 37/A', '10015', 'IVREA', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23130', 'JESI', 'VIA PELLEGRINI, 1/3', '60035', 'JESI', 'AN', '042');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17300', 'LA SPEZIA 1', 'CORSO NAZIONALE, 326', '19100', 'LA SPEZIA', 'SP', '011');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17310', 'LA SPEZIA 2', 'CORSO NAZIONALE, 326', '19100', 'LA SPEZIA', 'SP', '011');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('35230', 'LAGONEGRO', 'VIA NAPOLI, 55', '85042', 'LAGONEGRO', 'PZ', '076');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('31110', 'LANCIANO', 'VIALE DELLE ROSE 34', '66034', 'LANCIANO', 'CH', '069');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('31200', 'L''AQUILA 1', 'V.LE FILOMUSI GUELFI', '67100', 'L''AQUILA', 'AQ', '066');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24200', 'LATINA', 'PIAZZALE CARTURAN, 3', '04100', 'LATINA', 'LT', '059');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34400', 'LECCE', 'VIA O.QUARTA, 19/B', '73100', 'LECCE', 'LE', '075');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13320', 'LECCO', 'VIA BRUNO BUOZZI, 15', '22053', 'LECCO', 'LC', '097');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15640', 'LEGNAGO', 'VIA BEZZECCA, 30', '37045', 'LEGNAGO', 'VR', '023');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13620', 'LEGNANO', 'LARGO F. TOSI, 3', '20025', 'LEGNANO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21500', 'LIVORNO', 'VIA A.PIERONI, 11', '57100', 'LIVORNO', 'LI', '049');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36302', 'LOCRI', 'VIA CUSMANO TRAV. 1^ 4/8', '89044', 'LOCRI', 'RC', '080');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13621', 'LODI', 'VIA S.GIACOMO, 17', '20075', 'LODI', 'LO', '098');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21600', 'LUCCA 1', 'VIA LUPORINI, 1021', '55100', 'LUCCA', 'LU', '046');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21610', 'LUCCA 2', 'VIA LUPORINI 1021', '55100', 'LUCCA', 'LU', '046');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18715', 'LUGO', 'P.ZA CAVINA, 6', '48022', 'LUGO', 'RA', '039');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23300', 'MACERATA', 'VIA PIANESI, 3', '62100', 'MACERATA', 'MC', '043');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34401', 'MAGLIE', 'VIA GALLIPOLI, 67', '73024', 'MAGLIE', 'LE', '075');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13233', 'MANERBIO', 'VIA DUCA D''AOSTA,15', '25025', 'MANERBIO', 'BS', '017');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34310', 'MANFREDONIA', 'VIALE DI VITTORIO, 265', '71043', 'MANFREDONIA', 'FG', '071');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13500', 'MANTOVA 1', 'VIA VITTORINO DA FELTRE, 44', '46100', 'MANTOVA', 'MN', '020');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13510', 'MANTOVA 2', 'VIA VITTORINO DA FELTRE, 44', '46100', 'MANTOVA', 'MN', '020');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15510', 'VENEZIA 2', 'V.F.LLI BANDIERA, 1', '30175', 'MARGHERA', 'VE', '027');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21210', 'MASSA', 'VIA GIORGINI, 1', '54100', 'MASSA', 'MS', '045');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('35100', 'MATERA', 'VIA APPULO LUCANA, 144', '75100', 'MATERA', 'MT', '077');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41901', 'MAZARA DEL VALLO', 'VIA CASTELVETRANO 23', '91026', 'MAZARA DEL VALLO', 'TP', '081');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('35201', 'MELFI', 'VIA FOGGIA COMPL. LE TERRAZZE', '85025', 'MELFI', 'PZ', '076');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('14120', 'MERANO', 'VIA XXX APRILE, 17', '39012', 'MERANO', 'BZ', '021');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41500', 'MESSINA', 'V.GARIBALDI-IS.8 CORT.PORTO', '98100', 'MESSINA', 'ME', '083');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13640', 'MILANO 2', 'VIA BONCOMPAGNI, 41', '20139', 'MILANO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13660', 'MILANO 3', 'VIA CUSANI, 1', '20121', 'MILANO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13670', 'MILANO 4', 'CORSO DI PORTA NUOVA, 19', '20121', 'MILANO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13680', 'MILANO 5', 'CORSO DI PORTA NUOVA, 19', '20121', 'MILANO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13653', 'MILANO AREA 1', 'CORSO DI PORTA NUOVA, 19', '20121', 'MILANO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13654', 'MILANO AREA 2', 'CORSO DI PORTA NUOVA, 19', '20121', 'MILANO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13600', 'MILANO PORTA NUOVA', 'CORSO DI PORTA NUOVA, 19', '20121', 'MILANO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41520', 'MILAZZO', 'PIAZZA ROMA', '98057', 'MILAZZO', 'ME', '083');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18400', 'MODENA 1', 'VIA C.COSTA, 29/31', '41100', 'MODENA', 'MO', '036');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18410', 'MODENA 3', 'VIA C.COSTA, 29/31', '41100', 'MODENA', 'MO', '036');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18440', 'MODENA 4', 'VIA C.COSTA, 29/31', '41100', 'MODENA', 'MO', '036');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11540', 'MONCALIERI', 'VIA UNGARETTI, 27', '10024', 'MONCALIERI', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('16120', 'MONFALCONE', 'VIA COSULICH, 4', '34074', 'MONFALCONE', 'GO', '031');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34140', 'MONOPOLI', 'VIA V.VENETO, 62/64', '70043', 'MONOPOLI', 'BA', '072');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13622', 'MONZA', 'VIA PAVONI, 6/8', '20052', 'MONZA', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33400', 'NAPOLI 1', 'V.NUOVA POGGIOREALE, ANG S.L', '80143', 'NAPOLI', 'NA', '063');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33410', 'NAPOLI 2', 'V.NUOVA POGGIOREALE, ANG S.L', '80143', 'NAPOLI', 'NA', '063');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33440', 'NAPOLI 3', 'V.NUOVA POGGIOREALE, ANG S.L', '80143', 'NAPOLI', 'NA', '063');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33460', 'NAPOLI 4', 'V.NUOVA POGGIOREALE, ANG S.L', '80143', 'NAPOLI', 'NA', '063');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33470', 'NAPOLI 5', 'V.NUOVA.POGG., ANG.S.LAZZARO', '80143', 'NAPOLI', 'NA', '063');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33401', 'NAPOLI CAMPI FLEGREI', 'P.ZA PILASTRI, 17', '80125', 'NAPOLI', 'NA', '063');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33403', 'NAPOLI VIA DE GASPERI', 'VIA A. DE GASPERI, 3', '80133', 'NAPOLI', 'NA', '063');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24444', 'NETTUNO VELLETRI', 'VIA ENNIO VISCA, 18', '00048', 'NETTUNO', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33531', 'NOCERA INFERIORE', 'VIA CICALESE PRIMA TRAVERSA', '84014', 'NOCERA INFERIORE', 'SA', '065');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11400', 'NOVARA', 'VIA ANDREA COSTA, 33', '28100', 'NOVARA', 'NO', '003');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11131', 'NOVI LIGURE', 'VIA TORTONA, 2', '15067', 'NOVI LIGURE', 'AL', '006');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('42200', 'NUORO', 'VIA PIETRO MASTINO, 72/76', '08100', 'NUORO', 'NU', '091');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('42330', 'OLBIA', 'ZONA AEROPORTO-COSTA SMERALDA', '07026', 'OLBIA', 'SS', '090');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('42400', 'ORISTANO', 'VIA EMILIO LUSSU, 2', '09170', 'ORISTANO', 'OR', '095');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('22230', 'ORVIETO', 'V.LE 1° MAGGIO, 73', '05018', 'ORVIETO', 'TR', '055');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15200', 'PADOVA 1', 'VIA MARTIRI LIBERTA, 2', '35100', 'PADOVA', 'PD', '028');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15210', 'PADOVA 2', 'VIA MARTIRI LIBERTA, 2', '35100', 'PADOVA', 'PD', '028');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15240', 'PADOVA 3', 'VIA MARTIRI LIBERTA, 2', '35100', 'PADOVA', 'PD', '028');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13240', 'PALAZZOLO SULL''OGLIO', 'VIA BRESCIANINI,1/3', '25036', 'PALAZZOLO SULL''OGLIO', 'BS', '017');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41600', 'PALERMO 1', 'VIA DEL FANTE, 58 - TORRE B', '90146', 'PALERMO', 'PA', '082');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41610', 'PALERMO 2', 'VIA DEL FANTE, 58 - TORRE B', '90146', 'PALERMO', 'PA', '082');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41640', 'PALERMO 3', 'VIA M.TITONE, 19/B', '90129', 'PALERMO', 'PA', '082');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36303', 'PALMI', 'VIA BRUNO BUOZZI, 56', '89015', 'PALMI', 'RC', '080');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36201', 'PAOLA', 'S.S. 18 CONTRADA CROCE, 42', '87027', 'PAOLA', 'CS', '078');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18500', 'PARMA', 'VIA ABBEVERATOIA, 71/A', '43100', 'PARMA', 'PR', '034');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13700', 'PAVIA 1', 'PIAZZA MUNICIPIO, 15', '27100', 'PAVIA', 'PV', '018');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13710', 'PAVIA 2', 'PIAZZA MUNICIPIO, 15', '27100', 'PAVIA', 'PV', '018');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('22100', 'PERUGIA 1', 'P.ZZA PARTIGIANI, 9', '06100', 'PERUGIA', 'PG', '054');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23400', 'PESARO 1', 'PIAZZALE 1 MAGGIO, 27', '61100', 'PESARO', 'PU', '041');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23410', 'PESARO 2', 'PIAZZALE 1 MAGGIO, 27', '61100', 'PESARO', 'PU', '041');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('31300', 'PESCARA', 'VIA BOLOGNA, 24', '65100', 'PESCARA', 'PE', '068');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18600', 'PIACENZA', 'PIAZZETTA DEL TEMPIO, 29', '29100', 'PIACENZA', 'PC', '033');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11560', 'PINEROLO', 'VIA MARTIRI DEL XXI, 92', '10064', 'PINEROLO', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21520', 'PIOMBINO', 'LOCALITA S.ROCCO', '57025', 'PIOMBINO', 'LI', '049');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21700', 'PISA 1', 'VIA DI SIMONE, 2', '56100', 'PISA', 'PI', '050');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21710', 'PISA 2', 'VIA DI SIMONE, 2', '56100', 'PISA', 'PI', '050');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21800', 'PISTOIA', 'PIAZZA DANTE', '51100', 'PISTOIA', 'PT', '047');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21301', 'PONTASSIEVE', 'PIAZZA WASHINGTON, 15', '50065', 'PONTASSIEVE', 'FI', '048');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21730', 'PONTEDERA', 'VIA FANTOZZI', '56025', 'PONTEDERA', 'PI', '050');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('16700', 'PORDENONE', 'VIA CERAMICA VECCHIA', '33170', 'PORDENONE', 'PN', '093');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('35200', 'POTENZA', 'VIA MARCONI-RAMPA PASCOLI', '85100', 'POTENZA', 'PZ', '076');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21320', 'PRATO', 'P.ZZA EUROPA, 3', '50047', 'PRATO', 'PO', '100');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41700', 'RAGUSA', 'PIAZZA GRAMSCI', '97100', 'RAGUSA', 'RG', '088');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18700', 'RAVENNA 1', 'VIA FARINI, 54', '48100', 'RAVENNA', 'RA', '039');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18710', 'RAVENNA 2', 'VIA FARINI, 54', '48100', 'RAVENNA', 'RA', '039');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36300', 'REGGIO CALABRIA', 'CORSO GARIBALDI, 635/637', '89100', 'REGGIO CALABRIA', 'RC', '080');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18800', 'REGGIO EMILIA 1', 'VIA MONTE MARMOLADA, 5', '42100', 'REGGIO EMILIA', 'RE', '035');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18810', 'REGGIO EMILIA 2', 'VIA MONTE MARMOLADA, 5', '42100', 'REGGIO EMILIA', 'RE', '035');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13609', 'RHO', 'VIA MARTIRI DELLA LIBERTA’', '20017', 'RHO', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24300', 'RIETI', 'V.LE MATTEUCCI, 6-6/A', '02100', 'RIETI', 'RI', '057');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('18320', 'RIMINI', 'P.LE GIULIO CESARE, 4', '47037', 'RIMINI', 'RN', '099');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11542', 'RIVOLI', 'VIA ADIGE, 9', '10098', 'RIVOLI', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24400', 'ROMA 1', 'P.ZA CINQUE GIORNATE, 3', '00192', 'ROMA', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24470', 'ROMA 2', 'VIA DIEGO FABBRI, 74', '00137', 'ROMA', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24440', 'ROMA 3', 'V.ACQUA BULLICANTE, 312', '00177', 'ROMA', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24441', 'ROMA 4', 'V.MICHELE DE MARCO, 20', '00169', 'ROMA', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24480', 'ROMA 5', 'VIALE STEFANO GRADI, 57', '00143', 'ROMA', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24410', 'ROMA 6', 'P.ZA CINQUE GIORNATE, 4', '00192', 'ROMA', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24401', 'ROMA AURELIO', 'VIA ENRICO OSSO', '00100', 'ROMA', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36202', 'ROSSANO', 'VIA CARMINE GAETANO CANDIANO, 14', '87067', 'ROSSANO', 'CS', '078');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('14220', 'ROVERETO', 'L.GO CAMERA COMMERCIO, 2', '38068', 'ROVERETO', 'TN', '022');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15300', 'ROVIGO', 'VIALE TRIESTE, 18', '45100', 'ROVIGO', 'RO', '029');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33101', 'S.ANGELO DEI LOMBARDI', 'LOC. BOSCHETTO', '83054', 'S.ANGELO DEI LOMBARDI', 'AV', '064');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34301', 'S.SEVERO', 'C/O INPS PIAZZA REPUBBLICA 27', '71016', 'S.SEVERO', 'FG', '071');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33532', 'SALA CONSILINA', 'VIA DON LUIGI STURZO 2BIS', '84036', 'SALA CONSILINA', 'SA', '065');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33500', 'SALERNO 1', 'VIA DE LEO, 12', '84100', 'SALERNO', 'SA', '065');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33510', 'SALERNO 2', 'VIA DE LEO, 12', '84100', 'SALERNO', 'SA', '065');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33540', 'SALERNO 3', 'VIA DE LEO, 12', '84100', 'SALERNO', 'SA', '065');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11331', 'SALUZZO', 'VIA FIUME, 11', '12037', 'SALUZZO', 'CN', '004');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15530', 'SAN DONÀ DI PIAVE', 'VIA VIZZOTTO, 48', '30027', 'SAN DONÀ DI PIAVE', 'VE', '027');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33201', 'SANT'' AGATA DEI GOTI', 'VIA CAUDINA, 15', '82019', 'SANT'' AGATA DEI GOTI', 'BN', '062');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13922', 'SARONNO', 'PIAZZA CADUTI SARONNESI, 7', '21047', 'SARONNO', 'VA', '012');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17301', 'SARZANA', 'VIA VARIANTE AURELIA, 153', '19038', 'SARZANA', 'SP', '011');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('42300', 'SASSARI', 'PIAZZA G. MARCONI, 8', '07100', 'SASSARI', 'SS', '090');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('17400', 'SAVONA', 'VIA VENEZIA, 6/8', '17100', 'SAVONA', 'SV', '009');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15732', 'SCHIO', 'P.ZA FALCONE E BORSELLINO', '36015', 'SCHIO', 'VI', '024');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('23131', 'SENIGALLIA', 'VIA TEVERE, 33', '60019', 'SENIGALLIA', 'AN', '042');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('33301', 'SESSA AURUNCA', 'VIA XXI LUGLIO, 119', '81037', 'SESSA AURUNCA', 'CE', '061');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13623', 'SESTO S.GIOVANNI', 'VIA RISORGIMENTO, 4', '20099', 'SESTO S.GIOVANNI', 'MI', '015');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21900', 'SIENA', 'VIALE FEDERICO TOZZI, 7', '53100', 'SIENA', 'SI', '052');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41800', 'SIRACUSA', 'RIVA FORTE DEL GALLO', '96100', 'SIRACUSA', 'SR', '089');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13800', 'SONDRIO', 'VIA TRIESTE, 3', '23100', 'SONDRIO', 'SO', '014');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24131', 'SORA', 'VIA REGINA ELENA 74', '03039', 'SORA', 'FR', '060');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('31231', 'SULMONA', 'VIA GAETANO SALVEMINI', '67039', 'SULMONA', 'AQ', '066');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34500', 'TARANTO 1', 'VIA PLINIO-ANG. V.SALINELLA', '74100', 'TARANTO', 'TA', '073');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('34510', 'TARANTO 2', 'VIA JAPIGIA, 2-ANG.V.MINNITI', '74100', 'TARANTO', 'TA', '073');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('31400', 'TERAMO', 'VIA CARDUCCI, 36', '64100', 'TERAMO', 'TE', '067');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41630', 'TERMINI IMERESE', 'P.ZA FRANCESCO CRISPI, 4', '90018', 'TERMINI IMERESE', 'PA', '082');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('32130', 'TERMOLI', 'VIA FRANCESCO DESANCTIS,1/9', '86039', 'TERMOLI', 'CB', '070');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('22200', 'TERNI', 'VIALE TURATI, 18/20', '05100', 'TERNI', 'TR', '055');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24460', 'TIVOLI ROMA 8', 'V.TIBURTINA, 75', '00019', 'TIVOLI', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('16321', 'TOLMEZZO', 'VIA R.DEL DIN, 11', '33028', 'TOLMEZZO', 'UD', '030');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11570', 'TORINO 3', 'CORSO ORBASSANO, 366', '10137', 'TORINO', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11580', 'TORINO 4', 'CORSO GALILEO FERRARIS, 1', '10121', 'TORINO', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11553', 'TORINO AREA 1', 'CORSO GALILEO FERRARIS, 1', '10121', 'TORINO', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11554', 'TORINO AREA 2', 'CORSO GALILEO FERRARIS, 1', '10121', 'TORINO', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11500', 'TORINO CENTRO', 'CORSO GALILEO FERRARIS, 1', '10121', 'TORINO', 'TO', '001');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('41900', 'TRAPANI', 'VIA VITO SORBA, 18', '91100', 'TRAPANI', 'TP', '081');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('14200', 'TRENTO', 'VIA GAZZOLETTI, 1/3', '38100', 'TRENTO', 'TN', '022');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15400', 'TREVISO 1', 'G.D ANNUNZIO, 35', '31100', 'TREVISO', 'TV', '026');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15410', 'TREVISO 2', 'G.D ANNUNZIO, 35', '31100', 'TREVISO', 'TV', '026');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('16200', 'TRIESTE', 'VIA DEL TEATRO ROMANO,18', '34121', 'TRIESTE', 'TS', '032');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('16300', 'UDINE', 'PIAZZA DUOMO, 7', '33100', 'UDINE', 'UD', '030');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13900', 'VARESE', 'VIA AGUGGIARI, 6', '21100', 'VARESE', 'VA', '012');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24443', 'VELLETRI ROMA 9', 'C.SO DELLA REPUBBLICA, 17', '00049', 'VELLETRI', 'RM', '058');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15500', 'VENEZIA 1', 'S.CROCE-C.NUOVA S.SIMEONE', '30125', 'VENEZIA', 'VE', '027');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('11600', 'VERCELLI', 'LARGO BRIGATA CAGLIARI, 2/4', '13100', 'VERCELLI', 'VC', '002');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15600', 'VERONA 1', 'CORSO CAVOUR, 6', '37100', 'VERONA', 'VR', '023');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15610', 'VERONA 2', 'CORSO CAVOUR, 6', '37100', 'VERONA', 'VR', '023');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('21630', 'VIAREGGIO', 'VIA DELLA VETRAIA', '55049', 'VIAREGGIO', 'LU', '046');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('36110', 'VIBO VALENTIA', 'VIA ALCIDE DE GASPERI SN', '88018', 'VIBO VALENTIA', 'VV', '102');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('15710', 'VICENZA', 'VIALE MILANO, 63', '36100', 'VICENZA', 'VI', '024');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('13730', 'VIGEVANO', 'V.LE MONTEGRAPPA, 79', '27029', 'VIGEVANO', 'PV', '018');
INSERT INTO SEDEINAIL (IDSEDEINAIL, DENOMINAZIONE, INDIRIZZO, CAP, CITTA, PROVINCIASIGLA, IDPROVINCIA) VALUES ('24500', 'VITERBO', 'VIA SABOTINO, 1/3', '01100', 'VITERBO', 'VT', '056');

COMMIT WORK;

INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0100', 'AGRIGENTO', 'AG', '084');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0101', 'SCIACCA', 'AG', '084');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0200', 'ALESSANDRIA', 'AL', '006');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0300', 'ANCONA', 'AN', '042');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0391', 'JESI', 'AN', '042');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0400', 'AOSTA', 'AO', '007');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0500', 'AREZZO', 'AR', '051');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0600', 'ASCOLI PICENO', 'AP', '044');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0690', 'FERMO', 'FM', '110');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0700', 'ASTI', 'AT', '005');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0800', 'AVELLINO', 'AV', '064');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0890', 'ARIANO IRPINO', 'AV', '064');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0900', 'BARI', 'BA', '072');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0901', 'ANDRIA', 'BA', '072');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('0993', 'GIOIA DEL COLLE', 'BA', '072');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1000', 'BELLUNO', 'BL', '025');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1100', 'BENEVENTO', 'BN', '062');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1200', 'BERGAMO', 'BG', '016');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1300', 'BOLOGNA', 'BO', '037');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1301', 'IMOLA', 'BO', '037');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1393', 'SAN LAZZARO DI SAVENA', 'BO', '037');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1400', 'BOLZANO', 'BZ', '021');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1491', 'MERANO', 'BZ', '021');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1500', 'BRESCIA', 'BS', '017');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1594', 'MANERBiO', 'BS', '017');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1595', 'CHIARI', 'BS', '017');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1600', 'BRINDISI', 'BR', '074');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1700', 'CAGLIARI', 'CA', '092');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1701', 'IGLESIAS', 'CA', '092');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1791', 'QUARTU SANT ELENA', 'CA', '092');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1800', 'CALTANISSETTA', 'CL', '085');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1900', 'CAMPOBASSO', 'CB', '070');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('1990', 'TERMOLI', 'CB', '070');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2000', 'CASERTA', 'CE', '061');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2001', 'AVERSA', 'CE', '061');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2100', 'CATANIA', 'CT', '087');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2190', 'CALTAGIRONE', 'CT', '087');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2200', 'CATANZARO', 'CZ', '079');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2201', 'LAMEZIA TERME', 'CZ', '079');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2202', 'VIBO VALENTIA', 'VV', '102');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2203', 'CROTONE', 'KR', '101');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2300', 'CHIETI', 'CH', '069');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2391', 'VASTO', 'CH', '069');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2400', 'COMO', 'CO', '013');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2401', 'LECCO', 'LC', '097');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2490', 'CANTU', 'CO', '013');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2500', 'COSENZA', 'CS', '078');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2501', 'ROSSANO CALABRO', 'CS', '078');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2590', 'PAOLA', 'CS', '078');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2591', 'CASTROVILLARI', 'CS', '078');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2600', 'CREMONA', 'CR', '019');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2700', 'CUNEO', 'CN', '004');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2791', 'ALBA', 'CN', '004');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2792', 'MONDOVI''', 'CN', '004');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2800', 'ENNA', 'EN', '086');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('2900', 'FERRARA', 'FE', '038');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3000', 'FIRENZE', 'FI', '048');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3001', 'PRATO', 'PO', '100');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3090', 'EMPOLI', 'FI', '048');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3093', 'SCANDICCI', 'FI', '048');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3094', 'SESTO FIORENTINO', 'FI', '048');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3100', 'FOGGIA', 'FG', '071');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3191', 'SAN SEVERO', 'FG', '071');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3200', 'FORLI''', 'FC', '040');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3201', 'RIMINI', 'RN', '099');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3290', 'CESENA', 'FC', '040');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3300', 'FROSINONE', 'FR', '060');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3301', 'CASSINO', 'FR', '060');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3400', 'GENOVA', 'GE', '010');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3401', 'SESTRI LEVANTE', 'GE', '010');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3402', 'GENOVA PONENTE', 'GE', '010');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3500', 'GORIZIA', 'GO', '031');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3600', 'GROSSETO', 'GR', '053');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3700', 'IMPERIA', 'IM', '008');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3800', 'L''AQUILA', 'AQ', '066');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3801', 'SULMONA', 'AQ', '066');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3802', 'AVEZZANO', 'AQ', '066');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('3900', 'LA SPEZIA', 'SP', '011');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4000', 'LATINA', 'LT', '059');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4091', 'TERRACINA', 'LT', '059');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4100', 'LECCE', 'LE', '075');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4101', 'CASARANO', 'LE', '075');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4190', 'NARDO''', 'LE', '075');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4200', 'LIVORNO', 'LI', '049');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4201', 'PIOMBINO', 'LI', '049');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4300', 'LUCCA', 'LU', '046');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4400', 'MACERATA', 'MC', '043');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4500', 'MANTOVA', 'MN', '020');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4600', 'MASSA CARRARA', 'MS', '045');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4700', 'MATERA', 'MT', '077');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4800', 'MESSINA', 'ME', '083');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4891', 'SANTA TERESA DI RIVA', 'ME', '083');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4892', 'BARCELLONA POZZO DI GOTTO', 'ME', '083');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4900', 'MILANO', 'MI', '015');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4901', 'MONZA', 'MB', '108');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4902', 'MILANO NORD', 'MI', '015');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4903', 'MILANO MISSORI', 'MI', '015');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4904', 'MILANO FIORI', 'MI', '015');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4905', 'MILANO-CORVETTO', 'MI', '015');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4908', 'LEGNANO', 'MI', '015');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4909', 'SEREGNO', 'MI', '015');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4927', 'LODI', 'LO', '098');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4979', 'VIMERCATE', 'MB', '108');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4991', 'MELEGNANO', 'MI', '015');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4995', 'DESIO', 'MB', '108');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5000', 'MODENA', 'MO', '036');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5094', 'SASSUOLO', 'MO', '036');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5100', 'NAPOLI', 'NA', '063');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5101', 'CASTELLAMMARE', 'NA', '063');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5102', 'NOLA', 'NA', '063');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5103', 'NAPOLI ARZANO', 'NA', '063');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5104', 'NA SOCCAVO', 'NA', '063');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5105', 'NAPOLI VOMERO', 'NA', '063');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5106', 'POZZUOLI', 'NA', '063');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5199', 'GIUGLIANO', 'NA', '063');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5200', 'NOVARA', 'NO', '003');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5290', 'VERBANO-CUSIO-OSSOLA', 'VB', '103');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5300', 'NUORO', 'NU', '091');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5400', 'PADOVA', 'PD', '028');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5490', 'CITTADELLA', 'PD', '028');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5500', 'PALERMO', 'PA', '082');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5502', 'PALERMO/SUD', 'PA', '082');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5600', 'PARMA', 'PR', '034');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5700', 'PAVIA', 'PV', '018');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5791', 'VIGEVANO', 'PV', '018');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5800', 'PERUGIA', 'PG', '054');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5801', 'CITTA'' DI CASTELLO', 'PG', '054');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5890', 'FOLIGNO', 'PG', '054');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5900', 'PESARO', 'PU', '041');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('5992', 'FANO', 'PU', '041');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6000', 'PESCARA', 'PE', '068');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6100', 'PIACENZA', 'PC', '033');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6200', 'PISA', 'PI', '050');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6300', 'PISTOIA', 'PT', '047');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6400', 'POTENZA', 'PZ', '076');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6490', 'MELFI', 'PZ', '076');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6500', 'RAGUSA', 'RG', '088');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6590', 'MODICA', 'RG', '088');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6600', 'RAVENNA', 'RA', '039');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6691', 'LUGO', 'RA', '039');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6700', 'REGGIO CALABRIA', 'RC', '080');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6790', 'PALMI', 'RC', '080');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6791', 'LOCRI', 'RC', '080');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6800', 'REGGIO NELL''EMILIA', 'RE', '035');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6891', 'GUASTALLA', 'RE', '035');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('6900', 'RIETI', 'RI', '057');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7000', 'ROMA', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7001', 'ROMA EUR', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7002', 'ROMA M.VERDE GIANICOL.', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7003', 'LIDO DI OSTIA', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7004', 'ROMA-MONTESACRO', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7005', 'ROMA CENTRO', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7006', 'CIVITAVECCHIA', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7009', 'ROMA CASILINO PRENEST', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7010', 'ROMA TUSCOLANO', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7012', 'ROMA AURELIO', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7013', 'ROMA TIBURTINO', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7014', 'ROMA-FLAMINIO', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7015', 'POMEZIA', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7074', 'GROTTAFERRATA', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7091', 'GUIDONIA - TIVOLI', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7092', 'VELLETRI', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7094', 'MONTEROTONDO', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7095', 'ANZIO', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7096', 'PALESTRINA', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7099', 'GUIDONIA', 'RM', '058');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7100', 'ROVIGO', 'RO', '029');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7200', 'SALERNO', 'SA', '065');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7201', 'NOCERA INFERIORE', 'SA', '065');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7202', 'BATTIPAGLIA', 'SA', '065');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7300', 'SASSARI', 'SS', '090');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7390', 'OLBIA', 'OT', '104');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7400', 'SAVONA', 'SV', '009');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7500', 'SIENA', 'SI', '052');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7600', 'SIRACUSA', 'SR', '089');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7601', 'NOTO', 'SR', '089');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7700', 'SONDRIO', 'SO', '014');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7800', 'TARANTO', 'TA', '073');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7890', 'MANDURIA', 'TA', '073');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('7900', 'TERAMO', 'TE', '067');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8000', 'TERNI', 'TR', '055');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8100', 'TORINO', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8101', 'MONCALIERI', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8102', 'IVREA', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8103', 'TORINO/NORD', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8105', 'PINEROLO', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8106', 'COLLEGNO', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8191', 'ORBASSANO', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8192', 'CHIERI', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8193', 'CHIVASSO', 'TO', '001');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8200', 'TRAPANI', 'TP', '081');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8300', 'TRENTO', 'TN', '022');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8400', 'TREVISO', 'TV', '026');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8490', 'CONEGLIANO', 'TV', '026');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8500', 'TRIESTE', 'TS', '032');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8600', 'UDINE', 'UD', '030');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8691', 'CERVIGNANO DEL FRIULI', 'CO', '013');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8700', 'VARESE', 'VA', '012');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8790', 'BUSTO ARSIZIO', 'VA', '012');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8800', 'VENEZIA', 'VE', '027');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8801', 'SAN DONA'' DI PIAVE', 'VE', '027');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8891', 'CHIOGGIA', 'VE', '027');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8894', 'MESTRE', 'VE', '027');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8900', 'VERCELLI', 'VC', '002');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('8901', 'BIELLA', 'BI', '096');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('9000', 'VERONA', 'VR', '023');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('9100', 'VICENZA', 'VI', '024');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('9200', 'VITERBO', 'VT', '056');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('9300', 'PORDENONE', 'PN', '093');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('9400', 'ISERNIA', 'IS', '094');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('9500', 'ORISTANO', 'OR', '095');
INSERT INTO SEDEINPS (IDSEDEINPS, DENOMINAZIONE, PROVINCIASIGLA, IDPROVINCIA) VALUES ('4955', 'MILANO SESTO SAN GIOVANNI', 'MI', '015');

COMMIT WORK;


INSERT INTO STATOLAVORATORE (IDSTATOLAVORATORE, DESCRIZIONE) VALUES (0, 'Sconosciuto');
INSERT INTO STATOLAVORATORE (IDSTATOLAVORATORE, DESCRIZIONE) VALUES (1, 'Assunto');
INSERT INTO STATOLAVORATORE (IDSTATOLAVORATORE, DESCRIZIONE) VALUES (2, 'Licenziato o dimesso');

COMMIT WORK;

INSERT INTO TIPOTITOLARE (IDTIPOTITOLARE, DESCRIZIONE) VALUES ('0', 'Sconosciuto');
INSERT INTO TIPOTITOLARE (IDTIPOTITOLARE, DESCRIZIONE) VALUES ('1', 'Azienda / Ente / Amministrazione');
INSERT INTO TIPOTITOLARE (IDTIPOTITOLARE, DESCRIZIONE) VALUES ('2', 'Consulente del lavoro');
INSERT INTO TIPOTITOLARE (IDTIPOTITOLARE, DESCRIZIONE) VALUES ('3', 'Associazione di categoria, Caf imprese o Servizio istituito dall''Associazione di categoria, MEF-SPT');
INSERT INTO TIPOTITOLARE (IDTIPOTITOLARE, DESCRIZIONE) VALUES ('4', 'Avvocato');
INSERT INTO TIPOTITOLARE (IDTIPOTITOLARE, DESCRIZIONE) VALUES ('5', 'Dottore commercialista o esperto contabile');
--INSERT INTO TIPOTITOLARE (IDTIPOTITOLARE, DESCRIZIONE) VALUES ('6', 'C.E.D');
INSERT INTO TIPOTITOLARE (IDTIPOTITOLARE, DESCRIZIONE) VALUES ('7', 'Agrotecnici / agrotecnici laureati');

COMMIT WORK;

INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (11, 'Imprenditore individuale, libero professionista e lavoratore autonomo');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (12, 'Società di persone');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (13, 'Società di capitali');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (14, 'Società Cooperativa');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (15, 'Consorzio di diritto privato ed altre forme di cooperazione fra imprese');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (16, 'Ente pubblico economico, azienda speciale, azienda puibblica di servizi');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (17, 'Ente privato con personalità giuridica');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (18, 'Ente privato senza personalità giuridica');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (19, 'Impresa o ente privato costituito all''estero non altrimenti classificabile che svolge un''attività economica in Italia');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (21, 'Organo costituzionale o a rilevanza costituzionale');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (22, 'Amministarzione dello Stato');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (23, 'Autorità indipendente');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (24, 'Regione e autonomia locale');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (25, 'Azienda o ente del servizio sanitario nazionale');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (26, 'Istituto, scuola e università pubblica');
INSERT INTO FORMAGIURIDICACATEGORIA (IDCATEGORIA, DESCRIZIONE) VALUES (27, 'Ente pubblico non economico');

COMMIT WORK;

INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1110, 11, 'Imprenditore individuale agricolo');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1120, 11, 'Imprenditore individuale non agricolo');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1130, 11, 'Libero professionista');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1140, 11, 'Lavoratore autonomo');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1210, 12, 'Società semplice');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1220, 12, 'Società in nome collettivo');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1230, 12, 'Società in accomandita semplice');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1240, 12, 'Studio associato e società di professionisti');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1250, 12, 'Società di fatto o irregolare, comunione ereditaria');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1310, 13, 'Società per azioni');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1320, 13, 'Società a responsabilità limitata');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1330, 13, 'Società a responsabilità limitata con un unico socio');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1340, 13, 'Società in accomandita per azioni');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1350, 13, 'Società a responsabilità limitata semplificata');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1360, 13, 'Società a responsabilità limitata con capitale ridotto');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1410, 14, 'Società cooperativa a mutualità prevalente');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1420, 14, 'Società cooperativa diversa');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1430, 14, 'Società cooperativa sociale');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1440, 14, 'Società di mutua assicurazione');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1510, 15, 'Consorzio di diritto privato');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1520, 15, 'Società consortile');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1530, 15, 'Associazione o raggruppamento temporaneo di imprese');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1540, 15, 'Gruppo europeo di interesse economico');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1610, 16, 'Ente pubblico economico');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1620, 16, 'Azienda speciale ai sensi del t.u 267/2000');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1630, 16, 'Azienda pubblica di servizi alle persone ai sensi del D.Lgs n. 207/2001');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1710, 17, 'Associazione riconosciuta');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1720, 17, 'Fondazione (esclusa fondazione bancaria)');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1730, 17, 'Fondazione bancaria');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1740, 17, 'Ente ecclesiastico');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1750, 17, 'Società di mutuo soccorso');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1790, 17, 'Altra forma di ente privato con personalità giuridica');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1810, 18, 'Associazione non riconosciuta');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1820, 18, 'Comitato');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1830, 18, 'Condominio');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1890, 18, 'Altra forma di ente privato senza personalità giuridica');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (1900, 19, 'Impresa o ente privato costituito all''estero non altrimenti classificabile che svolge una attività e');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2100, 21, 'Organo costituzionale o a rilevanza costituzionale');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2210, 22, 'Presidenza del consiglio');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2220, 22, 'Ministero');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2230, 22, 'Agenzia dello Stato');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2240, 22, 'Archivio notarile');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2300, 23, 'Autorità indipendenti');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2410, 24, 'Regione');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2420, 24, 'Provincia');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2430, 24, 'Comune');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2440, 24, 'Comunità montana o isolana');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2450, 24, 'Unione di comuni');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2460, 24, 'Città metropolitana');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2500, 25, 'Azienda o ente del servizio sanitario nazionale');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2610, 26, 'Istituto e scuola pubblica di ogni ordine e grado');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2620, 26, 'Università pubblica');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2711, 27, 'Istituto o ente pubblico di ricerca');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2712, 27, 'Istituto pubblico di assistenza e beneficienza');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2720, 27, 'Camera di commercio');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2730, 27, 'Ordine e collegio professionale');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2740, 27, 'Consorzio di diritto pubblico');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2751, 27, 'Ente parco');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2752, 27, 'Ente o autorità portuale');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2753, 27, 'Ente di sviluppo agricolo regionale o di altro ente locale');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2754, 27, 'Ente per il turismo');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2755, 27, 'Ente ambientale regionale');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2756, 27, 'Ente per la ricerca e per l''aggiornamento educativo');
INSERT INTO FORMAGIURIDICA (IDFORMAGIURIDICA, IDCATEGORIA, DESCRIZIONE) VALUES (2790, 27, 'Altro ente pubblico non economico nazionale');

COMMIT WORK;

INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (1, 'Società in accomandita per azioni', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (2, 'Società a responsabilità limitata', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (3, 'Società per azioni', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (4, 'Società cooperative e loro consorzi iscritti nei registri prefettizi e nello schedario della cooperazione', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (5, 'Altre società cooperative', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (6, 'Mutue assicuratrici', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (7, 'Consorzi con personalità giuridica', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (8, 'Associazioni riconosciute', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (9, 'Fondazioni', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (10, 'Altri enti ed istituti con personalità giuridica', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (11, 'Consorzi senza personalità giuridica', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (12, 'Associazioni non riconosciute e comitati', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (13, 'Altre organizzazioni di persone o di beni senza personalità giuridica (escluse le comunioni)', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (14, 'Enti pubblici economici', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (15, 'Enti pubblici non economici', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (16, 'Casse mutue e fondi di previdenza, assistenza, pensioni o simili con o senza personalità giuridica', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (17, 'Opere pie e società di mutuo soccorso', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (18, 'Enti ospedalieri', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (19, 'Enti ed istituti di previdenza e di assistenza sociale', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (20, 'Aziende autonome di cura, soggiorno e turismo', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (21, 'Aziende regionali, provinciali, comunali e loro consorzi', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (22, 'Società, organizzazioni ed enti costituiti all’estero non altrimenti classificabili con sede dell’amministrazione od oggetto principale in Italia', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (23, 'Società semplici ed equiparate ai sensi dell’art. 5, comma 3, lett. b), del TUIR', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (24, 'Società in nome collettivo ed equiparate ai sensi dell’art. 5, comma 3, lett. b), del TUIR', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (25, 'Società in accomandita semplice', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (26, 'Società di armamento', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (27, 'Associazione fra artisti e professionisti', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (28, 'Aziende coniugali', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (29, 'GEIE (Gruppi europei di interesse economico)', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (50, 'Società per azioni, aziende speciali e consorzi di cui agli artt. 31, 113, 114, 115 e 116 del D.Lgs 18 agosto 2000, n. 267 (Testo Unico delle leggi sull’ordinamento degli enti locali)', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (51, 'Condomìni', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (52, 'Depositi I.V.A.', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (53, 'Società sportive dilettantistiche costituite in società di capitali senza fine di lucro', 0);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (30, 'Società semplici, irregolari e di fatto', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (31, 'Società in nome collettivo', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (32, 'Società in accomandita semplice', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (33, 'Società di armamento', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (34, 'Associazioni fra professionisti', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (35, 'Società in accomandita per azioni', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (36, 'Società a responsabilità limitata', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (37, 'Società per azioni', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (38, 'Consorzi', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (39, 'Altri enti ed istituti', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (40, 'Associazioni riconosciute, non riconosciute e di fatto', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (41, 'Fondazioni', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (42, 'Opere pie e società di mutuo soccorso', 1);
INSERT INTO AE_NATURAGIURIDICA (IDNATURAGIURIDICA, DESCRIZIONE, NONRESIDENTE) VALUES (43, 'Altre organizzazioni di persone e di beni', 1);

COMMIT WORK;

INSERT INTO AE_STATOSOCIETARIO (IDSTATOSOCIETARIO, DESCRIZIONE) VALUES (1, 'Soggetto in normale attività');
INSERT INTO AE_STATOSOCIETARIO (IDSTATOSOCIETARIO, DESCRIZIONE) VALUES (2, 'Soggetto in liquidazione per cessazione di attività');
INSERT INTO AE_STATOSOCIETARIO (IDSTATOSOCIETARIO, DESCRIZIONE) VALUES (3, 'Soggetto in fallimento o in liquidazione coatta amministrativa');
INSERT INTO AE_STATOSOCIETARIO (IDSTATOSOCIETARIO, DESCRIZIONE) VALUES (4, 'Soggetto estinto');

COMMIT WORK;

INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('0', 'Sconosciuto');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('1', 'Parente entro il terzo grado o affine entro il secondo grado');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('2', 'Ascendente (genitore, nonno, bisnonno) e gli equiparati ai genitori (adottanti, gli affilianti, il patrigno o la matrigna, nonché le persone alle quali l''interessato fu affidato)');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('3', 'Coniuge');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('4', 'Genero/Nuora');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('5', 'Suocero/Suocera');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('6', 'Fratello/Sorella');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('7', 'Nipote in linea diretta');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('8', 'Figlio legittimo o legittimato, adottivo o affiliato');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('9', 'Figlio naturale legalmente riconosciuto o giudizialmente dichiarato');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('10', 'Figlio nato da precedente matrimonio dell''altro coniuge');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('11', 'Nipote in linea collaterale (figli di fratelli e sorelle)');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('12', 'Affine entro il terzo grado');
INSERT INTO RAPPORTOPARENTELA (IDRAPPORTOPARENTELA, DESCRIZIONE) VALUES ('13', 'Coniuge legalmente ed effettivamente separato');

COMMIT WORK;


INSERT INTO TIPOPERSONAGIURIDICA (IDTIPOPERSONAGIURIDICA, DESCRIZIONE, INPSCOD) VALUES ('1', 'Azienda con una sola posizione inps, non autorizzata all''accentramento contributivo', 'A1');
INSERT INTO TIPOPERSONAGIURIDICA (IDTIPOPERSONAGIURIDICA, DESCRIZIONE, INPSCOD) VALUES ('2', 'Azienda con più posizioni inps, non autorizzata all''accentramento contributivo-principale', 'A2');
INSERT INTO TIPOPERSONAGIURIDICA (IDTIPOPERSONAGIURIDICA, DESCRIZIONE, INPSCOD) VALUES ('3', 'Azienda con più posizioni inps, non autorizzata all''accentramento contributivo-secondaria', 'A3');
INSERT INTO TIPOPERSONAGIURIDICA (IDTIPOPERSONAGIURIDICA, DESCRIZIONE, INPSCOD) VALUES ('4', 'Azienda con una sola posizione inps, autorizzata all''accentramento contributivo', 'B1');
INSERT INTO TIPOPERSONAGIURIDICA (IDTIPOPERSONAGIURIDICA, DESCRIZIONE, INPSCOD) VALUES ('5', 'Azienda con più posizioni inps, autorizzata all''accentramento contributivo-principale', 'B2');
INSERT INTO TIPOPERSONAGIURIDICA (IDTIPOPERSONAGIURIDICA, DESCRIZIONE, INPSCOD) VALUES ('6', 'Azienda con più posizioni inps, autorizzata all''accentramento contributivo-secondaria', 'B3');
INSERT INTO TIPOPERSONAGIURIDICA (IDTIPOPERSONAGIURIDICA, DESCRIZIONE, INPSCOD) VALUES ('0', 'Sconosciuta', NULL);

COMMIT WORK;

INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PR01', 'C.E.D.A.I.I.E.R. EMILIA ROMAGNA', '2', NULL, '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AN02', 'C.ED.AM. CASSA EDILE ARTIG. MARCHE', '2', NULL, '11');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BA02', 'EDILCASSA DI PUGLIA', '2', NULL, '16');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RC02', 'EDILCASSA REGIONALE CALABRESE', '2', NULL, '18');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AQ02', 'EDILCASSA REGIONE ABRUZZO', '2', NULL, '13');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PZ02', 'EDILCASSA REGIONE BASILICATA', '2', NULL, '17');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RM02', 'EDILCASSA REGIONE LAZIO', '2', NULL, '12');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CB02', 'EDILCASSA REGIONE MOLISE', '2', NULL, '14');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CA02', 'EDILCASSA REGIONE SARDA', '2', NULL, '20');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PA02', 'EDILCASSA REGIONE SICILIA', '2', NULL, '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AR01', 'FONDO AS. LAV. ED. ARTIGIANI', '2', NULL, NULL);
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('TO00', 'TORINO', '1', '001', '01');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VC00', 'VERCELLI', '1', '002', '01');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('NO00', 'NOVARA', '1', '003', '01');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CN00', 'CUNEO', '1', '004', '01');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AT00', 'ASTI', '1', '005', '01');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AL00', 'ALESSANDRIA', '1', '006', '01');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AO00', 'AOSTA', '1', '007', '02');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('IM00', 'IMPERIA', '1', '008', '07');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('SV00', 'SAVONA', '1', '009', '07');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('GE00', 'GENOVA', '1', '010', '07');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('SP00', 'LA SPEZIA', '1', '011', '07');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VA00', 'VARESE', '1', '012', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CO00', 'COMO', '1', '013', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('SO00', 'SONDRIO', '1', '014', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('MI00', 'MILANO', '1', '015', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BG00', 'BERGAMO', '1', '016', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BG01', 'EDILCASSA BERGAMO', '2', '016', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BS00', 'BRESCIA', '1', '017', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PV00', 'PAVIA', '1', '018', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CR00', 'CREMONA', '1', '019', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('MN00', 'MANTOVA', '1', '020', '03');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BZ00', 'BOLZANO', '1', '021', '04');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('TN00', 'TRENTO', '1', '022', '04');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VR00', 'VERONA', '1', '023', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VI00', 'VICENZA', '1', '024', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BL00', 'BELLUNO', '1', '025', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('TV00', 'TREVISO', '1', '026', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VE00', 'VENEZIA', '1', '027', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VE11', 'C.E.A.V. MARGHERA VENEZIA', '2', '027', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VE21', 'C.E.V.A. MESTRE VENEZIA', '2', '027', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PD00', 'PADOVA', '1', '028', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RO00', 'ROVIGO', '1', '029', '05');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('UD00', 'UDINE', '1', '030', '06');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('GO00', 'GORIZIA', '1', '031', '06');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('TS00', 'TRIESTE', '1', '032', '06');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PC00', 'PIACENZA', '1', '033', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PR00', 'PARMA', '1', '034', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RE00', 'REGGIO EMILIA', '1', '035', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RE03', 'C.E.M.A. REGGIO EMILIA', '2', '035', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('MO00', 'MODENA', '1', '036', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('MO03', 'CASSA EDILE P.I. MODENA', '2', '036', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BO00', 'BOLOGNA', '1', '037', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BO03', 'C.A.L.E.C. BOLOGNA', '2', '037', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BO01', 'C.E.D.A. BOLOGNA', '2', '037', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FE00', 'FERRARA', '1', '038', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FE01', 'C.E.D.A.F. FERRARA', '2', '038', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FE03', 'C.E.L.CO.F. FERRARA', '2', '038', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RA00', 'RAVENNA', '1', '039', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FO00', 'FORLI''', '1', '040', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FO03', 'CASSA EDILE COOP. FORLI''', '2', '040', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PS00', 'PESARO', '1', '041', '11');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AN00', 'ANCONA', '1', '042', '11');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('MC00', 'MACERATA', '1', '043', '11');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AP00', 'ASCOLI PICENO', '1', '044', '11');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('MS00', 'MASSA CARRARA', '1', '045', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('LU00', 'LUCCA', '1', '046', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PT00', 'PISTOIA', '1', '047', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FI00', 'FIRENZE', '1', '048', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FI02', 'C.E.R.T. FIRENZE', '2', '048', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('LI00', 'LIVORNO', '1', '049', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PI00', 'PISA', '1', '050', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AR00', 'AREZZO', '1', '051', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('SI00', 'SIENA', '1', '052', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('GR00', 'GROSSETO', '1', '053', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PG00', 'PERUGIA', '1', '054', '10');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('TR00', 'TERNI', '1', '055', '10');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VT00', 'VITERBO', '1', '056', '12');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RI00', 'RIETI', '1', '057', '12');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RM00', 'ROMA', '1', '058', '12');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('LT00', 'LATINA', '1', '059', '12');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FR00', 'FROSINONE', '1', '060', '12');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CE00', 'CASERTA', '1', '061', '15');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BN00', 'BENEVENTO', '1', '062', '15');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('NA00', 'NAPOLI', '1', '063', '15');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AV00', 'AVELLINO', '1', '064', '15');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('SA00', 'SALERNO', '1', '065', '15');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AQ00', 'L''AQUILA', '1', '066', '13');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('TE00', 'TERAMO', '1', '067', '13');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PE00', 'PESCARA', '1', '068', '13');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CH00', 'CHIETI', '1', '069', '13');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CB00', 'CAMPOBASSO', '1', '070', '14');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('FG00', 'FOGGIA', '1', '071', '16');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BA00', 'BARI', '1', '072', '16');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('TA00', 'TARANTO', '1', '073', '16');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BR00', 'BRINDISI', '1', '074', '16');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('LE00', 'LECCE', '1', '075', '16');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PZ00', 'POTENZA', '1', '076', '17');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('MT00', 'MATERA', '1', '077', '17');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CS00', 'COSENZA', '1', '078', '18');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CZ00', 'CATANZARO', '1', '079', '18');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RC00', 'REGGIO CALABRIA', '1', '080', '18');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('TP00', 'TRAPANI', '1', '081', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PA00', 'PALERMO', '1', '082', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('ME00', 'MESSINA', '1', '083', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('AG00', 'AGRIGENTO', '1', '084', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CL00', 'CALTANISSETTA', '1', '085', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('EN00', 'ENNA', '1', '086', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CT00', 'CATANIA', '1', '087', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RG00', 'RAGUSA', '1', '088', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('SR00', 'SIRACUSA', '1', '089', '19');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('SS00', 'SASSARI', '1', '090', '20');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('NU00', 'NUORO', '1', '091', '20');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('CA00', 'CAGLIARI', '1', '092', '20');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PN00', 'PORDENONE', '1', '093', '06');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('OR00', 'ORISTANO', '1', '095', '20');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('BI00', 'BIELLA', '1', '096', '01');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('RN00', 'RIMINI', '1', '099', '08');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('PO00', 'PRATO', '1', '100', '09');
INSERT INTO CASSAEDILE (IDCASSAEDILE, DENOMINAZIONE, IDTIPO, IDPROVINCIA, IDREGIONE) VALUES ('VB00', 'VERBANIA INTRA', '1', '103', '01');

COMMIT WORK;

INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('ESTER', 'ESTERO', NULL, NULL);
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AG101', 'AGRIGENTO', 'AGRIGENTO', 'AG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AL120', 'ALESSANDRIA', 'ALESSANDRIA', 'AL');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AL121', 'CASALE M.TO', 'CASALE MONFERRATO', 'AL');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AL122', 'NOVI LIGURE', 'NOVI LIGURE', 'AL');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AN104', 'SENIGALLIA', 'SENIGALLIA', 'AN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AN105', 'JESI', 'JESI', 'AN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AN106', 'FABRIANO', 'FABRIANO', 'AN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AN107', 'ANCONA', 'ANCONA', 'AN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AO101', 'AOSTA', 'AOSTA', 'AO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AP111', 'FERMO', 'FERMO', 'AP');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AP112', 'S. BENEDETTO T.', 'S. BENEDETTO DEL TRONTO', 'AP');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AP113', 'ASCOLI PICENO', 'ASCOLI PICENO', 'AP');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AQ101', 'AVEZZANO/SULMONA', 'AVEZZANO', 'AQ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AQ104', 'L''AQUILA', 'L''AQUILA', 'AQ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AR108', 'AREZZO', 'AREZZO', 'AR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AT119', 'ASTI', 'ASTI', 'AT');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AV101', 'AVELLINO 1', 'ARIANO IRPINO', 'AV');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('AV102', 'AVELLINO 2', 'AVELLINO', 'AV');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BA101', 'BA/1', 'ANDRIA', 'BA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BA102', 'BA/2', 'BARLETTA', 'BA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BA103', 'BA/3', 'ALTAMURA', 'BA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BA104', 'BA/4', 'BARI', 'BA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BA105', 'BA/5', 'PUTIGNANO', 'BA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BG301', 'BERGAMO', 'BERGAMO', 'BG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BI112', 'BIELLA', 'BIELLA', 'BI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BL101', 'BELLUNO', 'BELLUNO', 'BL');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BL102', 'FELTRE', 'FELTRE', 'BL');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BN103', 'BENEVENTO 1', 'BENEVENTO', 'BN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BO105', 'BOLOGNA SUD', 'CASALECCHIO DI RENO', 'BO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BO106', 'IMOLA', 'IMOLA', 'BO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BO107', 'BOLOGNA NORD', 'SAN GIORGIO DI PIANO', 'BO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BO108', 'BOLOGNA', 'BOLOGNA', 'BO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BR106', 'BR/1', 'BRINDISI', 'BR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BS302', 'BRESCIA', 'BRESCIA', 'BS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BS315', 'VALLECAMONICA SEBINO', 'SEBINO BRENO', 'BS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BZ101', 'CENTRO SUD BZ', 'BOLZANO', 'BZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BZ102', 'OVEST MERANO', 'MERANO', 'BZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BZ103', 'NORD BRESSANONE', 'BRESSANONE', 'BZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('BZ104', 'EST BRUNICO', 'BRUNICO', 'BZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CA106', '6', 'SANLURI', 'CA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CA107', '7', 'CARBONIA', 'CA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CA108', '8', 'CAGLIARI', 'CA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CB103', 'CENTRO MOLISE', 'CAMPOBASSO', 'CB');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CB104', 'BASSO MOLISE', 'TERMOLI', 'CB');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CE104', 'CASERTA 1', 'CASERTA', 'CE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CE105', 'CASERTA 2', 'AVERSA', 'CE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CH102', 'CHIETI', 'CHIETI', 'CH');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CH103', 'LANCIANO/VASTO', 'LANCIANO', 'CH');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CL102', 'CALTANISSETTA', 'CALTANISSETTA', 'CL');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CN115', 'CUNEO', 'CUNEO', 'CN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CN116', 'MONDOVI''', 'MONDOVI''', 'CN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CN117', 'SAVIGLIANO', 'SAVIGLIANO', 'CN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CN118', 'ALBA', 'ALBA', 'CN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CO303', 'COMO', 'COMO', 'CO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CR304', 'CREMONA', 'CREMONA', 'CR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CS101', 'PAOLA', 'PAOLA', 'CS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CS102', 'CASTROVILLARI', 'CASTROVILLARI', 'CS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CS103', 'ROSSANO', 'ROSSANO', 'CS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CS104', 'COSENZA', 'COSENZA', 'CS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CT103', 'CATANIA', 'CATANIA', 'CT');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CZ106', 'LAMEZIA TERME', 'LAMEZIA TERME', 'CZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('CZ107', 'CATANZARO', 'CATANZARO', 'CZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('EN104', 'ENNA', 'ENNA', 'EN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FC111', 'FORLI''', 'FORLI''', 'FC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FC112', 'CESENA', 'CESENA', 'FC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FE109', 'FERRARA', 'FERRARA', 'FE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FG107', 'FG/1', 'SAN SEVERO', 'FG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FG108', 'FG/2', 'CERIGNOLA', 'FG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FG109', 'FG/3', 'FOGGIA', 'FG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FI110', 'FIRENZE', 'FIRENZE', 'FI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FI111', 'EMPOLI', 'EMPOLI', 'FI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('FR112', 'FROSINONE', 'FROSINONE', 'FR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('GE103', 'GENOVESE', 'GENOVA', 'GE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('GE104', 'CHIAVARESE', 'CHIAVARI', 'GE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('GO102', 'ISONTINA', 'GORIZIA', 'GO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('GR109', 'GROSSETO', 'GROSSETO', 'GR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('IM101', 'IMPERIESE', 'BUSSANA DI SANREMO', 'IM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('IS101', 'ALTO MOLISE', 'AGNONE', 'IS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('IS102', 'PENTRIA', 'ISERNIA', 'IS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('KR105', 'CROTONE', 'CROTONE', 'KR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('LC305', 'LECCO', 'LECCO', 'LC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('LE110', 'LE/1', 'LECCE', 'LE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('LE111', 'LE/2', 'MAGLIE', 'LE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('LI106', 'LIVORNO', 'LIVORNO', 'LI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('LO306', 'LODI', 'LODI', 'LO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('LT111', 'LATINA', 'LATINA', 'LT');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('LU102', 'LUCCA', 'LUCCA', 'LU');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('LU112', 'VERSILIA', 'VIAREGGIO', 'LU');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MC108', 'CIVITANOVA M.', 'CIVITANOVA MARCHE', 'MC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MC109', 'MACERATA', 'MACERATA', 'MC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MC110', 'CAMERINO', 'CAMERINO', 'MC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('ME105', 'MESSINA', 'MESSINA', 'ME');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MI308', 'MILANO', 'MILANO', 'MI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MI309', 'MILANO1', 'LEGNANO', 'MI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MI310', 'MILANO2', 'MELEGNANO', 'MI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MI311', 'MILANO3', 'MONZA', 'MI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MN307', 'MANTOVA', 'MANTOVA', 'MN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MO104', 'MODENA', 'MODENA', 'MO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MS101', 'MASSA CARRARA', 'MASSA CARRARA', 'MS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MT104', 'MATERA', 'MATERA', 'MT');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('MT105', 'MONTALBANO JONICO', 'MONTALBANO JONICO', 'MT');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('NA106', 'NAPOLI 1', 'NAPOLI', 'NA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('NA107', 'NAPOLI 2', 'POZZUOLI', 'NA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('NA108', 'NAPOLI 3', 'FRATTAMAGGIORE', 'NA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('NA109', 'NAPOLI 4', 'POMIGLIANO D''ARCO', 'NA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('NA110', 'NAPOLI 5', 'CASTELLAMARE DI STABIA', 'NA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('NO113', 'NOVARA', 'NOVARA', 'NO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('NU103', '3', 'NUORO', 'NU');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('NU104', '4', 'LANUSEI', 'NU');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('OR105', '5', 'ORISTANO', 'OR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PA106', 'PALERMO', 'PALERMO', 'PA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PC101', 'PIACENZA', 'PIACENZA', 'PC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PD115', 'CITTADELLA', 'CITTADELLA', 'PD');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PD116', 'PADOVA', 'PADOVA', 'PD');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PD117', 'ESTE', 'MONSELICE', 'PD');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PE105', 'PESCARA', 'PESCARA', 'PE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PG101', 'CITTA'' DI CASTELLO', 'CITTA'' DI CASTELLO', 'PG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PG102', 'PERUGIA', 'PERUGIA', 'PG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PG103', 'FOLIGNO', 'FOLIGNO', 'PG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PI105', 'PISA', 'PISA', 'PI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PN106', 'FRIULI OCCIDENTALE', 'PORDENONE', 'PN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PO104', 'PRATO', 'PRATO', 'PO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PR102', 'PARMA', 'PARMA', 'PR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PT103', 'PISTOIA', 'PISTOIA', 'PT');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PU101', 'PESARO', 'PESARO', 'PU');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PU102', 'URBINO', 'URBINO', 'PU');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PU103', 'FANO', 'FANO', 'PU');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PV312', 'PAVIA', 'PAVIA', 'PV');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PZ101', 'VENOSA', 'VENOSA', 'PZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PZ102', 'POTENZA', 'POTENZA', 'PZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('PZ103', 'LAGONEGRO', 'LAGONEGRO', 'PZ');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RA110', 'RAVENNA', 'RAVENNA', 'RA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RC109', 'LOCRI', 'LOCRI', 'RC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RC110', 'PALMI', 'PALMI', 'RC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RC111', 'REGGIO CALABRIA', 'REGGIO CALABRIA', 'RC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RE103', 'REGGIO EMILIA', 'REGGIO EMILIA', 'RE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RG107', 'RAGUSA', 'RAGUSA', 'RG');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RI110', 'RIETI', 'RIETI', 'RI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RM101', 'RM/A', 'ROMA', 'RM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RM102', 'RM/B', 'ROMA', 'RM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RM103', 'RM/C', 'ROMA', 'RM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RM104', 'RM/D', 'ROMA', 'RM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RM105', 'RM/E', 'ROMA', 'RM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RM106', 'RM/F', 'CIVITAVECCHIA', 'RM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RM107', 'RM/G', 'TIVOLI', 'RM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RM108', 'RM/H', 'ALBANO LAZIALE', 'RM');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RN113', 'RIMINI', 'RIMINI', 'RN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RO118', 'ROVIGO', 'ROVIGO', 'RO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('RO119', 'ADRIA', 'ADRIA', 'RO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SA111', 'SALERNO 1', 'NOCERA INFERIORE', 'SA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SA112', 'SALERNO 2', 'SALERNO', 'SA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SA113', 'SALERNO 3', 'VALLO DELLA LUCANIA', 'SA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SI107', 'SIENA', 'SIENA', 'SI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SO313', 'SONDRIO', 'SONDRIO', 'SO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SP105', 'SPEZZINO', 'LA SPEZIA', 'SP');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SR108', 'SIRACUSA', 'SIRACUSA', 'SR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SS101', '1', 'SASSARI', 'SS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SS102', '2', 'OLBIA', 'SS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('SV102', 'SAVONESE', 'SAVONA', 'SV');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TA112', 'TA/1', 'TARANTO', 'TA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TE106', 'TERAMO', 'TERAMO', 'TE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TN101', 'TRENTO', 'TRENTO', 'TN');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO101', 'TORINO I', 'TORINO', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO102', 'TORINO II', 'TORINO', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO103', 'TORINO III', 'TORINO', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO104', 'TORINO IV', 'TORINO', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO105', 'COLLEGNO', 'COLLEGNO', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO106', 'CIRIE''', 'CIRIE''', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO107', 'CHIVASSO', 'CHIVASSO', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO108', 'CHIERI', 'CHIERI', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO109', 'IVREA', 'IVREA', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TO110', 'PINEROLO', 'PINEROLO', 'TO');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TP109', 'TRAPANI', 'TRAPANI', 'TP');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TR105', 'TERNI', 'TERNI', 'TR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TS101', 'TRIESTINA', 'TRIESTE', 'TS');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TV107', 'PIEVE DI SOLIGO', 'PIEVE DI DI SOLIGO', 'TV');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TV108', 'ASOLO', 'ASOLO', 'TV');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('TV109', 'TREVISO', 'TREVISO', 'TV');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('UD103', 'ALTO FRIULI', 'GEMONA', 'UD');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('UD104', 'MEDIO FRIULI', 'UDINE', 'UD');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('UD105', 'BASSA FRIULANA', 'PALMANOVA', 'UD');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VA314', 'VARESE', 'VARESE', 'VA');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VB114', 'OMEGNA', 'OMEGNA', 'VB');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VC111', 'VERCELLI', 'VERCELLI', 'VC');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VE110', 'S. DONA'' DEL PIAVE', 'S. DONA'' DI PIAVE', 'VE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VE112', 'VENEZIANA', 'MESTRE', 'VE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VE113', 'MIRANO', 'MIRANO', 'VE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VE114', 'CHIOGGIA', 'CHIOGGIA', 'VE');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VI103', 'BASSANO D. GRAPPA', 'BASSANO D. GRAPPA', 'VI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VI104', 'THIENE', 'THIENE', 'VI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VI105', 'ARZIGNANO', 'ARZIGNANO', 'VI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VI106', 'VICENZA', 'VICENZA', 'VI');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VR120', 'VERONA', 'VERONA', 'VR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VR121', 'LEGNAGO', 'LEGNAGO', 'VR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VR122', 'BUSSOLENGO', 'BUSSOLENGO', 'VR');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VT109', 'VITERBO', 'VITERBO', 'VT');
INSERT INTO ASL (IDASL, DENOMINAZIONE, COMUNE, PROVINCIASIGLA) VALUES ('VV108', 'VIBO VALENTIA', 'VIBO VALENTIA', 'VV');


COMMIT WORK;

/*
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('1', 'Legislatori, dirigenti e imprenditori');
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('2', 'Professioni intellettuali,scientifiche e di elevata specializzazione');
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('3', 'Professioni tecniche');
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('4', 'Impiegati');
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('5', 'Professioni qualificate nelle attività commercaili e nei servizi');
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('6', 'Artigiani, operai specializzati e agricoltori');
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('7', 'Conduttori di impianti e operai semiqualificati di macchinari fissi e mobili');
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('8', 'Professioni non qualificate');
INSERT INTO ISTAT_GRANDIGRUPPI (CODICE, DESCRIZIONE) VALUES ('9', 'Forze armate');

COMMIT WORK;

INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('11', 'Membri dei corpi legislativi e di governo, dirigenti amministrativi e giudiziari della pubblica
amministrazione e di organizzazioni di interesse nazionale e sovranazionale');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('12', 'Imprenditori, amministratori e direttori di grandi aziende private');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('13', 'Imprenditori, gestori e responsabili di piccole imprese');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('21', 'Specialisti in scienze matematiche, fisiche, naturali ed assimilati');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('22', 'Ingegneri, architetti e professioni assimilate');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('23', 'Specialisti nelle scienze della vita');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('24', 'Specialisti della salute');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('25', 'Specialisti in scienze umane, sociali e gestionali');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('26', 'Specialisti della formazione, della ricerca ed assimilati');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('31', 'Professioni tecniche nelle scienze fisiche, naturali, nell’ingegneria ed assimilate');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('32', 'Professioni tecniche nelle scienze della salute e della vita');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('33', 'Professioni tecniche nell’amministrazione e nelle attività finanziarie e commerciali');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('34', 'Professioni tecniche nei servizi pubblici e alle persone');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('41', 'Impiegati di ufficio');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('42', 'Impiegati a contatto diretto con il pubblico');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('51', 'Professioni qualificate nelle attività commerciali');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('52', 'Professioni qualificate nelle attività turistiche ed alberghiere');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('53', 'Maestri di arti e mestieri, addestratori ed assimilati');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('54', 'Professioni qualificate nei servizi sanitari');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('55', 'Professioni qualificate nei servizi sociali, culturali, di sicurezza, di pulizia ed assimilati');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('61', 'Artigiani e operai specializzati dell’ industria estrattiva e dell’ edilizia');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('62', 'Artigiani ed operai metalmeccanici specializzati ed assimilati');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('63', 'Artigiani ed operai specializzati della meccanica di precisione, dell’artigianato artistico, della
stampa ed assimilati');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('64', 'Agricoltori e operai specializzati dell’agricoltura, delle foreste, della zootecnia, della pesca e della
caccia');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('65', 'Artigiani e operai specializzati delle lavorazioni alimentari, del legno, del tessile, dell’abbigliamento,
delle pelli, del cuoio ed assimilati');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('66', 'Artigiani ed operai specializzati dell’industria dello spettacolo');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('71', 'Conduttori di impianti industriali');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('72', 'Operai semiqualificati di macchinari fissi per la lavorazione in serie e operai addetti al montaggio');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('73', 'Operatori di macchinari fissi in agricoltura e nella industria alimentare');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('74', 'Conduttori di veicoli, di macchinari mobili e di sollevamento');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('81', 'Professioni non qualificate nelle attività gestionali');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('82', 'Professioni non qualificate nelle attività commerciali e nei servizi');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('83', 'Professioni non qualificate nei servizi di istruzione e sanitari');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('84', 'Professioni non qualificate nei servizi alle persone ed assimilati');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('85', 'Professioni non qualificate dell’agricoltura, dell’allevamento, della pesca e della forestazione');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('86', 'Professioni non qualificate delle miniere, delle costruzioni e delle attività industriali');
INSERT INTO ISTAT_GRUPPI (CODICE, DESCRIZIONE) VALUES ('90', 'Forze armate');

COMMIT WORK;

*/


INSERT INTO TIPOINDIRIZZO (IDTIPOINDIRIZZO, DESCRIZIONE) VALUES ('0', 'Altro');
INSERT INTO TIPOINDIRIZZO (IDTIPOINDIRIZZO, DESCRIZIONE) VALUES ('1', 'Residenza anagrafica');
INSERT INTO TIPOINDIRIZZO (IDTIPOINDIRIZZO, DESCRIZIONE) VALUES ('2', 'Domicilio anagrafico');
INSERT INTO TIPOINDIRIZZO (IDTIPOINDIRIZZO, DESCRIZIONE) VALUES ('3', 'Domicilio fiscale al 31 dicembre');
INSERT INTO TIPOINDIRIZZO (IDTIPOINDIRIZZO, DESCRIZIONE) VALUES ('4', 'Domicilio fiscale al 1 gennaio');
INSERT INTO TIPOINDIRIZZO (IDTIPOINDIRIZZO, DESCRIZIONE) VALUES ('5', 'Sede legale');
INSERT INTO TIPOINDIRIZZO (IDTIPOINDIRIZZO, DESCRIZIONE) VALUES ('7', 'Sede amministrativa');
INSERT INTO TIPOINDIRIZZO (IDTIPOINDIRIZZO, DESCRIZIONE) VALUES ('9', 'Sede operativa');


COMMIT WORK;

INSERT INTO AZIONE (IDAZIONE, DESCRIZIONE, NOTE) VALUES (0, 'Nessuna operazione' , NULL);
INSERT INTO AZIONE (IDAZIONE, DESCRIZIONE, NOTE) VALUES (1, 'Controllo completo' , NULL);
INSERT INTO AZIONE (IDAZIONE, DESCRIZIONE, NOTE) VALUES (2, 'Solo lettura' , NULL);
INSERT INTO AZIONE (IDAZIONE, DESCRIZIONE, NOTE) VALUES (3, 'Lettura, modifica, senza cancellazione' , NULL);

COMMIT WORK;

INSERT INTO TARGET (IDTARGET, DESCRIZIONE, NOTE) VALUES (0, 'Errore' , NULL);
INSERT INTO TARGET (IDTARGET, DESCRIZIONE, NOTE) VALUES (1, 'Altre funzioni' , NULL);
INSERT INTO TARGET (IDTARGET, DESCRIZIONE, NOTE) VALUES (2, 'Gestione anagrafica' , NULL);
INSERT INTO TARGET (IDTARGET, DESCRIZIONE, NOTE) VALUES (3, 'Gestione lavoratori' , NULL);
INSERT INTO TARGET (IDTARGET, DESCRIZIONE, NOTE) VALUES (4, 'Gestione cedolini' , NULL);
INSERT INTO TARGET (IDTARGET, DESCRIZIONE, NOTE) VALUES (5, 'Dichiarazioni annuali e mensili' , NULL);

COMMIT WORK;

INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('0000', '-');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('CS01', 'Lavoratore con indennità art.80 L.388/2000');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('E000', 'Lavoratore in aspettativa per funzioni pubbl. elettive');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('ICSM', 'Lavoratore progetto ICS – Ministero del Lavoro');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('ICSS', 'Lavoratore progetto speciale Sardegna');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('ISPT', 'Lavoratore progetto incentivi Taranto');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('LAPA', 'Lavoratore programma P.A.R.I. 2007');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('LS01', 'Lavoratore impegnato in LSU');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('N000', 'Lav.marittimo con nazionalità di Paese S.E.E.');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('NFOR', 'Lavoratore non in forza all’azienda. Deve essere utilizzato in tutti i casi in cui sia
necessario inviare una denuncia (arretrati, conguagli, ecc.) dopo la cessazione del rapporto di lavoro.');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('PARI', 'Lavoratore interessato al programma P.A.R.I.');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('S000', 'Lavoratore in aspettativa per cariche sindacali');
INSERT INTO TIPOLAVORATORESTAT (IDTIPOLAVORATORESTAT, DESCRIZIONE) VALUES ('DICO', 'Lavoratore distaccato/comandato in INPS');

COMMIT WORK;

INSERT INTO TIPODATORE (IDTIPODATORE, DESCRIZIONE, SOSTITUTOIMPOSTA) VALUES ('1','La persona non è datore di lavoro','0');
INSERT INTO TIPODATORE (IDTIPODATORE, DESCRIZIONE, SOSTITUTOIMPOSTA) VALUES ('2','La persona è titolare di un''impresa individuale', '1');
INSERT INTO TIPODATORE (IDTIPODATORE, DESCRIZIONE, SOSTITUTOIMPOSTA) VALUES ('3','La persona è un datore di lavoro domestico','0');
INSERT INTO TIPODATORE (IDTIPODATORE, DESCRIZIONE, SOSTITUTOIMPOSTA) VALUES ('4','La persona rappresenta un''associazione non riconosciuta (è sostituto d''imposta)', '1');
INSERT INTO TIPODATORE (IDTIPODATORE, DESCRIZIONE, SOSTITUTOIMPOSTA) VALUES ('5','La persona rappresenta un''associazione non riconosciuta (non è sostituto d''imposta)', '0');

COMMIT WORK;

INSERT INTO AE_TIPODESTINAZIONE5M (IDAETIPODESTINAZIONE, DESCRIZIONE) VALUES (0, 'Non specificato');
INSERT INTO AE_TIPODESTINAZIONE5M (IDAETIPODESTINAZIONE, DESCRIZIONE) VALUES (1, 'Sostegno del volontariato e delle altre organizzazioni non lucrative di utilità sociale, delle associazioni di promozione sociale e delle associazioni e fondazioni riconosciute che operano nei settori di cui all''art. 10, c.1, lett a), del D.Lgs. n.460 del 1997');
INSERT INTO AE_TIPODESTINAZIONE5M (IDAETIPODESTINAZIONE, DESCRIZIONE) VALUES (2, 'Finanziamento agli enti della ricerca scientifica e delle università');
INSERT INTO AE_TIPODESTINAZIONE5M (IDAETIPODESTINAZIONE, DESCRIZIONE) VALUES (3, 'Finanziamento alla ricerca sanitaria');
INSERT INTO AE_TIPODESTINAZIONE5M (IDAETIPODESTINAZIONE, DESCRIZIONE) VALUES (4, 'Sostegno delle attività sociali svolte dal comune di residenza del contribuente');
INSERT INTO AE_TIPODESTINAZIONE5M (IDAETIPODESTINAZIONE, DESCRIZIONE) VALUES (5, 'Sostegno alle associazioni sportive dilettantistiche riconosciute ai fini sportivi del CONI a norma di legge, che svolgono una rilevante attività di interesse sociale');

COMMIT WORK;

INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0101', 'C.G.I.L. CAMERA DEL LAVORO TERRITORIALE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0102', 'C.G.I.L. F.I.L.C.E.M.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0103', 'C.G.I.L. F.I.L.L.E.A.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0104', 'C.G.I.L. F.I.O.M.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0105', 'C.G.I.L. F.I.L.T.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0106', 'C.G.I.L. F.I.L.C.A.M.S.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0107', 'C.G.I.L. F.I.L.T.E.A.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0108', 'C.G.I.L. F.L.A.I.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0109', 'C.G.I.L. S.L.C.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0110', 'C.G.I.L. F.I.L.P.T.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0111', 'C.G.I.L. FEDERAZIONE LAVORATORI FUNZIONE PUBBLICA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0112', 'C.G.I.L. F.L.C.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0113', 'C.G.I.L. S.N.R.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0114', 'C.G.I.L. S.N.U.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0115', 'C.G.I.L. F.I.S.A.C.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0116', 'C.G.I.L. F.N.L.E.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0117', 'C.G.I.L. NIDIL');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0201', 'C.I.S.L. UST - UNIONE SIND. TERRIT.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0202', 'C.I.S.L. F.E.M.C.A. FED. ENERGIA, MODA, CHIMICI E AFFINI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0203', 'C.I.S.L. F.I.L.C.A.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0204', 'C.I.S.L. F.I.M.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0205', 'C.I.S.L. FIT-AUTOF. E INTERNAV.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0206', 'C.I.S.L. F.I.T. - FERROVIERI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0207', 'C.I.S.L. F.I.T. - LAV. PORTI E AEROPORT.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0208', 'C.I.S.L. F.I.T. - LAV. SERV. E AMBIENTE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0209', 'C.I.S.L. F.I.T. - MARITTIMI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0210', 'C.I.S.L. FIT');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0211', 'C.I.S.L. F.I.S.A.S.C.A.T.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0212', 'C.I.S.L. F.E.M.C.A. FED. ENERGIA, MODA, CHIMICI E AFFINI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0213', 'C.I.S.L. F.A.I.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0214', 'C.I.S.L. F.I.S.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0215', 'C.I.S.L. F.A.I.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0216', 'C.I.S.L. F.A.I.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0217', 'C.I.S.L. SLP');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0218', 'C.I.S.L. F.P.T. - SETTORE UFFICI LOCALI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0219', 'C.I.S.L. F.P.T. - SETTORE UFFICI TELEFONICI PRIV.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0220', 'C.I.S.L. F.P.T. - SETTORE UFFICI TELEFONICI STATO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0221', 'C.I.S.L. F.P.T. - INSTALL. APPALTI POSTALI TELEF.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0222', 'C.I.S.L. F.P.P. - SETTORE STATO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0223', 'C.I.S.L. F.P.P. - SETTORE AUTONOMIE LOCALI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0224', 'C.I.S.L. F.P.P. - ENTI PUBBLICI NON ECONOMICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0225', 'C.I.S.L. FPS');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0226', 'C.I.S.L. CISL SCUOLA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0227', 'C.I.S.L. FSUR - S.I.S.M.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0228', 'C.I.S.L. FIR');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0229', 'C.I.S.L. UNIVERSITA''');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0230', 'C.I.S.L. FIBA CREDITO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0231', 'C.I.S.L. FIBA ASSICURAZ.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0232', 'C.I.S.L. F.L.A.E.I.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0233', 'C.I.S.L. FISTEL - FED.ITALIANA SPETTACOLO E TELECOMUNICAZ.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0234', 'C.I.S.L. UNIONE SINDACATI PALERMITANI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0235', 'C.I.S.L. FELSA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0236', 'C.I.S.L. FNS');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0301', 'U.I.L. CAMERA DEL LAVORO TERRITORIALE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0302', 'U.I.L. UILCEM');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0303', 'U.I.L. FE.NE.A.L.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0304', 'U.I.L. U.I.L.M.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0305', 'U.I.L. TRASPORTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0306', 'U.I.L. U.I.L.TU.C.S.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0307', 'U.I.L. U.I.L.T.A.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0308', 'U.I.L. UILA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0309', 'U.I.L. U.I.L.S.I.C.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0310', 'U.I.L. U.I.L.I.A.S. - MONOPOLI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0311', 'U.I.L. U.I.L. POST.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0312', 'U.I.L. COMUNICAZIONE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0313', 'U.I.L. UILPA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0314', 'U.I.L. U.I.L.D.E.P.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0315', 'U.I.L. - ENTI LOCALI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0316', 'U.I.L. U.I.L.E.M.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0317', 'U.I.L. SCUOLA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0318', 'U.I.L. FPL SEGRETERIA NAZIONALE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0319', 'U.I.L. - UNIVERSITA'', RICERCA, GIOVANI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0320', 'U.I.L. U.I.L.ASS.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0321', 'U.I.L. UILCA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0322', 'U.I.L. F.I.L.E.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0323', 'U.I.L. U.I.L.S.P.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0324', 'U.I.L. U.I.L.PE.M');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0325', 'U.I.L. CPO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0401', 'U.G.L. ALIMENTAZIONE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0402', 'U.G.L. CARTA E STAMPA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0403', 'U.G.L. CHIMICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0404', 'U.G.L. COSTRUZIONI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0405', 'U.G.L. ENERGIA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0406', 'U.G.L. METALMECCANICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0407', 'U.G.L. SPETTACOLO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0408', 'U.G.L. TELECOMUNICAZIONI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0409', 'U.G.L. TESSILI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0410', 'U.G.L. COLTIVATORI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0411', 'U.G.L. LAVORATORI AGRICOLI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0412', 'U.G.L. COLONI E MEZZADRI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0413', 'U.G.L. AUTOFERROTRANVIERI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0414', 'U.G.L. MARE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0415', 'U.G.L. TRASPORTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0416', 'U.G.L. TERZIARIO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0417', 'U.G.L. SICUREZZA CIVILE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0418', 'U.G.L. ASSICURATORI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0419', 'U.G.L. CREDITO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0420', 'U.G.L. ENTI LOCALI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0421', 'U.G.L. ENTI PUBBLICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0422', 'U.G.L. FERROVIE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0423', 'U.G.L. POSTE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0424', 'U.G.L. SANITA''');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0425', 'U.G.L. SCUOLA/UNIVERSITA''');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0426', 'U.G.L. STATALI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0427', 'U.G.L. VIGILI DEL FUOCO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0428', 'U.G.L. PENSIONATI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0429', 'U.G.L. TESSILI FIBRE ARTIFICIALI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0501', 'A.S.G.B. UNIONE SINDACATI AUTONOMI SUDTIROLESI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0601', 'CONF.S.A.L. ENTI LOCALI: AUTONOMIE LOCALI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0602', 'CONF.S.A.L. SNALA: MONOPOLI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0603', 'CONF.S.A.L. FNP: ENTI NON ECONOMICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0604', 'CONF.S.A.L. FENAR: RICERCA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0605', 'CONF.S.A.L. FIALS: SANITA''');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0606', 'CONF.S.A.L. SNALS: SCUOLA, UNIVERSITA''');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0607', 'CONF.S.A.L. UNSA: MINISTERIALI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0608', 'CONF.S.A.L. UNIVERSITA''');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0609', 'CONF.S.A.L. FNA: AGRICOLTURA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0610', 'CONF.S.A.L. FESICA: INDUSTRIA E COMMERCIO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0611', 'CONF.S.A.L. CHIMICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0612', 'CONF.S.A.L. FALBI: BANCARI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0613', 'CONF.S.A.L. EDILIZIA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0614', 'CONF.S.A.L. ENERGIA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0615', 'CONF.S.A.L. GRAFICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0616', 'CONF.S.A.L. FISMIC: METALMECCANICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0617', 'CONF.S.A.L. SERVIZI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0618', 'CONF.S.A.L. LIBERSIND: SPETTACOLO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0619', 'CONF.S.A.L. SAILP: POSTELEGRAFONICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0620', 'CONF.S.A.L. TESSILI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0621', 'CONF.S.A.L. FAST: TRASPORTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0622', 'CONF.S.A.L. FEALT: LAVORATORI TEMPORANEI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0623', 'CONF.S.A.L. SAMPI: MEDICI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0624', 'CONF.S.A.L. SELD: DISABILI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0625', 'CONF.S.A.L. FASPI: PICCOLI IMPRENDITORI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0626', 'CONF.S.A.L. SNALA ANAS: AUTOSTRADE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0627', 'CONF.S.A.L. SAGE: GIORNALISTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0628', 'CONF.S.A.L. FEDERCASA: INQUILINI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0629', 'CONF.S.A.L. SAB: BARACELLI REGIONE SARDEGNA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0630', 'CONF.S.A.L. SILDIR: DIPENDENTI REGIONE SARDEGNA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0701', 'C.I.S.A.L. FAILMS');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0702', 'C.I.S.A.L. FIALC');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0703', 'C.I.S.A.L. FAILPA PULIZIA E AFFINI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0704', 'C.I.S.A.L. FEDERCALZATURIERI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0705', 'C.I.S.A.L. FAILPC POLIGRAFICI E CARTAI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0706', 'C.I.S.A.L. FAILTS');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0707', 'C.I.S.A.L. FISALT LAVORATORI DEL TABACCO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0708', 'C.I.S.A.L. SALPG LAVORATORI PLASTICA E GOMMA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0709', 'C.I.S.A.L. FILAIA ALIMENTARISTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0710', 'C.I.S.A.L. SALC CERAMISTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0711', 'C.I.S.A.L. FAILEA EDILI E AFFINI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0712', 'C.I.S.A.L. FNASLA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0713', 'C.I.S.A.L. FEDERMAR');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0714', 'C.I.S.A.L. SCUOLA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0715', 'C.I.S.A.L. COMUNICAZIONE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0716', 'C.I.S.A.L. FIADEL');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0717', 'C.I.S.A.L. CLIM');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0801', 'S.A.V.T. SINDACATO AUTONOMO VALDOSTANO TRAVAILL.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0901', 'C.I.U. USPPI - AGRICOLTURA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0902', 'C.I.U. CISAS - FID');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0903', 'C.I.U. UNIONQUADRI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0904', 'C.I.U. PRESTAZIONI TEMPORANEE AREA SERVIZI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0905', 'C.I.U. PRESTAZIONI TEMPORANEE AREA INDUSTRIE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0906', 'C.I.U. PRESTAZIONI TEMPORANEE AREA TRASPORTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0907', 'C.I.U. PRESTAZIONI TEMPORANEE AREA COMUNICAZIONI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('0908', 'C.I.U. PRESTAZIONI TEMPORANEE AREA ENERGIE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1002', 'U.N.T.I.A. UNIONE NAZIONALE TUTELE IN AGRICOLTURA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1101', 'C.U.B. A.LL.C.A');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1102', 'C.U.B. COBAS P.T.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1103', 'C.U.B. C.S.S.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1104', 'C.U.B. CUB - EDILI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1105', 'C.U.B. CUB - INFORMAZIONE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1106', 'C.U.B. CUB - SALLCA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1107', 'C.U.B. CUB - SCUOLA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1108', 'C.U.B. CUB - TESSILI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1109', 'C.U.B. FLAICA - UNITI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1110', 'C.U.B. FLMU - UNITI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1111', 'C.U.B. TRASPORTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1112', 'C.U.B. RDB - FEDERAZIONE LSU');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1113', 'C.U.B. RDB - FEDERAZIONE ENERGIA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1114', 'C.U.B. RDB - TRASPORTI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1115', 'C.U.B. RDB - PUBBLICO IMPIEGO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1116', 'C.U.B. RDB - SERVIZI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1117', 'C.U.B. SULTA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1201', 'EUROCOLTIVATORI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1301', 'FE.N.A.P.I. FEDERAZ. NAZIONALE AUTONOMA PICCOLI IMPRENDITORI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1401', 'ACLITERRA ASSOCIAZIONE PROFESSIONALE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1501', 'U.N.S.I.C. UNIONE NAZIONALE SINDACALE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1601', 'A.N.C.C.A. ASS. NAZ. COLTIVATORI CONTRATTO AGRARIO');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1701', 'UNIMPRESA UNIONE NAZIONALE DI IMPRESE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1801', 'CONFESERCENTI CONF. ITALIANA ESERCENTI ATTIVITA COMM. E TURIS.');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('1901', 'A.N.P.A. ASSOCIAZIONE NAZIONALE PRODUTTORI AGRICOLI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2001', 'A.M.P.I. ASS.MEDITERRANEA PICCOLE IMPRESE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2101', 'FAPI FEDERAZIONE ARTIGIANI PENSIONATI ITALIANI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2201', 'ASSOPENSIONATI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2301', 'USAE UNIONE SINDACATI AUTONOMI EUROPEI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2302', 'USAE FENALPI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2303', 'USAE ADELPI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2401', 'FELTEP FEDERAZIONE LAVORATORI TEMPORANEI PADANI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2501', 'CNA CONF. NAZ. ARTIGIANATO E PICCOLA E MEDIA IMPRESA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2601', 'CASARTIGIANI CONF. AUTONOMA SINDACATI ARTIGIANI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2701', 'CLAAI CONF. LIBERE ASSOCIAZIONI ARTIGIANE ITALIANE');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2801', 'AILP ASSOCIAZIONE ITALIANA LAVORATORI E PENSIONATI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('2901', 'FNUA FEDERAZIONE NAZIONALE USPPI-AGRICOLTURA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('3001', 'SNAD SIND. NAZ. AUTONOMO DISOCCUPATI E CASSAINTEGRATI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('3101', 'FAGRI FILIERA AGRICOLA ITALIANA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('3201', 'FEDER.AGRI. FED. NAZ. SVILUPPO AGRICOLTURA');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('3301', 'CONF.LAVORATORICONF.LAVORATORI');
INSERT INTO TIPOSINDACATO (IDTIPOSINDACATO, DESCRIZIONE) VALUES ('3401', 'CSE CONFEDERAZIONE INDIPENDENTE SINDACATI EUROPEI');

COMMIT WORK;

--spostaste tabelle CNCE da paghe a anag 15/07/2011
INSERT INTO CNCE_TIPOCOMMITTENTE (IDTIPOCOMMITTENTE, DESCRIZIONE) VALUES ('1', 'Committente pubblico');
INSERT INTO CNCE_TIPOCOMMITTENTE (IDTIPOCOMMITTENTE, DESCRIZIONE) VALUES ('2', 'Committente privato');
INSERT INTO CNCE_TIPOCOMMITTENTE (IDTIPOCOMMITTENTE, DESCRIZIONE) VALUES ('3', 'Lavori in proprio');
INSERT INTO CNCE_TIPOCOMMITTENTE (IDTIPOCOMMITTENTE, DESCRIZIONE) VALUES ('4', 'Lavori in appalto/subappalto da impresa edile');

COMMIT WORK;

INSERT INTO CNCE_SITUAZIONECANTIERE (IDSITUAZIONE, DESCRIZIONE) VALUES ('1', 'Normale attività');
INSERT INTO CNCE_SITUAZIONECANTIERE (IDSITUAZIONE, DESCRIZIONE) VALUES ('2', 'Ripresa Lavori');
INSERT INTO CNCE_SITUAZIONECANTIERE (IDSITUAZIONE, DESCRIZIONE) VALUES ('3', 'Sospensione');
INSERT INTO CNCE_SITUAZIONECANTIERE (IDSITUAZIONE, DESCRIZIONE) VALUES ('4', 'Cessazione');
INSERT INTO CNCE_SITUAZIONECANTIERE (IDSITUAZIONE, DESCRIZIONE) VALUES ('5', 'Senza Dipendenti');

COMMIT WORK;

INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('01', 'OG1 – nuova edilizia civile comp. Impianti e fognature');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('02', 'OG1 – nuova edilizia industriale esclusi impianti');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('03', 'Ristrutturazione di edifici civili');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('04', 'Ristrutturazione di edifici industriali');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('05', 'OG2 – restauro e manutenzione di beni tutelati');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('06', 'OG3 – opere stradali, ponti etc.');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('07', 'OG4 – opere d’arte nel sottosuolo');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('08', 'OG5 – dighe');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('09', 'OG6 – acquedotti e fognature');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('10', 'OG6 – gasdotti');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('11', 'OG6 – oleodotti');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('12', 'OG6 - opere di irrigazione ed evacuazione');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('13', 'OG7 – opere marittime');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('14', 'OG8 – opere fluviali');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('15', 'OG9 - impianti per la produzione di energia elettrica');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('16', 'OG10 – impianti per la trasformazione e distribuzione');
INSERT INTO CNCE_TIPOATTIVITA (IDTIPOATTIVITA, DESCRIZIONE) VALUES ('17', 'OG12 – OG13 – bonifica e protezione ambientale');

COMMIT WORK;

INSERT INTO CNCE_TIPOCONTRATTO (IDTIPOCONTRATTO, DESCRIZIONE) VALUES ('1', 'Industria');
INSERT INTO CNCE_TIPOCONTRATTO (IDTIPOCONTRATTO, DESCRIZIONE) VALUES ('2', 'Artigianato');
INSERT INTO CNCE_TIPOCONTRATTO (IDTIPOCONTRATTO, DESCRIZIONE) VALUES ('3', 'Cooperazione');
INSERT INTO CNCE_TIPOCONTRATTO (IDTIPOCONTRATTO, DESCRIZIONE) VALUES ('4', 'Piccola industria');

COMMIT WORK;

INSERT INTO CNCE_TIPOLAVORO (IDTIPOLAVORO, DESCRIZIONE) VALUES ('1', 'Lavori in appalto');
INSERT INTO CNCE_TIPOLAVORO (IDTIPOLAVORO, DESCRIZIONE) VALUES ('2', 'Lavori in subappalto');
INSERT INTO CNCE_TIPOLAVORO (IDTIPOLAVORO, DESCRIZIONE) VALUES ('3', 'Lavori in proprio');
INSERT INTO CNCE_TIPOLAVORO (IDTIPOLAVORO, DESCRIZIONE) VALUES ('4', 'Somministrazione / Distacco');
INSERT INTO CNCE_TIPOLAVORO (IDTIPOLAVORO, DESCRIZIONE) VALUES ('5', 'Affidamento');

COMMIT WORK;

INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('1', 'Agrigento');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('2', 'Alessandria');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('3', 'Ancona');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('4', 'Aosta');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('5', 'Arezzo');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('6', 'Ascoli Piceno');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('7', 'Asti');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('8', 'Avellino');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('9', 'Bari');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('10', 'Belluno');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('11', 'Benevento');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('12', 'Bergamo');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('13', 'Biella');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('14', 'Bologna');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('15', 'Bolzano');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('16', 'Brescia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('17', 'Brindisi');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('18', 'Cagliari');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('19', 'Caltanissetta');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('20', 'Campobasso');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('21', 'Caserta');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('22', 'Catania');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('23', 'Catanzaro');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('24', 'Chieti');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('25', 'Como');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('26', 'Cosenza');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('27', 'Cremona');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('28', 'Crotone');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('29', 'Cuneo');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('30', 'Enna');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('31', 'Ferrara');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('32', 'Firenze');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('33', 'Foggia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('34', 'Forlì Cesena');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('35', 'Frosinone');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('36', 'Genova');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('37', 'Gorizia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('38', 'Grosseto');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('39', 'Imperia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('40', 'Isernia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('41', 'L''Aquila');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('42', 'La Spezia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('43', 'Latina');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('44', 'Lecce');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('45', 'Lecco');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('46', 'Livorno');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('47', 'Lodi');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('48', 'Lucca');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('49', 'Macerata');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('50', 'Mantova');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('51', 'Massa Carrara');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('52', 'Matera');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('53', 'Messina');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('54', 'Milano');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('55', 'Modena');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('56', 'Napoli');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('57', 'Novara');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('58', 'Nuoro');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('59', 'Oristano');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('60', 'Padova');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('61', 'Palermo');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('62', 'Parma');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('63', 'Pavia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('64', 'Perugia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('65', 'Pesaro Urbino');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('66', 'Pescara');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('67', 'Piacenza');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('68', 'Pisa');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('69', 'Pistoia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('70', 'Pordenone');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('71', 'Potenza');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('72', 'Prato');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('73', 'Ragusa');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('74', 'Ravenna');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('75', 'Reggio Calabria');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('76', 'Reggio Emilia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('77', 'Rieti');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('78', 'Rimini');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('79', 'Roma');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('80', 'Rovigo');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('81', 'Salerno');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('82', 'Sassari');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('83', 'Savona');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('84', 'Siena');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('85', 'Siracusa');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('86', 'Sondrio');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('87', 'Taranto');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('88', 'Teramo');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('89', 'Terni');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('90', 'Torino');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('91', 'Trapani');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('92', 'Trento');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('93', 'Treviso');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('94', 'Trieste');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('95', 'Udine');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('96', 'Varese');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('97', 'Venezia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('98', 'Verbano Cusio Ossola');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('99', 'Vercelli');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('100', 'Verona');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('101', 'Vibo Valentia');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('102', 'Vicenza');
INSERT INTO QUESTURA (IDQUESTURA, DESCRIZIONE) VALUES ('103', 'Viterbo');

INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('111', 'Stabilimenti di produzione cinematografica', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('112', 'Imprese di produzione cinematografica', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('113', 'Imprese di produzione varia (shorts pubblicitari, fotoromanzi ecc', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('114', 'Imprese di sviluppo e stampa', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('115', 'Imprese di doppiaggio', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('121', 'Imprese di distribuzione e noleggio', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('122', 'Esercizi esclusivamente cinematografici', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('123', 'Esercizi cinematografici polivalenti', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('211', 'Edizione musicale, incisione colonne di repertorio e incisione ed dischi', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('212', 'Edizione musicale, incisione colonne di repertorio e incisione dischi. Categoria cantanti', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('221', 'Enti autonomi lirici e sinfonici', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('222', 'Imprese liriche', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('223', 'Imprese concertistiche', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('224', 'Imprese di spettacolo di balletto', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('225', 'Imprese di spettacolo di operette', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('231', 'Complessi orchestrali di musica leggera', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('232', 'Complessi bandistici', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('311', 'Teatri stabili', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('312', 'Compagnie di prosa', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('322', 'Compagnie di commedia musicale', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('331', 'Esercizi teatrali', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('411', 'Rai Radiotelevisione italiana', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('412', 'Radiotelevisioni nazionali private', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('413', 'Radiotelevisioni estere', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('511', 'Esercizi pubblici con orchestra (dancing,nights ecc.)', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('512', 'Case da gioco', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('513', 'Sale da gioco', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('514', 'Sale di attrazione', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('515', 'Parchi di divertimento e zoo-safari', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('516', 'Sale bingo', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('521', 'Spettacolo viaggianti, giostre ed attrazioni', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('522', 'Circhi equestri', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('531', 'Imprese organizzatrici di festivals di partito, feste patronali ecc.', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('532', 'Imprese organizzatrici di festivals', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('533', 'Imprese organizzatrici di manifestazioni di moda', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('611', 'Imprese ed organismi preposti alla gestione di impianti sportivi e che svolgono attività sportiva di qualsiasi genere', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('612', 'Imprese esercenti attività sportiva nell''ambito delle discipline regolamentate dal C.O.N.I. e che trattengono rapporti con sportivi professionisti', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('711', 'Posizione provvisorie in attesa di accertamenti', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('712', 'Imprese non dello spettacolo che effettuano versamenti per trattenute di pensione', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('713', 'Imprese esercenti attività di fornitura di servizi nei vari settori dello spettacolo', '01.01.2008', NULL);
INSERT INTO SP_CATEGORIA (IDCATEGORIA, DESCRIZIONE, VALIDODAL, VALIDOAL) VALUES ('714', 'Lavoratore autonomo', '01.01.2008', NULL);

COMMIT WORK;

INSERT INTO PA_ORGANO (IDORGANO, DESCRIZIONE) VALUES ('1', 'Tribunale civile in funzione di giudice del lavoro');
INSERT INTO PA_ORGANO (IDORGANO, DESCRIZIONE) VALUES ('2', 'Corte di appello');
INSERT INTO PA_ORGANO (IDORGANO, DESCRIZIONE) VALUES ('3', 'TAR');
INSERT INTO PA_ORGANO (IDORGANO, DESCRIZIONE) VALUES ('4', 'Consiglio di Stato');
INSERT INTO PA_ORGANO (IDORGANO, DESCRIZIONE) VALUES ('5', 'Cassazione');
INSERT INTO PA_ORGANO (IDORGANO, DESCRIZIONE) VALUES ('6', 'Organo di conciliazione');
INSERT INTO PA_ORGANO (IDORGANO, DESCRIZIONE) VALUES ('7', 'Sede sindacale');

COMMIT WORK;


INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (1, 'Rappresentante legale, negoziale o di fatto, socio amministratore');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (2, 'Rappresentante di minore, inabilitato o interdetto, ovvero curatore dell’eredità giacente, amministratore di eredità devoluta sotto condizione sospensiva o in favore di nascituro non ancora concepito ovvero amministratore di sostegno per le persone con limitata capacità di agire');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (3, 'Curatore fallimentare');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (4, 'Commissario liquidatore (liquidazione coatta amministrativa ovvero amministrazione straordinaria)');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (5, 'Commissario giudiziale (amministrazione controllata) ovvero custode giudiziario (custodia giudiziaria), ovvero amministratore giudiziario in qualità di rappresentante dei beni sequestrati');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (6, 'Rappresentante fiscale di soggetto non residente');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (7, 'Erede');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (8, 'Liquidatore (liquidazione volontaria)');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (9, 'Soggetto tenuto a presentare la dichiarazione ai fini IVA per conto del soggetto estinto a seguito di operazioni straordinarie o altre trasformazioni sostanziali soggettive (cessionario d’azienda, società beneficiaria, incorporante, conferitaria, ecc.); ovvero, ai fini delle imposte sui redditi e/o dell’IRAP, rappresentante della società beneficiaria (scissione) o della società risultante dalla fusione o incorporazione');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (10, 'Rappresentante fiscale di soggetto non residente con le limitazioni di cui all’art. 44, comma 3, del D.L. n. 331/1993');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (11, 'Soggetto esercente l’attività tutoria del minore o interdetto in relazione alla funzione istituzionale rivestita');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (12, 'Liquidatore (liquidazione volontaria di ditta individuale - periodo ante messa in liquidazione)');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (13, 'Amministratore di condominio');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (14, 'Soggetto che sottoscrive la dichiarazione per conto di una pubblica amministrazione');
INSERT INTO AE_TipoCarica (IdTipoCarica, Descrizione) VALUES (15, 'Commissario liquidatore di una pubblica amministrazione');

COMMIT WORK;

/******************************************************************************/
/****                                Done                                  ****/
/******************************************************************************/