-- Created		01/12/2004
-- Modified:	18/10/2019
-- Project		Paghe Pro
-- Model		Anagrafica (Geo)
-- Company		Iubar.it (http://www.iubar.it)
-- Author		ing. Andrea Borgogelli Avveduti (info@iubar.it)
-- Version:		01.45.00
-- Database		Firebird

/******************************************************************************/
/****                                Connection                            ****/
/******************************************************************************/

CONNECT 'localhost:C:\Users\Iubar\AppData\Local\Temp\fdb\anag.fdb'
USER 'SYSDBA' PASSWORD 'masterkey';

/******************************************************************************/
/****                                Dati Geografici                       ****/
/******************************************************************************/

INSERT INTO CONTINENTE (IDCONTINENTE, DENOMINAZIONE) VALUES ('1', 'Europa');
INSERT INTO CONTINENTE (IDCONTINENTE, DENOMINAZIONE) VALUES ('2', 'Africa');
INSERT INTO CONTINENTE (IDCONTINENTE, DENOMINAZIONE) VALUES ('3', 'Asia');
INSERT INTO CONTINENTE (IDCONTINENTE, DENOMINAZIONE) VALUES ('4', 'America');
INSERT INTO CONTINENTE (IDCONTINENTE, DENOMINAZIONE) VALUES ('5', 'Oceania');
INSERT INTO CONTINENTE (IDCONTINENTE, DENOMINAZIONE) VALUES ('6', 'Apolide');

INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('11', 'Unione europea', '1');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('12', NULL, '1');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('13', NULL, '1');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('21', NULL, '2');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('22', NULL, '2');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('23', NULL, '2');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('24', NULL, '2');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('31', NULL, '3');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('32', NULL, '3');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('33', NULL, '3');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('41', NULL, '4');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('42', NULL, '4');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('50', NULL, '5');
INSERT INTO STATOAREA (IDAREA, DENOMINAZIONE, IDCONTINENTE) VALUES ('60', NULL, '6');


---------------------------- STATO ESTERO
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('0', '11', 'Italia', 'ITALIA', 'Italia', 'Repubblica Italiana', NULL, NULL, NULL, 'ITA', NULL, '0000', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('201', '12', 'Albania', 'ALBANIA', 'Albania', 'Rep. Popolare Socialista di Albania', 'ALBANESE', '87', '999100', 'AL', NULL, 'Z100', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('202', '13', 'Andorra', 'ANDORRA', 'Andorra', 'Principato di Andorra', 'ANDORRANA', '4', '999301', 'AND', NULL, 'Z101', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('203', '11', 'Austria', 'AUSTRIA', 'Austria', 'Repubblica Austriaca', 'AUSTRIACA', '8', '999102', 'A', 'AT', 'Z102', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('206', '11', 'Belgio', 'BELGIO', 'Belgium', 'Regno del Belgio', 'BELGA', '9', '999103', 'B', 'BE', 'Z103', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('209', '11', 'Bulgaria', 'BULGARIA', 'Bulgaria', 'Repubblica Popolare di Bulgaria', 'BULGARA', '12', '999104', 'BG', 'BG', 'Z104', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('212', '11', 'Danimarca', 'DANIMARCA', 'Denmark', 'Regno di Danimarca', 'DANESE', '21', '999107', 'DK', 'DK', 'Z107', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('214', '11', 'Finlandia', 'FINLANDIA', 'Finland', 'Repubblica di Finlandia', 'FINLANDESE', '28', '999109', 'FIN', 'FI', 'Z109', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('215', '11', 'Francia', 'FRANCIA', 'France', 'Repubblica Francese', 'FRANCESE', '29', '999110', 'F', 'FR', 'Z110', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('216', '11', 'Germania', 'GERMANIA', 'Germany', 'Repubblica Federale di Germania', 'TEDESCA', '94', '999112', 'D', 'DE', 'Z112', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('219', '11', 'Regno Unito', 'REGNO UNITO', 'United Kingdom', 'R.U. di Gran Bretagna e Irlanda Nord', 'BRITANNICA', '31', NULL, 'GB', 'GB', 'Z114', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('220', '11', 'Grecia', 'GRECIA', 'Greece', 'Repubblica Greca', 'GRECA', '32', '999115', 'GR', 'EL', 'Z115', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('221', '11', 'Irlanda', 'IRLANDA', 'Ireland', 'Repubblica d''Irlanda', 'IRLANDESE', '40', '998116', NULL, 'IE', 'Z116', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('223', '13', 'Islanda', 'ISLANDA', 'Iceland', 'Repubblica d''Islanda', 'ISLANDESE', '41', '999117', 'IS', 'IS', 'Z117', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('225', '13', 'Liechtenstein', 'LIECHTENSTEIN', 'Liechtenstein', 'Principato di Liechtenstein', NULL, '90', '999119', 'FL', 'LI', 'Z119', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('226', '11', 'Lussemburgo', 'LUSSEMBURGO', 'Luxembourg', 'Granducato di Lussemburgo', 'LUSSEMBURGHESE', '92', '999120', 'L', 'LU', 'Z120', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('227', '11', 'Malta', 'MALTA', 'Malta', 'Repubblica di Malta', 'MALTESE', '105', '999121', 'M', 'MT', 'Z121', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('229', '13', 'Monaco', 'PRINCIPATO DI MONACO', 'Monaco', 'Principato di Monaco', 'MONEGASCA', '91', '999123', 'MC', NULL, 'Z123', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('231', '13', 'Norvegia', 'NORVEGIA', 'Norway', 'Regno di Norvegia', 'NORVEGESE', '48', '999125', 'N', 'NO', 'Z125', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('232', '11', 'Paesi Bassi', 'PAESI BASSI', 'Netherlands', 'Regno Dei Paesi Bassi', 'OLANDESE', '50', '999126', 'NL', 'NL', 'Z126', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('233', '11', 'Polonia', 'POLONIA', 'Poland', 'Repubblica di Polonia', 'POLACCA', '54', '999127', 'PL', 'PL', 'Z127', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('234', '11', 'Portogallo', 'PORTOGALLO', 'Portugal', 'Repubblica Portoghese', 'PORTOGHESE', '55', '999128', 'P', 'PT', 'Z128', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('235', '11', 'Romania', 'ROMANIA', 'Romania', 'Repubblica Socialista di Romania', 'ROMENA', '61', '999129', 'RO', 'RO', 'Z129', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('236', '13', 'San Marino', 'SAN MARINO', 'San Marino', 'Repubblica di San Marino', 'SANMARINESE', '37', '999130', 'RSM', NULL, 'Z130', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('239', '11', 'Spagna', 'SPAGNA', 'Spain', 'Regno di Spagna', 'SPAGNOLA', '67', '999131', 'E', 'ES', 'Z131', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('240', '11', 'Svezia', 'SVEZIA', 'Sweden', 'Regno di Svezia', 'SVEDESE', '68', '999132', 'S', 'SE', 'Z132', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('241', '13', 'Svizzera', 'SVIZZERA', 'Switzerland', 'Confederazione Elvetica', 'SVIZZERA', '71', '999133', 'CH', 'CH', 'Z133', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('243', '12', 'Ucraina', 'UCRAINA', 'Ukraine', 'Repubblica dell''Ucraina', 'UCRAINA', '263', '999138', 'UA', NULL, 'Z138', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('244', '11', 'Ungheria', 'UNGHERIA', 'Hungary', 'Repubblica Ungherese', 'UNGHERESE', '77', '999134', 'H', 'HU', 'Z134', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('245', '12', 'Russa, Federazione', 'RUSSIA (FEDERAZIONE DI)', 'Russian Federation', 'Repubblica Russa', 'RUSSA', '262', '999154', NULL, NULL, 'Z154', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('246', '13', 'Stato della Città del Vaticano', 'SANTA SEDE (CITTA'' DEL VATICANO)', 'Vatican City State', 'Stato della Città del Vaticano', NULL, '93', '999106', NULL, NULL, 'Z106', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('247', '11', 'Estonia', 'ESTONIA', 'Estonia', 'Repubblica del l''Estonia', 'ESTONE', '257', '999144', 'EST', 'EE', 'Z144', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('248', '11', 'Lettonia', 'LETTONIA', 'Latvia', 'Repubblica di Lettonia', 'LETTONE', '258', '999145', 'LV', 'LV', 'Z145', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('249', '11', 'Lituania', 'LITUANIA', 'Lithuania', 'Repubblica della Lituania', 'LITUANA', '259', '999146', 'LT', 'LT', 'Z146', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('250', '11', 'Croazia', 'CROAZIA', 'Croatia', 'Repubblica della Croazia', 'CROATA', '261', '999149', 'HR', NULL, 'Z149', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('251', '11', 'Slovenia', 'SLOVENIA', 'Slovenia', 'Repubblica della Slovenia', 'SLOVENA', '260', '998150', 'SLO', 'SI', 'Z150', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('252', '12', 'Bosnia-Erzegovina', 'BOSNIA-ERZEGOVINA', 'Bosnia and Herzegovina', 'Repubblica di Bosnia Erzegovina', 'BOSNIACA', '274', '999153', NULL, NULL, 'Z153', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('253', '12', 'Macedonia, Repubblica di', 'MACEDONIA', 'Macedonia (FYROM)', 'Ex Repubblica Jugoslava di Macedonia', 'MACEDONE', '278', '998148', 'MK', NULL, 'Z148', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('254', '12', 'Moldova', 'MOLDOVIA', 'Moldova, Republic of', 'Repubblica di Moldova', NULL, '265', '999140', NULL, NULL, 'Z140', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('255', '11', 'Slovacchia', 'SLOVACCHIA', 'Slovakia', 'Repubblica Slovacca', 'SLOVACCA', '276', '998155', 'SK', 'SK', 'Z155', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('256', '12', 'Bielorussia', 'BIELORUSSIA', 'Belarus', 'Repubblica di Bielorussia', 'BIELORUSSA', '264', '999139', 'BY', NULL, 'Z139', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('257', '11', 'Ceca, Repubblica', 'CECA (REPUBBLICA)', 'Czech Republic', 'Repubblica Ceca', 'CECA', '275', '998156', NULL, 'CZ', 'Z156', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('270', '12', 'Montenegro', 'SERBIA E MONTENEGRO', 'Montenegro', NULL, 'MONTENEGRINA', '288', '999158', 'SCG', NULL, 'Z159', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('271', '12', 'Serbia, Repubblica di', 'SERBIA', 'Serbia', 'Serba', 'SERBA', '288', '999158', 'SCG', NULL, 'Z158', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('272', '12', 'Kosovo', 'KOSSOVO', 'Kosovo', NULL, 'KOSOVARA', NULL, '999160', '', NULL, 'Z160', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('301', '32', 'Afghanistan', 'AFGHANISTAN', 'Afghanistan', 'Repubblica Democratica di Afganistan', 'AFGHANA', '2', '999200', 'AFG', NULL, 'Z200', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('302', '31', 'Arabia Saudita', 'ARABIA SAUDITA', 'Saudi Arabia', 'Regno di Arabia Saudita', 'SAUDITA', '5', '999203', 'KSA', NULL, 'Z203', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('304', '31', 'Bahrein', 'BAHRAIN', 'Bahrain', 'Stato di Bahrein', NULL, '169', '999204', 'BRN', NULL, 'Z204', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('305', '32', 'Bangladesh', 'BANGLADESH', 'Bangladesh', 'Repubblica Popolare del Bangladesh', NULL, '130', '999249', 'BD', NULL, 'Z249', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('306', '32', 'Bhutan', 'BHUTAN', 'Bhutan', 'Principato di Bhutan', 'BHUTANESE ', '97', '999205', 'BHT', NULL, 'Z205', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('307', '33', 'Myanmar (ex Birmania)', 'MYANMAR', 'Myanmar', NULL, 'BIRMANA', '83', NULL, 'BUR', NULL, 'Z206', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('309', '33', 'Brunei', 'BRUNEI DARUSSALAM', 'Brunei Darussalam', 'Stato del Brunei', NULL, '125', '999207', 'BRU', NULL, 'Z207', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('310', '33', 'Cambogia', 'CAMBOGIA', 'Cambodia', 'Repubblica Popolare della Cambogia', 'CAMBOGIANA', '135', '999208', 'K', NULL, 'Z208', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('311', '32', 'Sri Lanka (ex Ceylon)', 'SRI LANKA', 'Sri Lanka', 'Repubblica di Sri Lanka', 'CINGALESE', '85', '998209', 'CL', NULL, 'Z209', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('314', '33', 'Cinese, Repubblica Popolare', 'CINA', 'China', 'Repubblica Popolare Cinese', 'CINESE', '16', '999210', NULL, NULL, 'Z210', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('315', '11', 'Cipro', 'CIPRO', 'Cyprus', 'Repubblica Cipriota', 'CIPRIOTA', '101', '999211', 'CY', 'CY', 'Z211', NULL, '1');
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('319', '33', 'Corea, Repubblica Popolare Democratica (Corea del Nord)', 'COREA (REP.POPOLARE DEMOCRATICA)', 'Korea, Democratic People''s Republic of', 'Rep. Dem. Popolare Coreana (Nord)', 'NORDCOREANA', '74', '999214', NULL, NULL, 'Z214', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('320', '33', 'Corea, Repubblica (Corea del Sud)', 'COREA (REPUBBLICA DI)', 'Korea, Republic of', 'Repubblica di Corea (Sud)', 'SUDCOREANA', '84', '999213', NULL, NULL, 'Z213', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('322', '31', 'Emirati Arabi Uniti', 'EMIRATI ARABI UNITI', 'United Arab Emirates', 'Emirati Arabi Uniti', NULL, '796', '998215', 'UAE', NULL, 'Z215', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('323', '33', 'Filippine', 'FILIPPINE', 'Philippines', 'Repubblica delle Filippine', 'FILIPPINA', '27', '999216', 'RP', NULL, 'Z216', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('324', '31', 'Territori dell''Autonomia Palestinese', NULL, 'Palestinian Territory, Occupied', NULL, 'PALESTINESE', NULL, NULL, NULL, NULL, 'Z161', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('326', '33', 'Giappone', 'GIAPPONE', 'Japan', 'Impero del Giappone', 'GIAPPONESE', '88', '999219', 'J', NULL, 'Z219', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('327', '31', 'Giordania', 'GIORDANIA', 'Jordan', 'Regno Ascemita di Giordania', 'GIORDANA', '122', '999220', 'HKJ', NULL, 'Z220', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('330', '32', 'India', 'INDIA', 'India', 'Repubblica Indiana', 'INDIANA', '114', '999222', 'IND', NULL, 'Z222', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('331', '33', 'Indonesia', 'INDONESIA', 'Indonesia', 'Repubblica di Indonesia', 'INDONESIANA', '129', '999223', 'RI', NULL, 'Z223', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('332', '31', 'Iran, Repubblica Islamica del', 'IRAN', 'Iran, Islamic Republic of', 'Repubblica Islamica del l''Iran', 'IRANIANA', '39', '999224', 'IR', NULL, 'Z224', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('333', '31', 'Iraq', 'IRAQ', 'Iraq', 'Rep. Democratica e Popolare Irachena', 'IRACHENA', '38', '999225', 'IRQ', NULL, 'Z225', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('334', '31', 'Israele', 'ISRAELE', 'Israel', 'Stato d''Israele', 'ISRAELIANA', '182', '999226', 'IL', NULL, 'Z226', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('335', '31', 'Kuwait', 'KUWAIT', 'Kuwait', 'Stato del Kuwait', 'KUATIANA', '126', '999227', 'KWT', NULL, 'Z227', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('336', '33', 'Laos', 'LAOS (REP.DEMOCRATICA POPOLARE)', 'Lao People''s Democratic Republic', 'Rep. Democratica Popolare del Laos', 'LAOTIANA', '136', '999228', 'LAO', NULL, 'Z228', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('337', '31', 'Libano', 'LIBANO', 'Lebanon', 'Repubblica Libanese', 'LIBANESE', '95', '999229', 'RL', NULL, 'Z229', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('339', '32', 'Maldive', 'MALDIVE', 'Maldives', 'Repubblica delle Maldive', NULL, '127', '999232', 'MV', NULL, 'Z232', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('340', '33', 'Malaysia', 'MALAYSIA', 'Malaysia', 'Stato Federale della Malesia', 'MALESIANA', '106', '999247', NULL, NULL, 'Z247', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('341', '33', 'Mongolia', 'MONGOLIA', 'Mongolia', 'Repubblica Popolare di Mongolia', 'MONGOLA', '110', '999233', 'MNG', NULL, 'Z233', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('342', '32', 'Nepal', 'NEPAL', 'Nepal', 'Regno del Nepal', 'NEPALESE', '115', '999234', 'NEP', NULL, 'Z234', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('343', '31', 'Oman', 'OMAN', 'Oman', 'Sultanato di Oman', NULL, '163', '999235', 'OM', NULL, 'Z235', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('344', '32', 'Pakistan', 'PAKISTAN', 'Pakistan', 'Repubblica Islamica del Pakistan', 'PACHISTANA', '36', '999236', 'PK', NULL, 'Z236', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('345', '31', 'Qatar', 'QATAR', 'Qatar', 'Stato del Qatar', NULL, '168', '999237', 'Q', NULL, 'Z237', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('346', '33', 'Singapore', 'SINGAPORE', 'Singapore', 'Repubblica di Singapore', NULL, '147', '998248', 'SGP', NULL, 'Z248', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('348', '31', 'Siria', 'SIRIA', 'Syrian Arab Republic', 'Repubblica Araba di Siria', 'SIRIANA', '65', '998240', 'SYR', NULL, 'Z240', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('349', '33', 'Thailandia', 'THAILANDIA', 'Thailand', 'Regno di Thailandia', 'TAILANDESE', '72', '999241', NULL, NULL, 'Z241', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('351', '12', 'Turchia', 'TURCHIA', 'Turkey', 'Repubblica Turca', 'TURCA', '76', '999243', 'TR', NULL, 'Z243', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('353', '33', 'Vietnam', 'VIETNAM', 'Viet Nam', 'Repubblica Socialista del Vietnam', 'VIETNAMITA', '62', '999251', 'VN', NULL, 'Z251', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('354', '31', 'Yemen', 'YEMEN', 'Yemen', 'Repubblica Araba Yemenita', 'YEMENITA', '42', '999246', 'ADN', NULL, 'Z246', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('356', '32', 'Kazakhstan', 'KAZAKISTAN', 'Kazakhstan', 'Repubblica del Kazakistan', 'KAZAKA', '269', '999255', NULL, NULL, 'Z255', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('357', '32', 'Uzbekistan', 'UZBEKISTAN', 'Uzbekistan', 'Repubblica di Uzbekistan', 'UZBEKA', '271', '999259', 'UZ', NULL, 'Z259', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('358', '31', 'Armenia', 'ARMENIA', 'Armenia', 'Repubblica di Armenia', 'ARMENA', '266', '999252', 'ARM', NULL, 'Z252', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('359', '31', 'Azerbaigian', 'AZERBAIGIAN', 'Azerbaijan', 'Repubblica di Azerbaigian', NULL, '268', '999253', NULL, NULL, 'Z253', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('360', '31', 'Georgia', 'GEORGIA', 'Georgia', 'Repubblica di Georgia', 'GEORGIANA', '267', '999254', 'GE', NULL, 'Z254', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('361', '32', 'Kirghizistan', 'KIRGHIZISTAN', 'Kyrgyzstan', 'Repubblica di Khirgizia', 'KIRGISA', '270', '999256', 'KS', NULL, 'Z256', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('362', '32', 'Tagikistan', 'TAGIKISTAN', 'Tajikistan', 'Repubblica di Tagikistan', 'TAGIKA', '272', '999257', 'TJ', NULL, 'Z257', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('363', '33', 'Taiwan (ex Formosa)', 'TAIWAN', 'Taiwan', 'Repubblica di Taiwan', NULL, '22', NULL, NULL, NULL, 'Z217', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('364', '32', 'Turkmenistan', 'TURKMENISTAN', 'Turkmenistan', 'Repubblica di Turkmenistan', 'TURKMENA', '273', '999258', 'TM', NULL, 'Z258', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('401', '21', 'Algeria', 'ALGERIA', 'Algeria', 'Repubblica Democratica di Algeria', 'ALGERINA', '3', '999301', 'DZ', NULL, 'Z301', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('402', '24', 'Angola', 'ANGOLA', 'Angola', 'Repubblica Popolare di Angola', 'ANGOLANA', '133', '999302', 'ANG', NULL, 'Z302', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('404', '22', 'Costa d''Avorio', 'COSTA D''AVORIO', 'Côte D''Ivoire', 'Repubblica di Costa d''Avorio', 'IVORIANA', '146', '999313', 'CI', NULL, 'Z313', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('406', '22', 'Benin (ex Dahomey)', 'BENIN', 'Benin', 'Repubblica Popolare del Benin', NULL, '158', '999314', 'BPB', NULL, 'Z314', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('408', '24', 'Botswana', 'BOTSWANA', 'Botswana', 'Repubblica di Botswana', NULL, '98', '998358', 'BB', NULL, 'Z358', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('409', '22', 'Burkina Faso (ex Alto Volta)', 'BURKINA FASO', 'Burkina Faso', 'Burkina Faso', NULL, '142', '998354', 'RHV', NULL, 'Z354', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('410', '23', 'Burundi', 'BURUNDI', 'Burundi', 'Repubblica del Burundi', NULL, '25', '999305', 'BU', NULL, 'Z305', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('411', '24', 'Camerun', 'CAMERUN', 'Cameroon', 'Repubblica del Camerun', 'CAMERUNENSE', '119', '999306', 'CAM', NULL, 'Z306', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('413', '22', 'Capo Verde', 'CAPO VERDE', 'Cape Verde', 'Repubblica di Capo Verde', 'CAPOVERDIANA', '188', '999307', 'CV', NULL, 'Z307', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('414', '24', 'Centrafricana, Repubblica', 'CENTROAFRICANA (REPUBBLICA)', 'Central African Republic', 'Repubblica Centrafricana', NULL, '143', '999308', NULL, NULL, 'Z308', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('415', '24', 'Ciad', 'CIAD', 'Chad', 'Repubblica del Ciad', NULL, '144', '998309', 'TCH', NULL, 'Z309', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('417', '23', 'Comore', 'COMORE', 'Comoros', 'Rep. Federale Islamica delle Comore', NULL, '176', '999310', 'COM', NULL, 'Z310', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('418', '24', 'Congo (Repubblica del)', 'CONGO (REP. POPOLARE DEL)', 'Congo', 'Repubblica Popolare del Congo', 'CONGOLESE', '145', '999311', NULL, NULL, 'Z311', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('419', '21', 'Egitto', 'EGITTO', 'Egypt', 'Repubblica Araba d''Egitto', 'EGIZIANA', '23', '999336', 'ET', NULL, 'Z336', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('420', '23', 'Etiopia', 'ETIOPIA', 'Ethiopia', 'Repubblica d''Etiopia', 'ETIOPE', '26', '999315', 'ETH', NULL, 'Z315', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('421', '24', 'Gabon', 'GABON', 'Gabon', 'Repubblica Gabonese', NULL, '157', '999316', 'G', NULL, 'Z316', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('422', '22', 'Gambia', 'GAMBIA', 'Gambia', 'Repubblica del Gambia', NULL, '164', '999317', 'WAG', NULL, 'Z317', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('423', '22', 'Ghana', 'GHANA', 'Ghana', 'Repubblica del Ghana', 'GHANESE', '112', '999318', 'GH', NULL, 'Z318', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('424', '23', 'Gibuti', 'GIBUTI', 'Djibouti', 'Repubblica di Gibuti', NULL, '113', '999361', 'DJI', NULL, 'Z361', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('425', '22', 'Guinea', 'GUINEA', 'Guinea', 'Repubblica di Guinea', NULL, '137', '999319', 'RG', NULL, 'Z319', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('426', '22', 'Guinea Bissau', 'GUINEA BISSAU', 'Guinea-Bissau', 'Repubblica di Guinea Bissao', NULL, '185', '999320', NULL, NULL, 'Z320', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('427', '24', 'Guinea Equatoriale', 'GUINEA EQUATORIALE', 'Equatorial Guinea', 'Repubblica di Guinea Equatoriale', NULL, '167', '999321', 'GQ', NULL, 'Z321', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('428', '23', 'Kenya', 'KENYA', 'Kenya', 'Repubblica del Kenia', 'KENIANA', '116', '999322', 'EAK', NULL, 'Z322', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('429', '24', 'Lesotho', 'LESOTHO', 'Lesotho', NULL, NULL, '89', '998359', 'LS', NULL, 'Z359', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('430', '22', 'Liberia', 'LIBERIA', 'Liberia', NULL, 'LIBERIANA', '44', '999325', 'LB', NULL, 'Z325', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('431', '21', 'Libia', 'LIBIA', 'Libyan Arab Jamahiriya', 'Rep. Araba Socialista Popol. di Libia', 'LIBICA', '45', '999326', 'LAR', NULL, 'Z326', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('432', '23', 'Madagascar', 'MADAGASCAR', 'Madagascar', 'Repubblica Democratica di Madagascar', NULL, '104', '999327', 'RM', NULL, 'Z327', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('434', '23', 'Malawi', 'MALAWI', 'Malawi', 'Repubblica di Malawi', NULL, '56', '999328', 'MW', NULL, 'Z328', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('435', '22', 'Mali', 'MALI', 'Mali', 'Repubblica del Mali', NULL, '149', '999329', 'RMM', NULL, 'Z329', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('436', '21', 'Marocco', 'MAROCCO', 'Morocco', 'Regno del Marocco', 'MAROCCHINA', '107', '998330', 'MA', NULL, 'Z330', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('437', '22', 'Mauritania', 'MAURITANIA', 'Mauritania', 'Repubblica Islamica di Mauritania', NULL, '141', '999331', 'RIM', NULL, 'Z331', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('438', '23', 'Mauritius', 'MAURITIUS', 'Mauritius', 'Maurizio', NULL, '128', '999332', NULL, NULL, 'Z332', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('440', '23', 'Mozambico', 'MOZAMBICO', 'Mozambique', 'Repubblica Popolare di Mozambico', NULL, '134', '999333', 'MOC', NULL, 'Z333', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('441', '24', 'Namibia', 'NAMIBIA', 'Namibia', 'Repubblica della Namibia', NULL, '206', '998300', 'NAM', NULL, 'Z300', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('442', '22', 'Niger', 'NIGER', 'Niger', 'Repubblica del Niger', NULL, '150', '999334', 'RN', NULL, 'Z334', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('443', '22', 'Nigeria', 'NIGERIA', 'Nigeria', 'Repubblica Federale di Nigeria', 'NIGERIANA', '117', '999335', 'WAN', NULL, 'Z335', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('446', '23', 'Ruanda', 'RUANDA', 'Rwanda', 'Repubblica Ruandese', NULL, '151', '999338', 'RWA', NULL, 'Z338', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('448', '24', 'São Tomé e Principe', 'SAO TOME E PRINCIPE', 'Sao Tome and Principe', 'Rep. Democrat. di Sao Tome e Principe', NULL, '187', '999341', 'STP', NULL, 'Z341', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('449', '23', 'Seychelles', 'SEYCHELLES', 'Seychelles', 'Repubblica delle Seicelle', NULL, '189', NULL, 'SY', NULL, 'Z342', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('450', '22', 'Senegal', 'SENEGAL', 'Senegal', 'Repubblica del Senegal', 'SENEGALESE', '152', '999343', 'SN', NULL, 'Z343', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('451', '22', 'Sierra Leone', 'SIERRA LEONE', 'Sierra Leone', 'Repubblica della Sierra Leone', NULL, '153', '999344', 'WAL', NULL, 'Z344', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('453', '23', 'Somalia', 'SOMALIA', 'Somalia', 'Repubblica Democratica Somala', 'SOMALA', '66', '999345', 'SO', NULL, 'Z345', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('454', '24', 'Sud Africa', 'REPUBBLICA SUDAFRICANA', 'South Africa', 'Repubblica del Sudafrica', 'SUDAFRICANA', '78', '997347', 'ZA', NULL, 'Z347', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('455', '21', 'Sudan', 'SUDAN', 'Sudan', 'Repubblica del Sudan', 'SUDANESE', '70', '999348', 'SUN', NULL, 'Z348', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('456', '24', 'Swaziland', 'SWAZILAND', 'Swaziland', 'Regno di Swaziland', NULL, '138', '998349', 'SD', NULL, 'Z349', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('457', '23', 'Tanzania', 'TANZANIA', 'Tanzania, United Republic of', 'Repubblica Unita di Tanzania', 'TANZANIANA', '57', '998357', 'EAT', NULL, 'Z357', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('458', '22', 'Togo', 'TOGO', 'Togo', 'Repubblica del Togo', 'TOGOLESE', '155', '999351', 'TG', NULL, 'Z351', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('460', '21', 'Tunisia', 'TUNISIA', 'Tunisia', 'Repubblica Tunisina', 'TUNISINA', '75', '999352', 'TN', NULL, 'Z352', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('461', '23', 'Uganda', 'UGANDA', 'Uganda', 'Repubblica di Uganda', 'UGANDESE', '132', '999353', 'EAU', NULL, 'Z353', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('463', '24', 'Congo, Repubblica democratica del (ex Zaire)', 'CONGO (REP. DEMOCRATICA DEL)', 'Congo, The Democratic Republic of The', 'Repubblica Democratica del Congo', 'CONGOLESE', '18', '998312', NULL, NULL, 'Z312', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('464', '23', 'Zambia', 'ZAMBIA', 'Zambia', 'Repubblica di Zambia', 'ZAMBESE', '58', '999355', 'Z', NULL, 'Z355', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('465', '23', 'Zimbabwe (ex Rhodesia)', 'ZIMBABWE', 'Zimbabwe', 'Repubblica di Zimbabwe', NULL, '73', '998337', 'ZW', NULL, 'Z337', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('466', '23', 'Eritrea', 'ERITREA', 'Eritrea', 'Stato di Eritrea', 'ERITREA', '277', '999368', 'ER', NULL, 'Z368', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('503', '42', 'Antigua e Barbuda', 'ANTIGUA E BARBUDA', 'Antigua and Barbuda', 'Antigua e Barbuda', NULL, '197', '999532', 'AG', NULL, 'Z532', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('505', '42', 'Bahamas', 'BAHAMAS', 'Bahamas', 'Stato Libero Associato delle Bahamas', NULL, '160', '999502', 'BS', NULL, 'Z502', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('506', '42', 'Barbados', 'BARBADOS', 'Barbados', 'Barbados', NULL, '118', '998522', 'BDS', NULL, 'Z522', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('507', '42', 'Belize', 'BELIZE', 'Belize', 'Belize', NULL, '198', '999512', 'BH', NULL, 'Z512', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('509', '41', 'Canada', 'CANADA', 'Canada', 'Dominio del Canada', 'CANADESE', '13', '999401', 'CDN', NULL, 'Z401', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('513', '42', 'Costa Rica', 'COSTA RICA', 'Costa Rica', 'Repubblica di Costa Rica', 'COSTATICANA', '19', '999503', 'CR', NULL, 'Z503', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('514', '42', 'Cuba', 'CUBA', 'Cuba', 'Repubblica di Cuba', 'CUBANA', '20', '999504', 'C', NULL, 'Z504', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('515', '42', 'Dominica', 'DOMINICA', 'Dominica', 'Stato Libero Associato di Dominica', NULL, '192', '998526', 'WD', NULL, 'Z526', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('516', '42', 'Dominicana, Repubblica', 'DOMINICANA (REPUBBLICA)', 'Dominican Republic', 'Repubblica Dominicana', NULL, '63', '999505', NULL, NULL, 'Z505', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('517', '42', 'El Salvador', 'EL SALVADOR', 'El Salvador', 'Repubblica di El Salvador', 'SALVADOREGNA', '64', '999506', 'ES', NULL, 'Z506', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('518', '42', 'Giamaica', 'GIAMAICA', 'Jamaica', 'Giamaica', 'GIAMAICANA', '82', '999507', 'JA', NULL, 'Z507', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('519', '42', 'Grenada', 'GRENADA', 'Grenada', 'Grenada', NULL, '156', '998524', 'WG', NULL, 'Z524', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('523', '42', 'Guatemala', 'GUATEMALA', 'Guatemala', 'Repubblica di Guatemala', 'GUATEMALTECA', '33', '999509', 'GCA', NULL, 'Z509', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('524', '42', 'Haiti', 'HAITI', 'Haiti', 'Repubblica di Haiti', 'HAITIANA', '34', '99510', 'RH', NULL, 'Z510', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('525', '42', 'Honduras', 'HONDURAS', 'Honduras', 'Repubblica di Honduras', 'HONDUREGNA', '35', '99511', 'HN', NULL, 'Z511', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('527', '42', 'Messico', 'MESSICO', 'Mexico', 'Stati Uniti Messicani', 'MESSICANA', '46', '999514', 'MEX', NULL, 'Z514', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('529', '42', 'Nicaragua', 'NICARAGUA', 'Nicaragua', NULL, 'NICARACUENSE', '47', '999515', 'NIC', NULL, 'Z515', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('530', '42', 'Panama', 'PANAMA', 'Panama', 'Repubblica di Panama', 'PANAMENSE', '51', '999516', 'PA', NULL, 'Z516', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('532', '42', 'Saint Lucia', 'SAINTE LUCIA', 'Saint Lucia', 'Santa Lucia', NULL, '199', '998527', NULL, NULL, 'Z527', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('533', '42', 'Saint Vincent e Grenadine', 'ST.VINCENTE E LE GRENADINE', 'Saint Vincent and The Grenadines', 'Saint Vincent e Grenadine', NULL, '196', '998528', 'WV', NULL, 'Z528', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('534', '42', 'Saint Kitts e Nevis', 'SAINT KITTS E NEVIS', 'Saint Kitts and Nevis', 'Federazione di Saint Kits e Nevis', NULL, '195', '998533', 'KN', NULL, 'Z533', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('536', '41', 'Stati Uniti d''America', 'STATI UNITI', 'United States', 'Stati Uniti d''America', 'STATUNITENSE', '69', '999404', 'USA', NULL, 'Z404', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('602', '42', 'Argentina', 'ARGENTINA', 'Argentina', 'Repubblica Argentina', 'ARGENTINA', '6', '999600', 'RA', NULL, 'Z600', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('604', '42', 'Bolivia', 'BOLIVIA', 'Bolivia, Plurinational State of', NULL, 'BOLIVIANA', '10', '999601', 'BOL', NULL, 'Z601', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('605', '42', 'Brasile', 'BRASILE', 'Brazil', 'Repubblica Federativa del Brasile', 'BRASILIANA', '11', '999602', 'BR', NULL, 'Z602', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('606', '42', 'Cile', 'CILE', 'Chile', 'Repubblica del Cile', 'CILENA', '15', '999603', 'RCH', NULL, 'Z603', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('608', '42', 'Colombia', 'COLOMBIA', 'Colombia', 'Repubblica di Colombia', 'COLOMBIANA', '17', '999604', 'CO', NULL, 'Z604', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('609', '42', 'Ecuador', 'ECUADOR', 'Ecuador', 'Repubblica del l''ecuador', 'ECUADOREGNA', '24', '999605', 'EC', NULL, 'Z605', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('612', '42', 'Guyana', 'GUYANA', 'Guyana', 'Rep. Cooperativistica di Guaiana', NULL, '159', '999606', 'GUY', NULL, 'Z606', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('614', '42', 'Paraguay', 'PARAGUAY', 'Paraguay', 'Repubblica del Paraguay', 'PARAGUAIANA', '52', '999610', 'PY', NULL, 'Z610', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('615', '42', 'Perù', 'PERU''', 'Peru', 'Repubblica del Peru', 'PERUVIANA', '53', '999611', 'PE', NULL, 'Z611', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('616', '42', 'Suriname', 'SURINAM', 'Suriname', 'Repubblica del Suriname', NULL, '124', '998608', 'SME', NULL, 'Z608', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('617', '42', 'Trinidad e Tobago', 'TRINIDAD E TOBAGO', 'Trinidad and Tobago', 'Repubblica di Trinidad e Tobago', NULL, '120', '999612', 'TT', NULL, 'Z612', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('618', '42', 'Uruguay', 'URUGUAY', 'Uruguay', 'Repubblica Orientale dell''Uruguay', 'URUGUAIANA', '80', '999613', 'ROU', NULL, 'Z613', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('619', '42', 'Venezuela', 'VENEZUELA', 'Venezuela, Bolivarian Republic of', 'Repubblica del Venezuela', 'VENZUELANA', '81', '999614', 'YV', NULL, 'Z614', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('701', '50', 'Australia', 'AUSTRALIA', 'Australia', 'Stato Libero Associato di Australia', 'AUSTRALIANA', '7', '999700', 'AUS', NULL, 'Z700', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('703', '50', 'Figi', 'FIJI', 'Fiji', 'Figi', NULL, '161', '999704', 'FJI', NULL, 'Z704', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('708', '50', 'Kiribati', 'KIRIBATI', 'Kiribati', 'Repubblica di Kiribati', NULL, '194', '998731', 'KIR', NULL, 'Z731', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('712', '50', 'Marshall, Isole', 'MARSHALL (ISOLE)', 'Marshall Islands', NULL, NULL, '217', '999711', NULL, NULL, 'Z711', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('713', '50', 'Micronesia, Stati Federati', 'MICRONESIA (STATI FEDERATI DI)', 'Micronesia, Federated States of', NULL, NULL, '215', '998735', NULL, NULL, 'Z735', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('715', '50', 'Nauru', 'NAURU', 'Nauru', 'Repubblica di Nauru', NULL, '109', '999713', 'NAU', NULL, 'Z713', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('719', '50', 'Nuova Zelanda', 'NUOVA ZELANDA', 'New Zealand', 'Dominio di Nuova Zelanda', 'NEOZELANDESE', '49', '999719', 'NZ', NULL, 'Z719', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('720', '50', 'Palau', 'PALAU', 'Palau', NULL, NULL, '216', '998734', 'PAL', NULL, 'Z734', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('721', '50', 'Papua Nuova Guinea', 'PAPUA NUOVA GUINEA', 'Papua New Guinea', 'Papuasia Nuova Guinea', NULL, '186', '998730', 'PNG', NULL, 'Z730', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('725', '50', 'Salomone, Isole', 'ISOLE SALOMONE', 'Solomon Islands', 'Salomone', NULL, '191', '999724', NULL, NULL, 'Z724', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('727', '50', 'Samoa', 'SAMOA OCCIDENTALI', 'Samoa', 'Stato Indipendente delle Samoa Occid.', NULL, '131', '999726', 'WS', NULL, 'Z726', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('730', '50', 'Tonga', 'TONGA', 'Tonga', 'Regno di Tonga', NULL, '162', '999728', 'TO', NULL, 'Z728', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('731', '50', 'Tuvalu', 'TUVALU', 'Tuvalu', 'Tuvalu', NULL, '193', '998732', 'TUV', NULL, 'Z732', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('732', '50', 'Vanuatu', 'VANUATU', 'Vanuatu', 'Repubblica di Vanuatu', NULL, '121', '998733', 'VU', NULL, 'Z733', NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('999', '60', 'Apolide', NULL, 'Stateless', '<Apolide>', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('338', '33', 'Timor Orientale', NULL, 'East Timor', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('467', '21', 'Sud Sudan, Repubblica del', NULL, 'South Sudan, Republic of', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('888', '12', 'Riconosciuti non cittadini (lettoni)*', NULL, 'Recognized non-citizens*', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('925', '13', 'Jersey, Isole*', NULL, 'Jersey, Islands*', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO STATOESTERO (IDSTATOESTERO, IDAREA, DENOMINAZIONE, DENOMINAZIONE2, DENOMINAZIONE3, CITTADINANZA, CITTADINANZA2, IDAGENZIAENTRATE, IDSTATOESTEROINPS, IDSTATOESTEROINAIL, IDSTATOESTEROCO, FINANZECOD, FINANZECODDATA, UE) VALUES ('959', '13', 'Man, Isola di*', NULL, 'Man, Isle of*', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);


-- REGIONE

INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('01', 'Piemonte', 'Nord-Occidentale', '13');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('02', 'Valle d''Aosta', 'Nord-Occidentale', '20');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('03', 'Lombardia', 'Nord-Occidentale', '10');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('04', 'Trentino-Alto Adige', 'Nord-Orientale', NULL);
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('05', 'Veneto', 'Nord-Orientale', '21');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('06', 'Friuli-Venezia Giulia', 'Nord Orientale', '7');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('07', 'Liguria', 'Nord-Occidentale', '9');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('08', 'Emilia-Romagna', 'Nord Orientale', '6');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('09', 'Toscana', 'Centrale', '17');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('10', 'Umbria', 'Centrale', '19');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('11', 'Marche', 'Centrale', '11');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('12', 'Lazio', 'Centrale', '8');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('13', 'Abruzzo', 'Meridionale', '1');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('14', 'Molise', 'Meridionale', '12');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('15', 'Campania', 'Meridionale', '5');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('16', 'Puglia', 'Meridionale', '14');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('17', 'Basilicata', 'Meridionale', '2');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('18', 'Calabria', 'Meridionale', '4');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('19', 'Sicilia', 'Insulare', '16');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('20', 'Sardegna', 'Insulare', '15');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('21', 'Bolzano', NULL, '3');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('22', 'Trento', NULL, '18');
INSERT INTO REGIONE (IDREGIONE, DENOMINAZIONE, RIPARTIZIONEGEOGRAFICA, CODAGENZIAENTRATE) VALUES ('99', 'Estero', 'Estero', NULL);

INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('001', '01', 'TO', 'Torino');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('002', '01', 'VC', 'Vercelli');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('003', '01', 'NO', 'Novara');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('004', '01', 'CN', 'Cuneo');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('005', '01', 'AT', 'Asti');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('006', '01', 'AL', 'Alessandria');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('096', '01', 'BI', 'Biella');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('103', '01', 'VB', 'Verbano-Cusio-Ossola');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('007', '02', 'AO', 'Valle d''Aosta');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('012', '03', 'VA', 'Varese');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('013', '03', 'CO', 'Como');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('014', '03', 'SO', 'Sondrio');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('015', '03', 'MI', 'Milano');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('016', '03', 'BG', 'Bergamo');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('017', '03', 'BS', 'Brescia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('018', '03', 'PV', 'Pavia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('019', '03', 'CR', 'Cremona');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('020', '03', 'MN', 'Mantova');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('097', '03', 'LC', 'Lecco');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('098', '03', 'LO', 'Lodi');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('021', '04', 'BZ', 'Bolzano - Bozen');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('022', '04', 'TN', 'Trento');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('023', '05', 'VR', 'Verona');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('024', '05', 'VI', 'Vicenza');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('025', '05', 'BL', 'Belluno');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('026', '05', 'TV', 'Treviso');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('027', '05', 'VE', 'Venezia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('028', '05', 'PD', 'Padova');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('029', '05', 'RO', 'Rovigo');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('030', '06', 'UD', 'Udine');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('031', '06', 'GO', 'Gorizia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('032', '06', 'TS', 'Trieste');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('093', '06', 'PN', 'Pordenone');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('008', '07', 'IM', 'Imperia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('009', '07', 'SV', 'Savona');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('010', '07', 'GE', 'Genova');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('011', '07', 'SP', 'La Spezia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('033', '08', 'PC', 'Piacenza');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('034', '08', 'PR', 'Parma');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('035', '08', 'RE', 'Reggio nell''Emilia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('036', '08', 'MO', 'Modena');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('037', '08', 'BO', 'Bologna');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('038', '08', 'FE', 'Ferrara');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('039', '08', 'RA', 'Ravenna');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('040', '08', 'FC', 'Forlì-Cesena');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('099', '08', 'RN', 'Rimini');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('045', '09', 'MS', 'Massa-Carrara');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('046', '09', 'LU', 'Lucca');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('047', '09', 'PT', 'Pistoia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('048', '09', 'FI', 'Firenze');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('049', '09', 'LI', 'Livorno');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('050', '09', 'PI', 'Pisa');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('051', '09', 'AR', 'Arezzo');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('052', '09', 'SI', 'Siena');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('053', '09', 'GR', 'Grosseto');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('100', '09', 'PO', 'Prato');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('054', '10', 'PG', 'Perugia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('055', '10', 'TR', 'Terni');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('041', '11', 'PU', 'Pesaro Urbino');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('042', '11', 'AN', 'Ancona');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('043', '11', 'MC', 'Macerata');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('044', '11', 'AP', 'Ascoli Piceno');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('056', '12', 'VT', 'Viterbo');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('057', '12', 'RI', 'Rieti');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('058', '12', 'RM', 'Roma');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('059', '12', 'LT', 'Latina');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('060', '12', 'FR', 'Frosinone');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('066', '13', 'AQ', 'L''Aquila');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('067', '13', 'TE', 'Teramo');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('068', '13', 'PE', 'Pescara');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('069', '13', 'CH', 'Chieti');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('070', '14', 'CB', 'Campobasso');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('094', '14', 'IS', 'Isernia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('061', '15', 'CE', 'Caserta');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('062', '15', 'BN', 'Benevento');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('063', '15', 'NA', 'Napoli');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('064', '15', 'AV', 'Avellino');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('065', '15', 'SA', 'Salerno');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('071', '16', 'FG', 'Foggia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('072', '16', 'BA', 'Bari');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('073', '16', 'TA', 'Taranto');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('074', '16', 'BR', 'Brindisi');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('075', '16', 'LE', 'Lecce');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('076', '17', 'PZ', 'Potenza');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('077', '17', 'MT', 'Matera');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('078', '18', 'CS', 'Cosenza');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('079', '18', 'CZ', 'Catanzaro');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('080', '18', 'RC', 'Reggio di Calabria');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('101', '18', 'KR', 'Crotone');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('102', '18', 'VV', 'Vibo Valentia');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('081', '19', 'TP', 'Trapani');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('082', '19', 'PA', 'Palermo');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('083', '19', 'ME', 'Messina');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('084', '19', 'AG', 'Agrigento');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('085', '19', 'CL', 'Caltanissetta');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('086', '19', 'EN', 'Enna');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('087', '19', 'CT', 'Catania');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('088', '19', 'RG', 'Ragusa');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('089', '19', 'SR', 'Siracusa');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('090', '20', 'SS', 'Sassari');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('091', '20', 'NU', 'Nuoro');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('092', '20', 'CA', 'Cagliari');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('095', '20', 'OR', 'Oristano');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('104', '20', 'OT', 'Olbia-Tempio');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('105', '20', 'OG', 'Ogliastra');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('106', '20', 'VS', 'Medio Campidano');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('107', '20', 'CI', 'Carbonia-Iglesias');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('108', '03', 'MB', 'Monza e della Brianza');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('109', '16', 'BT', 'Barletta-Andria-Trani');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('110', '11', 'FM', 'Fermo');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('111', '20', 'SU', 'Provincia del Sud Sardegna');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('701', '99', 'FIUM', 'Fiume');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('702', '99', 'POLA', 'Pola');
INSERT INTO PROVINCIA (IDPROVINCIA, IDREGIONE, SIGLA, DENOMINAZIONE) VALUES ('703', '99', 'ZARA', 'Zara');

COMMIT WORK;


INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001001', '001', 'Agliè', 'A074', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001002', '001', 'Airasca', 'A109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001003', '001', 'Ala di Stura', 'A117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001004', '001', 'Albiano d''Ivrea', 'A157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001005', '001', 'Alice Superiore', 'A199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001006', '001', 'Almese', 'A218', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001007', '001', 'Alpette', 'A221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001008', '001', 'Alpignano', 'A222', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001009', '001', 'Andezeno', 'A275', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001010', '001', 'Andrate', 'A282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001011', '001', 'Angrogna', 'A295', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001012', '001', 'Arignano', 'A405', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001013', '001', 'Avigliana', 'A518', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001014', '001', 'Azeglio', 'A525', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001015', '001', 'Bairo', 'A584', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001016', '001', 'Balangero', 'A587', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001017', '001', 'Baldissero Canavese', 'A590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001018', '001', 'Baldissero Torinese', 'A591', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001019', '001', 'Balme', 'A599', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001020', '001', 'Banchette', 'A607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001021', '001', 'Barbania', 'A625', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001022', '001', 'Bardonecchia', 'A651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001023', '001', 'Barone Canavese', 'A673', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001024', '001', 'Beinasco', 'A734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001025', '001', 'Bibiana', 'A853', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001026', '001', 'Bobbio Pellice', 'A910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001027', '001', 'Bollengo', 'A941', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001028', '001', 'Borgaro Torinese', 'A990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001029', '001', 'Borgiallo', 'B003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001030', '001', 'Borgofranco d''Ivrea', 'B015', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001031', '001', 'Borgomasino', 'B021', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001032', '001', 'Borgone Susa', 'B024', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001033', '001', 'Bosconero', 'B075', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001034', '001', 'Brandizzo', 'B121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001035', '001', 'Bricherasio', 'B171', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001036', '001', 'Brosso', 'B205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001037', '001', 'Brozolo', 'B209', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001038', '001', 'Bruino', 'B216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001039', '001', 'Brusasco', 'B225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001040', '001', 'Bruzolo', 'B232', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001041', '001', 'Buriasco', 'B278', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001042', '001', 'Burolo', 'B279', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001043', '001', 'Busano', 'B284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001044', '001', 'Bussoleno', 'B297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001045', '001', 'Buttigliera Alta', 'B305', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001046', '001', 'Cafasse', 'B350', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001047', '001', 'Caluso', 'B435', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001048', '001', 'Cambiano', 'B462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001049', '001', 'Campiglione Fenile', 'B512', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001050', '001', 'Candia Canavese', 'B588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001051', '001', 'Candiolo', 'B592', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001052', '001', 'Canischio', 'B605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001053', '001', 'Cantalupa', 'B628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001054', '001', 'Cantoira', 'B637', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001055', '001', 'Caprie', 'B705', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001056', '001', 'Caravino', 'B733', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001057', '001', 'Carema', 'B762', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001058', '001', 'Carignano', 'B777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001059', '001', 'Carmagnola', 'B791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001060', '001', 'Casalborgone', 'B867', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001061', '001', 'Cascinette d''Ivrea', 'B953', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001062', '001', 'Caselette', 'B955', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001063', '001', 'Caselle Torinese', 'B960', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001064', '001', 'Castagneto Po', 'C045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001065', '001', 'Castagnole Piemonte', 'C048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001066', '001', 'Castellamonte', 'C133', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001067', '001', 'Castelnuovo Nigra', 'C241', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001068', '001', 'Castiglione Torinese', 'C307', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001069', '001', 'Cavagnolo', 'C369', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001070', '001', 'Cavour', 'C404', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001071', '001', 'Cercenasco', 'C487', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001072', '001', 'Ceres', 'C497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001073', '001', 'Ceresole Reale', 'C505', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001074', '001', 'Cesana Torinese', 'C564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001075', '001', 'Chialamberto', 'C604', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001076', '001', 'Chianocco', 'C610', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001077', '001', 'Chiaverano', 'C624', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001078', '001', 'Chieri', 'C627', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001079', '001', 'Chiesanuova', 'C629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001080', '001', 'Chiomonte', 'C639', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001081', '001', 'Chiusa di San Michele', 'C655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001082', '001', 'Chivasso', 'C665', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001083', '001', 'Ciconio', 'C679', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001084', '001', 'Cintano', 'C711', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001085', '001', 'Cinzano', 'C715', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001086', '001', 'Ciriè', 'C722', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001087', '001', 'Claviere', 'C793', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001088', '001', 'Coassolo Torinese', 'C801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001089', '001', 'Coazze', 'C803', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001090', '001', 'Collegno', 'C860', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001091', '001', 'Colleretto Castelnuovo', 'C867', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001092', '001', 'Colleretto Giacosa', 'C868', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001093', '001', 'Condove', 'C955', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001094', '001', 'Corio', 'D008', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001095', '001', 'Cossano Canavese', 'D092', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001096', '001', 'Cuceglio', 'D197', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001097', '001', 'Cumiana', 'D202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001098', '001', 'Cuorgnè', 'D208', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001099', '001', 'Druento', 'D373', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001100', '001', 'Exilles', 'D433', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001101', '001', 'Favria', 'D520', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001102', '001', 'Feletto', 'D524', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001103', '001', 'Fenestrelle', 'D532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001104', '001', 'Fiano', 'D562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001105', '001', 'Fiorano Canavese', 'D608', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001106', '001', 'Foglizzo', 'D646', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001107', '001', 'Forno Canavese', 'D725', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001108', '001', 'Frassinetto', 'D781', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001109', '001', 'Front', 'D805', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001110', '001', 'Frossasco', 'D812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001111', '001', 'Garzigliana', 'D931', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001112', '001', 'Gassino Torinese', 'D933', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001113', '001', 'Germagnano', 'D983', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001114', '001', 'Giaglione', 'E009', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001115', '001', 'Giaveno', 'E020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001116', '001', 'Givoletto', 'E067', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001117', '001', 'Gravere', 'E154', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001118', '001', 'Groscavallo', 'E199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001119', '001', 'Grosso', 'E203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001120', '001', 'Grugliasco', 'E216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001121', '001', 'Ingria', 'E301', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001122', '001', 'Inverso Pinasca', 'E311', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001123', '001', 'Isolabella', 'E345', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001124', '001', 'Issiglio', 'E368', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001125', '001', 'Ivrea', 'E379', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001126', '001', 'La Cassa', 'E394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001127', '001', 'La Loggia', 'E423', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001128', '001', 'Lanzo Torinese', 'E445', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001129', '001', 'Lauriano', 'E484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001130', '001', 'Leini', 'E518', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001131', '001', 'Lemie', 'E520', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001132', '001', 'Lessolo', 'E551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001133', '001', 'Levone', 'E566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001134', '001', 'Locana', 'E635', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001135', '001', 'Lombardore', 'E660', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001136', '001', 'Lombriasco', 'E661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001137', '001', 'Loranzè', 'E683', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001138', '001', 'Lugnacco', 'E727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001139', '001', 'Luserna San Giovanni', 'E758', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001140', '001', 'Lusernetta', 'E759', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001141', '001', 'Lusigliè', 'E763', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001142', '001', 'Macello', 'E782', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001143', '001', 'Maglione', 'E817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001144', '001', 'Marentino', 'E941', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001145', '001', 'Massello', 'F041', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001146', '001', 'Mathi', 'F053', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001147', '001', 'Mattie', 'F058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001148', '001', 'Mazzè', 'F067', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001149', '001', 'Meana di Susa', 'F074', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001150', '001', 'Mercenasco', 'F140', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001151', '001', 'Meugliano', 'F164', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001152', '001', 'Mezzenile', 'F182', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001153', '001', 'Mombello di Torino', 'F315', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001154', '001', 'Mompantero', 'F318', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001155', '001', 'Monastero di Lanzo', 'F327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001156', '001', 'Moncalieri', 'F335', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001157', '001', 'Moncenisio', 'D553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001158', '001', 'Montaldo Torinese', 'F407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001159', '001', 'Montalenghe', 'F411', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001160', '001', 'Montalto Dora', 'F420', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001161', '001', 'Montanaro', 'F422', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001162', '001', 'Monteu da Po', 'F651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001163', '001', 'Moriondo Torinese', 'F733', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001164', '001', 'Nichelino', 'F889', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001165', '001', 'Noasca', 'F906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001166', '001', 'Nole', 'F925', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001167', '001', 'Nomaglio', 'F927', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001168', '001', 'None', 'F931', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001169', '001', 'Novalesa', 'F948', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001170', '001', 'Oglianico', 'G010', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001171', '001', 'Orbassano', 'G087', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001172', '001', 'Orio Canavese', 'G109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001173', '001', 'Osasco', 'G151', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001174', '001', 'Osasio', 'G152', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001175', '001', 'Oulx', 'G196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001176', '001', 'Ozegna', 'G202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001177', '001', 'Palazzo Canavese', 'G262', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001178', '001', 'Pancalieri', 'G303', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001179', '001', 'Parella', 'G330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001180', '001', 'Pavarolo', 'G387', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001181', '001', 'Pavone Canavese', 'G392', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001182', '001', 'Pecco', 'G396', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001183', '001', 'Pecetto Torinese', 'G398', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001184', '001', 'Perosa Argentina', 'G463', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001185', '001', 'Perosa Canavese', 'G462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001186', '001', 'Perrero', 'G465', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001187', '001', 'Pertusio', 'G477', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001188', '001', 'Pessinetto', 'G505', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001189', '001', 'Pianezza', 'G559', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001190', '001', 'Pinasca', 'G672', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001191', '001', 'Pinerolo', 'G674', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001192', '001', 'Pino Torinese', 'G678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001193', '001', 'Piobesi Torinese', 'G684', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001194', '001', 'Piossasco', 'G691', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001195', '001', 'Piscina', 'G705', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001196', '001', 'Piverone', 'G719', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001197', '001', 'Poirino', 'G777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001198', '001', 'Pomaretto', 'G805', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001199', '001', 'Pont-Canavese', 'G826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001200', '001', 'Porte', 'G900', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001201', '001', 'Pragelato', 'G973', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001202', '001', 'Prali', 'G978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001203', '001', 'Pralormo', 'G979', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001204', '001', 'Pramollo', 'G982', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001205', '001', 'Prarostino', 'G986', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001206', '001', 'Prascorsano', 'G988', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001207', '001', 'Pratiglione', 'G997', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001208', '001', 'Quagliuzzo', 'H100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001209', '001', 'Quassolo', 'H120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001210', '001', 'Quincinetto', 'H127', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001211', '001', 'Reano', 'H207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001212', '001', 'Ribordone', 'H270', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001215', '001', 'Riva presso Chieri', 'H337', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001213', '001', 'Rivalba', 'H333', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001214', '001', 'Rivalta di Torino', 'H335', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001216', '001', 'Rivara', 'H338', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001217', '001', 'Rivarolo Canavese', 'H340', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001218', '001', 'Rivarossa', 'H344', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001219', '001', 'Rivoli', 'H355', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001220', '001', 'Robassomero', 'H367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001221', '001', 'Rocca Canavese', 'H386', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001222', '001', 'Roletto', 'H498', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001223', '001', 'Romano Canavese', 'H511', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001224', '001', 'Ronco Canavese', 'H539', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001225', '001', 'Rondissone', 'H547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001226', '001', 'Rorà', 'H554', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001228', '001', 'Rosta', 'H583', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001227', '001', 'Roure', 'H555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001229', '001', 'Rubiana', 'H627', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001230', '001', 'Rueglio', 'H631', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001231', '001', 'Salassa', 'H691', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001232', '001', 'Salbertrand', 'H684', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001233', '001', 'Salerano Canavese', 'H702', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001234', '001', 'Salza di Pinerolo', 'H734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001235', '001', 'Samone', 'H753', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001236', '001', 'San Benigno Canavese', 'H775', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001237', '001', 'San Carlo Canavese', 'H789', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001238', '001', 'San Colombano Belmonte', 'H804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001239', '001', 'San Didero', 'H820', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001240', '001', 'San Francesco al Campo', 'H847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001242', '001', 'San Germano Chisone', 'H862', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001243', '001', 'San Gillio', 'H873', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001244', '001', 'San Giorgio Canavese', 'H890', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001245', '001', 'San Giorio di Susa', 'H900', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001246', '001', 'San Giusto Canavese', 'H936', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001247', '001', 'San Martino Canavese', 'H997', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001248', '001', 'San Maurizio Canavese', 'I024', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001249', '001', 'San Mauro Torinese', 'I030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001250', '001', 'San Pietro Val Lemina', 'I090', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001251', '001', 'San Ponso', 'I126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001252', '001', 'San Raffaele Cimena', 'I137', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001253', '001', 'San Sebastiano da Po', 'I152', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001254', '001', 'San Secondo di Pinerolo', 'I154', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001241', '001', 'Sangano', 'H855', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001255', '001', 'Sant''Ambrogio di Torino', 'I258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001256', '001', 'Sant''Antonino di Susa', 'I296', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001257', '001', 'Santena', 'I327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001258', '001', 'Sauze di Cesana', 'I465', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001259', '001', 'Sauze d''Oulx', 'I466', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001260', '001', 'Scalenghe', 'I490', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001261', '001', 'Scarmagno', 'I511', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001262', '001', 'Sciolze', 'I539', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001263', '001', 'Sestriere', 'I692', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001264', '001', 'Settimo Rottaro', 'I701', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001265', '001', 'Settimo Torinese', 'I703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001266', '001', 'Settimo Vittone', 'I702', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001267', '001', 'Sparone', 'I886', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001268', '001', 'Strambinello', 'I969', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001269', '001', 'Strambino', 'I970', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001270', '001', 'Susa', 'L013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001271', '001', 'Tavagnasco', 'L066', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001272', '001', 'Torino', 'L219', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001273', '001', 'Torrazza Piemonte', 'L238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001274', '001', 'Torre Canavese', 'L247', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001275', '001', 'Torre Pellice', 'L277', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001276', '001', 'Trana', 'L327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001277', '001', 'Trausella', 'L338', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001278', '001', 'Traversella', 'L345', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001279', '001', 'Traves', 'L340', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001280', '001', 'Trofarello', 'L445', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001281', '001', 'Usseaux', 'L515', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001282', '001', 'Usseglio', 'L516', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001283', '001', 'Vaie', 'L538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001284', '001', 'Val della Torre', 'L555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001285', '001', 'Valgioie', 'L578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001286', '001', 'Vallo Torinese', 'L629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001287', '001', 'Valperga', 'L644', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001288', '001', 'Valprato Soana', 'B510', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001289', '001', 'Varisella', 'L685', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001290', '001', 'Vauda Canavese', 'L698', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001292', '001', 'Venaria Reale', 'L727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001291', '001', 'Venaus', 'L726', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001293', '001', 'Verolengo', 'L779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001294', '001', 'Verrua Savoia', 'L787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001295', '001', 'Vestignè', 'L811', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001296', '001', 'Vialfrè', 'L830', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001297', '001', 'Vico Canavese', 'L548', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001298', '001', 'Vidracco', 'L857', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001299', '001', 'Vigone', 'L898', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001300', '001', 'Villafranca Piemonte', 'L948', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001301', '001', 'Villanova Canavese', 'L982', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001303', '001', 'Villar Dora', 'L999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001305', '001', 'Villar Focchiardo', 'M007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001306', '001', 'Villar Pellice', 'M013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001307', '001', 'Villar Perosa', 'M014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001302', '001', 'Villarbasse', 'M002', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001304', '001', 'Villareggia', 'M004', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001308', '001', 'Villastellone', 'M027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001309', '001', 'Vinovo', 'M060', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001310', '001', 'Virle Piemonte', 'M069', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001311', '001', 'Vische', 'M071', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001312', '001', 'Vistrorio', 'M080', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001313', '001', 'Viù', 'M094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001314', '001', 'Volpiano', 'M122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001315', '001', 'Volvera', 'M133', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001316', '001', 'Mappano', 'M316', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001820', '001', 'Col San Giovanni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001821', '001', 'Desertes', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001822', '001', 'Drusacco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001823', '001', 'Faetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001824', '001', 'Favria-Oglianico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001825', '001', 'Fenile', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001826', '001', 'Fenils', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001827', '001', 'Foresto di Susa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001828', '001', 'Forno Alpi Graie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001829', '001', 'Frassinere', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001830', '001', 'Gauna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001831', '001', 'Inverso Porte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001832', '001', 'Luserna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001833', '001', 'Maniglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001834', '001', 'Marcorengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001835', '001', 'Meano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001836', '001', 'Melezet', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001837', '001', 'Mentoulles', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001838', '001', 'Millaures', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001839', '001', 'Mocchie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001840', '001', 'Mollieres', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001841', '001', 'Monasterolo Torinese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001842', '001', 'Mondrone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001843', '001', 'Montestrutto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001844', '001', 'Muriaglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001845', '001', 'Novareglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001846', '001', 'Palazzo Piverone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001847', '001', 'Pedanea', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001848', '001', 'Piazzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001849', '001', 'Priacco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001850', '001', 'Revigliasco Torinese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001851', '001', 'Riclaretto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001852', '001', 'Rivera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001853', '001', 'Roccapiatta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001854', '001', 'Rochemolles', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001855', '001', 'Rodoretto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001856', '001', 'Rollieres', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001857', '001', 'Salecanischio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001858', '001', 'Sale Castelnuovo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001859', '001', 'Salto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001860', '001', 'San Gillio Torinese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001861', '001', 'San Giovanni Pellice', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001862', '001', 'San Martino di Perrero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001863', '001', 'Savoulx', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001864', '001', 'Solomiac', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001865', '001', 'Strambino Romano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001866', '001', 'Tavernette', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001867', '001', 'Thures', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001868', '001', 'Tina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001869', '001', 'Traverse', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001870', '001', 'Valchiusella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001871', '001', 'Valprato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('001872', '001', 'Villa Castelnuovo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002002', '002', 'Alagna Valsesia', 'A119', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002003', '002', 'Albano Vercellese', 'A130', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002004', '002', 'Alice Castello', 'A198', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002006', '002', 'Arborio', 'A358', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002007', '002', 'Asigliano Vercellese', 'A466', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002008', '002', 'Balmuccia', 'A600', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002009', '002', 'Balocco', 'A601', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002011', '002', 'Bianzè', 'A847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002014', '002', 'Boccioleto', 'A914', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002015', '002', 'Borgo d''Ale', 'B009', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002017', '002', 'Borgo Vercelli', 'B046', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002016', '002', 'Borgosesia', 'B041', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002019', '002', 'Breia', 'B136', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002021', '002', 'Buronzo', 'B280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002025', '002', 'Campertogno', 'B505', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002029', '002', 'Carcoforo', 'B752', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002030', '002', 'Caresana', 'B767', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002031', '002', 'Caresanablot', 'B768', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002032', '002', 'Carisio', 'B782', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002033', '002', 'Casanova Elvo', 'B928', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002038', '002', 'Cellio', 'C450', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002041', '002', 'Cervatto', 'C548', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002042', '002', 'Cigliano', 'C680', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002043', '002', 'Civiasco', 'C757', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002045', '002', 'Collobiano', 'C884', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002047', '002', 'Costanzana', 'D113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002048', '002', 'Cravagliana', 'D132', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002049', '002', 'Crescentino', 'D154', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002052', '002', 'Crova', 'D187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002054', '002', 'Desana', 'D281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002057', '002', 'Fobello', 'D641', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002058', '002', 'Fontanetto Po', 'D676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002059', '002', 'Formigliana', 'D712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002061', '002', 'Gattinara', 'D938', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002062', '002', 'Ghislarengo', 'E007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002065', '002', 'Greggio', 'E163', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002066', '002', 'Guardabosone', 'E237', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002067', '002', 'Lamporo', 'E433', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002068', '002', 'Lenta', 'E528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002070', '002', 'Lignana', 'E583', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002071', '002', 'Livorno Ferraris', 'E626', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002072', '002', 'Lozzolo', 'E711', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002078', '002', 'Mollia', 'F297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002079', '002', 'Moncrivello', 'F342', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002082', '002', 'Motta de'' Conti', 'F774', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002088', '002', 'Olcenengo', 'G016', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002089', '002', 'Oldenico', 'G018', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002090', '002', 'Palazzolo Vercellese', 'G266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002091', '002', 'Pertengo', 'G471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002093', '002', 'Pezzana', 'G528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002096', '002', 'Pila', 'G666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002097', '002', 'Piode', 'G685', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002102', '002', 'Postua', 'G940', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002104', '002', 'Prarolo', 'G985', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002107', '002', 'Quarona', 'H108', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002108', '002', 'Quinto Vercellese', 'H132', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002110', '002', 'Rassa', 'H188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002111', '002', 'Rima San Giuseppe', 'H291', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002112', '002', 'Rimasco', 'H292', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002113', '002', 'Rimella', 'H293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002114', '002', 'Riva Valdobbia', 'H329', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002115', '002', 'Rive', 'H346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002116', '002', 'Roasio', 'H365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002118', '002', 'Ronsecco', 'H549', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002121', '002', 'Rossa', 'H577', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002122', '002', 'Rovasenda', 'H364', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002123', '002', 'Sabbia', 'H648', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002126', '002', 'Salasco', 'H690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002127', '002', 'Sali Vercellese', 'H707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002128', '002', 'Saluggia', 'H725', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002131', '002', 'San Germano Vercellese', 'H861', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002035', '002', 'San Giacomo Vercellese', 'B952', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002133', '002', 'Santhià', 'I337', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002134', '002', 'Scopa', 'I544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002135', '002', 'Scopello', 'I545', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002137', '002', 'Serravalle Sesia', 'I663', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002142', '002', 'Stroppiana', 'I984', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002147', '002', 'Tricerro', 'L420', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002148', '002', 'Trino', 'L429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002150', '002', 'Tronzano Vercellese', 'L451', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002152', '002', 'Valduggia', 'L566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002156', '002', 'Varallo', 'L669', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002158', '002', 'Vercelli', 'L750', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002163', '002', 'Villarboit', 'M003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002164', '002', 'Villata', 'M028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002166', '002', 'Vocca', 'M106', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002170', '002', 'Alto Sermenza', 'M389', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002171', '002', 'Cellio con Breia', 'M398', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002801', '002', 'Agnona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002802', '002', 'Andorno Cacciorna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002803', '002', 'Aranco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002804', '002', 'Bornate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002805', '002', 'Camasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002806', '002', 'Cascine di Stra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002807', '002', 'Castellengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002808', '002', 'Castelletto Villa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002809', '002', 'Cervarolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002810', '002', 'Chiavazza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002811', '002', 'Cossila', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002812', '002', 'Crevola Sesia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002813', '002', 'Croce di Mosso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002814', '002', 'Doccio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002815', '002', 'Ferruta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002816', '002', 'Flecchia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002817', '002', 'Foresto Sesia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002818', '002', 'Isolella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002819', '002', 'Locarno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002820', '002', 'Morca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002821', '002', 'Morondo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002822', '002', 'Parone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002823', '002', 'Pianceri', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002824', '002', 'Piane Sesia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002825', '002', 'Rocca Pietra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002826', '002', 'San Giuseppe di Casto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002827', '002', 'Valle Superiore Mosso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002828', '002', 'Valmaggia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('002829', '002', 'Vintebbio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003001', '003', 'Agrate Conturbia', 'A088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003002', '003', 'Ameno', 'A264', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003006', '003', 'Armeno', 'A414', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003008', '003', 'Arona', 'A429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003012', '003', 'Barengo', 'A653', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003016', '003', 'Bellinzago Novarese', 'A752', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003018', '003', 'Biandrate', 'A844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003019', '003', 'Boca', 'A911', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003021', '003', 'Bogogno', 'A929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003022', '003', 'Bolzano Novarese', 'A953', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003025', '003', 'Borgo Ticino', 'B043', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003023', '003', 'Borgolavezzaro', 'B016', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003024', '003', 'Borgomanero', 'B019', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003026', '003', 'Briga Novarese', 'B176', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003027', '003', 'Briona', 'B183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003030', '003', 'Caltignaga', 'B431', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003032', '003', 'Cameri', 'B473', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003036', '003', 'Carpignano Sesia', 'B823', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003037', '003', 'Casalbeltrame', 'B864', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003039', '003', 'Casaleggio Novara', 'B883', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003040', '003', 'Casalino', 'B897', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003041', '003', 'Casalvolone', 'B920', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003042', '003', 'Castellazzo Novarese', 'C149', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003043', '003', 'Castelletto sopra Ticino', 'C166', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003044', '003', 'Cavaglietto', 'C364', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003045', '003', 'Cavaglio d''Agogna', 'C365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003047', '003', 'Cavallirio', 'C378', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003049', '003', 'Cerano', 'C483', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003051', '003', 'Colazza', 'C829', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003052', '003', 'Comignago', 'C926', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003055', '003', 'Cressa', 'D162', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003058', '003', 'Cureggio', 'D216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003060', '003', 'Divignano', 'D309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003062', '003', 'Dormelletto', 'D347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003065', '003', 'Fara Novarese', 'D492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003066', '003', 'Fontaneto d''Agogna', 'D675', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003068', '003', 'Galliate', 'D872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003069', '003', 'Garbagna Novarese', 'D911', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003070', '003', 'Gargallo', 'D921', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003071', '003', 'Gattico', 'D937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003073', '003', 'Ghemme', 'E001', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003076', '003', 'Gozzano', 'E120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003077', '003', 'Granozzo con Monticello', 'E143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003079', '003', 'Grignasco', 'E177', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003082', '003', 'Invorio', 'E314', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003083', '003', 'Landiona', 'E436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003084', '003', 'Lesa', 'E544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003088', '003', 'Maggiora', 'E803', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003090', '003', 'Mandello Vitta', 'E880', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003091', '003', 'Marano Ticino', 'E907', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003093', '003', 'Massino Visconti', 'F047', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003095', '003', 'Meina', 'F093', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003097', '003', 'Mezzomerico', 'F188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003098', '003', 'Miasino', 'F191', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003100', '003', 'Momo', 'F317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003103', '003', 'Nebbiuno', 'F859', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003104', '003', 'Nibbiola', 'F886', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003106', '003', 'Novara', 'F952', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003108', '003', 'Oleggio', 'G019', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003109', '003', 'Oleggio Castello', 'G020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003112', '003', 'Orta San Giulio', 'G134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003114', '003', 'Paruzzaro', 'G349', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003115', '003', 'Pella', 'G421', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003116', '003', 'Pettenasco', 'G520', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003119', '003', 'Pisano', 'G703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003120', '003', 'Pogno', 'G775', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003121', '003', 'Pombia', 'G809', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003122', '003', 'Prato Sesia', 'H001', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003129', '003', 'Recetto', 'H213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003130', '003', 'Romagnano Sesia', 'H502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003131', '003', 'Romentino', 'H518', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003133', '003', 'San Maurizio d''Opaglio', 'I025', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003134', '003', 'San Nazzaro Sesia', 'I052', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003135', '003', 'San Pietro Mosezzo', 'I116', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003138', '003', 'Sillavengo', 'I736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003139', '003', 'Sizzano', 'I767', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003140', '003', 'Soriso', 'I857', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003141', '003', 'Sozzago', 'I880', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003143', '003', 'Suno', 'L007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003144', '003', 'Terdobbiate', 'L104', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003146', '003', 'Tornaco', 'L223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003149', '003', 'Trecate', 'L356', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003153', '003', 'Vaprio d''Agogna', 'L668', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003154', '003', 'Varallo Pombia', 'L670', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003157', '003', 'Veruno', 'L798', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003158', '003', 'Vespolate', 'L808', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003159', '003', 'Vicolungo', 'L847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003164', '003', 'Vinzaglio', 'M062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003801', '003', 'Agaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003802', '003', 'Agnellengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003803', '003', 'Agrano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003804', '003', 'Albogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003805', '003', 'Alzate con Linduno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003806', '003', 'Antronapiana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003807', '003', 'Anzino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003808', '003', 'Ara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003809', '003', 'Arizzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003810', '003', 'Arizzano Inferiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003811', '003', 'Arizzano Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003812', '003', 'Artò', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003813', '003', 'Auzate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003814', '003', 'Beura', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003815', '003', 'Bieno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003816', '003', 'Bognanco Dentro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003817', '003', 'Bognanco Fuori', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003818', '003', 'Boleto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003819', '003', 'Borgone d''Ossola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003820', '003', 'Brisino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003821', '003', 'Brovello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003822', '003', 'Bugnate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003823', '003', 'Buttogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003824', '003', 'Caddo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003825', '003', 'Calice Ossolano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003826', '003', 'Calogna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003827', '003', 'Campello Monti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003828', '003', 'Cardezza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003829', '003', 'Cargiago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003830', '003', 'Carpugnino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003831', '003', 'Casaleggio Castellazzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003832', '003', 'Castiglione d''Ossola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003833', '003', 'Cavaglio San Donnino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003834', '003', 'Cavandone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003835', '003', 'Chignolo Verbano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003836', '003', 'Cimamulera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003837', '003', 'Cireggio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003838', '003', 'Cisore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003839', '003', 'Coimo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003840', '003', 'Coiromonte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003841', '003', 'Comnago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003842', '003', 'Corciago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003843', '003', 'Crana Gattugno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003844', '003', 'Cravegna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003845', '003', 'Crusinallo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003846', '003', 'Cursolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003847', '003', 'Cuzzago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003848', '003', 'Dagnente', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003849', '003', 'Dissimo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003850', '003', 'Esio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003851', '003', 'Finero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003852', '003', 'Folsogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003853', '003', 'Fomarco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003854', '003', 'Fornero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003855', '003', 'Forno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003856', '003', 'Fosseno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003857', '003', 'Ghevio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003858', '003', 'Graglia Piana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003859', '003', 'Intra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003860', '003', 'Invorio Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003861', '003', 'Isola San Giulio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003862', '003', 'Luzzogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003863', '003', 'Magognino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003864', '003', 'Mercurago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003865', '003', 'Migiandone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003866', '003', 'Monte Ossolano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003867', '003', 'Montebuglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003868', '003', 'Montrigiasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003869', '003', 'Mozzio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003870', '003', 'Nocco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003871', '003', 'Olgia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003872', '003', 'Orasso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003873', '003', 'Orta Novarese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003874', '003', 'Pallanza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003875', '003', 'Preglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003876', '003', 'Prequartera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003877', '003', 'Quarna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003878', '003', 'Rovegro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003879', '003', 'Rumianca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003880', '003', 'Salecchio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003881', '003', 'Sambughetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003882', '003', 'San Bartolomeo Valmara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003883', '003', 'San Carlo d''Ossola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003884', '003', 'Sant’Agata Sopra Cannobio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003885', '003', 'Santa Maria Maggiore e Crana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003886', '003', 'Santino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003887', '003', 'Schieranco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003888', '003', 'Sologno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003889', '003', 'Sovazza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003890', '003', 'Spoccia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003891', '003', 'Stropino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003892', '003', 'Suna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003893', '003', 'Tapigliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003894', '003', 'Tappia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003895', '003', 'Traffiume', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003896', '003', 'Trobaso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003897', '003', 'Unchio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003898', '003', 'Vagna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003899', '003', 'Vergano Novarese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003900', '003', 'Vezzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003901', '003', 'Viceno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003902', '003', 'Viggiona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003903', '003', 'Vocogno e Prestinone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003904', '003', 'Zornasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('003905', '003', 'Zoverallo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004001', '004', 'Acceglio', 'A016', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004002', '004', 'Aisone', 'A113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004003', '004', 'Alba', 'A124', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004004', '004', 'Albaretto della Torre', 'A139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004005', '004', 'Alto', 'A238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004006', '004', 'Argentera', 'A394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004007', '004', 'Arguello', 'A396', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004008', '004', 'Bagnasco', 'A555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004009', '004', 'Bagnolo Piemonte', 'A571', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004010', '004', 'Baldissero d''Alba', 'A589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004011', '004', 'Barbaresco', 'A629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004012', '004', 'Barge', 'A660', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004013', '004', 'Barolo', 'A671', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004014', '004', 'Bastia Mondovì', 'A709', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004015', '004', 'Battifollo', 'A716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004016', '004', 'Beinette', 'A735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004017', '004', 'Bellino', 'A750', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004018', '004', 'Belvedere Langhe', 'A774', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004019', '004', 'Bene Vagienna', 'A779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004020', '004', 'Benevello', 'A782', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004021', '004', 'Bergolo', 'A798', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004022', '004', 'Bernezzo', 'A805', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004023', '004', 'Bonvicino', 'A979', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004025', '004', 'Borgo San Dalmazzo', 'B033', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004024', '004', 'Borgomale', 'B018', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004026', '004', 'Bosia', 'B079', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004027', '004', 'Bossolasco', 'B084', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004028', '004', 'Boves', 'B101', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004029', '004', 'Bra', 'B111', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004030', '004', 'Briaglia', 'B167', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004031', '004', 'Briga Alta', 'B175', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004032', '004', 'Brondello', 'B200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004033', '004', 'Brossasco', 'B204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004034', '004', 'Busca', 'B285', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004035', '004', 'Camerana', 'B467', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004036', '004', 'Camo', 'B489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004037', '004', 'Canale', 'B573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004038', '004', 'Canosio', 'B621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004039', '004', 'Caprauna', 'B692', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004040', '004', 'Caraglio', 'B719', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004041', '004', 'Caramagna Piemonte', 'B720', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004042', '004', 'Cardè', 'B755', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004043', '004', 'Carrù', 'B841', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004044', '004', 'Cartignano', 'B845', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004045', '004', 'Casalgrasso', 'B894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004046', '004', 'Castagnito', 'C046', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004047', '004', 'Casteldelfino', 'C081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004048', '004', 'Castellar', 'C140', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004049', '004', 'Castelletto Stura', 'C165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004050', '004', 'Castelletto Uzzone', 'C167', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004051', '004', 'Castellinaldo d''Alba', 'C173', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004052', '004', 'Castellino Tanaro', 'C176', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004053', '004', 'Castelmagno', 'C205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004054', '004', 'Castelnuovo di Ceva', 'C214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004055', '004', 'Castiglione Falletto', 'C314', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004056', '004', 'Castiglione Tinella', 'C317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004057', '004', 'Castino', 'C323', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004058', '004', 'Cavallerleone', 'C375', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004059', '004', 'Cavallermaggiore', 'C376', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004060', '004', 'Celle di Macra', 'C441', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004061', '004', 'Centallo', 'C466', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004062', '004', 'Ceresole Alba', 'C504', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004063', '004', 'Cerretto Langhe', 'C530', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004064', '004', 'Cervasca', 'C547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004065', '004', 'Cervere', 'C550', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004066', '004', 'Ceva', 'C589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004067', '004', 'Cherasco', 'C599', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004068', '004', 'Chiusa di Pesio', 'C653', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004069', '004', 'Cigliè', 'C681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004070', '004', 'Cissone', 'C738', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004071', '004', 'Clavesana', 'C792', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004072', '004', 'Corneliano d''Alba', 'D022', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004073', '004', 'Cortemilia', 'D062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004074', '004', 'Cossano Belbo', 'D093', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004075', '004', 'Costigliole Saluzzo', 'D120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004076', '004', 'Cravanzana', 'D133', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004077', '004', 'Crissolo', 'D172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004078', '004', 'Cuneo', 'D205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004079', '004', 'Demonte', 'D271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004080', '004', 'Diano d''Alba', 'D291', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004081', '004', 'Dogliani', 'D314', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004082', '004', 'Dronero', 'D372', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004083', '004', 'Elva', 'D401', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004084', '004', 'Entracque', 'D410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004085', '004', 'Envie', 'D412', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004086', '004', 'Farigliano', 'D499', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004087', '004', 'Faule', 'D511', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004088', '004', 'Feisoglio', 'D523', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004089', '004', 'Fossano', 'D742', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004090', '004', 'Frabosa Soprana', 'D751', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004091', '004', 'Frabosa Sottana', 'D752', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004092', '004', 'Frassino', 'D782', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004093', '004', 'Gaiola', 'D856', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004094', '004', 'Gambasca', 'D894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004095', '004', 'Garessio', 'D920', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004096', '004', 'Genola', 'D967', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004097', '004', 'Gorzegno', 'E111', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004098', '004', 'Gottasecca', 'E115', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004099', '004', 'Govone', 'E118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004100', '004', 'Grinzane Cavour', 'E182', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004101', '004', 'Guarene', 'E251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004102', '004', 'Igliano', 'E282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004103', '004', 'Isasca', 'E327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004105', '004', 'La Morra', 'E430', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004104', '004', 'Lagnasco', 'E406', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004106', '004', 'Lequio Berria', 'E540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004107', '004', 'Lequio Tanaro', 'E539', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004108', '004', 'Lesegno', 'E546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004109', '004', 'Levice', 'E564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004110', '004', 'Limone Piemonte', 'E597', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004111', '004', 'Lisio', 'E615', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004112', '004', 'Macra', 'E789', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004113', '004', 'Magliano Alfieri', 'E809', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004114', '004', 'Magliano Alpi', 'E808', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004115', '004', 'Mango', 'E887', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004116', '004', 'Manta', 'E894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004117', '004', 'Marene', 'E939', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004118', '004', 'Margarita', 'E945', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004119', '004', 'Marmora', 'E963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004120', '004', 'Marsaglia', 'E973', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004121', '004', 'Martiniana Po', 'E988', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004122', '004', 'Melle', 'F114', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004123', '004', 'Moiola', 'F279', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004124', '004', 'Mombarcaro', 'F309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004125', '004', 'Mombasiglio', 'F312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004126', '004', 'Monastero di Vasco', 'F326', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004127', '004', 'Monasterolo Casotto', 'F329', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004128', '004', 'Monasterolo di Savigliano', 'F330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004129', '004', 'Monchiero', 'F338', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004130', '004', 'Mondovì', 'F351', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004131', '004', 'Monesiglio', 'F355', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004132', '004', 'Monforte d''Alba', 'F358', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004133', '004', 'Montà', 'F385', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004134', '004', 'Montaldo di Mondovì', 'F405', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004135', '004', 'Montaldo Roero', 'F408', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004136', '004', 'Montanera', 'F424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004137', '004', 'Montelupo Albese', 'F550', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004138', '004', 'Montemale di Cuneo', 'F558', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004139', '004', 'Monterosso Grana', 'F608', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004140', '004', 'Monteu Roero', 'F654', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004141', '004', 'Montezemolo', 'F666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004142', '004', 'Monticello d''Alba', 'F669', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004143', '004', 'Moretta', 'F723', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004144', '004', 'Morozzo', 'F743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004145', '004', 'Murazzano', 'F809', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004146', '004', 'Murello', 'F811', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004147', '004', 'Narzole', 'F846', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004148', '004', 'Neive', 'F863', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004149', '004', 'Neviglie', 'F883', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004150', '004', 'Niella Belbo', 'F894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004151', '004', 'Niella Tanaro', 'F895', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004152', '004', 'Novello', 'F961', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004153', '004', 'Nucetto', 'F972', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004154', '004', 'Oncino', 'G066', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004155', '004', 'Ormea', 'G114', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004156', '004', 'Ostana', 'G183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004157', '004', 'Paesana', 'G228', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004158', '004', 'Pagno', 'G240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004159', '004', 'Pamparato', 'G302', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004160', '004', 'Paroldo', 'G339', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004161', '004', 'Perletto', 'G457', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004162', '004', 'Perlo', 'G458', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004163', '004', 'Peveragno', 'G526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004164', '004', 'Pezzolo Valle Uzzone', 'G532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004165', '004', 'Pianfei', 'G561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004166', '004', 'Piasco', 'G575', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004167', '004', 'Pietraporzio', 'G625', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004168', '004', 'Piobesi d''Alba', 'G683', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004169', '004', 'Piozzo', 'G697', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004170', '004', 'Pocapaglia', 'G742', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004171', '004', 'Polonghera', 'G800', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004172', '004', 'Pontechianale', 'G837', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004173', '004', 'Pradleves', 'G970', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004174', '004', 'Prazzo', 'H011', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004175', '004', 'Priero', 'H059', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004176', '004', 'Priocca', 'H068', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004177', '004', 'Priola', 'H069', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004178', '004', 'Prunetto', 'H085', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004179', '004', 'Racconigi', 'H150', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004180', '004', 'Revello', 'H247', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004181', '004', 'Rifreddo', 'H285', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004182', '004', 'Rittana', 'H326', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004183', '004', 'Roaschia', 'H362', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004184', '004', 'Roascio', 'H363', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004185', '004', 'Robilante', 'H377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004186', '004', 'Roburent', 'H378', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004188', '004', 'Rocca Cigliè', 'H391', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004189', '004', 'Rocca de'' Baldi', 'H395', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004187', '004', 'Roccabruna', 'H385', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004190', '004', 'Roccaforte Mondovì', 'H407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004191', '004', 'Roccasparvera', 'H447', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004192', '004', 'Roccavione', 'H453', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004193', '004', 'Rocchetta Belbo', 'H462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004194', '004', 'Roddi', 'H472', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004195', '004', 'Roddino', 'H473', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004196', '004', 'Rodello', 'H474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004197', '004', 'Rossana', 'H578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004198', '004', 'Ruffia', 'H633', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004199', '004', 'Sale delle Langhe', 'H695', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004200', '004', 'Sale San Giovanni', 'H704', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004201', '004', 'Saliceto', 'H710', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004202', '004', 'Salmour', 'H716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004203', '004', 'Saluzzo', 'H727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004204', '004', 'Sambuco', 'H746', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004205', '004', 'Sampeyre', 'H755', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004206', '004', 'San Benedetto Belbo', 'H770', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004207', '004', 'San Damiano Macra', 'H812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004210', '004', 'San Michele Mondovì', 'I037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004208', '004', 'Sanfrè', 'H851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004209', '004', 'Sanfront', 'H852', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004212', '004', 'Santa Vittoria d''Alba', 'I316', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004211', '004', 'Sant''Albano Stura', 'I210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004213', '004', 'Santo Stefano Belbo', 'I367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004214', '004', 'Santo Stefano Roero', 'I372', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004215', '004', 'Savigliano', 'I470', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004216', '004', 'Scagnello', 'I484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004217', '004', 'Scarnafigi', 'I512', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004218', '004', 'Serralunga d''Alba', 'I646', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004219', '004', 'Serravalle Langhe', 'I659', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004220', '004', 'Sinio', 'I750', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004221', '004', 'Somano', 'I817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004222', '004', 'Sommariva del Bosco', 'I822', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004223', '004', 'Sommariva Perno', 'I823', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004224', '004', 'Stroppo', 'I985', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004225', '004', 'Tarantasca', 'L048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004226', '004', 'Torre Bormida', 'L252', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004227', '004', 'Torre Mondovì', 'L241', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004228', '004', 'Torre San Giorgio', 'L278', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004229', '004', 'Torresina', 'L281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004230', '004', 'Treiso', 'L367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004231', '004', 'Trezzo Tinella', 'L410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004232', '004', 'Trinità', 'L427', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004233', '004', 'Valdieri', 'L558', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004234', '004', 'Valgrana', 'L580', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004235', '004', 'Valloriate', 'L631', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004236', '004', 'Valmala', 'L636', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004237', '004', 'Venasca', 'L729', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004238', '004', 'Verduno', 'L758', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004239', '004', 'Vernante', 'L771', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004240', '004', 'Verzuolo', 'L804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004241', '004', 'Vezza d''Alba', 'L817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004242', '004', 'Vicoforte', 'L841', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004243', '004', 'Vignolo', 'L888', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004244', '004', 'Villafalletto', 'L942', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004245', '004', 'Villanova Mondovì', 'L974', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004246', '004', 'Villanova Solaro', 'L990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004247', '004', 'Villar San Costanzo', 'M015', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004248', '004', 'Vinadio', 'M055', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004249', '004', 'Viola', 'M063', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004250', '004', 'Vottignasco', 'M136', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004801', '004', 'Albaretto Valle di Macra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004802', '004', 'Alma', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004803', '004', 'Andonno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004804', '004', 'Bersezio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004805', '004', 'Briga Marittima', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004806', '004', 'Castelletto Monforte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004807', '004', 'Gaiola Moiola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004808', '004', 'Gorrino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004809', '004', 'Lottulo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004810', '004', 'Malpotremo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004811', '004', 'Novello Monchiero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004812', '004', 'Paglieres', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004813', '004', 'Perno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004814', '004', 'Priero Montezemolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004815', '004', 'Sambuco-Pietraporzio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004816', '004', 'San Michele Prazzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004817', '004', 'San Pietro di Monterosso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004818', '004', 'Scaletta Uzzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004819', '004', 'Scarnafigi-Ruffia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004820', '004', 'Tenda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004821', '004', 'Torre Uzzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004822', '004', 'Ussolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('004823', '004', 'Villanovetta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005001', '005', 'Agliano Terme', 'A072', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005002', '005', 'Albugnano', 'A173', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005003', '005', 'Antignano', 'A312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005004', '005', 'Aramengo', 'A352', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005005', '005', 'Asti', 'A479', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005006', '005', 'Azzano d''Asti', 'A527', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005007', '005', 'Baldichieri d''Asti', 'A588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005008', '005', 'Belveglio', 'A770', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005009', '005', 'Berzano di San Pietro', 'A812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005010', '005', 'Bruno', 'B221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005011', '005', 'Bubbio', 'B236', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005012', '005', 'Buttigliera d''Asti', 'B306', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005013', '005', 'Calamandrana', 'B376', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005014', '005', 'Calliano', 'B418', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005015', '005', 'Calosso', 'B425', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005016', '005', 'Camerano Casasco', 'B469', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005017', '005', 'Canelli', 'B594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005018', '005', 'Cantarana', 'B633', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005019', '005', 'Capriglio', 'B707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005020', '005', 'Casorzo', 'B991', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005021', '005', 'Cassinasco', 'C022', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005022', '005', 'Castagnole delle Lanze', 'C049', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005023', '005', 'Castagnole Monferrato', 'C047', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005024', '005', 'Castel Boglione', 'C064', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005032', '005', 'Castel Rocchero', 'C253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005025', '005', 'Castell''Alfero', 'C127', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005026', '005', 'Castellero', 'C154', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005027', '005', 'Castelletto Molina', 'C161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005028', '005', 'Castello di Annone', 'A300', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005029', '005', 'Castelnuovo Belbo', 'C226', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005030', '005', 'Castelnuovo Calcea', 'C230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005031', '005', 'Castelnuovo Don Bosco', 'C232', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005033', '005', 'Cellarengo', 'C438', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005034', '005', 'Celle Enomondo', 'C440', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005035', '005', 'Cerreto d''Asti', 'C528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005036', '005', 'Cerro Tanaro', 'C533', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005037', '005', 'Cessole', 'C583', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005038', '005', 'Chiusano d''Asti', 'C658', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005039', '005', 'Cinaglio', 'C701', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005040', '005', 'Cisterna d''Asti', 'C739', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005041', '005', 'Coazzolo', 'C804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005042', '005', 'Cocconato', 'C807', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005044', '005', 'Corsione', 'D046', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005045', '005', 'Cortandone', 'D050', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005046', '005', 'Cortanze', 'D051', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005047', '005', 'Cortazzone', 'D052', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005048', '005', 'Cortiglione', 'D072', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005049', '005', 'Cossombrato', 'D101', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005050', '005', 'Costigliole d''Asti', 'D119', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005051', '005', 'Cunico', 'D207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005052', '005', 'Dusino San Michele', 'D388', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005053', '005', 'Ferrere', 'D554', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005054', '005', 'Fontanile', 'D678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005055', '005', 'Frinco', 'D802', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005056', '005', 'Grana', 'E134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005057', '005', 'Grazzano Badoglio', 'E159', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005058', '005', 'Incisa Scapaccino', 'E295', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005059', '005', 'Isola d''Asti', 'E338', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005060', '005', 'Loazzolo', 'E633', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005061', '005', 'Maranzana', 'E917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005062', '005', 'Maretto', 'E944', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005063', '005', 'Moasca', 'F254', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005064', '005', 'Mombaldone', 'F308', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005065', '005', 'Mombaruzzo', 'F311', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005066', '005', 'Mombercelli', 'F316', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005067', '005', 'Monale', 'F323', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005068', '005', 'Monastero Bormida', 'F325', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005069', '005', 'Moncalvo', 'F336', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005070', '005', 'Moncucco Torinese', 'F343', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005071', '005', 'Mongardino', 'F361', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005072', '005', 'Montabone', 'F386', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005073', '005', 'Montafia', 'F390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005074', '005', 'Montaldo Scarampi', 'F409', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005075', '005', 'Montechiaro d''Asti', 'F468', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005076', '005', 'Montegrosso d''Asti', 'F527', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005077', '005', 'Montemagno', 'F556', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005121', '005', 'Montiglio Monferrato', 'M302', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005079', '005', 'Moransengo', 'F709', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005080', '005', 'Nizza Monferrato', 'F902', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005081', '005', 'Olmo Gentile', 'G048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005082', '005', 'Passerano Marmorito', 'G358', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005083', '005', 'Penango', 'G430', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005084', '005', 'Piea', 'G593', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005085', '005', 'Pino d''Asti', 'G676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005086', '005', 'Piovà Massaia', 'G692', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005087', '005', 'Portacomaro', 'G894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005088', '005', 'Quaranti', 'H102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005089', '005', 'Refrancore', 'H219', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005090', '005', 'Revigliasco d''Asti', 'H250', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005091', '005', 'Roatto', 'H366', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005092', '005', 'Robella', 'H376', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005093', '005', 'Rocca d''Arazzo', 'H392', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005094', '005', 'Roccaverano', 'H451', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005095', '005', 'Rocchetta Palafea', 'H466', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005096', '005', 'Rocchetta Tanaro', 'H468', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005097', '005', 'San Damiano d''Asti', 'H811', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005098', '005', 'San Giorgio Scarampi', 'H899', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005099', '005', 'San Martino Alfieri', 'H987', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005100', '005', 'San Marzano Oliveto', 'I017', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005101', '005', 'San Paolo Solbrito', 'I076', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005103', '005', 'Scurzolengo', 'I555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005104', '005', 'Serole', 'I637', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005105', '005', 'Sessame', 'I678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005106', '005', 'Settime', 'I698', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005107', '005', 'Soglio', 'I781', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005108', '005', 'Tigliole', 'L168', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005109', '005', 'Tonco', 'L203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005110', '005', 'Tonengo', 'L204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005111', '005', 'Vaglio Serra', 'L531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005112', '005', 'Valfenera', 'L574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005113', '005', 'Vesime', 'L807', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005114', '005', 'Viale', 'L829', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005115', '005', 'Viarigi', 'L834', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005116', '005', 'Vigliano d''Asti', 'L879', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005119', '005', 'Villa San Secondo', 'M019', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005117', '005', 'Villafranca d''Asti', 'L945', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005118', '005', 'Villanova d''Asti', 'L984', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005120', '005', 'Vinchio', 'M058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005043', '005', 'Colcavagno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005078', '005', 'Montiglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005102', '005', 'Scandeluzza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005801', '005', 'Bagnasco d''Asti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005802', '005', 'Castelvero d''Asti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005803', '005', 'Castiglione d''Asti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005804', '005', 'Cocconito', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005805', '005', 'Dusino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005806', '005', 'Marmorito', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005807', '005', 'Mondonio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005808', '005', 'Passerano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005809', '005', 'Primeglio Schierano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005810', '005', 'Quarto Astese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005811', '005', 'Rinco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005812', '005', 'San Marzano Moasca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005813', '005', 'San Marzanotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005814', '005', 'San Michele d''Asti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005815', '005', 'San Paolo della Valle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005816', '005', 'Serravalle d’Asti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005817', '005', 'Sessant', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005818', '005', 'Solbrito', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005819', '005', 'Vaglierano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('005820', '005', 'Villa Corsione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006001', '006', 'Acqui Terme', 'A052', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006002', '006', 'Albera Ligure', 'A146', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006003', '006', 'Alessandria', 'A182', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006004', '006', 'Alfiano Natta', 'A189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006005', '006', 'Alice Bel Colle', 'A197', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006006', '006', 'Alluvioni Cambiò', 'A211', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006007', '006', 'Altavilla Monferrato', 'A227', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006008', '006', 'Alzano Scrivia', 'A245', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006009', '006', 'Arquata Scrivia', 'A436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006010', '006', 'Avolasca', 'A523', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006011', '006', 'Balzola', 'A605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006012', '006', 'Basaluzzo', 'A689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006013', '006', 'Bassignana', 'A708', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006014', '006', 'Belforte Monferrato', 'A738', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006015', '006', 'Bergamasco', 'A793', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006016', '006', 'Berzano di Tortona', 'A813', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006017', '006', 'Bistagno', 'A889', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006018', '006', 'Borghetto di Borbera', 'A998', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006020', '006', 'Borgo San Martino', 'B037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006019', '006', 'Borgoratto Alessandrino', 'B029', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006021', '006', 'Bosco Marengo', 'B071', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006022', '006', 'Bosio', 'B080', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006023', '006', 'Bozzole', 'B109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006024', '006', 'Brignano-Frascata', 'B179', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006025', '006', 'Cabella Ligure', 'B311', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006026', '006', 'Camagna Monferrato', 'B453', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006027', '006', 'Camino', 'B482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006028', '006', 'Cantalupo Ligure', 'B629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006029', '006', 'Capriata d''Orba', 'B701', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006030', '006', 'Carbonara Scrivia', 'B736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006031', '006', 'Carentino', 'B765', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006032', '006', 'Carezzano', 'B769', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006033', '006', 'Carpeneto', 'B818', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006034', '006', 'Carrega Ligure', 'B836', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006035', '006', 'Carrosio', 'B840', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006036', '006', 'Cartosio', 'B847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006037', '006', 'Casal Cermelli', 'B870', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006039', '006', 'Casale Monferrato', 'B885', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006038', '006', 'Casaleggio Boiro', 'B882', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006040', '006', 'Casalnoceto', 'B902', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006041', '006', 'Casasco', 'B941', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006042', '006', 'Cassano Spinola', 'C005', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006043', '006', 'Cassine', 'C027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006044', '006', 'Cassinelle', 'C030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006045', '006', 'Castellania', 'C137', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006046', '006', 'Castellar Guidobono', 'C142', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006047', '006', 'Castellazzo Bormida', 'C148', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006048', '006', 'Castelletto d''Erro', 'C156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006049', '006', 'Castelletto d''Orba', 'C158', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006050', '006', 'Castelletto Merli', 'C160', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006051', '006', 'Castelletto Monferrato', 'C162', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006052', '006', 'Castelnuovo Bormida', 'C229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006053', '006', 'Castelnuovo Scrivia', 'C243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006054', '006', 'Castelspina', 'C274', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006055', '006', 'Cavatore', 'C387', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006056', '006', 'Cella Monte', 'C432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006057', '006', 'Cereseto', 'C503', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006058', '006', 'Cerreto Grue', 'C507', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006059', '006', 'Cerrina Monferrato', 'C531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006060', '006', 'Coniolo', 'C962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006061', '006', 'Conzano', 'C977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006062', '006', 'Costa Vescovato', 'D102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006063', '006', 'Cremolino', 'D149', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006064', '006', 'Cuccaro Monferrato', 'D194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006065', '006', 'Denice', 'D272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006066', '006', 'Dernice', 'D277', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006067', '006', 'Fabbrica Curone', 'D447', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006068', '006', 'Felizzano', 'D528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006069', '006', 'Fraconalto', 'D559', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006070', '006', 'Francavilla Bisio', 'D759', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006071', '006', 'Frascaro', 'D770', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006072', '006', 'Frassinello Monferrato', 'D777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006073', '006', 'Frassineto Po', 'D780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006074', '006', 'Fresonara', 'D797', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006075', '006', 'Frugarolo', 'D813', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006076', '006', 'Fubine Monferrato', 'D814', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006077', '006', 'Gabiano', 'D835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006078', '006', 'Gamalero', 'D890', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006079', '006', 'Garbagna', 'D910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006080', '006', 'Gavazzana', 'D941', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006081', '006', 'Gavi', 'D944', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006082', '006', 'Giarole', 'E015', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006083', '006', 'Gremiasco', 'E164', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006084', '006', 'Grognardo', 'E188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006085', '006', 'Grondona', 'E191', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006086', '006', 'Guazzora', 'E255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006087', '006', 'Isola Sant''Antonio', 'E360', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006088', '006', 'Lerma', 'E543', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006089', '006', 'Lu', 'E712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006090', '006', 'Malvicino', 'E870', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006091', '006', 'Masio', 'F015', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006092', '006', 'Melazzo', 'F096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006093', '006', 'Merana', 'F131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006094', '006', 'Mirabello Monferrato', 'F232', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006095', '006', 'Molare', 'F281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006096', '006', 'Molino dei Torti', 'F293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006097', '006', 'Mombello Monferrato', 'F313', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006098', '006', 'Momperone', 'F320', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006099', '006', 'Moncestino', 'F337', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006100', '006', 'Mongiardino Ligure', 'F365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006101', '006', 'Monleale', 'F374', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006102', '006', 'Montacuto', 'F387', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006103', '006', 'Montaldeo', 'F403', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006104', '006', 'Montaldo Bormida', 'F404', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006105', '006', 'Montecastello', 'F455', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006106', '006', 'Montechiaro d''Acqui', 'F469', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006107', '006', 'Montegioco', 'F518', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006108', '006', 'Montemarzino', 'F562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006109', '006', 'Morano sul Po', 'F707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006110', '006', 'Morbello', 'F713', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006111', '006', 'Mornese', 'F737', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006112', '006', 'Morsasco', 'F751', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006113', '006', 'Murisengo', 'F814', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006114', '006', 'Novi Ligure', 'F965', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006115', '006', 'Occimiano', 'F995', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006116', '006', 'Odalengo Grande', 'F997', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006117', '006', 'Odalengo Piccolo', 'F998', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006118', '006', 'Olivola', 'G042', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006119', '006', 'Orsara Bormida', 'G124', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006120', '006', 'Ottiglio', 'G193', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006121', '006', 'Ovada', 'G197', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006122', '006', 'Oviglio', 'G199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006123', '006', 'Ozzano Monferrato', 'G204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006124', '006', 'Paderna', 'G215', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006125', '006', 'Pareto', 'G334', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006126', '006', 'Parodi Ligure', 'G338', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006127', '006', 'Pasturana', 'G367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006128', '006', 'Pecetto di Valenza', 'G397', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006129', '006', 'Pietra Marazzi', 'G619', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006130', '006', 'Piovera', 'G695', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006131', '006', 'Pomaro Monferrato', 'G807', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006132', '006', 'Pontecurone', 'G839', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006133', '006', 'Pontestura', 'G858', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006134', '006', 'Ponti', 'G861', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006135', '006', 'Ponzano Monferrato', 'G872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006136', '006', 'Ponzone', 'G877', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006137', '006', 'Pozzol Groppo', 'G960', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006138', '006', 'Pozzolo Formigaro', 'G961', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006139', '006', 'Prasco', 'G987', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006140', '006', 'Predosa', 'H021', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006141', '006', 'Quargnento', 'H104', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006142', '006', 'Quattordio', 'H121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006143', '006', 'Ricaldone', 'H272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006144', '006', 'Rivalta Bormida', 'H334', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006145', '006', 'Rivarone', 'H343', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006147', '006', 'Rocca Grimalda', 'H414', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006146', '006', 'Roccaforte Ligure', 'H406', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006148', '006', 'Rocchetta Ligure', 'H465', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006149', '006', 'Rosignano Monferrato', 'H569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006150', '006', 'Sala Monferrato', 'H677', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006151', '006', 'Sale', 'H694', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006152', '006', 'San Cristoforo', 'H810', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006153', '006', 'San Giorgio Monferrato', 'H878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006154', '006', 'San Salvatore Monferrato', 'I144', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006155', '006', 'San Sebastiano Curone', 'I150', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006156', '006', 'Sant''Agata Fossili', 'I190', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006157', '006', 'Sardigliano', 'I429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006158', '006', 'Sarezzano', 'I432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006159', '006', 'Serralunga di Crea', 'I645', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006160', '006', 'Serravalle Scrivia', 'I657', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006161', '006', 'Sezzadio', 'I711', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006162', '006', 'Silvano d''Orba', 'I738', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006163', '006', 'Solero', 'I798', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006164', '006', 'Solonghello', 'I808', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006165', '006', 'Spigno Monferrato', 'I901', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006166', '006', 'Spineto Scrivia', 'I911', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006167', '006', 'Stazzano', 'I941', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006168', '006', 'Strevi', 'I977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006169', '006', 'Tagliolo Monferrato', 'L027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006170', '006', 'Tassarolo', 'L059', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006171', '006', 'Terruggia', 'L139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006172', '006', 'Terzo', 'L143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006173', '006', 'Ticineto', 'L165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006174', '006', 'Tortona', 'L304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006175', '006', 'Treville', 'L403', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006176', '006', 'Trisobbio', 'L432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006177', '006', 'Valenza', 'L570', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006178', '006', 'Valmacca', 'L633', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006179', '006', 'Vignale Monferrato', 'L881', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006180', '006', 'Vignole Borbera', 'L887', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006181', '006', 'Viguzzolo', 'L904', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006182', '006', 'Villadeati', 'L931', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006183', '006', 'Villalvernia', 'L963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006184', '006', 'Villamiroglio', 'L970', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006185', '006', 'Villanova Monferrato', 'L972', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006186', '006', 'Villaromagnano', 'M009', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006187', '006', 'Visone', 'M077', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006188', '006', 'Volpedo', 'M120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006189', '006', 'Volpeglino', 'M121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006190', '006', 'Voltaggio', 'M123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006191', '006', 'Cassano Spinola', 'M388', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006192', '006', 'Alluvioni Piovera', 'M397', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006801', '006', 'Bisio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006802', '006', 'Brignano del Curone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006803', '006', 'Brusaschetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006804', '006', 'Carezzano Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006805', '006', 'Castel de'' Ratti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006806', '006', 'Castel San Pietro Monferrato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006807', '006', 'Corteranzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006808', '006', 'Cuquello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006809', '006', 'Forotondo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006810', '006', 'Frascata', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006811', '006', 'Groppo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006812', '006', 'Malvino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006813', '006', 'Molino Alzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006814', '006', 'Molo di Borbera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006815', '006', 'Montalero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006816', '006', 'Montechiaro Denice', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006817', '006', 'Pavone d''Alessandria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006818', '006', 'Quarti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006819', '006', 'Rosingo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006820', '006', 'Salabue', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006821', '006', 'Sorli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006822', '006', 'Tagliolo Belforte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006823', '006', 'Torre de'' Ratti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006824', '006', 'Varengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006825', '006', 'Vargo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('006826', '006', 'Villabella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007001', '007', 'Allein', 'A205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007002', '007', 'Antey-Saint-André', 'A305', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007003', '007', 'Aosta', 'A326', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007004', '007', 'Arnad', 'A424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007005', '007', 'Arvier', 'A452', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007006', '007', 'Avise', 'A521', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007007', '007', 'Ayas', 'A094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007008', '007', 'Aymavilles', 'A108', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007009', '007', 'Bard', 'A643', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007010', '007', 'Bionaz', 'A877', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007011', '007', 'Brissogne', 'B192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007012', '007', 'Brusson', 'B230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007013', '007', 'Challand-Saint-Anselme', 'C593', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007014', '007', 'Challand-Saint-Victor', 'C594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007015', '007', 'Chambave', 'C595', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007016', '007', 'Chamois', 'B491', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007017', '007', 'Champdepraz', 'C596', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007018', '007', 'Champorcher', 'B540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007019', '007', 'Charvensod', 'C598', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007020', '007', 'Châtillon', 'C294', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007021', '007', 'Cogne', 'C821', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007022', '007', 'Courmayeur', 'D012', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007023', '007', 'Donnas', 'D338', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007024', '007', 'Doues', 'D356', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007025', '007', 'Emarèse', 'D402', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007026', '007', 'Etroubles', 'D444', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007027', '007', 'Fénis', 'D537', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007028', '007', 'Fontainemore', 'D666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007029', '007', 'Gaby', 'D839', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007030', '007', 'Gignod', 'E029', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007031', '007', 'Gressan', 'E165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007032', '007', 'Gressoney-La-Trinité', 'E167', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007033', '007', 'Gressoney-Saint-Jean', 'E168', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007034', '007', 'Hône', 'E273', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007035', '007', 'Introd', 'E306', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007036', '007', 'Issime', 'E369', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007037', '007', 'Issogne', 'E371', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007038', '007', 'Jovençan', 'E391', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007039', '007', 'La Magdeleine', 'A308', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007040', '007', 'La Salle', 'E458', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007041', '007', 'La Thuile', 'E470', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007042', '007', 'Lillianes', 'E587', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007043', '007', 'Montjovet', 'F367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007044', '007', 'Morgex', 'F726', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007045', '007', 'Nus', 'F987', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007046', '007', 'Ollomont', 'G045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007047', '007', 'Oyace', 'G012', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007048', '007', 'Perloz', 'G459', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007049', '007', 'Pollein', 'G794', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007050', '007', 'Pontboset', 'G545', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007051', '007', 'Pontey', 'G860', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007052', '007', 'Pont-Saint-Martin', 'G854', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007053', '007', 'Pré-Saint-Didier', 'H042', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007054', '007', 'Quart', 'H110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007055', '007', 'Rhêmes-Notre-Dame', 'H262', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007056', '007', 'Rhêmes-Saint-Georges', 'H263', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007057', '007', 'Roisan', 'H497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007058', '007', 'Saint-Christophe', 'H669', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007059', '007', 'Saint-Denis', 'H670', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007060', '007', 'Saint-Marcel', 'H671', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007061', '007', 'Saint-Nicolas', 'H672', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007062', '007', 'Saint-Oyen', 'H673', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007063', '007', 'Saint-Pierre', 'H674', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007064', '007', 'Saint-Rhémy-en-Bosses', 'H675', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007065', '007', 'Saint-Vincent', 'H676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007066', '007', 'Sarre', 'I442', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007067', '007', 'Torgnon', 'L217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007068', '007', 'Valgrisenche', 'L582', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007069', '007', 'Valpelline', 'L643', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007070', '007', 'Valsavarenche', 'L647', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007071', '007', 'Valtournenche', 'L654', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007072', '007', 'Verrayes', 'L783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007073', '007', 'Verrès', 'C282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007074', '007', 'Villeneuve', 'L981', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007801', '007', 'Challant', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007802', '007', 'Gressoney', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007803', '007', 'Rhêmes', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('007804', '007', 'Valdigna d’Aosta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008001', '008', 'Airole', 'A111', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008002', '008', 'Apricale', 'A338', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008003', '008', 'Aquila d''Arroscia', 'A344', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008004', '008', 'Armo', 'A418', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008005', '008', 'Aurigo', 'A499', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008006', '008', 'Badalucco', 'A536', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008007', '008', 'Bajardo', 'A581', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008008', '008', 'Bordighera', 'A984', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008009', '008', 'Borghetto d''Arroscia', 'A993', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008010', '008', 'Borgomaro', 'B020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008011', '008', 'Camporosso', 'B559', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008012', '008', 'Caravonica', 'B734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008013', '008', 'Carpasio', 'B814', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008015', '008', 'Castel Vittorio', 'C110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008014', '008', 'Castellaro', 'C143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008016', '008', 'Ceriana', 'C511', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008017', '008', 'Cervo', 'C559', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008018', '008', 'Cesio', 'C578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008019', '008', 'Chiusanico', 'C657', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008020', '008', 'Chiusavecchia', 'C660', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008021', '008', 'Cipressa', 'C718', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008022', '008', 'Civezza', 'C755', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008023', '008', 'Cosio d''Arroscia', 'D087', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008024', '008', 'Costarainera', 'D114', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008025', '008', 'Diano Arentino', 'D293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008026', '008', 'Diano Castello', 'D296', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008027', '008', 'Diano Marina', 'D297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008028', '008', 'Diano San Pietro', 'D298', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008029', '008', 'Dolceacqua', 'D318', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008030', '008', 'Dolcedo', 'D319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008031', '008', 'Imperia', 'E290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008032', '008', 'Isolabona', 'E346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008033', '008', 'Lucinasco', 'E719', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008034', '008', 'Mendatica', 'F123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008035', '008', 'Molini di Triora', 'F290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008036', '008', 'Montalto Ligure', 'F406', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008037', '008', 'Montegrosso Pian Latte', 'F528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008038', '008', 'Olivetta San Michele', 'G041', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008039', '008', 'Ospedaletti', 'G164', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008040', '008', 'Perinaldo', 'G454', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008041', '008', 'Pietrabruna', 'G607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008042', '008', 'Pieve di Teco', 'G632', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008043', '008', 'Pigna', 'G660', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008044', '008', 'Pompeiana', 'G814', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008045', '008', 'Pontedassio', 'G840', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008046', '008', 'Pornassio', 'G890', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008047', '008', 'Prelà', 'H027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008048', '008', 'Ranzo', 'H180', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008049', '008', 'Rezzo', 'H257', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008050', '008', 'Riva Ligure', 'H328', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008051', '008', 'Rocchetta Nervina', 'H460', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008052', '008', 'San Bartolomeo al Mare', 'H763', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008053', '008', 'San Biagio della Cima', 'H780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008054', '008', 'San Lorenzo al Mare', 'H957', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008055', '008', 'Sanremo', 'I138', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008056', '008', 'Santo Stefano al Mare', 'I365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008057', '008', 'Seborga', 'I556', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008058', '008', 'Soldano', 'I796', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008059', '008', 'Taggia', 'L024', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008060', '008', 'Terzorio', 'L146', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008061', '008', 'Triora', 'L430', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008062', '008', 'Vallebona', 'L596', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008063', '008', 'Vallecrosia', 'L599', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008064', '008', 'Vasia', 'L693', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008065', '008', 'Ventimiglia', 'L741', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008066', '008', 'Vessalico', 'L809', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008067', '008', 'Villa Faraldi', 'L943', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008068', '008', 'Montalto Carpasio', 'M387', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008801', '008', 'Arzeno d''Oneglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008802', '008', 'Bestagno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008803', '008', 'Borghetto San Nicolò', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008804', '008', 'Borgo Sant''Agata', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008805', '008', 'Boscomare', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008806', '008', 'Bussana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008807', '008', 'Candeasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008808', '008', 'Caramagna Ligure', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008809', '008', 'Cartari e Calderara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008810', '008', 'Castelvecchio di Santa Maria Maggiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008811', '008', 'Cenova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008812', '008', 'Col di Rodi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008813', '008', 'Conio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008814', '008', 'Costa d''Oneglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008815', '008', 'Diano Borello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008816', '008', 'Diano Calderina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008817', '008', 'Gazzelli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008818', '008', 'Lavina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008819', '008', 'Lingueglietta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008820', '008', 'Maro Castello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008821', '008', 'Mendatica Montegrosso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008822', '008', 'Moano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008823', '008', 'Moltedo Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008824', '008', 'Montegrazie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008825', '008', 'Olivastri', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008826', '008', 'Oneglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008827', '008', 'Pantasina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008828', '008', 'Pianavia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008829', '008', 'Piani', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008830', '008', 'Poggi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008831', '008', 'Riva Santo Stefano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008832', '008', 'San Lazzaro Reale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008833', '008', 'Sarola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008834', '008', 'Sasso di Bordighera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008835', '008', 'Tavole', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008836', '008', 'Torrazza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008837', '008', 'Torria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008838', '008', 'Ubaga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008839', '008', 'Valloria Marittima', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008840', '008', 'Villaguardia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008841', '008', 'Villatalla', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008842', '008', 'Villaviani', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008843', '008', 'Ville San Pietro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('008844', '008', 'Ville San Sebastiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009001', '009', 'Alassio', 'A122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009002', '009', 'Albenga', 'A145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009004', '009', 'Albisola Superiore', 'A166', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009003', '009', 'Albissola Marina', 'A165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009005', '009', 'Altare', 'A226', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009006', '009', 'Andora', 'A278', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009007', '009', 'Arnasco', 'A422', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009008', '009', 'Balestrino', 'A593', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009009', '009', 'Bardineto', 'A647', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009010', '009', 'Bergeggi', 'A796', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009011', '009', 'Boissano', 'A931', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009012', '009', 'Borghetto Santo Spirito', 'A999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009013', '009', 'Borgio Verezzi', 'B005', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009014', '009', 'Bormida', 'B048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009015', '009', 'Cairo Montenotte', 'B369', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009016', '009', 'Calice Ligure', 'B409', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009017', '009', 'Calizzano', 'B416', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009018', '009', 'Carcare', 'B748', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009019', '009', 'Casanova Lerrone', 'B927', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009020', '009', 'Castelbianco', 'C063', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009021', '009', 'Castelvecchio di Rocca Barbena', 'C276', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009022', '009', 'Celle Ligure', 'C443', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009023', '009', 'Cengio', 'C463', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009024', '009', 'Ceriale', 'C510', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009025', '009', 'Cisano sul Neva', 'C729', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009026', '009', 'Cosseria', 'D095', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009027', '009', 'Dego', 'D264', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009028', '009', 'Erli', 'D424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009029', '009', 'Finale Ligure', 'D600', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009030', '009', 'Garlenda', 'D927', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009031', '009', 'Giustenice', 'E064', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009032', '009', 'Giusvalla', 'E066', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009033', '009', 'Laigueglia', 'E414', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009034', '009', 'Loano', 'E632', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009035', '009', 'Magliolo', 'E816', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009036', '009', 'Mallare', 'E860', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009037', '009', 'Massimino', 'F046', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009038', '009', 'Millesimo', 'F213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009039', '009', 'Mioglia', 'F226', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009040', '009', 'Murialdo', 'F813', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009041', '009', 'Nasino', 'F847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009042', '009', 'Noli', 'F926', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009043', '009', 'Onzo', 'G076', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009044', '009', 'Orco Feglino', 'D522', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009045', '009', 'Ortovero', 'G144', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009046', '009', 'Osiglia', 'G155', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009047', '009', 'Pallare', 'G281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009048', '009', 'Piana Crixia', 'G542', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009049', '009', 'Pietra Ligure', 'G605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009050', '009', 'Plodio', 'G741', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009051', '009', 'Pontinvrea', 'G866', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009052', '009', 'Quiliano', 'H126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009053', '009', 'Rialto', 'H266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009054', '009', 'Roccavignale', 'H452', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009055', '009', 'Sassello', 'I453', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009056', '009', 'Savona', 'I480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009057', '009', 'Spotorno', 'I926', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009058', '009', 'Stella', 'I946', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009059', '009', 'Stellanello', 'I947', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009060', '009', 'Testico', 'L152', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009061', '009', 'Toirano', 'L190', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009062', '009', 'Tovo San Giacomo', 'L315', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009063', '009', 'Urbe', 'L499', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009064', '009', 'Vado Ligure', 'L528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009065', '009', 'Varazze', 'L675', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009066', '009', 'Vendone', 'L730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009067', '009', 'Vezzi Portio', 'L823', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009068', '009', 'Villanova d''Albenga', 'L975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009069', '009', 'Zuccarello', 'M197', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009801', '009', 'Bardino Nuovo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009802', '009', 'Bardino Vecchio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009803', '009', 'Biestro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009804', '009', 'Borgio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009805', '009', 'Brovida', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009806', '009', 'Cagna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009807', '009', 'Calvisio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009808', '009', 'Campochiesa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009809', '009', 'Carpe', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009810', '009', 'Carretto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009811', '009', 'Cenesi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009812', '009', 'Ellera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009813', '009', 'Finalborgo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009814', '009', 'Finale Marina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009815', '009', 'Finale Pia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009816', '009', 'Gorra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009817', '009', 'Lodisio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009818', '009', 'Martina Olba', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009819', '009', 'Olba', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009820', '009', 'Orco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009821', '009', 'Perti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009822', '009', 'Portio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009823', '009', 'Ranzi Pietra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009824', '009', 'Rocchetta Cairo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009825', '009', 'Rocchetta Cengio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009826', '009', 'Santa Giulia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009827', '009', 'Segno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009828', '009', 'Varigotti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009829', '009', 'Vellego', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009830', '009', 'Verezzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009831', '009', 'Verzi Pietra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('009832', '009', 'Vezzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010001', '010', 'Arenzano', 'A388', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010002', '010', 'Avegno', 'A506', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010003', '010', 'Bargagli', 'A658', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010004', '010', 'Bogliasco', 'A922', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010005', '010', 'Borzonasca', 'B067', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010006', '010', 'Busalla', 'B282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010007', '010', 'Camogli', 'B490', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010008', '010', 'Campo Ligure', 'B538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010009', '010', 'Campomorone', 'B551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010010', '010', 'Carasco', 'B726', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010011', '010', 'Casarza Ligure', 'B939', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010012', '010', 'Casella', 'B956', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010013', '010', 'Castiglione Chiavarese', 'C302', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010014', '010', 'Ceranesi', 'C481', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010015', '010', 'Chiavari', 'C621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010016', '010', 'Cicagna', 'C673', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010017', '010', 'Cogoleto', 'C823', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010018', '010', 'Cogorno', 'C826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010019', '010', 'Coreglia Ligure', 'C995', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010020', '010', 'Crocefieschi', 'D175', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010021', '010', 'Davagna', 'D255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010022', '010', 'Fascia', 'D509', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010023', '010', 'Favale di Malvaro', 'D512', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010024', '010', 'Fontanigorda', 'D677', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010025', '010', 'Genova', 'D969', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010026', '010', 'Gorreto', 'E109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010027', '010', 'Isola del Cantone', 'E341', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010028', '010', 'Lavagna', 'E488', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010029', '010', 'Leivi', 'E519', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010030', '010', 'Lorsica', 'E695', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010031', '010', 'Lumarzo', 'E737', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010032', '010', 'Masone', 'F020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010033', '010', 'Mele', 'F098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010034', '010', 'Mezzanego', 'F173', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010035', '010', 'Mignanego', 'F202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010036', '010', 'Moconesi', 'F256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010037', '010', 'Moneglia', 'F354', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010038', '010', 'Montebruno', 'F445', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010039', '010', 'Montoggio', 'F682', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010040', '010', 'Ne', 'F858', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010041', '010', 'Neirone', 'F862', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010042', '010', 'Orero', 'G093', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010043', '010', 'Pieve Ligure', 'G646', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010044', '010', 'Portofino', 'G913', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010045', '010', 'Propata', 'H073', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010046', '010', 'Rapallo', 'H183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010047', '010', 'Recco', 'H212', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010048', '010', 'Rezzoaglio', 'H258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010049', '010', 'Ronco Scrivia', 'H536', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010050', '010', 'Rondanina', 'H546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010051', '010', 'Rossiglione', 'H581', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010052', '010', 'Rovegno', 'H599', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010053', '010', 'San Colombano Certenoli', 'H802', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010054', '010', 'Santa Margherita Ligure', 'I225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010056', '010', 'Santo Stefano d''Aveto', 'I368', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010055', '010', 'Sant''Olcese', 'I346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010057', '010', 'Savignone', 'I475', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010058', '010', 'Serra Riccò', 'I640', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010059', '010', 'Sestri Levante', 'I693', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010060', '010', 'Sori', 'I852', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010061', '010', 'Tiglieto', 'L167', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010062', '010', 'Torriglia', 'L298', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010063', '010', 'Tribogna', 'L416', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010064', '010', 'Uscio', 'L507', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010065', '010', 'Valbrevenna', 'L546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010066', '010', 'Vobbia', 'M105', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010067', '010', 'Zoagli', 'M182', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010801', '010', 'Apparizione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010802', '010', 'Bavari', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010803', '010', 'Bogliasco Pieve', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010804', '010', 'Bolzaneto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010805', '010', 'Borzoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010806', '010', 'Canepa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010807', '010', 'Cornigliano Ligure', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010808', '010', 'Foce', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010809', '010', 'Marassi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010810', '010', 'Molassana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010811', '010', 'Multedo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010812', '010', 'Nervi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010813', '010', 'Pegli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010814', '010', 'Pontedecimo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010815', '010', 'Pra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010816', '010', 'Quarto dei Mille', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010817', '010', 'Quinto al Mare', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010818', '010', 'Rivarolo Ligure', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010819', '010', 'San Francesco d''Albaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010820', '010', 'San Fruttuoso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010821', '010', 'San Giovanni Battista', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010822', '010', 'San Martino d''Albaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010823', '010', 'San Pier d''Arena', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010824', '010', 'San Quirico in Val Polcevera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010825', '010', 'Sant''Ilario Ligure', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010826', '010', 'Sestri Ponente', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010827', '010', 'Staglieno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010828', '010', 'Struppa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('010829', '010', 'Voltri', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011001', '011', 'Ameglia', 'A261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011002', '011', 'Arcola', 'A373', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011003', '011', 'Beverino', 'A836', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011004', '011', 'Bolano', 'A932', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011005', '011', 'Bonassola', 'A961', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011006', '011', 'Borghetto di Vara', 'A992', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011007', '011', 'Brugnato', 'B214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011008', '011', 'Calice al Cornoviglio', 'B410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011009', '011', 'Carro', 'B838', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011010', '011', 'Carrodano', 'B839', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011011', '011', 'Castelnuovo Magra', 'C240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011012', '011', 'Deiva Marina', 'D265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011013', '011', 'Follo', 'D655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011014', '011', 'Framura', 'D758', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011015', '011', 'La Spezia', 'E463', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011016', '011', 'Lerici', 'E542', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011017', '011', 'Levanto', 'E560', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011018', '011', 'Maissana', 'E842', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011019', '011', 'Monterosso al Mare', 'F609', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011020', '011', 'Luni', 'G143', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011021', '011', 'Pignone', 'G664', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011022', '011', 'Portovenere', 'G925', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011023', '011', 'Riccò del Golfo di Spezia', 'H275', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011024', '011', 'Riomaggiore', 'H304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011025', '011', 'Rocchetta di Vara', 'H461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011026', '011', 'Santo Stefano di Magra', 'I363', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011027', '011', 'Sarzana', 'I449', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011028', '011', 'Sesta Godano', 'E070', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011029', '011', 'Varese Ligure', 'L681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011030', '011', 'Vernazza', 'L774', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011031', '011', 'Vezzano Ligure', 'L819', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011032', '011', 'Zignago', 'M177', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('011801', '011', 'Trebiano Magra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012001', '012', 'Agra', 'A085', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012002', '012', 'Albizzate', 'A167', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012003', '012', 'Angera', 'A290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012004', '012', 'Arcisate', 'A371', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012005', '012', 'Arsago Seprio', 'A441', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012006', '012', 'Azzate', 'A531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012007', '012', 'Azzio', 'A532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012008', '012', 'Barasso', 'A619', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012009', '012', 'Bardello', 'A645', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012010', '012', 'Bedero Valcuvia', 'A728', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012011', '012', 'Besano', 'A819', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012012', '012', 'Besnate', 'A825', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012013', '012', 'Besozzo', 'A826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012014', '012', 'Biandronno', 'A845', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012015', '012', 'Bisuschio', 'A891', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012016', '012', 'Bodio Lomnago', 'A918', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012017', '012', 'Brebbia', 'B126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012018', '012', 'Bregano', 'B131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012019', '012', 'Brenta', 'B150', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012020', '012', 'Brezzo di Bedero', 'B166', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012021', '012', 'Brinzio', 'B182', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012022', '012', 'Brissago-Valtravaglia', 'B191', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012023', '012', 'Brunello', 'B219', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012024', '012', 'Brusimpiano', 'B228', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012025', '012', 'Buguggiate', 'B258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012026', '012', 'Busto Arsizio', 'B300', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012027', '012', 'Cadegliano-Viconago', 'B326', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012028', '012', 'Cadrezzate', 'B347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012029', '012', 'Cairate', 'B368', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012030', '012', 'Cantello', 'B634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012031', '012', 'Caravate', 'B732', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012032', '012', 'Cardano al Campo', 'B754', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012033', '012', 'Carnago', 'B796', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012034', '012', 'Caronno Pertusella', 'B805', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012035', '012', 'Caronno Varesino', 'B807', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012036', '012', 'Casale Litta', 'B875', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012037', '012', 'Casalzuigno', 'B921', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012038', '012', 'Casciago', 'B949', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012039', '012', 'Casorate Sempione', 'B987', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012040', '012', 'Cassano Magnago', 'C004', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012041', '012', 'Cassano Valcuvia', 'B999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012042', '012', 'Castellanza', 'C139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012043', '012', 'Castello Cabiaglio', 'B312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012044', '012', 'Castelseprio', 'C273', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012045', '012', 'Castelveccana', 'C181', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012046', '012', 'Castiglione Olona', 'C300', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012047', '012', 'Castronno', 'C343', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012048', '012', 'Cavaria con Premezzo', 'C382', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012049', '012', 'Cazzago Brabbia', 'C409', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012050', '012', 'Cislago', 'C732', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012051', '012', 'Cittiglio', 'C751', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012052', '012', 'Clivio', 'C796', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012053', '012', 'Cocquio-Trevisago', 'C810', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012054', '012', 'Comabbio', 'C911', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012055', '012', 'Comerio', 'C922', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012056', '012', 'Cremenaga', 'D144', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012057', '012', 'Crosio della Valle', 'D185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012058', '012', 'Cuasso al Monte', 'D192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012059', '012', 'Cugliate-Fabiasco', 'D199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012060', '012', 'Cunardo', 'D204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012061', '012', 'Curiglia con Monteviasco', 'D217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012062', '012', 'Cuveglio', 'D238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012063', '012', 'Cuvio', 'D239', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012064', '012', 'Daverio', 'D256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012065', '012', 'Dumenza', 'D384', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012066', '012', 'Duno', 'D385', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012067', '012', 'Fagnano Olona', 'D467', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012068', '012', 'Ferno', 'D543', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012069', '012', 'Ferrera di Varese', 'D551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012070', '012', 'Gallarate', 'D869', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012071', '012', 'Galliate Lombardo', 'D871', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012072', '012', 'Gavirate', 'D946', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012073', '012', 'Gazzada Schianno', 'D951', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012074', '012', 'Gemonio', 'D963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012075', '012', 'Gerenzano', 'D981', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012076', '012', 'Germignaga', 'D987', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012077', '012', 'Golasecca', 'E079', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012078', '012', 'Gorla Maggiore', 'E101', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012079', '012', 'Gorla Minore', 'E102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012080', '012', 'Gornate Olona', 'E104', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012081', '012', 'Grantola', 'E144', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012082', '012', 'Inarzo', 'E292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012083', '012', 'Induno Olona', 'E299', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012084', '012', 'Ispra', 'E367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012085', '012', 'Jerago con Orago', 'E386', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012086', '012', 'Lavena Ponte Tresa', 'E494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012087', '012', 'Laveno-Mombello', 'E496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012088', '012', 'Leggiuno', 'E510', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012089', '012', 'Lonate Ceppino', 'E665', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012090', '012', 'Lonate Pozzolo', 'E666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012091', '012', 'Lozza', 'E707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012092', '012', 'Luino', 'E734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012093', '012', 'Luvinate', 'E769', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012094', '012', 'Maccagno', 'E775', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012095', '012', 'Malgesso', 'E856', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012096', '012', 'Malnate', 'E863', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012097', '012', 'Marchirolo', 'E929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012098', '012', 'Marnate', 'E965', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012099', '012', 'Marzio', 'F002', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012100', '012', 'Masciago Primo', 'F007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012101', '012', 'Mercallo', 'F134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012102', '012', 'Mesenzana', 'F154', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012103', '012', 'Montegrino Valtravaglia', 'F526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012104', '012', 'Monvalle', 'F703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012105', '012', 'Morazzone', 'F711', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012106', '012', 'Mornago', 'F736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012107', '012', 'Oggiona con Santo Stefano', 'G008', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012108', '012', 'Olgiate Olona', 'G028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012109', '012', 'Origgio', 'G103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012110', '012', 'Orino', 'G105', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012111', '012', 'Osmate', 'E529', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012112', '012', 'Pino sulla Sponda del Lago Maggiore', 'G677', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012113', '012', 'Porto Ceresio', 'G906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012114', '012', 'Porto Valtravaglia', 'G907', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012115', '012', 'Rancio Valcuvia', 'H173', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012116', '012', 'Ranco', 'H174', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012117', '012', 'Saltrio', 'H723', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012118', '012', 'Samarate', 'H736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012141', '012', 'Sangiano', 'H872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012119', '012', 'Saronno', 'I441', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012120', '012', 'Sesto Calende', 'I688', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012121', '012', 'Solbiate Arno', 'I793', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012122', '012', 'Solbiate Olona', 'I794', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012123', '012', 'Somma Lombardo', 'I819', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012124', '012', 'Sumirago', 'L003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012125', '012', 'Taino', 'L032', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012126', '012', 'Ternate', 'L115', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012127', '012', 'Tradate', 'L319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012128', '012', 'Travedona-Monate', 'L342', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012129', '012', 'Tronzano Lago Maggiore', 'A705', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012130', '012', 'Uboldo', 'L480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012131', '012', 'Valganna', 'L577', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012132', '012', 'Varano Borghi', 'L671', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012133', '012', 'Varese', 'L682', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012134', '012', 'Vedano Olona', 'L703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012135', '012', 'Veddasca', 'L705', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012136', '012', 'Venegono Inferiore', 'L733', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012137', '012', 'Venegono Superiore', 'L734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012138', '012', 'Vergiate', 'L765', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012139', '012', 'Viggiù', 'L876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012140', '012', 'Vizzola Ticino', 'M101', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012142', '012', 'Maccagno con Pino e Veddasca', 'M339', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012801', '012', 'Abbiateguazzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012802', '012', 'Albusciago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012803', '012', 'Arbizzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012804', '012', 'Arcumeggia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012805', '012', 'Ardena', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012806', '012', 'Armio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012807', '012', 'Arnate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012808', '012', 'Arolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012809', '012', 'Ballarate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012810', '012', 'Barza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012811', '012', 'Barzola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012812', '012', 'Biegno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012813', '012', 'Bizzozero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012814', '012', 'Bobbiate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012815', '012', 'Bodio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012816', '012', 'Bogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012817', '012', 'Bolladello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012818', '012', 'Borsano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012819', '012', 'Bosco Valtravaglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012820', '012', 'Brenno Useria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012821', '012', 'Brissago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012822', '012', 'Cadegliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012823', '012', 'Cadero con Graglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012824', '012', 'Caidate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012825', '012', 'Cajello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012826', '012', 'Campagnano Vedasca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012827', '012', 'Capolago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012828', '012', 'Capronno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012829', '012', 'Cardana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012830', '012', 'Caronno Corbellaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012831', '012', 'Cassina Ferrara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012832', '012', 'Cassina Pertusella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012833', '012', 'Cassina Verghera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012834', '012', 'Castegnate Olona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012835', '012', 'Castelnovate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012836', '012', 'Cavona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012837', '012', 'Cedrate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012838', '012', 'Celina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012839', '012', 'Cerro Lago Maggiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012840', '012', 'Cimbro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012841', '012', 'Cocquio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012842', '012', 'Corgeno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012843', '012', 'Crenna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012844', '012', 'Crugnola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012845', '012', 'Cugliate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012846', '012', 'Cuveglio in Valle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012847', '012', 'Cuvirone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012848', '012', 'Due Cossani', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012849', '012', 'Fabiasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012850', '012', 'Garabiolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012851', '012', 'Gazzada', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012852', '012', 'Gornate-Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012853', '012', 'Gurone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012854', '012', 'Jerago con Besnate ed Orago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012855', '012', 'Laveno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012856', '012', 'Lisanza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012857', '012', 'Lissago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012858', '012', 'Lozzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012859', '012', 'Maccagno Inferiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012860', '012', 'Masnago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012861', '012', 'Menzago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012862', '012', 'Mezzana Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012863', '012', 'Mombello Lago Maggiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012864', '012', 'Monate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012865', '012', 'Montanate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012866', '012', 'Montegrino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012867', '012', 'Monteviasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012868', '012', 'Morosolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012869', '012', 'Muceno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012870', '012', 'Musadino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012871', '012', 'Musignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012872', '012', 'Nizzolina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012873', '012', 'Olginasio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012874', '012', 'Oltrona al Lago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012875', '012', 'Oriano Sopra Ticino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012876', '012', 'Orino-Azzio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012877', '012', 'Peveranza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012878', '012', 'Premezzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012879', '012', 'Prospiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012880', '012', 'Quinzano San Pietro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012881', '012', 'Roggiano Valtravaglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012882', '012', 'Rovate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012883', '012', 'Runo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012884', '012', 'Sacconago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012885', '012', 'San Pancrazio al Colle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012886', '012', 'Sant’Ambrogio Olona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012887', '012', 'Sant’Antonino Ticino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012888', '012', 'Santa Maria del Monte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012889', '012', 'Schianno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012890', '012', 'Sesona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012891', '012', 'Solbiate sull’Arno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012892', '012', 'Torba', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012893', '012', 'Tornavento', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012894', '012', 'Travedona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012895', '012', 'Trevisago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012896', '012', 'Vararo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012897', '012', 'Veccana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012898', '012', 'Velate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012899', '012', 'Venegono', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012900', '012', 'Vergobbio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012901', '012', 'Viconago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012902', '012', 'Villa Dosia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012903', '012', 'Vinago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012904', '012', 'Voldomino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('012905', '012', 'Voltore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013003', '013', 'Albavilla', 'A143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013004', '013', 'Albese con Cassano', 'A153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013005', '013', 'Albiolo', 'A164', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013006', '013', 'Alserio', 'A224', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013007', '013', 'Alzate Brianza', 'A249', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013009', '013', 'Anzano del Parco', 'A319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013010', '013', 'Appiano Gentile', 'A333', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013011', '013', 'Argegno', 'A391', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013012', '013', 'Arosio', 'A430', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013013', '013', 'Asso', 'A476', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013015', '013', 'Barni', 'A670', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013019', '013', 'Bellagio', 'A744', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013021', '013', 'Bene Lario', 'A778', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013022', '013', 'Beregazzo con Figliaro', 'A791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013023', '013', 'Binago', 'A870', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013024', '013', 'Bizzarone', 'A898', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013025', '013', 'Blessagno', 'A904', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013026', '013', 'Blevio', 'A905', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013028', '013', 'Bregnano', 'B134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013029', '013', 'Brenna', 'B144', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013030', '013', 'Brienno', 'B172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013032', '013', 'Brunate', 'B218', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013034', '013', 'Bulgarograsso', 'B262', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013035', '013', 'Cabiate', 'B313', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013036', '013', 'Cadorago', 'B346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013037', '013', 'Caglio', 'B355', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013038', '013', 'Cagno', 'B359', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013040', '013', 'Campione d''Italia', 'B513', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013041', '013', 'Cantù', 'B639', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013042', '013', 'Canzo', 'B641', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013043', '013', 'Capiago Intimiano', 'B653', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013044', '013', 'Carate Urio', 'B730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013045', '013', 'Carbonate', 'B742', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013046', '013', 'Carimate', 'B778', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013047', '013', 'Carlazzo', 'B785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013048', '013', 'Carugo', 'B851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013050', '013', 'Casasco d''Intelvi', 'B942', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013052', '013', 'Caslino d''Erba', 'B974', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013053', '013', 'Casnate con Bernate', 'B977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013055', '013', 'Cassina Rizzardi', 'C020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013058', '013', 'Castelmarte', 'C206', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013059', '013', 'Castelnuovo Bozzente', 'C220', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013060', '013', 'Castiglione d''Intelvi', 'C299', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013061', '013', 'Cavallasca', 'C374', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013062', '013', 'Cavargna', 'C381', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013063', '013', 'Cerano d''Intelvi', 'C482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013064', '013', 'Cermenate', 'C516', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013065', '013', 'Cernobbio', 'C520', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013068', '013', 'Cirimido', 'C724', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013070', '013', 'Civenna', 'C754', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013071', '013', 'Claino con Osteno', 'C787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013074', '013', 'Colonno', 'C902', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013075', '013', 'Como', 'C933', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013076', '013', 'Consiglio di Rumo', 'C965', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013077', '013', 'Corrido', 'D041', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013083', '013', 'Cremia', 'D147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013084', '013', 'Cucciago', 'D196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013085', '013', 'Cusino', 'D232', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013087', '013', 'Dizzasco', 'D310', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013089', '013', 'Domaso', 'D329', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013090', '013', 'Dongo', 'D341', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013092', '013', 'Dosso del Liro', 'D355', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013093', '013', 'Drezzo', 'D369', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013095', '013', 'Erba', 'D416', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013097', '013', 'Eupilio', 'D445', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013098', '013', 'Faggeto Lario', 'D462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013099', '013', 'Faloppio', 'D482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013100', '013', 'Fenegrò', 'D531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013101', '013', 'Figino Serenza', 'D579', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013102', '013', 'Fino Mornasco', 'D605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013106', '013', 'Garzeno', 'D930', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013107', '013', 'Gera Lario', 'D974', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013108', '013', 'Germasino', 'D986', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013109', '013', 'Gironico', 'E051', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013110', '013', 'Grandate', 'E139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013111', '013', 'Grandola ed Uniti', 'E141', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013112', '013', 'Gravedona', 'E151', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013113', '013', 'Griante', 'E172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013114', '013', 'Guanzate', 'E235', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013118', '013', 'Inverigo', 'E309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013119', '013', 'Laglio', 'E405', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013120', '013', 'Laino', 'E416', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013121', '013', 'Lambrugo', 'E428', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013122', '013', 'Lanzo d''Intelvi', 'E444', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013123', '013', 'Lasnigo', 'E462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013125', '013', 'Lenno', 'E525', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013126', '013', 'Lezzeno', 'E569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013128', '013', 'Limido Comasco', 'E593', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013129', '013', 'Lipomo', 'E607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013130', '013', 'Livo', 'E623', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013131', '013', 'Locate Varesino', 'E638', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013133', '013', 'Lomazzo', 'E659', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013134', '013', 'Longone al Segrino', 'E679', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013135', '013', 'Luisago', 'E735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013136', '013', 'Lurago d''Erba', 'E749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013137', '013', 'Lurago Marinone', 'E750', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013138', '013', 'Lurate Caccivio', 'E753', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013139', '013', 'Magreglio', 'E830', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013143', '013', 'Mariano Comense', 'E951', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013144', '013', 'Maslianico', 'F017', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013145', '013', 'Menaggio', 'F120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013147', '013', 'Merone', 'F151', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013148', '013', 'Mezzegra', 'F181', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013152', '013', 'Moltrasio', 'F305', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013153', '013', 'Monguzzo', 'F372', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013154', '013', 'Montano Lucino', 'F427', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013155', '013', 'Montemezzo', 'F564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013157', '013', 'Montorfano', 'F688', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013159', '013', 'Mozzate', 'F788', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013160', '013', 'Musso', 'F828', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013161', '013', 'Nesso', 'F877', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013163', '013', 'Novedrate', 'F958', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013165', '013', 'Olgiate Comasco', 'G025', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013169', '013', 'Oltrona di San Mamette', 'G056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013170', '013', 'Orsenigo', 'G126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013172', '013', 'Ossuccio', 'G182', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013175', '013', 'Parè', 'G329', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013178', '013', 'Peglio', 'G415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013179', '013', 'Pellio Intelvi', 'G427', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013183', '013', 'Pianello del Lario', 'G556', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013184', '013', 'Pigra', 'G665', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013185', '013', 'Plesio', 'G737', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013186', '013', 'Pognana Lario', 'G773', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013187', '013', 'Ponna', 'G821', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013188', '013', 'Ponte Lambro', 'G847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013189', '013', 'Porlezza', 'G889', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013192', '013', 'Proserpio', 'H074', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013193', '013', 'Pusiano', 'H094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013194', '013', 'Ramponio Verna', 'H171', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013195', '013', 'Rezzago', 'H255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013197', '013', 'Rodero', 'H478', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013199', '013', 'Ronago', 'H521', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013201', '013', 'Rovellasca', 'H601', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013202', '013', 'Rovello Porro', 'H602', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013203', '013', 'Sala Comacina', 'H679', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013204', '013', 'San Bartolomeo Val Cavargna', 'H760', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013205', '013', 'San Fedele Intelvi', 'H830', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013206', '013', 'San Fermo della Battaglia', 'H840', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013207', '013', 'San Nazzaro Val Cavargna', 'I051', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013248', '013', 'San Siro', 'I162', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013211', '013', 'Schignano', 'I529', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013212', '013', 'Senna Comasco', 'I611', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013215', '013', 'Solbiate', 'I792', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013216', '013', 'Sorico', 'I856', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013217', '013', 'Sormano', 'I860', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013218', '013', 'Stazzona', 'I943', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013222', '013', 'Tavernerio', 'L071', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013223', '013', 'Torno', 'L228', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013225', '013', 'Tremezzo', 'L371', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013226', '013', 'Trezzone', 'L413', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013227', '013', 'Turate', 'L470', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013228', '013', 'Uggiate-Trevano', 'L487', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013233', '013', 'Val Rezzo', 'H259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013229', '013', 'Valbrona', 'L547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013232', '013', 'Valmorea', 'L640', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013234', '013', 'Valsolda', 'C936', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013236', '013', 'Veleso', 'L715', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013238', '013', 'Veniano', 'L737', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013239', '013', 'Vercana', 'L748', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013242', '013', 'Vertemate con Minoprio', 'L792', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013245', '013', 'Villa Guardia', 'L956', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013246', '013', 'Zelbio', 'M156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013253', '013', 'Alta Valle Intelvi', 'M383', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013249', '013', 'Gravedona ed Uniti', 'M315', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013250', '013', 'Bellagio', 'M335', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013251', '013', 'Colverde', 'M336', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013252', '013', 'Tremezzina', 'M341', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013254', '013', 'Centro Valle Intelvi', 'M394', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013208', '013', 'Sant''Abbondio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013210', '013', 'Santa Maria Rezzonico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013801', '013', 'Abbadia Sopra Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013802', '013', 'Acquate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013803', '013', 'Aizurro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013804', '013', 'Albate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013805', '013', 'Albese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013806', '013', 'Albogasio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013807', '013', 'Arcellasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013808', '013', 'Asnago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013809', '013', 'Bagaggera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013810', '013', 'Baiedo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013811', '013', 'Ballabio Inferiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013812', '013', 'Ballabio Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013813', '013', 'Barcone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013814', '013', 'Bartesate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013815', '013', 'Belledo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013816', '013', 'Bernaga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013817', '013', 'Bernate Rosales', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013818', '013', 'Biglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013819', '013', 'Bindo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013820', '013', 'Breccia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013821', '013', 'Breglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013822', '013', 'Brenno della Torre', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013823', '013', 'Brianzola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013824', '013', 'Buccinigo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013825', '013', 'Buggiolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013826', '013', 'Bugiallo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013827', '013', 'Bulgorello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013828', '013', 'Cagliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013829', '013', 'Camerlata', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013830', '013', 'Camnago Faloppia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013831', '013', 'Camnago Volta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013832', '013', 'Capiago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013833', '013', 'Capiate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013834', '013', 'Carate Lario', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013835', '013', 'Carcano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013836', '013', 'Carella con Mariaga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013837', '013', 'Careno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013838', '013', 'Carlazzo Valsolda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013839', '013', 'Carugo Arosio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013840', '013', 'Casanova Lanza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013841', '013', 'Casirago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013842', '013', 'Casletto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013843', '013', 'Caslino al Piano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013844', '013', 'Casnate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013845', '013', 'Cassago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013846', '013', 'Cassano Albese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013847', '013', 'Cassina de'' Bracchi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013848', '013', 'Cassina Mariaga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013849', '013', 'Castello Sopra Lecco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013850', '013', 'Castello Valsolda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013851', '013', 'Caversaccio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013852', '013', 'Centemero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013853', '013', 'Cereda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013854', '013', 'Cernusco Montevecchia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013855', '013', 'Cesello Brianza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013856', '013', 'Chiuso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013857', '013', 'Cima', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013858', '013', 'Civello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013859', '013', 'Civiglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013860', '013', 'Colciago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013861', '013', 'Cologna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013862', '013', 'Concenedo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013863', '013', 'Consonno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013864', '013', 'Contra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013865', '013', 'Corenno Plinio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013866', '013', 'Cortabbio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013867', '013', 'Cremnago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013868', '013', 'Cressogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013869', '013', 'Crevenna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013870', '013', 'Croce', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013871', '013', 'Dasio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013872', '013', 'Dozio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013873', '013', 'Drano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013874', '013', 'Erba Incino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013875', '013', 'Esino Inferiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013876', '013', 'Esino Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013877', '013', 'Fabbrica Durini', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013878', '013', 'Gaggino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013879', '013', 'Germanedo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013880', '013', 'Gottro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013881', '013', 'Grandola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013882', '013', 'Grona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013883', '013', 'Imberido', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013884', '013', 'Incino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013885', '013', 'Indovero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013886', '013', 'Intimiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013887', '013', 'Isola Comacina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013888', '013', 'Laorca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013889', '013', 'Lemna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013890', '013', 'Lezza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013891', '013', 'Lieto Colle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013892', '013', 'Limonta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013893', '013', 'Linzanico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013894', '013', 'Lomaniga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013895', '013', 'Loveno Sopra Menaggio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013896', '013', 'Lucino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013897', '013', 'Maccio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013898', '013', 'Maggianico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013899', '013', 'Minoprio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013900', '013', 'Mirabello Comasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013901', '013', 'Moiana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013902', '013', 'Molina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013903', '013', 'Mondonico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013904', '013', 'Montano Comasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013905', '013', 'Monte Olimpino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013906', '013', 'Nava', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013907', '013', 'Novate Brianza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013908', '013', 'Olate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013909', '013', 'Olcio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013910', '013', 'Onno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013911', '013', 'Oriano di Brianza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013912', '013', 'Pagnano Valsassina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013913', '013', 'Palanzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013914', '013', 'Parravicino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013915', '013', 'Penzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013916', '013', 'Pessina Valsassina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013917', '013', 'Piano Porlezza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013918', '013', 'Piazza Santo Stefano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013919', '013', 'Ponte Lambro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013920', '013', 'Ponzate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013921', '013', 'Puria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013922', '013', 'Ramponio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013923', '013', 'Rancio di Lecco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013924', '013', 'Ravellino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013925', '013', 'Rebbio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013926', '013', 'Rezzonico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013927', '013', 'Romanò Brianza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013928', '013', 'Rongio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013929', '013', 'Rovenna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013930', '013', 'Sabbioncello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013931', '013', 'Sala al Barro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013932', '013', 'San Bartolomeo al Bosco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013933', '013', 'San Giovanni alla Castagna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013934', '013', 'San Siro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013935', '013', 'Santa Maria di Rovagnate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013936', '013', 'Santa Valeria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013937', '013', 'Sartirana Briantea', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013938', '013', 'Scarenna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013939', '013', 'Scaria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013940', '013', 'Seghebbia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013941', '013', 'Seprio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013942', '013', 'Solzago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013943', '013', 'Somana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013944', '013', 'Stazzona Germasino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013945', '013', 'Tavordo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013946', '013', 'Traversa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013947', '013', 'Tregolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013948', '013', 'Tremezzina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013949', '013', 'Trevano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013950', '013', 'Uggiate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013951', '013', 'Urio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013952', '013', 'Vassena', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013953', '013', 'Verderio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013954', '013', 'Verna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013955', '013', 'Vertemate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013956', '013', 'Vill’Albese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013957', '013', 'Villa Romanò', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013958', '013', 'Villa Vergano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013959', '013', 'Vimogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013960', '013', 'Visino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('013961', '013', 'Zelbio-Veleso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014001', '014', 'Albaredo per San Marco', 'A135', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014002', '014', 'Albosaggia', 'A172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014003', '014', 'Andalo Valtellino', 'A273', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014004', '014', 'Aprica', 'A337', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014005', '014', 'Ardenno', 'A382', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014006', '014', 'Bema', 'A777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014007', '014', 'Berbenno di Valtellina', 'A787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014008', '014', 'Bianzone', 'A848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014009', '014', 'Bormio', 'B049', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014010', '014', 'Buglio in Monte', 'B255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014011', '014', 'Caiolo', 'B366', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014012', '014', 'Campodolcino', 'B530', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014013', '014', 'Caspoggio', 'B993', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014014', '014', 'Castello dell''Acqua', 'C186', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014015', '014', 'Castione Andevenno', 'C325', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014016', '014', 'Cedrasco', 'C418', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014017', '014', 'Cercino', 'C493', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014018', '014', 'Chiavenna', 'C623', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014019', '014', 'Chiesa in Valmalenco', 'C628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014020', '014', 'Chiuro', 'C651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014021', '014', 'Cino', 'C709', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014022', '014', 'Civo', 'C785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014023', '014', 'Colorina', 'C903', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014024', '014', 'Cosio Valtellino', 'D088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014025', '014', 'Dazio', 'D258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014026', '014', 'Delebio', 'D266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014027', '014', 'Dubino', 'D377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014028', '014', 'Faedo Valtellino', 'D456', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014029', '014', 'Forcola', 'D694', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014030', '014', 'Fusine', 'D830', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014031', '014', 'Gerola Alta', 'D990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014032', '014', 'Gordona', 'E090', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014033', '014', 'Grosio', 'E200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014034', '014', 'Grosotto', 'E201', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014036', '014', 'Lanzada', 'E443', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014037', '014', 'Livigno', 'E621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014038', '014', 'Lovero', 'E705', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014035', '014', 'Madesimo', 'E342', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014039', '014', 'Mantello', 'E896', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014040', '014', 'Mazzo di Valtellina', 'F070', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014041', '014', 'Mello', 'F115', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014042', '014', 'Menarola', 'F121', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014043', '014', 'Mese', 'F153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014044', '014', 'Montagna in Valtellina', 'F393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014045', '014', 'Morbegno', 'F712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014046', '014', 'Novate Mezzola', 'F956', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014047', '014', 'Pedesina', 'G410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014048', '014', 'Piantedo', 'G572', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014049', '014', 'Piateda', 'G576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014050', '014', 'Piuro', 'G718', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014051', '014', 'Poggiridenti', 'G431', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014052', '014', 'Ponte in Valtellina', 'G829', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014053', '014', 'Postalesio', 'G937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014054', '014', 'Prata Camportaccio', 'G993', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014055', '014', 'Rasura', 'H192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014056', '014', 'Rogolo', 'H493', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014057', '014', 'Samolaco', 'H752', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014058', '014', 'San Giacomo Filippo', 'H868', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014059', '014', 'Sernio', 'I636', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014060', '014', 'Sondalo', 'I828', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014061', '014', 'Sondrio', 'I829', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014062', '014', 'Spriana', 'I928', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014063', '014', 'Talamona', 'L035', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014064', '014', 'Tartano', 'L056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014065', '014', 'Teglio', 'L084', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014066', '014', 'Tirano', 'L175', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014067', '014', 'Torre di Santa Maria', 'L244', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014068', '014', 'Tovo di Sant''Agata', 'L316', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014069', '014', 'Traona', 'L330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014070', '014', 'Tresivio', 'L392', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014074', '014', 'Val Masino', 'L638', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014071', '014', 'Valdidentro', 'L557', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014072', '014', 'Valdisotto', 'L563', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014073', '014', 'Valfurva', 'L576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014075', '014', 'Verceia', 'L749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014076', '014', 'Vervio', 'L799', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014077', '014', 'Villa di Chiavenna', 'L907', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014078', '014', 'Villa di Tirano', 'L908', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014801', '014', 'Acqua', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014802', '014', 'Boffetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('014803', '014', 'Campovico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015002', '015', 'Abbiategrasso', 'A010', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015005', '015', 'Albairate', 'A127', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015007', '015', 'Arconate', 'A375', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015009', '015', 'Arese', 'A389', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015010', '015', 'Arluno', 'A413', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015011', '015', 'Assago', 'A473', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015250', '015', 'Baranzate', 'A618', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015012', '015', 'Bareggio', 'A652', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015014', '015', 'Basiano', 'A697', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015015', '015', 'Basiglio', 'A699', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015016', '015', 'Bellinzago Lombardo', 'A751', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015019', '015', 'Bernate Ticino', 'A804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015022', '015', 'Besate', 'A820', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015024', '015', 'Binasco', 'A872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015026', '015', 'Boffalora sopra Ticino', 'A920', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015027', '015', 'Bollate', 'A940', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015032', '015', 'Bresso', 'B162', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015035', '015', 'Bubbiano', 'B235', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015036', '015', 'Buccinasco', 'B240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015038', '015', 'Buscate', 'B286', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015040', '015', 'Bussero', 'B292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015041', '015', 'Busto Garolfo', 'B301', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015042', '015', 'Calvignasco', 'B448', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015044', '015', 'Cambiago', 'B461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015046', '015', 'Canegrate', 'B593', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015050', '015', 'Carpiano', 'B820', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015051', '015', 'Carugate', 'B850', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015055', '015', 'Casarile', 'B938', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015058', '015', 'Casorezzo', 'B989', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015059', '015', 'Cassano d''Adda', 'C003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015060', '015', 'Cassina de'' Pecchi', 'C014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015061', '015', 'Cassinetta di Lugagnano', 'C033', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015062', '015', 'Castano Primo', 'C052', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015070', '015', 'Cernusco sul Naviglio', 'C523', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015071', '015', 'Cerro al Lambro', 'C536', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015072', '015', 'Cerro Maggiore', 'C537', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015074', '015', 'Cesano Boscone', 'C565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015076', '015', 'Cesate', 'C569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015077', '015', 'Cinisello Balsamo', 'C707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015078', '015', 'Cisliano', 'C733', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015081', '015', 'Cologno Monzese', 'C895', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015082', '015', 'Colturano', 'C908', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015085', '015', 'Corbetta', 'C986', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015086', '015', 'Cormano', 'D013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015087', '015', 'Cornaredo', 'D018', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015093', '015', 'Corsico', 'D045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015096', '015', 'Cuggiono', 'D198', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015097', '015', 'Cusago', 'D229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015098', '015', 'Cusano Milanino', 'D231', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015099', '015', 'Dairago', 'D244', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015101', '015', 'Dresano', 'D367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015103', '015', 'Gaggiano', 'D845', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015105', '015', 'Garbagnate Milanese', 'D912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015106', '015', 'Gessate', 'D995', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015108', '015', 'Gorgonzola', 'E094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015110', '015', 'Grezzago', 'E170', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015112', '015', 'Gudo Visconti', 'E258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015113', '015', 'Inveruno', 'E313', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015114', '015', 'Inzago', 'E317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015115', '015', 'Lacchiarella', 'E395', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015116', '015', 'Lainate', 'E415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015118', '015', 'Legnano', 'E514', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015122', '015', 'Liscate', 'E610', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015125', '015', 'Locate di Triulzi', 'E639', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015130', '015', 'Magenta', 'E801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015131', '015', 'Magnago', 'E819', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015134', '015', 'Marcallo con Casone', 'E921', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015136', '015', 'Masate', 'F003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015139', '015', 'Mediglia', 'F084', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015140', '015', 'Melegnano', 'F100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015142', '015', 'Melzo', 'F119', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015144', '015', 'Mesero', 'F155', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015146', '015', 'Milano', 'F205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015150', '015', 'Morimondo', 'D033', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015151', '015', 'Motta Visconti', 'F783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015154', '015', 'Nerviano', 'F874', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015155', '015', 'Nosate', 'F939', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015157', '015', 'Novate Milanese', 'F955', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015158', '015', 'Noviglio', 'F968', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015159', '015', 'Opera', 'G078', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015164', '015', 'Ossona', 'G181', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015165', '015', 'Ozzero', 'G206', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015166', '015', 'Paderno Dugnano', 'G220', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015167', '015', 'Pantigliate', 'G316', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015168', '015', 'Parabiago', 'G324', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015169', '015', 'Paullo', 'G385', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015170', '015', 'Pero', 'C013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015171', '015', 'Peschiera Borromeo', 'G488', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015172', '015', 'Pessano con Bornago', 'G502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015173', '015', 'Pieve Emanuele', 'G634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015175', '015', 'Pioltello', 'G686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015176', '015', 'Pogliano Milanese', 'G772', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015177', '015', 'Pozzo d''Adda', 'G955', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015178', '015', 'Pozzuolo Martesana', 'G965', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015179', '015', 'Pregnana Milanese', 'H026', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015181', '015', 'Rescaldina', 'H240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015182', '015', 'Rho', 'H264', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015183', '015', 'Robecchetto con Induno', 'H371', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015184', '015', 'Robecco sul Naviglio', 'H373', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015185', '015', 'Rodano', 'H470', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015188', '015', 'Rosate', 'H560', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015189', '015', 'Rozzano', 'H623', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015191', '015', 'San Colombano al Lambro', 'H803', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015192', '015', 'San Donato Milanese', 'H827', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015194', '015', 'San Giorgio su Legnano', 'H884', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015195', '015', 'San Giuliano Milanese', 'H930', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015201', '015', 'San Vittore Olona', 'I409', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015202', '015', 'San Zenone al Lambro', 'I415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015200', '015', 'Santo Stefano Ticino', 'I361', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015204', '015', 'Sedriano', 'I566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015205', '015', 'Segrate', 'I577', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015206', '015', 'Senago', 'I602', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015209', '015', 'Sesto San Giovanni', 'I690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015210', '015', 'Settala', 'I696', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015211', '015', 'Settimo Milanese', 'I700', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015213', '015', 'Solaro', 'I786', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015219', '015', 'Trezzano Rosa', 'L408', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015220', '015', 'Trezzano sul Naviglio', 'L409', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015221', '015', 'Trezzo sull''Adda', 'L411', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015222', '015', 'Tribiano', 'L415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015224', '015', 'Truccazzano', 'L454', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015226', '015', 'Turbigo', 'L471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015249', '015', 'Vanzaghello', 'L664', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015229', '015', 'Vanzago', 'L665', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015230', '015', 'Vaprio d''Adda', 'L667', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015235', '015', 'Vermezzo', 'L768', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015236', '015', 'Vernate', 'L773', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015237', '015', 'Vignate', 'L883', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015248', '015', 'Villa Cortese', 'L928', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015242', '015', 'Vimodrone', 'M053', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015243', '015', 'Vittuone', 'M091', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015244', '015', 'Vizzolo Predabissi', 'M102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015246', '015', 'Zelo Surrigone', 'M160', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015247', '015', 'Zibido San Giacomo', 'M176', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015801', '015', 'Affori', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015802', '015', 'Agliate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015803', '015', 'Arcagna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015804', '015', 'Baggio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015805', '015', 'Balsamo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015806', '015', 'Baranzate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015807', '015', 'Barate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015808', '015', 'Barbajana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015809', '015', 'Bargano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015810', '015', 'Bestazzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015811', '015', 'Bienate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015812', '015', 'Binzago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015813', '015', 'Birago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015814', '015', 'Bisentrate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015815', '015', 'Boldinasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015816', '015', 'Bolgiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015817', '015', 'Bonirola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015818', '015', 'Bornago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015819', '015', 'Bottedo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015820', '015', 'Briavacca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015821', '015', 'Brusuglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015822', '015', 'Bruzzano dei Due Borghi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015823', '015', 'Bustighera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015824', '015', 'Ca'' de'' Mazzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015825', '015', 'Ca'' de'' Zecchi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015826', '015', 'Ca'' dei Bolli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015827', '015', 'Ca'' dell''Acqua', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015828', '015', 'Calò', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015829', '015', 'Campolungo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015830', '015', 'Capriano di Brianza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015831', '015', 'Caselle d''Ozero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015832', '015', 'Casirate Olona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015833', '015', 'Casolate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015834', '015', 'Casone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015835', '015', 'Cassina Aliprandi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015836', '015', 'Cassina Amata', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015837', '015', 'Cassina Baraggia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015838', '015', 'Cassina de'' Gatti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015839', '015', 'Cassina Nuova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015840', '015', 'Cassina Pobbia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015841', '015', 'Cassina Savina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015842', '015', 'Cassina Triulza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015843', '015', 'Cassino d''Alberi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015844', '015', 'Castellazzo de'' Barzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015845', '015', 'Castelletto Mendosio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015846', '015', 'Castiraga da Reggio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015847', '015', 'Cavaione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015848', '015', 'Caviaga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015849', '015', 'Cazzano Besana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015850', '015', 'Ceppeda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015851', '015', 'Cerchiate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015852', '015', 'Chiaravalle Milanese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015853', '015', 'Chiosi d''Adda Vigadore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015854', '015', 'Chiosi di Porta Cremonese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015855', '015', 'Chiosi di Porta d''Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015856', '015', 'Chiosi di Porta Regale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015857', '015', 'Chiosi Uniti con Bottedo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015858', '015', 'Cinisello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015859', '015', 'Coazzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015860', '015', 'Colnago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015861', '015', 'Colzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015862', '015', 'Concesa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015863', '015', 'Copreno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015864', '015', 'Corneliano Bertario', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015865', '015', 'Corpi Santi di Milano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015866', '015', 'Corte Sant''Andrea', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015867', '015', 'Costa al Lambro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015868', '015', 'Crescenzago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015869', '015', 'Dergano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015870', '015', 'Dugnano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015871', '015', 'Fagnano sul Naviglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015872', '015', 'Figino di Milano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015873', '015', 'Furato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015874', '015', 'Garbatola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015875', '015', 'Garegnano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015876', '015', 'Gattera Maiocca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015877', '015', 'Gorlaprecotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015878', '015', 'Grancino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015879', '015', 'Grazzanello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015880', '015', 'Greco Milanese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015881', '015', 'Groppello d''Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015882', '015', 'Guazzina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015883', '015', 'Gugnano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015884', '015', 'Incirano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015885', '015', 'Induno Ticino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015886', '015', 'Isola Balba', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015887', '015', 'Lambrate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015888', '015', 'Lardera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015889', '015', 'Limito', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015890', '015', 'Linate al Lambro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015891', '015', 'Lucernate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015892', '015', 'Marcallo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015893', '015', 'Masciago Milanese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015894', '015', 'Mazzo Milanese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015895', '015', 'Melegnanello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015896', '015', 'Mercugnano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015897', '015', 'Mettone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015898', '015', 'Mezzana Casati', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015899', '015', 'Mezzano Passone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015900', '015', 'Mignette', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015901', '015', 'Mirabello San Bernardino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015902', '015', 'Moncucco di Monza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015903', '015', 'Moncucco Vecchio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015904', '015', 'Mongiardino Sillaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015905', '015', 'Montesiro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015906', '015', 'Morsenchio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015907', '015', 'Motta Vigana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015908', '015', 'Muggiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015909', '015', 'Musocco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015910', '015', 'Niguarda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015911', '015', 'Nosedo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015912', '015', 'Novegro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015913', '015', 'Omate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015914', '015', 'Oreno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015915', '015', 'Paina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015916', '015', 'Palazzolo Milanese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015917', '015', 'Passirana Milanese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015918', '015', 'Pasturago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015919', '015', 'Pedriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015920', '015', 'Pezzolo de'' Codazzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015921', '015', 'Pezzolo di Tavazzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015922', '015', 'Pinzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015923', '015', 'Pizzolano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015924', '015', 'Pontesesto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015925', '015', 'Porto d''Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015926', '015', 'Precotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015927', '015', 'Premenugo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015928', '015', 'Quartiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015929', '015', 'Quarto Cagnino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015930', '015', 'Quinto Romano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015931', '015', 'Quintosole', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015932', '015', 'Regina Fittarezza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015933', '015', 'Rescalda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015934', '015', 'Riozzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015935', '015', 'Robbiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015936', '015', 'Robecchetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015937', '015', 'Robecco Lodigiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015938', '015', 'Ronchetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015939', '015', 'Roserio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015940', '015', 'Rovagnasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015941', '015', 'Ruginello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015942', '015', 'San Damiano di Monza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015943', '015', 'San Giuliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015944', '015', 'San Novo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015945', '015', 'San Pedrino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015946', '015', 'San Pietro Bestazzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015947', '015', 'San Pietro Cusico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015948', '015', 'San Vito e Marta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015949', '015', 'Sant’Agata Martesana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015950', '015', 'Santa Maria in Prato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015951', '015', 'Sellanuova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015952', '015', 'Sesto Pergola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015953', '015', 'Sesto Ulteriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015954', '015', 'Soltarico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015955', '015', 'Sulbiate Inferiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015956', '015', 'Sulbiate Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015957', '015', 'Tainate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015958', '015', 'Tavazzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015959', '015', 'Terrazzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015960', '015', 'Tormo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015961', '015', 'Trecella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015962', '015', 'Tregasio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015963', '015', 'Trenno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015964', '015', 'Trivulza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015965', '015', 'Trivulzina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015966', '015', 'Turro Milanese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015967', '015', 'Usmate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015968', '015', 'Vaiano Valle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015969', '015', 'Valle Guidino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015970', '015', 'Veduggio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015971', '015', 'Vergo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015972', '015', 'Vidardo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015973', '015', 'Vigadore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015974', '015', 'Viganò Certosino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015975', '015', 'Vigentino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015976', '015', 'Vigonzino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015977', '015', 'Villa Pizzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015978', '015', 'Villa Pompeiana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015979', '015', 'Villa Raverio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015980', '015', 'Villanova Vimercate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015981', '015', 'Villarossa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015982', '015', 'Vittadone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015983', '015', 'Zelo Foramagno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015984', '015', 'Zivido', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('015985', '015', 'Zorlesco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016001', '016', 'Adrara San Martino', 'A057', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016002', '016', 'Adrara San Rocco', 'A058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016003', '016', 'Albano Sant''Alessandro', 'A129', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016004', '016', 'Albino', 'A163', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016248', '016', 'Algua', 'A193', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016005', '016', 'Almè', 'A214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016006', '016', 'Almenno San Bartolomeo', 'A216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016007', '016', 'Almenno San Salvatore', 'A217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016008', '016', 'Alzano Lombardo', 'A246', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016009', '016', 'Ambivere', 'A259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016010', '016', 'Antegnate', 'A304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016011', '016', 'Arcene', 'A365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016012', '016', 'Ardesio', 'A383', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016013', '016', 'Arzago d''Adda', 'A440', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016014', '016', 'Averara', 'A511', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016015', '016', 'Aviatico', 'A517', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016016', '016', 'Azzano San Paolo', 'A528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016017', '016', 'Azzone', 'A533', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016018', '016', 'Bagnatica', 'A557', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016019', '016', 'Barbata', 'A631', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016020', '016', 'Bariano', 'A664', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016021', '016', 'Barzana', 'A684', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016022', '016', 'Bedulita', 'A732', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016023', '016', 'Berbenno', 'A786', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016024', '016', 'Bergamo', 'A794', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016025', '016', 'Berzo San Fermo', 'A815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016026', '016', 'Bianzano', 'A846', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016027', '016', 'Blello', 'A903', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016028', '016', 'Bolgare', 'A937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016029', '016', 'Boltiere', 'A950', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016030', '016', 'Bonate Sopra', 'A963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016031', '016', 'Bonate Sotto', 'A962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016032', '016', 'Borgo di Terzo', 'B010', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016033', '016', 'Bossico', 'B083', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016034', '016', 'Bottanuco', 'B088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016035', '016', 'Bracca', 'B112', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016036', '016', 'Branzi', 'B123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016037', '016', 'Brembate', 'B137', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016038', '016', 'Brembate di Sopra', 'B138', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016039', '016', 'Brembilla', 'B140', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016040', '016', 'Brignano Gera d''Adda', 'B178', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016041', '016', 'Brumano', 'B217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016042', '016', 'Brusaporto', 'B223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016043', '016', 'Calcinate', 'B393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016044', '016', 'Calcio', 'B395', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016046', '016', 'Calusco d''Adda', 'B434', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016047', '016', 'Calvenzano', 'B442', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016048', '016', 'Camerata Cornello', 'B471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016049', '016', 'Canonica d''Adda', 'B618', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016050', '016', 'Capizzone', 'B661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016051', '016', 'Capriate San Gervasio', 'B703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016052', '016', 'Caprino Bergamasco', 'B710', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016053', '016', 'Caravaggio', 'B731', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016055', '016', 'Carobbio degli Angeli', 'B801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016056', '016', 'Carona', 'B803', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016057', '016', 'Carvico', 'B854', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016058', '016', 'Casazza', 'B947', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016059', '016', 'Casirate d''Adda', 'B971', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016060', '016', 'Casnigo', 'B978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016061', '016', 'Cassiglio', 'C007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016063', '016', 'Castel Rozzone', 'C255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016062', '016', 'Castelli Calepio', 'C079', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016064', '016', 'Castione della Presolana', 'C324', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016065', '016', 'Castro', 'C337', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016066', '016', 'Cavernago', 'C396', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016067', '016', 'Cazzano Sant''Andrea', 'C410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016068', '016', 'Cenate Sopra', 'C456', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016069', '016', 'Cenate Sotto', 'C457', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016070', '016', 'Cene', 'C459', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016071', '016', 'Cerete', 'C506', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016072', '016', 'Chignolo d''Isola', 'C635', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016073', '016', 'Chiuduno', 'C649', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016074', '016', 'Cisano Bergamasco', 'C728', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016075', '016', 'Ciserano', 'C730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016076', '016', 'Cividate al Piano', 'C759', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016077', '016', 'Clusone', 'C800', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016078', '016', 'Colere', 'C835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016079', '016', 'Cologno al Serio', 'C894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016080', '016', 'Colzate', 'C910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016081', '016', 'Comun Nuovo', 'C937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016082', '016', 'Corna Imagna', 'D015', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016249', '016', 'Cornalba', 'D016', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016083', '016', 'Cortenuova', 'D066', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016084', '016', 'Costa di Mezzate', 'D110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016247', '016', 'Costa Serina', 'D111', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016085', '016', 'Costa Valle Imagna', 'D103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016086', '016', 'Costa Volpino', 'D117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016087', '016', 'Covo', 'D126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016088', '016', 'Credaro', 'D139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016089', '016', 'Curno', 'D221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016090', '016', 'Cusio', 'D233', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016091', '016', 'Dalmine', 'D245', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016092', '016', 'Dossena', 'D352', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016093', '016', 'Endine Gaiano', 'D406', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016094', '016', 'Entratico', 'D411', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016096', '016', 'Fara Gera d''Adda', 'D490', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016097', '016', 'Fara Olivana con Sola', 'D491', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016098', '016', 'Filago', 'D588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016099', '016', 'Fino del Monte', 'D604', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016100', '016', 'Fiorano al Serio', 'D606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016101', '016', 'Fontanella', 'D672', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016102', '016', 'Fonteno', 'D684', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016103', '016', 'Foppolo', 'D688', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016104', '016', 'Foresto Sparso', 'D697', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016105', '016', 'Fornovo San Giovanni', 'D727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016106', '016', 'Fuipiano Valle Imagna', 'D817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016107', '016', 'Gandellino', 'D903', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016108', '016', 'Gandino', 'D905', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016109', '016', 'Gandosso', 'D906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016110', '016', 'Gaverina Terme', 'D943', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016111', '016', 'Gazzaniga', 'D952', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016112', '016', 'Gerosa', 'D991', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016113', '016', 'Ghisalba', 'E006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016114', '016', 'Gorlago', 'E100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016115', '016', 'Gorle', 'E103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016116', '016', 'Gorno', 'E106', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016117', '016', 'Grassobbio', 'E148', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016118', '016', 'Gromo', 'E189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016119', '016', 'Grone', 'E192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016120', '016', 'Grumello del Monte', 'E219', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016121', '016', 'Isola di Fondra', 'E353', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016122', '016', 'Isso', 'E370', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016123', '016', 'Lallio', 'E422', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016124', '016', 'Leffe', 'E509', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016125', '016', 'Lenna', 'E524', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016126', '016', 'Levate', 'E562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016127', '016', 'Locatello', 'E640', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016128', '016', 'Lovere', 'E704', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016129', '016', 'Lurano', 'E751', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016130', '016', 'Luzzana', 'E770', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016131', '016', 'Madone', 'E794', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016132', '016', 'Mapello', 'E901', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016133', '016', 'Martinengo', 'E987', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016250', '016', 'Medolago', 'F085', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016134', '016', 'Mezzoldo', 'F186', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016135', '016', 'Misano di Gera d''Adda', 'F243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016136', '016', 'Moio de'' Calvi', 'F276', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016137', '016', 'Monasterolo del Castello', 'F328', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016139', '016', 'Montello', 'F547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016140', '016', 'Morengo', 'F720', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016141', '016', 'Mornico al Serio', 'F738', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016142', '016', 'Mozzanica', 'F786', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016143', '016', 'Mozzo', 'F791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016144', '016', 'Nembro', 'F864', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016145', '016', 'Olmo al Brembo', 'G049', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016146', '016', 'Oltre il Colle', 'G050', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016147', '016', 'Oltressenda Alta', 'G054', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016148', '016', 'Oneta', 'G068', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016149', '016', 'Onore', 'G075', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016150', '016', 'Orio al Serio', 'G108', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016151', '016', 'Ornica', 'G118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016152', '016', 'Osio Sopra', 'G159', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016153', '016', 'Osio Sotto', 'G160', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016154', '016', 'Pagazzano', 'G233', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016155', '016', 'Paladina', 'G249', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016156', '016', 'Palazzago', 'G259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016157', '016', 'Palosco', 'G295', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016158', '016', 'Parre', 'G346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016159', '016', 'Parzanica', 'G350', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016160', '016', 'Pedrengo', 'G412', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016161', '016', 'Peia', 'G418', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016162', '016', 'Pianico', 'G564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016163', '016', 'Piario', 'G574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016164', '016', 'Piazza Brembana', 'G579', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016165', '016', 'Piazzatorre', 'G583', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016166', '016', 'Piazzolo', 'G588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016167', '016', 'Pognano', 'G774', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016168', '016', 'Ponte Nossa', 'F941', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016170', '016', 'Ponte San Pietro', 'G856', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016169', '016', 'Ponteranica', 'G853', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016171', '016', 'Pontida', 'G864', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016172', '016', 'Pontirolo Nuovo', 'G867', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016173', '016', 'Pradalunga', 'G968', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016174', '016', 'Predore', 'H020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016175', '016', 'Premolo', 'H036', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016176', '016', 'Presezzo', 'H046', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016177', '016', 'Pumenengo', 'H091', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016178', '016', 'Ranica', 'H176', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016179', '016', 'Ranzanico', 'H177', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016180', '016', 'Riva di Solto', 'H331', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016182', '016', 'Rogno', 'H492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016183', '016', 'Romano di Lombardia', 'H509', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016184', '016', 'Roncobello', 'H535', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016185', '016', 'Roncola', 'H544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016186', '016', 'Rota d''Imagna', 'H584', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016187', '016', 'Rovetta', 'H615', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016188', '016', 'San Giovanni Bianco', 'H910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016189', '016', 'San Paolo d''Argon', 'B310', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016190', '016', 'San Pellegrino Terme', 'I079', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016191', '016', 'Santa Brigida', 'I168', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016192', '016', 'Sant''Omobono Terme', 'I349', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016193', '016', 'Sarnico', 'I437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016194', '016', 'Scanzorosciate', 'I506', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016195', '016', 'Schilpario', 'I530', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016196', '016', 'Sedrina', 'I567', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016197', '016', 'Selvino', 'I597', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016198', '016', 'Seriate', 'I628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016199', '016', 'Serina', 'I629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016200', '016', 'Solto Collina', 'I812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016251', '016', 'Solza', 'I813', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016201', '016', 'Songavazzo', 'I830', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016202', '016', 'Sorisole', 'I858', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016203', '016', 'Sotto il Monte Giovanni XXIII', 'I869', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016204', '016', 'Sovere', 'I873', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016205', '016', 'Spinone al Lago', 'I916', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016206', '016', 'Spirano', 'I919', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016207', '016', 'Stezzano', 'I951', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016208', '016', 'Strozza', 'I986', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016209', '016', 'Suisio', 'I997', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016210', '016', 'Taleggio', 'L037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016211', '016', 'Tavernola Bergamasca', 'L073', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016212', '016', 'Telgate', 'L087', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016213', '016', 'Terno d''Isola', 'L118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016214', '016', 'Torre Boldone', 'L251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016216', '016', 'Torre de'' Roveri', 'L265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016217', '016', 'Torre Pallavicina', 'L276', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016218', '016', 'Trescore Balneario', 'L388', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016219', '016', 'Treviglio', 'L400', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016220', '016', 'Treviolo', 'L404', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016221', '016', 'Ubiale Clanezzo', 'C789', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016222', '016', 'Urgnano', 'L502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016223', '016', 'Valbondione', 'L544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016224', '016', 'Valbrembo', 'L545', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016225', '016', 'Valgoglio', 'L579', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016226', '016', 'Valleve', 'L623', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016227', '016', 'Valnegra', 'L642', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016228', '016', 'Valsecca', 'L649', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016229', '016', 'Valtorta', 'L655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016230', '016', 'Vedeseta', 'L707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016232', '016', 'Verdellino', 'L752', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016233', '016', 'Verdello', 'L753', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016234', '016', 'Vertova', 'L795', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016235', '016', 'Viadanica', 'L827', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016236', '016', 'Vigano San Martino', 'L865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016237', '016', 'Vigolo', 'L894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016238', '016', 'Villa d''Adda', 'L929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016239', '016', 'Villa d''Almè', 'A215', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016240', '016', 'Villa di Serio', 'L936', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016241', '016', 'Villa d''Ogna', 'L938', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016242', '016', 'Villongo', 'M045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016243', '016', 'Vilminore di Scalve', 'M050', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016244', '016', 'Zandobbio', 'M144', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016245', '016', 'Zanica', 'M147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016246', '016', 'Zogno', 'M184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097080', '016', 'Torre de'' Busi', 'L257', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016252', '016', 'Sant''Omobono Terme', 'M333', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016253', '016', 'Val Brembilla', 'M334', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016181', '016', 'Riviera d''Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016801', '016', 'Albegno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016802', '016', 'Alzano di Sopra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016803', '016', 'Alzano Maggiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016804', '016', 'Baresi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016805', '016', 'Barsizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016806', '016', 'Bondione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016807', '016', 'Bondo Petello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016808', '016', 'Bordogna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016809', '016', 'Borgounito', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016810', '016', 'Brembate di Sotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016811', '016', 'Bruntino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016812', '016', 'Calepio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016813', '016', 'Capriate d''Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016814', '016', 'Carobbio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016815', '016', 'Cenate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016816', '016', 'Cenate d''Argon', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016817', '016', 'Centrisola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016818', '016', 'Cepino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016819', '016', 'Colognola del Piano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016820', '016', 'Corte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016821', '016', 'Curdomo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016822', '016', 'Curnasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016823', '016', 'Desenzano al Serio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016824', '016', 'Dezzo di Scalve', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016825', '016', 'Endenna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016826', '016', 'Endine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016827', '016', 'Esmate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016828', '016', 'Filago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016829', '016', 'Fiumenero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016830', '016', 'Fondra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016831', '016', 'Frerola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016832', '016', 'Fuipiano al Brembo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016833', '016', 'Grignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016834', '016', 'Grumello de'' Zanchi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016835', '016', 'Grumello del Piano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016836', '016', 'Lizzola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016837', '016', 'Locate Bergamasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016838', '016', 'Lorentino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016839', '016', 'Mariano al Brembo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016840', '016', 'Massari Melzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016841', '016', 'Mazzoleni e Falghera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016842', '016', 'Molini di Colognola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016843', '016', 'Nese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016844', '016', 'Oltrepovo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016845', '016', 'Oltressenda Bassa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016846', '016', 'Orezzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016847', '016', 'Ossanesga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016848', '016', 'Pian Gaiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016849', '016', 'Piazzo Alto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016850', '016', 'Piazzo Basso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016851', '016', 'Poscante', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016852', '016', 'Redona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016853', '016', 'Rigosa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016854', '016', 'Rocca del Colle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016855', '016', 'Rosciate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016856', '016', 'Rossino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016857', '016', 'Rota Dentro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016858', '016', 'Rota Fuori', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016859', '016', 'Rovetta con Fino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016860', '016', 'Sabbio Bergamasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016861', '016', 'San Gallo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016862', '016', 'San Gervasio d''Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016863', '016', 'San Martino de'' Calvi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016864', '016', 'San Pietro d''Orzio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016865', '016', 'Sant’Antonio d''Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016866', '016', 'Santo Stefano del Monte degli Angeli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016867', '016', 'Scano al Brembo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016868', '016', 'Scanzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016869', '016', 'Selino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016870', '016', 'Sellere', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016871', '016', 'Sforzatica', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016872', '016', 'Solto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016873', '016', 'Sombreno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016874', '016', 'Somendenna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016875', '016', 'Spino al Brembo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016876', '016', 'Spinone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016877', '016', 'Stabello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016878', '016', 'Tagliuno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016879', '016', 'Trabuchello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016880', '016', 'Vall’Alta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016881', '016', 'Valtesse', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016882', '016', 'Villongo San Filastro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016883', '016', 'Villongo Sant’Alessandro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016884', '016', 'Vilminore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016885', '016', 'Zorzino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('016886', '016', 'Calolzio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017001', '017', 'Acquafredda', 'A034', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017002', '017', 'Adro', 'A060', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017003', '017', 'Agnosine', 'A082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017004', '017', 'Alfianello', 'A188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017005', '017', 'Anfo', 'A288', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017006', '017', 'Angolo Terme', 'A293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017007', '017', 'Artogne', 'A451', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017008', '017', 'Azzano Mella', 'A529', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017009', '017', 'Bagnolo Mella', 'A569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017010', '017', 'Bagolino', 'A578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017011', '017', 'Barbariga', 'A630', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017012', '017', 'Barghe', 'A661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017013', '017', 'Bassano Bresciano', 'A702', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017014', '017', 'Bedizzole', 'A729', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017015', '017', 'Berlingo', 'A799', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017016', '017', 'Berzo Demo', 'A816', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017017', '017', 'Berzo Inferiore', 'A817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017018', '017', 'Bienno', 'A861', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017019', '017', 'Bione', 'A878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017020', '017', 'Borgo San Giacomo', 'B035', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017021', '017', 'Borgosatollo', 'B040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017022', '017', 'Borno', 'B054', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017023', '017', 'Botticino', 'B091', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017024', '017', 'Bovegno', 'B100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017025', '017', 'Bovezzo', 'B102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017026', '017', 'Brandico', 'B120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017027', '017', 'Braone', 'B124', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017028', '017', 'Breno', 'B149', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017029', '017', 'Brescia', 'B157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017030', '017', 'Brione', 'B184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017031', '017', 'Caino', 'B365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017032', '017', 'Calcinato', 'B394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017033', '017', 'Calvagese della Riviera', 'B436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017034', '017', 'Calvisano', 'B450', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017035', '017', 'Capo di Ponte', 'B664', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017036', '017', 'Capovalle', 'B676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017037', '017', 'Capriano del Colle', 'B698', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017038', '017', 'Capriolo', 'B711', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017039', '017', 'Carpenedolo', 'B817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017040', '017', 'Castegnato', 'C055', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017042', '017', 'Castel Mella', 'C208', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017041', '017', 'Castelcovati', 'C072', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017043', '017', 'Castenedolo', 'C293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017044', '017', 'Casto', 'C330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017045', '017', 'Castrezzato', 'C332', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017046', '017', 'Cazzago San Martino', 'C408', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017047', '017', 'Cedegolo', 'C417', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017048', '017', 'Cellatica', 'C439', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017049', '017', 'Cerveno', 'C549', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017050', '017', 'Ceto', 'C585', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017051', '017', 'Cevo', 'C591', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017052', '017', 'Chiari', 'C618', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017053', '017', 'Cigole', 'C685', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017054', '017', 'Cimbergo', 'C691', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017055', '017', 'Cividate Camuno', 'C760', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017056', '017', 'Coccaglio', 'C806', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017057', '017', 'Collebeato', 'C850', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017058', '017', 'Collio', 'C883', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017059', '017', 'Cologne', 'C893', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017060', '017', 'Comezzano-Cizzago', 'C925', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017061', '017', 'Concesio', 'C948', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017062', '017', 'Corte Franca', 'D058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017063', '017', 'Corteno Golgi', 'D064', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017064', '017', 'Corzano', 'D082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017065', '017', 'Darfo Boario Terme', 'D251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017066', '017', 'Dello', 'D270', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017067', '017', 'Desenzano del Garda', 'D284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017068', '017', 'Edolo', 'D391', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017069', '017', 'Erbusco', 'D421', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017070', '017', 'Esine', 'D434', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017071', '017', 'Fiesse', 'D576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017072', '017', 'Flero', 'D634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017073', '017', 'Gambara', 'D891', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017074', '017', 'Gardone Riviera', 'D917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017075', '017', 'Gardone Val Trompia', 'D918', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017076', '017', 'Gargnano', 'D924', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017077', '017', 'Gavardo', 'D940', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017078', '017', 'Ghedi', 'D999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017079', '017', 'Gianico', 'E010', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017080', '017', 'Gottolengo', 'E116', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017081', '017', 'Gussago', 'E271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017082', '017', 'Idro', 'E280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017083', '017', 'Incudine', 'E297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017084', '017', 'Irma', 'E325', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017085', '017', 'Iseo', 'E333', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017086', '017', 'Isorella', 'E364', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017087', '017', 'Lavenone', 'E497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017088', '017', 'Leno', 'E526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017089', '017', 'Limone sul Garda', 'E596', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017090', '017', 'Lodrino', 'E652', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017091', '017', 'Lograto', 'E654', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017092', '017', 'Lonato del Garda', 'M312', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017093', '017', 'Longhena', 'E673', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017094', '017', 'Losine', 'E698', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017095', '017', 'Lozio', 'E706', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017096', '017', 'Lumezzane', 'E738', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017097', '017', 'Maclodio', 'E787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017098', '017', 'Magasa', 'E800', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017099', '017', 'Mairano', 'E841', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017100', '017', 'Malegno', 'E851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017101', '017', 'Malonno', 'E865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017102', '017', 'Manerba del Garda', 'E883', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017103', '017', 'Manerbio', 'E884', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017104', '017', 'Marcheno', 'E928', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017105', '017', 'Marmentino', 'E961', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017106', '017', 'Marone', 'E967', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017107', '017', 'Mazzano', 'F063', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017108', '017', 'Milzano', 'F216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017109', '017', 'Moniga del Garda', 'F373', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017110', '017', 'Monno', 'F375', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017111', '017', 'Monte Isola', 'F532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017112', '017', 'Monticelli Brusati', 'F672', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017113', '017', 'Montichiari', 'F471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017114', '017', 'Montirone', 'F680', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017115', '017', 'Mura', 'F806', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017116', '017', 'Muscoline', 'F820', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017117', '017', 'Nave', 'F851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017118', '017', 'Niardo', 'F884', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017119', '017', 'Nuvolento', 'F989', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017120', '017', 'Nuvolera', 'F990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017121', '017', 'Odolo', 'G001', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017122', '017', 'Offlaga', 'G006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017123', '017', 'Ome', 'G061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017124', '017', 'Ono San Pietro', 'G074', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017125', '017', 'Orzinuovi', 'G149', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017126', '017', 'Orzivecchi', 'G150', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017127', '017', 'Ospitaletto', 'G170', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017128', '017', 'Ossimo', 'G179', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017129', '017', 'Padenghe sul Garda', 'G213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017130', '017', 'Paderno Franciacorta', 'G217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017131', '017', 'Paisco Loveno', 'G247', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017132', '017', 'Paitone', 'G248', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017133', '017', 'Palazzolo sull''Oglio', 'G264', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017134', '017', 'Paratico', 'G327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017135', '017', 'Paspardo', 'G354', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017136', '017', 'Passirano', 'G361', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017137', '017', 'Pavone del Mella', 'G391', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017139', '017', 'Pertica Alta', 'G474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017140', '017', 'Pertica Bassa', 'G475', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017141', '017', 'Pezzaze', 'G529', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017142', '017', 'Pian Camuno', 'G546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017206', '017', 'Piancogno', 'G549', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017143', '017', 'Pisogne', 'G710', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017144', '017', 'Polaveno', 'G779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017145', '017', 'Polpenazze del Garda', 'G801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017146', '017', 'Pompiano', 'G815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017147', '017', 'Poncarale', 'G818', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017148', '017', 'Ponte di Legno', 'G844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017149', '017', 'Pontevico', 'G859', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017150', '017', 'Pontoglio', 'G869', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017151', '017', 'Pozzolengo', 'G959', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017152', '017', 'Pralboino', 'G977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017153', '017', 'Preseglie', 'H043', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017154', '017', 'Prestine', 'H050', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017155', '017', 'Prevalle', 'H055', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017156', '017', 'Provaglio d''Iseo', 'H078', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017157', '017', 'Provaglio Val Sabbia', 'H077', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017158', '017', 'Puegnago sul Garda', 'H086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017159', '017', 'Quinzano d''Oglio', 'H140', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017160', '017', 'Remedello', 'H230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017161', '017', 'Rezzato', 'H256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017162', '017', 'Roccafranca', 'H410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017163', '017', 'Rodengo Saiano', 'H477', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017164', '017', 'Roè Volciano', 'H484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017165', '017', 'Roncadelle', 'H525', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017166', '017', 'Rovato', 'H598', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017167', '017', 'Rudiano', 'H630', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017168', '017', 'Sabbio Chiese', 'H650', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017169', '017', 'Sale Marasino', 'H699', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017170', '017', 'Salò', 'H717', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017171', '017', 'San Felice del Benaco', 'H838', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017172', '017', 'San Gervasio Bresciano', 'H865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017138', '017', 'San Paolo', 'G407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017173', '017', 'San Zeno Naviglio', 'I412', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017174', '017', 'Sarezzo', 'I433', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017175', '017', 'Saviore dell''Adamello', 'I476', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017176', '017', 'Sellero', 'I588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017177', '017', 'Seniga', 'I607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017178', '017', 'Serle', 'I631', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017179', '017', 'Sirmione', 'I633', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017180', '017', 'Soiano del Lago', 'I782', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017181', '017', 'Sonico', 'I831', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017182', '017', 'Sulzano', 'L002', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017183', '017', 'Tavernole sul Mella', 'C698', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017184', '017', 'Temù', 'L094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017185', '017', 'Tignale', 'L169', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017186', '017', 'Torbole Casaglia', 'L210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017187', '017', 'Toscolano-Maderno', 'L312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017188', '017', 'Travagliato', 'L339', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017189', '017', 'Tremosine sul Garda', 'L372', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017190', '017', 'Trenzano', 'L380', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017191', '017', 'Treviso Bresciano', 'L406', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017192', '017', 'Urago d''Oglio', 'L494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017193', '017', 'Vallio Terme', 'L626', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017194', '017', 'Valvestino', 'L468', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017195', '017', 'Verolanuova', 'L777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017196', '017', 'Verolavecchia', 'L778', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017197', '017', 'Vestone', 'L812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017198', '017', 'Vezza d''Oglio', 'L816', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017199', '017', 'Villa Carcina', 'L919', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017200', '017', 'Villachiara', 'L923', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017201', '017', 'Villanuova sul Clisi', 'L995', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017202', '017', 'Vione', 'M065', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017203', '017', 'Visano', 'M070', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017204', '017', 'Vobarno', 'M104', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017205', '017', 'Zone', 'M188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('17092', '017', 'Lonato del Garda', 'M312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017801', '017', 'Acqualunga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017802', '017', 'Alone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017803', '017', 'Anfurro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017804', '017', 'Armo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017805', '017', 'Avenone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017806', '017', 'Barco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017807', '017', 'Bel Prato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017808', '017', 'Bollone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017809', '017', 'Borgonato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017810', '017', 'Bornato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017811', '017', 'Botticino Mattina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017812', '017', 'Botticino Sera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017813', '017', 'Brozzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017814', '017', 'Burago Riviera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017815', '017', 'Cadignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017816', '017', 'Cajonvico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017817', '017', 'Calino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017818', '017', 'Camignone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017819', '017', 'Campoverde', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017820', '017', 'Carcina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017821', '017', 'Carzago della Riviera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017822', '017', 'Castrezzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017823', '017', 'Ceto-Cerveno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017824', '017', 'Cignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017825', '017', 'Ciliverghe', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017826', '017', 'Cimbergo-Paspardo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017827', '017', 'Cividate Malegno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017828', '017', 'Cizzago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017829', '017', 'Clusane sul Lago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017830', '017', 'Colombaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017831', '017', 'Comero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017832', '017', 'Comezzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017833', '017', 'Cortenedolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017834', '017', 'Corticelle Pieve', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017835', '017', 'Cossirano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017836', '017', 'Cremezzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017837', '017', 'Degagna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017838', '017', 'Erbanno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017839', '017', 'Farfengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017840', '017', 'Faverzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017841', '017', 'Fiumicello Urago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017842', '017', 'Folzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017843', '017', 'Frontignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017844', '017', 'Gerolanuova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017845', '017', 'Goglione Sopra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017846', '017', 'Goglione Sotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017847', '017', 'Gorzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017848', '017', 'Inzino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017849', '017', 'Levrange', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017850', '017', 'Livemmo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017851', '017', 'Loveno Grumello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017852', '017', 'Ludriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017853', '017', 'Lumezzane Pieve', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017854', '017', 'Lumezzane San Sebastiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017855', '017', 'Lumezzane Sant’Apollonio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017856', '017', 'Maderno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017857', '017', 'Magno Sopra Inzino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017858', '017', 'Mazzunno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017859', '017', 'Milzanello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017860', '017', 'Moerna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017861', '017', 'Mompiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017862', '017', 'Mu', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017863', '017', 'Navono', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017864', '017', 'Nigoline', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017865', '017', 'Nozza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017866', '017', 'Ono Degno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017867', '017', 'Oriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017868', '017', 'Padernello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017869', '017', 'Paisco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017870', '017', 'Persone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017871', '017', 'Peschiera Maraglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017872', '017', 'Pezzoro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017873', '017', 'Pilzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017874', '017', 'Poncarale Flero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017875', '017', 'Pontagna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017876', '017', 'Portese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017877', '017', 'Porzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017878', '017', 'Prandaglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017879', '017', 'Presegno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017880', '017', 'Provaglio Sopra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017881', '017', 'Provaglio Sotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017882', '017', 'Provezze', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017883', '017', 'Quinzanello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017884', '017', 'Raffa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017885', '017', 'Remedello Sopra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017886', '017', 'Remedello Sotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017887', '017', 'Rivoltella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017888', '017', 'Rodengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017889', '017', 'Saiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017890', '017', 'San Bartolomeo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017891', '017', 'San Felice di Scovolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017892', '017', 'San Nazzaro Mella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017893', '017', 'San Vigilio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017894', '017', 'Sant’Alessandro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017895', '017', 'Sant’Eufemia della Fonte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017896', '017', 'Santicolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017897', '017', 'Scarpizzolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017898', '017', 'Siviano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017899', '017', 'Sopraponte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017900', '017', 'Soprazocco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017901', '017', 'Terzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017902', '017', 'Timoline', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017903', '017', 'Torbiato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017904', '017', 'Toscolano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017905', '017', 'Urago Mella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017906', '017', 'Valsaviore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017907', '017', 'Vello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017908', '017', 'Villa Cogozzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017909', '017', 'Villa d’Allegno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('017910', '017', 'Virle Treponti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018001', '018', 'Alagna', 'A118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018002', '018', 'Albaredo Arnaboldi', 'A134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018003', '018', 'Albonese', 'A171', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018004', '018', 'Albuzzano', 'A175', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018005', '018', 'Arena Po', 'A387', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018006', '018', 'Badia Pavese', 'A538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018007', '018', 'Bagnaria', 'A550', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018008', '018', 'Barbianello', 'A634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018009', '018', 'Bascapè', 'A690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018010', '018', 'Bastida de'' Dossi', 'A711', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018011', '018', 'Bastida Pancarana', 'A712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018012', '018', 'Battuda', 'A718', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018013', '018', 'Belgioioso', 'A741', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018014', '018', 'Bereguardo', 'A792', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018015', '018', 'Borgarello', 'A989', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018016', '018', 'Borgo Priolo', 'B028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018018', '018', 'Borgo San Siro', 'B038', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018017', '018', 'Borgoratto Mormorolo', 'B030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018019', '018', 'Bornasco', 'B051', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018020', '018', 'Bosnasco', 'B082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018021', '018', 'Brallo di Pregola', 'B117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018022', '018', 'Breme', 'B142', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018023', '018', 'Bressana Bottarone', 'B159', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018024', '018', 'Broni', 'B201', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018025', '018', 'Calvignano', 'B447', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018026', '018', 'Campospinoso', 'B567', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018027', '018', 'Candia Lomellina', 'B587', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018028', '018', 'Canevino', 'B599', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018029', '018', 'Canneto Pavese', 'B613', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018030', '018', 'Carbonara al Ticino', 'B741', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018031', '018', 'Casanova Lonati', 'B929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018032', '018', 'Casatisma', 'B945', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018033', '018', 'Casei Gerola', 'B954', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018034', '018', 'Casorate Primo', 'B988', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018035', '018', 'Cassolnovo', 'C038', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018036', '018', 'Castana', 'C050', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018037', '018', 'Casteggio', 'C053', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018038', '018', 'Castelletto di Branduzzo', 'C157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018039', '018', 'Castello d''Agogna', 'C184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018040', '018', 'Castelnovetto', 'C213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018041', '018', 'Cava Manara', 'C360', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018042', '018', 'Cecima', 'C414', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018043', '018', 'Ceranova', 'C484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018044', '018', 'Ceretto Lomellina', 'C508', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018045', '018', 'Cergnago', 'C509', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018046', '018', 'Certosa di Pavia', 'C541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018047', '018', 'Cervesina', 'C551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018048', '018', 'Chignolo Po', 'C637', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018049', '018', 'Cigognola', 'C684', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018050', '018', 'Cilavegna', 'C686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018051', '018', 'Codevilla', 'C813', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018052', '018', 'Confienza', 'C958', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018053', '018', 'Copiano', 'C979', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018054', '018', 'Corana', 'C982', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018055', '018', 'Cornale', 'D017', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018056', '018', 'Corteolona', 'D067', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018057', '018', 'Corvino San Quirico', 'D081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018058', '018', 'Costa de'' Nobili', 'D109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018059', '018', 'Cozzo', 'D127', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018060', '018', 'Cura Carpignano', 'B824', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018061', '018', 'Dorno', 'D348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018062', '018', 'Ferrera Erbognone', 'D552', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018063', '018', 'Filighera', 'D594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018064', '018', 'Fortunago', 'D732', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018065', '018', 'Frascarolo', 'D771', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018066', '018', 'Galliavola', 'D873', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018067', '018', 'Gambarana', 'D892', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018068', '018', 'Gambolò', 'D901', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018069', '018', 'Garlasco', 'D925', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018070', '018', 'Genzone', 'D973', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018071', '018', 'Gerenzago', 'D980', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018072', '018', 'Giussago', 'E062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018073', '018', 'Godiasco Salice Terme', 'E072', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018074', '018', 'Golferenzo', 'E081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018075', '018', 'Gravellona Lomellina', 'E152', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018076', '018', 'Gropello Cairoli', 'E195', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018077', '018', 'Inverno e Monteleone', 'E310', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018078', '018', 'Landriano', 'E437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018079', '018', 'Langosco', 'E439', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018080', '018', 'Lardirago', 'E454', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018081', '018', 'Linarolo', 'E600', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018082', '018', 'Lirio', 'E608', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018083', '018', 'Lomello', 'E662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018084', '018', 'Lungavilla', 'B387', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018085', '018', 'Magherno', 'E804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018086', '018', 'Marcignago', 'E934', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018087', '018', 'Marzano', 'E999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018088', '018', 'Mede', 'F080', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018089', '018', 'Menconico', 'F122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018090', '018', 'Mezzana Bigli', 'F170', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018091', '018', 'Mezzana Rabattone', 'F171', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018092', '018', 'Mezzanino', 'F175', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018093', '018', 'Miradolo Terme', 'F238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018094', '018', 'Montalto Pavese', 'F417', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018095', '018', 'Montebello della Battaglia', 'F440', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018096', '018', 'Montecalvo Versiggia', 'F449', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018097', '018', 'Montescano', 'F638', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018098', '018', 'Montesegale', 'F644', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018099', '018', 'Monticelli Pavese', 'F670', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018100', '018', 'Montù Beccaria', 'F701', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018101', '018', 'Mornico Losana', 'F739', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018102', '018', 'Mortara', 'F754', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018103', '018', 'Nicorvo', 'F891', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018104', '018', 'Olevano di Lomellina', 'G021', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018105', '018', 'Oliva Gessi', 'G032', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018106', '018', 'Ottobiano', 'G194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018107', '018', 'Palestro', 'G275', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018108', '018', 'Pancarana', 'G304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018109', '018', 'Parona', 'G342', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018110', '018', 'Pavia', 'G388', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018111', '018', 'Pietra de'' Giorgi', 'G612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018112', '018', 'Pieve Albignola', 'G635', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018113', '018', 'Pieve del Cairo', 'G639', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018114', '018', 'Pieve Porto Morone', 'G650', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018115', '018', 'Pinarolo Po', 'G671', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018116', '018', 'Pizzale', 'G720', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018117', '018', 'Ponte Nizza', 'G851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018118', '018', 'Portalbera', 'G895', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018119', '018', 'Rea', 'H204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018120', '018', 'Redavalle', 'H216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018121', '018', 'Retorbido', 'H246', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018122', '018', 'Rivanazzano Terme', 'H336', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018123', '018', 'Robbio', 'H369', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018124', '018', 'Robecco Pavese', 'H375', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018125', '018', 'Rocca de'' Giorgi', 'H396', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018126', '018', 'Rocca Susella', 'H450', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018127', '018', 'Rognano', 'H491', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018128', '018', 'Romagnese', 'H505', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018129', '018', 'Roncaro', 'H527', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018130', '018', 'Rosasco', 'H559', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018131', '018', 'Rovescala', 'H614', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018132', '018', 'Ruino', 'H637', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018133', '018', 'San Cipriano Po', 'H799', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018134', '018', 'San Damiano al Colle', 'H814', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018135', '018', 'San Genesio ed Uniti', 'H859', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018136', '018', 'San Giorgio di Lomellina', 'H885', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018137', '018', 'San Martino Siccomario', 'I014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018145', '018', 'San Zenone al Po', 'I416', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018138', '018', 'Sannazzaro de'' Burgondi', 'I048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018139', '018', 'Santa Cristina e Bissone', 'I175', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018140', '018', 'Santa Giuletta', 'I203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018142', '018', 'Santa Margherita di Staffora', 'I230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018143', '018', 'Santa Maria della Versa', 'I237', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018141', '018', 'Sant''Alessio con Vialone', 'I213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018144', '018', 'Sant''Angelo Lomellina', 'I276', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018146', '018', 'Sartirana Lomellina', 'I447', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018147', '018', 'Scaldasole', 'I487', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018148', '018', 'Semiana', 'I599', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018149', '018', 'Silvano Pietra', 'I739', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018150', '018', 'Siziano', 'E265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018151', '018', 'Sommo', 'I825', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018152', '018', 'Spessa', 'I894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018153', '018', 'Stradella', 'I968', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018154', '018', 'Suardi', 'B014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018155', '018', 'Torrazza Coste', 'L237', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018156', '018', 'Torre Beretti e Castellaro', 'L250', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018157', '018', 'Torre d''Arese', 'L256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018158', '018', 'Torre de'' Negri', 'L262', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018159', '018', 'Torre d''Isola', 'L269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018160', '018', 'Torrevecchia Pia', 'L285', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018161', '018', 'Torricella Verzate', 'L292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018162', '018', 'Travacò Siccomario', 'I236', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018163', '018', 'Trivolzio', 'L440', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018164', '018', 'Tromello', 'L449', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018165', '018', 'Trovo', 'L453', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018166', '018', 'Val di Nizza', 'L562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018167', '018', 'Valeggio', 'L568', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018168', '018', 'Valle Lomellina', 'L593', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018169', '018', 'Valle Salimbene', 'L617', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018170', '018', 'Valverde', 'L659', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018171', '018', 'Varzi', 'L690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018172', '018', 'Velezzo Lomellina', 'L716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018173', '018', 'Vellezzo Bellini', 'L720', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018174', '018', 'Verretto', 'L784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018175', '018', 'Verrua Po', 'L788', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018176', '018', 'Vidigulfo', 'L854', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018177', '018', 'Vigevano', 'L872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018178', '018', 'Villa Biscossi', 'L917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018179', '018', 'Villanova d''Ardenghi', 'L983', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018180', '018', 'Villanterio', 'L994', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018181', '018', 'Vistarino', 'M079', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018182', '018', 'Voghera', 'M109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018183', '018', 'Volpara', 'M119', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018184', '018', 'Zavattarello', 'M150', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018185', '018', 'Zeccone', 'M152', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018186', '018', 'Zeme', 'M161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018187', '018', 'Zenevredo', 'M162', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018188', '018', 'Zerbo', 'M166', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018189', '018', 'Zerbolò', 'M167', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018190', '018', 'Zinasco', 'M180', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018192', '018', 'Corteolona e Genzone', 'M372', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018191', '018', 'Cornale e Bastida', 'M338', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018801', '018', 'Barona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018802', '018', 'Baselica Bologna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018803', '018', 'Belvedere al Po', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018804', '018', 'Bottarone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018805', '018', 'Branduzzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018806', '018', 'Bressana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018807', '018', 'Buttirago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018808', '018', 'Ca'' de'' Tedioli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018809', '018', 'Ca'' della Terra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018810', '018', 'Cairo Lomellino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018811', '018', 'Calignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018812', '018', 'Cambiò', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018813', '018', 'Campomorto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018814', '018', 'Camporinaldo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018815', '018', 'Campospinoso Albaredo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018816', '018', 'Cantonale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018817', '018', 'Carpignago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018818', '018', 'Casatico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018819', '018', 'Cassine Calderari', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018820', '018', 'Cassine Sirigari', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018821', '018', 'Cassine Tolentine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018822', '018', 'Cassino Po', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018823', '018', 'Castel Lambro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018824', '018', 'Castellaro de'' Giorgi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018825', '018', 'Castelletto Po', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018826', '018', 'Cavagnera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018827', '018', 'Cella di Bobbio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018828', '018', 'Celpenchio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018829', '018', 'Comairano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018830', '018', 'Corbesate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018831', '018', 'Corpi Santi di Pavia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018832', '018', 'Donelasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018833', '018', 'Fossarmato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018834', '018', 'Gerrechiozzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018835', '018', 'Giovenzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018836', '018', 'Goido', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018837', '018', 'Gualdrasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018838', '018', 'Guinzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018839', '018', 'Liconasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018840', '018', 'Mandrino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018841', '018', 'Mangialupo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018842', '018', 'Mezzano Parpanese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018843', '018', 'Mezzano Siccomario', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018844', '018', 'Mirabello ed Uniti di Pavia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018845', '018', 'Misano Olona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018846', '018', 'Montebolognola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018847', '018', 'Monteleone sui Colli Pavesi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018848', '018', 'Montesano al Piano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018849', '018', 'Montù Berchielli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018850', '018', 'Motta San Damiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018851', '018', 'Origioso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018852', '018', 'Pairana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018853', '018', 'Papiago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018854', '018', 'Pietra Gavina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018855', '018', 'Pissarello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018856', '018', 'Pizzocorno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018857', '018', 'Pometo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018858', '018', 'Pontecarate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018859', '018', 'Prado', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018860', '018', 'Sagliano di Crenna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018861', '018', 'San Perone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018862', '018', 'San Ponzo Semola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018863', '018', 'San Varese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018864', '018', 'San Zeno e Foppa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018865', '018', 'Sant’Albano di Bobbio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018866', '018', 'Santa Margherita di Bobbio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018867', '018', 'Santa Margherita Po', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018868', '018', 'Spirago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018869', '018', 'Staghiglione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018870', '018', 'Terrasa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018871', '018', 'Torradello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018872', '018', 'Torre Beretti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018873', '018', 'Torre de'' Torti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018874', '018', 'Torre del Mangano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018875', '018', 'Torre del Monte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018876', '018', 'Torriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018877', '018', 'Torrino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018878', '018', 'Trebbiano Nizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018879', '018', 'Trognano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018880', '018', 'Turago Bordone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018881', '018', 'Vaccarizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018882', '018', 'Vairano Pavese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018883', '018', 'Verrua Siccomario', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018884', '018', 'Vigalfo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018885', '018', 'Vigonzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018886', '018', 'Villalunga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018887', '018', 'Villareggio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018888', '018', 'Vimanone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018889', '018', 'Vivente', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018890', '018', 'Zavattarello Valverde', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018891', '018', 'Zelata', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('018892', '018', 'Zibido al Lambro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019001', '019', 'Acquanegra Cremonese', 'A039', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019002', '019', 'Agnadello', 'A076', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019003', '019', 'Annicco', 'A299', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019004', '019', 'Azzanello', 'A526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019005', '019', 'Bagnolo Cremasco', 'A570', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019006', '019', 'Bonemerse', 'A972', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019007', '019', 'Bordolano', 'A986', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019008', '019', 'Ca'' d''Andrea', 'B320', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019009', '019', 'Calvatone', 'B439', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019010', '019', 'Camisano', 'B484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019011', '019', 'Campagnola Cremasca', 'B498', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019012', '019', 'Capergnanica', 'B650', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019013', '019', 'Cappella Cantone', 'B679', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019014', '019', 'Cappella de'' Picenardi', 'B680', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019015', '019', 'Capralba', 'B686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019016', '019', 'Casalbuttano ed Uniti', 'B869', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019017', '019', 'Casale Cremasco-Vidolasco', 'B881', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019018', '019', 'Casaletto Ceredano', 'B889', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019019', '019', 'Casaletto di Sopra', 'B890', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019020', '019', 'Casaletto Vaprio', 'B891', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019021', '019', 'Casalmaggiore', 'B898', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019022', '019', 'Casalmorano', 'B900', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019024', '019', 'Castel Gabbiano', 'C115', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019023', '019', 'Casteldidone', 'C089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019025', '019', 'Castelleone', 'C153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019026', '019', 'Castelverde', 'B129', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019027', '019', 'Castelvisconti', 'C290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019028', '019', 'Cella Dati', 'C435', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019029', '019', 'Chieve', 'C634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019030', '019', 'Cicognolo', 'C678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019031', '019', 'Cingia de'' Botti', 'C703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019032', '019', 'Corte de'' Cortesi con Cignone', 'D056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019033', '019', 'Corte de'' Frati', 'D057', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019034', '019', 'Credera Rubbiano', 'D141', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019035', '019', 'Crema', 'D142', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019036', '019', 'Cremona', 'D150', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019037', '019', 'Cremosano', 'D151', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019038', '019', 'Crotta d''Adda', 'D186', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019039', '019', 'Cumignano sul Naviglio', 'D203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019040', '019', 'Derovere', 'D278', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019041', '019', 'Dovera', 'D358', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019042', '019', 'Drizzona', 'D370', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019043', '019', 'Fiesco', 'D574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019044', '019', 'Formigara', 'D710', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019045', '019', 'Gabbioneta-Binanuova', 'D834', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019046', '019', 'Gadesco-Pieve Delmona', 'D841', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019047', '019', 'Genivolta', 'D966', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019048', '019', 'Gerre de'' Caprioli', 'D993', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019049', '019', 'Gombito', 'E082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019050', '019', 'Grontardo', 'E193', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019051', '019', 'Grumello Cremonese ed Uniti', 'E217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019052', '019', 'Gussola', 'E272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019053', '019', 'Isola Dovarese', 'E356', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019054', '019', 'Izano', 'E380', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019055', '019', 'Madignano', 'E793', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019056', '019', 'Malagnino', 'E843', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019057', '019', 'Martignana di Po', 'E983', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019058', '019', 'Monte Cremasco', 'F434', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019059', '019', 'Montodine', 'F681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019060', '019', 'Moscazzano', 'F761', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019061', '019', 'Motta Baluffi', 'F771', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019062', '019', 'Offanengo', 'G004', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019063', '019', 'Olmeneta', 'G047', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019064', '019', 'Ostiano', 'G185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019065', '019', 'Paderno Ponchielli', 'G222', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019066', '019', 'Palazzo Pignano', 'G260', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019067', '019', 'Pandino', 'G306', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019068', '019', 'Persico Dosimo', 'G469', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019069', '019', 'Pescarolo ed Uniti', 'G483', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019070', '019', 'Pessina Cremonese', 'G504', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019071', '019', 'Piadena', 'G536', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019072', '019', 'Pianengo', 'G558', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019073', '019', 'Pieranica', 'G603', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019074', '019', 'Pieve d''Olmi', 'G647', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019075', '019', 'Pieve San Giacomo', 'G651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019076', '019', 'Pizzighettone', 'G721', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019077', '019', 'Pozzaglio ed Uniti', 'B914', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019078', '019', 'Quintano', 'H130', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019079', '019', 'Ricengo', 'H276', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019080', '019', 'Ripalta Arpina', 'H314', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019081', '019', 'Ripalta Cremasca', 'H315', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019082', '019', 'Ripalta Guerina', 'H316', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019083', '019', 'Rivarolo del Re ed Uniti', 'H341', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019084', '019', 'Rivolta d''Adda', 'H357', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019085', '019', 'Robecco d''Oglio', 'H372', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019086', '019', 'Romanengo', 'H508', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019087', '019', 'Salvirola', 'H731', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019088', '019', 'San Bassano', 'H767', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019089', '019', 'San Daniele Po', 'H815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019090', '019', 'San Giovanni in Croce', 'H918', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019091', '019', 'San Martino del Lago', 'I007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019092', '019', 'Scandolara Ravara', 'I497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019093', '019', 'Scandolara Ripa d''Oglio', 'I498', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019094', '019', 'Sergnano', 'I627', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019095', '019', 'Sesto ed Uniti', 'I683', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019096', '019', 'Solarolo Rainerio', 'I790', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019097', '019', 'Soncino', 'I827', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019098', '019', 'Soresina', 'I849', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019099', '019', 'Sospiro', 'I865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019100', '019', 'Spinadesco', 'I906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019101', '019', 'Spineda', 'I909', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019102', '019', 'Spino d''Adda', 'I914', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019103', '019', 'Stagno Lombardo', 'I935', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019104', '019', 'Ticengo', 'L164', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019105', '019', 'Torlino Vimercati', 'L221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019106', '019', 'Tornata', 'L225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019107', '019', 'Torre de'' Picenardi', 'L258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019108', '019', 'Torricella del Pizzo', 'L296', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019109', '019', 'Trescore Cremasco', 'L389', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019110', '019', 'Trigolo', 'L426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019111', '019', 'Vaiano Cremasco', 'L535', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019112', '019', 'Vailate', 'L539', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019113', '019', 'Vescovato', 'L806', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019114', '019', 'Volongo', 'M116', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019115', '019', 'Voltido', 'M127', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019801', '019', 'Acqualunga Badona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019802', '019', 'Alfiano ed Uniti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019803', '019', 'Ardole San Marino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019804', '019', 'Bagnarolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019805', '019', 'Barbiselle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019806', '019', 'Barzaniga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019807', '019', 'Bettenesco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019808', '019', 'Binanuova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019809', '019', 'Bottaiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019810', '019', 'Brancere', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019811', '019', 'Breda Guazzona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019812', '019', 'Brolpasino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019813', '019', 'Ca'' de'' Bonavogli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019814', '019', 'Ca'' de'' Caggi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019815', '019', 'Ca'' de'' Corti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019816', '019', 'Ca'' de'' Quinzani', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019817', '019', 'Ca'' de'' Sfondrati', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019818', '019', 'Ca'' de'' Soresini', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019819', '019', 'Ca'' de'' Staoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019820', '019', 'Ca'' de'' Stefani', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019821', '019', 'Canova del Morbasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019822', '019', 'Canova Olzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019823', '019', 'Cansero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019824', '019', 'Carpaneta con Dosimo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019825', '019', 'Caruberto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019826', '019', 'Casale Cremasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019827', '019', 'Casalorzo Geroldi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019828', '019', 'Casalsigone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019829', '019', 'Casanova d''Offredi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019830', '019', 'Cassine Gandine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019831', '019', 'Castelfranco d''Oglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019832', '019', 'Castelnuovo Cremasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019833', '019', 'Castelnuovo del Vescovo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019834', '019', 'Castelnuovo del Zappa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019835', '019', 'Castelnuovo Gherardi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019836', '019', 'Castelponzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019837', '019', 'Cava Tigozzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019838', '019', 'Cavallara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019839', '019', 'Cella Dati', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019840', '019', 'Cignone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019841', '019', 'Colombarolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019842', '019', 'Corpi Santi di Cremona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019843', '019', 'Corte Madama', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019844', '019', 'Cortetano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019845', '019', 'Costa Sant''Abramo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019846', '019', 'Credera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019847', '019', 'Dosso Baroardo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019848', '019', 'Dosso de'' Frati', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019849', '019', 'Duemiglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019850', '019', 'Farinate', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019851', '019', 'Fengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019852', '019', 'Forcello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019853', '019', 'Fossa Guazzona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019854', '019', 'Fracchia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019855', '019', 'Gabbioneta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019856', '019', 'Gadesco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019857', '019', 'Gambina Barchetti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019858', '019', 'Gazzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019859', '019', 'Gradella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019860', '019', 'Grontorto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019861', '019', 'Isola Pescaroli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019862', '019', 'Isolello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019863', '019', 'Levata', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019864', '019', 'Licengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019865', '019', 'Longardore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019866', '019', 'Luignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019867', '019', 'Marzalengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019868', '019', 'Mirabello Ciria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019869', '019', 'Montanara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019870', '019', 'Monticelli Ripa d''Oglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019871', '019', 'Nosadello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019872', '019', 'Ombriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019873', '019', 'Ossalengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019874', '019', 'Ossolaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019875', '019', 'Paderno Cremonese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019876', '019', 'Palvareto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019877', '019', 'Passarera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019878', '019', 'Persico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019879', '019', 'Pieve Delmona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019880', '019', 'Pieve San Maurizio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019881', '019', 'Pieve Terzagni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019882', '019', 'Polengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019883', '019', 'Pontirolo Capredoni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019884', '019', 'Porta Ombriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019885', '019', 'Pozzaglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019886', '019', 'Pozzo Baronzio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019887', '019', 'Prato Muzio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019888', '019', 'Quistro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019889', '019', 'Recorfano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019890', '019', 'Ripalta Nuova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019891', '019', 'Ripalta Vecchia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019892', '019', 'Romprezzagno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019893', '019', 'Ronca de'' Golferami', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019894', '019', 'Roncadello d''Adda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019895', '019', 'Rovereto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019896', '019', 'Rubbiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019897', '019', 'San Bernardino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019898', '019', 'San Lorenzo Aroldo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019899', '019', 'San Lorenzo de'' Picenardi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019900', '019', 'San Lorenzo Guazzone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019901', '019', 'San Lorenzo Mondinari', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019902', '019', 'San Martino in Beliseto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019903', '019', 'San Michele Cremasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019904', '019', 'San Paolo Ripa d''Oglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019905', '019', 'San Salvatore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019906', '019', 'San Sillo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019907', '019', 'San Vito e Modesto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019908', '019', 'Santa Maria della Croce', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019909', '019', 'Scannabue', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019910', '019', 'Silvella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019911', '019', 'Solarolo del Persico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019912', '019', 'Solarolo Monasterolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019913', '019', 'Stilo de'' Mariani', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019914', '019', 'Torre d’Angiolini', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019915', '019', 'Tredossi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019916', '019', 'Trezzolasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019917', '019', 'Triburgo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019918', '019', 'Vairano Cremasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019920', '019', 'Vidiceto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019921', '019', 'Vidolasco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019922', '019', 'Vighizzolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019923', '019', 'Villa Rocca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019924', '019', 'Zanengo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019925', '019', 'Zappello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('019926', '019', 'Vho', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020001', '020', 'Acquanegra sul Chiese', 'A038', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020002', '020', 'Asola', 'A470', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020003', '020', 'Bagnolo San Vito', 'A575', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020004', '020', 'Bigarello', 'A866', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020005', '020', 'Borgoforte', 'B011', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020006', '020', 'Borgofranco sul Po', 'B013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020007', '020', 'Bozzolo', 'B110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020008', '020', 'Canneto sull''Oglio', 'B612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020009', '020', 'Carbonara di Po', 'B739', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020010', '020', 'Casalmoro', 'B901', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020011', '020', 'Casaloldo', 'B907', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020012', '020', 'Casalromano', 'B911', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020014', '020', 'Castel d''Ario', 'C076', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020015', '020', 'Castel Goffredo', 'C118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020013', '020', 'Castelbelforte', 'C059', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020016', '020', 'Castellucchio', 'C195', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020017', '020', 'Castiglione delle Stiviere', 'C312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020018', '020', 'Cavriana', 'C406', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020019', '020', 'Ceresara', 'C502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020020', '020', 'Commessaggio', 'C930', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020021', '020', 'Curtatone', 'D227', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020022', '020', 'Dosolo', 'D351', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020023', '020', 'Felonica', 'D529', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020024', '020', 'Gazoldo degli Ippoliti', 'D949', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020025', '020', 'Gazzuolo', 'D959', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020026', '020', 'Goito', 'E078', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020027', '020', 'Gonzaga', 'E089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020028', '020', 'Guidizzolo', 'E261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020029', '020', 'Magnacavallo', 'E818', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020030', '020', 'Mantova', 'E897', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020031', '020', 'Marcaria', 'E922', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020032', '020', 'Mariana Mantovana', 'E949', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020033', '020', 'Marmirolo', 'E962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020034', '020', 'Medole', 'F086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020035', '020', 'Moglia', 'F267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020036', '020', 'Monzambano', 'F705', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020037', '020', 'Motteggiana', 'B012', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020038', '020', 'Ostiglia', 'G186', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020039', '020', 'Pegognaga', 'G417', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020040', '020', 'Pieve di Coriano', 'G633', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020041', '020', 'Piubega', 'G717', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020042', '020', 'Poggio Rusco', 'G753', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020043', '020', 'Pomponesco', 'G816', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020044', '020', 'Ponti sul Mincio', 'G862', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020045', '020', 'Porto Mantovano', 'G917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020046', '020', 'Quingentole', 'H129', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020047', '020', 'Quistello', 'H143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020048', '020', 'Redondesco', 'H218', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020049', '020', 'Revere', 'H248', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020050', '020', 'Rivarolo Mantovano', 'H342', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020051', '020', 'Rodigo', 'H481', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020052', '020', 'Roncoferraro', 'H541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020053', '020', 'Roverbella', 'H604', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020054', '020', 'Sabbioneta', 'H652', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020055', '020', 'San Benedetto Po', 'H771', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020056', '020', 'San Giacomo delle Segnate', 'H870', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020057', '020', 'San Giorgio di Mantova', 'H883', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020058', '020', 'San Giovanni del Dosso', 'H912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020059', '020', 'San Martino dall''Argine', 'I005', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020060', '020', 'Schivenoglia', 'I532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020061', '020', 'Sermide e Felonica', 'I632', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020062', '020', 'Serravalle a Po', 'I662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020063', '020', 'Solferino', 'I801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020064', '020', 'Sustinente', 'L015', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020065', '020', 'Suzzara', 'L020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020066', '020', 'Viadana', 'L826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020067', '020', 'Villa Poma', 'F804', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020068', '020', 'Villimpenta', 'M044', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020069', '020', 'Virgilio', 'H123', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020070', '020', 'Volta Mantovana', 'M125', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020071', '020', 'Borgo Virgilio', 'M340', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020072', '020', 'Borgo Mantovano', 'M396', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('020801', '020', 'Casalpoglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021001', '021', 'Aldino', 'A179', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021002', '021', 'Andriano', 'A286', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021003', '021', 'Anterivo', 'A306', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021004', '021', 'Appiano sulla strada del vino', 'A332', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021005', '021', 'Avelengo', 'A507', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021006', '021', 'Badia', 'A537', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021007', '021', 'Barbiano', 'A635', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021008', '021', 'Bolzano', 'A952', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021009', '021', 'Braies', 'B116', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021010', '021', 'Brennero', 'B145', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021011', '021', 'Bressanone', 'B160', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021012', '021', 'Bronzolo', 'B203', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021013', '021', 'Brunico', 'B220', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021014', '021', 'Caines', 'B364', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021015', '021', 'Caldaro sulla strada del vino', 'B397', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021016', '021', 'Campo di Trens', 'B529', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021017', '021', 'Campo Tures', 'B570', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021018', '021', 'Castelbello-Ciardes', 'C062', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021019', '021', 'Castelrotto', 'C254', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021020', '021', 'Cermes', 'A022', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021021', '021', 'Chienes', 'C625', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021022', '021', 'Chiusa', 'C652', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021023', '021', 'Cornedo all''Isarco', 'B799', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021024', '021', 'Cortaccia sulla strada del vino', 'D048', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021025', '021', 'Cortina sulla strada del vino', 'D075', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021026', '021', 'Corvara in Badia', 'D079', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021027', '021', 'Curon Venosta', 'D222', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021028', '021', 'Dobbiaco', 'D311', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021029', '021', 'Egna', 'D392', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021030', '021', 'Falzes', 'D484', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021031', '021', 'Fiè allo Sciliar', 'D571', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021032', '021', 'Fortezza', 'D731', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021033', '021', 'Funes', 'D821', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021034', '021', 'Gais', 'D860', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021035', '021', 'Gargazzone', 'D923', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021036', '021', 'Glorenza', 'E069', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021117', '021', 'La Valle', 'E491', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021037', '021', 'Laces', 'E398', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021038', '021', 'Lagundo', 'E412', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021039', '021', 'Laion', 'E420', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021040', '021', 'Laives', 'E421', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021041', '021', 'Lana', 'E434', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021042', '021', 'Lasa', 'E457', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021043', '021', 'Lauregno', 'E481', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021044', '021', 'Luson', 'E764', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021045', '021', 'Magrè sulla strada del vino', 'E829', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021046', '021', 'Malles Venosta', 'E862', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021047', '021', 'Marebbe', 'E938', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021048', '021', 'Marlengo', 'E959', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021049', '021', 'Martello', 'E981', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021050', '021', 'Meltina', 'F118', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021051', '021', 'Merano', 'F132', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021052', '021', 'Monguelfo-Tesido', 'F371', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021053', '021', 'Montagna', 'F392', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021054', '021', 'Moso in Passiria', 'F766', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021055', '021', 'Nalles', 'F836', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021056', '021', 'Naturno', 'F849', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021057', '021', 'Naz-Sciaves', 'F856', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021058', '021', 'Nova Levante', 'F949', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021059', '021', 'Nova Ponente', 'F950', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021060', '021', 'Ora', 'G083', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021061', '021', 'Ortisei', 'G140', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021062', '021', 'Parcines', 'G328', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021063', '021', 'Perca', 'G443', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021064', '021', 'Plaus', 'G299', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021065', '021', 'Ponte Gardena', 'G830', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021066', '021', 'Postal', 'G936', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021067', '021', 'Prato allo Stelvio', 'H004', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021068', '021', 'Predoi', 'H019', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021069', '021', 'Proves', 'H081', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021070', '021', 'Racines', 'H152', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021071', '021', 'Rasun-Anterselva', 'H189', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021072', '021', 'Renon', 'H236', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021073', '021', 'Rifiano', 'H284', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021074', '021', 'Rio di Pusteria', 'H299', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021075', '021', 'Rodengo', 'H475', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021076', '021', 'Salorno', 'H719', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021077', '021', 'San Candido', 'H786', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021079', '021', 'San Genesio Atesino', 'H858', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021080', '021', 'San Leonardo in Passiria', 'H952', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021081', '021', 'San Lorenzo di Sebato', 'H956', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021082', '021', 'San Martino in Badia', 'H988', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021083', '021', 'San Martino in Passiria', 'H989', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021084', '021', 'San Pancrazio', 'I065', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021085', '021', 'Santa Cristina Valgardena', 'I173', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021086', '021', 'Sarentino', 'I431', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021087', '021', 'Scena', 'I519', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021088', '021', 'Selva dei Molini', 'I593', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021089', '021', 'Selva di Val Gardena', 'I591', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021091', '021', 'Senales', 'I604', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021118', '021', 'Senale-San Felice', 'I603', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021092', '021', 'Sesto', 'I687', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021093', '021', 'Silandro', 'I729', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021094', '021', 'Sluderno', 'I771', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021095', '021', 'Stelvio', 'I948', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021096', '021', 'Terento', 'L106', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021097', '021', 'Terlano', 'L108', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021098', '021', 'Termeno sulla strada del vino', 'L111', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021099', '021', 'Tesimo', 'L149', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021100', '021', 'Tires', 'L176', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021101', '021', 'Tirolo', 'L178', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021102', '021', 'Trodena nel parco naturale', 'L444', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021103', '021', 'Tubre', 'L455', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021104', '021', 'Ultimo', 'L490', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021105', '021', 'Vadena', 'L527', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021107', '021', 'Val di Vizze', 'L564', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021106', '021', 'Valdaora', 'L552', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021108', '021', 'Valle Aurina', 'L595', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021109', '021', 'Valle di Casies', 'L601', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021110', '021', 'Vandoies', 'L660', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021111', '021', 'Varna', 'L687', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021116', '021', 'Velturno', 'L724', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021112', '021', 'Verano', 'L745', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021113', '021', 'Villabassa', 'L915', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021114', '021', 'Villandro', 'L971', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021115', '021', 'Vipiteno', 'M067', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021078', '021', 'San Felice/St. Felix', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021090', '021', 'Senale/U.L.Frau im Walde', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021801', '021', 'Acereto/Ahornach', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021802', '021', 'Albes/Albeins', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021803', '021', 'Alliz/Allitz', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021804', '021', 'Anterselva/Antholz', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021805', '021', 'Burgusio/Burgeis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021806', '021', 'Caminata in Tures/Kematen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021807', '021', 'Castelbello/Kastelbell', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021808', '021', 'Casteldarne/Ehrenburg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021809', '021', 'Cauria/Gfrill', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021810', '021', 'Cengles/Tschengls', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021811', '021', 'Ceves/Tschöfs', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021812', '021', 'Ciardes/Tschars', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021813', '021', 'Clusio/Schleis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021814', '021', 'Coldrano/Goldrain', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021815', '021', 'Colfosco/Colfosco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021816', '021', 'Colle in Casies/Pichl in Gsies', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021817', '021', 'Colli in Pusteria/Pichlern', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021818', '021', 'Colsano/Galsaun', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021819', '021', 'Corti in Pusteria/Hofern', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021820', '021', 'Corvara in Passiria/Rabenstein', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021821', '021', 'Corzes/Kortsch', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021822', '021', 'Covelano/Göflan', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021823', '021', 'Curon/Graun', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021824', '021', 'Elle/Ellen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021825', '021', 'Eores/Afers', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021826', '021', 'Favogna di Sotto/Unterfennberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021827', '021', 'Fleres/Pflersch', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021828', '021', 'Foiana/Völlan', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021829', '021', 'Fundres/Pfunders', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021830', '021', 'Gries/Gries', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021831', '021', 'Grimaldo/Greinwalden', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021832', '021', 'Gudon/Gufidaun', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021833', '021', 'Issengo/Issing', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021834', '021', 'Lacinigo/Latschinig', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021835', '021', 'Lappago/Lappach', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021836', '021', 'Laudes/Laatsch', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021837', '021', 'Lazfons/Latzfons', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021838', '021', 'Longiarù/Campill', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021839', '021', 'Lutago/Luttach', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021840', '021', 'Magrè/Margreid', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021841', '021', 'Maia Alta/Obermais', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021842', '021', 'Maia Bassa/Untermais', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021843', '021', 'Mallas/Mals', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021844', '021', 'Mantana/Monthal', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021845', '021', 'Maranza/Meransen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021846', '021', 'Mareta/Mareit', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021847', '021', 'Mazia/Matsch', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021848', '021', 'Millan-Sarnes/Milland-Sarns', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021849', '021', 'Molini di Tures/Mühlen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021850', '021', 'Monghezzo di Fuori/Getzenberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021851', '021', 'Montassilone/Tesselberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021852', '021', 'Monte di Mezzodì/Sonnenberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021853', '021', 'Monte di Tramontana/Nördersberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021854', '021', 'Monte San Candido/Innichberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021855', '021', 'Montechiaro/Lichtenberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021856', '021', 'Montefontana/Tomberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021857', '021', 'Monteponente/Pfeffersberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021858', '021', 'Morter/Morter', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021859', '021', 'Mules/Mauls', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021860', '021', 'Naz/Natz', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021861', '021', 'Novacella/Neustift', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021862', '021', 'Onies/Onach', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021863', '021', 'Oris/Eyrs', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021864', '021', 'Planol/Planeil', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021865', '021', 'Plata/Platt', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021866', '021', 'Prati/Wiesen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021867', '021', 'Prato alla Drava/Winnebach', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021868', '021', 'Prato di Venosta/Prad', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021869', '021', 'Quarazze/Gratsch', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021870', '021', 'Rasun di Sopra/Oberrasen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021871', '021', 'Rasun di Sotto/Niederrasen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021872', '021', 'Rasun Valdaora/Rasen Olang', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021873', '021', 'Resia/Reschen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021874', '021', 'Ridanna/Riednaun', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021875', '021', 'Rina/Welschellen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021876', '021', 'Riomolino/Mühlbach', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021877', '021', 'Riscone/Reischach', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021878', '021', 'Riva di Tures/Rain', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021879', '021', 'San Valentino alla Mutta/St. Valentin auf der Haide', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021881', '021', 'San Giacomo/St. Jakob in Ahrn', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021882', '021', 'San Giorgio/St. Georgen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021883', '021', 'San Giovanni/St. Johann in Ahrn', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021884', '021', 'San Leonardo/St. Leonhard', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021885', '021', 'San Lugano/St. Lugano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021886', '021', 'San Martino al Monte/St. Martin am Vorberg', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021887', '021', 'San Martino in Casies/St. Martin in Gsies', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021888', '021', 'San Pietro/St. Peter in Ahrn', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021889', '021', 'San Sigismondo/St. Sigmund', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021890', '021', 'San Valentino al Brennero/Brenner', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021891', '021', 'Sant''Andrea in Monte/St. Andrä', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021892', '021', 'Santa Maddalena in Casies/St. Magdalena in Gsies', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021893', '021', 'Scaleres/Schalders', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021894', '021', 'Sciaves/Schabs', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021896', '021', 'Slingia/Schlinig', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021897', '021', 'Spinga/Spinges', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021898', '021', 'Stava/Staben', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021899', '021', 'Stilves/Stilfes', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021900', '021', 'Tablà/Tabland', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021901', '021', 'Tanas/Tannas', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021902', '021', 'Tarces/Tartsch', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021903', '021', 'Tarres/Tarsch', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021904', '021', 'Telves/Telfes', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021905', '021', 'Teodone/Dietenheim', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021906', '021', 'Tesido/Taisten', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021907', '021', 'Tiso/Teis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021908', '021', 'Trens/Trens', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021909', '021', 'Tunes/Thuins', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021910', '021', 'Valas/Flaas', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021911', '021', 'Valgiovo/Jaufenthal', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021912', '021', 'Vallarga/Weitental', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021913', '021', 'Valle San Silvestro/Wahlen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021914', '021', 'Vallelunga/Langtaufers', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021915', '021', 'Valles/Vals', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021916', '021', 'Vandoies di Sopra/Obervintl', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021917', '021', 'Vandoies di Sotto/Niedervintl', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021918', '021', 'Vanga/Wangen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021920', '021', 'Vezzano/Vezzan', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021921', '021', 'Villa Ottone/Uttenhein', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021922', '021', 'Villa Santa Caterina/Aufhofen', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021923', '021', 'Vizze/Pfitsch', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('021924', '021', 'Versciaco/Vierschach', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022228', '022', 'Comano Terme', 'M314', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022229', '022', 'Ledro', 'M313', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022233', '022', 'Dimaro Folgarida', 'M366', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022234', '022', 'Pieve di Bono-Prezzo', 'M365', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022235', '022', 'Altavalle', 'M349', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022236', '022', 'Altopiano della Vigolana', 'M350', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022237', '022', 'Amblar-Don', 'M351', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022001', '022', 'Ala', 'A116', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022002', '022', 'Albiano', 'A158', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022003', '022', 'Aldeno', 'A178', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022004', '022', 'Amblar', 'A260', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022005', '022', 'Andalo', 'A274', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022006', '022', 'Arco', 'A372', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022007', '022', 'Avio', 'A520', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022009', '022', 'Baselga di Pinè', 'A694', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022011', '022', 'Bedollo', 'A730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022012', '022', 'Bersone', 'A808', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022013', '022', 'Besenello', 'A821', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022015', '022', 'Bieno', 'A863', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022017', '022', 'Bleggio Superiore', 'A902', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022018', '022', 'Bocenago', 'A916', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022019', '022', 'Bolbeno', 'A933', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022020', '022', 'Bondo', 'A967', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022021', '022', 'Bondone', 'A968', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022022', '022', 'Borgo Valsugana', 'B006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022023', '022', 'Bosentino', 'B078', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022024', '022', 'Breguzzo', 'B135', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022025', '022', 'Brentonico', 'B153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022026', '022', 'Bresimo', 'B158', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022027', '022', 'Brez', 'B165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022028', '022', 'Brione', 'B185', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022029', '022', 'Caderzone Terme', 'B335', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022238', '022', 'Borgo Chiese', 'M352', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022030', '022', 'Cagnò', 'B360', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022031', '022', 'Calavino', 'B386', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022032', '022', 'Calceranica al Lago', 'B389', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022033', '022', 'Caldes', 'B400', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022034', '022', 'Caldonazzo', 'B404', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022035', '022', 'Calliano', 'B419', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022036', '022', 'Campitello di Fassa', 'B514', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022037', '022', 'Campodenno', 'B525', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022038', '022', 'Canal San Bovo', 'B577', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022039', '022', 'Canazei', 'B579', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022040', '022', 'Capriana', 'B697', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022041', '022', 'Carano', 'B723', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022042', '022', 'Carisolo', 'B783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022043', '022', 'Carzano', 'B856', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022045', '022', 'Castel Condino', 'C183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022046', '022', 'Castelfondo', 'C103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022048', '022', 'Castello Tesino', 'C194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022047', '022', 'Castello-Molina di Fiemme', 'C189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022049', '022', 'Castelnuovo', 'C216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022050', '022', 'Cavalese', 'C372', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022051', '022', 'Cavareno', 'C380', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022052', '022', 'Cavedago', 'C392', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022053', '022', 'Cavedine', 'C393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022054', '022', 'Cavizzana', 'C400', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022055', '022', 'Cembra', 'C452', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022056', '022', 'Centa San Nicolò', 'C467', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022057', '022', 'Cimego', 'C694', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022058', '022', 'Cimone', 'C700', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022059', '022', 'Cinte Tesino', 'C712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022060', '022', 'Cis', 'C727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022061', '022', 'Civezzano', 'C756', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022062', '022', 'Cles', 'C794', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022063', '022', 'Cloz', 'C797', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022064', '022', 'Commezzadura', 'C931', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022066', '022', 'Condino', 'C953', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022067', '022', 'Coredo', 'C994', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022068', '022', 'Croviana', 'D188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022069', '022', 'Cunevo', 'D206', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022070', '022', 'Daiano', 'D243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022071', '022', 'Dambel', 'D246', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022072', '022', 'Daone', 'D248', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022073', '022', 'Darè', 'D250', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022074', '022', 'Denno', 'D273', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022075', '022', 'Dimaro', 'D302', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022076', '022', 'Don', 'D336', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022077', '022', 'Dorsino', 'D349', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022078', '022', 'Drena', 'D365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022079', '022', 'Dro', 'D371', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022080', '022', 'Faedo', 'D457', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022081', '022', 'Fai della Paganella', 'D468', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022082', '022', 'Faver', 'D516', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022083', '022', 'Fiavè', 'D565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022084', '022', 'Fiera di Primiero', 'D572', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022085', '022', 'Fierozzo', 'D573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022086', '022', 'Flavon', 'D631', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022087', '022', 'Folgaria', 'D651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022088', '022', 'Fondo', 'D663', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022089', '022', 'Fornace', 'D714', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022090', '022', 'Frassilongo', 'D775', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022091', '022', 'Garniga Terme', 'D928', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022092', '022', 'Giovo', 'E048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022093', '022', 'Giustino', 'E065', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022094', '022', 'Grauno', 'E150', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022095', '022', 'Grigno', 'E178', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022096', '022', 'Grumes', 'E222', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022097', '022', 'Imer', 'E288', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022098', '022', 'Isera', 'E334', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022099', '022', 'Ivano-Fracena', 'E378', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022100', '022', 'Lardaro', 'E452', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022101', '022', 'Lasino', 'E461', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022102', '022', 'Lavarone', 'E492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022103', '022', 'Lavis', 'E500', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022104', '022', 'Levico Terme', 'E565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022105', '022', 'Lisignago', 'E614', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022106', '022', 'Livo', 'E624', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022108', '022', 'Lona-Lases', 'E664', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022109', '022', 'Luserna', 'E757', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022110', '022', 'Malé', 'E850', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022111', '022', 'Malosco', 'E866', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022112', '022', 'Massimeno', 'F045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022113', '022', 'Mazzin', 'F068', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022114', '022', 'Mezzana', 'F168', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022115', '022', 'Mezzano', 'F176', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022116', '022', 'Mezzocorona', 'F183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022117', '022', 'Mezzolombardo', 'F187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022118', '022', 'Moena', 'F263', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022120', '022', 'Molveno', 'F307', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022121', '022', 'Monclassico', 'F341', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022122', '022', 'Montagne', 'F396', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022123', '022', 'Mori', 'F728', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022124', '022', 'Nago-Torbole', 'F835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022125', '022', 'Nanno', 'F837', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022126', '022', 'Nave San Rocco', 'F853', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022127', '022', 'Nogaredo', 'F920', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022128', '022', 'Nomi', 'F929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022129', '022', 'Novaledo', 'F947', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022130', '022', 'Ospedaletto', 'G168', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022131', '022', 'Ossana', 'G173', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022132', '022', 'Padergnone', 'G214', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022133', '022', 'Palù del Fersina', 'G296', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022134', '022', 'Panchià', 'G305', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022136', '022', 'Peio', 'G419', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022137', '022', 'Pellizzano', 'G428', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022138', '022', 'Pelugo', 'G429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022139', '022', 'Pergine Valsugana', 'G452', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022140', '022', 'Pieve di Bono', 'G641', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022142', '022', 'Pieve Tesino', 'G656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022143', '022', 'Pinzolo', 'G681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022144', '022', 'Pomarolo', 'G808', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022145', '022', 'Pozza di Fassa', 'G950', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022146', '022', 'Praso', 'G989', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022147', '022', 'Predazzo', 'H018', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022148', '022', 'Preore', 'H039', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022149', '022', 'Prezzo', 'H057', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022150', '022', 'Rabbi', 'H146', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022151', '022', 'Ragoli', 'H162', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022152', '022', 'Revò', 'H254', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022153', '022', 'Riva del Garda', 'H330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022154', '022', 'Romallo', 'H506', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022155', '022', 'Romeno', 'H517', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022156', '022', 'Roncegno Terme', 'H528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022157', '022', 'Ronchi Valsugana', 'H532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022158', '022', 'Roncone', 'H545', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022135', '022', 'Ronzo-Chienis', 'M303', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022159', '022', 'Ronzone', 'H552', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022160', '022', 'Roverè della Luna', 'H607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022161', '022', 'Rovereto', 'H612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022162', '022', 'Ruffrè-Mendola', 'H634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022163', '022', 'Rumo', 'H639', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022164', '022', 'Sagron Mis', 'H666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022165', '022', 'Samone', 'H754', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022166', '022', 'San Lorenzo in Banale', 'H966', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022167', '022', 'San Michele all''Adige', 'I042', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022168', '022', 'Sant''Orsola Terme', 'I354', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022169', '022', 'Sanzeno', 'I411', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022170', '022', 'Sarnonico', 'I439', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022171', '022', 'Scurelle', 'I554', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022172', '022', 'Segonzano', 'I576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022173', '022', 'Sfruz', 'I714', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022174', '022', 'Siror', 'I760', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022175', '022', 'Smarano', 'I772', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022176', '022', 'Soraga di Fassa', 'I839', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022177', '022', 'Sover', 'I871', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022178', '022', 'Spera', 'I889', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022179', '022', 'Spiazzo', 'I899', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022180', '022', 'Spormaggiore', 'I924', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022181', '022', 'Sporminore', 'I925', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022182', '022', 'Stenico', 'I949', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022183', '022', 'Storo', 'I964', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022184', '022', 'Strembo', 'I975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022185', '022', 'Strigno', 'I979', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022186', '022', 'Taio', 'L033', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022187', '022', 'Tassullo', 'L060', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022188', '022', 'Telve', 'L089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022189', '022', 'Telve di Sopra', 'L090', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022190', '022', 'Tenna', 'L096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022191', '022', 'Tenno', 'L097', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022192', '022', 'Terlago', 'L107', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022193', '022', 'Terragnolo', 'L121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022194', '022', 'Terres', 'L137', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022195', '022', 'Terzolas', 'L145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022196', '022', 'Tesero', 'L147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022199', '022', 'Tione di Trento', 'L174', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022200', '022', 'Ton', 'L200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022201', '022', 'Tonadico', 'L201', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022202', '022', 'Torcegno', 'L211', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022203', '022', 'Trambileno', 'L322', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022204', '022', 'Transacqua', 'L329', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022205', '022', 'Trento', 'L378', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022206', '022', 'Tres', 'L385', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022207', '022', 'Tuenno', 'L457', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022208', '022', 'Valda', 'L550', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022209', '022', 'Valfloriana', 'L575', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022210', '022', 'Vallarsa', 'L588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022211', '022', 'Varena', 'L678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022212', '022', 'Vattaro', 'L697', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022213', '022', 'Vermiglio', 'L769', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022214', '022', 'Vervò', 'L800', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022215', '022', 'Vezzano', 'L821', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022216', '022', 'Vignola-Falesina', 'L886', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022217', '022', 'Vigo di Fassa', 'L893', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022220', '022', 'Vigo Rendena', 'L903', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022219', '022', 'Vigolo Vattaro', 'L896', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022221', '022', 'Villa Agnedo', 'L910', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022222', '022', 'Villa Lagarina', 'L957', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022223', '022', 'Villa Rendena', 'M006', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022224', '022', 'Volano', 'M113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022225', '022', 'Zambana', 'M142', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022226', '022', 'Ziano di Fiemme', 'M173', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022227', '022', 'Zuclo', 'M198', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022239', '022', 'Borgo Lares', 'M353', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022240', '022', 'Castel Ivano', 'M354', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022241', '022', 'Cembra Lisignago', 'M355', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022242', '022', 'Contà', 'M356', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022230', '022', 'Predaia', 'M344', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022231', '022', 'San Lorenzo Dorsino', 'M345', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022232', '022', 'Valdaone', 'M343', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022243', '022', 'Madruzzo', 'M357', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022244', '022', 'Porte di Rendena', 'M358', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022245', '022', 'Primiero San Martino di Castrozza', 'M359', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022246', '022', 'Sella Giudicarie', 'M360', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022247', '022', 'Tre Ville', 'M361', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022248', '022', 'Vallelaghi', 'M362', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022249', '022', 'Ville d''Anaunia', 'M363', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022250', '022', 'Sèn Jan di Fassa', 'M390', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022008', '022', 'Banco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022010', '022', 'Baselga di Vezzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022014', '022', 'Bezzecca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022016', '022', 'Bleggio Inferiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022044', '022', 'Casez', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022065', '022', 'Concei', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022107', '022', 'Lomaso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022119', '022', 'Molina di Ledro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022141', '022', 'Pieve di Ledro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022197', '022', 'Tiarno di Sopra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022198', '022', 'Tiarno di Sotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022218', '022', 'Vigolo Baselga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022801', '022', 'Agrone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022802', '022', 'Almazzago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022803', '022', 'Andogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022804', '022', 'Arnago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022805', '022', 'Beseno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022806', '022', 'Biacesa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022807', '022', 'Bleggio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022808', '022', 'Bolentina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022809', '022', 'Bondo Breguzzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022810', '022', 'Borghetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022811', '022', 'Borzago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022812', '022', 'Bozzana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022813', '022', 'Cadine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022814', '022', 'Celledizzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022815', '022', 'Campo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022816', '022', 'Canezza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022817', '022', 'Carciato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022818', '022', 'Castagnè', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022819', '022', 'Castellano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022820', '022', 'Castello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022821', '022', 'Celentino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022822', '022', 'Chienis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022823', '022', 'Chizzola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022824', '022', 'Ciago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022825', '022', 'Cognola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022826', '022', 'Cogolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022827', '022', 'Cologna in Giudicarie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022828', '022', 'Cologna-Gavazzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022829', '022', 'Comano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022830', '022', 'Comasine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022831', '022', 'Costasavina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022832', '022', 'Covelo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022833', '022', 'Creto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022834', '022', 'Dardine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022835', '022', 'Darzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022836', '022', 'Deggiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022837', '022', 'Dercolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022838', '022', 'Dermulo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022839', '022', 'Enguiso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022840', '022', 'Falesina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022841', '022', 'Fisto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022842', '022', 'Forno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022843', '022', 'Fraveggio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022844', '022', 'Gardolo al Piano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022845', '022', 'Grumo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022846', '022', 'Iavrè', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022847', '022', 'Ischia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022848', '022', 'Legos', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022849', '022', 'Lenzima', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022850', '022', 'Lenzumo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022851', '022', 'Lizzana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022852', '022', 'Locca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022853', '022', 'Lodrone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022854', '022', 'Lon', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022855', '022', 'Lover', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022856', '022', 'Lundo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022857', '022', 'Madrano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022858', '022', 'Madruzzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022859', '022', 'Magras', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022860', '022', 'Malgolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022861', '022', 'Manzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022862', '022', 'Marano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022863', '022', 'Marco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022864', '022', 'Margone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022865', '022', 'Masi di Vigo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022866', '022', 'Mastellina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022867', '022', 'Mattarello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022868', '022', 'Meano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022869', '022', 'Mechel', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022870', '022', 'Mestriago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022871', '022', 'Mezzano Imer', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022872', '022', 'Mezzolago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022873', '022', 'Miola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022874', '022', 'Mollaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022875', '022', 'Montes', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022876', '022', 'Mortaso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022877', '022', 'Noarna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022878', '022', 'Nogarè', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022879', '022', 'Nomesino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022880', '022', 'Noriglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022881', '022', 'Oltresarca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022882', '022', 'Patone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022883', '022', 'Pederzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022884', '022', 'Perra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022885', '022', 'Piano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022886', '022', 'Pilcante', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022887', '022', 'Por', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022888', '022', 'Povo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022889', '022', 'Pranzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022890', '022', 'Prè', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022891', '022', 'Pregasina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022892', '022', 'Preghena', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022893', '022', 'Premione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022894', '022', 'Presson', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022895', '022', 'Primiero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022896', '022', 'Priò', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022897', '022', 'Quetta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022898', '022', 'Ranzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022899', '022', 'Ravina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022900', '022', 'Reviano Folas', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022901', '022', 'Romagnano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022902', '022', 'Romarzolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022903', '022', 'Roncogno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022904', '022', 'Ronzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022905', '022', 'Rover Carbonare', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022906', '022', 'Samoclevo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022907', '022', 'San Giacomo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022908', '022', 'Santa Margherita', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022909', '022', 'Saone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022910', '022', 'Sardagna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022911', '022', 'Sasso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022912', '022', 'Scelmo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022913', '022', 'Segno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022914', '022', 'Seio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022915', '022', 'Seo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022916', '022', 'Serravalle all’Adige', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022917', '022', 'Serso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022918', '022', 'Sevignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022919', '022', 'Sopramonte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022920', '022', 'Strada', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022921', '022', 'Stramentizzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022922', '022', 'Stumiaga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022923', '022', 'Susà', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022924', '022', 'Tavodo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022925', '022', 'Tavon', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022926', '022', 'Termenago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022927', '022', 'Termon', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022928', '022', 'Tiarno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022929', '022', 'Torra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022930', '022', 'Toss', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022931', '022', 'Tuenetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022932', '022', 'Valle San Felice', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022933', '022', 'Vasio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022934', '022', 'Verdesina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022935', '022', 'Viarago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022936', '022', 'Vigalzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022937', '022', 'Vignola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022938', '022', 'Vigo d’Anaunia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022939', '022', 'Villa Banale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022940', '022', 'Villazzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022941', '022', 'Ville del Monte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('022942', '022', 'Vion', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023001', '023', 'Affi', 'A061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023002', '023', 'Albaredo d''Adige', 'A137', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023003', '023', 'Angiari', 'A292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023004', '023', 'Arcole', 'A374', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023005', '023', 'Badia Calavena', 'A540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023006', '023', 'Bardolino', 'A650', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023007', '023', 'Belfiore', 'A737', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023008', '023', 'Bevilacqua', 'A837', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023009', '023', 'Bonavigo', 'A964', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023010', '023', 'Boschi Sant''Anna', 'B070', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023011', '023', 'Bosco Chiesanuova', 'B073', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023012', '023', 'Bovolone', 'B107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023013', '023', 'Brentino Belluno', 'B152', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023014', '023', 'Brenzone sul Garda', 'B154', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023015', '023', 'Bussolengo', 'B296', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023016', '023', 'Buttapietra', 'B304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023017', '023', 'Caldiero', 'B402', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023018', '023', 'Caprino Veronese', 'B709', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023019', '023', 'Casaleone', 'B886', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023020', '023', 'Castagnaro', 'C041', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023021', '023', 'Castel d''Azzano', 'C078', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023022', '023', 'Castelnuovo del Garda', 'C225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023023', '023', 'Cavaion Veronese', 'C370', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023024', '023', 'Cazzano di Tramigna', 'C412', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023025', '023', 'Cerea', 'C498', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023026', '023', 'Cerro Veronese', 'C538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023027', '023', 'Cologna Veneta', 'C890', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023028', '023', 'Colognola ai Colli', 'C897', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023029', '023', 'Concamarise', 'C943', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023030', '023', 'Costermano sul Garda', 'D118', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023031', '023', 'Dolcè', 'D317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023032', '023', 'Erbè', 'D419', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023033', '023', 'Erbezzo', 'D420', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023034', '023', 'Ferrara di Monte Baldo', 'D549', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023035', '023', 'Fumane', 'D818', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023036', '023', 'Garda', 'D915', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023037', '023', 'Gazzo Veronese', 'D957', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023038', '023', 'Grezzana', 'E171', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023039', '023', 'Illasi', 'E284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023040', '023', 'Isola della Scala', 'E349', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023041', '023', 'Isola Rizza', 'E358', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023042', '023', 'Lavagno', 'E489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023043', '023', 'Lazise', 'E502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023044', '023', 'Legnago', 'E512', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023045', '023', 'Malcesine', 'E848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023046', '023', 'Marano di Valpolicella', 'E911', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023047', '023', 'Mezzane di Sotto', 'F172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023048', '023', 'Minerbe', 'F218', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023049', '023', 'Montecchia di Crosara', 'F461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023050', '023', 'Monteforte d''Alpone', 'F508', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023051', '023', 'Mozzecane', 'F789', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023052', '023', 'Negrar', 'F861', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023053', '023', 'Nogara', 'F918', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023054', '023', 'Nogarole Rocca', 'F921', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023055', '023', 'Oppeano', 'G080', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023056', '023', 'Palù', 'G297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023057', '023', 'Pastrengo', 'G365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023058', '023', 'Pescantina', 'G481', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023059', '023', 'Peschiera del Garda', 'G489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023060', '023', 'Povegliano Veronese', 'G945', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023061', '023', 'Pressana', 'H048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023062', '023', 'Rivoli Veronese', 'H356', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023063', '023', 'Roncà', 'H522', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023064', '023', 'Ronco all''Adige', 'H540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023065', '023', 'Roverchiara', 'H606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023067', '023', 'Roverè Veronese', 'H608', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023066', '023', 'Roveredo di Guà', 'H610', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023068', '023', 'Salizzole', 'H714', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023069', '023', 'San Bonifacio', 'H783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023070', '023', 'San Giovanni Ilarione', 'H916', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023071', '023', 'San Giovanni Lupatoto', 'H924', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023073', '023', 'San Martino Buon Albergo', 'I003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023074', '023', 'San Mauro di Saline', 'H712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023075', '023', 'San Pietro di Morubio', 'I105', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023076', '023', 'San Pietro in Cariano', 'I109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023079', '023', 'San Zeno di Montagna', 'I414', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023072', '023', 'Sanguinetto', 'H944', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023077', '023', 'Sant''Ambrogio di Valpolicella', 'I259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023078', '023', 'Sant''Anna d''Alfaedo', 'I292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023080', '023', 'Selva di Progno', 'I594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023081', '023', 'Soave', 'I775', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023082', '023', 'Sommacampagna', 'I821', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023083', '023', 'Sona', 'I826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023084', '023', 'Sorgà', 'I850', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023085', '023', 'Terrazzo', 'L136', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023086', '023', 'Torri del Benaco', 'L287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023087', '023', 'Tregnago', 'L364', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023088', '023', 'Trevenzuolo', 'L396', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023089', '023', 'Valeggio sul Mincio', 'L567', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023090', '023', 'Velo Veronese', 'L722', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023091', '023', 'Verona', 'L781', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023092', '023', 'Veronella', 'D193', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023093', '023', 'Vestenanova', 'L810', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023094', '023', 'Vigasio', 'L869', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023095', '023', 'Villa Bartolomea', 'L912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023096', '023', 'Villafranca di Verona', 'L949', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023097', '023', 'Zevio', 'M172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023098', '023', 'Zimella', 'M178', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023801', '023', 'Avesa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023802', '023', 'Belluno Veronese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023803', '023', 'Bevilacqua-Boschi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023804', '023', 'Brentino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023805', '023', 'Breonio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023806', '023', 'Ca'' di David', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023807', '023', 'Castione Veronese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023808', '023', 'Correzzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023809', '023', 'Marcellise', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023810', '023', 'Mizzole', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023811', '023', 'Montorio Veronese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023812', '023', 'Negarine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023813', '023', 'Parona di Valpolicella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023814', '023', 'Prun', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023815', '023', 'Quinto di Valpantena', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023816', '023', 'Quinzano Veronese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023817', '023', 'San Massimo all''Adige', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023818', '023', 'San Michele Extra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('023819', '023', 'Santa Maria in Stelle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024001', '024', 'Agugliaro', 'A093', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024002', '024', 'Albettone', 'A154', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024003', '024', 'Alonte', 'A220', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024004', '024', 'Altavilla Vicentina', 'A231', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024005', '024', 'Altissimo', 'A236', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024006', '024', 'Arcugnano', 'A377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024007', '024', 'Arsiero', 'A444', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024008', '024', 'Arzignano', 'A459', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024009', '024', 'Asiago', 'A465', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024010', '024', 'Asigliano Veneto', 'A467', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024011', '024', 'Barbarano Vicentino', 'A627', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024012', '024', 'Bassano del Grappa', 'A703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024013', '024', 'Bolzano Vicentino', 'A954', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024014', '024', 'Breganze', 'B132', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024015', '024', 'Brendola', 'B143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024016', '024', 'Bressanvido', 'B161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024017', '024', 'Brogliano', 'B196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024018', '024', 'Caldogno', 'B403', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024019', '024', 'Caltrano', 'B433', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024020', '024', 'Calvene', 'B441', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024021', '024', 'Camisano Vicentino', 'B485', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024022', '024', 'Campiglia dei Berici', 'B511', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024023', '024', 'Campolongo sul Brenta', 'B547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024024', '024', 'Carrè', 'B835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024025', '024', 'Cartigliano', 'B844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024026', '024', 'Cassola', 'C037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024027', '024', 'Castegnero', 'C056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024028', '024', 'Castelgomberto', 'C119', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024029', '024', 'Chiampo', 'C605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024030', '024', 'Chiuppano', 'C650', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024031', '024', 'Cismon del Grappa', 'C734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024032', '024', 'Cogollo del Cengio', 'C824', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024033', '024', 'Conco', 'C949', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024034', '024', 'Cornedo Vicentino', 'D020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024035', '024', 'Costabissara', 'D107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024036', '024', 'Creazzo', 'D136', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024037', '024', 'Crespadoro', 'D156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024038', '024', 'Dueville', 'D379', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024039', '024', 'Enego', 'D407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024040', '024', 'Fara Vicentino', 'D496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024041', '024', 'Foza', 'D750', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024042', '024', 'Gallio', 'D882', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024043', '024', 'Gambellara', 'D897', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024044', '024', 'Gambugliano', 'D902', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024045', '024', 'Grancona', 'E138', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024046', '024', 'Grisignano di Zocco', 'E184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024047', '024', 'Grumolo delle Abbadesse', 'E226', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024048', '024', 'Isola Vicentina', 'E354', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024049', '024', 'Laghi', 'E403', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024050', '024', 'Lastebasse', 'E465', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024051', '024', 'Longare', 'E671', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024052', '024', 'Lonigo', 'E682', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024053', '024', 'Lugo di Vicenza', 'E731', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024054', '024', 'Lusiana', 'E762', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024055', '024', 'Malo', 'E864', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024056', '024', 'Marano Vicentino', 'E912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024057', '024', 'Marostica', 'E970', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024058', '024', 'Mason Vicentino', 'F019', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024059', '024', 'Molvena', 'F306', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024063', '024', 'Monte di Malo', 'F486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024060', '024', 'Montebello Vicentino', 'F442', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024061', '024', 'Montecchio Maggiore', 'F464', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024062', '024', 'Montecchio Precalcino', 'F465', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024064', '024', 'Montegalda', 'F514', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024065', '024', 'Montegaldella', 'F515', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024066', '024', 'Monteviale', 'F662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024067', '024', 'Monticello Conte Otto', 'F675', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024068', '024', 'Montorso Vicentino', 'F696', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024069', '024', 'Mossano', 'F768', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024070', '024', 'Mussolente', 'F829', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024071', '024', 'Nanto', 'F838', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024072', '024', 'Nogarole Vicentino', 'F922', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024073', '024', 'Nove', 'F957', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024074', '024', 'Noventa Vicentina', 'F964', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024075', '024', 'Orgiano', 'G095', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024076', '024', 'Pedemonte', 'G406', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024077', '024', 'Pianezze', 'G560', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024078', '024', 'Piovene Rocchette', 'G694', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024079', '024', 'Pojana Maggiore', 'G776', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024080', '024', 'Posina', 'G931', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024081', '024', 'Pove del Grappa', 'G943', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024082', '024', 'Pozzoleone', 'G957', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024083', '024', 'Quinto Vicentino', 'H134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024084', '024', 'Recoaro Terme', 'H214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024085', '024', 'Roana', 'H361', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024086', '024', 'Romano d''Ezzelino', 'H512', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024087', '024', 'Rosà', 'H556', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024088', '024', 'Rossano Veneto', 'H580', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024089', '024', 'Rotzo', 'H594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024090', '024', 'Salcedo', 'F810', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024092', '024', 'San Germano dei Berici', 'H863', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024093', '024', 'San Nazario', 'I047', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024094', '024', 'San Pietro Mussolino', 'I117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024096', '024', 'San Vito di Leguzzano', 'I401', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024091', '024', 'Sandrigo', 'H829', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024095', '024', 'Santorso', 'I353', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024097', '024', 'Sarcedo', 'I425', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024098', '024', 'Sarego', 'I430', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024099', '024', 'Schiavon', 'I527', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024100', '024', 'Schio', 'I531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024101', '024', 'Solagna', 'I783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024102', '024', 'Sossano', 'I867', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024103', '024', 'Sovizzo', 'I879', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024104', '024', 'Tezze sul Brenta', 'L156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024105', '024', 'Thiene', 'L157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024106', '024', 'Tonezza del Cimone', 'D717', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024107', '024', 'Torrebelvicino', 'L248', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024108', '024', 'Torri di Quartesolo', 'L297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024110', '024', 'Trissino', 'L433', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024111', '024', 'Valdagno', 'L551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024112', '024', 'Valdastico', 'L554', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024113', '024', 'Valli del Pasubio', 'L624', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024114', '024', 'Valstagna', 'L650', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024115', '024', 'Velo d''Astico', 'L723', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024116', '024', 'Vicenza', 'L840', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024117', '024', 'Villaga', 'L952', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024118', '024', 'Villaverla', 'M032', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024119', '024', 'Zanè', 'M145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024120', '024', 'Zermeghedo', 'M170', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024121', '024', 'Zovencedo', 'M194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024122', '024', 'Zugliano', 'M199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024123', '024', 'Val Liona', 'M384', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024124', '024', 'Barbarano Mossano', 'M401', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024109', '024', 'Tretto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024801', '024', 'Casotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024802', '024', 'Crosara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024803', '024', 'Forni di Val d''Astico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024804', '024', 'Magrè Vicentino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024805', '024', 'Novale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024806', '024', 'Treschè Conca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024807', '024', 'Vallonara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('024808', '024', 'Valrovina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025001', '025', 'Agordo', 'A083', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025002', '025', 'Alano di Piave', 'A121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025003', '025', 'Alleghe', 'A206', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025004', '025', 'Arsiè', 'A443', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025005', '025', 'Auronzo di Cadore', 'A501', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025006', '025', 'Belluno', 'A757', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025007', '025', 'Borca di Cadore', 'A982', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025008', '025', 'Calalzo di Cadore', 'B375', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025023', '025', 'Canale d''Agordo', 'B574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025009', '025', 'Castellavazzo', 'C146', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025010', '025', 'Cencenighe Agordino', 'C458', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025011', '025', 'Cesiomaggiore', 'C577', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025012', '025', 'Chies d''Alpago', 'C630', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025013', '025', 'Cibiana di Cadore', 'C672', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025014', '025', 'Colle Santa Lucia', 'C872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025015', '025', 'Comelico Superiore', 'C920', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025016', '025', 'Cortina d''Ampezzo', 'A266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025017', '025', 'Danta di Cadore', 'D247', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025018', '025', 'Domegge di Cadore', 'D330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025019', '025', 'Falcade', 'D470', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025020', '025', 'Farra d''Alpago', 'D506', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025021', '025', 'Feltre', 'D530', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025022', '025', 'Fonzaso', 'D686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025024', '025', 'Forno di Zoldo', 'D726', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025025', '025', 'Gosaldo', 'E113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025027', '025', 'La Valle Agordina', 'E490', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025026', '025', 'Lamon', 'E429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025028', '025', 'Lentiai', 'C562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025029', '025', 'Limana', 'E588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025030', '025', 'Livinallongo del Col di Lana', 'E622', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025031', '025', 'Longarone', 'E672', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025032', '025', 'Lorenzago di Cadore', 'E687', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025033', '025', 'Lozzo di Cadore', 'E708', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025034', '025', 'Mel', 'F094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025035', '025', 'Ospitale di Cadore', 'G169', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025036', '025', 'Pedavena', 'G404', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025037', '025', 'Perarolo di Cadore', 'G442', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025038', '025', 'Pieve d''Alpago', 'G638', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025039', '025', 'Pieve di Cadore', 'G642', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025040', '025', 'Ponte nelle Alpi', 'B662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025041', '025', 'Puos d''Alpago', 'H092', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025042', '025', 'Quero', 'H124', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025043', '025', 'Rivamonte Agordino', 'H327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025044', '025', 'Rocca Pietore', 'H379', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025045', '025', 'San Gregorio nelle Alpi', 'H938', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025046', '025', 'San Nicolò di Comelico', 'I063', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025047', '025', 'San Pietro di Cadore', 'I088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025049', '025', 'San Tomaso Agordino', 'I347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025051', '025', 'San Vito di Cadore', 'I392', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025048', '025', 'Santa Giustina', 'I206', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025050', '025', 'Santo Stefano di Cadore', 'C919', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025053', '025', 'Sedico', 'I563', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025054', '025', 'Selva di Cadore', 'I592', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025055', '025', 'Seren del Grappa', 'I626', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025056', '025', 'Sospirolo', 'I866', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025057', '025', 'Soverzene', 'I876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025058', '025', 'Sovramonte', 'I673', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025059', '025', 'Taibon Agordino', 'L030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025060', '025', 'Tambre', 'L040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025061', '025', 'Trichiana', 'L422', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025062', '025', 'Vallada Agordina', 'L584', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025063', '025', 'Valle di Cadore', 'L590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025064', '025', 'Vas', 'L692', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025065', '025', 'Vigo di Cadore', 'L890', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025066', '025', 'Vodo Cadore', 'M108', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025067', '025', 'Voltago Agordino', 'M124', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025068', '025', 'Zoldo Alto', 'I345', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025069', '025', 'Zoppè di Cadore', 'M189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025070', '025', 'Quero Vas', 'M332', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025071', '025', 'Longarone', 'M342', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025072', '025', 'Alpago', 'M375', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025073', '025', 'Val di Zoldo', 'M374', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026001', '026', 'Altivole', 'A237', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026002', '026', 'Arcade', 'A360', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026003', '026', 'Asolo', 'A471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026004', '026', 'Borso del Grappa', 'B061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026005', '026', 'Breda di Piave', 'B128', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026006', '026', 'Caerano di San Marco', 'B349', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026007', '026', 'Cappella Maggiore', 'B678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026008', '026', 'Carbonera', 'B744', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026009', '026', 'Casale sul Sile', 'B879', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026010', '026', 'Casier', 'B965', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026011', '026', 'Castelcucco', 'C073', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026012', '026', 'Castelfranco Veneto', 'C111', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026013', '026', 'Castello di Godego', 'C190', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026014', '026', 'Cavaso del Tomba', 'C384', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026015', '026', 'Cessalto', 'C580', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026016', '026', 'Chiarano', 'C614', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026017', '026', 'Cimadolmo', 'C689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026018', '026', 'Cison di Valmarino', 'C735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026019', '026', 'Codognè', 'C815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026020', '026', 'Colle Umberto', 'C848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026021', '026', 'Conegliano', 'C957', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026022', '026', 'Cordignano', 'C992', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026023', '026', 'Cornuda', 'D030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026024', '026', 'Crespano del Grappa', 'D157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026025', '026', 'Crocetta del Montello', 'C670', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026026', '026', 'Farra di Soligo', 'D505', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026027', '026', 'Follina', 'D654', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026028', '026', 'Fontanelle', 'D674', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026029', '026', 'Fonte', 'D680', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026030', '026', 'Fregona', 'D794', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026031', '026', 'Gaiarine', 'D854', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026032', '026', 'Giavera del Montello', 'E021', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026033', '026', 'Godega di Sant''Urbano', 'E071', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026034', '026', 'Gorgo al Monticano', 'E092', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026035', '026', 'Istrana', 'E373', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026036', '026', 'Loria', 'E692', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026037', '026', 'Mansuè', 'E893', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026038', '026', 'Mareno di Piave', 'E940', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026039', '026', 'Maser', 'F009', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026040', '026', 'Maserada sul Piave', 'F012', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026041', '026', 'Meduna di Livenza', 'F088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026042', '026', 'Miane', 'F190', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026043', '026', 'Mogliano Veneto', 'F269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026044', '026', 'Monastier di Treviso', 'F332', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026045', '026', 'Monfumo', 'F360', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026046', '026', 'Montebelluna', 'F443', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026047', '026', 'Morgano', 'F725', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026048', '026', 'Moriago della Battaglia', 'F729', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026049', '026', 'Motta di Livenza', 'F770', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026050', '026', 'Nervesa della Battaglia', 'F872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026051', '026', 'Oderzo', 'F999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026052', '026', 'Ormelle', 'G115', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026053', '026', 'Orsago', 'G123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026054', '026', 'Paderno del Grappa', 'G221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026055', '026', 'Paese', 'G229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026056', '026', 'Pederobba', 'G408', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026057', '026', 'Pieve di Soligo', 'G645', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026058', '026', 'Ponte di Piave', 'G846', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026059', '026', 'Ponzano Veneto', 'G875', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026060', '026', 'Portobuffolè', 'G909', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026061', '026', 'Possagno', 'G933', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026062', '026', 'Povegliano', 'G944', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026063', '026', 'Preganziol', 'H022', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026064', '026', 'Quinto di Treviso', 'H131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026065', '026', 'Refrontolo', 'H220', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026066', '026', 'Resana', 'H238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026067', '026', 'Revine Lago', 'H253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026068', '026', 'Riese Pio X', 'H280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026069', '026', 'Roncade', 'H523', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026070', '026', 'Salgareda', 'H706', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026071', '026', 'San Biagio di Callalta', 'H781', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026072', '026', 'San Fior', 'H843', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026073', '026', 'San Pietro di Feletto', 'I103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026074', '026', 'San Polo di Piave', 'I124', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026076', '026', 'San Vendemiano', 'I382', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026077', '026', 'San Zenone degli Ezzelini', 'I417', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026075', '026', 'Santa Lucia di Piave', 'I221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026078', '026', 'Sarmede', 'I435', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026079', '026', 'Segusino', 'I578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026080', '026', 'Sernaglia della Battaglia', 'I635', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026081', '026', 'Silea', 'F116', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026082', '026', 'Spresiano', 'I927', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026083', '026', 'Susegana', 'L014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026084', '026', 'Tarzo', 'L058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026085', '026', 'Trevignano', 'L402', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026086', '026', 'Treviso', 'L407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026087', '026', 'Valdobbiadene', 'L565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026088', '026', 'Vazzola', 'L700', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026089', '026', 'Vedelago', 'L706', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026090', '026', 'Vidor', 'L856', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026091', '026', 'Villorba', 'M048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026092', '026', 'Vittorio Veneto', 'M089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026093', '026', 'Volpago del Montello', 'M118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026094', '026', 'Zenson di Piave', 'M163', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026095', '026', 'Zero Branco', 'M171', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026801', '026', 'Ceneda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026802', '026', 'Piavon', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026803', '026', 'Revine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026804', '026', 'San Giorgio di Lago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026805', '026', 'San Pietro di Barbozza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026806', '026', 'Sant’Andrea di Cavasagra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026807', '026', 'Serravalle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('026808', '026', 'Spercenigo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027001', '027', 'Annone Veneto', 'A302', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027002', '027', 'Campagna Lupia', 'B493', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027003', '027', 'Campolongo Maggiore', 'B546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027004', '027', 'Camponogara', 'B554', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027005', '027', 'Caorle', 'B642', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027044', '027', 'Cavallino-Treporti', 'M308', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027006', '027', 'Cavarzere', 'C383', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027007', '027', 'Ceggia', 'C422', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027008', '027', 'Chioggia', 'C638', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027009', '027', 'Cinto Caomaggiore', 'C714', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027010', '027', 'Cona', 'C938', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027011', '027', 'Concordia Sagittaria', 'C950', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027012', '027', 'Dolo', 'D325', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027013', '027', 'Eraclea', 'D415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027014', '027', 'Fiesso d''Artico', 'D578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027015', '027', 'Fossalta di Piave', 'D740', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027016', '027', 'Fossalta di Portogruaro', 'D741', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027017', '027', 'Fossò', 'D748', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027018', '027', 'Gruaro', 'E215', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027019', '027', 'Jesolo', 'C388', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027020', '027', 'Marcon', 'E936', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027021', '027', 'Martellago', 'E980', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027022', '027', 'Meolo', 'F130', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027023', '027', 'Mira', 'F229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027024', '027', 'Mirano', 'F241', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027025', '027', 'Musile di Piave', 'F826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027026', '027', 'Noale', 'F904', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027027', '027', 'Noventa di Piave', 'F963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027028', '027', 'Pianiga', 'G565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027029', '027', 'Portogruaro', 'G914', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027030', '027', 'Pramaggiore', 'G981', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027031', '027', 'Quarto d''Altino', 'H117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027032', '027', 'Salzano', 'H735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027033', '027', 'San Donà di Piave', 'H823', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027034', '027', 'San Michele al Tagliamento', 'I040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027035', '027', 'Santa Maria di Sala', 'I242', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027036', '027', 'San Stino di Livenza', 'I373', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027037', '027', 'Scorzè', 'I551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027038', '027', 'Spinea', 'I908', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027039', '027', 'Stra', 'I965', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027040', '027', 'Teglio Veneto', 'L085', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027041', '027', 'Torre di Mosto', 'L267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027042', '027', 'Venezia', 'L736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027043', '027', 'Vigonovo', 'L899', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027801', '027', 'Burano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027802', '027', 'Chirignago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027803', '027', 'Favaro Veneto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027804', '027', 'Malamocco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027805', '027', 'Mestre', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027806', '027', 'Murano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027807', '027', 'Pellestrina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027808', '027', 'Zelarino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027809', '027', 'Gambarare', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('027810', '027', 'Oriago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028001', '028', 'Abano Terme', 'A001', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028002', '028', 'Agna', 'A075', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028003', '028', 'Albignasego', 'A161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028004', '028', 'Anguillara Veneta', 'A296', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028005', '028', 'Arquà Petrarca', 'A434', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028006', '028', 'Arre', 'A438', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028007', '028', 'Arzergrande', 'A458', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028008', '028', 'Bagnoli di Sopra', 'A568', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028009', '028', 'Baone', 'A613', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028010', '028', 'Barbona', 'A637', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028011', '028', 'Battaglia Terme', 'A714', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028012', '028', 'Boara Pisani', 'A906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028013', '028', 'Borgoricco', 'B031', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028014', '028', 'Bovolenta', 'B106', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028015', '028', 'Brugine', 'B213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028016', '028', 'Cadoneghe', 'B345', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028020', '028', 'Campo San Martino', 'B564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028017', '028', 'Campodarsego', 'B524', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028018', '028', 'Campodoro', 'B531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028019', '028', 'Camposampiero', 'B563', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028021', '028', 'Candiana', 'B589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028022', '028', 'Carceri', 'B749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028023', '028', 'Carmignano di Brenta', 'B795', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028026', '028', 'Cartura', 'B848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028027', '028', 'Casale di Scodosia', 'B877', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028028', '028', 'Casalserugo', 'B912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028029', '028', 'Castelbaldo', 'C057', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028030', '028', 'Cervarese Santa Croce', 'C544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028031', '028', 'Cinto Euganeo', 'C713', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028032', '028', 'Cittadella', 'C743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028033', '028', 'Codevigo', 'C812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028034', '028', 'Conselve', 'C964', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028035', '028', 'Correzzola', 'D040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028036', '028', 'Curtarolo', 'D226', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028106', '028', 'Due Carrare', 'M300', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028037', '028', 'Este', 'D442', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028038', '028', 'Fontaniva', 'D679', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028039', '028', 'Galliera Veneta', 'D879', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028040', '028', 'Galzignano Terme', 'D889', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028041', '028', 'Gazzo', 'D956', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028042', '028', 'Grantorto', 'E145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028043', '028', 'Granze', 'E146', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028044', '028', 'Legnaro', 'E515', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028045', '028', 'Limena', 'E592', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028046', '028', 'Loreggia', 'E684', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028047', '028', 'Lozzo Atestino', 'E709', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028048', '028', 'Maserà di Padova', 'F011', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028049', '028', 'Masi', 'F013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028050', '028', 'Massanzago', 'F033', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028051', '028', 'Megliadino San Fidenzio', 'F091', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028052', '028', 'Megliadino San Vitale', 'F092', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028053', '028', 'Merlara', 'F148', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028054', '028', 'Mestrino', 'F161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028055', '028', 'Monselice', 'F382', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028056', '028', 'Montagnana', 'F394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028057', '028', 'Montegrotto Terme', 'F529', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028058', '028', 'Noventa Padovana', 'F962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028059', '028', 'Ospedaletto Euganeo', 'G167', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028060', '028', 'Padova', 'G224', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028061', '028', 'Pernumia', 'G461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028062', '028', 'Piacenza d''Adige', 'G534', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028063', '028', 'Piazzola sul Brenta', 'G587', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028064', '028', 'Piombino Dese', 'G688', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028065', '028', 'Piove di Sacco', 'G693', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028066', '028', 'Polverara', 'G802', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028067', '028', 'Ponso', 'G823', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028069', '028', 'Ponte San Nicolò', 'G855', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028068', '028', 'Pontelongo', 'G850', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028070', '028', 'Pozzonovo', 'G963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028071', '028', 'Rovolon', 'H622', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028072', '028', 'Rubano', 'H625', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028073', '028', 'Saccolongo', 'H655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028074', '028', 'Saletto', 'H705', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028075', '028', 'San Giorgio delle Pertiche', 'H893', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028076', '028', 'San Giorgio in Bosco', 'H897', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028077', '028', 'San Martino di Lupari', 'I008', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028078', '028', 'San Pietro in Gu', 'I107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028079', '028', 'San Pietro Viminario', 'I120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028080', '028', 'Santa Giustina in Colle', 'I207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028081', '028', 'Santa Margherita d''Adige', 'I226', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028082', '028', 'Sant''Angelo di Piove di Sacco', 'I275', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028083', '028', 'Sant''Elena', 'I319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028084', '028', 'Sant''Urbano', 'I375', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028085', '028', 'Saonara', 'I418', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028086', '028', 'Selvazzano Dentro', 'I595', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028087', '028', 'Solesino', 'I799', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028088', '028', 'Stanghella', 'I938', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028089', '028', 'Teolo', 'L100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028090', '028', 'Terrassa Padovana', 'L132', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028091', '028', 'Tombolo', 'L199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028092', '028', 'Torreglia', 'L270', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028093', '028', 'Trebaseleghe', 'L349', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028094', '028', 'Tribano', 'L414', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028095', '028', 'Urbana', 'L497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028096', '028', 'Veggiano', 'L710', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028097', '028', 'Vescovana', 'L805', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028098', '028', 'Vighizzolo d''Este', 'L878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028099', '028', 'Vigodarzere', 'L892', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028100', '028', 'Vigonza', 'L900', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028101', '028', 'Villa del Conte', 'L934', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028102', '028', 'Villa Estense', 'L937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028103', '028', 'Villafranca Padovana', 'L947', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028104', '028', 'Villanova di Camposampiero', 'L979', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028105', '028', 'Vo''', 'M103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028107', '028', 'Borgo Veneto', 'M402', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028024', '028', 'Carrara San Giorgio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028025', '028', 'Carrara Santo Stefano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('028801', '028', 'San Michele delle Badesse', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029001', '029', 'Adria', 'A059', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029002', '029', 'Ariano nel Polesine', 'A400', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029003', '029', 'Arquà Polesine', 'A435', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029004', '029', 'Badia Polesine', 'A539', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029005', '029', 'Bagnolo di Po', 'A574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029006', '029', 'Bergantino', 'A795', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029007', '029', 'Bosaro', 'B069', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029008', '029', 'Calto', 'B432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029009', '029', 'Canaro', 'B578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029010', '029', 'Canda', 'B582', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029011', '029', 'Castelguglielmo', 'C122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029012', '029', 'Castelmassa', 'C207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029013', '029', 'Castelnovo Bariano', 'C215', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029014', '029', 'Ceneselli', 'C461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029015', '029', 'Ceregnano', 'C500', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029017', '029', 'Corbola', 'C987', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029018', '029', 'Costa di Rovigo', 'D105', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029019', '029', 'Crespino', 'D161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029021', '029', 'Ficarolo', 'D568', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029022', '029', 'Fiesso Umbertiano', 'D577', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029023', '029', 'Frassinelle Polesine', 'D776', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029024', '029', 'Fratta Polesine', 'D788', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029025', '029', 'Gaiba', 'D855', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029026', '029', 'Gavello', 'D942', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029027', '029', 'Giacciano con Baruchella', 'E008', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029028', '029', 'Guarda Veneta', 'E240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029029', '029', 'Lendinara', 'E522', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029030', '029', 'Loreo', 'E689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029031', '029', 'Lusia', 'E761', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029032', '029', 'Melara', 'F095', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029033', '029', 'Occhiobello', 'F994', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029034', '029', 'Papozze', 'G323', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029035', '029', 'Pettorazza Grimani', 'G525', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029036', '029', 'Pincara', 'G673', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029037', '029', 'Polesella', 'G782', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029038', '029', 'Pontecchio Polesine', 'G836', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029039', '029', 'Porto Tolle', 'G923', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029052', '029', 'Porto Viro', 'G926', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029040', '029', 'Rosolina', 'H573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029041', '029', 'Rovigo', 'H620', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029042', '029', 'Salara', 'H689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029043', '029', 'San Bellino', 'H768', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029044', '029', 'San Martino di Venezze', 'H996', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029045', '029', 'Stienta', 'I953', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029046', '029', 'Taglio di Po', 'L026', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029047', '029', 'Trecenta', 'L359', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029048', '029', 'Villadose', 'L939', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029049', '029', 'Villamarzana', 'L967', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029050', '029', 'Villanova del Ghebbo', 'L985', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029051', '029', 'Villanova Marchesana', 'L988', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029016', '029', 'Contarina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029020', '029', 'Donada', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029801', '029', 'Bellombra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029802', '029', 'Boara Polesine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029803', '029', 'Borsea', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029804', '029', 'Bottrighe', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029805', '029', 'Buso Sarzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029806', '029', 'Ca'' Emo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029807', '029', 'Concadirame', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029808', '029', 'Crocetta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029809', '029', 'Grignano di Polesine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029810', '029', 'Massa Superiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029811', '029', 'Ramo di Palo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029812', '029', 'Salvaterra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029813', '029', 'Sant’Apollinare con Selva', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029814', '029', 'Villa d’Adige', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('029815', '029', 'Saguedo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('025052', '030', 'Sappada', 'I421', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030001', '030', 'Aiello del Friuli', 'A103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030002', '030', 'Amaro', 'A254', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030003', '030', 'Ampezzo', 'A267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030004', '030', 'Aquileia', 'A346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030005', '030', 'Arta Terme', 'A447', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030006', '030', 'Artegna', 'A448', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030007', '030', 'Attimis', 'A491', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030008', '030', 'Bagnaria Arsa', 'A553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030009', '030', 'Basiliano', 'A700', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030010', '030', 'Bertiolo', 'A810', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030011', '030', 'Bicinicco', 'A855', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030012', '030', 'Bordano', 'A983', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030013', '030', 'Buja', 'B259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030014', '030', 'Buttrio', 'B309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030015', '030', 'Camino al Tagliamento', 'B483', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030016', '030', 'Campoformido', 'B536', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030018', '030', 'Carlino', 'B788', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030019', '030', 'Cassacco', 'B994', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030020', '030', 'Castions di Strada', 'C327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030021', '030', 'Cavazzo Carnico', 'C389', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030022', '030', 'Cercivento', 'C494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030023', '030', 'Cervignano del Friuli', 'C556', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030024', '030', 'Chiopris-Viscone', 'C641', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030025', '030', 'Chiusaforte', 'C656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030026', '030', 'Cividale del Friuli', 'C758', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030027', '030', 'Codroipo', 'C817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030028', '030', 'Colloredo di Monte Albano', 'C885', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030029', '030', 'Comeglians', 'C918', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030030', '030', 'Corno di Rosazzo', 'D027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030031', '030', 'Coseano', 'D085', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030032', '030', 'Dignano', 'D300', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030033', '030', 'Dogna', 'D316', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030034', '030', 'Drenchia', 'D366', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030035', '030', 'Enemonzo', 'D408', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030036', '030', 'Faedis', 'D455', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030037', '030', 'Fagagna', 'D461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030038', '030', 'Fiumicello', 'D627', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030039', '030', 'Flaibano', 'D630', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030137', '030', 'Forgaria nel Friuli', 'D700', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030040', '030', 'Forni Avoltri', 'D718', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030041', '030', 'Forni di Sopra', 'D719', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030042', '030', 'Forni di Sotto', 'D720', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030043', '030', 'Gemona del Friuli', 'D962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030044', '030', 'Gonars', 'E083', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030045', '030', 'Grimacco', 'E179', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030046', '030', 'Latisana', 'E473', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030047', '030', 'Lauco', 'E476', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030048', '030', 'Lestizza', 'E553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030049', '030', 'Lignano Sabbiadoro', 'E584', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030050', '030', 'Ligosullo', 'E586', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030051', '030', 'Lusevera', 'E760', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030052', '030', 'Magnano in Riviera', 'E820', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030053', '030', 'Majano', 'E833', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030054', '030', 'Malborghetto Valbruna', 'E847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030055', '030', 'Manzano', 'E899', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030056', '030', 'Marano Lagunare', 'E910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030057', '030', 'Martignacco', 'E982', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030058', '030', 'Mereto di Tomba', 'F144', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030059', '030', 'Moggio Udinese', 'F266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030060', '030', 'Moimacco', 'F275', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030061', '030', 'Montenars', 'F574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030062', '030', 'Mortegliano', 'F756', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030063', '030', 'Moruzzo', 'F760', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030064', '030', 'Muzzana del Turgnano', 'F832', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030065', '030', 'Nimis', 'F898', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030066', '030', 'Osoppo', 'G163', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030067', '030', 'Ovaro', 'G198', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030068', '030', 'Pagnacco', 'G238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030069', '030', 'Palazzolo dello Stella', 'G268', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030070', '030', 'Palmanova', 'G284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030071', '030', 'Paluzza', 'G300', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030072', '030', 'Pasian di Prato', 'G352', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030073', '030', 'Paularo', 'G381', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030074', '030', 'Pavia di Udine', 'G389', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030075', '030', 'Pocenia', 'G743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030076', '030', 'Pontebba', 'G831', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030077', '030', 'Porpetto', 'G891', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030078', '030', 'Povoletto', 'G949', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030079', '030', 'Pozzuolo del Friuli', 'G966', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030080', '030', 'Pradamano', 'G969', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030081', '030', 'Prato Carnico', 'H002', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030082', '030', 'Precenicco', 'H014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030083', '030', 'Premariacco', 'H029', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030084', '030', 'Preone', 'H038', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030085', '030', 'Prepotto', 'H040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030086', '030', 'Pulfero', 'H089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030087', '030', 'Ragogna', 'H161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030088', '030', 'Ravascletto', 'H196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030089', '030', 'Raveo', 'H200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030090', '030', 'Reana del Rojale', 'H206', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030091', '030', 'Remanzacco', 'H229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030092', '030', 'Resia', 'H242', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030093', '030', 'Resiutta', 'H244', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030094', '030', 'Rigolato', 'H289', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030095', '030', 'Rive d''Arcano', 'H347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030096', '030', 'Rivignano', 'H352', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030097', '030', 'Ronchis', 'H533', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030098', '030', 'Ruda', 'H629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030099', '030', 'San Daniele del Friuli', 'H816', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030100', '030', 'San Giorgio di Nogaro', 'H895', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030101', '030', 'San Giovanni al Natisone', 'H906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030102', '030', 'San Leonardo', 'H951', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030103', '030', 'San Pietro al Natisone', 'I092', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030105', '030', 'San Vito al Torre', 'I404', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030106', '030', 'San Vito di Fagagna', 'I405', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030104', '030', 'Santa Maria la Longa', 'I248', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030107', '030', 'Sauris', 'I464', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030108', '030', 'Savogna', 'I478', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030109', '030', 'Sedegliano', 'I562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030110', '030', 'Socchieve', 'I777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030111', '030', 'Stregna', 'I974', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030112', '030', 'Sutrio', 'L018', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030113', '030', 'Taipana', 'G736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030114', '030', 'Talmassons', 'L039', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030116', '030', 'Tarcento', 'L050', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030117', '030', 'Tarvisio', 'L057', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030118', '030', 'Tavagnacco', 'L065', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030119', '030', 'Teor', 'L101', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030120', '030', 'Terzo d''Aquileia', 'L144', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030121', '030', 'Tolmezzo', 'L195', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030122', '030', 'Torreano', 'L246', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030123', '030', 'Torviscosa', 'L309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030124', '030', 'Trasaghis', 'L335', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030125', '030', 'Treppo Carnico', 'L381', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030126', '030', 'Treppo Grande', 'L382', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030127', '030', 'Tricesimo', 'L421', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030128', '030', 'Trivignano Udinese', 'L438', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030129', '030', 'Udine', 'L483', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030130', '030', 'Varmo', 'L686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030131', '030', 'Venzone', 'L743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030132', '030', 'Verzegnis', 'L801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030133', '030', 'Villa Santina', 'L909', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030134', '030', 'Villa Vicentina', 'M034', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030135', '030', 'Visco', 'M073', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030136', '030', 'Zuglio', 'M200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030188', '030', 'Rivignano Teor', 'M317', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030138', '030', 'Campolongo Tapogliano', 'M311', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030190', '030', 'Fiumicello Villa Vicentina', 'M400', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030191', '030', 'Treppo Ligosullo', 'M399', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030017', '030', 'Campolongo al Torre', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030115', '030', 'Tapogliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030801', '030', 'Camporosso in Valcanale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030802', '030', 'Castel del Monte Udinese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030803', '030', 'Cesclans', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030804', '030', 'Ciseriis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030805', '030', 'Feletto Umberto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030806', '030', 'Fusine in Valromana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030807', '030', 'Ioannis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030808', '030', 'Ipplis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030809', '030', 'Laglesie San Leopoldo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030810', '030', 'Malborghetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030811', '030', 'Mione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030812', '030', 'Muscoli Strassoldo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030813', '030', 'Perteole', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030814', '030', 'Pontebba Nova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030815', '030', 'Raccolana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030816', '030', 'Rivolto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030817', '030', 'Rodda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030818', '030', 'Scodovacca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030819', '030', 'Segnacco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030820', '030', 'Tarcetta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('030821', '030', 'Ugovizza Valbruna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031001', '031', 'Capriva del Friuli', 'B712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031002', '031', 'Cormons', 'D014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031003', '031', 'Doberdò del Lago', 'D312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031004', '031', 'Dolegna del Collio', 'D321', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031005', '031', 'Farra d''Isonzo', 'D504', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031006', '031', 'Fogliano Redipuglia', 'D645', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031007', '031', 'Gorizia', 'E098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031008', '031', 'Gradisca d''Isonzo', 'E124', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031009', '031', 'Grado', 'E125', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031010', '031', 'Mariano del Friuli', 'E952', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031011', '031', 'Medea', 'F081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031012', '031', 'Monfalcone', 'F356', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031013', '031', 'Moraro', 'F710', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031014', '031', 'Mossa', 'F767', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031015', '031', 'Romans d''Isonzo', 'H514', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031016', '031', 'Ronchi dei Legionari', 'H531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031017', '031', 'Sagrado', 'H665', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031018', '031', 'San Canzian d''Isonzo', 'H787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031019', '031', 'San Floriano del Collio', 'H845', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031020', '031', 'San Lorenzo Isontino', 'H964', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031021', '031', 'San Pier d''Isonzo', 'I082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031022', '031', 'Savogna d''Isonzo', 'I479', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031023', '031', 'Staranzano', 'I939', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031024', '031', 'Turriaco', 'L474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031025', '031', 'Villesse', 'M043', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031701', '031', 'Aidussina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031702', '031', 'Bergogna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031703', '031', 'Cal di Canale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031704', '031', 'Canale d''Isonzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031705', '031', 'Caporetto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031706', '031', 'Castel Dobra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031707', '031', 'Cernizza Goriziana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031708', '031', 'Chiapovano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031709', '031', 'Circhina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031710', '031', 'Comeno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031711', '031', 'Gargaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031712', '031', 'Gracova Serravalle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031713', '031', 'Idria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031714', '031', 'Merna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031715', '031', 'Montenero d''Idria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031716', '031', 'Montespino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031717', '031', 'Opacchiasella', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031718', '031', 'Plezzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031719', '031', 'Ranziano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031720', '031', 'Rifembergo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031721', '031', 'Salona d''Isonzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031722', '031', 'Sambasso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031723', '031', 'San Daniele del Carso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031724', '031', 'San Martino Quisca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031725', '031', 'San Vito di Vipacco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031726', '031', 'Santa Croce di Aidussina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031727', '031', 'Santa Lucia d''Isonzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031728', '031', 'Sonzia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031729', '031', 'Tarnova della Selva', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031730', '031', 'Temenizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031731', '031', 'Tolmino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031732', '031', 'Vipacco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031733', '031', 'Zolla', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031801', '031', 'Brazzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031802', '031', 'Corona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031803', '031', 'Cosbana nel Collio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031804', '031', 'Lucinico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031805', '031', 'Piedimonte del Calvario', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031806', '031', 'Romans', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031807', '031', 'Salcano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031808', '031', 'San Pietro di Gorizia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031809', '031', 'Sant’Andrea di Gorizia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031810', '031', 'Versa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031811', '031', 'Vertoiba in Campi Santi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031812', '031', 'Aiba', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031813', '031', 'Anicova Corada', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031814', '031', 'Auzza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031815', '031', 'Battaglia della Bainsizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031816', '031', 'Biglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031817', '031', 'Bigliana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031818', '031', 'Boriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031819', '031', 'Brestovizza in Valle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031820', '031', 'Bretto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031821', '031', 'Budagne', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031822', '031', 'Camigna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031823', '031', 'Ceconico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031824', '031', 'Cobbia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031825', '031', 'Creda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031826', '031', 'Descla', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031827', '031', 'Dole', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031828', '031', 'Dol Grande', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031829', '031', 'Dol-Ottelza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031830', '031', 'Dresenza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031831', '031', 'Ersel in Monte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031832', '031', 'Gabria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031833', '031', 'Gabrovizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031834', '031', 'Godovici', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031835', '031', 'Goiaci', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031836', '031', 'Goriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031837', '031', 'Gozza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031838', '031', 'Idresca d''Isonzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031839', '031', 'Idria di Sotto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031840', '031', 'Ledine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031841', '031', 'Libussina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031842', '031', 'Locavizza di Aidussina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031843', '031', 'Locavizza di Canale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031844', '031', 'Lose', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031845', '031', 'Luico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031846', '031', 'Medana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031847', '031', 'Monte San Vito', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031848', '031', 'Monte Urabice', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031849', '031', 'Oltresonzia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031850', '031', 'Ossecca Vittuglia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031851', '031', 'Ossegliano San Michele', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031852', '031', 'Paniqua', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031853', '031', 'Planina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031854', '031', 'Pliscovizza della Madonna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031855', '031', 'Pocrai del Piro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031856', '031', 'Podraga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031857', '031', 'Prevacina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031858', '031', 'Ronzina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031859', '031', 'Sable Grande', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031860', '031', 'Saga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031861', '031', 'Samaria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031862', '031', 'Santo Spirito della Bainsizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031863', '031', 'Scherbina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031864', '031', 'Scrilla', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031865', '031', 'Sebreghe', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031866', '031', 'Sedula', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031867', '031', 'Sella delle Trincee', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031868', '031', 'Serpenizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031869', '031', 'Slappe Zorzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031870', '031', 'Sturia delle Fusine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031871', '031', 'Ternova d''Isonzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031872', '031', 'Trenta d''Isonzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031873', '031', 'Tribussa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031874', '031', 'Ustie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031875', '031', 'Verpogliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031876', '031', 'Vertovino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031877', '031', 'Ville Montevecchio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031878', '031', 'Voissizza di Comeno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031879', '031', 'Volzana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('031880', '031', 'Voschia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032001', '032', 'Duino Aurisina', 'D383', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032002', '032', 'Monrupino', 'F378', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032003', '032', 'Muggia', 'F795', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032004', '032', 'San Dorligo della Valle', 'D324', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032005', '032', 'Sgonico', 'I715', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032006', '032', 'Trieste', 'L424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032701', '032', 'Bucuie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032702', '032', 'Cave Auremiane', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032703', '032', 'Corgnale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032704', '032', 'Cossana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032705', '032', 'Crenovizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032706', '032', 'Divaccia Grotte del Timavo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032707', '032', 'Duttogliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032708', '032', 'Postumia Grotte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032709', '032', 'San Giacomo in Colle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032710', '032', 'San Michele di Postumia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032711', '032', 'San Pietro del Carso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032712', '032', 'Senosecchia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032713', '032', 'Sesana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032714', '032', 'Tomadio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032715', '032', 'Villa Slavina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032801', '032', 'Aurisina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032802', '032', 'Duino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032803', '032', 'Malchina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032804', '032', 'San Pelagio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032805', '032', 'Slivia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032806', '032', 'Alber di Sesana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032807', '032', 'Auremo di Sopra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032808', '032', 'Caccia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032809', '032', 'Capriva nel Carso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032810', '032', 'Famie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032811', '032', 'Lase', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032812', '032', 'Poverio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032813', '032', 'Roditti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032814', '032', 'Scoppo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032815', '032', 'Senadole', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032816', '032', 'Storie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('032817', '032', 'Villabassa di Senosecchia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033001', '033', 'Agazzano', 'A067', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033002', '033', 'Alseno', 'A223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033003', '033', 'Besenzone', 'A823', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033004', '033', 'Bettola', 'A831', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033005', '033', 'Bobbio', 'A909', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033006', '033', 'Borgonovo Val Tidone', 'B025', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033007', '033', 'Cadeo', 'B332', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033008', '033', 'Calendasco', 'B405', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033009', '033', 'Caminata', 'B479', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033010', '033', 'Caorso', 'B643', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033011', '033', 'Carpaneto Piacentino', 'B812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033013', '033', 'Castel San Giovanni', 'C261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033012', '033', 'Castell''Arquato', 'C145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033014', '033', 'Castelvetro Piacentino', 'C288', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033015', '033', 'Cerignale', 'C513', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033016', '033', 'Coli', 'C838', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033017', '033', 'Corte Brugnatella', 'D054', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033018', '033', 'Cortemaggiore', 'D061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033019', '033', 'Farini', 'D502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033020', '033', 'Ferriere', 'D555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033021', '033', 'Fiorenzuola d''Arda', 'D611', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033022', '033', 'Gazzola', 'D958', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033023', '033', 'Gossolengo', 'E114', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033024', '033', 'Gragnano Trebbiense', 'E132', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033025', '033', 'Gropparello', 'E196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033026', '033', 'Lugagnano Val d''Arda', 'E726', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033027', '033', 'Monticelli d''Ongina', 'F671', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033028', '033', 'Morfasso', 'F724', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033029', '033', 'Nibbiano', 'F885', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033030', '033', 'Ottone', 'G195', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033031', '033', 'Pecorara', 'G399', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033032', '033', 'Piacenza', 'G535', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033033', '033', 'Pianello Val Tidone', 'G557', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033034', '033', 'Piozzano', 'G696', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033035', '033', 'Podenzano', 'G747', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033036', '033', 'Ponte dell''Olio', 'G842', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033037', '033', 'Pontenure', 'G852', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033038', '033', 'Rivergaro', 'H350', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033039', '033', 'Rottofreno', 'H593', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033040', '033', 'San Giorgio Piacentino', 'H887', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033041', '033', 'San Pietro in Cerro', 'G788', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033042', '033', 'Sarmato', 'I434', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033043', '033', 'Travo', 'L348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033044', '033', 'Vernasca', 'L772', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033045', '033', 'Vigolzone', 'L897', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033046', '033', 'Villanova sull''Arda', 'L980', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033047', '033', 'Zerba', 'M165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033048', '033', 'Ziano Piacentino', 'L848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033049', '033', 'Alta Val Tidone', 'M386', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033801', '033', 'Borgo San Bernardino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033802', '033', 'Mortizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033803', '033', 'San Lazzaro Alberoni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033804', '033', 'Sant’Antonio a Trebbia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('033805', '033', 'Trebecco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034050', '034', 'Polesine Zibello', 'M367', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034001', '034', 'Albareto', 'A138', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034002', '034', 'Bardi', 'A646', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034003', '034', 'Bedonia', 'A731', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034004', '034', 'Berceto', 'A788', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034005', '034', 'Bore', 'A987', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034006', '034', 'Borgo Val di Taro', 'B042', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034007', '034', 'Busseto', 'B293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034008', '034', 'Calestano', 'B408', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034009', '034', 'Collecchio', 'C852', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034010', '034', 'Colorno', 'C904', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034011', '034', 'Compiano', 'C934', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034012', '034', 'Corniglio', 'D026', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034013', '034', 'Felino', 'D526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034014', '034', 'Fidenza', 'B034', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034015', '034', 'Fontanellato', 'D673', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034016', '034', 'Fontevivo', 'D685', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034017', '034', 'Fornovo di Taro', 'D728', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034018', '034', 'Langhirano', 'E438', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034019', '034', 'Lesignano de'' Bagni', 'E547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034020', '034', 'Medesano', 'F082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034021', '034', 'Mezzani', 'F174', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034022', '034', 'Monchio delle Corti', 'F340', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034023', '034', 'Montechiarugolo', 'F473', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034024', '034', 'Neviano degli Arduini', 'F882', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034025', '034', 'Noceto', 'F914', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034026', '034', 'Palanzano', 'G255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034027', '034', 'Parma', 'G337', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034028', '034', 'Pellegrino Parmense', 'G424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034029', '034', 'Polesine Parmense', 'G783', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034030', '034', 'Roccabianca', 'H384', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034031', '034', 'Sala Baganza', 'H682', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034032', '034', 'Salsomaggiore Terme', 'H720', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034033', '034', 'San Secondo Parmense', 'I153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034034', '034', 'Sissa', 'I763', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034035', '034', 'Solignano', 'I803', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034036', '034', 'Soragna', 'I840', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034037', '034', 'Sorbolo', 'I845', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034038', '034', 'Terenzo', 'E548', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034039', '034', 'Tizzano Val Parma', 'L183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034040', '034', 'Tornolo', 'L229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034041', '034', 'Torrile', 'L299', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034042', '034', 'Traversetolo', 'L346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034043', '034', 'Trecasali', 'L354', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034044', '034', 'Valmozzola', 'L641', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034045', '034', 'Varano de'' Melegari', 'L672', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034046', '034', 'Varsi', 'L689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034048', '034', 'Zibello', 'M174', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034049', '034', 'Sissa Trecasali', 'M325', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034801', '034', 'Boccolo de'' Tassi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034802', '034', 'Cortile San Martino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034803', '034', 'Golese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034804', '034', 'Marore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034805', '034', 'Pione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034806', '034', 'San Donato d''Enza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034807', '034', 'San Lazzaro Parmense', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034808', '034', 'San Martino Sinzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034809', '034', 'San Pancrazio Parmense', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('034810', '034', 'Vigatto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035001', '035', 'Albinea', 'A162', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035002', '035', 'Bagnolo in Piano', 'A573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035003', '035', 'Baiso', 'A586', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035004', '035', 'Bibbiano', 'A850', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035005', '035', 'Boretto', 'A988', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035006', '035', 'Brescello', 'B156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035007', '035', 'Busana', 'B283', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035008', '035', 'Cadelbosco di Sopra', 'B328', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035009', '035', 'Campagnola Emilia', 'B499', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035010', '035', 'Campegine', 'B502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035018', '035', 'Canossa', 'C669', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035011', '035', 'Carpineti', 'B825', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035012', '035', 'Casalgrande', 'B893', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035013', '035', 'Casina', 'B967', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035014', '035', 'Castellarano', 'C141', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035015', '035', 'Castelnovo di Sotto', 'C218', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035016', '035', 'Castelnovo ne'' Monti', 'C219', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035017', '035', 'Cavriago', 'C405', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035019', '035', 'Collagna', 'C840', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035020', '035', 'Correggio', 'D037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035021', '035', 'Fabbrico', 'D450', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035022', '035', 'Gattatico', 'D934', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035023', '035', 'Gualtieri', 'E232', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035024', '035', 'Guastalla', 'E253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035025', '035', 'Ligonchio', 'E585', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035026', '035', 'Luzzara', 'E772', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035027', '035', 'Montecchio Emilia', 'F463', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035028', '035', 'Novellara', 'F960', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035029', '035', 'Poviglio', 'G947', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035030', '035', 'Quattro Castella', 'H122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035031', '035', 'Ramiseto', 'G654', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035033', '035', 'Reggio nell''Emilia', 'H223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035032', '035', 'Reggiolo', 'H225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035034', '035', 'Rio Saliceto', 'H298', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035035', '035', 'Rolo', 'H500', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035036', '035', 'Rubiera', 'H628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035037', '035', 'San Martino in Rio', 'I011', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035038', '035', 'San Polo d''Enza', 'I123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035039', '035', 'Sant''Ilario d''Enza', 'I342', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035040', '035', 'Scandiano', 'I496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035041', '035', 'Toano', 'L184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035042', '035', 'Vetto', 'L815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035043', '035', 'Vezzano sul Crostolo', 'L820', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035044', '035', 'Viano', 'L831', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035045', '035', 'Villa Minozzo', 'L969', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035046', '035', 'Ventasso', 'M364', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('035801', '035', 'Gazzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036001', '036', 'Bastiglia', 'A713', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036002', '036', 'Bomporto', 'A959', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036003', '036', 'Campogalliano', 'B539', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036004', '036', 'Camposanto', 'B566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036005', '036', 'Carpi', 'B819', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036006', '036', 'Castelfranco Emilia', 'C107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036007', '036', 'Castelnuovo Rangone', 'C242', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036008', '036', 'Castelvetro di Modena', 'C287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036009', '036', 'Cavezzo', 'C398', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036010', '036', 'Concordia sulla Secchia', 'C951', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036011', '036', 'Fanano', 'D486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036012', '036', 'Finale Emilia', 'D599', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036013', '036', 'Fiorano Modenese', 'D607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036014', '036', 'Fiumalbo', 'D617', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036015', '036', 'Formigine', 'D711', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036016', '036', 'Frassinoro', 'D783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036017', '036', 'Guiglia', 'E264', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036018', '036', 'Lama Mocogno', 'E426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036019', '036', 'Maranello', 'E904', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036020', '036', 'Marano sul Panaro', 'E905', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036021', '036', 'Medolla', 'F087', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036022', '036', 'Mirandola', 'F240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036023', '036', 'Modena', 'F257', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036024', '036', 'Montecreto', 'F484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036025', '036', 'Montefiorino', 'F503', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036026', '036', 'Montese', 'F642', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036027', '036', 'Nonantola', 'F930', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036028', '036', 'Novi di Modena', 'F966', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036029', '036', 'Palagano', 'G250', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036030', '036', 'Pavullo nel Frignano', 'G393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036031', '036', 'Pievepelago', 'G649', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036032', '036', 'Polinago', 'G789', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036033', '036', 'Prignano sulla Secchia', 'H061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036034', '036', 'Ravarino', 'H195', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036035', '036', 'Riolunato', 'H303', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036036', '036', 'San Cesario sul Panaro', 'H794', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036037', '036', 'San Felice sul Panaro', 'H835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036038', '036', 'San Possidonio', 'I128', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036039', '036', 'San Prospero', 'I133', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036040', '036', 'Sassuolo', 'I462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036041', '036', 'Savignano sul Panaro', 'I473', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036042', '036', 'Serramazzoni', 'F357', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036043', '036', 'Sestola', 'I689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036044', '036', 'Soliera', 'I802', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036045', '036', 'Spilamberto', 'I903', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036046', '036', 'Vignola', 'L885', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('036047', '036', 'Zocca', 'M183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037001', '037', 'Anzola dell''Emilia', 'A324', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037002', '037', 'Argelato', 'A392', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037003', '037', 'Baricella', 'A665', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037004', '037', 'Bazzano', 'A726', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037005', '037', 'Bentivoglio', 'A785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037006', '037', 'Bologna', 'A944', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037007', '037', 'Borgo Tossignano', 'B044', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037008', '037', 'Budrio', 'B249', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037009', '037', 'Calderara di Reno', 'B399', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037010', '037', 'Camugnano', 'B572', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037011', '037', 'Casalecchio di Reno', 'B880', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037012', '037', 'Casalfiumanese', 'B892', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037013', '037', 'Castel d''Aiano', 'C075', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037014', '037', 'Castel del Rio', 'C086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037015', '037', 'Castel di Casio', 'B969', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037016', '037', 'Castel Guelfo di Bologna', 'C121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037019', '037', 'Castel Maggiore', 'C204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037020', '037', 'Castel San Pietro Terme', 'C265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037017', '037', 'Castello d''Argile', 'C185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037018', '037', 'Castello di Serravalle', 'C191', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037021', '037', 'Castenaso', 'C292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037022', '037', 'Castiglione dei Pepoli', 'C296', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037023', '037', 'Crespellano', 'D158', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037024', '037', 'Crevalcore', 'D166', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037025', '037', 'Dozza', 'D360', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037026', '037', 'Fontanelice', 'D668', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037027', '037', 'Gaggio Montano', 'D847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037028', '037', 'Galliera', 'D878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037029', '037', 'Granaglione', 'E135', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037030', '037', 'Granarolo dell''Emilia', 'E136', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037031', '037', 'Grizzana Morandi', 'E187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037032', '037', 'Imola', 'E289', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037033', '037', 'Lizzano in Belvedere', 'A771', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037034', '037', 'Loiano', 'E655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037035', '037', 'Malalbergo', 'E844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037036', '037', 'Marzabotto', 'B689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037037', '037', 'Medicina', 'F083', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037038', '037', 'Minerbio', 'F219', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037039', '037', 'Molinella', 'F288', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037040', '037', 'Monghidoro', 'F363', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037042', '037', 'Monte San Pietro', 'F627', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037041', '037', 'Monterenzio', 'F597', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037043', '037', 'Monteveglio', 'F659', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037044', '037', 'Monzuno', 'F706', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037045', '037', 'Mordano', 'F718', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037046', '037', 'Ozzano dell''Emilia', 'G205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037047', '037', 'Pianoro', 'G570', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037048', '037', 'Pieve di Cento', 'G643', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037049', '037', 'Porretta Terme', 'A558', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037050', '037', 'Sala Bolognese', 'H678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037051', '037', 'San Benedetto Val di Sambro', 'G566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037052', '037', 'San Giorgio di Piano', 'H896', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037053', '037', 'San Giovanni in Persiceto', 'G467', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037054', '037', 'San Lazzaro di Savena', 'H945', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037055', '037', 'San Pietro in Casale', 'I110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037056', '037', 'Sant''Agata Bolognese', 'I191', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037057', '037', 'Sasso Marconi', 'G972', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037058', '037', 'Savigno', 'I474', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037059', '037', 'Vergato', 'L762', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037060', '037', 'Zola Predosa', 'M185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037061', '037', 'Valsamoggia', 'M320', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037062', '037', 'Alto Reno Terme', 'M369', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037801', '037', 'Borgo Panigale', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('037802', '037', 'Musiano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038001', '038', 'Argenta', 'A393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038002', '038', 'Berra', 'A806', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038003', '038', 'Bondeno', 'A965', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038004', '038', 'Cento', 'C469', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038005', '038', 'Codigoro', 'C814', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038006', '038', 'Comacchio', 'C912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038007', '038', 'Copparo', 'C980', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038008', '038', 'Ferrara', 'D548', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038009', '038', 'Formignana', 'D713', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038025', '038', 'Goro', 'E107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038010', '038', 'Jolanda di Savoia', 'E320', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038011', '038', 'Lagosanto', 'E410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038012', '038', 'Masi Torello', 'F016', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038013', '038', 'Massa Fiscaglia', 'F026', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038014', '038', 'Mesola', 'F156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038015', '038', 'Migliarino', 'F198', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038026', '038', 'Migliaro', 'F199', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038016', '038', 'Mirabello', 'F235', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038017', '038', 'Ostellato', 'G184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038018', '038', 'Poggio Renatico', 'G768', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038019', '038', 'Portomaggiore', 'G916', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038020', '038', 'Ro', 'H360', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038021', '038', 'Sant''Agostino', 'I209', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038024', '038', 'Tresigallo', 'L390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038022', '038', 'Vigarano Mainarda', 'L868', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038023', '038', 'Voghiera', 'M110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038027', '038', 'Fiscaglia', 'M323', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('038028', '038', 'Terre del Reno', 'M381', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039001', '039', 'Alfonsine', 'A191', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039002', '039', 'Bagnacavallo', 'A547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039003', '039', 'Bagnara di Romagna', 'A551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039004', '039', 'Brisighella', 'B188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039005', '039', 'Casola Valsenio', 'B982', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039006', '039', 'Castel Bolognese', 'C065', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039007', '039', 'Cervia', 'C553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039008', '039', 'Conselice', 'C963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039009', '039', 'Cotignola', 'D121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039010', '039', 'Faenza', 'D458', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039011', '039', 'Fusignano', 'D829', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039012', '039', 'Lugo', 'E730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039013', '039', 'Massa Lombarda', 'F029', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039014', '039', 'Ravenna', 'H199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039015', '039', 'Riolo Terme', 'H302', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039016', '039', 'Russi', 'H642', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039017', '039', 'Sant''Agata sul Santerno', 'I196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('039018', '039', 'Solarolo', 'I787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040001', '040', 'Bagno di Romagna', 'A565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040003', '040', 'Bertinoro', 'A809', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040004', '040', 'Borghi', 'B001', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040005', '040', 'Castrocaro Terme e Terra del Sole', 'C339', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040007', '040', 'Cesena', 'C573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040008', '040', 'Cesenatico', 'C574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040009', '040', 'Civitella di Romagna', 'C777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040011', '040', 'Dovadola', 'D357', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040012', '040', 'Forlì', 'D704', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040013', '040', 'Forlimpopoli', 'D705', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040014', '040', 'Galeata', 'D867', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040015', '040', 'Gambettola', 'D899', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040016', '040', 'Gatteo', 'D935', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040018', '040', 'Longiano', 'E675', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040019', '040', 'Meldola', 'F097', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040020', '040', 'Mercato Saraceno', 'F139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040022', '040', 'Modigliana', 'F259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040028', '040', 'Montiano', 'F668', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040031', '040', 'Portico e San Benedetto', 'G904', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040032', '040', 'Predappio', 'H017', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040033', '040', 'Premilcuore', 'H034', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040036', '040', 'Rocca San Casciano', 'H437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040037', '040', 'Roncofreddo', 'H542', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040041', '040', 'San Mauro Pascoli', 'I027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040043', '040', 'Santa Sofia', 'I310', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040044', '040', 'Sarsina', 'I444', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040045', '040', 'Savignano sul Rubicone', 'I472', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040046', '040', 'Sogliano al Rubicone', 'I779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040049', '040', 'Tredozio', 'L361', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040050', '040', 'Verghereto', 'L764', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040801', '040', 'Fiumana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040802', '040', 'Mortano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040803', '040', 'Roversano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040804', '040', 'Sorbano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('040805', '040', 'Teodorano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041001', '041', 'Acqualagna', 'A035', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041002', '041', 'Apecchio', 'A327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041003', '041', 'Auditore', 'A493', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041004', '041', 'Barchi', 'A639', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041005', '041', 'Belforte all''Isauro', 'A740', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041006', '041', 'Borgo Pace', 'B026', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041007', '041', 'Cagli', 'B352', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041008', '041', 'Cantiano', 'B636', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041009', '041', 'Carpegna', 'B816', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041010', '041', 'Cartoceto', 'B846', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041012', '041', 'Colbordolo', 'C830', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041013', '041', 'Fano', 'D488', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041014', '041', 'Fermignano', 'D541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041015', '041', 'Fossombrone', 'D749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041016', '041', 'Fratte Rosa', 'D791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041017', '041', 'Frontino', 'D807', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041018', '041', 'Frontone', 'D808', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041019', '041', 'Gabicce Mare', 'D836', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041020', '041', 'Gradara', 'E122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041021', '041', 'Isola del Piano', 'E351', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041022', '041', 'Lunano', 'E743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041023', '041', 'Macerata Feltria', 'E785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041025', '041', 'Mercatello sul Metauro', 'F135', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041026', '041', 'Mercatino Conca', 'F136', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041027', '041', 'Mombaroccio', 'F310', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041028', '041', 'Mondavio', 'F347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041029', '041', 'Mondolfo', 'F348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041031', '041', 'Monte Cerignone', 'F467', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041035', '041', 'Monte Grimano Terme', 'F524', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041038', '041', 'Monte Porzio', 'F589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041030', '041', 'Montecalvo in Foglia', 'F450', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041032', '041', 'Monteciccardo', 'F474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041033', '041', 'Montecopiolo', 'F478', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041034', '041', 'Montefelcino', 'F497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041036', '041', 'Montelabbate', 'F533', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041037', '041', 'Montemaggiore al Metauro', 'F555', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041040', '041', 'Orciano di Pesaro', 'G089', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041041', '041', 'Peglio', 'G416', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041043', '041', 'Pergola', 'G453', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041044', '041', 'Pesaro', 'G479', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041045', '041', 'Petriano', 'G514', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041046', '041', 'Piagge', 'G537', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041047', '041', 'Piandimeleto', 'G551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041048', '041', 'Pietrarubbia', 'G627', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041049', '041', 'Piobbico', 'G682', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041050', '041', 'Saltara', 'H721', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041051', '041', 'San Costanzo', 'H809', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041052', '041', 'San Giorgio di Pesaro', 'H886', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041054', '041', 'San Lorenzo in Campo', 'H958', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041056', '041', 'Sant''Angelo in Lizzola', 'I285', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041057', '041', 'Sant''Angelo in Vado', 'I287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041058', '041', 'Sant''Ippolito', 'I344', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041059', '041', 'Sassocorvaro', 'I459', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041060', '041', 'Sassofeltrio', 'I460', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041061', '041', 'Serra Sant''Abbondio', 'I654', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041062', '041', 'Serrungarina', 'I670', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041064', '041', 'Tavoleto', 'L078', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041065', '041', 'Tavullia', 'L081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041066', '041', 'Urbania', 'L498', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041067', '041', 'Urbino', 'L500', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041068', '041', 'Vallefoglia', 'M331', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041069', '041', 'Colli al Metauro', 'M380', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041070', '041', 'Terre Roveresche', 'M379', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041801', '041', 'Candelara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041802', '041', 'Casteldimezzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041803', '041', 'Fenigli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041804', '041', 'Fiorenzuola di Focara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041805', '041', 'Ginestreto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041806', '041', 'Isola di Fano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041807', '041', 'Montalfoglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041808', '041', 'Montalto Tarugo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041809', '041', 'Monte Montanaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041810', '041', 'Montebello Metaurense', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041811', '041', 'Montefabbri', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041812', '041', 'Monteguiduccio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041813', '041', 'Monterolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041814', '041', 'Montesecco Antico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041815', '041', 'Montevecchio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041816', '041', 'Novillara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041817', '041', 'Pozzo Alto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041818', '041', 'San Vito sul Cesano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041819', '041', 'Sant’Andrea di Suasa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041820', '041', 'Scavolino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041821', '041', 'Sorbolongo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041822', '041', 'Torre San Marco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('041823', '041', 'Frontone-Serra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042001', '042', 'Agugliano', 'A092', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042002', '042', 'Ancona', 'A271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042003', '042', 'Arcevia', 'A366', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042004', '042', 'Barbara', 'A626', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042005', '042', 'Belvedere Ostrense', 'A769', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042006', '042', 'Camerano', 'B468', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042007', '042', 'Camerata Picena', 'B470', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042009', '042', 'Castel Colonna', 'C071', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042008', '042', 'Castelbellino', 'C060', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042010', '042', 'Castelfidardo', 'C100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042011', '042', 'Castelleone di Suasa', 'C152', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042012', '042', 'Castelplanio', 'C248', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042013', '042', 'Cerreto d''Esi', 'C524', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042014', '042', 'Chiaravalle', 'C615', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042015', '042', 'Corinaldo', 'D007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042016', '042', 'Cupramontana', 'D211', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042017', '042', 'Fabriano', 'D451', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042018', '042', 'Falconara Marittima', 'D472', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042019', '042', 'Filottrano', 'D597', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042020', '042', 'Genga', 'D965', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042021', '042', 'Jesi', 'E388', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042022', '042', 'Loreto', 'E690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042023', '042', 'Maiolati Spontini', 'E837', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042024', '042', 'Mergo', 'F145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042025', '042', 'Monsano', 'F381', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042029', '042', 'Monte Roberto', 'F600', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042030', '042', 'Monte San Vito', 'F634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042026', '042', 'Montecarotto', 'F453', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042027', '042', 'Montemarciano', 'F560', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042028', '042', 'Monterado', 'F593', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042031', '042', 'Morro d''Alba', 'F745', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042032', '042', 'Numana', 'F978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042033', '042', 'Offagna', 'G003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042034', '042', 'Osimo', 'G157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042035', '042', 'Ostra', 'F401', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042036', '042', 'Ostra Vetere', 'F581', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042037', '042', 'Poggio San Marcello', 'G771', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042038', '042', 'Polverigi', 'G803', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042039', '042', 'Ripe', 'H322', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042040', '042', 'Rosora', 'H575', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042041', '042', 'San Marcello', 'H979', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042042', '042', 'San Paolo di Jesi', 'I071', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042043', '042', 'Santa Maria Nuova', 'I251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042044', '042', 'Sassoferrato', 'I461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042045', '042', 'Senigallia', 'I608', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042046', '042', 'Serra de'' Conti', 'I643', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042047', '042', 'Serra San Quirico', 'I653', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042048', '042', 'Sirolo', 'I758', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042049', '042', 'Staffolo', 'I932', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042050', '042', 'Trecastelli', 'M318', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042801', '042', 'Montesicuro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042802', '042', 'Paterno d''Ancona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('042803', '042', 'Rosora Mergo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043001', '043', 'Acquacanina', 'A031', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043002', '043', 'Apiro', 'A329', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043003', '043', 'Appignano', 'A334', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043004', '043', 'Belforte del Chienti', 'A739', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043005', '043', 'Bolognola', 'A947', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043006', '043', 'Caldarola', 'B398', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043007', '043', 'Camerino', 'B474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043008', '043', 'Camporotondo di Fiastrone', 'B562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043009', '043', 'Castelraimondo', 'C251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043010', '043', 'Castelsantangelo sul Nera', 'C267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043011', '043', 'Cessapalombo', 'C582', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043012', '043', 'Cingoli', 'C704', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043013', '043', 'Civitanova Marche', 'C770', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043014', '043', 'Colmurano', 'C886', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043015', '043', 'Corridonia', 'D042', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043016', '043', 'Esanatoglia', 'D429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043017', '043', 'Fiastra', 'D564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043018', '043', 'Fiordimonte', 'D609', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043019', '043', 'Fiuminata', 'D628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043020', '043', 'Gagliole', 'D853', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043021', '043', 'Gualdo', 'E228', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043022', '043', 'Loro Piceno', 'E694', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043023', '043', 'Macerata', 'E783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043024', '043', 'Matelica', 'F051', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043025', '043', 'Mogliano', 'F268', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043027', '043', 'Monte Cavallo', 'F460', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043031', '043', 'Monte San Giusto', 'F621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043032', '043', 'Monte San Martino', 'F622', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043026', '043', 'Montecassiano', 'F454', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043028', '043', 'Montecosaro', 'F482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043029', '043', 'Montefano', 'F496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043030', '043', 'Montelupone', 'F552', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043033', '043', 'Morrovalle', 'F749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043034', '043', 'Muccia', 'F793', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043035', '043', 'Penna San Giovanni', 'G436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043036', '043', 'Petriolo', 'G515', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043038', '043', 'Pieve Torina', 'G657', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043037', '043', 'Pievebovigliana', 'G637', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043039', '043', 'Pioraco', 'G690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043040', '043', 'Poggio San Vicino', 'D566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043041', '043', 'Pollenza', 'F567', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043042', '043', 'Porto Recanati', 'G919', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043043', '043', 'Potenza Picena', 'F632', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043044', '043', 'Recanati', 'H211', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043045', '043', 'Ripe San Ginesio', 'H323', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043046', '043', 'San Ginesio', 'H876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043047', '043', 'San Severino Marche', 'I156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043048', '043', 'Sant''Angelo in Pontano', 'I286', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043049', '043', 'Sarnano', 'I436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043050', '043', 'Sefro', 'I569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043051', '043', 'Serrapetrona', 'I651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043052', '043', 'Serravalle di Chienti', 'I661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043053', '043', 'Tolentino', 'L191', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043054', '043', 'Treia', 'L366', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043055', '043', 'Urbisaglia', 'L501', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043056', '043', 'Ussita', 'L517', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043057', '043', 'Visso', 'M078', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043058', '043', 'Valfornace', 'M382', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('043801', '043', 'Porto Civitanova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044001', '044', 'Acquasanta Terme', 'A044', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044002', '044', 'Acquaviva Picena', 'A047', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044005', '044', 'Appignano del Tronto', 'A335', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044006', '044', 'Arquata del Tronto', 'A437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044007', '044', 'Ascoli Piceno', 'A462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044010', '044', 'Carassai', 'B727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044011', '044', 'Castel di Lama', 'C093', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044012', '044', 'Castignano', 'C321', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044013', '044', 'Castorano', 'C331', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044014', '044', 'Colli del Tronto', 'C877', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044015', '044', 'Comunanza', 'C935', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044016', '044', 'Cossignano', 'D096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044017', '044', 'Cupra Marittima', 'D210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044020', '044', 'Folignano', 'D652', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044021', '044', 'Force', 'D691', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044023', '044', 'Grottammare', 'E207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044027', '044', 'Maltignano', 'E868', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044029', '044', 'Massignano', 'F044', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044031', '044', 'Monsampolo del Tronto', 'F380', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044032', '044', 'Montalto delle Marche', 'F415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044034', '044', 'Montedinove', 'F487', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044036', '044', 'Montefiore dell''Aso', 'F501', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044038', '044', 'Montegallo', 'F516', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044044', '044', 'Montemonaco', 'F570', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044045', '044', 'Monteprandone', 'F591', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044054', '044', 'Offida', 'G005', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044056', '044', 'Palmiano', 'G289', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044063', '044', 'Ripatransone', 'H321', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044064', '044', 'Roccafluvione', 'H390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044065', '044', 'Rotella', 'H588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044066', '044', 'San Benedetto del Tronto', 'H769', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044071', '044', 'Spinetoli', 'I912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044073', '044', 'Venarotta', 'L728', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044801', '044', 'Alteta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044802', '044', 'Capradosso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044803', '044', 'Castel di Croce', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044804', '044', 'Lisciano del Tronto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044805', '044', 'Montacuto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044806', '044', 'Montadamo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044807', '044', 'Montecalvo del Castellano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044808', '044', 'Moregnano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044809', '044', 'Mozzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044810', '044', 'Osoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044811', '044', 'Pagliare', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044812', '044', 'Patrignone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044813', '044', 'Porchia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044814', '044', 'Porchiano dell''Ascensione', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044815', '044', 'Quintodecimo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044816', '044', 'Ripaberarda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044817', '044', 'Roccareonile', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044818', '044', 'Sant’Elpidio Morico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044819', '044', 'Santa Maria del Tronto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('044820', '044', 'Torre di Palme', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045001', '045', 'Aulla', 'A496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045002', '045', 'Bagnone', 'A576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045003', '045', 'Carrara', 'B832', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045004', '045', 'Casola in Lunigiana', 'B979', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045005', '045', 'Comano', 'C914', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045006', '045', 'Filattiera', 'D590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045007', '045', 'Fivizzano', 'D629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045008', '045', 'Fosdinovo', 'D735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045009', '045', 'Licciana Nardi', 'E574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045010', '045', 'Massa', 'F023', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045011', '045', 'Montignoso', 'F679', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045012', '045', 'Mulazzo', 'F802', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045013', '045', 'Podenzana', 'G746', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045014', '045', 'Pontremoli', 'G870', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045015', '045', 'Tresana', 'L386', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045016', '045', 'Villafranca in Lunigiana', 'L946', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045017', '045', 'Zeri', 'M169', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045801', '045', 'Albiano di Magra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045802', '045', 'Apuania', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('045803', '045', 'Terrarossa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046001', '046', 'Altopascio', 'A241', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046002', '046', 'Bagni di Lucca', 'A560', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046003', '046', 'Barga', 'A657', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046004', '046', 'Borgo a Mozzano', 'B007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046005', '046', 'Camaiore', 'B455', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046006', '046', 'Camporgiano', 'B557', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046007', '046', 'Capannori', 'B648', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046008', '046', 'Careggine', 'B760', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046009', '046', 'Castelnuovo di Garfagnana', 'C236', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046010', '046', 'Castiglione di Garfagnana', 'C303', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046011', '046', 'Coreglia Antelminelli', 'C996', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046012', '046', 'Fabbriche di Vallico', 'D449', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046013', '046', 'Forte dei Marmi', 'D730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046014', '046', 'Fosciandora', 'D734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046015', '046', 'Gallicano', 'D874', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046016', '046', 'Giuncugnano', 'E059', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046017', '046', 'Lucca', 'E715', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046018', '046', 'Massarosa', 'F035', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046019', '046', 'Minucciano', 'F225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046020', '046', 'Molazzana', 'F283', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046021', '046', 'Montecarlo', 'F452', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046022', '046', 'Pescaglia', 'G480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046023', '046', 'Piazza al Serchio', 'G582', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046024', '046', 'Pietrasanta', 'G628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046025', '046', 'Pieve Fosciana', 'G648', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046026', '046', 'Porcari', 'G882', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046027', '046', 'San Romano in Garfagnana', 'I142', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046028', '046', 'Seravezza', 'I622', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046029', '046', 'Sillano', 'I737', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046030', '046', 'Stazzema', 'I942', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046031', '046', 'Vagli Sotto', 'L533', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046032', '046', 'Vergemoli', 'L763', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046033', '046', 'Viareggio', 'L833', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046034', '046', 'Villa Basilica', 'L913', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046035', '046', 'Villa Collemandina', 'L926', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046036', '046', 'Fabbriche di Vergemoli', 'M319', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('046037', '046', 'Sillano Giuncugnano', 'M347', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047001', '047', 'Abetone', 'A012', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047002', '047', 'Agliana', 'A071', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047003', '047', 'Buggiano', 'B251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047022', '047', 'Chiesina Uzzanese', 'C631', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047004', '047', 'Cutigliano', 'D235', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047005', '047', 'Lamporecchio', 'E432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047006', '047', 'Larciano', 'E451', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047007', '047', 'Marliana', 'E960', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047008', '047', 'Massa e Cozzile', 'F025', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047009', '047', 'Monsummano Terme', 'F384', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047010', '047', 'Montale', 'F410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047011', '047', 'Montecatini-Terme', 'A561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047012', '047', 'Pescia', 'G491', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047013', '047', 'Pieve a Nievole', 'G636', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047014', '047', 'Pistoia', 'G713', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047015', '047', 'Piteglio', 'G715', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047016', '047', 'Ponte Buggianese', 'G833', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047017', '047', 'Quarrata', 'H109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047018', '047', 'Sambuca Pistoiese', 'H744', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047019', '047', 'San Marcello Pistoiese', 'H980', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047020', '047', 'Serravalle Pistoiese', 'I660', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047021', '047', 'Uzzano', 'L522', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047023', '047', 'Abetone Cutigliano', 'M376', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047024', '047', 'San Marcello Piteglio', 'M377', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047801', '047', 'Montecatini di Val di Nievole', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047802', '047', 'Porta al Borgo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047803', '047', 'Porta Carratica', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047804', '047', 'Porta Lucchese', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047805', '047', 'Porta San Marco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('047806', '047', 'Vellano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048001', '048', 'Bagno a Ripoli', 'A564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048002', '048', 'Barberino di Mugello', 'A632', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048003', '048', 'Barberino Val d''Elsa', 'A633', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048004', '048', 'Borgo San Lorenzo', 'B036', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048005', '048', 'Calenzano', 'B406', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048006', '048', 'Campi Bisenzio', 'B507', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048008', '048', 'Capraia e Limite', 'B684', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048010', '048', 'Castelfiorentino', 'C101', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048011', '048', 'Cerreto Guidi', 'C529', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048012', '048', 'Certaldo', 'C540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048013', '048', 'Dicomano', 'D299', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048014', '048', 'Empoli', 'D403', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048015', '048', 'Fiesole', 'D575', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048016', '048', 'Figline Valdarno', 'D583', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048017', '048', 'Firenze', 'D612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048018', '048', 'Firenzuola', 'D613', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048019', '048', 'Fucecchio', 'D815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048020', '048', 'Gambassi Terme', 'D895', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048021', '048', 'Greve in Chianti', 'E169', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048022', '048', 'Impruneta', 'E291', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048023', '048', 'Incisa in Val d''Arno', 'E296', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048024', '048', 'Lastra a Signa', 'E466', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048025', '048', 'Londa', 'E668', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048026', '048', 'Marradi', 'E971', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048027', '048', 'Montaione', 'F398', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048028', '048', 'Montelupo Fiorentino', 'F551', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048030', '048', 'Montespertoli', 'F648', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048031', '048', 'Palazzuolo sul Senio', 'G270', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048032', '048', 'Pelago', 'G420', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048033', '048', 'Pontassieve', 'G825', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048035', '048', 'Reggello', 'H222', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048036', '048', 'Rignano sull''Arno', 'H286', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048037', '048', 'Rufina', 'H635', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048038', '048', 'San Casciano in Val di Pesa', 'H791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048039', '048', 'San Godenzo', 'H937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048040', '048', 'San Piero a Sieve', 'I085', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048041', '048', 'Scandicci', 'B962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048042', '048', 'Scarperia', 'I514', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048043', '048', 'Sesto Fiorentino', 'I684', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048044', '048', 'Signa', 'I728', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048045', '048', 'Tavarnelle Val di Pesa', 'L067', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048046', '048', 'Vaglia', 'L529', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048049', '048', 'Vicchio', 'L838', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048050', '048', 'Vinci', 'M059', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048052', '048', 'Figline e Incisa Valdarno', 'M321', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048053', '048', 'Scarperia e San Piero', 'M326', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048801', '048', 'Brozzi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048802', '048', 'Galluzzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048803', '048', 'Legnaia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048804', '048', 'Pellegrino da Careggi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('048805', '048', 'Rovezzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049001', '049', 'Bibbona', 'A852', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049002', '049', 'Campiglia Marittima', 'B509', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049003', '049', 'Campo nell''Elba', 'B553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049004', '049', 'Capoliveri', 'B669', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049005', '049', 'Capraia Isola', 'B685', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049006', '049', 'Castagneto Carducci', 'C044', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049007', '049', 'Cecina', 'C415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049008', '049', 'Collesalvetti', 'C869', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049009', '049', 'Livorno', 'E625', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049010', '049', 'Marciana', 'E930', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049011', '049', 'Marciana Marina', 'E931', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049012', '049', 'Piombino', 'G687', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049013', '049', 'Porto Azzurro', 'E680', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049014', '049', 'Portoferraio', 'G912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049015', '049', 'Rio Marina', 'H305', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049016', '049', 'Rio nell''Elba', 'H297', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049017', '049', 'Rosignano Marittimo', 'H570', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049018', '049', 'San Vincenzo', 'I390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049019', '049', 'Sassetta', 'I454', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049020', '049', 'Suvereto', 'L019', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('049021', '049', 'Rio', 'M391', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050001', '050', 'Bientina', 'A864', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050002', '050', 'Buti', 'B303', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050003', '050', 'Calci', 'B390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050004', '050', 'Calcinaia', 'B392', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050005', '050', 'Capannoli', 'B647', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050006', '050', 'Casale Marittimo', 'B878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050007', '050', 'Casciana Terme', 'A559', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050008', '050', 'Cascina', 'B950', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050009', '050', 'Castelfranco di Sotto', 'C113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050010', '050', 'Castellina Marittima', 'C174', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050011', '050', 'Castelnuovo di Val di Cecina', 'C244', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050012', '050', 'Chianni', 'C609', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050013', '050', 'Crespina', 'D160', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050014', '050', 'Fauglia', 'D510', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050015', '050', 'Guardistallo', 'E250', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050016', '050', 'Lajatico', 'E413', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050017', '050', 'Lari', 'E455', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050018', '050', 'Lorenzana', 'E688', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050019', '050', 'Montecatini Val di Cecina', 'F458', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050020', '050', 'Montescudaio', 'F640', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050021', '050', 'Monteverdi Marittimo', 'F661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050022', '050', 'Montopoli in Val d''Arno', 'F686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050023', '050', 'Orciano Pisano', 'G090', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050024', '050', 'Palaia', 'G254', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050025', '050', 'Peccioli', 'G395', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050026', '050', 'Pisa', 'G702', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050027', '050', 'Pomarance', 'G804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050028', '050', 'Ponsacco', 'G822', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050029', '050', 'Pontedera', 'G843', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050030', '050', 'Riparbella', 'H319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050031', '050', 'San Giuliano Terme', 'A562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050032', '050', 'San Miniato', 'I046', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050033', '050', 'Santa Croce sull''Arno', 'I177', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050034', '050', 'Santa Luce', 'I217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050035', '050', 'Santa Maria a Monte', 'I232', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050036', '050', 'Terricciola', 'L138', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050037', '050', 'Vecchiano', 'L702', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050038', '050', 'Vicopisano', 'L850', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050039', '050', 'Volterra', 'M126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050040', '050', 'Casciana Terme Lari', 'M327', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050041', '050', 'Crespina Lorenzana', 'M328', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050801', '050', 'Montecalvoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('050802', '050', 'Santa Luce Orciano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051001', '051', 'Anghiari', 'A291', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051002', '051', 'Arezzo', 'A390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051003', '051', 'Badia Tedalda', 'A541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051004', '051', 'Bibbiena', 'A851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051005', '051', 'Bucine', 'B243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051006', '051', 'Capolona', 'B670', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051007', '051', 'Caprese Michelangelo', 'B693', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051008', '051', 'Castel Focognano', 'C102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051010', '051', 'Castel San Niccolò', 'C263', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051009', '051', 'Castelfranco di Sopra', 'C112', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051011', '051', 'Castiglion Fibocchi', 'C318', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051012', '051', 'Castiglion Fiorentino', 'C319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051013', '051', 'Cavriglia', 'C407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051014', '051', 'Chitignano', 'C648', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051015', '051', 'Chiusi della Verna', 'C663', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051016', '051', 'Civitella in Val di Chiana', 'C774', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051017', '051', 'Cortona', 'D077', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051018', '051', 'Foiano della Chiana', 'D649', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051019', '051', 'Laterina', 'E468', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051020', '051', 'Loro Ciuffenna', 'E693', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051021', '051', 'Lucignano', 'E718', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051022', '051', 'Marciano della Chiana', 'E933', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051025', '051', 'Monte San Savino', 'F628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051023', '051', 'Montemignaio', 'F565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051024', '051', 'Monterchi', 'F594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051026', '051', 'Montevarchi', 'F656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051027', '051', 'Ortignano Raggiolo', 'G139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051028', '051', 'Pergine Valdarno', 'G451', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051029', '051', 'Pian di Sco', 'G552', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051030', '051', 'Pieve Santo Stefano', 'G653', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051031', '051', 'Poppi', 'G879', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051032', '051', 'Pratovecchio', 'H008', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051033', '051', 'San Giovanni Valdarno', 'H901', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051034', '051', 'Sansepolcro', 'I155', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051035', '051', 'Sestino', 'I681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051036', '051', 'Stia', 'I952', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051037', '051', 'Subbiano', 'I991', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051038', '051', 'Talla', 'L038', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051039', '051', 'Terranuova Bracciolini', 'L123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051040', '051', 'Castelfranco Piandiscò', 'M322', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051041', '051', 'Pratovecchio Stia', 'M329', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051042', '051', 'Laterina Pergine Valdarno', 'M392', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051801', '051', 'Castiglion Ubertini', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051802', '051', 'Pratovecchio Stia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('051803', '051', 'Raggiolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052001', '052', 'Abbadia San Salvatore', 'A006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052002', '052', 'Asciano', 'A461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052003', '052', 'Buonconvento', 'B269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052004', '052', 'Casole d''Elsa', 'B984', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052005', '052', 'Castellina in Chianti', 'C172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052006', '052', 'Castelnuovo Berardenga', 'C227', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052007', '052', 'Castiglione d''Orcia', 'C313', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052008', '052', 'Cetona', 'C587', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052009', '052', 'Chianciano Terme', 'C608', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052010', '052', 'Chiusdino', 'C661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052011', '052', 'Chiusi', 'C662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052012', '052', 'Colle di Val d''Elsa', 'C847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052013', '052', 'Gaiole in Chianti', 'D858', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052014', '052', 'Montalcino', 'F402', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052015', '052', 'Montepulciano', 'F592', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052016', '052', 'Monteriggioni', 'F598', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052017', '052', 'Monteroni d''Arbia', 'F605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052018', '052', 'Monticiano', 'F676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052019', '052', 'Murlo', 'F815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052020', '052', 'Piancastagnaio', 'G547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052021', '052', 'Pienza', 'G602', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052022', '052', 'Poggibonsi', 'G752', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052023', '052', 'Radda in Chianti', 'H153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052024', '052', 'Radicofani', 'H156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052025', '052', 'Radicondoli', 'H157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052026', '052', 'Rapolano Terme', 'H185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052027', '052', 'San Casciano dei Bagni', 'H790', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052028', '052', 'San Gimignano', 'H875', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052029', '052', 'San Giovanni d''Asso', 'H911', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052030', '052', 'San Quirico d''Orcia', 'I135', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052031', '052', 'Sarteano', 'I445', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052032', '052', 'Siena', 'I726', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052033', '052', 'Sinalunga', 'A468', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052034', '052', 'Sovicille', 'I877', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052035', '052', 'Torrita di Siena', 'L303', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052036', '052', 'Trequanda', 'L384', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052037', '052', 'Montalcino', 'M378', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052801', '052', 'Masse di Città', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052802', '052', 'Masse di San Martino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('052803', '052', 'Masse di Siena', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053001', '053', 'Arcidosso', 'A369', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053002', '053', 'Campagnatico', 'B497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053003', '053', 'Capalbio', 'B646', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053004', '053', 'Castel del Piano', 'C085', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053005', '053', 'Castell''Azzara', 'C147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053006', '053', 'Castiglione della Pescaia', 'C310', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053007', '053', 'Cinigiano', 'C705', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053008', '053', 'Civitella Paganico', 'C782', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053009', '053', 'Follonica', 'D656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053010', '053', 'Gavorrano', 'D948', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053011', '053', 'Grosseto', 'E202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053012', '053', 'Isola del Giglio', 'E348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053013', '053', 'Magliano in Toscana', 'E810', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053014', '053', 'Manciano', 'E875', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053015', '053', 'Massa Marittima', 'F032', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053016', '053', 'Monte Argentario', 'F437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053027', '053', 'Monterotondo Marittimo', 'F612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053017', '053', 'Montieri', 'F677', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053018', '053', 'Orbetello', 'G088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053019', '053', 'Pitigliano', 'G716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053020', '053', 'Roccalbegna', 'H417', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053021', '053', 'Roccastrada', 'H449', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053022', '053', 'Santa Fiora', 'I187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053023', '053', 'Scansano', 'I504', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053024', '053', 'Scarlino', 'I510', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053025', '053', 'Seggiano', 'I571', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053028', '053', 'Semproniano', 'I601', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('053026', '053', 'Sorano', 'I841', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054001', '054', 'Assisi', 'A475', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054002', '054', 'Bastia Umbra', 'A710', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054003', '054', 'Bettona', 'A832', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054004', '054', 'Bevagna', 'A835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054005', '054', 'Campello sul Clitunno', 'B504', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054006', '054', 'Cannara', 'B609', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054007', '054', 'Cascia', 'B948', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054008', '054', 'Castel Ritaldi', 'C252', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054009', '054', 'Castiglione del Lago', 'C309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054010', '054', 'Cerreto di Spoleto', 'C527', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054011', '054', 'Citerna', 'C742', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054012', '054', 'Città della Pieve', 'C744', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054013', '054', 'Città di Castello', 'C745', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054014', '054', 'Collazzone', 'C845', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054015', '054', 'Corciano', 'C990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054016', '054', 'Costacciaro', 'D108', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054017', '054', 'Deruta', 'D279', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054018', '054', 'Foligno', 'D653', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054019', '054', 'Fossato di Vico', 'D745', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054020', '054', 'Fratta Todina', 'D787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054021', '054', 'Giano dell''Umbria', 'E012', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054022', '054', 'Gualdo Cattaneo', 'E229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054023', '054', 'Gualdo Tadino', 'E230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054024', '054', 'Gubbio', 'E256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054025', '054', 'Lisciano Niccone', 'E613', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054026', '054', 'Magione', 'E805', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054027', '054', 'Marsciano', 'E975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054028', '054', 'Massa Martana', 'F024', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054029', '054', 'Monte Castello di Vibio', 'F456', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054032', '054', 'Monte Santa Maria Tiberina', 'F629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054030', '054', 'Montefalco', 'F492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054031', '054', 'Monteleone di Spoleto', 'F540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054033', '054', 'Montone', 'F685', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054034', '054', 'Nocera Umbra', 'F911', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054035', '054', 'Norcia', 'F935', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054036', '054', 'Paciano', 'G212', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054037', '054', 'Panicale', 'G308', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054038', '054', 'Passignano sul Trasimeno', 'G359', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054039', '054', 'Perugia', 'G478', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054040', '054', 'Piegaro', 'G601', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054041', '054', 'Pietralunga', 'G618', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054042', '054', 'Poggiodomo', 'G758', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054043', '054', 'Preci', 'H015', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054044', '054', 'San Giustino', 'H935', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054045', '054', 'Sant''Anatolia di Narco', 'I263', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054046', '054', 'Scheggia e Pascelupo', 'I522', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054047', '054', 'Scheggino', 'I523', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054048', '054', 'Sellano', 'I585', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054049', '054', 'Sigillo', 'I727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054050', '054', 'Spello', 'I888', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054051', '054', 'Spoleto', 'I921', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054052', '054', 'Todi', 'L188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054053', '054', 'Torgiano', 'L216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054054', '054', 'Trevi', 'L397', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054055', '054', 'Tuoro sul Trasimeno', 'L466', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054056', '054', 'Umbertide', 'D786', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054057', '054', 'Valfabbrica', 'L573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054058', '054', 'Vallo di Nera', 'L627', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054059', '054', 'Valtopina', 'L653', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054801', '054', 'Castel San Felice', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054802', '054', 'Castel San Giovanni di Spoleto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054803', '054', 'Ceselli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054804', '054', 'Collemancio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054805', '054', 'Montesanto Vigi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054806', '054', 'Pascelupo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('054807', '054', 'Piedipaterno sul Nera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055001', '055', 'Acquasparta', 'A045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055002', '055', 'Allerona', 'A207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055003', '055', 'Alviano', 'A242', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055004', '055', 'Amelia', 'A262', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055005', '055', 'Arrone', 'A439', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055006', '055', 'Attigliano', 'A490', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055033', '055', 'Avigliano Umbro', 'M258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055007', '055', 'Baschi', 'A691', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055008', '055', 'Calvi dell''Umbria', 'B446', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055009', '055', 'Castel Giorgio', 'C117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055010', '055', 'Castel Viscardo', 'C289', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055011', '055', 'Fabro', 'D454', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055012', '055', 'Ferentillo', 'D538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055013', '055', 'Ficulle', 'D570', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055014', '055', 'Giove', 'E045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055015', '055', 'Guardea', 'E241', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055016', '055', 'Lugnano in Teverina', 'E729', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055017', '055', 'Montecastrilli', 'F457', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055018', '055', 'Montecchio', 'F462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055019', '055', 'Montefranco', 'F510', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055020', '055', 'Montegabbione', 'F513', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055021', '055', 'Monteleone d''Orvieto', 'F543', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055022', '055', 'Narni', 'F844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055023', '055', 'Orvieto', 'G148', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055024', '055', 'Otricoli', 'G189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055025', '055', 'Parrano', 'G344', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055026', '055', 'Penna in Teverina', 'G432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055027', '055', 'Polino', 'G790', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055028', '055', 'Porano', 'G881', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055029', '055', 'San Gemini', 'H857', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055030', '055', 'San Venanzo', 'I381', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055031', '055', 'Stroncone', 'I981', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055032', '055', 'Terni', 'L117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055801', '055', 'Capitone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055802', '055', 'Carnaiola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055803', '055', 'Castel di Lago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055804', '055', 'Cesi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055805', '055', 'Collescipoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055806', '055', 'Collestatte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055807', '055', 'Montegiove', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055808', '055', 'Monterubbiaglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055809', '055', 'Papigno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055810', '055', 'Piediluco', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055811', '055', 'Porchiano del Monte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055812', '055', 'Portaria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055813', '055', 'San Vito in Monte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('055814', '055', 'Torre Orsina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056001', '056', 'Acquapendente', 'A040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056002', '056', 'Arlena di Castro', 'A412', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056003', '056', 'Bagnoregio', 'A577', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056004', '056', 'Barbarano Romano', 'A628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056006', '056', 'Bassano in Teverina', 'A706', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056005', '056', 'Bassano Romano', 'A704', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056007', '056', 'Blera', 'A857', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056008', '056', 'Bolsena', 'A949', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056009', '056', 'Bomarzo', 'A955', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056010', '056', 'Calcata', 'B388', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056011', '056', 'Canepina', 'B597', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056012', '056', 'Canino', 'B604', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056013', '056', 'Capodimonte', 'B663', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056014', '056', 'Capranica', 'B688', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056015', '056', 'Caprarola', 'B691', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056016', '056', 'Carbognano', 'B735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056017', '056', 'Castel Sant''Elia', 'C269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056018', '056', 'Castiglione in Teverina', 'C315', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056019', '056', 'Celleno', 'C446', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056020', '056', 'Cellere', 'C447', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056021', '056', 'Civita Castellana', 'C765', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056022', '056', 'Civitella d''Agliano', 'C780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056023', '056', 'Corchiano', 'C988', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056024', '056', 'Fabrica di Roma', 'D452', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056025', '056', 'Faleria', 'D475', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056026', '056', 'Farnese', 'D503', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056027', '056', 'Gallese', 'D870', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056028', '056', 'Gradoli', 'E126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056029', '056', 'Graffignano', 'E128', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056030', '056', 'Grotte di Castro', 'E210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056031', '056', 'Ischia di Castro', 'E330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056032', '056', 'Latera', 'E467', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056033', '056', 'Lubriano', 'E713', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056034', '056', 'Marta', 'E978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056035', '056', 'Montalto di Castro', 'F419', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056037', '056', 'Monte Romano', 'F603', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056036', '056', 'Montefiascone', 'F499', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056038', '056', 'Monterosi', 'F606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056039', '056', 'Nepi', 'F868', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056040', '056', 'Onano', 'G065', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056041', '056', 'Oriolo Romano', 'G111', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056042', '056', 'Orte', 'G135', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056043', '056', 'Piansano', 'G571', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056044', '056', 'Proceno', 'H071', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056045', '056', 'Ronciglione', 'H534', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056047', '056', 'San Lorenzo Nuovo', 'H969', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056048', '056', 'Soriano nel Cimino', 'I855', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056049', '056', 'Sutri', 'L017', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056050', '056', 'Tarquinia', 'D024', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056051', '056', 'Tessennano', 'L150', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056052', '056', 'Tuscania', 'L310', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056053', '056', 'Valentano', 'L569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056054', '056', 'Vallerano', 'L612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056055', '056', 'Vasanello', 'A701', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056056', '056', 'Vejano', 'L713', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056057', '056', 'Vetralla', 'L814', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056058', '056', 'Vignanello', 'L882', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056046', '056', 'Villa San Giovanni in Tuscia', 'H913', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056059', '056', 'Viterbo', 'M082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056060', '056', 'Vitorchiano', 'M086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056801', '056', 'Bagnaja', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056802', '056', 'Castel Cellesi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056803', '056', 'Grotte Santo Stefano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056804', '056', 'Roccalvecce', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056805', '056', 'San Martino al Cimino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('056806', '056', 'San Michele in Teverina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057001', '057', 'Accumoli', 'A019', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057002', '057', 'Amatrice', 'A258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057003', '057', 'Antrodoco', 'A315', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057004', '057', 'Ascrea', 'A464', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057005', '057', 'Belmonte in Sabina', 'A765', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057006', '057', 'Borbona', 'A981', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057008', '057', 'Borgo Velino', 'A996', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057007', '057', 'Borgorose', 'B008', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057009', '057', 'Cantalice', 'B627', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057010', '057', 'Cantalupo in Sabina', 'B631', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057011', '057', 'Casaprota', 'B934', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057012', '057', 'Casperia', 'A472', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057013', '057', 'Castel di Tora', 'C098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057015', '057', 'Castel Sant''Angelo', 'C268', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057014', '057', 'Castelnuovo di Farfa', 'C224', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057016', '057', 'Cittaducale', 'C746', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057017', '057', 'Cittareale', 'C749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057018', '057', 'Collalto Sabino', 'C841', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057019', '057', 'Colle di Tora', 'C857', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057020', '057', 'Collegiove', 'C859', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057021', '057', 'Collevecchio', 'C876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057022', '057', 'Colli sul Velino', 'C880', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057023', '057', 'Concerviano', 'C946', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057024', '057', 'Configni', 'C959', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057025', '057', 'Contigliano', 'C969', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057026', '057', 'Cottanello', 'D124', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057027', '057', 'Fara in Sabina', 'D493', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057028', '057', 'Fiamignano', 'D560', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057029', '057', 'Forano', 'D689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057030', '057', 'Frasso Sabino', 'D785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057031', '057', 'Greccio', 'E160', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057032', '057', 'Labro', 'E393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057033', '057', 'Leonessa', 'E535', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057034', '057', 'Longone Sabino', 'E681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057035', '057', 'Magliano Sabina', 'E812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057036', '057', 'Marcetelli', 'E927', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057037', '057', 'Micigliano', 'F193', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057038', '057', 'Mompeo', 'F319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057039', '057', 'Montasola', 'F430', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057043', '057', 'Monte San Giovanni in Sabina', 'F619', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057040', '057', 'Montebuono', 'F446', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057041', '057', 'Monteleone Sabino', 'F541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057042', '057', 'Montenero Sabino', 'F579', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057044', '057', 'Montopoli di Sabina', 'F687', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057045', '057', 'Morro Reatino', 'F746', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057046', '057', 'Nespolo', 'F876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057047', '057', 'Orvinio', 'B595', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057048', '057', 'Paganico Sabino', 'G232', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057049', '057', 'Pescorocchiano', 'G498', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057050', '057', 'Petrella Salto', 'G513', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057051', '057', 'Poggio Bustone', 'G756', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057052', '057', 'Poggio Catino', 'G757', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057053', '057', 'Poggio Mirteto', 'G763', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057054', '057', 'Poggio Moiano', 'G764', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057055', '057', 'Poggio Nativo', 'G765', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057056', '057', 'Poggio San Lorenzo', 'G770', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057057', '057', 'Posta', 'G934', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057058', '057', 'Pozzaglia Sabina', 'G951', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057059', '057', 'Rieti', 'H282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057060', '057', 'Rivodutri', 'H354', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057062', '057', 'Rocca Sinibalda', 'H446', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057061', '057', 'Roccantica', 'H427', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057063', '057', 'Salisano', 'H713', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057064', '057', 'Scandriglia', 'I499', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057065', '057', 'Selci', 'I581', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057066', '057', 'Stimigliano', 'I959', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057067', '057', 'Tarano', 'L046', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057068', '057', 'Toffia', 'L189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057070', '057', 'Torri in Sabina', 'L286', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057069', '057', 'Torricella in Sabina', 'L293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057071', '057', 'Turania', 'G507', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057072', '057', 'Vacone', 'L525', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057073', '057', 'Varco Sabino', 'L676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057801', '057', 'Bocchignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057802', '057', 'Castel San Benedetto Reatino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057803', '057', 'Cerchiara in Sabina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057804', '057', 'Collebaccaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057805', '057', 'Monte Santa Maria in Sabina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057806', '057', 'Oliveto in Sabina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057807', '057', 'Poggio Fidoni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057808', '057', 'Posticciola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057809', '057', 'Rocchette', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057810', '057', 'San Giovanni Reatino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057811', '057', 'Sant’Elia Reatino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('057812', '057', 'Vazia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058001', '058', 'Affile', 'A062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058002', '058', 'Agosta', 'A084', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058003', '058', 'Albano Laziale', 'A132', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058004', '058', 'Allumiere', 'A210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058005', '058', 'Anguillara Sabazia', 'A297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058006', '058', 'Anticoli Corrado', 'A309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058007', '058', 'Anzio', 'A323', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058008', '058', 'Arcinazzo Romano', 'A370', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058117', '058', 'Ardea', 'M213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058009', '058', 'Ariccia', 'A401', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058010', '058', 'Arsoli', 'A446', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058011', '058', 'Artena', 'A449', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058012', '058', 'Bellegra', 'A749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058013', '058', 'Bracciano', 'B114', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058014', '058', 'Camerata Nuova', 'B472', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058015', '058', 'Campagnano di Roma', 'B496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058016', '058', 'Canale Monterano', 'B576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058017', '058', 'Canterano', 'B635', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058018', '058', 'Capena', 'B649', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058019', '058', 'Capranica Prenestina', 'B687', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058020', '058', 'Carpineto Romano', 'B828', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058021', '058', 'Casape', 'B932', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058022', '058', 'Castel Gandolfo', 'C116', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058023', '058', 'Castel Madama', 'C203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058025', '058', 'Castel San Pietro Romano', 'C266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058024', '058', 'Castelnuovo di Porto', 'C237', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058026', '058', 'Cave', 'C390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058027', '058', 'Cerreto Laziale', 'C518', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058028', '058', 'Cervara di Roma', 'C543', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058029', '058', 'Cerveteri', 'C552', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058118', '058', 'Ciampino', 'M272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058030', '058', 'Ciciliano', 'C677', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058031', '058', 'Cineto Romano', 'C702', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058032', '058', 'Civitavecchia', 'C773', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058033', '058', 'Civitella San Paolo', 'C784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058034', '058', 'Colleferro', 'C858', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058035', '058', 'Colonna', 'C900', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058036', '058', 'Fiano Romano', 'D561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058037', '058', 'Filacciano', 'D586', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058120', '058', 'Fiumicino', 'M297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058122', '058', 'Fonte Nuova', 'M309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058038', '058', 'Formello', 'D707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058039', '058', 'Frascati', 'D773', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058040', '058', 'Gallicano nel Lazio', 'D875', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058041', '058', 'Gavignano', 'D945', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058042', '058', 'Genazzano', 'D964', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058043', '058', 'Genzano di Roma', 'D972', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058044', '058', 'Gerano', 'D978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058045', '058', 'Gorga', 'E091', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058046', '058', 'Grottaferrata', 'E204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058047', '058', 'Guidonia Montecelio', 'E263', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058048', '058', 'Jenne', 'E382', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058049', '058', 'Labico', 'E392', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058116', '058', 'Ladispoli', 'M212', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058050', '058', 'Lanuvio', 'C767', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058115', '058', 'Lariano', 'M207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058051', '058', 'Licenza', 'E576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058052', '058', 'Magliano Romano', 'E813', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058053', '058', 'Mandela', 'B632', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058054', '058', 'Manziana', 'E900', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058055', '058', 'Marano Equo', 'E908', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058056', '058', 'Marcellina', 'E924', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058057', '058', 'Marino', 'E958', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058058', '058', 'Mazzano Romano', 'F064', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058059', '058', 'Mentana', 'F127', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058060', '058', 'Monte Compatri', 'F477', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058064', '058', 'Monte Porzio Catone', 'F590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058061', '058', 'Monteflavio', 'F504', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058062', '058', 'Montelanico', 'F534', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058063', '058', 'Montelibretti', 'F545', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058065', '058', 'Monterotondo', 'F611', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058066', '058', 'Montorio Romano', 'F692', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058067', '058', 'Moricone', 'F730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058068', '058', 'Morlupo', 'F734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058069', '058', 'Nazzano', 'F857', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058070', '058', 'Nemi', 'F865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058071', '058', 'Nerola', 'F871', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058072', '058', 'Nettuno', 'F880', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058073', '058', 'Olevano Romano', 'G022', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058074', '058', 'Palestrina', 'G274', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058075', '058', 'Palombara Sabina', 'G293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058076', '058', 'Percile', 'G444', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058077', '058', 'Pisoniano', 'G704', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058078', '058', 'Poli', 'G784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058079', '058', 'Pomezia', 'G811', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058080', '058', 'Ponzano Romano', 'G874', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058081', '058', 'Riano', 'H267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058082', '058', 'Rignano Flaminio', 'H288', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058083', '058', 'Riofreddo', 'H300', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058084', '058', 'Rocca Canterano', 'H387', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058085', '058', 'Rocca di Cave', 'H401', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058086', '058', 'Rocca di Papa', 'H404', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058088', '058', 'Rocca Priora', 'H432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058089', '058', 'Rocca Santo Stefano', 'H441', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058087', '058', 'Roccagiovine', 'H411', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058090', '058', 'Roiate', 'H494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058091', '058', 'Roma', 'H501', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058092', '058', 'Roviano', 'H618', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058093', '058', 'Sacrofano', 'H658', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058094', '058', 'Sambuci', 'H745', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058119', '058', 'San Cesareo', 'M295', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058095', '058', 'San Gregorio da Sassola', 'H942', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058096', '058', 'San Polo dei Cavalieri', 'I125', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058100', '058', 'San Vito Romano', 'I400', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058097', '058', 'Santa Marinella', 'I255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058098', '058', 'Sant''Angelo Romano', 'I284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058099', '058', 'Sant''Oreste', 'I352', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058101', '058', 'Saracinesco', 'I424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058102', '058', 'Segni', 'I573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058103', '058', 'Subiaco', 'I992', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058104', '058', 'Tivoli', 'L182', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058105', '058', 'Tolfa', 'L192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058106', '058', 'Torrita Tiberina', 'L302', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058107', '058', 'Trevignano Romano', 'L401', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058108', '058', 'Vallepietra', 'L611', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058109', '058', 'Vallinfreda', 'L625', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058110', '058', 'Valmontone', 'L639', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058111', '058', 'Velletri', 'L719', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058112', '058', 'Vicovaro', 'L851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058113', '058', 'Vivaro Romano', 'M095', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058114', '058', 'Zagarolo', 'M141', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058121', '058', 'Boville', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058801', '058', 'Montecelio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('058802', '058', 'Nettunia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059001', '059', 'Aprilia', 'A341', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059002', '059', 'Bassiano', 'A707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059003', '059', 'Campodimele', 'B527', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059004', '059', 'Castelforte', 'C104', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059005', '059', 'Cisterna di Latina', 'C740', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059006', '059', 'Cori', 'D003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059007', '059', 'Fondi', 'D662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059008', '059', 'Formia', 'D708', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059009', '059', 'Gaeta', 'D843', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059010', '059', 'Itri', 'E375', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059011', '059', 'Latina', 'E472', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059012', '059', 'Lenola', 'E527', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059013', '059', 'Maenza', 'E798', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059014', '059', 'Minturno', 'F224', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059015', '059', 'Monte San Biagio', 'F616', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059016', '059', 'Norma', 'F937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059017', '059', 'Pontinia', 'G865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059018', '059', 'Ponza', 'G871', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059019', '059', 'Priverno', 'G698', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059020', '059', 'Prossedi', 'H076', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059022', '059', 'Rocca Massima', 'H421', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059021', '059', 'Roccagorga', 'H413', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059023', '059', 'Roccasecca dei Volsci', 'H444', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059024', '059', 'Sabaudia', 'H647', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059025', '059', 'San Felice Circeo', 'H836', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059026', '059', 'Santi Cosma e Damiano', 'I339', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059027', '059', 'Sermoneta', 'I634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059028', '059', 'Sezze', 'I712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059029', '059', 'Sonnino', 'I832', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059030', '059', 'Sperlonga', 'I892', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059031', '059', 'Spigno Saturnia', 'I902', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059032', '059', 'Terracina', 'L120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059033', '059', 'Ventotene', 'L742', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059801', '059', 'Castellonorato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059802', '059', 'Elena', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('059803', '059', 'Maranola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060001', '060', 'Acquafondata', 'A032', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060002', '060', 'Acuto', 'A054', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060003', '060', 'Alatri', 'A123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060004', '060', 'Alvito', 'A244', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060005', '060', 'Amaseno', 'A256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060006', '060', 'Anagni', 'A269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060007', '060', 'Aquino', 'A348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060008', '060', 'Arce', 'A363', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060009', '060', 'Arnara', 'A421', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060010', '060', 'Arpino', 'A433', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060011', '060', 'Atina', 'A486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060012', '060', 'Ausonia', 'A502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060013', '060', 'Belmonte Castello', 'A763', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060014', '060', 'Boville Ernica', 'A720', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060015', '060', 'Broccostella', 'B195', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060016', '060', 'Campoli Appennino', 'B543', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060017', '060', 'Casalattico', 'B862', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060018', '060', 'Casalvieri', 'B919', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060019', '060', 'Cassino', 'C034', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060020', '060', 'Castelliri', 'C177', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060021', '060', 'Castelnuovo Parano', 'C223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060023', '060', 'Castro dei Volsci', 'C338', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060022', '060', 'Castrocielo', 'C340', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060024', '060', 'Ceccano', 'C413', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060025', '060', 'Ceprano', 'C479', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060026', '060', 'Cervaro', 'C545', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060027', '060', 'Colfelice', 'C836', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060029', '060', 'Colle San Magno', 'C870', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060028', '060', 'Collepardo', 'C864', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060030', '060', 'Coreno Ausonio', 'C998', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060031', '060', 'Esperia', 'D440', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060032', '060', 'Falvaterra', 'D483', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060033', '060', 'Ferentino', 'D539', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060034', '060', 'Filettino', 'D591', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060035', '060', 'Fiuggi', 'A310', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060036', '060', 'Fontana Liri', 'D667', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060037', '060', 'Fontechiari', 'D682', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060038', '060', 'Frosinone', 'D810', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060039', '060', 'Fumone', 'D819', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060040', '060', 'Gallinaro', 'D881', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060041', '060', 'Giuliano di Roma', 'E057', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060042', '060', 'Guarcino', 'E236', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060043', '060', 'Isola del Liri', 'E340', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060044', '060', 'Monte San Giovanni Campano', 'F620', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060045', '060', 'Morolo', 'F740', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060046', '060', 'Paliano', 'G276', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060047', '060', 'Pastena', 'G362', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060048', '060', 'Patrica', 'G374', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060049', '060', 'Pescosolido', 'G500', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060050', '060', 'Picinisco', 'G591', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060051', '060', 'Pico', 'G592', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060052', '060', 'Piedimonte San Germano', 'G598', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060053', '060', 'Piglio', 'G659', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060054', '060', 'Pignataro Interamna', 'G662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060055', '060', 'Pofi', 'G749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060056', '060', 'Pontecorvo', 'G838', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060057', '060', 'Posta Fibreno', 'G935', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060058', '060', 'Ripi', 'H324', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060059', '060', 'Rocca d''Arce', 'H393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060060', '060', 'Roccasecca', 'H443', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060061', '060', 'San Biagio Saracinisco', 'H779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060062', '060', 'San Donato Val di Comino', 'H824', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060063', '060', 'San Giorgio a Liri', 'H880', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060064', '060', 'San Giovanni Incarico', 'H917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060070', '060', 'San Vittore del Lazio', 'I408', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060065', '060', 'Sant''Ambrogio sul Garigliano', 'I256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060066', '060', 'Sant''Andrea del Garigliano', 'I265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060067', '060', 'Sant''Apollinare', 'I302', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060068', '060', 'Sant''Elia Fiumerapido', 'I321', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060069', '060', 'Santopadre', 'I351', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060071', '060', 'Serrone', 'I669', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060072', '060', 'Settefrati', 'I697', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060073', '060', 'Sgurgola', 'I716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060074', '060', 'Sora', 'I838', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060075', '060', 'Strangolagalli', 'I973', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060076', '060', 'Supino', 'L009', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060077', '060', 'Terelle', 'L105', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060078', '060', 'Torre Cajetani', 'L243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060079', '060', 'Torrice', 'L290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060080', '060', 'Trevi nel Lazio', 'L398', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060081', '060', 'Trivigliano', 'L437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060082', '060', 'Vallecorsa', 'L598', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060083', '060', 'Vallemaio', 'L605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060084', '060', 'Vallerotonda', 'L614', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060085', '060', 'Veroli', 'L780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060086', '060', 'Vicalvi', 'L836', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060087', '060', 'Vico nel Lazio', 'L843', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060088', '060', 'Villa Latina', 'A081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060089', '060', 'Villa Santa Lucia', 'L905', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060090', '060', 'Villa Santo Stefano', 'I364', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060091', '060', 'Viticuso', 'M083', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060801', '060', 'Roccaguglielma', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060802', '060', 'San Pietro in Curolis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060803', '060', 'Sant’Andrea di Vallefredda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('060804', '060', 'Viticuso ed Acquafondata', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061001', '061', 'Ailano', 'A106', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061002', '061', 'Alife', 'A200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061003', '061', 'Alvignano', 'A243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061004', '061', 'Arienzo', 'A403', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061005', '061', 'Aversa', 'A512', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061006', '061', 'Baia e Latina', 'A579', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061007', '061', 'Bellona', 'A755', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061008', '061', 'Caianello', 'B361', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061009', '061', 'Caiazzo', 'B362', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061010', '061', 'Calvi Risorta', 'B445', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061011', '061', 'Camigliano', 'B477', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061012', '061', 'Cancello ed Arnone', 'B581', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061013', '061', 'Capodrise', 'B667', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061014', '061', 'Capriati a Volturno', 'B704', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061015', '061', 'Capua', 'B715', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061016', '061', 'Carinaro', 'B779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061017', '061', 'Carinola', 'B781', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061018', '061', 'Casagiove', 'B860', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061019', '061', 'Casal di Principe', 'B872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061020', '061', 'Casaluce', 'B916', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061103', '061', 'Casapesenna', 'M260', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061021', '061', 'Casapulla', 'B935', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061022', '061', 'Caserta', 'B963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061023', '061', 'Castel Campagnano', 'B494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061024', '061', 'Castel di Sasso', 'C097', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061026', '061', 'Castel Morrone', 'C211', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061027', '061', 'Castel Volturno', 'C291', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061025', '061', 'Castello del Matese', 'C178', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061102', '061', 'Cellole', 'M262', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061028', '061', 'Cervino', 'C558', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061029', '061', 'Cesa', 'C561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061030', '061', 'Ciorlano', 'C716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061031', '061', 'Conca della Campania', 'C939', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061032', '061', 'Curti', 'D228', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061033', '061', 'Dragoni', 'D361', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061101', '061', 'Falciano del Massico', 'D471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061034', '061', 'Fontegreca', 'D683', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061035', '061', 'Formicola', 'D709', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061036', '061', 'Francolise', 'D769', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061037', '061', 'Frignano', 'D799', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061038', '061', 'Gallo Matese', 'D884', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061039', '061', 'Galluccio', 'D886', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061040', '061', 'Giano Vetusto', 'E011', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061041', '061', 'Gioia Sannitica', 'E039', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061042', '061', 'Grazzanise', 'E158', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061043', '061', 'Gricignano di Aversa', 'E173', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061044', '061', 'Letino', 'E554', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061045', '061', 'Liberi', 'E570', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061046', '061', 'Lusciano', 'E754', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061047', '061', 'Macerata Campania', 'E784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061048', '061', 'Maddaloni', 'E791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061049', '061', 'Marcianise', 'E932', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061050', '061', 'Marzano Appio', 'E998', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061051', '061', 'Mignano Monte Lungo', 'F203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061052', '061', 'Mondragone', 'F352', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061053', '061', 'Orta di Atella', 'G130', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061054', '061', 'Parete', 'G333', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061055', '061', 'Pastorano', 'G364', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061056', '061', 'Piana di Monte Verna', 'G541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061057', '061', 'Piedimonte Matese', 'G596', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061058', '061', 'Pietramelara', 'G620', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061059', '061', 'Pietravairano', 'G630', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061060', '061', 'Pignataro Maggiore', 'G661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061061', '061', 'Pontelatone', 'G849', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061062', '061', 'Portico di Caserta', 'G903', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061063', '061', 'Prata Sannita', 'G991', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061064', '061', 'Pratella', 'G995', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061065', '061', 'Presenzano', 'H045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061066', '061', 'Raviscanina', 'H202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061067', '061', 'Recale', 'H210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061068', '061', 'Riardo', 'H268', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061069', '061', 'Rocca d''Evandro', 'H398', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061070', '061', 'Roccamonfina', 'H423', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061071', '061', 'Roccaromana', 'H436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061072', '061', 'Rocchetta e Croce', 'H459', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061073', '061', 'Ruviano', 'H165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061074', '061', 'San Cipriano d''Aversa', 'H798', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061075', '061', 'San Felice a Cancello', 'H834', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061076', '061', 'San Gregorio Matese', 'H939', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061077', '061', 'San Marcellino', 'H978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061104', '061', 'San Marco Evangelista', 'F043', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061078', '061', 'San Nicola la Strada', 'I056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061079', '061', 'San Pietro Infine', 'I113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061080', '061', 'San Potito Sannitico', 'I130', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061081', '061', 'San Prisco', 'I131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061085', '061', 'San Tammaro', 'I261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061082', '061', 'Santa Maria a Vico', 'I233', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061083', '061', 'Santa Maria Capua Vetere', 'I234', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061084', '061', 'Santa Maria la Fossa', 'I247', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061086', '061', 'Sant''Angelo d''Alife', 'I273', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061087', '061', 'Sant''Arpino', 'I306', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061088', '061', 'Sessa Aurunca', 'I676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061089', '061', 'Sparanise', 'I885', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061090', '061', 'Succivo', 'I993', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061091', '061', 'Teano', 'L083', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061092', '061', 'Teverola', 'L155', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061093', '061', 'Tora e Piccilli', 'L205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061094', '061', 'Trentola Ducenta', 'L379', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061095', '061', 'Vairano Patenora', 'L540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061096', '061', 'Valle Agricola', 'L594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061097', '061', 'Valle di Maddaloni', 'L591', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061098', '061', 'Villa di Briano', 'D801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061099', '061', 'Villa Literno', 'L844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061100', '061', 'Vitulazio', 'M092', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061801', '061', 'Albanova', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061802', '061', 'Arienzo San Felice', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061803', '061', 'Atella di Napoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061804', '061', 'Casalba', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061805', '061', 'Fertilia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061806', '061', 'Frignano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061807', '061', 'Lusciano e Ducenta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061808', '061', 'San Leucio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('061809', '061', 'Villa Volturno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062001', '062', 'Airola', 'A110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062002', '062', 'Amorosi', 'A265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062003', '062', 'Apice', 'A328', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062004', '062', 'Apollosa', 'A330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062005', '062', 'Arpaia', 'A431', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062006', '062', 'Arpaise', 'A432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062007', '062', 'Baselice', 'A696', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062008', '062', 'Benevento', 'A783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062009', '062', 'Bonea', 'A970', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062010', '062', 'Bucciano', 'B239', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062011', '062', 'Buonalbergo', 'B267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062012', '062', 'Calvi', 'B444', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062013', '062', 'Campolattaro', 'B541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062014', '062', 'Campoli del Monte Taburno', 'B542', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062015', '062', 'Casalduni', 'B873', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062016', '062', 'Castelfranco in Miscano', 'C106', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062017', '062', 'Castelpagano', 'C245', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062018', '062', 'Castelpoto', 'C250', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062019', '062', 'Castelvenere', 'C280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062020', '062', 'Castelvetere in Val Fortore', 'C284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062021', '062', 'Cautano', 'C359', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062022', '062', 'Ceppaloni', 'C476', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062023', '062', 'Cerreto Sannita', 'C525', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062024', '062', 'Circello', 'C719', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062025', '062', 'Colle Sannita', 'C846', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062026', '062', 'Cusano Mutri', 'D230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062027', '062', 'Dugenta', 'D380', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062028', '062', 'Durazzano', 'D386', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062029', '062', 'Faicchio', 'D469', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062030', '062', 'Foglianise', 'D644', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062031', '062', 'Foiano di Val Fortore', 'D650', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062032', '062', 'Forchia', 'D693', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062033', '062', 'Fragneto l''Abate', 'D755', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062034', '062', 'Fragneto Monforte', 'D756', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062035', '062', 'Frasso Telesino', 'D784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062036', '062', 'Ginestra degli Schiavoni', 'E034', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062037', '062', 'Guardia Sanframondi', 'E249', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062038', '062', 'Limatola', 'E589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062039', '062', 'Melizzano', 'F113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062040', '062', 'Moiano', 'F274', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062041', '062', 'Molinara', 'F287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062042', '062', 'Montefalcone di Val Fortore', 'F494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062043', '062', 'Montesarchio', 'F636', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062044', '062', 'Morcone', 'F717', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062045', '062', 'Paduli', 'G227', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062046', '062', 'Pago Veiano', 'G243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062047', '062', 'Pannarano', 'G311', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062048', '062', 'Paolisi', 'G318', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062049', '062', 'Paupisi', 'G386', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062050', '062', 'Pesco Sannita', 'G494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062051', '062', 'Pietraroja', 'G626', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062052', '062', 'Pietrelcina', 'G631', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062053', '062', 'Ponte', 'G827', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062054', '062', 'Pontelandolfo', 'G848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062055', '062', 'Puglianello', 'H087', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062056', '062', 'Reino', 'H227', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062057', '062', 'San Bartolomeo in Galdo', 'H764', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062058', '062', 'San Giorgio del Sannio', 'H894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062059', '062', 'San Giorgio La Molara', 'H898', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062060', '062', 'San Leucio del Sannio', 'H953', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062061', '062', 'San Lorenzello', 'H955', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062062', '062', 'San Lorenzo Maggiore', 'H967', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062063', '062', 'San Lupo', 'H973', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062064', '062', 'San Marco dei Cavoti', 'H984', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062065', '062', 'San Martino Sannita', 'I002', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062066', '062', 'San Nazzaro', 'I049', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062067', '062', 'San Nicola Manfredi', 'I062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062068', '062', 'San Salvatore Telesino', 'I145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062069', '062', 'Santa Croce del Sannio', 'I179', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062070', '062', 'Sant''Agata de'' Goti', 'I197', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062071', '062', 'Sant''Angelo a Cupolo', 'I277', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062078', '062', 'Sant''Arcangelo Trimonte', 'F557', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062072', '062', 'Sassinoro', 'I455', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062073', '062', 'Solopaca', 'I809', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062074', '062', 'Telese Terme', 'L086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062075', '062', 'Tocco Caudio', 'L185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062076', '062', 'Torrecuso', 'L254', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062077', '062', 'Vitulano', 'M093', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062801', '062', 'Bagnara di Benevento', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062802', '062', 'Civitella Licinio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062803', '062', 'Luzzano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062804', '062', 'Montorso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062805', '062', 'Pastene', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062806', '062', 'Perrillo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062807', '062', 'San Marco a Monti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('062808', '062', 'Varoni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063001', '063', 'Acerra', 'A024', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063002', '063', 'Afragola', 'A064', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063003', '063', 'Agerola', 'A068', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063004', '063', 'Anacapri', 'A268', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063005', '063', 'Arzano', 'A455', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063006', '063', 'Bacoli', 'A535', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063007', '063', 'Barano d''Ischia', 'A617', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063008', '063', 'Boscoreale', 'B076', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063009', '063', 'Boscotrecase', 'B077', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063010', '063', 'Brusciano', 'B227', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063011', '063', 'Caivano', 'B371', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063012', '063', 'Calvizzano', 'B452', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063013', '063', 'Camposano', 'B565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063014', '063', 'Capri', 'B696', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063015', '063', 'Carbonara di Nola', 'B740', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063016', '063', 'Cardito', 'B759', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063017', '063', 'Casalnuovo di Napoli', 'B905', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063018', '063', 'Casamarciano', 'B922', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063019', '063', 'Casamicciola Terme', 'B924', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063020', '063', 'Casandrino', 'B925', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063021', '063', 'Casavatore', 'B946', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063022', '063', 'Casola di Napoli', 'B980', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063023', '063', 'Casoria', 'B990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063024', '063', 'Castellammare di Stabia', 'C129', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063025', '063', 'Castello di Cisterna', 'C188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063026', '063', 'Cercola', 'C495', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063027', '063', 'Cicciano', 'C675', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063028', '063', 'Cimitile', 'C697', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063029', '063', 'Comiziano', 'C929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063030', '063', 'Crispano', 'D170', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063064', '063', 'Ercolano', 'H243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063031', '063', 'Forio', 'D702', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063032', '063', 'Frattamaggiore', 'D789', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063033', '063', 'Frattaminore', 'D790', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063034', '063', 'Giugliano in Campania', 'E054', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063035', '063', 'Gragnano', 'E131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063036', '063', 'Grumo Nevano', 'E224', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063037', '063', 'Ischia', 'E329', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063038', '063', 'Lacco Ameno', 'E396', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063039', '063', 'Lettere', 'E557', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063040', '063', 'Liveri', 'E620', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063041', '063', 'Marano di Napoli', 'E906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063042', '063', 'Mariglianella', 'E954', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063043', '063', 'Marigliano', 'E955', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063092', '063', 'Massa di Somma', 'M289', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063044', '063', 'Massa Lubrense', 'F030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063045', '063', 'Melito di Napoli', 'F111', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063046', '063', 'Meta', 'F162', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063047', '063', 'Monte di Procida', 'F488', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063048', '063', 'Mugnano di Napoli', 'F799', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063049', '063', 'Napoli', 'F839', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063050', '063', 'Nola', 'F924', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063051', '063', 'Ottaviano', 'G190', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063052', '063', 'Palma Campania', 'G283', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063053', '063', 'Piano di Sorrento', 'G568', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063054', '063', 'Pimonte', 'G670', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063055', '063', 'Poggiomarino', 'G762', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063056', '063', 'Pollena Trocchia', 'G795', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063057', '063', 'Pomigliano d''Arco', 'G812', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063058', '063', 'Pompei', 'G813', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063059', '063', 'Portici', 'G902', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063060', '063', 'Pozzuoli', 'G964', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063061', '063', 'Procida', 'H072', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063062', '063', 'Qualiano', 'H101', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063063', '063', 'Quarto', 'H114', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063065', '063', 'Roccarainola', 'H433', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063066', '063', 'San Gennaro Vesuviano', 'H860', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063067', '063', 'San Giorgio a Cremano', 'H892', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063068', '063', 'San Giuseppe Vesuviano', 'H931', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063069', '063', 'San Paolo Bel Sito', 'I073', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063070', '063', 'San Sebastiano al Vesuvio', 'I151', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063075', '063', 'San Vitaliano', 'I391', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063090', '063', 'Santa Maria la Carità', 'M273', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063071', '063', 'Sant''Agnello', 'I208', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063072', '063', 'Sant''Anastasia', 'I262', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063073', '063', 'Sant''Antimo', 'I293', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063074', '063', 'Sant''Antonio Abate', 'I300', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063076', '063', 'Saviano', 'I469', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063077', '063', 'Scisciano', 'I540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063078', '063', 'Serrara Fontana', 'I652', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063079', '063', 'Somma Vesuviana', 'I820', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063080', '063', 'Sorrento', 'I862', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063081', '063', 'Striano', 'I978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063082', '063', 'Terzigno', 'L142', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063083', '063', 'Torre Annunziata', 'L245', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063084', '063', 'Torre del Greco', 'L259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063091', '063', 'Trecase', 'M280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063085', '063', 'Tufino', 'L460', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063086', '063', 'Vico Equense', 'L845', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063087', '063', 'Villaricca', 'G309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063088', '063', 'Visciano', 'M072', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063089', '063', 'Volla', 'M115', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063801', '063', 'Barra', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063802', '063', 'Chiaiano ed Uniti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063803', '063', 'Licignano di Napoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063804', '063', 'Pianura', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063805', '063', 'Piscinola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063806', '063', 'Ponticelli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063807', '063', 'San Giovanni a Teduccio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063808', '063', 'San Pietro a Patierno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063809', '063', 'Sant’Erasmo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063810', '063', 'Secondigliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063811', '063', 'Sirico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063812', '063', 'Soccavo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('063813', '063', 'Testaccio d''Ischia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064001', '064', 'Aiello del Sabato', 'A101', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064002', '064', 'Altavilla Irpina', 'A228', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064003', '064', 'Andretta', 'A284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064004', '064', 'Aquilonia', 'A347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064005', '064', 'Ariano Irpino', 'A399', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064006', '064', 'Atripalda', 'A489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064007', '064', 'Avella', 'A508', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064008', '064', 'Avellino', 'A509', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064009', '064', 'Bagnoli Irpino', 'A566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064010', '064', 'Baiano', 'A580', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064011', '064', 'Bisaccia', 'A881', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064012', '064', 'Bonito', 'A975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064013', '064', 'Cairano', 'B367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064014', '064', 'Calabritto', 'B374', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064015', '064', 'Calitri', 'B415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064016', '064', 'Candida', 'B590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064017', '064', 'Caposele', 'B674', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064018', '064', 'Capriglia Irpina', 'B706', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064019', '064', 'Carife', 'B776', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064020', '064', 'Casalbore', 'B866', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064021', '064', 'Cassano Irpino', 'B997', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064022', '064', 'Castel Baronia', 'C058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064023', '064', 'Castelfranci', 'C105', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064024', '064', 'Castelvetere sul Calore', 'C283', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064025', '064', 'Cervinara', 'C557', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064026', '064', 'Cesinali', 'C576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064027', '064', 'Chianche', 'C606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064028', '064', 'Chiusano di San Domenico', 'C659', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064029', '064', 'Contrada', 'C971', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064030', '064', 'Conza della Campania', 'C976', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064031', '064', 'Domicella', 'D331', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064032', '064', 'Flumeri', 'D638', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064033', '064', 'Fontanarosa', 'D671', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064034', '064', 'Forino', 'D701', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064035', '064', 'Frigento', 'D798', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064036', '064', 'Gesualdo', 'D998', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064037', '064', 'Greci', 'E161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064038', '064', 'Grottaminarda', 'E206', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064039', '064', 'Grottolella', 'E214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064040', '064', 'Guardia Lombardi', 'E245', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064041', '064', 'Lacedonia', 'E397', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064042', '064', 'Lapio', 'E448', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064043', '064', 'Lauro', 'E487', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064044', '064', 'Lioni', 'E605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064045', '064', 'Luogosano', 'E746', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064046', '064', 'Manocalzati', 'E891', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064047', '064', 'Marzano di Nola', 'E997', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064048', '064', 'Melito Irpino', 'F110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064049', '064', 'Mercogliano', 'F141', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064050', '064', 'Mirabella Eclano', 'F230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064051', '064', 'Montaguto', 'F397', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064052', '064', 'Montecalvo Irpino', 'F448', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064053', '064', 'Montefalcione', 'F491', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064054', '064', 'Monteforte Irpino', 'F506', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064055', '064', 'Montefredane', 'F511', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064056', '064', 'Montefusco', 'F512', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064057', '064', 'Montella', 'F546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064058', '064', 'Montemarano', 'F559', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064059', '064', 'Montemiletto', 'F566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064060', '064', 'Monteverde', 'F660', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064061', '064', 'Montoro Inferiore', 'F693', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064062', '064', 'Montoro Superiore', 'F694', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064063', '064', 'Morra De Sanctis', 'F744', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064064', '064', 'Moschiano', 'F762', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064065', '064', 'Mugnano del Cardinale', 'F798', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064066', '064', 'Nusco', 'F988', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064067', '064', 'Ospedaletto d''Alpinolo', 'G165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064068', '064', 'Pago del Vallo di Lauro', 'G242', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064069', '064', 'Parolise', 'G340', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064070', '064', 'Paternopoli', 'G370', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064071', '064', 'Petruro Irpino', 'G519', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064072', '064', 'Pietradefusi', 'G611', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064073', '064', 'Pietrastornina', 'G629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064074', '064', 'Prata di Principato Ultra', 'G990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064075', '064', 'Pratola Serra', 'H006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064076', '064', 'Quadrelle', 'H097', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064077', '064', 'Quindici', 'H128', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064079', '064', 'Rocca San Felice', 'H438', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064078', '064', 'Roccabascerana', 'H382', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064080', '064', 'Rotondi', 'H592', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064081', '064', 'Salza Irpina', 'H733', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064082', '064', 'San Mango sul Calore', 'H975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064083', '064', 'San Martino Valle Caudina', 'I016', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064084', '064', 'San Michele di Serino', 'I034', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064085', '064', 'San Nicola Baronia', 'I061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064086', '064', 'San Potito Ultra', 'I129', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064087', '064', 'San Sossio Baronia', 'I163', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064088', '064', 'Santa Lucia di Serino', 'I219', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064093', '064', 'Santa Paolina', 'I301', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064089', '064', 'Sant''Andrea di Conza', 'I264', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064091', '064', 'Sant''Angelo a Scala', 'I280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064090', '064', 'Sant''Angelo all''Esca', 'I279', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064092', '064', 'Sant''Angelo dei Lombardi', 'I281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064095', '064', 'Santo Stefano del Sole', 'I357', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064096', '064', 'Savignano Irpino', 'I471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064097', '064', 'Scampitella', 'I493', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064098', '064', 'Senerchia', 'I606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064099', '064', 'Serino', 'I630', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064100', '064', 'Sirignano', 'I756', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064101', '064', 'Solofra', 'I805', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064102', '064', 'Sorbo Serpico', 'I843', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064103', '064', 'Sperone', 'I893', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064104', '064', 'Sturno', 'I990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064105', '064', 'Summonte', 'L004', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064106', '064', 'Taurano', 'L061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064107', '064', 'Taurasi', 'L062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064108', '064', 'Teora', 'L102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064109', '064', 'Torella dei Lombardi', 'L214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064110', '064', 'Torre Le Nocelle', 'L272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064111', '064', 'Torrioni', 'L301', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064112', '064', 'Trevico', 'L399', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064113', '064', 'Tufo', 'L461', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064114', '064', 'Vallata', 'L589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064115', '064', 'Vallesaccarda', 'L616', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064116', '064', 'Venticano', 'L739', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064117', '064', 'Villamaina', 'L965', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064118', '064', 'Villanova del Battista', 'L973', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064119', '064', 'Volturara Irpina', 'M130', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064120', '064', 'Zungoli', 'M203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064121', '064', 'Montoro', 'M330', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064801', '064', 'Bellizzi Irpino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064802', '064', 'Chianchetelle', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064803', '064', 'Migliano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064804', '064', 'Quaglietta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064805', '064', 'San Barbato', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064806', '064', 'San Pietro Irpino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064807', '064', 'Sant''Agata Irpina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('064808', '064', 'Tavernola San Felice', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065001', '065', 'Acerno', 'A023', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065002', '065', 'Agropoli', 'A091', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065003', '065', 'Albanella', 'A128', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065004', '065', 'Alfano', 'A186', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065005', '065', 'Altavilla Silentina', 'A230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065006', '065', 'Amalfi', 'A251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065007', '065', 'Angri', 'A294', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065008', '065', 'Aquara', 'A343', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065009', '065', 'Ascea', 'A460', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065010', '065', 'Atena Lucana', 'A484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065011', '065', 'Atrani', 'A487', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065012', '065', 'Auletta', 'A495', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065013', '065', 'Baronissi', 'A674', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065014', '065', 'Battipaglia', 'A717', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065158', '065', 'Bellizzi', 'M294', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065015', '065', 'Bellosguardo', 'A756', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065016', '065', 'Bracigliano', 'B115', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065017', '065', 'Buccino', 'B242', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065018', '065', 'Buonabitacolo', 'B266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065019', '065', 'Caggiano', 'B351', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065020', '065', 'Calvanico', 'B437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065021', '065', 'Camerota', 'B476', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065022', '065', 'Campagna', 'B492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065023', '065', 'Campora', 'B555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065024', '065', 'Cannalonga', 'B608', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065025', '065', 'Capaccio Paestum', 'B644', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065028', '065', 'Casal Velino', 'B895', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065026', '065', 'Casalbuono', 'B868', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065027', '065', 'Casaletto Spartano', 'B888', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065029', '065', 'Caselle in Pittari', 'B959', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065034', '065', 'Castel San Giorgio', 'C259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065035', '065', 'Castel San Lorenzo', 'C262', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065030', '065', 'Castelcivita', 'C069', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065031', '065', 'Castellabate', 'C125', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065032', '065', 'Castelnuovo Cilento', 'C231', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065033', '065', 'Castelnuovo di Conza', 'C235', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065036', '065', 'Castiglione del Genovesi', 'C306', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065037', '065', 'Cava de'' Tirreni', 'C361', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065038', '065', 'Celle di Bulgheria', 'C444', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065039', '065', 'Centola', 'C470', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065040', '065', 'Ceraso', 'C485', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065041', '065', 'Cetara', 'C584', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065042', '065', 'Cicerale', 'C676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065043', '065', 'Colliano', 'C879', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065044', '065', 'Conca dei Marini', 'C940', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065045', '065', 'Controne', 'C973', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065046', '065', 'Contursi Terme', 'C974', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065047', '065', 'Corbara', 'C984', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065048', '065', 'Corleto Monforte', 'D011', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065049', '065', 'Cuccaro Vetere', 'D195', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065050', '065', 'Eboli', 'D390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065051', '065', 'Felitto', 'D527', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065052', '065', 'Fisciano', 'D615', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065053', '065', 'Furore', 'D826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065054', '065', 'Futani', 'D832', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065055', '065', 'Giffoni Sei Casali', 'E026', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065056', '065', 'Giffoni Valle Piana', 'E027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065057', '065', 'Gioi', 'E037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065058', '065', 'Giungano', 'E060', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065059', '065', 'Ispani', 'E365', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065060', '065', 'Laureana Cilento', 'E480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065061', '065', 'Laurino', 'E485', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065062', '065', 'Laurito', 'E486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065063', '065', 'Laviano', 'E498', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065064', '065', 'Lustra', 'E767', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065065', '065', 'Magliano Vetere', 'E814', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065066', '065', 'Maiori', 'E839', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065067', '065', 'Mercato San Severino', 'F138', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065068', '065', 'Minori', 'F223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065069', '065', 'Moio della Civitella', 'F278', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065070', '065', 'Montano Antilia', 'F426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065075', '065', 'Monte San Giacomo', 'F618', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065071', '065', 'Montecorice', 'F479', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065072', '065', 'Montecorvino Pugliano', 'F480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065073', '065', 'Montecorvino Rovella', 'F481', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065074', '065', 'Monteforte Cilento', 'F507', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065076', '065', 'Montesano sulla Marcellana', 'F625', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065077', '065', 'Morigerati', 'F731', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065078', '065', 'Nocera Inferiore', 'F912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065079', '065', 'Nocera Superiore', 'F913', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065080', '065', 'Novi Velia', 'F967', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065081', '065', 'Ogliastro Cilento', 'G011', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065082', '065', 'Olevano sul Tusciano', 'G023', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065083', '065', 'Oliveto Citra', 'G039', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065084', '065', 'Omignano', 'G063', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065085', '065', 'Orria', 'G121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065086', '065', 'Ottati', 'G192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065087', '065', 'Padula', 'G226', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065088', '065', 'Pagani', 'G230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065089', '065', 'Palomonte', 'G292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065090', '065', 'Pellezzano', 'G426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065091', '065', 'Perdifumo', 'G447', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065092', '065', 'Perito', 'G455', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065093', '065', 'Pertosa', 'G476', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065094', '065', 'Petina', 'G509', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065095', '065', 'Piaggine', 'G538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065096', '065', 'Pisciotta', 'G707', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065097', '065', 'Polla', 'G793', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065098', '065', 'Pollica', 'G796', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065099', '065', 'Pontecagnano Faiano', 'G834', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065100', '065', 'Positano', 'G932', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065101', '065', 'Postiglione', 'G939', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065102', '065', 'Praiano', 'G976', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065103', '065', 'Prignano Cilento', 'H062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065104', '065', 'Ravello', 'H198', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065105', '065', 'Ricigliano', 'H277', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065106', '065', 'Roccadaspide', 'H394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065107', '065', 'Roccagloriosa', 'H412', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065108', '065', 'Roccapiemonte', 'H431', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065109', '065', 'Rofrano', 'H485', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065110', '065', 'Romagnano al Monte', 'H503', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065111', '065', 'Roscigno', 'H564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065112', '065', 'Rutino', 'H644', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065113', '065', 'Sacco', 'H654', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065114', '065', 'Sala Consilina', 'H683', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065115', '065', 'Salento', 'H686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065116', '065', 'Salerno', 'H703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065117', '065', 'Salvitelle', 'H732', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065118', '065', 'San Cipriano Picentino', 'H800', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065119', '065', 'San Giovanni a Piro', 'H907', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065120', '065', 'San Gregorio Magno', 'H943', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065121', '065', 'San Mango Piemonte', 'H977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065122', '065', 'San Marzano sul Sarno', 'I019', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065123', '065', 'San Mauro Cilento', 'I031', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065124', '065', 'San Mauro la Bruca', 'I032', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065125', '065', 'San Pietro al Tanagro', 'I089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065126', '065', 'San Rufo', 'I143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065132', '065', 'San Valentino Torio', 'I377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065127', '065', 'Santa Marina', 'I253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065128', '065', 'Sant''Angelo a Fasanella', 'I278', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065129', '065', 'Sant''Arsenio', 'I307', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065130', '065', 'Sant''Egidio del Monte Albino', 'I317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065131', '065', 'Santomenna', 'I260', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065133', '065', 'Sanza', 'I410', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065134', '065', 'Sapri', 'I422', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065135', '065', 'Sarno', 'I438', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065136', '065', 'Sassano', 'I451', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065137', '065', 'Scafati', 'I483', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065138', '065', 'Scala', 'I486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065139', '065', 'Serramezzana', 'I648', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065140', '065', 'Serre', 'I666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065141', '065', 'Sessa Cilento', 'I677', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065142', '065', 'Siano', 'I720', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065143', '065', 'Sicignano degli Alburni', 'M253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065144', '065', 'Stella Cilento', 'G887', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065145', '065', 'Stio', 'I960', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065146', '065', 'Teggiano', 'D292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065147', '065', 'Torchiara', 'L212', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065148', '065', 'Torraca', 'L233', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065149', '065', 'Torre Orsaia', 'L274', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065150', '065', 'Tortorella', 'L306', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065151', '065', 'Tramonti', 'L323', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065152', '065', 'Trentinara', 'L377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065153', '065', 'Valle dell''Angelo', 'G540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065154', '065', 'Vallo della Lucania', 'L628', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065155', '065', 'Valva', 'L656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065156', '065', 'Vibonati', 'L835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065157', '065', 'Vietri sul Mare', 'L860', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065801', '065', 'Capitello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065802', '065', 'Castelruggiero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065803', '065', 'Fogna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065804', '065', 'Galdo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065805', '065', 'Licusati', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('065806', '065', 'Piaggine Soprane', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066001', '066', 'Acciano', 'A018', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066002', '066', 'Aielli', 'A100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066003', '066', 'Alfedena', 'A187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066004', '066', 'Anversa degli Abruzzi', 'A318', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066005', '066', 'Ateleta', 'A481', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066006', '066', 'Avezzano', 'A515', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066007', '066', 'Balsorano', 'A603', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066008', '066', 'Barete', 'A656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066009', '066', 'Barisciano', 'A667', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066010', '066', 'Barrea', 'A678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066011', '066', 'Bisegna', 'A884', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066012', '066', 'Bugnara', 'B256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066013', '066', 'Cagnano Amiterno', 'B358', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066014', '066', 'Calascio', 'B382', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066015', '066', 'Campo di Giove', 'B526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066016', '066', 'Campotosto', 'B569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066017', '066', 'Canistro', 'B606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066018', '066', 'Cansano', 'B624', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066019', '066', 'Capestrano', 'B651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066020', '066', 'Capistrello', 'B656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066021', '066', 'Capitignano', 'B658', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066022', '066', 'Caporciano', 'B672', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066023', '066', 'Cappadocia', 'B677', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066024', '066', 'Carapelle Calvisio', 'B725', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066025', '066', 'Carsoli', 'B842', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066026', '066', 'Castel del Monte', 'C083', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066027', '066', 'Castel di Ieri', 'C090', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066028', '066', 'Castel di Sangro', 'C096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066029', '066', 'Castellafiume', 'C126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066030', '066', 'Castelvecchio Calvisio', 'C278', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066031', '066', 'Castelvecchio Subequo', 'C279', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066032', '066', 'Celano', 'C426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066033', '066', 'Cerchio', 'C492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066034', '066', 'Civita d''Antino', 'C766', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066035', '066', 'Civitella Alfedena', 'C778', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066036', '066', 'Civitella Roveto', 'C783', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066037', '066', 'Cocullo', 'C811', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066038', '066', 'Collarmele', 'C844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066039', '066', 'Collelongo', 'C862', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066040', '066', 'Collepietro', 'C866', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066041', '066', 'Corfinio', 'C999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066042', '066', 'Fagnano Alto', 'D465', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066043', '066', 'Fontecchio', 'D681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066044', '066', 'Fossa', 'D736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066045', '066', 'Gagliano Aterno', 'D850', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066046', '066', 'Gioia dei Marsi', 'E040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066047', '066', 'Goriano Sicoli', 'E096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066048', '066', 'Introdacqua', 'E307', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066049', '066', 'L''Aquila', 'A345', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066050', '066', 'Lecce nei Marsi', 'E505', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066051', '066', 'Luco dei Marsi', 'E723', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066052', '066', 'Lucoli', 'E724', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066053', '066', 'Magliano de'' Marsi', 'E811', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066054', '066', 'Massa d''Albe', 'F022', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066055', '066', 'Molina Aterno', 'M255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066056', '066', 'Montereale', 'F595', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066057', '066', 'Morino', 'F732', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066058', '066', 'Navelli', 'F852', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066059', '066', 'Ocre', 'F996', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066060', '066', 'Ofena', 'G002', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066061', '066', 'Opi', 'G079', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066062', '066', 'Oricola', 'G102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066063', '066', 'Ortona dei Marsi', 'G142', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066064', '066', 'Ortucchio', 'G145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066065', '066', 'Ovindoli', 'G200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066066', '066', 'Pacentro', 'G210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066067', '066', 'Pereto', 'G449', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066068', '066', 'Pescasseroli', 'G484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066069', '066', 'Pescina', 'G492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066070', '066', 'Pescocostanzo', 'G493', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066071', '066', 'Pettorano sul Gizio', 'G524', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066072', '066', 'Pizzoli', 'G726', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066073', '066', 'Poggio Picenze', 'G766', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066074', '066', 'Prata d''Ansidonia', 'G992', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066075', '066', 'Pratola Peligna', 'H007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066076', '066', 'Prezza', 'H056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066077', '066', 'Raiano', 'H166', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066078', '066', 'Rivisondoli', 'H353', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066080', '066', 'Rocca di Botte', 'H399', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066081', '066', 'Rocca di Cambio', 'H400', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066082', '066', 'Rocca di Mezzo', 'H402', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066083', '066', 'Rocca Pia', 'H429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066079', '066', 'Roccacasale', 'H389', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066084', '066', 'Roccaraso', 'H434', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066085', '066', 'San Benedetto dei Marsi', 'H772', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066086', '066', 'San Benedetto in Perillis', 'H773', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066087', '066', 'San Demetrio ne'' Vestini', 'H819', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066088', '066', 'San Pio delle Camere', 'I121', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066092', '066', 'San Vincenzo Valle Roveto', 'I389', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066089', '066', 'Sante Marie', 'I326', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066090', '066', 'Sant''Eusanio Forconese', 'I336', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066091', '066', 'Santo Stefano di Sessanio', 'I360', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066093', '066', 'Scanno', 'I501', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066094', '066', 'Scontrone', 'I543', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066095', '066', 'Scoppito', 'I546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066096', '066', 'Scurcola Marsicana', 'I553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066097', '066', 'Secinaro', 'I558', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066098', '066', 'Sulmona', 'I804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066099', '066', 'Tagliacozzo', 'L025', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066100', '066', 'Tione degli Abruzzi', 'L173', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066101', '066', 'Tornimparte', 'L227', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066102', '066', 'Trasacco', 'L334', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066104', '066', 'Villa Santa Lucia degli Abruzzi', 'M021', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066105', '066', 'Villa Sant''Angelo', 'M023', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066103', '066', 'Villalago', 'L958', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066106', '066', 'Villavallelonga', 'M031', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066107', '066', 'Villetta Barrea', 'M041', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066108', '066', 'Vittorito', 'M090', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066801', '066', 'Arischia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066802', '066', 'Bagno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066803', '066', 'Camarda', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066804', '066', 'Paganica', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066805', '066', 'Preturo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066806', '066', 'Roio Piano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('066807', '066', 'Sassa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067001', '067', 'Alba Adriatica', 'A125', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067002', '067', 'Ancarano', 'A270', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067003', '067', 'Arsita', 'A445', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067004', '067', 'Atri', 'A488', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067005', '067', 'Basciano', 'A692', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067006', '067', 'Bellante', 'A746', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067007', '067', 'Bisenti', 'A885', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067008', '067', 'Campli', 'B515', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067009', '067', 'Canzano', 'B640', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067010', '067', 'Castel Castagna', 'C040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067011', '067', 'Castellalto', 'C128', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067012', '067', 'Castelli', 'C169', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067013', '067', 'Castiglione Messer Raimondo', 'C316', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067014', '067', 'Castilenti', 'C322', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067015', '067', 'Cellino Attanasio', 'C449', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067016', '067', 'Cermignano', 'C517', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067017', '067', 'Civitella del Tronto', 'C781', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067018', '067', 'Colledara', 'C311', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067019', '067', 'Colonnella', 'C901', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067020', '067', 'Controguerra', 'C972', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067021', '067', 'Corropoli', 'D043', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067022', '067', 'Cortino', 'D076', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067023', '067', 'Crognaleto', 'D179', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067024', '067', 'Fano Adriano', 'D489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067025', '067', 'Giulianova', 'E058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067026', '067', 'Isola del Gran Sasso d''Italia', 'E343', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067047', '067', 'Martinsicuro', 'E989', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067027', '067', 'Montefino', 'F500', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067028', '067', 'Montorio al Vomano', 'F690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067029', '067', 'Morro d''Oro', 'F747', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067030', '067', 'Mosciano Sant''Angelo', 'F764', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067031', '067', 'Nereto', 'F870', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067032', '067', 'Notaresco', 'F942', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067033', '067', 'Penna Sant''Andrea', 'G437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067034', '067', 'Pietracamela', 'G608', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067035', '067', 'Pineto', 'F831', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067036', '067', 'Rocca Santa Maria', 'H440', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067037', '067', 'Roseto degli Abruzzi', 'F585', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067038', '067', 'Sant''Egidio alla Vibrata', 'I318', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067039', '067', 'Sant''Omero', 'I348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067040', '067', 'Silvi', 'I741', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067041', '067', 'Teramo', 'L103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067042', '067', 'Torano Nuovo', 'L207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067043', '067', 'Torricella Sicura', 'L295', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067044', '067', 'Tortoreto', 'L307', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067045', '067', 'Tossicia', 'L314', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067046', '067', 'Valle Castellana', 'L597', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('067801', '067', 'Valle San Giovanni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068001', '068', 'Abbateggio', 'A008', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068002', '068', 'Alanno', 'A120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068003', '068', 'Bolognano', 'A945', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068004', '068', 'Brittoli', 'B193', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068005', '068', 'Bussi sul Tirino', 'B294', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068006', '068', 'Cappelle sul Tavo', 'B681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068007', '068', 'Caramanico Terme', 'B722', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068008', '068', 'Carpineto della Nora', 'B827', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068009', '068', 'Castiglione a Casauria', 'C308', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068010', '068', 'Catignano', 'C354', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068011', '068', 'Cepagatti', 'C474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068012', '068', 'Città Sant''Angelo', 'C750', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068013', '068', 'Civitaquana', 'C771', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068014', '068', 'Civitella Casanova', 'C779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068015', '068', 'Collecorvino', 'C853', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068016', '068', 'Corvara', 'D078', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068017', '068', 'Cugnoli', 'D201', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068018', '068', 'Elice', 'D394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068019', '068', 'Farindola', 'D501', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068020', '068', 'Lettomanoppello', 'E558', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068021', '068', 'Loreto Aprutino', 'E691', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068022', '068', 'Manoppello', 'E892', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068023', '068', 'Montebello di Bertona', 'F441', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068024', '068', 'Montesilvano', 'F646', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068025', '068', 'Moscufo', 'F765', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068026', '068', 'Nocciano', 'F908', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068027', '068', 'Penne', 'G438', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068028', '068', 'Pescara', 'G482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068029', '068', 'Pescosansonesco', 'G499', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068030', '068', 'Pianella', 'G555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068031', '068', 'Picciano', 'G589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068032', '068', 'Pietranico', 'G621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068033', '068', 'Popoli', 'G878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068034', '068', 'Roccamorice', 'H425', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068035', '068', 'Rosciano', 'H562', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068036', '068', 'Salle', 'H715', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068038', '068', 'San Valentino in Abruzzo Citeriore', 'I376', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068037', '068', 'Sant''Eufemia a Maiella', 'I332', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068039', '068', 'Scafa', 'I482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068040', '068', 'Serramonacesca', 'I649', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068041', '068', 'Spoltore', 'I922', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068042', '068', 'Tocco da Casauria', 'L186', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068043', '068', 'Torre de'' Passeri', 'L263', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068044', '068', 'Turrivalignani', 'L475', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068045', '068', 'Vicoli', 'L846', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068046', '068', 'Villa Celiera', 'L922', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068801', '068', 'Castellammare Adriatico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068802', '068', 'Montesilvano Marina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068803', '068', 'Musellaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('068804', '068', 'Roccacaramanico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069001', '069', 'Altino', 'A235', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069002', '069', 'Archi', 'A367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069003', '069', 'Ari', 'A398', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069004', '069', 'Arielli', 'A402', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069005', '069', 'Atessa', 'A485', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069006', '069', 'Bomba', 'A956', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069007', '069', 'Borrello', 'B057', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069008', '069', 'Bucchianico', 'B238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069010', '069', 'Canosa Sannita', 'B620', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069011', '069', 'Carpineto Sinello', 'B826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069012', '069', 'Carunchio', 'B853', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069013', '069', 'Casacanditella', 'B859', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069014', '069', 'Casalanguida', 'B861', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069015', '069', 'Casalbordino', 'B865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069016', '069', 'Casalincontrada', 'B896', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069017', '069', 'Casoli', 'B985', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069018', '069', 'Castel Frentano', 'C114', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069019', '069', 'Castelguidone', 'C123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069020', '069', 'Castiglione Messer Marino', 'C298', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069021', '069', 'Celenza sul Trigno', 'C428', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069022', '069', 'Chieti', 'C632', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069023', '069', 'Civitaluparella', 'C768', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069024', '069', 'Civitella Messer Raimondo', 'C776', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069025', '069', 'Colledimacine', 'C855', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069026', '069', 'Colledimezzo', 'C856', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069027', '069', 'Crecchio', 'D137', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069028', '069', 'Cupello', 'D209', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069029', '069', 'Dogliola', 'D315', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069104', '069', 'Fallo', 'D480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069030', '069', 'Fara Filiorum Petri', 'D494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069031', '069', 'Fara San Martino', 'D495', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069032', '069', 'Filetto', 'D592', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069033', '069', 'Fossacesia', 'D738', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069034', '069', 'Fraine', 'D757', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069035', '069', 'Francavilla al Mare', 'D763', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069036', '069', 'Fresagrandinaria', 'D796', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069037', '069', 'Frisa', 'D803', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069038', '069', 'Furci', 'D823', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069039', '069', 'Gamberale', 'D898', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069040', '069', 'Gessopalena', 'D996', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069041', '069', 'Gissi', 'E052', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069042', '069', 'Giuliano Teatino', 'E056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069043', '069', 'Guardiagrele', 'E243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069044', '069', 'Guilmi', 'E266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069045', '069', 'Lama dei Peligni', 'E424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069046', '069', 'Lanciano', 'E435', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069047', '069', 'Lentella', 'E531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069048', '069', 'Lettopalena', 'E559', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069049', '069', 'Liscia', 'E611', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069050', '069', 'Miglianico', 'F196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069051', '069', 'Montazzoli', 'F433', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069009', '069', 'Montebello sul Sangro', 'B268', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069052', '069', 'Monteferrante', 'F498', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069053', '069', 'Montelapiano', 'F535', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069054', '069', 'Montenerodomo', 'F578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069055', '069', 'Monteodorisio', 'F582', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069056', '069', 'Mozzagrogna', 'F785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069057', '069', 'Orsogna', 'G128', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069058', '069', 'Ortona', 'G141', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069059', '069', 'Paglieta', 'G237', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069060', '069', 'Palena', 'G271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069061', '069', 'Palmoli', 'G290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069062', '069', 'Palombaro', 'G294', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069063', '069', 'Pennadomo', 'G434', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069064', '069', 'Pennapiedimonte', 'G435', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069065', '069', 'Perano', 'G441', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069103', '069', 'Pietraferrazzana', 'G613', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069066', '069', 'Pizzoferrato', 'G724', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069067', '069', 'Poggiofiorito', 'G760', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069068', '069', 'Pollutri', 'G799', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069069', '069', 'Pretoro', 'H052', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069070', '069', 'Quadri', 'H098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069071', '069', 'Rapino', 'H184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069072', '069', 'Ripa Teatina', 'H320', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069074', '069', 'Rocca San Giovanni', 'H439', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069073', '069', 'Roccamontepiano', 'H424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069075', '069', 'Roccascalegna', 'H442', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069076', '069', 'Roccaspinalveti', 'H448', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069077', '069', 'Roio del Sangro', 'H495', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069078', '069', 'Rosello', 'H566', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069079', '069', 'San Buono', 'H784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069080', '069', 'San Giovanni Lipioni', 'H923', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069081', '069', 'San Giovanni Teatino', 'D690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069082', '069', 'San Martino sulla Marrucina', 'H991', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069083', '069', 'San Salvo', 'I148', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069086', '069', 'San Vito Chietino', 'I394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069084', '069', 'Santa Maria Imbaro', 'I244', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069085', '069', 'Sant''Eusanio del Sangro', 'I335', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069087', '069', 'Scerni', 'I520', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069088', '069', 'Schiavi di Abruzzo', 'I526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069089', '069', 'Taranta Peligna', 'L047', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069090', '069', 'Tollo', 'L194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069091', '069', 'Torino di Sangro', 'L218', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069092', '069', 'Tornareccio', 'L224', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069093', '069', 'Torrebruna', 'L253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069094', '069', 'Torrevecchia Teatina', 'L284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069095', '069', 'Torricella Peligna', 'L291', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069096', '069', 'Treglio', 'L363', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069097', '069', 'Tufillo', 'L459', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069098', '069', 'Vacri', 'L526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069099', '069', 'Vasto', 'E372', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069102', '069', 'Villa Santa Maria', 'M022', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069100', '069', 'Villalfonsina', 'L961', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069101', '069', 'Villamagna', 'L964', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069801', '069', 'Fallascoso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('069802', '069', 'San Silvestro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070001', '070', 'Acquaviva Collecroce', 'A050', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070002', '070', 'Baranello', 'A616', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070003', '070', 'Bojano', 'A930', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070004', '070', 'Bonefro', 'A971', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070005', '070', 'Busso', 'B295', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070006', '070', 'Campobasso', 'B519', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070007', '070', 'Campochiaro', 'B522', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070008', '070', 'Campodipietra', 'B528', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070009', '070', 'Campolieto', 'B544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070010', '070', 'Campomarino', 'B550', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070011', '070', 'Casacalenda', 'B858', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070012', '070', 'Casalciprano', 'B871', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070013', '070', 'Castelbottaccio', 'C066', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070014', '070', 'Castellino del Biferno', 'C175', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070015', '070', 'Castelmauro', 'C197', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070016', '070', 'Castropignano', 'C346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070017', '070', 'Cercemaggiore', 'C486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070018', '070', 'Cercepiccola', 'C488', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070019', '070', 'Civitacampomarano', 'C764', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070020', '070', 'Colle d''Anchise', 'C854', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070021', '070', 'Colletorto', 'C875', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070022', '070', 'Duronia', 'C772', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070023', '070', 'Ferrazzano', 'D550', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070024', '070', 'Fossalto', 'D737', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070025', '070', 'Gambatesa', 'D896', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070026', '070', 'Gildone', 'E030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070027', '070', 'Guardialfiera', 'E244', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070028', '070', 'Guardiaregia', 'E248', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070029', '070', 'Guglionesi', 'E259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070030', '070', 'Jelsi', 'E381', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070031', '070', 'Larino', 'E456', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070032', '070', 'Limosano', 'E599', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070033', '070', 'Lucito', 'E722', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070034', '070', 'Lupara', 'E748', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070035', '070', 'Macchia Valfortore', 'E780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070036', '070', 'Mafalda', 'E799', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070037', '070', 'Matrice', 'F055', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070038', '070', 'Mirabello Sannitico', 'F233', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070039', '070', 'Molise', 'F294', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070040', '070', 'Monacilioni', 'F322', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070041', '070', 'Montagano', 'F391', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070042', '070', 'Montecilfone', 'F475', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070043', '070', 'Montefalcone nel Sannio', 'F495', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070044', '070', 'Montelongo', 'F548', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070045', '070', 'Montemitro', 'F569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070046', '070', 'Montenero di Bisaccia', 'F576', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070047', '070', 'Montorio nei Frentani', 'F689', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070048', '070', 'Morrone del Sannio', 'F748', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070049', '070', 'Oratino', 'G086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070050', '070', 'Palata', 'G257', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070051', '070', 'Petacciato', 'G506', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070052', '070', 'Petrella Tifernina', 'G512', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070053', '070', 'Pietracatella', 'G609', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070054', '070', 'Pietracupa', 'G610', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070055', '070', 'Portocannone', 'G910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070056', '070', 'Provvidenti', 'H083', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070057', '070', 'Riccia', 'H273', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070058', '070', 'Ripabottoni', 'H311', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070059', '070', 'Ripalimosani', 'H313', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070060', '070', 'Roccavivara', 'H454', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070061', '070', 'Rotello', 'H589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070062', '070', 'Salcito', 'H693', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070063', '070', 'San Biase', 'H782', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070064', '070', 'San Felice del Molise', 'H833', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070065', '070', 'San Giacomo degli Schiavoni', 'H867', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070066', '070', 'San Giovanni in Galdo', 'H920', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070067', '070', 'San Giuliano del Sannio', 'H928', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070068', '070', 'San Giuliano di Puglia', 'H929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070069', '070', 'San Martino in Pensilis', 'H990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070070', '070', 'San Massimo', 'I023', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070071', '070', 'San Polo Matese', 'I122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070072', '070', 'Santa Croce di Magliano', 'I181', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070073', '070', 'Sant''Angelo Limosano', 'I289', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070074', '070', 'Sant''Elia a Pianisi', 'I320', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070075', '070', 'Sepino', 'I618', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070076', '070', 'Spinete', 'I910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070077', '070', 'Tavenna', 'L069', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070078', '070', 'Termoli', 'L113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070079', '070', 'Torella del Sannio', 'L215', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070080', '070', 'Toro', 'L230', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070081', '070', 'Trivento', 'L435', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070082', '070', 'Tufara', 'L458', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070083', '070', 'Ururi', 'L505', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('070084', '070', 'Vinchiaturo', 'M057', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071001', '071', 'Accadia', 'A015', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071002', '071', 'Alberona', 'A150', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071003', '071', 'Anzano di Puglia', 'A320', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071004', '071', 'Apricena', 'A339', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071005', '071', 'Ascoli Satriano', 'A463', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071006', '071', 'Biccari', 'A854', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071007', '071', 'Bovino', 'B104', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071008', '071', 'Cagnano Varano', 'B357', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071009', '071', 'Candela', 'B584', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071010', '071', 'Carapelle', 'B724', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071011', '071', 'Carlantino', 'B784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071012', '071', 'Carpino', 'B829', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071013', '071', 'Casalnuovo Monterotaro', 'B904', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071014', '071', 'Casalvecchio di Puglia', 'B917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071015', '071', 'Castelluccio dei Sauri', 'C198', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071016', '071', 'Castelluccio Valmaggiore', 'C202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071017', '071', 'Castelnuovo della Daunia', 'C222', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071018', '071', 'Celenza Valfortore', 'C429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071019', '071', 'Celle di San Vito', 'C442', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071020', '071', 'Cerignola', 'C514', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071021', '071', 'Chieuti', 'C633', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071022', '071', 'Deliceto', 'D269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071023', '071', 'Faeto', 'D459', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071024', '071', 'Foggia', 'D643', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071025', '071', 'Ischitella', 'E332', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071026', '071', 'Isole Tremiti', 'E363', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071027', '071', 'Lesina', 'E549', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071028', '071', 'Lucera', 'E716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071029', '071', 'Manfredonia', 'E885', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071031', '071', 'Mattinata', 'F059', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071033', '071', 'Monte Sant''Angelo', 'F631', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071032', '071', 'Monteleone di Puglia', 'F538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071034', '071', 'Motta Montecorvino', 'F777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071063', '071', 'Ordona', 'M266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071035', '071', 'Orsara di Puglia', 'G125', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071036', '071', 'Orta Nova', 'G131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071037', '071', 'Panni', 'G312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071038', '071', 'Peschici', 'G487', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071039', '071', 'Pietramontecorvino', 'G604', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071040', '071', 'Poggio Imperiale', 'G761', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071041', '071', 'Rignano Garganico', 'H287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071042', '071', 'Rocchetta Sant''Antonio', 'H467', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071043', '071', 'Rodi Garganico', 'H480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071044', '071', 'Roseto Valfortore', 'H568', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071046', '071', 'San Giovanni Rotondo', 'H926', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071047', '071', 'San Marco in Lamis', 'H985', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071048', '071', 'San Marco la Catola', 'H986', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071049', '071', 'San Nicandro Garganico', 'I054', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071050', '071', 'San Paolo di Civitate', 'I072', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071051', '071', 'San Severo', 'I158', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071052', '071', 'Sant''Agata di Puglia', 'I193', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071053', '071', 'Serracapriola', 'I641', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071054', '071', 'Stornara', 'I962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071055', '071', 'Stornarella', 'I963', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071056', '071', 'Torremaggiore', 'L273', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071058', '071', 'Troia', 'L447', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071059', '071', 'Vico del Gargano', 'L842', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071060', '071', 'Vieste', 'L858', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071061', '071', 'Volturara Appula', 'M131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071062', '071', 'Volturino', 'M132', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('071064', '071', 'Zapponeta', 'M267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072001', '072', 'Acquaviva delle Fonti', 'A048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072002', '072', 'Adelfia', 'A055', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072003', '072', 'Alberobello', 'A149', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072004', '072', 'Altamura', 'A225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072006', '072', 'Bari', 'A662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072008', '072', 'Binetto', 'A874', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072010', '072', 'Bitetto', 'A892', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072011', '072', 'Bitonto', 'A893', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072012', '072', 'Bitritto', 'A894', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072014', '072', 'Capurso', 'B716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072015', '072', 'Casamassima', 'B923', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072016', '072', 'Cassano delle Murge', 'B998', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072017', '072', 'Castellana Grotte', 'C134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072018', '072', 'Cellamare', 'C436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072019', '072', 'Conversano', 'C975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072020', '072', 'Corato', 'C983', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072021', '072', 'Gioia del Colle', 'E038', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072022', '072', 'Giovinazzo', 'E047', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072023', '072', 'Gravina in Puglia', 'E155', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072024', '072', 'Grumo Appula', 'E223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072025', '072', 'Locorotondo', 'E645', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072027', '072', 'Modugno', 'F262', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072028', '072', 'Mola di Bari', 'F280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072029', '072', 'Molfetta', 'F284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072030', '072', 'Monopoli', 'F376', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072031', '072', 'Noci', 'F915', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072032', '072', 'Noicattaro', 'F923', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072033', '072', 'Palo del Colle', 'G291', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072034', '072', 'Poggiorsini', 'G769', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072035', '072', 'Polignano a Mare', 'G787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072036', '072', 'Putignano', 'H096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072037', '072', 'Rutigliano', 'H643', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072038', '072', 'Ruvo di Puglia', 'H645', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072039', '072', 'Sammichele di Bari', 'H749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072040', '072', 'Sannicandro di Bari', 'I053', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072041', '072', 'Santeramo in Colle', 'I330', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072043', '072', 'Terlizzi', 'L109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072044', '072', 'Toritto', 'L220', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072046', '072', 'Triggiano', 'L425', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072047', '072', 'Turi', 'L472', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072048', '072', 'Valenzano', 'L571', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072801', '072', 'Canneto di Bari', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072802', '072', 'Carbonara di Bari', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072803', '072', 'Ceglie del Campo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072804', '072', 'Loseto', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('072805', '072', 'Montrone', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073001', '073', 'Avetrana', 'A514', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073002', '073', 'Carosino', 'B808', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073003', '073', 'Castellaneta', 'C136', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073004', '073', 'Crispiano', 'D171', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073005', '073', 'Faggiano', 'D463', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073006', '073', 'Fragagnano', 'D754', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073007', '073', 'Ginosa', 'E036', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073008', '073', 'Grottaglie', 'E205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073009', '073', 'Laterza', 'E469', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073010', '073', 'Leporano', 'E537', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073011', '073', 'Lizzano', 'E630', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073012', '073', 'Manduria', 'E882', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073013', '073', 'Martina Franca', 'E986', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073014', '073', 'Maruggio', 'E995', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073015', '073', 'Massafra', 'F027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073016', '073', 'Monteiasi', 'F531', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073017', '073', 'Montemesola', 'F563', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073018', '073', 'Monteparano', 'F587', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073019', '073', 'Mottola', 'F784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073020', '073', 'Palagianello', 'G251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073021', '073', 'Palagiano', 'G252', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073022', '073', 'Pulsano', 'H090', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073023', '073', 'Roccaforzata', 'H409', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073024', '073', 'San Giorgio Ionico', 'H882', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073025', '073', 'San Marzano di San Giuseppe', 'I018', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073026', '073', 'Sava', 'I467', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073029', '073', 'Statte', 'M298', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073027', '073', 'Taranto', 'L049', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('073028', '073', 'Torricella', 'L294', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074001', '074', 'Brindisi', 'B180', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074002', '074', 'Carovigno', 'B809', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074003', '074', 'Ceglie Messapica', 'C424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074004', '074', 'Cellino San Marco', 'C448', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074005', '074', 'Cisternino', 'C741', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074006', '074', 'Erchie', 'D422', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074007', '074', 'Fasano', 'D508', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074008', '074', 'Francavilla Fontana', 'D761', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074009', '074', 'Latiano', 'E471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074010', '074', 'Mesagne', 'F152', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074011', '074', 'Oria', 'G098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074012', '074', 'Ostuni', 'G187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074013', '074', 'San Donaci', 'H822', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074014', '074', 'San Michele Salentino', 'I045', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074015', '074', 'San Pancrazio Salentino', 'I066', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074016', '074', 'San Pietro Vernotico', 'I119', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074017', '074', 'San Vito dei Normanni', 'I396', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074018', '074', 'Torchiarolo', 'L213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074019', '074', 'Torre Santa Susanna', 'L280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('074020', '074', 'Villa Castelli', 'L920', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075001', '075', 'Acquarica del Capo', 'A042', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075002', '075', 'Alessano', 'A184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075003', '075', 'Alezio', 'A185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075004', '075', 'Alliste', 'A208', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075005', '075', 'Andrano', 'A281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075006', '075', 'Aradeo', 'A350', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075007', '075', 'Arnesano', 'A425', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075008', '075', 'Bagnolo del Salento', 'A572', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075009', '075', 'Botrugno', 'B086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075010', '075', 'Calimera', 'B413', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075011', '075', 'Campi Salentina', 'B506', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075012', '075', 'Cannole', 'B616', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075013', '075', 'Caprarica di Lecce', 'B690', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075014', '075', 'Carmiano', 'B792', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075015', '075', 'Carpignano Salentino', 'B822', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075016', '075', 'Casarano', 'B936', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075017', '075', 'Castri di Lecce', 'C334', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075018', '075', 'Castrignano de'' Greci', 'C335', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075019', '075', 'Castrignano del Capo', 'C336', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075096', '075', 'Castro', 'M261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075020', '075', 'Cavallino', 'C377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075021', '075', 'Collepasso', 'C865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075022', '075', 'Copertino', 'C978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075023', '075', 'Corigliano d''Otranto', 'D006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075024', '075', 'Corsano', 'D044', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075025', '075', 'Cursi', 'D223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075026', '075', 'Cutrofiano', 'D237', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075027', '075', 'Diso', 'D305', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075028', '075', 'Gagliano del Capo', 'D851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075029', '075', 'Galatina', 'D862', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075030', '075', 'Galatone', 'D863', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075031', '075', 'Gallipoli', 'D883', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075032', '075', 'Giuggianello', 'E053', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075033', '075', 'Giurdignano', 'E061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075034', '075', 'Guagnano', 'E227', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075035', '075', 'Lecce', 'E506', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075036', '075', 'Lequile', 'E538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075037', '075', 'Leverano', 'E563', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075038', '075', 'Lizzanello', 'E629', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075039', '075', 'Maglie', 'E815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075040', '075', 'Martano', 'E979', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075041', '075', 'Martignano', 'E984', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075042', '075', 'Matino', 'F054', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075043', '075', 'Melendugno', 'F101', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075044', '075', 'Melissano', 'F109', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075045', '075', 'Melpignano', 'F117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075046', '075', 'Miggiano', 'F194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075047', '075', 'Minervino di Lecce', 'F221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075048', '075', 'Monteroni di Lecce', 'F604', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075049', '075', 'Montesano Salentino', 'F623', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075050', '075', 'Morciano di Leuca', 'F716', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075051', '075', 'Muro Leccese', 'F816', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075052', '075', 'Nardò', 'F842', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075053', '075', 'Neviano', 'F881', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075054', '075', 'Nociglia', 'F916', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075055', '075', 'Novoli', 'F970', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075056', '075', 'Ortelle', 'G136', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075057', '075', 'Otranto', 'G188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075058', '075', 'Palmariggi', 'G285', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075059', '075', 'Parabita', 'G325', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075060', '075', 'Patù', 'G378', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075061', '075', 'Poggiardo', 'G751', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075097', '075', 'Porto Cesareo', 'M263', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075062', '075', 'Presicce', 'H047', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075063', '075', 'Racale', 'H147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075064', '075', 'Ruffano', 'H632', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075065', '075', 'Salice Salentino', 'H708', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075066', '075', 'Salve', 'H729', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075095', '075', 'San Cassiano', 'M264', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075068', '075', 'San Cesario di Lecce', 'H793', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075069', '075', 'San Donato di Lecce', 'H826', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075071', '075', 'San Pietro in Lama', 'I115', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075067', '075', 'Sanarica', 'H757', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075070', '075', 'Sannicola', 'I059', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075072', '075', 'Santa Cesarea Terme', 'I172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075073', '075', 'Scorrano', 'I549', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075074', '075', 'Seclì', 'I559', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075075', '075', 'Sogliano Cavour', 'I780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075076', '075', 'Soleto', 'I800', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075077', '075', 'Specchia', 'I887', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075078', '075', 'Spongano', 'I923', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075079', '075', 'Squinzano', 'I930', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075080', '075', 'Sternatia', 'I950', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075081', '075', 'Supersano', 'L008', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075082', '075', 'Surano', 'L010', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075083', '075', 'Surbo', 'L011', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075084', '075', 'Taurisano', 'L064', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075085', '075', 'Taviano', 'L074', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075086', '075', 'Tiggiano', 'L166', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075087', '075', 'Trepuzzi', 'L383', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075088', '075', 'Tricase', 'L419', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075089', '075', 'Tuglie', 'L462', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075090', '075', 'Ugento', 'L484', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075091', '075', 'Uggiano la Chiesa', 'L485', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075092', '075', 'Veglie', 'L711', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075093', '075', 'Vernole', 'L776', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('075094', '075', 'Zollino', 'M187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076001', '076', 'Abriola', 'A013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076002', '076', 'Acerenza', 'A020', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076003', '076', 'Albano di Lucania', 'A131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076004', '076', 'Anzi', 'A321', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076005', '076', 'Armento', 'A415', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076006', '076', 'Atella', 'A482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076007', '076', 'Avigliano', 'A519', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076008', '076', 'Balvano', 'A604', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076009', '076', 'Banzi', 'A612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076010', '076', 'Baragiano', 'A615', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076011', '076', 'Barile', 'A666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076012', '076', 'Bella', 'A743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076013', '076', 'Brienza', 'B173', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076014', '076', 'Brindisi Montagna', 'B181', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076015', '076', 'Calvello', 'B440', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076016', '076', 'Calvera', 'B443', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076017', '076', 'Campomaggiore', 'B549', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076018', '076', 'Cancellara', 'B580', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076019', '076', 'Carbone', 'B743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076021', '076', 'Castelgrande', 'C120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076022', '076', 'Castelluccio Inferiore', 'C199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076023', '076', 'Castelluccio Superiore', 'C201', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076024', '076', 'Castelmezzano', 'C209', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076025', '076', 'Castelsaraceno', 'C271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076026', '076', 'Castronuovo di Sant''Andrea', 'C345', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076027', '076', 'Cersosimo', 'C539', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076028', '076', 'Chiaromonte', 'C619', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076029', '076', 'Corleto Perticara', 'D010', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076030', '076', 'Episcopia', 'D414', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076031', '076', 'Fardella', 'D497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076032', '076', 'Filiano', 'D593', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076033', '076', 'Forenza', 'D696', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076034', '076', 'Francavilla in Sinni', 'D766', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076035', '076', 'Gallicchio', 'D876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076036', '076', 'Genzano di Lucania', 'D971', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076099', '076', 'Ginestra', 'E033', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076037', '076', 'Grumento Nova', 'E221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076038', '076', 'Guardia Perticara', 'E246', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076039', '076', 'Lagonegro', 'E409', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076040', '076', 'Latronico', 'E474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076041', '076', 'Laurenzana', 'E482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076042', '076', 'Lauria', 'E483', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076043', '076', 'Lavello', 'E493', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076044', '076', 'Maratea', 'E919', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076045', '076', 'Marsico Nuovo', 'E976', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076046', '076', 'Marsicovetere', 'E977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076047', '076', 'Maschito', 'F006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076048', '076', 'Melfi', 'F104', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076049', '076', 'Missanello', 'F249', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076050', '076', 'Moliterno', 'F295', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076051', '076', 'Montemilone', 'F568', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076052', '076', 'Montemurro', 'F573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076053', '076', 'Muro Lucano', 'F817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076054', '076', 'Nemoli', 'F866', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076055', '076', 'Noepoli', 'F917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076056', '076', 'Oppido Lucano', 'G081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076057', '076', 'Palazzo San Gervasio', 'G261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076100', '076', 'Paterno', 'M269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076058', '076', 'Pescopagano', 'G496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076059', '076', 'Picerno', 'G590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076060', '076', 'Pietragalla', 'G616', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076061', '076', 'Pietrapertosa', 'G623', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076062', '076', 'Pignola', 'G663', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076063', '076', 'Potenza', 'G942', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076064', '076', 'Rapolla', 'H186', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076065', '076', 'Rapone', 'H187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076066', '076', 'Rionero in Vulture', 'H307', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076067', '076', 'Ripacandida', 'H312', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076068', '076', 'Rivello', 'H348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076069', '076', 'Roccanova', 'H426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076070', '076', 'Rotonda', 'H590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076071', '076', 'Ruoti', 'H641', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076072', '076', 'Ruvo del Monte', 'H646', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076073', '076', 'San Chirico Nuovo', 'H795', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076074', '076', 'San Chirico Raparo', 'H796', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076075', '076', 'San Costantino Albanese', 'H808', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076076', '076', 'San Fele', 'H831', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076077', '076', 'San Martino d''Agri', 'H994', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076020', '076', 'San Paolo Albanese', 'B906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076078', '076', 'San Severino Lucano', 'I157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076079', '076', 'Sant''Angelo Le Fratte', 'I288', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076080', '076', 'Sant''Arcangelo', 'I305', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076081', '076', 'Sarconi', 'I426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076082', '076', 'Sasso di Castalda', 'I457', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076083', '076', 'Satriano di Lucania', 'G614', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076084', '076', 'Savoia di Lucania', 'H730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076085', '076', 'Senise', 'I610', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076086', '076', 'Spinoso', 'I917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076087', '076', 'Teana', 'L082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076088', '076', 'Terranova di Pollino', 'L126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076089', '076', 'Tito', 'L181', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076090', '076', 'Tolve', 'L197', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076091', '076', 'Tramutola', 'L326', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076092', '076', 'Trecchina', 'L357', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076093', '076', 'Trivigno', 'L439', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076094', '076', 'Vaglio Basilicata', 'L532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076095', '076', 'Venosa', 'L738', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076096', '076', 'Vietri di Potenza', 'L859', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076097', '076', 'Viggianello', 'L873', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076098', '076', 'Viggiano', 'L874', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('076801', '076', 'Castelluccio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077001', '077', 'Accettura', 'A017', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077002', '077', 'Aliano', 'A196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077003', '077', 'Bernalda', 'A801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077004', '077', 'Calciano', 'B391', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077005', '077', 'Cirigliano', 'C723', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077006', '077', 'Colobraro', 'C888', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077007', '077', 'Craco', 'D128', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077008', '077', 'Ferrandina', 'D547', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077009', '077', 'Garaguso', 'D909', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077010', '077', 'Gorgoglione', 'E093', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077011', '077', 'Grassano', 'E147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077012', '077', 'Grottole', 'E213', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077013', '077', 'Irsina', 'E326', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077014', '077', 'Matera', 'F052', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077015', '077', 'Miglionico', 'F201', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077016', '077', 'Montalbano Jonico', 'F399', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077017', '077', 'Montescaglioso', 'F637', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077018', '077', 'Nova Siri', 'A942', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077019', '077', 'Oliveto Lucano', 'G037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077020', '077', 'Pisticci', 'G712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077021', '077', 'Policoro', 'G786', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077022', '077', 'Pomarico', 'G806', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077023', '077', 'Rotondella', 'H591', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077024', '077', 'Salandra', 'H687', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077025', '077', 'San Giorgio Lucano', 'H888', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077026', '077', 'San Mauro Forte', 'I029', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077031', '077', 'Scanzano Jonico', 'M256', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077027', '077', 'Stigliano', 'I954', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077028', '077', 'Tricarico', 'L418', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077029', '077', 'Tursi', 'L477', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('077030', '077', 'Valsinni', 'D513', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078001', '078', 'Acquaformosa', 'A033', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078002', '078', 'Acquappesa', 'A041', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078003', '078', 'Acri', 'A053', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078004', '078', 'Aiello Calabro', 'A102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078005', '078', 'Aieta', 'A105', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078006', '078', 'Albidona', 'A160', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078007', '078', 'Alessandria del Carretto', 'A183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078008', '078', 'Altilia', 'A234', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078009', '078', 'Altomonte', 'A240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078010', '078', 'Amantea', 'A253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078011', '078', 'Amendolara', 'A263', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078012', '078', 'Aprigliano', 'A340', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078013', '078', 'Belmonte Calabro', 'A762', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078014', '078', 'Belsito', 'A768', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078015', '078', 'Belvedere Marittimo', 'A773', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078016', '078', 'Bianchi', 'A842', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078017', '078', 'Bisignano', 'A887', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078018', '078', 'Bocchigliero', 'A912', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078019', '078', 'Bonifati', 'A973', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078020', '078', 'Buonvicino', 'B270', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078021', '078', 'Calopezzati', 'B424', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078022', '078', 'Caloveto', 'B426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078023', '078', 'Campana', 'B500', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078024', '078', 'Canna', 'B607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078025', '078', 'Cariati', 'B774', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078026', '078', 'Carolei', 'B802', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078027', '078', 'Carpanzano', 'B813', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078028', '078', 'Casole Bruzio', 'B983', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078029', '078', 'Cassano all''Ionio', 'C002', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078030', '078', 'Castiglione Cosentino', 'C301', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078031', '078', 'Castrolibero', 'C108', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078032', '078', 'Castroregio', 'C348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078033', '078', 'Castrovillari', 'C349', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078034', '078', 'Celico', 'C430', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078035', '078', 'Cellara', 'C437', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078036', '078', 'Cerchiara di Calabria', 'C489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078037', '078', 'Cerisano', 'C515', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078038', '078', 'Cervicati', 'C554', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078039', '078', 'Cerzeto', 'C560', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078040', '078', 'Cetraro', 'C588', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078041', '078', 'Civita', 'C763', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078042', '078', 'Cleto', 'C795', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078043', '078', 'Colosimi', 'C905', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078044', '078', 'Corigliano Calabro', 'D005', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078045', '078', 'Cosenza', 'D086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078046', '078', 'Cropalati', 'D180', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078047', '078', 'Crosia', 'D184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078048', '078', 'Diamante', 'D289', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078049', '078', 'Dipignano', 'D304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078050', '078', 'Domanico', 'D328', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078051', '078', 'Fagnano Castello', 'D464', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078052', '078', 'Falconara Albanese', 'D473', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078053', '078', 'Figline Vegliaturo', 'D582', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078054', '078', 'Firmo', 'D614', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078055', '078', 'Fiumefreddo Bruzio', 'D624', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078056', '078', 'Francavilla Marittima', 'D764', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078057', '078', 'Frascineto', 'D774', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078058', '078', 'Fuscaldo', 'D828', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078059', '078', 'Grimaldi', 'E180', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078060', '078', 'Grisolia', 'E185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078061', '078', 'Guardia Piemontese', 'E242', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078062', '078', 'Lago', 'E407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078063', '078', 'Laino Borgo', 'E417', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078064', '078', 'Laino Castello', 'E419', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078065', '078', 'Lappano', 'E450', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078066', '078', 'Lattarico', 'E475', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078067', '078', 'Longobardi', 'E677', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078068', '078', 'Longobucco', 'E678', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078069', '078', 'Lungro', 'E745', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078070', '078', 'Luzzi', 'E773', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078071', '078', 'Maierà', 'E835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078072', '078', 'Malito', 'E859', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078073', '078', 'Malvito', 'E872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078074', '078', 'Mandatoriccio', 'E878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078075', '078', 'Mangone', 'E888', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078076', '078', 'Marano Marchesato', 'E914', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078077', '078', 'Marano Principato', 'E915', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078078', '078', 'Marzi', 'F001', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078079', '078', 'Mendicino', 'F125', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078080', '078', 'Mongrassano', 'F370', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078081', '078', 'Montalto Uffugo', 'F416', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078082', '078', 'Montegiordano', 'F519', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078083', '078', 'Morano Calabro', 'F708', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078084', '078', 'Mormanno', 'F735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078085', '078', 'Mottafollone', 'F775', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078086', '078', 'Nocara', 'F907', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078087', '078', 'Oriolo', 'G110', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078088', '078', 'Orsomarso', 'G129', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078089', '078', 'Paludi', 'G298', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078090', '078', 'Panettieri', 'G307', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078091', '078', 'Paola', 'G317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078092', '078', 'Papasidero', 'G320', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078093', '078', 'Parenti', 'G331', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078094', '078', 'Paterno Calabro', 'G372', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078095', '078', 'Pedace', 'G400', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078096', '078', 'Pedivigliano', 'G411', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078097', '078', 'Piane Crati', 'G553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078098', '078', 'Pietrafitta', 'G615', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078099', '078', 'Pietrapaola', 'G622', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078100', '078', 'Plataci', 'G733', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078101', '078', 'Praia a Mare', 'G975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078102', '078', 'Rende', 'H235', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078103', '078', 'Rocca Imperiale', 'H416', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078104', '078', 'Roggiano Gravina', 'H488', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078105', '078', 'Rogliano', 'H490', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078106', '078', 'Rose', 'H565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078107', '078', 'Roseto Capo Spulico', 'H572', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078108', '078', 'Rossano', 'H579', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078109', '078', 'Rota Greca', 'H585', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078110', '078', 'Rovito', 'H621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078111', '078', 'San Basile', 'H765', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078112', '078', 'San Benedetto Ullano', 'H774', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078113', '078', 'San Cosmo Albanese', 'H806', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078114', '078', 'San Demetrio Corone', 'H818', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078115', '078', 'San Donato di Ninea', 'H825', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078116', '078', 'San Fili', 'H841', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078118', '078', 'San Giorgio Albanese', 'H881', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078119', '078', 'San Giovanni in Fiore', 'H919', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078120', '078', 'San Lorenzo Bellizzi', 'H961', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078121', '078', 'San Lorenzo del Vallo', 'H962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078122', '078', 'San Lucido', 'H971', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078123', '078', 'San Marco Argentano', 'H981', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078124', '078', 'San Martino di Finita', 'H992', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078125', '078', 'San Nicola Arcella', 'I060', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078126', '078', 'San Pietro in Amantea', 'I108', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078127', '078', 'San Pietro in Guarano', 'I114', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078128', '078', 'San Sosti', 'I165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078135', '078', 'San Vincenzo La Costa', 'I388', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078117', '078', 'Sangineto', 'H877', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078129', '078', 'Santa Caterina Albanese', 'I171', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078130', '078', 'Santa Domenica Talao', 'I183', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078132', '078', 'Santa Maria del Cedro', 'C717', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078133', '078', 'Santa Sofia d''Epiro', 'I309', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078131', '078', 'Sant''Agata di Esaro', 'I192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078134', '078', 'Santo Stefano di Rogliano', 'I359', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078136', '078', 'Saracena', 'I423', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078137', '078', 'Scala Coeli', 'I485', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078138', '078', 'Scalea', 'I489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078139', '078', 'Scigliano', 'D290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078140', '078', 'Serra d''Aiello', 'I642', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078141', '078', 'Serra Pedace', 'I650', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078142', '078', 'Spezzano Albanese', 'I895', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078143', '078', 'Spezzano della Sila', 'I896', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078144', '078', 'Spezzano Piccolo', 'I898', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078145', '078', 'Tarsia', 'L055', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078146', '078', 'Terranova da Sibari', 'L124', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078147', '078', 'Terravecchia', 'L134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078148', '078', 'Torano Castello', 'L206', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078149', '078', 'Tortora', 'L305', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078150', '078', 'Trebisacce', 'L353', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078151', '078', 'Trenta', 'L375', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078152', '078', 'Vaccarizzo Albanese', 'L524', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078153', '078', 'Verbicaro', 'L747', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078154', '078', 'Villapiana', 'B903', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078155', '078', 'Zumpano', 'M202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078156', '078', 'Casali del Manco', 'M385', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078157', '078', 'Corigliano-Rossano', 'M403', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078801', '078', 'Aiello in Calabria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078802', '078', 'Guardia Piemontese Terme', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078803', '078', 'Laino Bruzio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078804', '078', 'Spezzano Grande', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('078805', '078', 'Terrati', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079002', '079', 'Albi', 'A155', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079003', '079', 'Amaroni', 'A255', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079004', '079', 'Amato', 'A257', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079005', '079', 'Andali', 'A272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079007', '079', 'Argusto', 'A397', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079008', '079', 'Badolato', 'A542', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079009', '079', 'Belcastro', 'A736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079011', '079', 'Borgia', 'B002', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079012', '079', 'Botricello', 'B085', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079017', '079', 'Caraffa di Catanzaro', 'B717', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079018', '079', 'Cardinale', 'B758', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079020', '079', 'Carlopoli', 'B790', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079023', '079', 'Catanzaro', 'C352', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079024', '079', 'Cenadi', 'C453', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079025', '079', 'Centrache', 'C472', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079027', '079', 'Cerva', 'C542', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079029', '079', 'Chiaravalle Centrale', 'C616', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079030', '079', 'Cicala', 'C674', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079033', '079', 'Conflenti', 'C960', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079034', '079', 'Cortale', 'D049', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079036', '079', 'Cropani', 'D181', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079039', '079', 'Curinga', 'D218', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079042', '079', 'Davoli', 'D257', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079043', '079', 'Decollatura', 'D261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079047', '079', 'Falerna', 'D476', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079048', '079', 'Feroleto Antico', 'D544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079052', '079', 'Fossato Serralta', 'D744', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079055', '079', 'Gagliato', 'D852', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079056', '079', 'Gasperina', 'D932', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079058', '079', 'Gimigliano', 'E031', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079059', '079', 'Girifalco', 'E050', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079060', '079', 'Gizzeria', 'E068', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079061', '079', 'Guardavalle', 'E239', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079063', '079', 'Isca sullo Ionio', 'E328', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079065', '079', 'Jacurso', 'E274', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079160', '079', 'Lamezia Terme', 'M208', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079068', '079', 'Magisano', 'E806', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079069', '079', 'Maida', 'E834', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079071', '079', 'Marcedusa', 'E923', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079072', '079', 'Marcellinara', 'E925', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079073', '079', 'Martirano', 'E990', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079074', '079', 'Martirano Lombardo', 'E991', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079077', '079', 'Miglierina', 'F200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079080', '079', 'Montauro', 'F432', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079081', '079', 'Montepaone', 'F586', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079083', '079', 'Motta Santa Lucia', 'F780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079087', '079', 'Nocera Terinese', 'F910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079088', '079', 'Olivadi', 'G034', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079089', '079', 'Palermiti', 'G272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079092', '079', 'Pentone', 'G439', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079094', '079', 'Petrizzi', 'G517', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079095', '079', 'Petronà', 'G518', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079096', '079', 'Pianopoli', 'D546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079099', '079', 'Platania', 'G734', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079108', '079', 'San Floro', 'H846', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079110', '079', 'San Mango d''Aquino', 'H976', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079114', '079', 'San Pietro a Maida', 'I093', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079115', '079', 'San Pietro Apostolo', 'I095', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079116', '079', 'San Sostene', 'I164', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079122', '079', 'San Vito sullo Ionio', 'I393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079117', '079', 'Santa Caterina dello Ionio', 'I170', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079118', '079', 'Sant''Andrea Apostolo dello Ionio', 'I266', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079123', '079', 'Satriano', 'I463', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079126', '079', 'Sellia', 'I589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079127', '079', 'Sellia Marina', 'I590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079129', '079', 'Serrastretta', 'I655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079130', '079', 'Sersale', 'I671', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079131', '079', 'Settingiano', 'I704', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079133', '079', 'Simeri Crichi', 'I745', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079134', '079', 'Sorbo San Basile', 'I844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079137', '079', 'Soverato', 'I872', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079138', '079', 'Soveria Mannelli', 'I874', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079139', '079', 'Soveria Simeri', 'I875', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079142', '079', 'Squillace', 'I929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079143', '079', 'Stalettì', 'I937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079146', '079', 'Taverna', 'L070', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079147', '079', 'Tiriolo', 'L177', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079148', '079', 'Torre di Ruggiero', 'L240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079151', '079', 'Vallefiorita', 'I322', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079157', '079', 'Zagarise', 'M140', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079085', '079', 'Nicastro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079105', '079', 'Sambiase', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079120', '079', 'Sant’Eufemia Lamezia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079801', '079', 'Castagna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('079802', '079', 'Piscopio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080001', '080', 'Africo', 'A065', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080002', '080', 'Agnana Calabra', 'A077', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080003', '080', 'Anoia', 'A303', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080004', '080', 'Antonimina', 'A314', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080005', '080', 'Ardore', 'A385', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080006', '080', 'Bagaladi', 'A544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080007', '080', 'Bagnara Calabra', 'A552', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080008', '080', 'Benestare', 'A780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080009', '080', 'Bianco', 'A843', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080010', '080', 'Bivongi', 'A897', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080011', '080', 'Bova', 'B097', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080013', '080', 'Bova Marina', 'B099', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080012', '080', 'Bovalino', 'B098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080014', '080', 'Brancaleone', 'B118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080015', '080', 'Bruzzano Zeffirio', 'B234', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080016', '080', 'Calanna', 'B379', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080017', '080', 'Camini', 'B481', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080018', '080', 'Campo Calabro', 'B516', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080019', '080', 'Candidoni', 'B591', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080020', '080', 'Canolo', 'B617', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080021', '080', 'Caraffa del Bianco', 'B718', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080022', '080', 'Cardeto', 'B756', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080023', '080', 'Careri', 'B766', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080024', '080', 'Casignana', 'B966', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080025', '080', 'Caulonia', 'C285', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080026', '080', 'Ciminà', 'C695', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080027', '080', 'Cinquefrondi', 'C710', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080028', '080', 'Cittanova', 'C747', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080029', '080', 'Condofuri', 'C954', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080030', '080', 'Cosoleto', 'D089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080031', '080', 'Delianuova', 'D268', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080032', '080', 'Feroleto della Chiesa', 'D545', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080033', '080', 'Ferruzzano', 'D557', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080034', '080', 'Fiumara', 'D619', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080035', '080', 'Galatro', 'D864', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080036', '080', 'Gerace', 'D975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080037', '080', 'Giffone', 'E025', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080038', '080', 'Gioia Tauro', 'E041', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080039', '080', 'Gioiosa Ionica', 'E044', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080040', '080', 'Grotteria', 'E212', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080041', '080', 'Laganadi', 'E402', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080042', '080', 'Laureana di Borrello', 'E479', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080043', '080', 'Locri', 'D976', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080044', '080', 'Mammola', 'E873', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080045', '080', 'Marina di Gioiosa Ionica', 'E956', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080046', '080', 'Maropati', 'E968', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080047', '080', 'Martone', 'E993', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080048', '080', 'Melicuccà', 'F105', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080049', '080', 'Melicucco', 'F106', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080050', '080', 'Melito di Porto Salvo', 'F112', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080051', '080', 'Molochio', 'F301', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080052', '080', 'Monasterace', 'F324', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080053', '080', 'Montebello Jonico', 'D746', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080054', '080', 'Motta San Giovanni', 'F779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080055', '080', 'Oppido Mamertina', 'G082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080056', '080', 'Palizzi', 'G277', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080057', '080', 'Palmi', 'G288', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080058', '080', 'Pazzano', 'G394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080059', '080', 'Placanica', 'G729', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080060', '080', 'Platì', 'G735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080061', '080', 'Polistena', 'G791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080062', '080', 'Portigliola', 'G905', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080063', '080', 'Reggio di Calabria', 'H224', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080064', '080', 'Riace', 'H265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080065', '080', 'Rizziconi', 'H359', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080066', '080', 'Roccaforte del Greco', 'H408', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080067', '080', 'Roccella Ionica', 'H456', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080068', '080', 'Roghudi', 'H489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080069', '080', 'Rosarno', 'H558', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080070', '080', 'Samo', 'H013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080097', '080', 'San Ferdinando', 'M277', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080071', '080', 'San Giorgio Morgeto', 'H889', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080072', '080', 'San Giovanni di Gerace', 'H903', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080073', '080', 'San Lorenzo', 'H959', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080074', '080', 'San Luca', 'H970', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080075', '080', 'San Pietro di Caridà', 'I102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080076', '080', 'San Procopio', 'I132', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080077', '080', 'San Roberto', 'I139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080078', '080', 'Santa Cristina d''Aspromonte', 'I176', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080079', '080', 'Sant''Agata del Bianco', 'I198', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080080', '080', 'Sant''Alessio in Aspromonte', 'I214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080081', '080', 'Sant''Eufemia d''Aspromonte', 'I333', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080082', '080', 'Sant''Ilario dello Ionio', 'I341', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080083', '080', 'Santo Stefano in Aspromonte', 'I371', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080084', '080', 'Scido', 'I536', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080085', '080', 'Scilla', 'I537', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080086', '080', 'Seminara', 'I600', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080087', '080', 'Serrata', 'I656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080088', '080', 'Siderno', 'I725', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080089', '080', 'Sinopoli', 'I753', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080090', '080', 'Staiti', 'I936', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080091', '080', 'Stignano', 'I955', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080092', '080', 'Stilo', 'I956', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080093', '080', 'Taurianova', 'L063', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080094', '080', 'Terranova Sappo Minulio', 'L127', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080095', '080', 'Varapodio', 'L673', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080096', '080', 'Villa San Giovanni', 'M018', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080801', '080', 'Cannitello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080802', '080', 'Caridà', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080803', '080', 'Cataforio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080804', '080', 'Catona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080805', '080', 'Gallico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080806', '080', 'Gallina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080807', '080', 'Iatrinoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080808', '080', 'Orti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080809', '080', 'Paracorio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080810', '080', 'Pedavoli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080811', '080', 'Pellaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080812', '080', 'Podargoni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080813', '080', 'Radicena', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080814', '080', 'Rosalì', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080815', '080', 'Salice Calabro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080816', '080', 'Sambatello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080817', '080', 'Samo di Calabria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080818', '080', 'San Pier Fedele', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080819', '080', 'Tresilico', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('080820', '080', 'Villa San Giuseppe', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081001', '081', 'Alcamo', 'A176', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081002', '081', 'Buseto Palizzolo', 'B288', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081003', '081', 'Calatafimi-Segesta', 'B385', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081004', '081', 'Campobello di Mazara', 'B521', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081005', '081', 'Castellammare del Golfo', 'C130', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081006', '081', 'Castelvetrano', 'C286', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081007', '081', 'Custonaci', 'D234', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081008', '081', 'Erice', 'D423', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081009', '081', 'Favignana', 'D518', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081010', '081', 'Gibellina', 'E023', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081011', '081', 'Marsala', 'E974', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081012', '081', 'Mazara del Vallo', 'F061', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081013', '081', 'Paceco', 'G208', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081014', '081', 'Pantelleria', 'G315', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081015', '081', 'Partanna', 'G347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081024', '081', 'Petrosino', 'M281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081016', '081', 'Poggioreale', 'G767', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081017', '081', 'Salaparuta', 'H688', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081018', '081', 'Salemi', 'H700', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081020', '081', 'San Vito Lo Capo', 'I407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081019', '081', 'Santa Ninfa', 'I291', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081021', '081', 'Trapani', 'L331', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081022', '081', 'Valderice', 'G319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081023', '081', 'Vita', 'M081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('081801', '081', 'Xitta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082001', '082', 'Alia', 'A195', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082002', '082', 'Alimena', 'A202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082003', '082', 'Aliminusa', 'A203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082004', '082', 'Altavilla Milicia', 'A229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082005', '082', 'Altofonte', 'A239', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082006', '082', 'Bagheria', 'A546', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082007', '082', 'Balestrate', 'A592', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082008', '082', 'Baucina', 'A719', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082009', '082', 'Belmonte Mezzagno', 'A764', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082010', '082', 'Bisacquino', 'A882', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082082', '082', 'Blufi', 'M268', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082011', '082', 'Bolognetta', 'A946', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082012', '082', 'Bompietro', 'A958', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082013', '082', 'Borgetto', 'A991', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082014', '082', 'Caccamo', 'B315', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082015', '082', 'Caltavuturo', 'B430', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082016', '082', 'Campofelice di Fitalia', 'B533', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082017', '082', 'Campofelice di Roccella', 'B532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082018', '082', 'Campofiorito', 'B535', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082019', '082', 'Camporeale', 'B556', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082020', '082', 'Capaci', 'B645', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082021', '082', 'Carini', 'B780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082022', '082', 'Castelbuono', 'C067', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082023', '082', 'Casteldaccia', 'C074', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082024', '082', 'Castellana Sicula', 'C135', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082025', '082', 'Castronovo di Sicilia', 'C344', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082026', '082', 'Cefalà Diana', 'C420', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082027', '082', 'Cefalù', 'C421', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082028', '082', 'Cerda', 'C496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082029', '082', 'Chiusa Sclafani', 'C654', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082030', '082', 'Ciminna', 'C696', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082031', '082', 'Cinisi', 'C708', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082032', '082', 'Collesano', 'C871', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082033', '082', 'Contessa Entellina', 'C968', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082034', '082', 'Corleone', 'D009', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082035', '082', 'Ficarazzi', 'D567', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082036', '082', 'Gangi', 'D907', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082037', '082', 'Geraci Siculo', 'D977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082038', '082', 'Giardinello', 'E013', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082039', '082', 'Giuliana', 'E055', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082040', '082', 'Godrano', 'E074', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082041', '082', 'Gratteri', 'E149', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082042', '082', 'Isnello', 'E337', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082043', '082', 'Isola delle Femmine', 'E350', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082044', '082', 'Lascari', 'E459', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082045', '082', 'Lercara Friddi', 'E541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082046', '082', 'Marineo', 'E957', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082047', '082', 'Mezzojuso', 'F184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082048', '082', 'Misilmeri', 'F246', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082049', '082', 'Monreale', 'F377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082050', '082', 'Montelepre', 'F544', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082051', '082', 'Montemaggiore Belsito', 'F553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082052', '082', 'Palazzo Adriano', 'G263', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082053', '082', 'Palermo', 'G273', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082054', '082', 'Partinico', 'G348', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082055', '082', 'Petralia Soprana', 'G510', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082056', '082', 'Petralia Sottana', 'G511', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082057', '082', 'Piana degli Albanesi', 'G543', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082058', '082', 'Polizzi Generosa', 'G792', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082059', '082', 'Pollina', 'G797', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082060', '082', 'Prizzi', 'H070', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082061', '082', 'Roccamena', 'H422', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082062', '082', 'Roccapalumba', 'H428', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082063', '082', 'San Cipirello', 'H797', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082064', '082', 'San Giuseppe Jato', 'H933', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082065', '082', 'San Mauro Castelverde', 'I028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082066', '082', 'Santa Cristina Gela', 'I174', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082067', '082', 'Santa Flavia', 'I188', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082068', '082', 'Sciara', 'I534', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082081', '082', 'Scillato', 'I538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082069', '082', 'Sclafani Bagni', 'I541', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082070', '082', 'Termini Imerese', 'L112', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082071', '082', 'Terrasini', 'L131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082072', '082', 'Torretta', 'L282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082073', '082', 'Trabia', 'L317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082074', '082', 'Trappeto', 'L332', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082075', '082', 'Ustica', 'L519', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082076', '082', 'Valledolmo', 'L603', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082077', '082', 'Ventimiglia di Sicilia', 'L740', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082078', '082', 'Vicari', 'L837', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082079', '082', 'Villabate', 'L916', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('082080', '082', 'Villafrati', 'L951', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083107', '083', 'Acquedolci', 'M211', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083001', '083', 'Alcara li Fusi', 'A177', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083002', '083', 'Alì', 'A194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083003', '083', 'Alì Terme', 'A201', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083004', '083', 'Antillo', 'A313', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083005', '083', 'Barcellona Pozzo di Gotto', 'A638', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083006', '083', 'Basicò', 'A698', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083007', '083', 'Brolo', 'B198', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083008', '083', 'Capizzi', 'B660', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083009', '083', 'Capo d''Orlando', 'B666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083010', '083', 'Capri Leone', 'B695', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083011', '083', 'Caronia', 'B804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083012', '083', 'Casalvecchio Siculo', 'B918', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083013', '083', 'Castel di Lucio', 'C094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083014', '083', 'Castell''Umberto', 'C051', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083015', '083', 'Castelmola', 'C210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083016', '083', 'Castroreale', 'C347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083017', '083', 'Cesarò', 'C568', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083018', '083', 'Condrò', 'C956', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083019', '083', 'Falcone', 'D474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083020', '083', 'Ficarra', 'D569', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083021', '083', 'Fiumedinisi', 'D622', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083022', '083', 'Floresta', 'D635', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083023', '083', 'Fondachelli-Fantina', 'D661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083024', '083', 'Forza d''Agrò', 'D733', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083025', '083', 'Francavilla di Sicilia', 'D765', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083026', '083', 'Frazzanò', 'D793', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083027', '083', 'Furci Siculo', 'D824', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083028', '083', 'Furnari', 'D825', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083029', '083', 'Gaggi', 'D844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083030', '083', 'Galati Mamertino', 'D861', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083031', '083', 'Gallodoro', 'D885', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083032', '083', 'Giardini-Naxos', 'E014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083033', '083', 'Gioiosa Marea', 'E043', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083034', '083', 'Graniti', 'E142', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083035', '083', 'Gualtieri Sicaminò', 'E233', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083036', '083', 'Itala', 'E374', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083037', '083', 'Leni', 'E523', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083038', '083', 'Letojanni', 'E555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083039', '083', 'Librizzi', 'E571', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083040', '083', 'Limina', 'E594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083041', '083', 'Lipari', 'E606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083042', '083', 'Longi', 'E674', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083043', '083', 'Malfa', 'E855', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083044', '083', 'Malvagna', 'E869', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083045', '083', 'Mandanici', 'E876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083046', '083', 'Mazzarrà Sant''Andrea', 'F066', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083047', '083', 'Merì', 'F147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083048', '083', 'Messina', 'F158', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083049', '083', 'Milazzo', 'F206', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083050', '083', 'Militello Rosmarino', 'F210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083051', '083', 'Mirto', 'F242', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083052', '083', 'Mistretta', 'F251', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083053', '083', 'Moio Alcantara', 'F277', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083054', '083', 'Monforte San Giorgio', 'F359', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083055', '083', 'Mongiuffi Melia', 'F368', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083056', '083', 'Montagnareale', 'F395', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083057', '083', 'Montalbano Elicona', 'F400', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083058', '083', 'Motta Camastra', 'F772', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083059', '083', 'Motta d''Affermo', 'F773', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083060', '083', 'Naso', 'F848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083061', '083', 'Nizza di Sicilia', 'F901', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083062', '083', 'Novara di Sicilia', 'F951', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083063', '083', 'Oliveri', 'G036', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083064', '083', 'Pace del Mela', 'G209', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083065', '083', 'Pagliara', 'G234', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083066', '083', 'Patti', 'G377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083067', '083', 'Pettineo', 'G522', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083068', '083', 'Piraino', 'G699', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083069', '083', 'Raccuja', 'H151', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083070', '083', 'Reitano', 'H228', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083071', '083', 'Roccafiorita', 'H405', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083072', '083', 'Roccalumera', 'H418', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083073', '083', 'Roccavaldina', 'H380', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083074', '083', 'Roccella Valdemone', 'H455', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083075', '083', 'Rodì Milici', 'H479', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083076', '083', 'Rometta', 'H519', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083077', '083', 'San Filippo del Mela', 'H842', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083078', '083', 'San Fratello', 'H850', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083079', '083', 'San Marco d''Alunzio', 'H982', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083080', '083', 'San Pier Niceto', 'I084', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083081', '083', 'San Piero Patti', 'I086', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083082', '083', 'San Salvatore di Fitalia', 'I147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083090', '083', 'San Teodoro', 'I328', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083083', '083', 'Santa Domenica Vittoria', 'I184', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083086', '083', 'Santa Lucia del Mela', 'I220', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083087', '083', 'Santa Marina Salina', 'I254', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083089', '083', 'Santa Teresa di Riva', 'I311', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083084', '083', 'Sant''Agata di Militello', 'I199', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083085', '083', 'Sant''Alessio Siculo', 'I215', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083088', '083', 'Sant''Angelo di Brolo', 'I283', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083091', '083', 'Santo Stefano di Camastra', 'I370', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083092', '083', 'Saponara', 'I420', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083093', '083', 'Savoca', 'I477', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083094', '083', 'Scaletta Zanclea', 'I492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083095', '083', 'Sinagra', 'I747', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083096', '083', 'Spadafora', 'I881', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083097', '083', 'Taormina', 'L042', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083106', '083', 'Terme Vigliatore', 'M210', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083098', '083', 'Torregrotta', 'L271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083108', '083', 'Torrenova', 'M286', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083099', '083', 'Tortorici', 'L308', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083100', '083', 'Tripi', 'L431', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083101', '083', 'Tusa', 'L478', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083102', '083', 'Ucria', 'L482', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083103', '083', 'Valdina', 'L561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083104', '083', 'Venetico', 'L735', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083105', '083', 'Villafranca Tirrena', 'L950', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083801', '083', 'Bauso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083802', '083', 'Calvaruso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083803', '083', 'Guidomandri', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083804', '083', 'Lanza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083805', '083', 'Locadi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083806', '083', 'Salina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083807', '083', 'Santo Stefano di Briga', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083808', '083', 'Spadafora San Martino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('083809', '083', 'Spadafora San Pietro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084001', '084', 'Agrigento', 'A089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084002', '084', 'Alessandria della Rocca', 'A181', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084003', '084', 'Aragona', 'A351', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084004', '084', 'Bivona', 'A896', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084005', '084', 'Burgio', 'B275', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084006', '084', 'Calamonaci', 'B377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084007', '084', 'Caltabellotta', 'B427', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084008', '084', 'Camastra', 'B460', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084009', '084', 'Cammarata', 'B486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084010', '084', 'Campobello di Licata', 'B520', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084011', '084', 'Canicattì', 'B602', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084012', '084', 'Casteltermini', 'C275', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084013', '084', 'Castrofilippo', 'C341', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084014', '084', 'Cattolica Eraclea', 'C356', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084015', '084', 'Cianciana', 'C668', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084016', '084', 'Comitini', 'C928', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084017', '084', 'Favara', 'D514', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084018', '084', 'Grotte', 'E209', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084019', '084', 'Joppolo Giancaxio', 'E390', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084020', '084', 'Lampedusa e Linosa', 'E431', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084021', '084', 'Licata', 'E573', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084022', '084', 'Lucca Sicula', 'E714', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084023', '084', 'Menfi', 'F126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084024', '084', 'Montallegro', 'F414', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084025', '084', 'Montevago', 'F655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084026', '084', 'Naro', 'F845', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084027', '084', 'Palma di Montechiaro', 'G282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084028', '084', 'Porto Empedocle', 'F299', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084029', '084', 'Racalmuto', 'H148', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084030', '084', 'Raffadali', 'H159', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084031', '084', 'Ravanusa', 'H194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084032', '084', 'Realmonte', 'H205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084033', '084', 'Ribera', 'H269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084034', '084', 'Sambuca di Sicilia', 'H743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084035', '084', 'San Biagio Platani', 'H778', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084036', '084', 'San Giovanni Gemini', 'H914', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084037', '084', 'Santa Elisabetta', 'I185', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084038', '084', 'Santa Margherita di Belice', 'I224', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084039', '084', 'Sant''Angelo Muxaro', 'I290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084040', '084', 'Santo Stefano Quisquina', 'I356', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084041', '084', 'Sciacca', 'I533', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084042', '084', 'Siculiana', 'I723', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('084043', '084', 'Villafranca Sicula', 'L944', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085001', '085', 'Acquaviva Platani', 'A049', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085002', '085', 'Bompensiere', 'A957', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085003', '085', 'Butera', 'B302', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085004', '085', 'Caltanissetta', 'B429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085005', '085', 'Campofranco', 'B537', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085006', '085', 'Delia', 'D267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085007', '085', 'Gela', 'D960', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085008', '085', 'Marianopoli', 'E953', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085009', '085', 'Mazzarino', 'F065', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085010', '085', 'Milena', 'E618', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085011', '085', 'Montedoro', 'F489', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085012', '085', 'Mussomeli', 'F830', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085013', '085', 'Niscemi', 'F899', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085014', '085', 'Resuttano', 'H245', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085015', '085', 'Riesi', 'H281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085016', '085', 'San Cataldo', 'H792', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085017', '085', 'Santa Caterina Villarmosa', 'I169', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085018', '085', 'Serradifalco', 'I644', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085019', '085', 'Sommatino', 'I824', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085020', '085', 'Sutera', 'L016', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085021', '085', 'Vallelunga Pratameno', 'L609', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('085022', '085', 'Villalba', 'L959', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086001', '086', 'Agira', 'A070', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086002', '086', 'Aidone', 'A098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086003', '086', 'Assoro', 'A478', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086004', '086', 'Barrafranca', 'A676', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086005', '086', 'Calascibetta', 'B381', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086006', '086', 'Catenanuova', 'C353', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086007', '086', 'Centuripe', 'C471', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086008', '086', 'Cerami', 'C480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086009', '086', 'Enna', 'C342', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086010', '086', 'Gagliano Castelferrato', 'D849', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086011', '086', 'Leonforte', 'E536', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086012', '086', 'Nicosia', 'F892', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086013', '086', 'Nissoria', 'F900', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086014', '086', 'Piazza Armerina', 'G580', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086015', '086', 'Pietraperzia', 'G624', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086016', '086', 'Regalbuto', 'H221', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086017', '086', 'Sperlinga', 'I891', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086018', '086', 'Troina', 'L448', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086019', '086', 'Valguarnera Caropepe', 'L583', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086020', '086', 'Villarosa', 'M011', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('086801', '086', 'Carcaci', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087001', '087', 'Aci Bonaccorsi', 'A025', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087002', '087', 'Aci Castello', 'A026', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087003', '087', 'Aci Catena', 'A027', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087005', '087', 'Aci Sant''Antonio', 'A029', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087004', '087', 'Acireale', 'A028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087006', '087', 'Adrano', 'A056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087007', '087', 'Belpasso', 'A766', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087008', '087', 'Biancavilla', 'A841', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087009', '087', 'Bronte', 'B202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087010', '087', 'Calatabiano', 'B384', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087011', '087', 'Caltagirone', 'B428', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087012', '087', 'Camporotondo Etneo', 'B561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087013', '087', 'Castel di Iudica', 'C091', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087014', '087', 'Castiglione di Sicilia', 'C297', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087015', '087', 'Catania', 'C351', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087016', '087', 'Fiumefreddo di Sicilia', 'D623', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087017', '087', 'Giarre', 'E017', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087018', '087', 'Grammichele', 'E133', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087019', '087', 'Gravina di Catania', 'E156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087020', '087', 'Licodia Eubea', 'E578', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087021', '087', 'Linguaglossa', 'E602', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087022', '087', 'Maletto', 'E854', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087057', '087', 'Maniace', 'M283', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087023', '087', 'Mascali', 'F004', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087024', '087', 'Mascalucia', 'F005', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087056', '087', 'Mazzarrone', 'M271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087025', '087', 'Militello in Val di Catania', 'F209', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087026', '087', 'Milo', 'F214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087027', '087', 'Mineo', 'F217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087028', '087', 'Mirabella Imbaccari', 'F231', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087029', '087', 'Misterbianco', 'F250', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087030', '087', 'Motta Sant''Anastasia', 'F781', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087031', '087', 'Nicolosi', 'F890', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087032', '087', 'Palagonia', 'G253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087033', '087', 'Paternò', 'G371', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087034', '087', 'Pedara', 'G402', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087035', '087', 'Piedimonte Etneo', 'G597', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087036', '087', 'Raddusa', 'H154', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087058', '087', 'Ragalna', 'M287', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087037', '087', 'Ramacca', 'H168', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087038', '087', 'Randazzo', 'H175', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087039', '087', 'Riposto', 'H325', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087040', '087', 'San Cono', 'H805', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087041', '087', 'San Giovanni la Punta', 'H922', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087042', '087', 'San Gregorio di Catania', 'H940', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087043', '087', 'San Michele di Ganzaria', 'I035', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087044', '087', 'San Pietro Clarenza', 'I098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087047', '087', 'Santa Maria di Licodia', 'I240', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087048', '087', 'Santa Venerina', 'I314', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087045', '087', 'Sant''Agata li Battiati', 'I202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087046', '087', 'Sant''Alfio', 'I216', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087049', '087', 'Scordia', 'I548', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087050', '087', 'Trecastagni', 'L355', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087051', '087', 'Tremestieri Etneo', 'L369', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087052', '087', 'Valverde', 'L658', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087053', '087', 'Viagrande', 'L828', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087054', '087', 'Vizzini', 'M100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087055', '087', 'Zafferana Etnea', 'M139', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087801', '087', 'Ionia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('087802', '087', 'San Giovanni di Galermo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088001', '088', 'Acate', 'A014', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088002', '088', 'Chiaramonte Gulfi', 'C612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088003', '088', 'Comiso', 'C927', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088004', '088', 'Giarratana', 'E016', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088005', '088', 'Ispica', 'E366', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088006', '088', 'Modica', 'F258', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088007', '088', 'Monterosso Almo', 'F610', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088008', '088', 'Pozzallo', 'G953', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088009', '088', 'Ragusa', 'H163', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088010', '088', 'Santa Croce Camerina', 'I178', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088011', '088', 'Scicli', 'I535', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088012', '088', 'Vittoria', 'M088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('088801', '088', 'Ragusa Ibla', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089001', '089', 'Augusta', 'A494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089002', '089', 'Avola', 'A522', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089003', '089', 'Buccheri', 'B237', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089004', '089', 'Buscemi', 'B287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089005', '089', 'Canicattini Bagni', 'B603', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089006', '089', 'Carlentini', 'B787', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089007', '089', 'Cassaro', 'C006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089008', '089', 'Ferla', 'D540', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089009', '089', 'Floridia', 'D636', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089010', '089', 'Francofonte', 'D768', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089011', '089', 'Lentini', 'E532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089012', '089', 'Melilli', 'F107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089013', '089', 'Noto', 'F943', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089014', '089', 'Pachino', 'G211', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089015', '089', 'Palazzolo Acreide', 'G267', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089020', '089', 'Portopalo di Capo Passero', 'M257', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089021', '089', 'Priolo Gargallo', 'M279', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089016', '089', 'Rosolini', 'H574', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089017', '089', 'Siracusa', 'I754', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089018', '089', 'Solarino', 'I785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('089019', '089', 'Sortino', 'I864', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090003', '090', 'Alghero', 'A192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090004', '090', 'Anela', 'A287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090005', '090', 'Ardara', 'A379', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090007', '090', 'Banari', 'A606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090008', '090', 'Benetutti', 'A781', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090010', '090', 'Bessude', 'A827', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090011', '090', 'Bonnanaro', 'A976', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090012', '090', 'Bono', 'A977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090013', '090', 'Bonorva', 'A978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090015', '090', 'Borutta', 'B064', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090016', '090', 'Bottidda', 'B094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090018', '090', 'Bultei', 'B264', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090019', '090', 'Bulzi', 'B265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090020', '090', 'Burgos', 'B276', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090022', '090', 'Cargeghe', 'B772', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090023', '090', 'Castelsardo', 'C272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090024', '090', 'Cheremule', 'C600', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090025', '090', 'Chiaramonti', 'C613', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090026', '090', 'Codrongianos', 'C818', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090027', '090', 'Cossoine', 'D100', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090028', '090', 'Esporlatu', 'D441', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090029', '090', 'Florinas', 'D637', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090030', '090', 'Giave', 'E019', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090031', '090', 'Illorai', 'E285', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090032', '090', 'Ittireddu', 'E376', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090033', '090', 'Ittiri', 'E377', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090034', '090', 'Laerru', 'E401', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090038', '090', 'Mara', 'E902', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090039', '090', 'Martis', 'E992', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090040', '090', 'Monteleone Rocca Doria', 'F542', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090042', '090', 'Mores', 'F721', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090043', '090', 'Muros', 'F818', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090044', '090', 'Nughedu San Nicolò', 'F975', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090045', '090', 'Nule', 'F976', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090046', '090', 'Nulvi', 'F977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090048', '090', 'Olmedo', 'G046', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090050', '090', 'Osilo', 'G156', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090051', '090', 'Ossi', 'G178', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090052', '090', 'Ozieri', 'G203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090053', '090', 'Padria', 'G225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090055', '090', 'Pattada', 'G376', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090056', '090', 'Perfugas', 'G450', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090057', '090', 'Ploaghe', 'G740', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090058', '090', 'Porto Torres', 'G924', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090059', '090', 'Pozzomaggiore', 'G962', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090060', '090', 'Putifigari', 'H095', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090061', '090', 'Romana', 'H507', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090064', '090', 'Sassari', 'I452', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090065', '090', 'Sedini', 'I565', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090066', '090', 'Semestene', 'I598', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090067', '090', 'Sennori', 'I614', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090068', '090', 'Siligo', 'I732', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090069', '090', 'Sorso', 'I863', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090071', '090', 'Thiesi', 'L158', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090072', '090', 'Tissi', 'L180', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090073', '090', 'Torralba', 'L235', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090075', '090', 'Tula', 'L464', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090076', '090', 'Uri', 'L503', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090077', '090', 'Usini', 'L509', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090078', '090', 'Villanova Monteleone', 'L989', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090079', '090', 'Valledoria', 'L604', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090082', '090', 'Viddalba', 'M259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090086', '090', 'Tergu', 'M282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090087', '090', 'Santa Maria Coghinas', 'M284', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090088', '090', 'Erula', 'M292', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090089', '090', 'Stintino', 'M290', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104001', '090', 'Aggius', 'A069', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104003', '090', 'Alà dei Sardi', 'A115', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104004', '090', 'Arzachena', 'A453', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104006', '090', 'Berchidda', 'A789', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104007', '090', 'Bortigiadas', 'B063', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104008', '090', 'Buddusò', 'B246', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104010', '090', 'Calangianus', 'B378', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104012', '090', 'La Maddalena', 'E425', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104014', '090', 'Luogosanto', 'E747', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104015', '090', 'Luras', 'E752', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104016', '090', 'Monti', 'F667', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104017', '090', 'Olbia', 'G015', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104018', '090', 'Oschiri', 'G153', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104020', '090', 'Palau', 'G258', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104002', '090', 'Aglientu', 'H848', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104022', '090', 'Santa Teresa Gallura', 'I312', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104025', '090', 'Tempio Pausania', 'L093', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104026', '090', 'Trinità d''Agultu e Vignola', 'L428', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104024', '090', 'Telti', 'L088', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104005', '090', 'Badesi', 'M214', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104011', '090', 'Golfo Aranci', 'M274', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104013', '090', 'Loiri Porto San Paolo', 'M275', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104021', '090', 'Sant''Antonio di Gallura', 'M276', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104019', '090', 'Padru', 'M301', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104009', '090', 'Budoni', 'B248', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('104023', '090', 'San Teodoro', 'I329', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090801', '090', 'Bantine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090802', '090', 'Nuchis', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('090803', '090', 'Rebeccu', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091001', '091', 'Aritzo', 'A407', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091003', '091', 'Atzara', 'A492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091004', '091', 'Austis', 'A503', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091007', '091', 'Belvì', 'A776', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091008', '091', 'Birori', 'A880', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091009', '091', 'Bitti', 'A895', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091010', '091', 'Bolotana', 'A948', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091011', '091', 'Borore', 'B056', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091012', '091', 'Bortigali', 'B062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091016', '091', 'Desulo', 'D287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091017', '091', 'Dorgali', 'D345', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091018', '091', 'Dualchi', 'D376', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091024', '091', 'Fonni', 'D665', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091025', '091', 'Gadoni', 'D842', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091027', '091', 'Galtellì', 'D888', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091028', '091', 'Gavoi', 'D947', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091033', '091', 'Irgoli', 'E323', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091038', '091', 'Lei', 'E517', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091040', '091', 'Loculi', 'E646', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091041', '091', 'Lodè', 'E647', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091043', '091', 'Lula', 'E736', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091044', '091', 'Macomer', 'E788', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091046', '091', 'Mamoiada', 'E874', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091047', '091', 'Meana Sardo', 'F073', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091050', '091', 'Noragugume', 'F933', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091051', '091', 'Nuoro', 'F979', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091055', '091', 'Oliena', 'G031', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091056', '091', 'Ollolai', 'G044', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091057', '091', 'Olzai', 'G058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091058', '091', 'Onanì', 'G064', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091059', '091', 'Onifai', 'G070', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091060', '091', 'Oniferi', 'G071', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091061', '091', 'Orani', 'G084', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091062', '091', 'Orgosolo', 'G097', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091063', '091', 'Orosei', 'G119', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091064', '091', 'Orotelli', 'G120', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091066', '091', 'Ortueri', 'G146', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091067', '091', 'Orune', 'G147', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091068', '091', 'Osidda', 'G154', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091070', '091', 'Ottana', 'G191', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091071', '091', 'Ovodda', 'G201', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091073', '091', 'Posada', 'G929', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091077', '091', 'Sarule', 'I448', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091083', '091', 'Silanus', 'I730', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091084', '091', 'Sindia', 'I748', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091085', '091', 'Siniscola', 'I751', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091086', '091', 'Sorgono', 'I851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091090', '091', 'Teti', 'L153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091091', '091', 'Tiana', 'L160', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091093', '091', 'Tonara', 'L202', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091094', '091', 'Torpè', 'L231', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091104', '091', 'Lodine', 'E649', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105001', '091', 'Arzana', 'A454', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105002', '091', 'Bari Sardo', 'A663', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105003', '091', 'Baunei', 'A722', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105005', '091', 'Elini', 'D395', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105006', '091', 'Gairo', 'D859', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105007', '091', 'Girasole', 'E049', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105008', '091', 'Ilbono', 'E283', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105009', '091', 'Jerzu', 'E387', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105010', '091', 'Lanusei', 'E441', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105011', '091', 'Loceri', 'E644', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105012', '091', 'Lotzorai', 'E700', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105013', '091', 'Osini', 'G158', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105014', '091', 'Perdasdefogu', 'G445', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105016', '091', 'Talana', 'L036', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105017', '091', 'Tertenia', 'L140', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105018', '091', 'Tortolì', 'A355', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105019', '091', 'Triei', 'L423', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105020', '091', 'Ulassai', 'L489', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105021', '091', 'Urzulei', 'L506', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105022', '091', 'Ussassai', 'L514', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105023', '091', 'Villagrande Strisaili', 'L953', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105004', '091', 'Cardedu', 'M285', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091801', '091', 'Garofai', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091802', '091', 'Irgoli di Galtelli', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091804', '091', 'Mulargia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('091805', '091', 'Tortolì', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092003', '092', 'Assemini', 'A474', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092009', '092', 'Cagliari', 'B354', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092011', '092', 'Capoterra', 'B675', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092015', '092', 'Decimomannu', 'D259', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092037', '092', 'Maracalagonis', 'E903', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092050', '092', 'Pula', 'H088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092051', '092', 'Quartu Sant''Elena', 'H118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092066', '092', 'Sarroch', 'I443', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092068', '092', 'Selargius', 'I580', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092074', '092', 'Sestu', 'I695', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092075', '092', 'Settimo San Pietro', 'I699', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092080', '092', 'Sinnai', 'I752', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092090', '092', 'Uta', 'L521', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092099', '092', 'Villa San Pietro', 'I118', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092105', '092', 'Quartucciu', 'H119', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092108', '092', 'Elmas', 'D399', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092109', '092', 'Monserrato', 'F383', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092801', '092', 'Arixi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092802', '092', 'Donigala Siurgus', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092805', '092', 'Pirri', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092806', '092', 'San Pantaleo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092807', '092', 'Serbariu', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092808', '092', 'Seuni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092809', '092', 'Sicci San Biagio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092810', '092', 'Sisini', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092811', '092', 'Siurgus', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092812', '092', 'Villagreca', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093001', '093', 'Andreis', 'A283', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093002', '093', 'Arba', 'A354', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093003', '093', 'Arzene', 'A456', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093004', '093', 'Aviano', 'A516', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093005', '093', 'Azzano Decimo', 'A530', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093006', '093', 'Barcis', 'A640', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093007', '093', 'Brugnera', 'B215', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093008', '093', 'Budoia', 'B247', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093009', '093', 'Caneva', 'B598', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093010', '093', 'Casarsa della Delizia', 'B940', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093011', '093', 'Castelnovo del Friuli', 'C217', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093012', '093', 'Cavasso Nuovo', 'C385', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093013', '093', 'Chions', 'C640', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093014', '093', 'Cimolais', 'C699', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093015', '093', 'Claut', 'C790', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093016', '093', 'Clauzetto', 'C791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093017', '093', 'Cordenons', 'C991', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093018', '093', 'Cordovado', 'C993', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093019', '093', 'Erto e Casso', 'D426', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093020', '093', 'Fanna', 'D487', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093021', '093', 'Fiume Veneto', 'D621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093022', '093', 'Fontanafredda', 'D670', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093024', '093', 'Frisanco', 'D804', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093025', '093', 'Maniago', 'E889', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093026', '093', 'Meduno', 'F089', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093027', '093', 'Montereale Valcellina', 'F596', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093028', '093', 'Morsano al Tagliamento', 'F750', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093029', '093', 'Pasiano di Pordenone', 'G353', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093030', '093', 'Pinzano al Tagliamento', 'G680', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093031', '093', 'Polcenigo', 'G780', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093032', '093', 'Porcia', 'G886', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093033', '093', 'Pordenone', 'G888', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093034', '093', 'Prata di Pordenone', 'G994', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093035', '093', 'Pravisdomini', 'H010', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093036', '093', 'Roveredo in Piano', 'H609', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093037', '093', 'Sacile', 'H657', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093038', '093', 'San Giorgio della Richinvelda', 'H891', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093039', '093', 'San Martino al Tagliamento', 'H999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093040', '093', 'San Quirino', 'I136', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093041', '093', 'San Vito al Tagliamento', 'I403', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093042', '093', 'Sequals', 'I621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093043', '093', 'Sesto al Reghena', 'I686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093044', '093', 'Spilimbergo', 'I904', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093045', '093', 'Tramonti di Sopra', 'L324', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093046', '093', 'Tramonti di Sotto', 'L325', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093047', '093', 'Travesio', 'L347', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093052', '093', 'Vajont', 'M265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093048', '093', 'Valvasone', 'L657', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093049', '093', 'Vito d''Asio', 'M085', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093050', '093', 'Vivaro', 'M096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093051', '093', 'Zoppola', 'M190', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093053', '093', 'Valvasone Arzene', 'M346', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('093801', '093', 'Vallenoncello', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094001', '094', 'Acquaviva d''Isernia', 'A051', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094002', '094', 'Agnone', 'A080', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094003', '094', 'Bagnoli del Trigno', 'A567', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094004', '094', 'Belmonte del Sannio', 'A761', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094005', '094', 'Cantalupo nel Sannio', 'B630', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094006', '094', 'Capracotta', 'B682', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094007', '094', 'Carovilli', 'B810', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094008', '094', 'Carpinone', 'B830', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094009', '094', 'Castel del Giudice', 'C082', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094012', '094', 'Castel San Vincenzo', 'C270', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094010', '094', 'Castelpetroso', 'C246', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094011', '094', 'Castelpizzuto', 'C247', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094013', '094', 'Castelverrino', 'C200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094014', '094', 'Cerro al Volturno', 'C534', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094015', '094', 'Chiauci', 'C620', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094016', '094', 'Civitanova del Sannio', 'C769', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094017', '094', 'Colli a Volturno', 'C878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094018', '094', 'Conca Casale', 'C941', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094019', '094', 'Filignano', 'D595', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094020', '094', 'Forlì del Sannio', 'D703', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094021', '094', 'Fornelli', 'D715', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094022', '094', 'Frosolone', 'D811', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094023', '094', 'Isernia', 'E335', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094024', '094', 'Longano', 'E669', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094025', '094', 'Macchia d''Isernia', 'E778', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094026', '094', 'Macchiagodena', 'E779', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094027', '094', 'Miranda', 'F239', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094028', '094', 'Montaquila', 'F429', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094029', '094', 'Montenero Val Cocchiara', 'F580', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094030', '094', 'Monteroduni', 'F601', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094031', '094', 'Pesche', 'G486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094032', '094', 'Pescolanciano', 'G495', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094033', '094', 'Pescopennataro', 'G497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094034', '094', 'Pettoranello del Molise', 'G523', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094035', '094', 'Pietrabbondante', 'G606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094036', '094', 'Pizzone', 'G727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094037', '094', 'Poggio Sannita', 'B317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094038', '094', 'Pozzilli', 'G954', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094039', '094', 'Rionero Sannitico', 'H308', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094040', '094', 'Roccamandolfi', 'H420', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094041', '094', 'Roccasicura', 'H445', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094042', '094', 'Rocchetta a Volturno', 'H458', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094043', '094', 'San Pietro Avellana', 'I096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094045', '094', 'Santa Maria del Molise', 'I238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094044', '094', 'Sant''Agapito', 'I189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094046', '094', 'Sant''Angelo del Pesco', 'I282', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094047', '094', 'Sant''Elena Sannita', 'B466', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094048', '094', 'Scapoli', 'I507', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094049', '094', 'Sessano del Molise', 'I679', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094050', '094', 'Sesto Campano', 'I682', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094051', '094', 'Vastogirardi', 'L696', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094052', '094', 'Venafro', 'L725', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094801', '094', 'Castellone al Volturno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('094802', '094', 'San Vincenzo a Volturno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095079', '095', 'Bosa', 'B068', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095080', '095', 'Flussio', 'D640', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095082', '095', 'Laconi', 'E400', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095083', '095', 'Magomadas', 'E825', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095084', '095', 'Modolo', 'F261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095085', '095', 'Montresta', 'F698', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095086', '095', 'Sagama', 'H661', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095087', '095', 'Suni', 'L006', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095088', '095', 'Tinnura', 'L172', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095001', '095', 'Abbasanta', 'A007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095002', '095', 'Aidomaggiore', 'A097', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095003', '095', 'Albagiara', 'A126', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095004', '095', 'Ales', 'A180', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095005', '095', 'Allai', 'A204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095006', '095', 'Arborea', 'A357', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095007', '095', 'Ardauli', 'A380', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095008', '095', 'Assolo', 'A477', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095009', '095', 'Asuni', 'A480', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095010', '095', 'Baradili', 'A614', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095011', '095', 'Baratili San Pietro', 'A621', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095012', '095', 'Baressa', 'A655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095013', '095', 'Bauladu', 'A721', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095014', '095', 'Bidonì', 'A856', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095015', '095', 'Bonarcado', 'A960', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095016', '095', 'Boroneddu', 'B055', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095017', '095', 'Busachi', 'B281', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095018', '095', 'Cabras', 'B314', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095019', '095', 'Cuglieri', 'D200', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095020', '095', 'Fordongianus', 'D695', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095021', '095', 'Ghilarza', 'E004', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095022', '095', 'Gonnoscodina', 'E087', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095023', '095', 'Gonnosnò', 'D585', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095024', '095', 'Gonnostramatza', 'E088', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095025', '095', 'Marrubiu', 'E972', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095026', '095', 'Masullas', 'F050', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095027', '095', 'Milis', 'F208', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095028', '095', 'Mogorella', 'F270', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095029', '095', 'Mogoro', 'F272', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095030', '095', 'Morgongiori', 'F727', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095031', '095', 'Narbolia', 'F840', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095032', '095', 'Neoneli', 'F867', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095033', '095', 'Norbello', 'F934', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095034', '095', 'Nughedu Santa Vittoria', 'F974', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095035', '095', 'Nurachi', 'F980', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095036', '095', 'Nureci', 'F985', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095037', '095', 'Ollastra', 'G043', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095038', '095', 'Oristano', 'G113', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095039', '095', 'Palmas Arborea', 'G286', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095040', '095', 'Pau', 'G379', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095041', '095', 'Paulilatino', 'G384', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095042', '095', 'Pompu', 'G817', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095043', '095', 'Riola Sardo', 'H301', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095044', '095', 'Ruinas', 'F271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095045', '095', 'Samugheo', 'H756', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095046', '095', 'San Nicolò d''Arcidano', 'A368', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095047', '095', 'Santa Giusta', 'I205', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095048', '095', 'Villa Sant''Antonio', 'I298', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095049', '095', 'Santu Lussurgiu', 'I374', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095050', '095', 'San Vero Milis', 'I384', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095051', '095', 'Scano di Montiferro', 'I503', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095052', '095', 'Sedilo', 'I564', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095053', '095', 'Seneghe', 'I605', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095054', '095', 'Senis', 'I609', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095055', '095', 'Sennariolo', 'I613', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095056', '095', 'Siamaggiore', 'I717', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095057', '095', 'Siamanna', 'I718', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095058', '095', 'Simala', 'I742', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095059', '095', 'Simaxis', 'I743', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095060', '095', 'Sini', 'I749', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095061', '095', 'Siris', 'I757', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095062', '095', 'Solarussa', 'I791', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095063', '095', 'Sorradile', 'I861', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095064', '095', 'Tadasuni', 'L023', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095065', '095', 'Terralba', 'L122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095066', '095', 'Tramatza', 'L321', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095067', '095', 'Tresnuraghes', 'L393', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095068', '095', 'Ulà Tirso', 'L488', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095069', '095', 'Uras', 'L496', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095070', '095', 'Usellus', 'L508', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095071', '095', 'Villanova Truschedu', 'L991', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095072', '095', 'Villaurbana', 'M030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095073', '095', 'Villa Verde', 'A609', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095074', '095', 'Zeddiani', 'M153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095075', '095', 'Zerfaliu', 'M168', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095076', '095', 'Siapiccia', 'I721', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095077', '095', 'Curcuris', 'D214', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095078', '095', 'Soddì', 'I778', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095801', '095', 'Domusnovas Canales', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095802', '095', 'Donigala Fenughedu', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095803', '095', 'Escovedu', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095804', '095', 'Figu', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095805', '095', 'Gonnosnò', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095806', '095', 'Massama', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095807', '095', 'Nuraxinieddu', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095808', '095', 'San Vero Congius', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095809', '095', 'Siamanna', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095810', '095', 'Silì', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095811', '095', 'Solanas', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095812', '095', 'Zeppara', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095813', '095', 'Zuri', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096085', '096', 'Lessona', 'M371', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096086', '096', 'Campiglia Cervo', 'M373', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096001', '096', 'Ailoche', 'A107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096002', '096', 'Andorno Micca', 'A280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096003', '096', 'Benna', 'A784', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096004', '096', 'Biella', 'A859', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096005', '096', 'Bioglio', 'A876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096006', '096', 'Borriana', 'B058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096007', '096', 'Brusnengo', 'B229', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096008', '096', 'Callabiana', 'B417', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096009', '096', 'Camandona', 'B457', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096010', '096', 'Camburzano', 'B465', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096011', '096', 'Campiglia Cervo', 'B508', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096012', '096', 'Candelo', 'B586', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096013', '096', 'Caprile', 'B708', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096014', '096', 'Casapinta', 'B933', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096015', '096', 'Castelletto Cervo', 'C155', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096016', '096', 'Cavaglià', 'C363', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096017', '096', 'Cerreto Castello', 'C526', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096018', '096', 'Cerrione', 'C532', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096019', '096', 'Coggiola', 'C819', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096020', '096', 'Cossato', 'D094', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096021', '096', 'Crevacuore', 'D165', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096022', '096', 'Crosa', 'D182', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096023', '096', 'Curino', 'D219', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096024', '096', 'Donato', 'D339', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096025', '096', 'Dorzano', 'D350', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096026', '096', 'Gaglianico', 'D848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096027', '096', 'Gifflenga', 'E024', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096028', '096', 'Graglia', 'E130', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096029', '096', 'Lessona', 'E552', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096030', '096', 'Magnano', 'E821', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096031', '096', 'Massazza', 'F037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096032', '096', 'Masserano', 'F042', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096033', '096', 'Mezzana Mortigliengo', 'F167', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096034', '096', 'Miagliano', 'F189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096035', '096', 'Mongrando', 'F369', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096084', '096', 'Mosso', 'M304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096037', '096', 'Mottalciata', 'F776', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096038', '096', 'Muzzano', 'F833', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096039', '096', 'Netro', 'F878', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096040', '096', 'Occhieppo Inferiore', 'F992', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096041', '096', 'Occhieppo Superiore', 'F993', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096042', '096', 'Pettinengo', 'G521', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096043', '096', 'Piatto', 'G577', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096044', '096', 'Piedicavallo', 'G594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096046', '096', 'Pollone', 'G798', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096047', '096', 'Ponderano', 'G820', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096048', '096', 'Portula', 'G927', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096049', '096', 'Pralungo', 'G980', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096050', '096', 'Pray', 'G974', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096051', '096', 'Quaregna', 'H103', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096052', '096', 'Quittengo', 'H145', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096053', '096', 'Ronco Biellese', 'H538', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096054', '096', 'Roppolo', 'H553', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096055', '096', 'Rosazza', 'H561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096056', '096', 'Sagliano Micca', 'H662', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096057', '096', 'Sala Biellese', 'H681', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096058', '096', 'Salussola', 'H726', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096060', '096', 'San Paolo Cervo', 'I074', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096059', '096', 'Sandigliano', 'H821', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096061', '096', 'Selve Marcone', 'I596', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096062', '096', 'Soprana', 'I835', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096063', '096', 'Sordevolo', 'I847', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096064', '096', 'Sostegno', 'I868', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096065', '096', 'Strona', 'I980', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096066', '096', 'Tavigliano', 'L075', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096067', '096', 'Ternengo', 'L116', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096068', '096', 'Tollegno', 'L193', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096069', '096', 'Torrazzo', 'L239', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096070', '096', 'Trivero', 'L436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096071', '096', 'Valdengo', 'L556', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096072', '096', 'Vallanzengo', 'L586', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096073', '096', 'Valle Mosso', 'L606', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096074', '096', 'Valle San Nicolao', 'L620', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096075', '096', 'Veglio', 'L712', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096076', '096', 'Verrone', 'L785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096077', '096', 'Vigliano Biellese', 'L880', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096078', '096', 'Villa del Bosco', 'L933', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096079', '096', 'Villanova Biellese', 'L978', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096080', '096', 'Viverone', 'M098', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096081', '096', 'Zimone', 'M179', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096082', '096', 'Zubiena', 'M196', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096083', '096', 'Zumaglia', 'M201', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096036', '096', 'Mosso Santa Maria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('096045', '096', 'Pistolesa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097001', '097', 'Abbadia Lariana', 'A005', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097002', '097', 'Airuno', 'A112', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097003', '097', 'Annone di Brianza', 'A301', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097004', '097', 'Ballabio', 'A594', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097005', '097', 'Barzago', 'A683', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097006', '097', 'Barzanò', 'A686', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097007', '097', 'Barzio', 'A687', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097008', '097', 'Bellano', 'A745', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097009', '097', 'Bosisio Parini', 'B081', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097010', '097', 'Brivio', 'B194', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097011', '097', 'Bulciago', 'B261', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097012', '097', 'Calco', 'B396', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097013', '097', 'Calolziocorte', 'B423', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097014', '097', 'Carenno', 'B763', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097015', '097', 'Casargo', 'B937', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097016', '097', 'Casatenovo', 'B943', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097017', '097', 'Cassago Brianza', 'B996', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097018', '097', 'Cassina Valsassina', 'C024', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097019', '097', 'Castello di Brianza', 'C187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097020', '097', 'Cernusco Lombardone', 'C521', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097021', '097', 'Cesana Brianza', 'C563', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097022', '097', 'Civate', 'C752', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097023', '097', 'Colico', 'C839', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097024', '097', 'Colle Brianza', 'C851', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097025', '097', 'Cortenova', 'D065', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097026', '097', 'Costa Masnaga', 'D112', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097027', '097', 'Crandola Valsassina', 'D131', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097028', '097', 'Cremella', 'D143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097029', '097', 'Cremeno', 'D145', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097030', '097', 'Dervio', 'D280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097031', '097', 'Dolzago', 'D327', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097032', '097', 'Dorio', 'D346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097033', '097', 'Ello', 'D398', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097034', '097', 'Erve', 'D428', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097035', '097', 'Esino Lario', 'D436', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097036', '097', 'Galbiate', 'D865', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097037', '097', 'Garbagnate Monastero', 'D913', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097038', '097', 'Garlate', 'D926', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097039', '097', 'Imbersago', 'E287', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097040', '097', 'Introbio', 'E305', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097041', '097', 'Introzzo', 'E308', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097042', '097', 'Lecco', 'E507', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097043', '097', 'Lierna', 'E581', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097044', '097', 'Lomagna', 'E656', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097045', '097', 'Malgrate', 'E858', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097046', '097', 'Mandello del Lario', 'E879', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097047', '097', 'Margno', 'E947', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097048', '097', 'Merate', 'F133', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097049', '097', 'Missaglia', 'F248', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097050', '097', 'Moggio', 'F265', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097051', '097', 'Molteno', 'F304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097052', '097', 'Monte Marenzo', 'F561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097053', '097', 'Montevecchia', 'F657', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097054', '097', 'Monticello Brianza', 'F674', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097055', '097', 'Morterone', 'F758', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097056', '097', 'Nibionno', 'F887', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097057', '097', 'Oggiono', 'G009', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097058', '097', 'Olgiate Molgora', 'G026', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097059', '097', 'Olginate', 'G030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097060', '097', 'Oliveto Lario', 'G040', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097061', '097', 'Osnago', 'G161', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097062', '097', 'Paderno d''Adda', 'G218', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097063', '097', 'Pagnona', 'G241', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097064', '097', 'Parlasco', 'G336', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097065', '097', 'Pasturo', 'G368', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097066', '097', 'Perego', 'G448', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097067', '097', 'Perledo', 'G456', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097068', '097', 'Pescate', 'G485', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097069', '097', 'Premana', 'H028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097070', '097', 'Primaluna', 'H063', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097071', '097', 'Robbiate', 'G223', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097072', '097', 'Rogeno', 'H486', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097073', '097', 'Rovagnate', 'H596', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097074', '097', 'Santa Maria Hoè', 'I243', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097075', '097', 'Sirone', 'I759', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097076', '097', 'Sirtori', 'I761', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097077', '097', 'Sueglio', 'I994', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097078', '097', 'Suello', 'I996', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097079', '097', 'Taceno', 'L022', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097081', '097', 'Tremenico', 'L368', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097082', '097', 'Valgreghentino', 'L581', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097083', '097', 'Valmadrera', 'L634', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097084', '097', 'Varenna', 'L680', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097085', '097', 'Vendrogno', 'L731', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097086', '097', 'Vercurago', 'L751', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097087', '097', 'Verderio Inferiore', 'L755', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097088', '097', 'Verderio Superiore', 'L756', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097089', '097', 'Vestreno', 'L813', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097090', '097', 'Viganò', 'L866', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097091', '097', 'Verderio', 'M337', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097092', '097', 'La Valletta Brianza', 'M348', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('097093', '097', 'Valvarrone', 'M395', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098001', '098', 'Abbadia Cerreto', 'A004', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098002', '098', 'Bertonico', 'A811', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098003', '098', 'Boffalora d''Adda', 'A919', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098004', '098', 'Borghetto Lodigiano', 'A995', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098005', '098', 'Borgo San Giovanni', 'B017', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098006', '098', 'Brembio', 'B141', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098007', '098', 'Camairago', 'B456', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098008', '098', 'Casaletto Lodigiano', 'B887', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098009', '098', 'Casalmaiocco', 'B899', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098010', '098', 'Casalpusterlengo', 'B910', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098011', '098', 'Caselle Landi', 'B961', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098012', '098', 'Caselle Lurani', 'B958', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098013', '098', 'Castelnuovo Bocca d''Adda', 'C228', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098014', '098', 'Castiglione d''Adda', 'C304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098015', '098', 'Castiraga Vidardo', 'C329', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098016', '098', 'Cavacurta', 'C362', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098017', '098', 'Cavenago d''Adda', 'C394', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098018', '098', 'Cervignano d''Adda', 'C555', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098019', '098', 'Codogno', 'C816', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098020', '098', 'Comazzo', 'C917', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098021', '098', 'Cornegliano Laudense', 'D021', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098022', '098', 'Corno Giovine', 'D028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098023', '098', 'Cornovecchio', 'D029', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098024', '098', 'Corte Palasio', 'D068', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098025', '098', 'Crespiatica', 'D159', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098026', '098', 'Fombio', 'D660', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098027', '098', 'Galgagnano', 'D868', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098028', '098', 'Graffignana', 'E127', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098029', '098', 'Guardamiglio', 'E238', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098030', '098', 'Livraga', 'E627', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098031', '098', 'Lodi', 'E648', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098032', '098', 'Lodi Vecchio', 'E651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098033', '098', 'Maccastorna', 'E777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098034', '098', 'Mairago', 'E840', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098035', '098', 'Maleo', 'E852', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098036', '098', 'Marudo', 'E994', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098037', '098', 'Massalengo', 'F028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098038', '098', 'Meleti', 'F102', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098039', '098', 'Merlino', 'F149', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098040', '098', 'Montanaso Lombardo', 'F423', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098041', '098', 'Mulazzano', 'F801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098042', '098', 'Orio Litta', 'G107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098043', '098', 'Ospedaletto Lodigiano', 'G166', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098044', '098', 'Ossago Lodigiano', 'G171', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098045', '098', 'Pieve Fissiraga', 'G096', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098046', '098', 'Salerano sul Lambro', 'H701', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098047', '098', 'San Fiorano', 'H844', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098048', '098', 'San Martino in Strada', 'I012', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098049', '098', 'San Rocco al Porto', 'I140', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098050', '098', 'Sant''Angelo Lodigiano', 'I274', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098051', '098', 'Santo Stefano Lodigiano', 'I362', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098052', '098', 'Secugnago', 'I561', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098053', '098', 'Senna Lodigiana', 'I612', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098054', '098', 'Somaglia', 'I815', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098055', '098', 'Sordio', 'I848', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098056', '098', 'Tavazzano con Villavesco', 'F260', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098057', '098', 'Terranova dei Passerini', 'L125', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098058', '098', 'Turano Lodigiano', 'L469', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098059', '098', 'Valera Fratta', 'L572', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098060', '098', 'Villanova del Sillaro', 'L977', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098061', '098', 'Zelo Buon Persico', 'M158', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('098062', '098', 'Castelgerundo', 'M393', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099001', '099', 'Bellaria-Igea Marina', 'A747', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099002', '099', 'Cattolica', 'C357', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099003', '099', 'Coriano', 'D004', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099004', '099', 'Gemmano', 'D961', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099005', '099', 'Misano Adriatico', 'F244', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099006', '099', 'Mondaino', 'F346', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099007', '099', 'Monte Colombo', 'F476', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099008', '099', 'Montefiore Conca', 'F502', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099009', '099', 'Montegridolfo', 'F523', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099010', '099', 'Montescudo', 'F641', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099011', '099', 'Morciano di Romagna', 'F715', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099012', '099', 'Poggio Berni', 'G755', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099013', '099', 'Riccione', 'H274', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099014', '099', 'Rimini', 'H294', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099015', '099', 'Saludecio', 'H724', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099016', '099', 'San Clemente', 'H801', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099017', '099', 'San Giovanni in Marignano', 'H921', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099018', '099', 'Santarcangelo di Romagna', 'I304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099019', '099', 'Torriana', 'I550', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099020', '099', 'Verucchio', 'L797', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099029', '099', 'Montescudo-Monte Colombo', 'M368', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099023', '099', 'Novafeltria', 'F137', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099024', '099', 'Pennabilli', 'G433', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099025', '099', 'San Leo', 'H949', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099026', '099', 'Sant''Agata Feltria', 'I201', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099027', '099', 'Talamello', 'L034', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099028', '099', 'Poggio Torriana', 'M324', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099021', '099', 'Casteldelci', 'C080', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('099022', '099', 'Maiolo', 'E838', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('100001', '100', 'Cantagallo', 'B626', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('100002', '100', 'Carmignano', 'B794', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('100003', '100', 'Montemurlo', 'F572', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('100004', '100', 'Poggio a Caiano', 'G754', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('100005', '100', 'Prato', 'G999', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('100006', '100', 'Vaiano', 'L537', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('100007', '100', 'Vernio', 'L775', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101001', '101', 'Belvedere di Spinello', 'A772', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101002', '101', 'Caccuri', 'B319', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101003', '101', 'Carfizzi', 'B771', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101004', '101', 'Casabona', 'B857', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101005', '101', 'Castelsilano', 'B968', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101006', '101', 'Cerenzia', 'C501', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101007', '101', 'Cirò', 'C725', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101008', '101', 'Cirò Marina', 'C726', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101009', '101', 'Cotronei', 'D123', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101010', '101', 'Crotone', 'D122', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101011', '101', 'Crucoli', 'D189', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101012', '101', 'Cutro', 'D236', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101013', '101', 'Isola di Capo Rizzuto', 'E339', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101014', '101', 'Melissa', 'F108', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101015', '101', 'Mesoraca', 'F157', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101016', '101', 'Pallagorio', 'G278', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101017', '101', 'Petilia Policastro', 'G508', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101019', '101', 'Rocca di Neto', 'H403', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101018', '101', 'Roccabernarda', 'H383', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101020', '101', 'San Mauro Marchesato', 'I026', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101021', '101', 'San Nicola dell''Alto', 'I057', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101022', '101', 'Santa Severina', 'I308', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101023', '101', 'Savelli', 'I468', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101024', '101', 'Scandale', 'I494', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101025', '101', 'Strongoli', 'I982', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101026', '101', 'Umbriatico', 'L492', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('101027', '101', 'Verzino', 'L802', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102001', '102', 'Acquaro', 'A043', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102002', '102', 'Arena', 'A386', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102003', '102', 'Briatico', 'B169', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102004', '102', 'Brognaturo', 'B197', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102005', '102', 'Capistrano', 'B655', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102006', '102', 'Cessaniti', 'C581', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102007', '102', 'Dasà', 'D253', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102008', '102', 'Dinami', 'D303', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102009', '102', 'Drapia', 'D364', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102010', '102', 'Fabrizia', 'D453', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102011', '102', 'Filadelfia', 'D587', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102012', '102', 'Filandari', 'D589', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102013', '102', 'Filogaso', 'D596', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102014', '102', 'Francavilla Angitola', 'D762', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102015', '102', 'Francica', 'D767', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102016', '102', 'Gerocarne', 'D988', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102017', '102', 'Ionadi', 'E321', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102018', '102', 'Joppolo', 'E389', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102019', '102', 'Limbadi', 'E590', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102020', '102', 'Maierato', 'E836', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102021', '102', 'Mileto', 'F207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102022', '102', 'Mongiana', 'F364', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102023', '102', 'Monterosso Calabro', 'F607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102024', '102', 'Nardodipace', 'F843', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102025', '102', 'Nicotera', 'F893', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102026', '102', 'Parghelia', 'G335', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102027', '102', 'Pizzo', 'G722', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102028', '102', 'Pizzoni', 'G728', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102029', '102', 'Polia', 'G785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102030', '102', 'Ricadi', 'H271', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102031', '102', 'Rombiolo', 'H516', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102032', '102', 'San Calogero', 'H785', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102033', '102', 'San Costantino Calabro', 'H807', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102034', '102', 'San Gregorio d''Ippona', 'H941', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102035', '102', 'San Nicola da Crissa', 'I058', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102036', '102', 'Sant''Onofrio', 'I350', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102037', '102', 'Serra San Bruno', 'I639', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102038', '102', 'Simbario', 'I744', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102039', '102', 'Sorianello', 'I853', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102040', '102', 'Soriano Calabro', 'I854', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102041', '102', 'Spadola', 'I884', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102042', '102', 'Spilinga', 'I905', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102043', '102', 'Stefanaconi', 'I945', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102044', '102', 'Tropea', 'L452', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102045', '102', 'Vallelonga', 'L607', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102046', '102', 'Vazzano', 'L699', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102047', '102', 'Vibo Valentia', 'F537', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102048', '102', 'Zaccanopoli', 'M138', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102049', '102', 'Zambrone', 'M143', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('102050', '102', 'Zungri', 'M204', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103001', '103', 'Antrona Schieranco', 'A317', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103002', '103', 'Anzola d''Ossola', 'A325', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103003', '103', 'Arizzano', 'A409', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103004', '103', 'Arola', 'A427', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103005', '103', 'Aurano', 'A497', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103006', '103', 'Baceno', 'A534', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103007', '103', 'Bannio Anzino', 'A610', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103008', '103', 'Baveno', 'A725', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103009', '103', 'Bee', 'A733', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103010', '103', 'Belgirate', 'A742', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103011', '103', 'Beura-Cardezza', 'A834', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103012', '103', 'Bognanco', 'A925', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103013', '103', 'Brovello-Carpugnino', 'B207', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103014', '103', 'Calasca-Castiglione', 'B380', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103015', '103', 'Cambiasca', 'B463', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103016', '103', 'Cannero Riviera', 'B610', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103017', '103', 'Cannobio', 'B615', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103018', '103', 'Caprezzo', 'B694', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103019', '103', 'Casale Corte Cerro', 'B876', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103020', '103', 'Cavaglio-Spoccia', 'C367', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103021', '103', 'Ceppo Morelli', 'C478', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103022', '103', 'Cesara', 'C567', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103023', '103', 'Cossogno', 'D099', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103024', '103', 'Craveggia', 'D134', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103025', '103', 'Crevoladossola', 'D168', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103026', '103', 'Crodo', 'D177', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103027', '103', 'Cursolo-Orasso', 'D225', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103028', '103', 'Domodossola', 'D332', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103029', '103', 'Druogno', 'D374', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103030', '103', 'Falmenta', 'D481', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103031', '103', 'Formazza', 'D706', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103032', '103', 'Germagno', 'D984', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103033', '103', 'Ghiffa', 'E003', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103034', '103', 'Gignese', 'E028', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103035', '103', 'Gravellona Toce', 'E153', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103036', '103', 'Gurro', 'E269', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103037', '103', 'Intragna', 'E304', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103038', '103', 'Loreglia', 'E685', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103039', '103', 'Macugnaga', 'E790', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103040', '103', 'Madonna del Sasso', 'E795', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103041', '103', 'Malesco', 'E853', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103042', '103', 'Masera', 'F010', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103043', '103', 'Massiola', 'F048', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103044', '103', 'Mergozzo', 'F146', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103045', '103', 'Miazzina', 'F192', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103046', '103', 'Montecrestese', 'F483', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103047', '103', 'Montescheno', 'F639', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103048', '103', 'Nonio', 'F932', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103049', '103', 'Oggebbio', 'G007', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103050', '103', 'Omegna', 'G062', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103051', '103', 'Ornavasso', 'G117', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103052', '103', 'Pallanzeno', 'G280', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103053', '103', 'Piedimulera', 'G600', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103054', '103', 'Pieve Vergonte', 'G658', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103055', '103', 'Premeno', 'H030', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103056', '103', 'Premia', 'H033', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103057', '103', 'Premosello-Chiovenda', 'H037', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103058', '103', 'Quarna Sopra', 'H106', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103059', '103', 'Quarna Sotto', 'H107', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103060', '103', 'Re', 'H203', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103061', '103', 'San Bernardino Verbano', 'H777', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103062', '103', 'Santa Maria Maggiore', 'I249', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103063', '103', 'Seppiana', 'I619', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103064', '103', 'Stresa', 'I976', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103065', '103', 'Toceno', 'L187', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103066', '103', 'Trarego Viggiona', 'L333', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103067', '103', 'Trasquera', 'L336', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103068', '103', 'Trontano', 'L450', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103069', '103', 'Valstrona', 'L651', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103070', '103', 'Vanzone con San Carlo', 'L666', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103071', '103', 'Varzo', 'L691', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103072', '103', 'Verbania', 'L746', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103073', '103', 'Viganella', 'L864', '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103074', '103', 'Vignone', 'L889', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103075', '103', 'Villadossola', 'L906', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103076', '103', 'Villette', 'M042', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103077', '103', 'Vogogna', 'M111', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('103078', '103', 'Borgomezzavalle', 'M370', NULL);
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108001', '108', 'Agrate Brianza', 'A087', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108002', '108', 'Aicurzio', 'A096', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108003', '108', 'Albiate', 'A159', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108004', '108', 'Arcore', 'A376', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108005', '108', 'Barlassina', 'A668', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108006', '108', 'Bellusco', 'A759', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108007', '108', 'Bernareggio', 'A802', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108008', '108', 'Besana in Brianza', 'A818', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108009', '108', 'Biassono', 'A849', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108010', '108', 'Bovisio-Masciago', 'B105', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108011', '108', 'Briosco', 'B187', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108012', '108', 'Brugherio', 'B212', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108013', '108', 'Burago di Molgora', 'B272', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108014', '108', 'Camparada', 'B501', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108015', '108', 'Carate Brianza', 'B729', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108016', '108', 'Carnate', 'B798', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108017', '108', 'Cavenago di Brianza', 'C395', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108018', '108', 'Ceriano Laghetto', 'C512', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108019', '108', 'Cesano Maderno', 'C566', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108020', '108', 'Cogliate', 'C820', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108021', '108', 'Concorezzo', 'C952', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108022', '108', 'Correzzana', 'D038', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108023', '108', 'Desio', 'D286', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108024', '108', 'Giussano', 'E063', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108025', '108', 'Lazzate', 'E504', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108026', '108', 'Lesmo', 'E550', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108027', '108', 'Limbiate', 'E591', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108028', '108', 'Lissone', 'E617', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108029', '108', 'Macherio', 'E786', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108030', '108', 'Meda', 'F078', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108031', '108', 'Mezzago', 'F165', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108032', '108', 'Misinto', 'F247', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108033', '108', 'Monza', 'F704', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108034', '108', 'Muggiò', 'F797', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108035', '108', 'Nova Milanese', 'F944', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108036', '108', 'Ornago', 'G116', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108037', '108', 'Renate', 'H233', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108038', '108', 'Ronco Briantino', 'H537', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108039', '108', 'Seregno', 'I625', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108040', '108', 'Seveso', 'I709', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108041', '108', 'Sovico', 'I878', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108042', '108', 'Sulbiate', 'I998', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108043', '108', 'Triuggio', 'L434', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108044', '108', 'Usmate Velate', 'L511', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108045', '108', 'Varedo', 'L677', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108046', '108', 'Vedano al Lambro', 'L704', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108047', '108', 'Veduggio con Colzano', 'L709', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108048', '108', 'Verano Brianza', 'L744', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108049', '108', 'Villasanta', 'M017', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108050', '108', 'Vimercate', 'M052', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108051', '108', 'Busnago', 'B289', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108052', '108', 'Caponago', 'B671', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108053', '108', 'Cornate d''Adda', 'D019', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108054', '108', 'Lentate sul Seveso', 'E530', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('108055', '108', 'Roncello', 'H529', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110001', '109', 'Andria', 'A285', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110002', '109', 'Barletta', 'A669', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110003', '109', 'Bisceglie', 'A883', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110004', '109', 'Canosa di Puglia', 'B619', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110005', '109', 'Margherita di Savoia', 'E946', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110006', '109', 'Minervino Murge', 'F220', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110007', '109', 'San Ferdinando di Puglia', 'H839', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110008', '109', 'Spinazzola', 'I907', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110009', '109', 'Trani', 'L328', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('110010', '109', 'Trinitapoli', 'B915', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109001', '110', 'Altidona', 'A233', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109002', '110', 'Amandola', 'A252', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109003', '110', 'Belmonte Piceno', 'A760', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109004', '110', 'Campofilone', 'B534', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109005', '110', 'Falerone', 'D477', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109006', '110', 'Fermo', 'D542', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109007', '110', 'Francavilla d''Ete', 'D760', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109008', '110', 'Grottazzolina', 'E208', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109009', '110', 'Lapedona', 'E447', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109010', '110', 'Magliano di Tenna', 'E807', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109011', '110', 'Massa Fermana', 'F021', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109012', '110', 'Monsampietro Morico', 'F379', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109013', '110', 'Montappone', 'F428', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109014', '110', 'Montefalcone Appennino', 'F493', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109015', '110', 'Montefortino', 'F509', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109016', '110', 'Monte Giberto', 'F517', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109017', '110', 'Montegiorgio', 'F520', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109018', '110', 'Montegranaro', 'F522', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109019', '110', 'Monteleone di Fermo', 'F536', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109020', '110', 'Montelparo', 'F549', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109021', '110', 'Monte Rinaldo', 'F599', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109022', '110', 'Monterubbiano', 'F614', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109023', '110', 'Monte San Pietrangeli', 'F626', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109024', '110', 'Monte Urano', 'F653', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109025', '110', 'Monte Vidon Combatte', 'F664', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109026', '110', 'Monte Vidon Corrado', 'F665', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109027', '110', 'Montottone', 'F697', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109028', '110', 'Moresco', 'F722', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109029', '110', 'Ortezzano', 'G137', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109030', '110', 'Pedaso', 'G403', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109031', '110', 'Petritoli', 'G516', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109032', '110', 'Ponzano di Fermo', 'G873', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109033', '110', 'Porto San Giorgio', 'G920', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109034', '110', 'Porto Sant''Elpidio', 'G921', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109035', '110', 'Rapagnano', 'H182', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109036', '110', 'Santa Vittoria in Matenano', 'I315', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109037', '110', 'Sant''Elpidio a Mare', 'I324', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109038', '110', 'Servigliano', 'C070', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109039', '110', 'Smerillo', 'I774', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('109040', '110', 'Torre San Patrizio', 'L279', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092110', '111', 'Escalaplano', 'D430', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092111', '111', 'Escolca', 'D431', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092112', '111', 'Esterzili', 'D443', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092113', '111', 'Gergei', 'D982', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092114', '111', 'Isili', 'E336', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092115', '111', 'Nuragus', 'F981', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092116', '111', 'Nurallao', 'F982', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092117', '111', 'Nurri', 'F986', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092118', '111', 'Orroli', 'G122', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092119', '111', 'Sadali', 'H659', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092120', '111', 'Serri', 'I668', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092121', '111', 'Seulo', 'I707', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092122', '111', 'Villanova Tulo', 'L992', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092002', '111', 'Armungia', 'A419', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092004', '111', 'Ballao', 'A597', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092005', '111', 'Barrali', 'A677', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092008', '111', 'Burcei', 'B274', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092016', '111', 'Decimoputzu', 'D260', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092017', '111', 'Dolianova', 'D323', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092018', '111', 'Domus de Maria', 'D333', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092020', '111', 'Donori', 'D344', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092024', '111', 'Gesico', 'D994', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092027', '111', 'Goni', 'E084', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092030', '111', 'Guamaggiore', 'E234', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092031', '111', 'Guasila', 'E252', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092036', '111', 'Mandas', 'E877', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092038', '111', 'Monastir', 'F333', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092039', '111', 'Muravera', 'F808', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092042', '111', 'Nuraminis', 'F983', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092044', '111', 'Ortacesus', 'G133', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092048', '111', 'Pimentel', 'G669', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092053', '111', 'Samatzai', 'H739', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092054', '111', 'San Basilio', 'H766', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092058', '111', 'San Nicolò Gerrei', 'G383', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092059', '111', 'San Sperate', 'I166', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092061', '111', 'Sant''Andrea Frius', 'I271', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092064', '111', 'San Vito', 'I402', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092069', '111', 'Selegas', 'I582', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092070', '111', 'Senorbì', 'I615', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092071', '111', 'Serdiana', 'I624', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092078', '111', 'Siliqua', 'I734', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092079', '111', 'Silius', 'I735', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092081', '111', 'Siurgus Donigala', 'I765', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092082', '111', 'Soleminis', 'I797', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092083', '111', 'Suelli', 'I995', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092084', '111', 'Teulada', 'L154', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092088', '111', 'Ussana', 'L512', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092091', '111', 'Vallermosa', 'L613', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092097', '111', 'Villaputzu', 'L998', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092098', '111', 'Villasalto', 'M016', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092100', '111', 'Villasimius', 'B738', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092101', '111', 'Villasor', 'M025', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092102', '111', 'Villaspeciosa', 'M026', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('092106', '111', 'Castiadas', 'M288', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('095081', '111', 'Genoni', 'D968', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('105015', '111', 'Seui', 'I706', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106001', '111', 'Arbus', 'A359', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106002', '111', 'Barumini', 'A681', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106003', '111', 'Collinas', 'C882', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106004', '111', 'Furtei', 'D827', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106005', '111', 'Genuri', 'D970', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106006', '111', 'Gesturi', 'D997', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106007', '111', 'Gonnosfanadiga', 'E085', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106008', '111', 'Guspini', 'E270', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106009', '111', 'Las Plassas', 'E464', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106010', '111', 'Lunamatrona', 'E742', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106011', '111', 'Pabillonis', 'G207', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106012', '111', 'Pauli Arbarei', 'G382', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106013', '111', 'Samassi', 'H738', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106014', '111', 'San Gavino Monreale', 'H856', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106015', '111', 'Sanluri', 'H974', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106016', '111', 'Sardara', 'I428', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106017', '111', 'Segariu', 'I570', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106018', '111', 'Serramanna', 'I647', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106019', '111', 'Serrenti', 'I667', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106020', '111', 'Setzu', 'I705', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106021', '111', 'Siddi', 'I724', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106022', '111', 'Tuili', 'L463', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106023', '111', 'Turri', 'L473', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106024', '111', 'Ussaramanna', 'L513', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106025', '111', 'Villacidro', 'L924', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106026', '111', 'Villamar', 'L966', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106027', '111', 'Villanovaforru', 'L986', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('106028', '111', 'Villanovafranca', 'L987', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107001', '111', 'Buggerru', 'B250', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107002', '111', 'Calasetta', 'B383', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107003', '111', 'Carbonia', 'B745', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107004', '111', 'Carloforte', 'B789', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107005', '111', 'Domusnovas', 'D334', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107006', '111', 'Fluminimaggiore', 'D639', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107007', '111', 'Giba', 'E022', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107008', '111', 'Gonnesa', 'E086', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107009', '111', 'Iglesias', 'E281', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107011', '111', 'Musei', 'F822', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107012', '111', 'Narcao', 'F841', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107013', '111', 'Nuxis', 'F991', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107014', '111', 'Perdaxius', 'G446', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107016', '111', 'Portoscuso', 'G922', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107017', '111', 'San Giovanni Suergiu', 'G287', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107018', '111', 'Santadi', 'I182', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107019', '111', 'Sant''Anna Arresi', 'M209', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107020', '111', 'Sant''Antioco', 'I294', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107021', '111', 'Tratalias', 'L337', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107022', '111', 'Villamassargia', 'L968', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107010', '111', 'Masainas', 'M270', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107023', '111', 'Villaperuccio', 'M278', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('107015', '111', 'Piscinas', 'M291', '0');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701701', '701', 'Abbazia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701702', '701', 'Castel Iablanizza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701703', '701', 'Castelnuovo d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701704', '701', 'Clana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701705', '701', 'Elsane', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701706', '701', 'Fiume', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701707', '701', 'Fontana del Conte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701708', '701', 'Laurana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701709', '701', 'Matteria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701710', '701', 'Mattuglie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701711', '701', 'Valsantamarina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701712', '701', 'Primano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701714', '701', 'Villa del Nevoso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701801', '701', 'Apriano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701802', '701', 'Berdo San Giovanni', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701803', '701', 'Bersezio del Quarnaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701804', '701', 'Bisterza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701805', '701', 'Ceglie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701806', '701', 'Monte Chilovi', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701807', '701', 'Retacevo in Monte', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701808', '701', 'Sagoria San Martino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701809', '701', 'Smeria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701810', '701', 'Torrenova di Bisterza', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('701811', '701', 'Volosca-Abbazia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702701', '702', 'Albona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702702', '702', 'Antignana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702703', '702', 'Arsia', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702704', '702', 'Barbana d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702705', '702', 'Bogliuno', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702706', '702', 'Brioni Maggiore', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702707', '702', 'Buie d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702708', '702', 'Canfanaro', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702709', '702', 'Capodistria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702710', '702', 'Cherso', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702711', '702', 'Cittanova d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702712', '702', 'Dignano d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702713', '702', 'Erpelle-Cosina', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702714', '702', 'Fianona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702715', '702', 'Gimino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702716', '702', 'Grisignana', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702717', '702', 'Isola d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702718', '702', 'Lanischie', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702719', '702', 'Lussingrande', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702720', '702', 'Lussinpiccolo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702721', '702', 'Maresego', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702722', '702', 'Monte di Capodistria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702723', '702', 'Montona', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702724', '702', 'Neresine', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702725', '702', 'Orsera', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702726', '702', 'Ossero', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702727', '702', 'Parenzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702728', '702', 'Pinguente', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702729', '702', 'Pirano', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702730', '702', 'Pisino', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702731', '702', 'Pola', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702732', '702', 'Portole', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702733', '702', 'Rovigno d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702734', '702', 'Rozzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702735', '702', 'Sanvincenti', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702736', '702', 'Umago', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702737', '702', 'Valdarsa', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702738', '702', 'Valle d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702739', '702', 'Verteneglio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702740', '702', 'Villa Decani', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702741', '702', 'Visignano d''Istria', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702742', '702', 'Visinada', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702801', '702', 'Draguccio', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('702802', '702', 'Occisla-Clanzo', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('703701', '703', 'Lagosta', NULL, '1');
INSERT INTO COMUNE (IDCOMUNE, IDPROVINCIA, DENOMINAZIONE, CODCATASTALE, SOPPRESSO) VALUES ('703702', '703', 'Zara', NULL, '1');

COMMIT WORK;


INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('1', 'Alto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('2', 'Alveo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('3', 'Alzaia', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('4', 'Androna', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('5', 'Angiporto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('6', 'Angolo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('7', 'Arco', 'Arco', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('8', 'Autostrada', 'Autost.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('9', 'Baia', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('10', 'Baluardo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('11', 'Banchina', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('12', 'Barbaria', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('13', 'Bastioni', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('14', 'Biri', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('15', 'Bivio', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('16', 'Bocca De', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('17', 'Borgata', 'Bo.ta', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('18', 'Borgo', 'B.go', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('19', 'Borgoloco', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('20', 'Brigata', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('21', 'Calata', 'Calata', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('22', 'Calle', 'Calle', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('23', 'Calle Larga', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('24', 'Calleselle', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('25', 'Campazzo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('26', 'Campiello', 'Camp.lo', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('27', 'Campo', 'Campo', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('28', 'Canale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('29', 'Canto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('30', 'Cantone', 'Cantone', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('31', 'Casale', 'Casale', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('32', 'Cascina', 'Casc.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('33', 'Casella Postale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('34', 'Cavalcavia', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('35', 'Cavoncello', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('36', 'Cavone', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('37', 'Chiasso', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('38', 'Circonvallazione', 'Circ.ne', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('39', 'Contra''', 'Contra''', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('40', 'Contrada', 'C.da', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('41', 'Corso', 'C.so', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('42', 'Corso', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('43', 'Corte', 'Corte', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('44', 'Corticella', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('45', 'Cortile', 'C.le', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('46', 'Cortina', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('47', 'Costa', 'Costa', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('48', 'Crocevia', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('49', 'Crosera', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('50', 'Cupa', 'Cupa', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('51', 'Cupa Vicinale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('52', 'Darsena', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('53', 'Discesa', 'Disc.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('54', 'Emiciclo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('55', 'Erta', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('56', 'Fondaco', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('57', 'Fondamenta', 'Fondam.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('58', 'Fondamente Nuove', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('59', 'Fondo', 'Fondo', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('60', 'Foro', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('61', 'Fossa', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('62', 'Fosso', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('63', 'Frazione', 'Fraz.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('64', 'Galleria', 'Gall.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('65', 'Giardini', 'Giard.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('66', 'Gradini', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('67', 'Gradoni', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('68', 'Grande Raccordo Anulare', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('69', 'Interrato', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('70', 'Isola', 'Isola', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('71', 'Larghetto', 'Larg.to', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('72', 'Largo', 'L.go', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('73', 'Largo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('74', 'Lista', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('75', 'Lista Vecchia', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('76', 'Localita''', 'Loc.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('77', 'Logge', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('78', 'Loggetta', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('79', 'Lungadige', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('80', 'Lungargine', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('81', 'Lungarno', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('82', 'Lungo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('83', 'Lungolago', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('84', 'Lungomare', 'L.mare', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('85', 'Lungotevere', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('86', 'Lungotorrente', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('87', 'Marittima', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('88', 'Marzaria', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('89', 'Masseria', 'Masseria', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('90', 'Mercati Generali', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('91', 'Mercato', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('92', 'Mercerie', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('93', 'Molo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('94', 'Monte', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('95', 'Murazzi', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('96', 'Paludo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('97', 'Parco', 'P.co', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('98', 'Passaggio', 'Pass.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('99', 'Passeggiata', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('100', 'Passo', 'P.so', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('101', 'Pendice', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('102', 'Pendino', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('103', 'Penninata', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('104', 'Pescaria', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('105', 'Piano', 'Piano', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('106', 'Piazza', 'P.za', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('107', 'Piazzale', 'P.le', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('108', 'Piazzata', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('109', 'Piazzetta', 'P.tta', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('110', 'Piazzola', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('111', 'Piscina', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('112', 'Ponte', 'P.te', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('113', 'Pontile', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('114', 'Porta', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('115', 'Porticato', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('116', 'Portici', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('117', 'Portico', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('118', 'Porto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('119', 'Presso', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('120', 'Prolungamento', 'Prolung.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('121', 'Quadrivio', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('122', 'Quartiere', 'Q.re', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('123', 'Raccordo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('124', 'Ramo', 'Ramo', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('125', 'Rampa', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('126', 'Rampante', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('127', 'Rampa', 'Rampa', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('128', 'Regione', 'Reg.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('129', 'Rialto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('130', 'Rigaste', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('131', 'Rio', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('132', 'Rio Tera''', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('133', 'Rione', 'Rne', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('134', 'Ripa', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('135', 'Riparto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('136', 'Riva', 'Riva', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('137', 'Rivale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('138', 'Riviera', 'Riv.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('139', 'Rotabile', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('140', 'Rotonda', 'Rot.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('141', 'Rua', 'Rua', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('142', 'Rue', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('143', 'Ruga', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('144', 'Ruga Giuffa', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('145', 'Ruga Vecchia', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('146', 'Rughetta', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('147', 'Sacca', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('148', 'Salita', 'Sal.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('149', 'Salizada', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('150', 'Salizzade', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('151', 'Sbarcatoio', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('152', 'Scala', 'Sc.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('153', 'Scala Privata', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('154', 'Scale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('155', 'Scali', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('156', 'Scalinata', 'Scalin.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('157', 'Sdrucciolo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('158', 'Secco', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('159', 'Sestiere', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('160', 'Silos', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('161', 'Sito', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('162', 'Sottopassaggio', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('163', 'Sottoportico', 'S.Portico', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('164', 'Spadaria', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('165', 'Spalto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('166', 'Stazione', 'Staz.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('167', 'Strada', 'S.da', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('168', 'Strada Comunale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('169', 'Strada Nuova', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('170', 'Strada Privata', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('171', 'Strada Provinciale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('172', 'Strada Statale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('173', 'Strada Vecchia', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('174', 'Strada Vicinale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('175', 'Stradale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('176', 'Stradello', 'St.llo', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('177', 'Stradetta', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('178', 'Stradone', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('179', 'Stretto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('180', 'Strettoia', 'Strett.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('181', 'Strettola', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('182', 'Supportico', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('183', 'Tondo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('184', 'Traghetto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('185', 'Tratto', 'Tratto', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('186', 'Traversa', 'Trav.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('187', 'Traversa Nuova', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('188', 'Traversa Privata', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('189', 'Traversa Vicinale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('190', 'Vallone', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('191', 'Varco', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('192', 'Via', 'Via', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('193', 'Via Comunale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('194', 'Via Nuova', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('195', 'Via Privata', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('196', 'Via Provinciale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('197', 'Via Vecchia', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('198', 'Via Vicinale', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('199', 'Viale', 'V.le', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('200', 'Viale Privato', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('201', 'Vico', 'Vico', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('202', 'Vicoletto', 'Vc.tto', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('203', 'Vicolo', 'V.c', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('204', 'Vicolo Largo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('205', 'Vicolo Lungo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('206', 'Vicolo Nuovo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('207', 'Vicolo Privato', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('208', 'Vicolo Rotto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('209', 'Vicolo Storto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('210', 'Vicolo Vecchio', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('211', 'Villa', 'Villa', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('212', 'Villaggio', 'Vlg.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('213', 'Viuzzo', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('214', 'Vocabolo', 'Vocab.', '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('215', 'Volta', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('216', 'Volto', NULL, '000');
INSERT INTO TOPONIMO (IDTOPONIMO, DESCRIZIONE, DESCRIZIONE2, IDSTATOESTERO) VALUES ('217', 'Zona Industriale', 'Zona ind.', '000');

COMMIT WORK;


/******************************************************************************/
/****                                Done                                  ****/
/******************************************************************************/

COMMIT WORK;