-- Created		01/12/2004
-- Modified:	18/10/2019
-- Project		Paghe Open
-- Model		Paghe (Db)
-- Company		Iubar.it (http://www.iubar.it)
-- Author		ing. Andrea Borgogelli Avveduti (info@iubar.it)
-- Version:		01.97.00
-- Database		Firebird

/******************************************************************************/
/****                                DB                                    ****/
/******************************************************************************/

CREATE DATABASE 'localhost:C:\Users\Iubar\AppData\Local\Temp\fdb\paghe.fdb'
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 4096
DEFAULT CHARACTER SET UTF8;

SET ECHO OFF ;

/******************************************************************************/
/****                                Domains                               ****/
/******************************************************************************/

Create Domain Currency As Decimal(15,6);
Create Domain Percentage As Decimal(7,6);
Create Domain Booleanint As Smallint CHECK (value is null or value in (0, 1));
Create Domain Arithmetic As Decimal(6,2);
Create Domain Note As Varchar(500);
Create Domain Note2 As Varchar(2000);
Create Domain Arithmetic2 As Decimal(16,6);
Create Domain IdUser As Varchar(50);

SET ECHO ON ;

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/

SET ECHO OFF ;


Create Table DbInfo  (
	Id Smallint NOT NULL,
	Descrizione Varchar(200),
	Valore Varchar(800),
 Primary Key (Id)
);

Create Table Inps_Qualifica1  (
	IdInpsQualifica1 Varchar(2) NOT NULL,
	Descrizione Varchar(500),
	Descrizione2 Varchar(50),
	IdTipoLavoratore2 Smallint,
	DataScadenza Date,
Constraint pk_Inps_Qualifica1 Primary Key (IdInpsQualifica1)
);

Create Table Inps_Qualifica2  (
	IdInpsQualifica2 Varchar(2) NOT NULL,
	Descrizione Varchar(300),
	DataScadenza Date,
Constraint pk_Inps_Qualifica2 Primary Key (IdInpsQualifica2)
);

Create Table Inps_Qualifica3  (
	IdInpsQualifica3 Varchar(2) NOT NULL,
	Descrizione Varchar(300),
	DataScadenza Date,
Constraint pk_Inps_Qualifica3 Primary Key (IdInpsQualifica3)
);

Create Table Inps_TipoAssunzione  (
	IdInpsTipoAssunzione Varchar(2) NOT NULL,
	Descrizione Varchar(400),
	DataScadenza Date,
Constraint pk_Inps_TipoAssunzione Primary Key (IdInpsTipoAssunzione)
);

Create Table Inps_TipoCessazione  (
	IdInpsTipoCessazione Varchar(2) NOT NULL,
	Descrizione Varchar(400),
	DataScadenza Date,
Constraint pk_Inps_TipoCessazione Primary Key (IdInpsTipoCessazione)
);

Create Table Inps_TipoLavoratore  (
	IdInpsTipoLavoratore Varchar(3) NOT NULL,
	Descrizione Varchar(300),
	FondoSpeciale Smallint,
	DataScadenza Date,
Constraint pk_Inps_TipoLavoratore Primary Key (IdInpsTipoLavoratore)
);

Create Table Inps_TipoCopertura  (
	IdInpsTipoCopertura Varchar(2) NOT NULL,
	Descrizione Varchar(300),
	DataScadenza Date,
Constraint pk_Inps_TipoCopertura Primary Key (IdInpsTipoCopertura)
);

Create Table Inps_Evento  (
	IdInpsEvento Varchar(4) NOT NULL,
	Descrizione Note,
	Descrizione2 Varchar(50),
	DataScadenza Date,
	Attivo Booleanint,
Constraint pk_Inps_Evento Primary Key (IdInpsEvento)
);

Create Table Inps_Attivita  (
	IdInpsAttivita Varchar(3) NOT NULL,
	Descrizione Varchar(200),
	DataScadenza Date,
Constraint pk_Inps_Attivita Primary Key (IdInpsAttivita)
);

Create Table Inps_AltreAss  (
	IdInpsAltreAss Varchar(4) NOT NULL,
	Descrizione Varchar(200),
	DataScadenza Date,
Constraint pk_Inps_AltreAss Primary Key (IdInpsAltreAss)
);

Create Table Inps_AliquotaCollaboratore  (
	IdInpsAliquota Varchar(5) NOT NULL,
	InpsAliquotaAnno Integer NOT NULL,
	Descrizione Varchar(400),
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Inps_AliquotaCollaboratore Primary Key (IdInpsAliquota,InpsAliquotaAnno)
);

Create Table Inps_TipoRapporto  (
	IdInpsTipoRapporto Varchar(3) NOT NULL,
	Descrizione Varchar(200),
	Descrizione2 Varchar(50),
	DataScadenza Date,
Constraint pk_Inps_TipoRapporto Primary Key (IdInpsTipoRapporto)
);

Create Table Inps_TipoAnf  (
	IdInpsTipoAnf Varchar(4) NOT NULL,
	Descrizione Varchar(300),
	DataScadenza Date,
	Coniugi Smallint,
	AlmenoFigliInabili Smallint,
	AlmenoFigliMinori Smallint,
Constraint pk_Inps_TipoAnf Primary Key (IdInpsTipoAnf)
);

Create Table Inps_Calamita  (
	IdInpsCalamita Varchar(3) NOT NULL,
	Descrizione Note,
	DataScadenza Date,
Constraint pk_Inps_Calamita Primary Key (IdInpsCalamita)
);

Create Table Inps_Certificazione  (
	IdInpsCertificazione Varchar(4) NOT NULL,
	Descrizione Varchar(200),
	DataScadenza Date,
Constraint pk_Inps_Certificazione Primary Key (IdInpsCertificazione)
);

Create Table Inps_TipoAgevolazione  (
	IdInpsTipoAgevolazione Varchar(3) NOT NULL,
	Descrizione Varchar(200),
	DataScadenza Date,
Constraint pk_Inps_TipoAgevolazione Primary Key (IdInpsTipoAgevolazione)
);

Create Table Inps_Settore  (
	IdInpsSettore Integer NOT NULL,
	Descrizione Varchar(300),
	Attivo Booleanint,
Constraint pk_Inps_Settore Primary Key (IdInpsSettore)
);

Create Table Inps_TipoContribuzione  (
	IdInpsTipoContribuzione Varchar(8) NOT NULL,
	Descrizione Varchar(600),
	ValidoDal Date,
	ValidoAl Date,
	IdInpsQualifica1 Varchar(2),
	NoDs Booleanint,
	NoCuaf Booleanint,
	NoCig Booleanint,
	Codificato Booleanint,
Constraint pk_Inps_TipoContribuzione Primary Key (IdInpsTipoContribuzione)
);

Create Table Inps_Settore_Contratto  (
	IdInpsSettore Integer NOT NULL,
	IdInpsContratto Varchar(4) NOT NULL,
Constraint pk_Inps_Settore_Contratto Primary Key (IdInpsSettore,IdInpsContratto)
);

Create Table Inps_Contratto  (
	IdInpsContratto Varchar(4) NOT NULL,
	Descrizione Note2,
	PartiContraenti Note,
	DataStipula Date,
	DataDecorrenza Date,
	DataScadenzaEconomica Date,
	DataScadenzaNormativa Date,
	DataRinnovoEconomico Date,
	Attivo Booleanint,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Inps_Contratto Primary Key (IdInpsContratto)
);

Create Table ContrattoDettaglio  (
	IdContrattoDettaglio Integer NOT NULL,
	IdInpsContratto Varchar(4) NOT NULL,
	IdUnitaMisura Smallint,
	Descrizione Varchar(200),
	Edr Currency,
	TredicesimaMese Smallint,
	TredicesimaGiorno Smallint,
	QuattordicesimaMese Smallint,
	QuattordicesimaGiorno Smallint,
	IstitutoScatti Booleanint,
	BancaOre Booleanint,
	StraordinariLimiteOreAnno Arithmetic,
	StraordinariLimiteOreMese Arithmetic,
	StraordinariLimiteOreSettimana Arithmetic,
	StraordinariLimiteOreGiorno Arithmetic,
	ScattiMese Smallint,
	ScattiNumero Smallint,
	Contingenza Smallint,
	IntegrazCongedoMatr Percentage,
	IdInfortunio Smallint,
	AssenzaCalcArrotondato Booleanint,
	AssenzaCalcEffettivo Booleanint,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
	Custom Booleanint,
Constraint pk_ContrattoDettaglio Primary Key (IdContrattoDettaglio)
);

Create Table Settimana  (
	IdDatoRetributivo Integer NOT NULL,
	IdSettimana Smallint NOT NULL,
	IdInpsTipoCopertura Varchar(2) NOT NULL,
Constraint pk_Settimana Primary Key (IdDatoRetributivo,IdSettimana)
);

Create Table DatoRetributivo  (
	IdDatoRetributivo Integer NOT NULL,
	IdPosizione Integer NOT NULL,
	IdInpsTipoLavoratore Varchar(3) NOT NULL,
	RetribTeorica Currency,
	ImponibileInps Currency,
	Dal Date,
	Al Date,
	OreRetribuite Arithmetic,
	GiorniRetribuiti Arithmetic,
	OreDaPresenze Arithmetic,
	GiorniDaPresenze Arithmetic,
	OreLavOrd Arithmetic,
	GiorniLavOrd Arithmetic,
	GiorniInps Arithmetic,
	SettimaneInps Arithmetic,
	ContributiInps1 Currency,
	ContributiInps2 Currency,
	ContributoFondoSost Currency,
	FondoIntegrativo Currency,
	IdTipoLavoratoreStat Varchar(5),
	RispettoMinimale Booleanint,
	GiorniContribuiti Arithmetic,
	OreContribuite Arithmetic,
	ForzImpZero Booleanint,
	Note Note,
Constraint pk_DatoRetributivo Primary Key (IdDatoRetributivo)
);

Create Table VariabileRetributiva  (
	IdDatoRetributivo Integer NOT NULL,
	IdTipoVarRetr Varchar(6) NOT NULL,
	Anno Integer,
	Mese Smallint,
	Imponibile Currency,
	Contributo Currency,
	IdInquadrDatoRetrib Integer,
	IdPosizioneOriginaria Integer,
Constraint pk_VariabileRetributiva Primary Key (IdDatoRetributivo,IdTipoVarRetr)
);

Create Table DiffAccredito  (
	IdDatoRetributivo Integer NOT NULL,
	IdInpsEvento Varchar(4) NOT NULL,
	DiffAccredito Currency,
	SettimaneInps Arithmetic,
Constraint pk_DiffAccredito Primary Key (IdDatoRetributivo,IdInpsEvento)
);

Create Table DatoParticolare  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_DatoParticolare Primary Key (IdDatoRetributivo)
);

Create Table Estero  (
	IdDatoRetributivo Integer NOT NULL,
	IdTipoContribEstero Varchar(3) NOT NULL,
	IdEsteroTipoImp Varchar(2),
	Imponibile Currency,
	ContributoEstero Currency,
Constraint pk_Estero Primary Key (IdDatoRetributivo,IdTipoContribEstero)
);

Create Table ContribSindacalista  (
	IdDatoRetributivo Integer NOT NULL,
	Anno Integer NOT NULL,
	Imponibile Currency,
	Dal Date,
	Al Date,
	ContributoSind Currency,
Constraint pk_ContribSindacalista Primary Key (IdDatoRetributivo,Anno)
);

Create Table LavDomicilio  (
	IdDatoRetributivo Integer NOT NULL,
	InizioCommessa Date,
	Imponibile Currency,
	GiorniRetribuiti Smallint,
Constraint pk_LavDomicilio Primary Key (IdDatoRetributivo)
);

Create Table Anf  (
	IdPosizione Integer NOT NULL,
	IdInpsTipoAnf Varchar(4),
	IdClasseAnf Smallint,
	ValidoDal Date,
	Assegno Currency,
	Riduzione Currency,
	RedditoFamiliare Currency,
	Note Note,
Constraint pk_Anf Primary Key (IdPosizione)
);

Create Table FondoSpeciale  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_FondoSpeciale Primary Key (IdDatoRetributivo)
);

Create Table PosizioneSubordinato  (
	IdPosizione Integer NOT NULL,
	IdInpsQualifica1 Varchar(2) NOT NULL,
	IdInpsQualifica2 Varchar(2),
	IdInpsQualifica3 Varchar(2),
	IdInpsSettore Integer NOT NULL,
	IdLivello Varchar(5) NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	IdInpsTipoContribuzione Varchar(8),
	IdCoefficiente Smallint NOT NULL,
	IdAssunzione Integer,
	IdCessazione Integer,
	IdInquadramento Integer,
	IdInpsTipoApprendistato Varchar(4),
	IdPeriodoApprendistato Smallint,
	TipoConsolidamento Varchar(2),
	TfrAccantonato Currency,
	IdTipoCalcolo Smallint,
	IdRateo Smallint,
	IdFerie Smallint,
	PartTimeOrario Percentage,
	PartTimeContratto Percentage,
Constraint pk_PosizioneSubordinato Primary Key (IdPosizione)
);

Create Table Agevolazione  (
	IdAgevolazione Integer NOT NULL,
	Importo Currency NOT NULL,
	IdTipo Varchar(3) NOT NULL,
Constraint pk_Agevolazione Primary Key (IdAgevolazione)
);

Create Table Cedolino_Elemento  (
	IdElemento Integer NOT NULL,
	IdPosizione Integer NOT NULL,
	IdDatoRetributivo Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
	IdProgressivo Smallint NOT NULL,
	IdUnitaMisura Smallint NOT NULL,
	IdAssenza Integer,
	Importo Currency,
	Quantita Arithmetic,
	Percentuale Percentage,
	Calcolato Booleanint,
	Ricorrente Booleanint,
	Note Varchar(200),
	Note2 Varchar(200),
	Nascosto Booleanint,
Constraint pk_Cedolino_Elemento Primary Key (IdElemento,IdPosizione,IdDatoRetributivo,IdTipoFoglio,IdProgressivo)
);

Create Table Cedolino  (
	IdPosizione Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
	IdContrattoDettaglio Integer,
	IdInail Integer,
	IdTipoRetribuzione Smallint,
	IdDocumento Integer,
	OreRetribuite Arithmetic,
	GiorniRetribuiti Arithmetic,
	OreEffettive Arithmetic,
	GiorniEffettivi Arithmetic,
	GiorniInps Arithmetic,
	OreOrdinarie Arithmetic,
	GiorniOrdinari Arithmetic,
	SettimaneInps Arithmetic,
	MinTabellare Currency,
	RetribGlobaleDiFatto Currency,
	TotaleRetribLorda Currency,
	TotaleRetribNetta Currency,
	Numerazione Integer,
	Arrotondamento Currency,
	ArrotondamentoPrec Currency,
	Note Note,
	UltimaElaborazione Timestamp,
	UltimaElaborazioneUser IdUser,
Constraint pk_Cedolino Primary Key (IdPosizione,IdTipoFoglio)
);

Create Table ContrattoVoce  (
	IdVoce Smallint NOT NULL,
	IdCategoria1 Smallint,
	IdCategoria2 Smallint,
	Descrizione Varchar(200),
	Descrizione2 Varchar(75),
	Indice Smallint,
	Tfr Booleanint,
	Custom Booleanint,
Constraint pk_ContrattoVoce Primary Key (IdVoce)
);

Create Table ElementoRetributivo  (
	IdElemento Integer NOT NULL,
	IdTipoElemento Smallint,
	IdTipoElemento2 Smallint,
	IdFrequenza Smallint,
	IdBaseImponibile Integer,
	Importo Currency,
	Percentuale Percentage,
	Descrizione Varchar(200),
	Descrizione2 Varchar(75),
	IdEntePrevidenziale Smallint,
	AliquotaPrevidenz Percentage,
	Irpef Booleanint,
	IrpefAliquota Percentage,
	IrpefAliquotaSost Percentage,
	Inail Booleanint,
	InailAliquota Percentage,
	Tfr Booleanint,
	TfrAliquota Percentage,
	Indiretto Booleanint,
	Netto Booleanint,
	RifImpresa Integer,
	RifTipoLavoratore Smallint,
	RifContratto Booleanint,
	DataErogazione Date,
	LimiteQuantitaAnnua Integer,
	Ordinamento Smallint,
	Ricorrente Booleanint,
	Contrattualizzato Booleanint,
	RifAssenza Booleanint,
	Figurativo Booleanint,
	Recalc Booleanint,
	Nascosto Booleanint,
	Note Note,
	Custom Booleanint,
Constraint pk_ElementoRetributivo Primary Key (IdElemento)
);

Create Table Frequenza  (
	IdFrequenza Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Frequenza Primary Key (IdFrequenza)
);

Create Table Settimana_Evento  (
	IdSettimana Smallint NOT NULL,
	IdDatoRetributivo Integer NOT NULL,
	IdInpsEvento Varchar(4) NOT NULL,
	DiffAccredito Currency,
	GiorniInteressati Arithmetic,
	OreInteressate Arithmetic,
	SettimaneInps Arithmetic,
Constraint pk_Settimana_Evento Primary Key (IdSettimana,IdDatoRetributivo,IdInpsEvento)
);

Create Table ContribAtipica  (
	IdDatoRetributivo Integer NOT NULL,
	Imponibile Currency,
	Dal Date,
	Al Date,
	NumSettimane Arithmetic,
	ContributoAtipica Currency,
Constraint pk_ContribAtipica Primary Key (IdDatoRetributivo)
);

Create Table Preavviso  (
	IdDatoRetributivo Integer NOT NULL,
	Imponibile Currency,
	Dal Date,
	Al Date,
	NumSettimane Arithmetic,
	SettimaneInps Smallint,
Constraint pk_Preavviso Primary Key (IdDatoRetributivo)
);

Create Table Bonus  (
	IdDatoRetributivo Integer NOT NULL,
	Importo Currency,
	Decorrenza Date,
Constraint pk_Bonus Primary Key (IdDatoRetributivo)
);

Create Table ContrattoRiallineamento  (
	IdDatoRetributivo Integer NOT NULL,
	GiorniInfMinimale Smallint NOT NULL,
	QuotaRetribInfMinimale Currency NOT NULL,
Constraint pk_ContrattoRiallineamento Primary Key (IdDatoRetributivo)
);

Create Table Assenza  (
	IdAssenza Integer NOT NULL,
	IdPosizione Integer NOT NULL,
	IdDatoRetributivo Integer,
	IdTipoAssenza Smallint,
	IdOpzione Smallint,
	GiornoDal Date,
	GiornoAl Date,
	OreDal Time,
	OreAl Time,
	GiornataIntera Booleanint,
	MezzaGiornata Booleanint,
	OreTot Arithmetic,
	GiorniTot Arithmetic,
	OreLavPrimoGg Arithmetic,
	InpsRmg Currency,
	Sanzionabile Booleanint,
	Integrata Booleanint,
	IntegrataDal Date,
	IntegrataAl Date,
Constraint pk_Assenza Primary Key (IdAssenza)
);

Create Table TipoAssenza  (
	IdTipoAssenza Smallint NOT NULL,
	IdCategoria Smallint,
	IdInpsEvento Varchar(4),
	IdTipoElemento Smallint,
	Causale Varchar(5),
	Descrizione Note,
	Descrizione2 Varchar(50),
	Indiretto Booleanint,
	RetribAggiuntiva Booleanint,
	Tfr Booleanint,
	OrderId Smallint,
	Attivo Booleanint,
Constraint pk_TipoAssenza Primary Key (IdTipoAssenza)
);

Create Table PosizioneParasubordinato  (
	IdPosizione Integer NOT NULL,
	IdInailAliquota Integer,
	InailAliquotaAnno Integer,
	IdInpsTipoRapporto Varchar(3) NOT NULL,
	IdInpsAliquota Varchar(5) NOT NULL,
	InpsAliquotaAnno Integer NOT NULL,
	PeriodoDal Date,
	PeriodoAl Date,
	ImponibileInps Currency,
	IdInpsAltreAss Varchar(4),
	IdInpsAttivita Varchar(3),
	IdInpsCalamita Varchar(3),
	IdInpsCertificazione Varchar(4),
Constraint pk_PosizioneParasubordinato Primary Key (IdPosizione)
);

Create Table PosizioneParasub_Agevolazione  (
	IdAgevolazione Integer NOT NULL,
	IdPosizione Integer NOT NULL,
Constraint pk_PosizioneParasub_Agevolazion Primary Key (IdAgevolazione,IdPosizione)
);

Create Table HelpSettori  (
	IdHelpSettore Smallint NOT NULL,
	Descrizione Varchar(400),
	OrarioDiLavoro Varchar(1200),
	DivisoreGiornaliero Varchar(400),
	DivisoreOrario Varchar(400),
	BaseDiComputo Varchar(200),
	Maggiorazioni Varchar(2000),
	Ferie Varchar(1200),
	Permessi Varchar(1200),
	MalattiaConservazioneDelPosto Varchar(400),
	MalattiaTrattamento Varchar(2000),
	FesteTrattamento Varchar(1200),
	DataAggiornamento Date,
	IdAnagrafica Integer,
	InfortunioConservazioneDelPosto Varchar(400),
	InfortunioTrattamento Varchar(1200),
	GravidanzaEPuerperio Varchar(1200),
	CongedoMatrimoniale Varchar(400),
	Preavviso Varchar(400),
	LavoroInterinale Varchar(400),
	LavoroPartTime Varchar(400),
	Apprendistato Varchar(400),
	MensilitaContrattuali Varchar(400),
	Custom Booleanint,
Constraint pk_HelpSettori Primary Key (IdHelpSettore)
);

Create Table CategoriaContrattoVoce1  (
	IdCategoria1 Smallint NOT NULL,
	Descrizione Varchar(400),
Constraint pk_CategoriaContrattoVoce1 Primary Key (IdCategoria1)
);

Create Table HelpTariffePremiInail  (
	Classificazione Integer NOT NULL,
	IdSettore Smallint NOT NULL,
	Lavorazioni Varchar(100),
	Tasso Smallint,
Constraint pk_HelpTariffePremiInail Primary Key (Classificazione)
);

Create Table HelpGrandiGruppi  (
	IdSettore Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_HelpGrandiGruppi Primary Key (IdSettore)
);

Create Table HelpIntegrazioneSalariale  (
	Id Integer NOT NULL,
	Decorrenza Varchar(200),
	Importo Currency,
	Netto Currency,
	Descrizione Varchar(200),
	Nota Note,
	Data Date,
Constraint pk_HelpIntegrazioneSalariale Primary Key (Id)
);

Create Table TipoNucleoFamiliare  (
	IdNucleo Varchar(20) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoNucleoFamiliare Primary Key (IdNucleo)
);

Create Table HelpRetrMedieAgricoltura  (
	Id Integer NOT NULL,
	Provincia Varchar(100),
	Otd Currency,
	OtiComuni Currency,
	OtiQualificati Currency,
	OtiQualificatiSuper Currency,
	OtiSpeciali Currency,
	OtiSpecialiSuper Currency,
Constraint pk_HelpRetrMedieAgricoltura Primary Key (Id)
);

Create Table Inail_LimiteContributivo  (
	IdLimiteContrib Smallint NOT NULL,
	IdInpsQualifica1 Varchar(2),
	IdSettore Smallint,
	Settore Varchar(100),
Constraint pk_Inail_LimiteContributivo Primary Key (IdLimiteContrib)
);

Create Table Dmag_TipoDitta1  (
	IdTipoDitta1 Smallint NOT NULL,
	Descrizione Varchar(2000),
Constraint pk_Dmag_TipoDitta1 Primary Key (IdTipoDitta1)
);

Create Table Dmag_TipoDitta2  (
	IdTipoDitta2 Smallint NOT NULL,
	Descrizione Varchar(2000),
Constraint pk_Dmag_TipoDitta2 Primary Key (IdTipoDitta2)
);

Create Table Dmag_TipoManodopera  (
	IdTipoManodopera Smallint NOT NULL,
	Descrizione Varchar(500),
Constraint pk_Dmag_TipoManodopera Primary Key (IdTipoManodopera)
);

Create Table Dmag_TipoDichiaraz  (
	IdTipoDichiaraz Varchar(4) NOT NULL,
	Descrizione Varchar(2000),
Constraint pk_Dmag_TipoDichiaraz Primary Key (IdTipoDichiaraz)
);

Create Table Dmag_TipoCategoria  (
	IdTipoCategoria Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_TipoCategoria Primary Key (IdTipoCategoria)
);

Create Table Dmag_TipoContratto  (
	IdTipoContratto Smallint NOT NULL,
	Descrizione Varchar(1200),
Constraint pk_Dmag_TipoContratto Primary Key (IdTipoContratto)
);

Create Table Dmag_TipoRetribuzione1  (
	IdTipoRetribuzione1 Varchar(2) NOT NULL,
	Descrizione Varchar(1200),
Constraint pk_Dmag_TipoRetribuzione1 Primary Key (IdTipoRetribuzione1)
);

Create Table Dmag_CompatibCodDitta  (
	IdDitta1 Smallint NOT NULL,
	IdDitta2 Smallint NOT NULL,
Constraint pk_Dmag_CompatibCodDitta Primary Key (IdDitta1,IdDitta2)
);

Create Table TipoContribEstero  (
	IdTipoContribEstero Varchar(3) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoContribEstero Primary Key (IdTipoContribEstero)
);

Create Table CalendarioFestivita  (
	IdCalendario Smallint NOT NULL,
	IdFesta Integer NOT NULL,
	COMU_UNIVOC Integer,
	Periodica Smallint,
	Giorno Smallint,
	Mese Smallint,
	Anno Smallint,
	Descrizione Varchar(400),
Constraint pk_CalendarioFestivita Primary Key (IdCalendario,IdFesta)
);

Create Table ContrattazioneIntegrativa  (
	IdContrIntegrativa Integer NOT NULL,
	IdInpsSettore Integer NOT NULL,
	IdInpsContratto Varchar(4) NOT NULL,
	Note Varchar(500),
Constraint pk_ContrattazioneIntegrativa Primary Key (IdContrIntegrativa)
);

Create Table TipoElementoRetributivo  (
	IdTipoElemento Smallint NOT NULL,
	IdTipoElemPadre Smallint,
	Sigla Varchar(4),
	Descrizione Varchar(400),
	Ordinamento Smallint,
	Nascosto Booleanint,
Constraint pk_TipoElementoRetributivo Primary Key (IdTipoElemento)
);

Create Table FondoPrevMarinara  (
	IdDatoRetributivo Integer NOT NULL,
	RetribMediaGiornaliera Currency NOT NULL,
Constraint pk_FondoPrevMarinara Primary Key (IdDatoRetributivo)
);

Create Table FondoAnte95  (
	IdDatoRetributivo Integer NOT NULL,
	RetribPensionabile Currency,
	GiorniNonRetribuiti Smallint,
	RetribTeoricaExL223 Currency,
	Tredicesima Currency,
	RetribAccessoriaEt Currency,
Constraint pk_FondoAnte95 Primary Key (IdDatoRetributivo)
);

Create Table FondoDaziere  (
	IdDatoRetributivo Integer NOT NULL,
	RetribPensionabile Currency,
	RetribTfr Currency,
	GiorniRetribuiti Smallint,
	GiorniUtili Smallint,
Constraint pk_FondoDaziere Primary Key (IdDatoRetributivo)
);

Create Table FondoGas  (
	IdDatoRetributivo Integer NOT NULL,
	RetribPensionabile Currency,
	Tredicesima Currency,
	GiorniUtili Arithmetic,
	GiorniRetribuiti Arithmetic,
Constraint pk_FondoGas Primary Key (IdDatoRetributivo)
);

Create Table FondoEsattoriale  (
	IdDatoRetributivo Integer NOT NULL,
	RetribPensionabile Currency,
	RetribPensionabileX13 Currency,
	DirittiTariffa Currency,
	RetribTfr Currency,
	GiorniRetribuiti Smallint,
	GiorniUtili Smallint,
Constraint pk_FondoEsattoriale Primary Key (IdDatoRetributivo)
);

Create Table FondoPortuale  (
	IdDatoRetributivo Integer NOT NULL,
	RetribPensionabile Currency,
	GiorniRetribuiti Smallint,
	GiorniUtili Smallint,
Constraint pk_FondoPortuale Primary Key (IdDatoRetributivo)
);

Create Table FondoFs  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_FondoFs Primary Key (IdDatoRetributivo)
);

Create Table FondoAnte95_Arretrato  (
	IdArretrato Integer NOT NULL,
	IdDatoRetributivo Integer NOT NULL,
	DalMese Smallint,
	AlMese Smallint,
	Anno Integer,
	RetribPensionabile Currency,
	RetribAccessoriaEt Currency,
Constraint pk_FondoAnte95_Arretrato Primary Key (IdArretrato)
);

Create Table FondoAnte95_ContribSindAnno  (
	IdContrib Integer NOT NULL,
	IdDatoRetributivo Integer NOT NULL,
	Anno Integer,
	RetribPensionabile Currency,
Constraint pk_FondoAnte95_ContribSindAnno Primary Key (IdContrib)
);

Create Table FondoGas_Preavviso  (
	IdDatoRetributivo Integer NOT NULL,
	RetrPensionabile Currency,
	GiorniUtili Smallint,
	GiorniRetribuiti Smallint,
Constraint pk_FondoGas_Preavviso Primary Key (IdDatoRetributivo)
);

Create Table FondoGas_Riscatto  (
	IdDatoRetributivo Integer NOT NULL,
	RetribPensionabile Currency,
	Dal Date,
	Al Date,
	GiorniUtili Smallint,
	GiorniRiscattati Smallint,
Constraint pk_FondoGas_Riscatto Primary Key (IdDatoRetributivo)
);

Create Table FondoEsattoriale_Arretrato  (
	IdArretrato Integer NOT NULL,
	IdDatoRetributivo Integer NOT NULL,
	Mese Smallint,
	RetribPensionabile Currency,
Constraint pk_FondoEsattoriale_Arretrato Primary Key (IdArretrato)
);

Create Table FondoFs_Mese  (
	IdDatoRetributivo Integer NOT NULL,
	Retribuzione177 Currency,
	GiorniRetribuitiFs Smallint,
	GiorniUtili Smallint,
	Tredicesima Currency,
	CompetenzeAccessorie Currency,
	IndennitaIntegrSpec Currency,
	RetribUltimoGiorno177 Currency,
	RetribUltimoGiornoIndennIntegrS Currency,
	RetribUltimoGiornoVentiq Currency,
	RetribUltimoGiornoBenef336 Currency,
	LimitiEta Smallint,
	LimitiServizio Date,
	FigRetrib177 Currency,
	FigGiorniRetribFs Smallint,
	FigGioriUtili Smallint,
	FigTredicesima Currency,
	FigCompetenzeAccessorie Currency,
	FigIndennitaIntegrSpec Currency,
Constraint pk_FondoFs_Mese Primary Key (IdDatoRetributivo)
);

Create Table FondoFs_Preavviso  (
	IdDatoRetributivo Integer NOT NULL,
	Retribuzione177 Currency,
	GiorniRetribuitiFs Smallint,
	GiorniUtili Smallint,
	Tredicesima Currency,
	CompetenzeAccessorie Currency,
	IndennitaIntegrSpec Currency,
Constraint pk_FondoFs_Preavviso Primary Key (IdDatoRetributivo)
);

Create Table FondoFs_ContribSindAnno  (
	IdDatoRetributivo Integer NOT NULL,
	IdContrib Integer NOT NULL,
	Anno Integer,
	Retribuzione177 Currency,
	Tredicesima Currency,
Constraint pk_FondoFs_ContribSindAnno Primary Key (IdDatoRetributivo,IdContrib)
);

Create Table FondoFs_Maggiorazione  (
	IdDatoRetributivo Integer NOT NULL,
	IdMaggiorazione Smallint NOT NULL,
	IdTipoMaggiorazione Varchar(4) NOT NULL,
	Giorni Smallint,
Constraint pk_FondoFs_Maggiorazione Primary Key (IdDatoRetributivo,IdMaggiorazione)
);

Create Table FondoFs_TipoMaggiorazione  (
	IdTipoMaggiorazione Varchar(4) NOT NULL,
	Descrizione Varchar(400),
Constraint pk_FondoFs_TipoMaggiorazione Primary Key (IdTipoMaggiorazione)
);

Create Table DispIntermittente  (
	IdDatoRetributivo Integer NOT NULL,
	Importo Currency,
	NumSettimane Smallint,
	SettimaneInps Arithmetic,
Constraint pk_DispIntermittente Primary Key (IdDatoRetributivo)
);

Create Table PosizioneLavoratore  (
	IdPosizione Integer NOT NULL,
	IdStatoPosizione Smallint NOT NULL,
	IdProfilo Integer,
	IdLavoratore Integer NOT NULL,
	IdImpresa Integer,
	IdSedeImpresa Smallint,
	MatricolaInps Varchar(20),
	IdTitolareDati Integer,
	MeseRiferimento Smallint,
	AnnoRiferimento Integer NOT NULL,
	RichiestaCancellazione Booleanint,
	DataRichiestaCancellazione Date,
	DataErogazione Date,
	IdOrario Integer,
	IdStatoCivile Smallint,
	IdComunePrestazione Varchar(8),
	IdStatoPrestazione Integer,
	IdTipoMalattia1 Smallint,
	IdTipoRetrMal Smallint,
	NoRecalc Booleanint,
	UltimaComunicazione Date,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_PosizioneLavoratore Primary Key (IdPosizione)
);

Create Table ContrattoDettaglioLivello  (
	IdContrattoDettaglio Integer NOT NULL,
	IdLivello Varchar(5) NOT NULL,
	Descrizione Varchar(200),
	IdInpsContratto Varchar(4) NOT NULL,
	Apprendista Booleanint,
	IdContrattoDettFinale Integer,
	IdLivelloFinale Varchar(5),
	DataAggiornamento Date,
	Custom Booleanint,
Constraint pk_ContrattoDettaglioLivello Primary Key (IdContrattoDettaglio,IdLivello)
);

Create Table ContrattoDettaglioLivelloVoce  (
	IdContrattoDettaglio Integer NOT NULL,
	IdLivello Varchar(5) NOT NULL,
	IdVoce Smallint NOT NULL,
	ValidoDal Date NOT NULL,
	Importo Currency,
	Percentuale Percentage,
	IdContrattoDettRif Integer,
	IdLivelloRif Varchar(5),
	IdVoceRif Smallint,
	ValidoDalRif Date,
	ValidoDalMese Smallint,
	ValidoAlMese Smallint,
	DataAggiornamento Date,
	Custom Booleanint,
Constraint pk_ContrattoDettaglioLivelloVoc Primary Key (IdContrattoDettaglio,IdLivello,IdVoce,ValidoDal)
);

Create Table ContrattoDettaglioVoce  (
	IdContrattoDettaglio Integer NOT NULL,
	IdVoce Smallint NOT NULL,
	IdBaseImponibile Integer,
	IdInpsContratto Varchar(4) NOT NULL,
	Inps Booleanint,
	Irpef Booleanint,
	Tfr Booleanint,
	Indiretto Booleanint,
	Maggiorazione Booleanint,
	Mese Smallint,
	Custom Booleanint,
Constraint pk_ContrattoDettaglioVoce Primary Key (IdContrattoDettaglio,IdVoce)
);

Create Table M770  (
	IdDichiarazione Integer NOT NULL,
	IdTipoM700 Smallint,
	IdDocumento Integer,
	IdExport Integer,
	IdEsito Integer,
Constraint pk_M770 Primary Key (IdDichiarazione)
);

Create Table Istat_Foi  (
	Anno Integer NOT NULL,
	Mese Smallint NOT NULL,
	Indice Arithmetic2,
	Base Integer,
Constraint pk_Istat_Foi Primary Key (Anno,Mese)
);

Create Table Istat_Contratti  (
	IdContratto Varchar(6) NOT NULL,
	IdSettore Varchar(3) NOT NULL,
	Descrizione Note,
Constraint pk_Istat_Contratti Primary Key (IdContratto)
);

Create Table Inps_AliquotaGruppo  (
	IdGruppo Smallint NOT NULL,
	Descrizione Varchar(200),
	Note Note2,
Constraint pk_Inps_AliquotaGruppo Primary Key (IdGruppo)
);

Create Table Inps_AliquotaArea  (
	IdArea Integer NOT NULL,
	IdGruppo Smallint NOT NULL,
	Descrizione Varchar(200),
	InpsTabella Varchar(10),
	UltimaModifica Timestamp,
	Esonero Note2,
	Note Note2,
Constraint pk_Inps_AliquotaArea Primary Key (IdArea)
);

Create Table Inps_AliquotaTipoLavoratore  (
	IdAliquotaTipoLav Integer NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_AliquotaTipoLavoratore Primary Key (IdAliquotaTipoLav)
);

Create Table Inail_PremioArtigiano  (
	IdFasciaRischio Smallint NOT NULL,
	IdFormaAssicurativa Smallint NOT NULL,
	RetribuzioneAnnua Currency NOT NULL,
	Premio Currency,
	DataAggiornamento Date NOT NULL,
Constraint pk_Inail_PremioArtigiano Primary Key (IdFasciaRischio,IdFormaAssicurativa,RetribuzioneAnnua,DataAggiornamento)
);

Create Table Istat_ClasseAttivita  (
	IdClasse Varchar(6) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Istat_ClasseAttivita Primary Key (IdClasse)
);

Create Table Istat_SettoreContratto  (
	IdSettore Varchar(3) NOT NULL,
	IdSettorePadre Varchar(3),
	Descrizione Varchar(200),
Constraint pk_Istat_SettoreContratto Primary Key (IdSettore)
);

Create Table Inps_AliquotaArea_Lavoratore  (
	IdAliquotaTipoLav Integer NOT NULL,
	IdArea Integer NOT NULL,
Constraint pk_Inps_AliquotaArea_Lavoratore Primary Key (IdAliquotaTipoLav,IdArea)
);

Create Table ContrattoFerie  (
	IdContrattoDettaglio Integer NOT NULL,
	IdFerie Smallint NOT NULL,
	IdTipoLavoratore2 Smallint,
	IdCoefficiente Smallint,
	Descrizione Varchar(200),
	IdLivello Varchar(5),
	AnzianitaDa Smallint,
	AnzianitaA Smallint,
	PeriodoGiorni Smallint,
	PeriodoSettimane Smallint,
	Frazionabili Booleanint,
	Note Note,
	Custom Booleanint,
Constraint pk_ContrattoFerie Primary Key (IdContrattoDettaglio,IdFerie)
);

Create Table ContrattoCoefficiente  (
	IdContrattoDettaglio Integer NOT NULL,
	IdCoefficiente Smallint NOT NULL,
	Descrizione Varchar(200),
	Giornaliero Arithmetic,
	Orario Arithmetic,
	GiorniSettimana Arithmetic,
	OreSettimana Arithmetic,
	SoloDonnaEMinore Booleanint,
	SoloUomo Booleanint,
	IdTipoLavoratore2 Smallint,
	Mensilita Smallint,
	MensilitaAggiuntiva Arithmetic,
	MensilitaAggIdUm Smallint,
	Mensilita1000 Integer,
	Note Note,
	Custom Booleanint,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_ContrattoCoefficiente Primary Key (IdContrattoDettaglio,IdCoefficiente)
);

Create Table ContrIntegrativa_AltroElem  (
	IdContrIntegrativa Integer NOT NULL,
	IdElemento Integer NOT NULL,
Constraint pk_ContrIntegrativa_AltroElem Primary Key (IdContrIntegrativa,IdElemento)
);

Create Table ContrattoScatto  (
	IdContrattoDettaglio Integer NOT NULL,
	IdScatto Smallint NOT NULL,
	IdLivello Varchar(5),
	IdCoefficiente Smallint,
	IdTipoLavoratore2 Smallint,
	IdAnzianita Smallint,
	ScattiNumero Smallint,
	ScattiMesi Smallint,
	Importo Currency,
	IdBaseImponibile Integer,
	Percentuale Percentage,
	ValidoDal Date,
	Note Note,
	Custom Booleanint,
Constraint pk_ContrattoScatto Primary Key (IdContrattoDettaglio,IdScatto)
);

Create Table ContrattoDett_Elemento  (
	IdContrattoDettaglio Integer NOT NULL,
	IdElemento Integer NOT NULL,
	IdVoce Smallint,
	IdTipoLavoratore2 Smallint,
	IdLivello Varchar(5),
	Importo Currency,
	Quantita Arithmetic,
	IdBaseImponibile Integer,
	Percentuale Percentage,
	Custom Booleanint,
Constraint pk_ContrattoDett_Elemento Primary Key (IdContrattoDettaglio,IdElemento)
);

Create Table Scadenza  (
	IdScadenzario Smallint NOT NULL,
	IdScadenza Integer NOT NULL,
	IdFrequenza Smallint,
	DataScadenza Date,
	IdImpresa Integer,
	IdLavoratore Integer,
	IdInpsQualifica1 Varchar(2),
	Descrizione Varchar(200),
	Note Note,
	Attiva Booleanint,
Constraint pk_Scadenza Primary Key (IdScadenzario,IdScadenza)
);

Create Table ContrattoDettaglioVoce_Cedolino  (
	IdContrattoDettaglio Integer NOT NULL,
	IdVoce Smallint NOT NULL,
	IdPosizione Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
Constraint pk_ContrattoDettaglioVoce_Cedol Primary Key (IdContrattoDettaglio,IdVoce)
);

Create Table Inps_Contratto_Gruppo  (
	IdInpsContratto Varchar(4) NOT NULL,
	IdGruppo Smallint NOT NULL,
Constraint pk_Inps_Contratto_Gruppo Primary Key (IdInpsContratto,IdGruppo)
);

Create Table Inps_ImpresaAutorizzazione  (
	IdMatricola Varchar(20) NOT NULL,
	Ca Varchar(5) NOT NULL,
	IdImpresa Integer NOT NULL,
	IdSedeImpresa Smallint,
Constraint pk_Inps_ImpresaAutorizzazione Primary Key (IdMatricola,Ca)
);

Create Table ContrattoOrario  (
	IdContrattoDettaglio Integer NOT NULL,
	IdOrario Smallint NOT NULL,
	IdTipoLavoratore2 Smallint,
	Festivita Note,
	RiduzioneOrario Note2,
	PermessiRetribuiti Note2,
	Flessibilita Note2,
	Custom Booleanint,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_ContrattoOrario Primary Key (IdContrattoDettaglio,IdOrario)
);

Create Table ContrattoMaggiorazione  (
	IdMaggiorazione Smallint NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	IdTipoElemento Smallint NOT NULL,
	IdTipoLavoratore2 Smallint,
	LimiteOreAnno Arithmetic,
	LimiteOreMese Arithmetic,
	LimiteOreSettimana Arithmetic,
	LimiteOreGiorno Arithmetic,
	Importo Currency,
	IdBaseImponibile Integer,
	Maggiorazione Percentage,
	Descrizione Varchar(200),
	ValidoDal Date,
	ValidoAl Date,
	Note Note2,
	Custom Smallint,
Constraint pk_ContrattoMaggiorazione Primary Key (IdMaggiorazione,IdContrattoDettaglio)
);

Create Table ContrattoIndennita  (
	IdIndennita Smallint NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	IdTipoIndennita Smallint,
	IdFrequenza Smallint,
	Descrizione Varchar(200),
	Descrizione2 Varchar(75),
	IdTipoLavoratore2 Smallint,
	Importo Currency,
	IdBaseImponibile Integer,
	Percentuale Percentage,
	IdUnitaMisura Smallint,
	ValidoDal Date,
	ValidoAl Date,
	Note Note,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
	Custom Booleanint,
Constraint pk_ContrattoIndennita Primary Key (IdIndennita,IdContrattoDettaglio)
);

Create Table TipoIndennita  (
	IdTipoIndennita Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoIndennita Primary Key (IdTipoIndennita)
);

Create Table ContrattoAssenzaLivello  (
	IdAssenza Smallint NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	IdLivello Varchar(5) NOT NULL,
Constraint pk_ContrattoAssenzaLivello Primary Key (IdAssenza,IdContrattoDettaglio,IdLivello)
);

Create Table ProfiloLavoratore  (
	IdProfilo Integer NOT NULL,
	Descrizione Varchar(200),
	IdInpsSettore Integer,
	IdContrattoDettaglio Integer,
	IdCoefficiente Smallint,
	IdTipoLavoratore2 Smallint,
	IdRateo Smallint,
	IdFerie Smallint,
	IdTipoCalcolo Smallint,
	TipoCalcoloFisso Booleanint,
	IdInfortunio Smallint,
	RateoRolOreMese Arithmetic2,
	RateoPermessiOreMese Arithmetic2,
	IdOrario Integer,
	OreAnno Arithmetic,
	OreMese Arithmetic,
	NoOrePresenze Booleanint,
	SoggettoInail Booleanint,
	SoggettoInps Booleanint,
	IdTipoMalattia1 Smallint,
	IdTipoMalattia2 Smallint,
	IdTipoRetrMal Smallint,
	FesteSoppRateo Booleanint,
	AssenzaCalcArrotondato Booleanint,
	AssenzaCalcEffettivo Smallint,
	IdInpsTipoApprendistato Varchar(4),
	IdPeriodoApprendistato Smallint,
	Note Note,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_ProfiloLavoratore Primary Key (IdProfilo)
);

Create Table Inps_AliquotaCollDettaglio  (
	IdInpsAliquota Varchar(5) NOT NULL,
	InpsAliquotaAnno Integer NOT NULL,
	Ivs Percentage,
	AltraAliquota1 Percentage,
	AltraAliquota2 Percentage,
	RedditoDa Currency,
	RedditoA Currency,
	MassimaleAnnuo Currency,
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Inps_AliquotaCollDettaglio Primary Key (IdInpsAliquota,InpsAliquotaAnno)
);

Create Table Irpef_AddizionaleRegionale  (
	IdRegione Varchar(3) NOT NULL,
	Anno Integer NOT NULL,
	ScaglioneDa Currency NOT NULL,
	ScaglioneA Currency,
	Aliquota Percentage,
	AliquotaMedia Percentage,
	AddImportoAnnuo Currency,
	RifNormativo Varchar(100),
	NumLeggeRegionale Varchar(10),
	DataLeggeRegionale Date,
	DataDecorrenza Date,
	UltimoAggiornamento Date,
	Note Note2,
Constraint pk_Irpef_AddizionaleRegionale Primary Key (IdRegione,Anno,ScaglioneDa)
);

Create Table Irpef_AddizionaleComunale  (
	CodCatastale Varchar(5) NOT NULL,
	Anno Integer NOT NULL,
	Esenzione Booleanint NOT NULL,
	ApplicazioneDa Currency NOT NULL,
	ApplicazioneA Currency,
	Aliquota Percentage,
	NumDelibera Varchar(10),
	DataDelibera Date,
	DataPubblicazione Date,
	Fascia Smallint,
	Flag Smallint,
	ImportoEsente Currency,
	UltimoAggiornamento Date,
	Custom Booleanint,
	Note Note,
Constraint pk_Irpef_AddizionaleComunale Primary Key (CodCatastale,Anno,Esenzione,ApplicazioneDa)
);

Create Table Irpef_AddizComunaleEsenz  (
	CodCatastale Varchar(5) NOT NULL,
	Anno Integer NOT NULL,
	SogliaReddito Currency,
	Aliquota Percentage,
	ImportoFisso Currency,
	NoteReddito Note,
	Note Note,
	UltimoAggiornamento Date,
Constraint pk_Irpef_AddizComunaleEsenz Primary Key (CodCatastale,Anno)
);

Create Table Inail_Aliquota  (
	IdInailAliquota Integer NOT NULL,
	InailAliquotaAnno Integer NOT NULL,
	MinimaleAnnuale Currency,
	MinimaleMensile Currency,
	MinimaleGiornaliero Currency,
	MinimaleOrario Currency,
	MassimaleAnnuale Currency,
	MassimaleMensile Currency,
	MassimaleGiornaliero Currency,
	MassimaleOrario Currency,
	ValidoDal Date,
	ValidoAl Date,
	Descrizione Note,
	IdTipo Smallint,
	Note Note2,
Constraint pk_Inail_Aliquota Primary Key (IdInailAliquota,InailAliquotaAnno)
);

Create Table ProgressivoAnno  (
	IdPosizione Integer NOT NULL,
	ImponibileInail Currency,
	ImponibileContribSociali Currency,
	ContributiSociali Currency,
	OneriDeducibili Currency,
	Detrazioni Currency,
	ImponibileIrpef Currency,
	IrpefLorda Currency,
	IrpefPagata Currency,
	IrpefCredito Currency,
Constraint pk_ProgressivoAnno Primary Key (IdPosizione)
);

Create Table Tfr_Mese  (
	IdPosizione Integer NOT NULL,
	RetribVirtuale Currency,
	RetribUltramensile Currency,
	TfrSpettante Currency,
	ImponibileTfr Currency,
	IdFormaPrevCompl Integer,
	BaseCalcolo Currency,
	BaseCalcoloPrevCompl Currency,
	QuotaPrevCompl Currency,
	PercPrevCompl Percentage,
	OneriSociali Currency,
	SgravioPrevCompl Currency,
Constraint pk_Tfr_Mese Primary Key (IdPosizione)
);

Create Table Tfr_Destinazione  (
	IdProfilo Integer NOT NULL,
	DataScelta Date NOT NULL,
	IdTipoScelta Varchar(3) NOT NULL,
	IdPrevObbl Varchar(4),
	IdPrevCompl Varchar(4),
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
	Rettifica Smallint,
	DataRichiestaCancellazione Date,
Constraint pk_Tfr_Destinazione Primary Key (IdProfilo,DataScelta)
);

Create Table Tfr_TipoScelta  (
	IdTipoScelta Varchar(3) NOT NULL,
	Descrizione Note,
Constraint pk_Tfr_TipoScelta Primary Key (IdTipoScelta)
);

Create Table Tfr_IscrizionePrevObbl  (
	IdPrevObbl Varchar(4) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Tfr_IscrizionePrevObbl Primary Key (IdPrevObbl)
);

Create Table Tfr_IscrizionePrevCompl  (
	IdPrevCompl Varchar(4) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Tfr_IscrizionePrevCompl Primary Key (IdPrevCompl)
);

Create Table Tfr_SceltaDestinazione  (
	IdProfilo Integer NOT NULL,
	DataScelta Date NOT NULL,
	IdFondoTesoreria Smallint,
	IdTipoQuotaPrevCompl Varchar(5),
	IdFormaPrevCompl Integer,
	MisuraPercPrevCompl Percentage,
	DataAdesione Date,
	Quir Booleanint,
Constraint pk_Tfr_SceltaDestinazione Primary Key (IdProfilo,DataScelta)
);

Create Table Tfr_TipoQuota  (
	IdTipoQuotaPrevCompl Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Tfr_TipoQuota Primary Key (IdTipoQuotaPrevCompl)
);

Create Table AlboCovip  (
	IdFormaPrevCompl Integer NOT NULL,
	Descrizione Note,
Constraint pk_AlboCovip Primary Key (IdFormaPrevCompl)
);

Create Table Tfr_MeseTesoreria  (
	IdPosizione Integer NOT NULL,
Constraint pk_Tfr_MeseTesoreria Primary Key (IdPosizione)
);

Create Table Tfr_Contribuzione  (
	IdPosizione Integer NOT NULL,
	ImportoCorrente Currency,
	Rivalutazione Currency,
	RestituzioneImpostaSost Currency,
Constraint pk_Tfr_Contribuzione Primary Key (IdPosizione)
);

Create Table Tfr_Prestazione  (
	IdPosizione Integer NOT NULL,
	ImportoLiquidazione Currency,
	ImportoAnticipazione Currency,
	RecuperoContribuzione Currency,
	ImpostaSostitutiva Currency,
Constraint pk_Tfr_Prestazione Primary Key (IdPosizione)
);

Create Table Tfr_FondoTesoreria  (
	IdFondoTesoreria Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Tfr_FondoTesoreria Primary Key (IdFondoTesoreria)
);

Create Table ProgressivoImpresa  (
	IdImpresa Integer NOT NULL,
	Anno Integer NOT NULL,
Constraint pk_ProgressivoImpresa Primary Key (IdImpresa,Anno)
);

Create Table Inps_LimiteImponibile  (
	IdLimiteImponibile Integer NOT NULL,
	IdUnitaMisura Smallint NOT NULL,
	ValidoDal Date NOT NULL,
	IdLimiteCategoria Smallint,
	IdLimiteQualifica Smallint,
	ValidoAl Date,
	Minimo Currency,
	Massimo Currency,
	FasciaDa Currency,
	FasciaA Currency,
	FasciaDenominazione Varchar(200),
	IdFrequenza Smallint,
	Riferimento Note,
	Note Note2,
	IdTipoLimite Smallint NOT NULL,
	Custom Booleanint,
Constraint pk_Inps_LimiteImponibile Primary Key (IdLimiteImponibile)
);

Create Table Inps_LimiteCategoria  (
	IdLimiteCategoria Smallint NOT NULL,
	Descrizione Varchar(200),
	IdLimiteCategoria2 Smallint NOT NULL,
Constraint pk_Inps_LimiteCategoria Primary Key (IdLimiteCategoria)
);

Create Table Inps_LimiteQualifica  (
	IdLimiteQualifica Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_LimiteQualifica Primary Key (IdLimiteQualifica)
);

Create Table Inps_LimiteCategoria2  (
	IdLimiteCategoria2 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_LimiteCategoria2 Primary Key (IdLimiteCategoria2)
);

Create Table Irpef_Scaglione  (
	IdScaglione Smallint NOT NULL,
	Anno Integer NOT NULL,
	RedditoDa Currency NOT NULL,
	RedditoA Currency,
	Aliquota Percentage,
	ValidoDal Date,
	ValidoAl Date,
	Note Note,
	UltimoAggiornamento Date,
Constraint pk_Irpef_Scaglione Primary Key (IdScaglione,Anno,RedditoDa)
);

Create Table Inps_ClasseAnf  (
	IdClasseAnf Smallint NOT NULL,
	IdInpsTipoAnf Varchar(4) NOT NULL,
	ValidoDal Date NOT NULL,
	IdInpsTipoAnf2 Smallint,
	ValidoAl Date,
	RedditoDa Currency,
	RedditoA Currency,
	C1 Currency,
	C2 Currency,
	C3 Currency,
	C4 Currency,
	C5 Currency,
	C6 Currency,
	C7 Currency,
	C8 Currency,
	C9 Currency,
	C10 Currency,
	C11 Currency,
	C12 Currency,
	Note Note,
	UltimoAggiornamento Timestamp,
Constraint pk_Inps_ClasseAnf Primary Key (IdClasseAnf,IdInpsTipoAnf,ValidoDal)
);

Create Table Inps_AssegnoFamMaggiorazione  (
	Anno Integer NOT NULL,
	IdMaggiorazione Smallint NOT NULL,
	MaggiorazioneFiglio1 Currency,
	MaggiorazioneFiglio2 Currency,
	MaggiorazioneFiglioMinore Currency,
	MaggiorazioneAltra1 Currency,
	MaggiorazioneAltra2 Currency,
	NoteMaggiorazioneAltra1 Note,
	NoteMaggiorazioneAltra2 Note,
	Note Note,
	UltimoAggiornamento Date,
Constraint pk_Inps_AssegnoFamMaggiorazione Primary Key (Anno,IdMaggiorazione)
);

Create Table Irpef_DetrazioneFiglio  (
	Anno Integer NOT NULL,
	IdDetrazione Smallint NOT NULL,
	NumFigli Smallint,
	DetrazioneAnnua Currency,
	MaggFiglioMinoreTreAnni Currency,
	MaggDisabile Currency,
	MaggNucleoAlmeno4Figli Currency,
	Note Note,
	UltimoAggiornamento Timestamp,
Constraint pk_Irpef_DetrazioneFiglio Primary Key (Anno,IdDetrazione)
);

Create Table Irpef_DetrazioneFamiliare  (
	Anno Integer NOT NULL,
	IdDetrazione Smallint NOT NULL,
	DetrazioneAnnua Currency,
Constraint pk_Irpef_DetrazioneFamiliare Primary Key (Anno,IdDetrazione)
);

Create Table Inps_TipoAnf2  (
	IdInpsTipoAnf2 Smallint NOT NULL,
	IdFrequenza Smallint NOT NULL,
	IdInpsTipoAnf Varchar(4) NOT NULL,
	Descrizione Varchar(200),
	UltimoAggiornamento Timestamp,
Constraint pk_Inps_TipoAnf2 Primary Key (IdInpsTipoAnf2)
);

Create Table Inps_AnfNota  (
	IdNota Smallint NOT NULL,
	ValidoDal Date NOT NULL,
	IdInpsTipoAnf Varchar(4),
	ValidoAl Date,
	Nota Note2,
	DataAggiornamento Date,
Constraint pk_Inps_AnfNota Primary Key (IdNota,ValidoDal)
);

Create Table Irpef_TipoReddito  (
	IdTipoReddito Smallint NOT NULL,
	Descrizione Varchar(200),
	Note Note,
Constraint pk_Irpef_TipoReddito Primary Key (IdTipoReddito)
);

Create Table Impresa_Contratto  (
	IdImpresa Integer NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	IdInpsSettore Integer NOT NULL,
	IdLimiteCategoria Smallint,
	IdArea Integer,
	IdInpsContratto Varchar(4),
	ValidoDal Date,
	ValidoAl Date,
	Attivo Smallint,
	Note Note,
Constraint pk_Impresa_Contratto Primary Key (IdImpresa,IdContrattoDettaglio)
);

Create Table F24  (
	IdDichiarazione Integer NOT NULL,
	ImportoCredito Currency,
	ImportoDebito Currency,
	IdDocumento Integer,
	IdExport Integer,
	IdEsito Integer,
Constraint pk_F24 Primary Key (IdDichiarazione)
);

Create Table Cud  (
	IdDichiarazione Integer NOT NULL,
	IdSoggetto Integer,
	DataAssunzione Date,
	IdDocumento Integer,
Constraint pk_Cud Primary Key (IdDichiarazione)
);

Create Table Assunzione  (
	IdAssunzione Integer NOT NULL,
	IdInpsTipoAssunzione Varchar(2) NOT NULL,
	IdTipoContratto Varchar(8),
	AssunzioneData Date,
	InpsMatricolaProvenienza Varchar(20),
	TempoDeterminato Booleanint,
	Trasformazione Date,
	ScadenzaContratto Date,
	FineProroga Date,
	ForzaMaggiore Booleanint,
	DescForzaMaggiore Note,
	IdImpresaDistacco Integer,
	AgriGgPreviste Smallint,
	AgriTipoLavoraz Varchar(200),
Constraint pk_Assunzione Primary Key (IdAssunzione)
);

Create Table Cessazione  (
	IdCessazione Integer NOT NULL,
	IdInpsTipoCessazione Varchar(2) NOT NULL,
	IdCoTipoCessazione Varchar(2),
	CessazioneData Date,
Constraint pk_Cessazione Primary Key (IdCessazione)
);

Create Table ContrattoIndennita_Livello  (
	IdIndennita Smallint NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	IdLivello Varchar(5) NOT NULL,
Constraint pk_ContrattoIndennita_Livello Primary Key (IdIndennita,IdContrattoDettaglio,IdLivello)
);

Create Table ElementoBaseImponibile  (
	IdBaseImponibile Integer NOT NULL,
	IdInpsContratto Varchar(4) NOT NULL,
	IdContrattoDettaglio Integer,
	Descrizione Varchar(200),
	Retributivo Booleanint,
	Note Note,
	Custom Booleanint,
Constraint pk_ElementoBaseImponibile Primary Key (IdBaseImponibile)
);

Create Table ContrattoVoce_BaseImp  (
	IdVoce Smallint NOT NULL,
	IdBaseImponibile Integer NOT NULL,
	Percentuale Percentage,
	Importo Currency,
	Custom Booleanint,
Constraint pk_ContrattoVoce_BaseImp Primary Key (IdVoce,IdBaseImponibile)
);

Create Table ContrattoAssenza  (
	IdAssenza Smallint NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	IdTipoLavoratore2 Smallint,
	GiornoDal Smallint,
	GiornoAl Smallint,
	GiorniInps Booleanint,
	MeseDal Smallint,
	MeseAl Smallint,
	Erogato Currency,
	IdBaseImponibile Integer,
	Percentuale Percentage,
	IntegrazioneInps Currency,
	IntegrazioneInpsPerc Percentage,
	RecuperoImpresa Currency,
	RecuperoImpresaPerc Percentage,
	ConservazionePosto Booleanint,
	AnzianitaDa Smallint,
	AnzianitaA Smallint,
	IntegrazioneInail Currency,
	IntegrazioneInailPerc Percentage,
	Fiscale Booleanint,
	Contributivo Booleanint,
	ValidoDal Date,
	ValidoAl Date,
	IdInpsEvento Varchar(4) NOT NULL,
	Note Note,
	DataAggiornamento Date,
	Custom Booleanint,
Constraint pk_ContrattoAssenza Primary Key (IdAssenza,IdContrattoDettaglio)
);

Create Table Uniemens  (
	IdDichiarazione Integer NOT NULL,
	IdTipoComposizione Varchar(3),
	IdDocumento Integer,
	IdExport Integer,
	IdEsito Integer,
Constraint pk_Uniemens Primary Key (IdDichiarazione)
);

Create Table Cnce_TipoAssunzione  (
	IdTipoAssunzione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_TipoAssunzione Primary Key (IdTipoAssunzione)
);

Create Table Cnce_TipoCessazione  (
	IdTipoCessazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_TipoCessazione Primary Key (IdTipoCessazione)
);

Create Table Cnce_LivelloQualifica  (
	IdLivelloQualifica Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_LivelloQualifica Primary Key (IdLivelloQualifica)
);

Create Table Cnce_Mansione  (
	IdMansione Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_Mansione Primary Key (IdMansione)
);

Create Table Inail_Contratto  (
	IdContratto Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inail_Contratto Primary Key (IdContratto)
);

Create Table Inail_Professione  (
	IdInailProfessione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inail_Professione Primary Key (IdInailProfessione)
);

Create Table Inail_Qualifica  (
	IdInailQualifica Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inail_Qualifica Primary Key (IdInailQualifica)
);

Create Table ElementoBaseImp_BaseImp  (
	IdBaseImponibile1 Integer NOT NULL,
	IdBaseImponibile2 Integer NOT NULL,
	Percentuale Percentage,
	Importo Currency,
	Custom Booleanint,
Constraint pk_ElementoBaseImp_BaseImp Primary Key (IdBaseImponibile1,IdBaseImponibile2)
);

Create Table RiduzioneInps  (
	IdRiduzioneInps Integer NOT NULL,
	Descrizione Varchar(200),
	IdArea Integer,
	Ivs Percentage,
	Ivs2 Percentage,
	Ds Percentage,
	Ds2 Percentage,
	Ds3 Percentage,
	Cuaf Percentage,
	Cig Percentage,
	Malattia Percentage,
	Maternita Percentage,
	Mobilita Percentage,
	Tfr Percentage,
	Cigs Percentage,
	Cigs2 Percentage,
	Solidarieta Percentage,
	IdTipo Smallint,
	Importo Currency,
	Limite Currency,
	ValidoDal Date,
	ValidoAl Date,
	Note Note,
Constraint pk_RiduzioneInps Primary Key (IdRiduzioneInps)
);

Create Table Posizione_RiduzioneInps  (
	IdPosizione Integer NOT NULL,
	IdRiduzioneInps Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
Constraint pk_Posizione_RiduzioneInps Primary Key (IdPosizione,IdRiduzioneInps,IdTipoFoglio)
);

Create Table StatoDichiarazione  (
	IdStatoDichiarazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_StatoDichiarazione Primary Key (IdStatoDichiarazione)
);

Create Table Uniemens_Posizione  (
	IdDichiarazione Integer NOT NULL,
	IdPosizione Integer NOT NULL,
	IdTipoRegolarizzaz Varchar(3) NOT NULL,
	Elimina Booleanint,
Constraint pk_Uniemens_Posizione Primary Key (IdDichiarazione,IdPosizione)
);

Create Table Co_EntePrevidenziale  (
	IdEntePrevidenziale Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Co_EntePrevidenziale Primary Key (IdEntePrevidenziale)
);

Create Table Co_TipoCessazione  (
	IdTipoCessazione Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Co_TipoCessazione Primary Key (IdTipoCessazione)
);

Create Table Co_TipoContratto  (
	IdTipoContratto Varchar(8) NOT NULL,
	Descrizione Varchar(200),
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Co_TipoContratto Primary Key (IdTipoContratto)
);

Create Table Co_Trasformazione  (
	IdTrasformazione Varchar(2) NOT NULL,
	Descrizione Varchar(200),
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Co_Trasformazione Primary Key (IdTrasformazione)
);

Create Table Co  (
	IdDichiarazione Integer NOT NULL,
	IdTipoCo Smallint,
	IdTipoComunicazione Smallint,
	IdArgomento Smallint,
	IdEntePrevidenziale Smallint,
	IdTipoCessazione Varchar(2),
	IdTrasformazione Varchar(2),
	IdTipoContratto Varchar(8),
	IdTipoTrasferimento Smallint,
	IdSoggetto Integer,
	AssunzioneData Date,
	IdProfessione Varchar(15),
	IdTitoloStudio Varchar(15),
	IdEsito Integer,
	IdExport Integer,
	IdSoggettoAbilitato Varchar(3),
Constraint pk_Co Primary Key (IdDichiarazione)
);

Create Table Co_Tipo  (
	IdTipoCo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Co_Tipo Primary Key (IdTipoCo)
);

Create Table Co_Argomento  (
	IdArgomento Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Co_Argomento Primary Key (IdArgomento)
);

Create Table Co_TipoComunicazione  (
	IdTipoComunicazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Co_TipoComunicazione Primary Key (IdTipoComunicazione)
);

Create Table Co_TipoTrasferimento  (
	IdTipoTrasferimento Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Co_TipoTrasferimento Primary Key (IdTipoTrasferimento)
);

Create Table Dichiarazione  (
	IdDichiarazione Integer NOT NULL,
	IdTipoDichiarazione Smallint NOT NULL,
	IdStatoDichiarazione Smallint,
	Anno Integer,
	Mese Smallint,
	IdSoggetto Integer,
	IdAutore Integer,
	Note Note,
	DataCreazione Date,
	UltimaElaborazione Timestamp,
	UltimaElaborazioneUser IdUser,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_Dichiarazione Primary Key (IdDichiarazione)
);

Create Table TipoDichiarazione  (
	IdTipoDichiarazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoDichiarazione Primary Key (IdTipoDichiarazione)
);

Create Table Dmag_AssCategoria  (
	IdAssCategoria Smallint NOT NULL,
	Descrizione Varchar(200),
	Sigla Varchar(100),
Constraint pk_Dmag_AssCategoria Primary Key (IdAssCategoria)
);

Create Table Inail_VoceTariffa  (
	IdVoceTariffa Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inail_VoceTariffa Primary Key (IdVoceTariffa)
);

Create Table Tfr_Fondinps  (
	IdPosizione Integer NOT NULL,
	ImportoCorrente Currency,
	ImportoPregresso Currency,
Constraint pk_Tfr_Fondinps Primary Key (IdPosizione)
);

Create Table Inps_FondoSpeciale  (
	IdFondoSpeciale Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_FondoSpeciale Primary Key (IdFondoSpeciale)
);

Create Table Inps_TipoLavoratore_Fondo  (
	IdFondoSpeciale Smallint NOT NULL,
	IdInpsTipoLavoratore Varchar(3) NOT NULL,
Constraint pk_Inps_TipoLavoratore_Fondo Primary Key (IdFondoSpeciale,IdInpsTipoLavoratore)
);

Create Table ContrattoNota  (
	IdContrattoDettaglio Integer NOT NULL,
	IdTipoNota Smallint NOT NULL,
	Nota Note2,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_ContrattoNota Primary Key (IdContrattoDettaglio,IdTipoNota)
);

Create Table ContrattoTipoNota  (
	IdTipoNota Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_ContrattoTipoNota Primary Key (IdTipoNota)
);

Create Table TipoCalcolo  (
	IdTipoCalcolo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoCalcolo Primary Key (IdTipoCalcolo)
);

Create Table ContrattoFestivitaRetrib  (
	IdContrattoDettaglio Integer NOT NULL,
	IdCoefficiente Smallint,
	Opzione Smallint,
	OpzioneFestSopp Smallint,
	OpzioneSabato Smallint,
	Note Note,
	Custom Booleanint,
Constraint pk_ContrattoFestivitaRetrib Primary Key (IdContrattoDettaglio)
);

Create Table CategoriaContrattoVoce2  (
	IdCategoria2 Smallint NOT NULL,
	Descrizione Varchar(400),
Constraint pk_CategoriaContrattoVoce2 Primary Key (IdCategoria2)
);

Create Table TipoRateo  (
	IdTipoRateo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoRateo Primary Key (IdTipoRateo)
);

Create Table PosizioneRateo  (
	IdPosizione Integer NOT NULL,
	IdTipoRateo Smallint NOT NULL,
	AnnoPrecedente Arithmetic2,
	Maturato Arithmetic2,
	Compensazione Arithmetic2,
	Goduto Arithmetic2,
	Liquidato Arithmetic2,
	Residuo Arithmetic2,
	Escluso Arithmetic2,
	TassoMensile Percentage,
	IdUnitaMisura Smallint NOT NULL,
	NoRecalc Booleanint,
Constraint pk_PosizioneRateo Primary Key (IdPosizione,IdTipoRateo)
);

Create Table ContrattoRateo  (
	IdContrattoDettaglio Integer NOT NULL,
	IdRateo Smallint NOT NULL,
	IdCoefficiente Smallint,
	IdTipoLavoratore2 Smallint,
	Nota Note,
	Custom Booleanint,
Constraint pk_ContrattoRateo Primary Key (IdContrattoDettaglio,IdRateo)
);

Create Table Contratto_Festivita  (
	IdContrattoDettaglio Integer NOT NULL,
	IdTipoFestivita Smallint NOT NULL,
	Note Note,
Constraint pk_Contratto_Festivita Primary Key (IdContrattoDettaglio,IdTipoFestivita)
);

Create Table ContrattoRateoValore  (
	IdContrattoDettaglio Integer NOT NULL,
	IdRateo Smallint NOT NULL,
	IdTipoRateo Smallint NOT NULL,
	IdAnzianita Smallint,
	IdUnitaMisura Smallint NOT NULL,
	IdUnitaMisura2 Smallint NOT NULL,
	Valore Arithmetic2,
Constraint pk_ContrattoRateoValore Primary Key (IdContrattoDettaglio,IdRateo,IdTipoRateo)
);

Create Table ContrattoFestivitaRetrib2  (
	IdContrattoDettaglio Integer NOT NULL,
	IdTipoFestivita Smallint NOT NULL,
	FrazioneRetribMensile Percentage,
	FrazioneRetribSett Percentage,
	FrazioneRetribMinima Percentage,
	MaggiorazioneOraria Percentage,
	TrattamentoDomenicale Booleanint,
	OreRiposo Arithmetic,
	OreRetribuzione Arithmetic,
	ImportoFisso Currency,
	Opzione Smallint,
Constraint pk_ContrattoFestivitaRetrib2 Primary Key (IdContrattoDettaglio,IdTipoFestivita)
);

Create Table ContrattoAnzianita  (
	IdContrattoDettaglio Integer NOT NULL,
	IdAnzianita Smallint NOT NULL,
	Descrizione Varchar(200),
	AnzianitaDa Smallint,
	AnzianitaA Smallint,
	IdUnitaMisura Smallint,
Constraint pk_ContrattoAnzianita Primary Key (IdContrattoDettaglio,IdAnzianita)
);

Create Table UnitaMisura  (
	IdUnitaMisura Smallint NOT NULL,
	Descrizione Varchar(200),
	Descrizione2 Varchar(10),
Constraint pk_UnitaMisura Primary Key (IdUnitaMisura)
);

Create Table AssegnoSostegno  (
	IdComune Varchar(8) NOT NULL,
	Anno Smallint NOT NULL,
	Ise Currency,
	Importo Currency,
Constraint pk_AssegnoSostegno Primary Key (IdComune,Anno)
);

Create Table NucleoFamiliare  (
	IdPosizione Integer NOT NULL,
	Componenti Smallint,
	Figli Smallint,
	FigliMinori Smallint,
	FigliInabili Smallint,
	Reddito Currency,
	RedditoAnno Integer,
	OrfaniInabili Smallint,
	OrfaniMinori Smallint,
	NipotiACarico Smallint,
	Note Note,
Constraint pk_NucleoFamiliare Primary Key (IdPosizione)
);

Create Table Tfr_Anno  (
	IdLavoratore Integer NOT NULL,
	Anno Integer NOT NULL,
	TfrFondoNonRivalut Currency,
	OneriSociali Currency,
	Anticipi Currency,
	AnticipiTassazOrdinaria Currency,
	RivalutazLorda Currency,
	ImpostaSuRivalutazione Currency,
	QuotaTfr Currency,
	ImpostaPagataSuAnticipaz Currency,
	TfrNetto Currency,
	IndiceRivalutazione Percentage,
	RivalutazioneLorda Currency,
	Rad Currency,
	QuoteTrasferite Currency,
	RetribVirtuale Currency,
	RetribUltramensile Currency,
	NoRecalc Booleanint,
	UltimaModificaUser IdUser,
	UltimaModifica Timestamp,
Constraint pk_Tfr_Anno Primary Key (IdLavoratore,Anno)
);

Create Table AltreAliquote  (
	Anno Integer NOT NULL,
	TfrAliquotaFondoSociale Percentage,
	TfrAliquotaTassazioneSeparata Percentage,
Constraint pk_AltreAliquote Primary Key (Anno)
);

Create Table Tfr_Detrazione  (
	IdDetrazioneTfr Smallint NOT NULL,
	IdTipoDetrazione Smallint NOT NULL,
	ValidoDal Date,
	ValidoAl Date,
	PartTime Percentage,
	MesiInteressati Smallint,
	ImportoMese Currency,
	AnniInteressati Integer,
	ImportoAnno Currency,
	Detrazione Currency,
Constraint pk_Tfr_Detrazione Primary Key (IdDetrazioneTfr)
);

Create Table Tfr_Prestazione2  (
	IdPrestazione Integer NOT NULL,
	IdSoggetto Integer,
	IdImpresa Integer,
	DataAssunzione Date,
	DataCessazione Date,
	IdPosizione Integer,
	DataPrestazione Date,
	Importo Currency,
Constraint pk_Tfr_Prestazione2 Primary Key (IdPrestazione)
);

Create Table Tfr_Situazione_Detrazione  (
	IdLavoratore Integer NOT NULL,
	Anno Integer NOT NULL,
	IdDetrazioneTfr Smallint NOT NULL,
Constraint pk_Tfr_Situazione_Detrazione Primary Key (IdLavoratore,Anno,IdDetrazioneTfr)
);

Create Table Tfr_TipoDetrazione  (
	IdTipoDetrazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Tfr_TipoDetrazione Primary Key (IdTipoDetrazione)
);

Create Table ProfiloPrevidenziale  (
	IdProfilo Integer NOT NULL,
	IdAliquotaPrevidenziale Integer,
	IdRiduzioneInps Integer,
	AliquotaTotCaricoLav Percentage,
	AliquotaTotCaricoDat Percentage,
	IdAliquotaAddizDat Smallint,
	IdAliquotaAddizLav Smallint,
	ContribFisso Booleanint,
	ContribTotCaricoLav Currency,
	ContribTotCaricoDat Currency,
	IdLimiteImponibile Integer,
	IdTipoIncentivo Varchar(5),
	IdEnteFinanziatore Varchar(4),
	Incentivo Currency,
	HaDirittoAnf Booleanint,
	RetribMinGg Currency,
	RetribMinHh Currency,
	RetribConvHh Currency,
	RetribConvGg Currency,
	ContribHh Currency,
	RegimePost95 Booleanint,
	IdTipoContribDom Smallint,
	RetribDomDa Currency,
	RetribDomNoCuaf Booleanint,
	Note Note,
	UltimaModificaUser IdUser,
	UltimaModifica Timestamp,
Constraint pk_ProfiloPrevidenziale Primary Key (IdProfilo)
);

Create Table PosizioneFiscaleAnno  (
	IdLavoratore Integer NOT NULL,
	AnnoRiferimento Integer NOT NULL,
	ImpostaLorda Currency,
	ImpostaNetta Currency,
	ImponibileImpSostitutiva Currency,
	ImpostaSostitutivaNetta Currency,
	ImponibileAddizionale Currency,
	AddizIdComune0101 Varchar(8),
	AddizIdComune3112 Varchar(8),
	AddizIdComune0101Succ Varchar(8),
	AddizComunaleAliquota Percentage,
	AddizComunale1 Currency,
	AddizComunale1Rate Smallint,
	AddizComunale2 Currency,
	AddizComunale2Rate Smallint,
	AddizIdRegione3112 Varchar(3),
	AddizRegionaleAliquota Percentage,
	AddizRegionale Currency,
	AddizRegionaleRate Smallint,
	DeduzAbitazione Currency,
	DeduzAltre Currency,
	DeduzOneri Currency,
	RedditoComplessivo Currency,
	RedditoImponibile Currency,
	Rettifiche Currency,
	Sanzioni Currency,
	Interessi Percentage,
	MeseConguaglio Smallint,
	RedditoFamiliare Currency,
	CreditoRenzi Currency,
	Opzione Smallint,
	NoRecalc Booleanint,
	Note Note,
	UltimaModificaUser IdUser,
	UltimaModifica Timestamp,
Constraint pk_PosizioneFiscaleAnno Primary Key (IdLavoratore,AnnoRiferimento)
);

Create Table PosizionePrevidenziale  (
	IdPosizione Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
	IdAliquotaPrevidenziale Integer,
	IdRiduzioneInps Integer,
	IdLimiteImponibile Integer,
	IdAliquotaAddizDat Smallint,
	IdAliquotaAddizLav Smallint,
	Imponibile Currency,
	AliquotaTotCaricoLav Percentage,
	AliquotaTotCaricoDat Percentage,
	ContribTotCaricoLav Currency,
	ContribTotCaricoDat Currency,
	ContribAggiuntiva Currency,
	ContribFisso Booleanint,
	AltriContribNonReddito Currency,
	HaDirittoAnf Booleanint,
	RetribMinGg Currency,
	RetribMinHh Currency,
	RetribConvGg Currency,
	RetribConvHh Currency,
	ContribHh Currency,
	ApplicatoMinimale Booleanint,
	IdTipoContribDom Smallint,
	RetribDomDa Currency,
	RetribDomNoCuaf Booleanint,
	RetribAggiuntAnticipata Currency,
	RetribAggiuntAnticipataGg Smallint,
	NoRecalc Booleanint,
	Note Note,
Constraint pk_PosizionePrevidenziale Primary Key (IdPosizione,IdTipoFoglio)
);

Create Table ProfiloFiscale  (
	IdProfilo Integer NOT NULL,
	ImponibileIrpefPresunto Currency,
	Coniuge Smallint,
	FigliMaggiori3anni Smallint,
	FigliMinori3Anni Smallint,
	RipartizFigli Percentage,
	FigliDisabiliMaggiori3Anni Smallint,
	FigliDisabiliMinori3Anni Smallint,
	DetrazConiugeAlFiglio Booleanint,
	AltroFamiliare Percentage,
	RipartizAltroFamiliare Percentage,
	RipartizFigliDisabili Percentage,
	RipartizFamigliaNum Percentage,
	AliquotaIrpef Percentage,
	GgLavoro Smallint,
	GgPensione Smallint,
	OpzioneDetrazione Smallint,
	OpzioneDetrazF Smallint,
	OpzioneDetrazL Smallint,
	OpzioneRedditoPresunto Smallint,
	Opzione80Renzi Smallint,
	OpzioneAltro Smallint,
	Note Note,
	UltimaModificaUser IdUser,
	UltimaModifica Timestamp,
Constraint pk_ProfiloFiscale Primary Key (IdProfilo)
);

Create Table AliquotaPrevidenziale  (
	IdAliquotaPrevidenziale Integer NOT NULL,
	IdEntePrevidenziale Smallint,
	IdAliquotaTipoLav Integer,
	IdInpsTipoLavoratore Varchar(3),
	IdArea Integer,
	Descrizione Varchar(200),
	AliquotaTotDatore Percentage,
	AliquotaTotLav Percentage,
	Ivs Percentage,
	Ds Percentage,
	Tfr Percentage,
	Cuaf Percentage,
	Cig Percentage,
	Malattia Percentage,
	Maternita Percentage,
	Ivs2 Percentage,
	Ds2 Percentage,
	Ds3 Percentage,
	Cigs Percentage,
	Cigs2 Percentage,
	Mobilita Percentage,
	AliquotaAggiuntiva Percentage,
	Fi1 Percentage,
	Fi2 Percentage,
	CtrAdd1 Percentage,
	CtrAdd2 Percentage,
	Prct Percentage,
	InpsTabella Varchar(10),
	ValidoDal Date,
	ValidoAl Date,
	Note Note,
	Custom Booleanint,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_AliquotaPrevidenziale Primary Key (IdAliquotaPrevidenziale)
);

Create Table PosizioneFamiliare  (
	IdPosizione Integer NOT NULL,
	IdAnagrafica Integer NOT NULL,
	Cf Varchar(16),
	IdRapportoParentela Smallint,
	CaricoPercentuale Percentage,
	CaricoDecorrenza Date,
	Detrazione Currency,
	IdStatoCivile Smallint,
	IdTipoOccupazione Smallint,
	Opzione Smallint,
	NoRecalc Booleanint,
Constraint pk_PosizioneFamiliare Primary Key (IdPosizione,IdAnagrafica)
);

Create Table ProfiloInail  (
	IdProfilo Integer NOT NULL,
	IdInailProfessione Smallint,
	IdInailQualifica Varchar(2),
	IdInailTipoRapporto Smallint,
	IdInailContratto Smallint,
	IdLimiteContrib Smallint,
	IdRetribConv Smallint,
	RiduzioneTasso Percentage,
	TassoRischio Percentage,
	IdTipoImponibile Smallint,
	IdGruppo2 Smallint,
	IdGruppo Smallint,
	PatCustom Varchar(20),
	IdPat Varchar(20),
	IdInailQualificaCu Varchar(2),
	IdInailComune Varchar(8),
Constraint pk_ProfiloInail Primary Key (IdProfilo)
);

Create Table PosizioneInail  (
	IdPosizione Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
	IdInailProfessione Smallint,
	IdInailQualifica Varchar(2),
	IdInailTipoRapporto Smallint,
	IdLimiteContrib Smallint,
	IdRetribConv Smallint,
	TassoRischio Percentage,
	RiduzioneTasso Percentage,
	PremioInail Currency,
	Imponibile Currency,
	IdTipoImponibile Smallint,
	ImponibileEsposto Currency,
	TassoEsposto Currency,
	IdGruppo2 Smallint,
	IdGruppo Smallint,
	DurataRapportoGg Arithmetic,
	DurataRapportoMM Arithmetic,
	PatCustom Varchar(20),
	IdPat Varchar(20),
	IdInailQualificaCu Varchar(2),
	ContribTotCaricoLav Currency,
	ContribTotCaricoDat Currency,
	AltriCompensi Currency,
	IdInailComune Varchar(8),
	NoRecalc Booleanint,
Constraint pk_PosizioneInail Primary Key (IdPosizione,IdTipoFoglio)
);

Create Table Inail_TipoRapporto  (
	IdInailTipoRapporto Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inail_TipoRapporto Primary Key (IdInailTipoRapporto)
);

Create Table Inail_RischioAssicurato  (
	IdRischio Integer NOT NULL,
	IdImpresa Integer,
	IdSedeImpresa Smallint,
	Pat Varchar(20) NOT NULL,
	IdVoceTariffa Integer NOT NULL,
	PeriodoDal Date,
	PeriodoAl Date,
	TassoInfortuniTeorico Percentage,
	TassoInfortuniApplicato Percentage,
	RischioSilAsb Percentage,
	OscillazioneSilicosi Percentage,
	Agevolazione Percentage,
	IdTipoAgevolazione Integer,
	ArtigianoRetribConvenz Currency,
	ArtigianoPremio Currency,
Constraint pk_Inail_RischioAssicurato Primary Key (IdRischio)
);

Create Table Inail_Gruppo  (
	IdGruppo Smallint NOT NULL,
	Descrizione Varchar(100),
Constraint pk_Inail_Gruppo Primary Key (IdGruppo)
);

Create Table Inail_Gruppo2  (
	IdGruppo2 Smallint NOT NULL,
	IdGruppo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inail_Gruppo2 Primary Key (IdGruppo2,IdGruppo)
);

Create Table NumerazioneUnica  (
	Numerazione Integer NOT NULL,
	IdTitolareDati Integer NOT NULL,
	IdPosizione Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
	IdImpresa Integer,
	Annullato Booleanint,
	DataAnnullamento Date,
	Eliminato Booleanint,
	DataEliminazione Date,
Constraint pk_NumerazioneUnica Primary Key (Numerazione,IdTitolareDati)
);

Create Table Inail_Pat  (
	IdPat Varchar(20) NOT NULL,
	IdSedeInail Integer,
	InizioData Date,
	CessazioneData Date,
	ControCodice Varchar(5),
	Note Note,
Constraint pk_Inail_Pat Primary Key (IdPat)
);

Create Table StatoPosizione  (
	IdStatoPosizione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_StatoPosizione Primary Key (IdStatoPosizione)
);

Create Table TipoLimite  (
	IdTipoLimite Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoLimite Primary Key (IdTipoLimite)
);

Create Table ElementoRetribLimite  (
	IdElemento Integer NOT NULL,
	Anno Integer NOT NULL,
	FinoA Currency,
	Eccedente Currency,
	IrpefAliquota Percentage,
Constraint pk_ElementoRetribLimite Primary Key (IdElemento,Anno)
);

Create Table PosizioneFiscale  (
	IdPosizione Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
	RedditoComplessivo Currency,
	RedditoImponibile Currency,
	AliquotaIrpef Percentage,
	ImpostaLorda Currency,
	ImpostaNetta Currency,
	ImponibileImpSostitutiva Currency,
	ImpostaSostitutivaNetta Currency,
	IdStatoEstero Integer,
	IdComune Varchar(8),
	AddizComunale1 Currency,
	AddizComunale2 Currency,
	AddizRegionale Currency,
	DeduzApplicate Currency,
	DetrazApplicate Currency,
	NoRecalc Booleanint,
	Note Note,
	UltimaModificaUser IdUser,
	UltimaModifica Timestamp,
Constraint pk_PosizioneFiscale Primary Key (IdPosizione,IdTipoFoglio)
);

Create Table PosizioneFiscaleAnnoDetraz  (
	IdLavoratore Integer NOT NULL,
	AnnoRiferimento Integer NOT NULL,
	FigliMinori3Anni Smallint,
	FigliMaggiori3Anni Smallint,
	RipartizFigli Percentage,
	FigliDisabiliMinori3Anni Smallint,
	FigliDisabiliMaggiori3Anni Smallint,
	RipartizFigliDisabili Percentage,
	AltroFamiliare Smallint,
	RipartizAltroFamiliare Percentage,
	Coniuge Smallint,
	DetrazOneri Currency,
	DetrazConiuge Currency,
	DetrazConiugeAlFiglio Booleanint,
	DetrazFigli Currency,
	DetrazFamigliaNumerosa Currency,
	DetrazAltriFamiliari Currency,
	DetrazAltre Currency,
	DetrazRedditoLavoro Currency,
	DetrazRedditoAltro Currency,
	GgPensione Smallint,
	GgLavoro Smallint,
	NoRecalc Booleanint,
	Opzione Smallint,
	Note Note,
	UltimaModificaUser IdUser,
	UltimaModifica Timestamp,
Constraint pk_PosizioneFiscaleAnnoDetraz Primary Key (IdLavoratore,AnnoRiferimento)
);

Create Table PosizioneFiscaleDetraz  (
	IdPosizione Integer NOT NULL,
	FigliMinori3Anni Smallint,
	FigliMaggiori3Anni Smallint,
	RipartizFigli Percentage,
	FigliDisabiliMaggiori3Anni Smallint,
	FigliDisabiliMinori3Anni Smallint,
	RipartizFigliDisabili Percentage,
	AltroFamiliare Smallint,
	RipartizAltroFamiliare Percentage,
	RipartizFamigliaNum Percentage,
	Coniuge Smallint,
	DetrazOneri Currency,
	DetrazConiuge Currency,
	DetrazConiugeAlFiglio Booleanint,
	DetrazFigli Currency,
	DetrazFamigliaNum Currency,
	DetrazAltriFamiliari Currency,
	DetrazAltre Currency,
	DetrazRedditoLavoro Currency,
	DetrazRedditoAltro Currency,
	GgPensione Smallint,
	GgLavoro Smallint,
	NoRecalc Booleanint,
	NoDetrazioni Booleanint,
	Opzione Smallint,
	Note Note,
	UltimaModificaUser IdUser,
	UltimaModifica Timestamp,
Constraint pk_PosizioneFiscaleDetraz Primary Key (IdPosizione)
);

Create Table FondoAnte95_PartPens  (
	IdDatoRetributivo Integer NOT NULL,
	IncrementoArt2L336 Currency,
	PersViaggFinoAl Date,
	DalU12 Date,
	AlU12 Date,
	RetribPensionabileU12 Currency,
	RetribAccessoriaU12 Currency,
Constraint pk_FondoAnte95_PartPens Primary Key (IdDatoRetributivo)
);

Create Table PosizioneInailAnno  (
	IdLavoratore Integer NOT NULL,
	AnnoRiferimento Integer NOT NULL,
	TassoRischio Percentage,
	RetribuzioneAp Currency,
	PremioInail Currency,
	AddizionaleAc Percentage,
	RataAnticipataAp Currency,
	RegolazioneAp Currency,
	RetribPresuntaAc Currency,
	TassoAc Percentage,
	RataAnticipataAc Currency,
	AddizionaleAp Percentage,
	RataAnticipataDovutaAc Currency,
	PremioDovutoAp Currency,
	NoRecalc Booleanint,
Constraint pk_PosizioneInailAnno Primary Key (IdLavoratore,AnnoRiferimento)
);

Create Table Inail_RetribConvenzionale  (
	IdRetribConv Smallint NOT NULL,
	Descrizione Varchar(200),
	IdInpsQualifica1 Varchar(2),
	IdSettore Smallint,
	Settore Varchar(100),
Constraint pk_Inail_RetribConvenzionale Primary Key (IdRetribConv)
);

Create Table Inail_LimiteContributivo2  (
	IdLimiteContrib Smallint NOT NULL,
	Anno Integer NOT NULL,
	IdUnitaMisura Smallint NOT NULL,
	Minimale Currency,
	Massimale Currency,
Constraint pk_Inail_LimiteContributivo2 Primary Key (IdLimiteContrib,Anno)
);

Create Table Inail_RetribConvenzionale2  (
	IdRetribConv Smallint NOT NULL,
	Anno Integer NOT NULL,
	IdUnitaMisura Smallint NOT NULL,
	Retribuzione Currency,
Constraint pk_Inail_RetribConvenzionale2 Primary Key (IdRetribConv,Anno)
);

Create Table TipoUniemens  (
	IdTipoComposizione Varchar(3) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoUniemens Primary Key (IdTipoComposizione)
);

Create Table Dr_CausaleVersMal  (
	IdCausaleVersMal Varchar(5) NOT NULL,
	Descrizione Varchar(700),
Constraint pk_Dr_CausaleVersMal Primary Key (IdCausaleVersMal)
);

Create Table Dr_CausaleRecMal  (
	IdCausaleRecMal Varchar(5) NOT NULL,
	Descrizione Varchar(400),
Constraint pk_Dr_CausaleRecMal Primary Key (IdCausaleRecMal)
);

Create Table Dr_CausaleRestituzAnf  (
	IdCausaleRestituzAnf Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_CausaleRestituzAnf Primary Key (IdCausaleRestituzAnf)
);

Create Table Dr_CausaleRecAnf  (
	IdCausaleRecAnf Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_CausaleRecAnf Primary Key (IdCausaleRecAnf)
);

Create Table Dr_CausaleContribAddCigo  (
	IdCausaleContribAddCigo Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_CausaleContribAddCigo Primary Key (IdCausaleContribAddCigo)
);

Create Table Dr_CausaleCongCigo  (
	IdCausaleCongCigo Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_CausaleCongCigo Primary Key (IdCausaleCongCigo)
);

Create Table Dr_CausaleContribAddCigs  (
	IdCausaleContribAddCigs Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_CausaleContribAddCigs Primary Key (IdCausaleContribAddCigs)
);

Create Table Dr_CausaleCongCigs  (
	IdCausaleCongCigs Varchar(5) NOT NULL,
	Descrizione Varchar(300),
Constraint pk_Dr_CausaleCongCigs Primary Key (IdCausaleCongCigs)
);

Create Table Dr_CausaleStatCigs  (
	IdCausaleStatCigs Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_CausaleStatCigs Primary Key (IdCausaleStatCigs)
);

Create Table Dr_CausaleTrattPens  (
	IdCausaleTrattPens Varchar(5) NOT NULL,
	Descrizione Varchar(200),
	ValidoAl Date,
Constraint pk_Dr_CausaleTrattPens Primary Key (IdCausaleTrattPens)
);

Create Table Dr_CausaleStatDivAbile  (
	IdCausaleStatDivAbile Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_CausaleStatDivAbile Primary Key (IdCausaleStatDivAbile)
);

Create Table Dr_BeneficioDivAbileRegione  (
	IdBeneficioDivAbileReg Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_BeneficioDivAbileRegione Primary Key (IdBeneficioDivAbileReg)
);

Create Table Dr_CausaleADebito  (
	IdCausaleADebito Varchar(5) NOT NULL,
	Descrizione Note,
Constraint pk_Dr_CausaleADebito Primary Key (IdCausaleADebito)
);

Create Table Dr_CausaleACredito  (
	IdCausaleACredito Varchar(5) NOT NULL,
	Descrizione Varchar(200),
	ValidoDal Date,
	ValidoAl Date,
	Percentuale Percentage,
Constraint pk_Dr_CausaleACredito Primary Key (IdCausaleACredito)
);

Create Table TipoVarRetr  (
	IdTipoVarRetr Varchar(6) NOT NULL,
	Descrizione Note2,
Constraint pk_TipoVarRetr Primary Key (IdTipoVarRetr)
);

Create Table Tfr_CausaleMcADeb  (
	IdCausaleMcADeb Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Tfr_CausaleMcADeb Primary Key (IdCausaleMcADeb)
);

Create Table Tfr_CausaleMcACred  (
	IdCausaleMcACred Varchar(5) NOT NULL,
	Descrizione Varchar(300),
Constraint pk_Tfr_CausaleMcACred Primary Key (IdCausaleMcACred)
);

Create Table Dr_CausaleVersMat  (
	IdCausaleVersMat Varchar(5) NOT NULL,
	Descrizione Varchar(700),
Constraint pk_Dr_CausaleVersMat Primary Key (IdCausaleVersMat)
);

Create Table Dr_CausaleRecMat  (
	IdCausaleRecMat Varchar(5) NOT NULL,
	Descrizione Varchar(400),
Constraint pk_Dr_CausaleRecMat Primary Key (IdCausaleRecMat)
);

Create Table Dr_ContribAggiuntiva  (
	IdDatoRetributivo Integer NOT NULL,
	Contrib1PerCentoImpCtrAgg Currency,
	Contrib1PerCentoContribAggCorr Currency,
	Regolarizz1PerCentoContribAgg Currency,
	Regolarizz1PerCentoRecAggReg Currency,
Constraint pk_Dr_ContribAggiuntiva Primary Key (IdDatoRetributivo)
);

Create Table Dr_FondoIntegrativo  (
	IdDatoRetributivo Integer NOT NULL,
	ImponibileFondoIntegr Currency,
	ContributoFondoIntegr Currency,
Constraint pk_Dr_FondoIntegrativo Primary Key (IdDatoRetributivo)
);

Create Table Dr_Malattia  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_Dr_Malattia Primary Key (IdDatoRetributivo)
);

Create Table Dr_MalattiaADebito  (
	IdDatoRetributivo Integer NOT NULL,
	IdMalattiaADebito Smallint NOT NULL,
	IdCausaleVersMal Varchar(5),
	ImportoVersMal Currency,
Constraint pk_Dr_MalattiaADebito Primary Key (IdDatoRetributivo,IdMalattiaADebito)
);

Create Table Dr_MalattiaACredito  (
	IdDatoRetributivo Integer NOT NULL,
	IndennitaMalattia Currency,
	IndennitaMalattia87_88 Currency,
Constraint pk_Dr_MalattiaACredito Primary Key (IdDatoRetributivo)
);

Create Table Dr_MalattiaACreditoAltre  (
	IdDatoRetributivo Integer NOT NULL,
	IdMalattiaACreditoAltre Smallint NOT NULL,
	IdCausaleRecMal Varchar(5),
	ImportoRecMal Currency,
Constraint pk_Dr_MalattiaACreditoAltre Primary Key (IdDatoRetributivo,IdMalattiaACreditoAltre)
);

Create Table Dr_Maternita  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_Dr_Maternita Primary Key (IdDatoRetributivo)
);

Create Table Dr_MaternitaACredito  (
	IdDatoRetributivo Integer NOT NULL,
	IndMat1Fascia Currency,
	IndMat2Fascia Currency,
	IndCongedoParentale Currency,
	IndAllattamento Currency,
Constraint pk_Dr_MaternitaACredito Primary Key (IdDatoRetributivo)
);

Create Table Dr_MaternitaADebito  (
	IdDatoRetributivo Integer NOT NULL,
	IdMaternitaADebito Smallint NOT NULL,
	IdCausaleVersMat Varchar(5),
	ImportoVersMat Currency,
Constraint pk_Dr_MaternitaADebito Primary Key (IdDatoRetributivo,IdMaternitaADebito)
);

Create Table Dr_MaternitaACreditoAltre  (
	IdDatoRetributivo Integer NOT NULL,
	IdMaternitaACreditoAltre Smallint NOT NULL,
	IdCausaleRecMat Varchar(5),
	ImportoRecMat Currency,
Constraint pk_Dr_MaternitaACreditoAltre Primary Key (IdDatoRetributivo,IdMaternitaACreditoAltre)
);

Create Table GestioneAnf  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_GestioneAnf Primary Key (IdDatoRetributivo)
);

Create Table AnfADebito  (
	IdDatoRetributivo Integer NOT NULL,
	IdAnfADebito Smallint NOT NULL,
	ImportoRestituzioneAnf Currency,
	IdCausaleRestituzAnf Varchar(5),
Constraint pk_AnfADebito Primary Key (IdDatoRetributivo,IdAnfADebito)
);

Create Table AnfACredito  (
	IdDatoRetributivo Integer NOT NULL,
	AssegniCorrenti Currency,
Constraint pk_AnfACredito Primary Key (IdDatoRetributivo)
);

Create Table AnfACreditoAltre  (
	IdDatoRetributivo Integer NOT NULL,
	IdAnfACreditoAltre Smallint NOT NULL,
	ImportoRecAnf Currency,
	IdCausaleRecAnf Varchar(5),
Constraint pk_AnfACreditoAltre Primary Key (IdDatoRetributivo,IdAnfACreditoAltre)
);

Create Table GestioneCig  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_GestioneCig Primary Key (IdDatoRetributivo)
);

Create Table CigoADebito  (
	IdDatoRetributivo Integer NOT NULL,
	IdCigoADebito Smallint NOT NULL,
	ImportoContribAddCigo Currency,
	IdCausaleContribAddCigo Varchar(5),
Constraint pk_CigoADebito Primary Key (IdDatoRetributivo,IdCigoADebito)
);

Create Table CigoACredito  (
	IdDatoRetributivo Integer NOT NULL,
	IndOrdinaria Currency,
Constraint pk_CigoACredito Primary Key (IdDatoRetributivo)
);

Create Table CigsADebito  (
	IdDatoRetributivo Integer NOT NULL,
	ImportoContribAddCigs Currency,
	IdCausaleContribAddCigs Varchar(5),
Constraint pk_CigsADebito Primary Key (IdDatoRetributivo)
);

Create Table CigsACredito  (
	IdDatoRetributivo Integer NOT NULL,
	IndStraordinaria Currency,
Constraint pk_CigsACredito Primary Key (IdDatoRetributivo)
);

Create Table CigsDatiStat  (
	IdDatoRetributivo Integer NOT NULL,
	ImponibileStatCigs Currency,
	IdCausaleStatCigs Varchar(5),
	NumOreStatCigs Arithmetic,
Constraint pk_CigsDatiStat Primary Key (IdDatoRetributivo)
);

Create Table CigoACredAltre  (
	IdDatoRetributivo Integer NOT NULL,
	IdCigoACredAltre Smallint NOT NULL,
	ImportoCongCigo Currency,
	IdCausaleCongCigo Varchar(5),
Constraint pk_CigoACredAltre Primary Key (IdDatoRetributivo,IdCigoACredAltre)
);

Create Table OreCongCigo  (
	IdDatoRetributivo Integer NOT NULL,
	IdOreCongCigo Smallint NOT NULL,
	NumAutorizzCigo Varchar(10),
	NumOreCigo Arithmetic,
Constraint pk_OreCongCigo Primary Key (IdDatoRetributivo,IdOreCongCigo)
);

Create Table CigsACredAltre  (
	IdDatoRetributivo Integer NOT NULL,
	IdCigsACredAltre Smallint NOT NULL,
	ImportoCongCigs Currency,
	IdCausaleCongCigs Varchar(5),
Constraint pk_CigsACredAltre Primary Key (IdDatoRetributivo,IdCigsACredAltre)
);

Create Table OreCongCigs  (
	IdDatoRetributivo Integer NOT NULL,
	IdOreCongCigs Smallint NOT NULL,
	NumAutorizzCigs Varchar(10),
	NumOreCigs Arithmetic,
Constraint pk_OreCongCigs Primary Key (IdDatoRetributivo,IdOreCongCigs)
);

Create Table LavPensionato  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_LavPensionato Primary Key (IdDatoRetributivo)
);

Create Table LavPensTrattenuta  (
	IdDatoRetributivo Integer NOT NULL,
	QuotaFpld Currency,
Constraint pk_LavPensTrattenuta Primary Key (IdDatoRetributivo)
);

Create Table FondiDiversi  (
	IdDatoRetributivo Integer NOT NULL,
	IdFondiDiversi Smallint NOT NULL,
	ImportoTrattPens Currency,
	IdCausaleTrattPens Varchar(5),
Constraint pk_FondiDiversi Primary Key (IdDatoRetributivo,IdFondiDiversi)
);

Create Table LavPensRimborso  (
	IdDatoRetributivo Integer NOT NULL,
	ImportoRimborso Currency,
Constraint pk_LavPensRimborso Primary Key (IdDatoRetributivo)
);

Create Table LavDivAbile  (
	IdDatoRetributivo Integer NOT NULL,
	IdCausaleStatDivAbile Varchar(5),
	IdBeneficioDivAbileReg Varchar(5),
	ImportoCorrente Currency,
	ImportoArretrato Currency,
Constraint pk_LavDivAbile Primary Key (IdDatoRetributivo)
);

Create Table AltreADebito  (
	IdDatoRetributivo Integer NOT NULL,
	IdAltreADebito Smallint NOT NULL,
	IdCausaleADebito Varchar(5),
	AltroImponibile Currency,
	NumOre Arithmetic,
	NumGG Arithmetic,
	ImportoADebito Currency,
Constraint pk_AltreADebito Primary Key (IdDatoRetributivo,IdAltreADebito)
);

Create Table AltreACredito  (
	IdDatoRetributivo Integer NOT NULL,
	IdAltreACredito Smallint NOT NULL,
	IdCausaleACredito Varchar(5),
	ImportoACredito Currency,
Constraint pk_AltreACredito Primary Key (IdDatoRetributivo,IdAltreACredito)
);

Create Table Inps_EsteroTipoImp  (
	IdEsteroTipoImp Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_EsteroTipoImp Primary Key (IdEsteroTipoImp)
);

Create Table Tfr_ContribImpPreg  (
	IdPosizione Integer NOT NULL,
	IdImportoPregresso Smallint NOT NULL,
	ImportoPregresso Currency,
	IdTipoImpPregCmt Varchar(5),
	Dal Date,
Constraint pk_Tfr_ContribImpPreg Primary Key (IdPosizione,IdImportoPregresso)
);

Create Table Tfr_TipoImpPregCmt  (
	IdTipoImpPregCmt Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Tfr_TipoImpPregCmt Primary Key (IdTipoImpPregCmt)
);

Create Table Tfr_MisureCompensative  (
	IdPosizione Integer NOT NULL,
Constraint pk_Tfr_MisureCompensative Primary Key (IdPosizione)
);

Create Table Tfr_MisCompADebito  (
	IdPosizione Integer NOT NULL,
	IdCausaleMcADeb Varchar(5),
	Importo Currency,
Constraint pk_Tfr_MisCompADebito Primary Key (IdPosizione)
);

Create Table Tfr_MisCompACredito  (
	IdPosizione Integer NOT NULL,
	IdCausaleMcACred Varchar(5),
	Importo Currency,
Constraint pk_Tfr_MisCompACredito Primary Key (IdPosizione)
);

Create Table DenunciaAziendale  (
	IdDenunciaAziendale Integer NOT NULL,
	IdDichiarazione Integer,
	InpsCodDitta Varchar(12) NOT NULL,
	Mese Smallint,
	Anno Integer,
	IdTrattQuotaLav Varchar(2),
	IdTipoRegolarizzaz Varchar(3),
	DataEsecutivita Date,
	NumLavoratori Smallint,
	ForzaAziendale Arithmetic,
	InfoStatNum Smallint,
	IdImpresa Integer,
	IdSedeImpresa Smallint,
	RichiestaCanc Booleanint,
	RichiestaCancData Date,
Constraint pk_DenunciaAziendale Primary Key (IdDenunciaAziendale)
);

Create Table TipoInfoStat  (
	IdTipoInfoStat Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoInfoStat Primary Key (IdTipoInfoStat)
);

Create Table Da_TrattQuotaLav  (
	IdTrattQuotaLav Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_TrattQuotaLav Primary Key (IdTrattQuotaLav)
);

Create Table Da_FondoInterprof  (
	IdDenunciaAziendale Integer NOT NULL,
	IdFondoInterAdesione1 Varchar(20),
	IdFondoInterAdesione2 Varchar(20),
	IdFondoInterRevoca1 Varchar(5),
	IdFondoInterRevoca2 Varchar(5),
	Adesione1NumDip Smallint,
	Adesione2NumDip Smallint,
Constraint pk_Da_FondoInterprof Primary Key (IdDenunciaAziendale)
);

Create Table Da_FondoInterRevoca  (
	IdFondoInterRevoca Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_FondoInterRevoca Primary Key (IdFondoInterRevoca)
);

Create Table Da_FondoInterAdesione  (
	IdFondoInterAdesione Varchar(20) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_FondoInterAdesione Primary Key (IdFondoInterAdesione)
);

Create Table Da_ContribAssistContrat  (
	IdDenunciaAziendale Integer NOT NULL,
	IdTipoContribAssist Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_Da_ContribAssistContrat Primary Key (IdDenunciaAziendale,IdTipoContribAssist)
);

Create Table Da_TipoContribAssist  (
	IdTipoContribAssist Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_TipoContribAssist Primary Key (IdTipoContribAssist)
);

Create Table Da_InfoStat  (
	IdDenunciaAziendale Integer NOT NULL,
	IdTipoInfoStat Varchar(5) NOT NULL,
	Num Smallint NOT NULL,
Constraint pk_Da_InfoStat Primary Key (IdDenunciaAziendale,IdTipoInfoStat)
);

Create Table Da_AziendaTfr  (
	IdDenunciaAziendale Integer NOT NULL,
	ImportoVers1 Currency,
	IdCausaleVers1 Varchar(5),
	ImportoVers2 Currency,
	IdCausaleVers2 Varchar(5),
Constraint pk_Da_AziendaTfr Primary Key (IdDenunciaAziendale)
);

Create Table Da_RecuperoTfr  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCausaleRec Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_Da_RecuperoTfr Primary Key (IdDenunciaAziendale,IdCausaleRec)
);

Create Table Tfr_CausaleVers  (
	IdCausaleVers Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Tfr_CausaleVers Primary Key (IdCausaleVers)
);

Create Table Tfr_CausaleRec  (
	IdCausaleRec Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Tfr_CausaleRec Primary Key (IdCausaleRec)
);

Create Table Da_PrestazBancari  (
	IdDenunciaAziendale Integer NOT NULL,
Constraint pk_Da_PrestazBancari Primary Key (IdDenunciaAziendale)
);

Create Table Da_VersPensBancari  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCausaleVersPens Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_Da_VersPensBancari Primary Key (IdDenunciaAziendale,IdCausaleVersPens)
);

Create Table Da_RecuperoPensBancari  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCausaleRecPens Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_Da_RecuperoPensBancari Primary Key (IdDenunciaAziendale,IdCausaleRecPens)
);

Create Table Da_CausaleRecPens  (
	IdCausaleRecPens Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_CausaleRecPens Primary Key (IdCausaleRecPens)
);

Create Table Da_CausaleVersPens  (
	IdCausaleVersPens Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_CausaleVersPens Primary Key (IdCausaleVersPens)
);

Create Table Da_AltrePartiteADebito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCausaleADebito Varchar(5) NOT NULL,
	NumGG Arithmetic,
	NumOre Arithmetic,
	NumDip Smallint,
	Retribuzione Currency,
	SommaADebito Currency,
Constraint pk_Da_AltrePartiteADebito Primary Key (IdDenunciaAziendale,IdCausaleADebito)
);

Create Table Da_CausaleACredito  (
	IdCausaleACredito Varchar(5) NOT NULL,
	Descrizione Note,
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Da_CausaleACredito Primary Key (IdCausaleACredito)
);

Create Table Da_CausaleADebito  (
	IdCausaleADebito Varchar(5) NOT NULL,
	Descrizione Varchar(400),
Constraint pk_Da_CausaleADebito Primary Key (IdCausaleADebito)
);

Create Table Da_AltrePartiteACredito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCausaleACredito Varchar(5) NOT NULL,
	SommaACredito Currency,
Constraint pk_Da_AltrePartiteACredito Primary Key (IdDenunciaAziendale,IdCausaleACredito)
);

Create Table Da_RecuperoPrestFondiSol  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCausaleRecPrest Varchar(5) NOT NULL,
	ImportoRecPrest Currency,
Constraint pk_Da_RecuperoPrestFondiSol Primary Key (IdDenunciaAziendale,IdCausaleRecPrest)
);

Create Table Da_CausaleRecPrest  (
	IdCausaleRecPrest Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_CausaleRecPrest Primary Key (IdCausaleRecPrest)
);

Create Table Da_DatiQuadraturaRetrContr  (
	IdDenunciaAziendale Integer NOT NULL,
	NumDenIndiv Smallint,
	TotaleADebito Currency,
	TotaleACredito Currency,
Constraint pk_Da_DatiQuadraturaRetrContr Primary Key (IdDenunciaAziendale)
);

Create Table AnfT4  (
	IdDatoRetributivo Integer NOT NULL,
	Imponibile Currency,
	Contributo Currency,
Constraint pk_AnfT4 Primary Key (IdDatoRetributivo)
);

Create Table DispSomministrati  (
	IdDatoRetributivo Integer NOT NULL,
	Importo Currency,
Constraint pk_DispSomministrati Primary Key (IdDatoRetributivo)
);

Create Table Inquadramento  (
	IdInquadramento Integer NOT NULL,
	IdLavoratore Integer NOT NULL,
	IdInpsTipoContribuzione Varchar(8) NOT NULL,
	IdInpsQualifica1 Varchar(2) NOT NULL,
	IdInpsQualifica2 Varchar(2),
	IdInpsQualifica3 Varchar(2),
Constraint pk_Inquadramento Primary Key (IdInquadramento)
);

Create Table EccedenzaMassimale  (
	IdDatoRetributivo Integer NOT NULL,
	Imponibile Currency,
	Contributo Currency,
	ContributoSol Currency,
	Imponibile2 Currency,
	ContributoSol2 Currency,
Constraint pk_EccedenzaMassimale Primary Key (IdDatoRetributivo)
);

Create Table F24_AltroEnte  (
	IdDichiarazione Integer NOT NULL,
	IdF24AltroEnte Smallint NOT NULL,
Constraint pk_F24_AltroEnte Primary Key (IdDichiarazione,IdF24AltroEnte)
);

Create Table F24_Regione  (
	IdDichiarazione Integer NOT NULL,
	IdF24Regione Smallint NOT NULL,
	CodRegione Varchar(2),
	CodTributo Varchar(4),
	Mese Smallint,
	Anno Integer,
	ImportoDebito Currency,
	ImportoCredito Currency,
Constraint pk_F24_Regione Primary Key (IdDichiarazione,IdF24Regione)
);

Create Table F24_Erario  (
	IdDichiarazione Integer NOT NULL,
	IdF24Erario Smallint NOT NULL,
	CodTributo Varchar(4),
	Rateazione Varchar(4),
	Anno Integer,
	ImportoDebito Currency,
	ImportoCredito Currency,
Constraint pk_F24_Erario Primary Key (IdDichiarazione,IdF24Erario)
);

Create Table F24_Inps  (
	IdDichiarazione Integer NOT NULL,
	IdF24Inps Smallint NOT NULL,
	CodSede Varchar(4),
	Causale Varchar(4),
	Matricola Varchar(17),
	PeriodoDa Varchar(6),
	PeriodoA Varchar(6),
	ImportoDebito Currency,
	ImportoCredito Currency,
Constraint pk_F24_Inps Primary Key (IdDichiarazione,IdF24Inps)
);

Create Table Inail_PosizioneImpresa  (
	IdImpresa Integer NOT NULL,
	Pat Varchar(20) NOT NULL,
	Anno Integer NOT NULL,
Constraint pk_Inail_PosizioneImpresa Primary Key (IdImpresa,Pat,Anno)
);

Create Table Inail_SilAsb  (
	IdImpresa Integer NOT NULL,
	Pat Varchar(20) NOT NULL,
	Anno Integer NOT NULL,
	RegRetribuzTot Currency,
	RegRetribuzEsente Currency,
	RegRetribuzSpecifica Currency,
	RegTassoTariffa Percentage,
	RegTassoCorrispondente Percentage,
	RegTassoApplicabile Percentage,
	RegOscillazione Percentage,
	RegPremio Currency,
	RataRetribuz Currency,
	RataTassoApplicabile Percentage,
	RataPremio Currency,
Constraint pk_Inail_SilAsb Primary Key (IdImpresa,Pat,Anno)
);

Create Table Inail_InfMal  (
	IdImpresa Integer NOT NULL,
	Pat Varchar(20) NOT NULL,
	Anno Integer NOT NULL,
	RegRetribuzTot Currency,
	RegRetribuzEsente Currency,
	RegIncidenza Percentage,
	RegTasso Percentage,
	RegAgevolaz Percentage,
	RegPremio Currency,
	RataRetribuz Currency,
	RataTasso Percentage,
	RataAgevolaz Percentage,
	RataPremio Currency,
Constraint pk_Inail_InfMal Primary Key (IdImpresa,Pat,Anno)
);

Create Table Inail_Artigiano  (
	IdImpresa Integer NOT NULL,
	Pat Varchar(20) NOT NULL,
	Anno Integer NOT NULL,
	IdLavoratore Integer NOT NULL,
	RegPremioNetto Currency,
	RataPremioNetto Currency,
	RataMesi Smallint,
	RegMesi Smallint,
Constraint pk_Inail_Artigiano Primary Key (IdImpresa,Pat,Anno,IdLavoratore)
);

Create Table Inail_Sconto  (
	IdImpresa Integer NOT NULL,
	Pat Varchar(20) NOT NULL,
	Anno Integer NOT NULL,
	IdTipo Smallint NOT NULL,
	RegImponibile Currency,
	RegTasso Percentage,
	RegPremioSoggRiduz Currency,
	IdScontoReg Smallint,
	RegImporto Currency,
	RataImponibile Currency,
	RataTasso Percentage,
	RataPremioSoggRiduz Currency,
	RataRiduzione Percentage,
	IdScontoRata Smallint,
	RataImporto Currency,
Constraint pk_Inail_Sconto Primary Key (IdImpresa,Pat,Anno,IdTipo)
);

Create Table Inail_ContribAssociativo  (
	IdImpresa Integer NOT NULL,
	Pat Varchar(20) NOT NULL,
	Anno Integer NOT NULL,
	RegRetribuzDipend Currency,
	RegRetribuzArtigiani Currency,
	RegAliquota Percentage,
	RegContribDovuto Currency,
	RegQuotaFissa Currency,
	RegAnticipo Currency,
	RegImporto Currency,
	RataRetribuzDipend Currency,
	RataRetribuzArtigiani Currency,
	RataAliquota Percentage,
	RataContribDovuto Currency,
	RataQuotaFissa Currency,
	RataImporto Currency,
Constraint pk_Inail_ContribAssociativo Primary Key (IdImpresa,Pat,Anno)
);

Create Table TipoFoglio  (
	IdTipoFoglio Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoFoglio Primary Key (IdTipoFoglio)
);

Create Table PosizioneScatto  (
	IdPosizione Integer NOT NULL,
	IdContrattoDettaglio Integer,
	IdScatto Smallint,
	Numero Smallint,
	Valore Currency,
	DataUltimoScatto Date,
	IdScatto2 Smallint,
	ValoreTotPrecLiv Currency,
	DataPrecLiv Date,
	IdFrequenza Smallint,
	IdUnitaMisura Smallint,
	ProssimoScatto Date,
	NoRecalc Booleanint,
Constraint pk_PosizioneScatto Primary Key (IdPosizione)
);

Create Table ApprendistatoGruppo  (
	IdContrattoDettaglio Integer NOT NULL,
	IdGruppo Smallint NOT NULL,
	Descrizione Varchar(200),
	DurataMesi Smallint,
	ValiditaDal Date,
	ValiditaAssuntiDal Date,
	ValiditaAssuntiAl Date,
	IdProvincia Varchar(4),
	IdLivelloAlTermine Varchar(5),
Constraint pk_ApprendistatoGruppo Primary Key (IdContrattoDettaglio,IdGruppo)
);

Create Table ApprendistatoDettaglio  (
	IdContrattoDettaglio Integer NOT NULL,
	IdGruppo Smallint NOT NULL,
	MeseDal Smallint NOT NULL,
	MeseAl Smallint,
	Percentuale Percentage,
	RetribuzioneOraria Currency,
Constraint pk_ApprendistatoDettaglio Primary Key (IdContrattoDettaglio,IdGruppo,MeseDal)
);

Create Table PosizioneIndennita  (
	IdPosizione Integer NOT NULL,
	IdIndennita Smallint NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	NoRecalc Booleanint,
Constraint pk_PosizioneIndennita Primary Key (IdPosizione,IdIndennita,IdContrattoDettaglio)
);

Create Table TipoElementoRetributivo2  (
	IdTipoElemento2 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoElementoRetributivo2 Primary Key (IdTipoElemento2)
);

Create Table PosizionePrevidenzialeAltro  (
	IdPosizione Integer NOT NULL,
	IdTipoFoglio Smallint NOT NULL,
	IdEntePrevidenziale Smallint,
	Imponibile Currency,
	AliquotaTotCaricoLav Percentage,
	AliquotaTotCaricoDat Percentage,
	ContribTotCaricoLav Currency,
	ContribTotCaricoDat Currency,
	RetribMinGg Currency,
	RetribMinHh Currency,
	ApplicatoMinimale Booleanint,
	NoRecalc Booleanint,
	Note Note,
Constraint pk_PosizionePrevidenzialeAltro Primary Key (IdPosizione,IdTipoFoglio)
);

Create Table ProfiloIndennita  (
	IdProfilo Integer NOT NULL,
	IdIndennita Smallint NOT NULL,
	IdContrattoDettaglio Integer NOT NULL,
	Quantita Arithmetic,
	Importo Currency,
Constraint pk_ProfiloIndennita Primary Key (IdProfilo,IdIndennita,IdContrattoDettaglio)
);

Create Table ProfiloScatto  (
	IdProfilo Integer NOT NULL,
	IdContrattoDettaglio Integer,
	IdScatto Smallint,
	Numero Smallint,
	Valore Currency,
	DataUltimoScatto Date,
	IdScatto2 Smallint,
	ValoreTotPrecLiv Currency,
	DataPrecLiv Date,
	IdFrequenza Smallint,
	IdUnitaMisura Smallint,
	ProssimoScatto Date,
	Note Note,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_ProfiloScatto Primary Key (IdProfilo)
);

Create Table Dr_Incentivo  (
	IdDatoRetributivo Integer NOT NULL,
	IdTipoIncentivo Varchar(5) NOT NULL,
	IdEnteFinanziatore Varchar(4) NOT NULL,
	ImportoCorr Currency,
	ImportoArr Currency,
Constraint pk_Dr_Incentivo Primary Key (IdDatoRetributivo,IdTipoIncentivo,IdEnteFinanziatore)
);

Create Table Dr_TipoIncentivo  (
	IdTipoIncentivo Varchar(5) NOT NULL,
	Descrizione Varchar(300),
Constraint pk_Dr_TipoIncentivo Primary Key (IdTipoIncentivo)
);

Create Table Dr_EnteFinanziatore  (
	IdEnteFinanziatore Varchar(4) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_EnteFinanziatore Primary Key (IdEnteFinanziatore)
);

Create Table PosizioneContrattIndividuale  (
	IdPosizione Integer NOT NULL,
	IdVoce Smallint NOT NULL,
	Importo Currency,
	PercSuRetribGlobale Percentage,
	PercSuCompetenze Percentage,
	Descrizione Varchar(200),
Constraint pk_PosizioneContrattIndividuale Primary Key (IdPosizione,IdVoce)
);

Create Table ProfiloContrattIndividuale  (
	IdProfilo Integer NOT NULL,
	IdVoce Smallint NOT NULL,
	Importo Currency,
	PercSuRetribGlobale Percentage,
	PercSuCompetenze Percentage,
	Descrizione Varchar(200),
Constraint pk_ProfiloContrattIndividuale Primary Key (IdProfilo,IdVoce)
);

Create Table ProfiloPrevidenzialeAltro  (
	IdProfilo Integer NOT NULL,
	IdEntePrevidenziale Smallint,
	AliquotaTotCaricoLav Percentage,
	AliquotaTotCaricoDat Percentage,
	ContribFisso Booleanint,
	ContribTotCaricoLav Currency,
	ContribTotCaricoDat Currency,
	RetribMinHh Currency,
	RetribMinGg Currency,
	Note Note,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_ProfiloPrevidenzialeAltro Primary Key (IdProfilo)
);

Create Table ProfiloAnf  (
	IdProfilo Integer NOT NULL,
	IdInpsTipoAnf Varchar(4),
	IdInpsTipoAnf2 Smallint,
	IdClasseAnf Smallint,
	RedditoFamiliare Currency,
Constraint pk_ProfiloAnf Primary Key (IdProfilo)
);

Create Table ProfiloInailImpresa  (
	IdImpresa Integer NOT NULL,
	IdSedeImpresa Smallint NOT NULL,
	IdContratto Smallint,
	IdGruppo2 Smallint,
	IdGruppo Smallint,
	InpsCodDitta Varchar(12),
Constraint pk_ProfiloInailImpresa Primary Key (IdImpresa,IdSedeImpresa)
);

Create Table Convenzbilaterale  (
	IdDatoRetributivo Integer NOT NULL,
	IdCodConv Varchar(5) NOT NULL,
	Periodo Date NOT NULL,
	Imponibile Currency,
	ImportoLav Currency,
	ImportoDat Currency,
	Importo Currency,
Constraint pk_Convenzbilaterale Primary Key (IdDatoRetributivo,IdCodConv,Periodo)
);

Create Table Dmag_Impresa  (
	IdDichiarazione Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdAssCategoria Smallint,
	IdTipoManodopera Smallint,
	IdTipoManodoperaDic Smallint,
	IdTipoDichiaraz Varchar(4),
	IdTipoDitta1 Smallint,
	IdTipoDitta2 Smallint,
	Lg166Lav Smallint,
	Lg166Retrib Currency,
	Progressivo Smallint,
	Accentramento Booleanint,
	AutorizzazRiscossione Booleanint,
	DichiaraAnticipaz Booleanint,
	DichiaraBeneficio Booleanint,
	DichiaraTrattQuotaLav Booleanint,
	IdImpresaSomministrata Integer,
	IdImpresaCodatrice Integer,
	Riallineamento Booleanint,
	RiallinContratto Date,
	RiallinAdesione Date,
	RiallinScadenza Date,
	IdComuneFondo Varchar(8),
	DeMinimis Booleanint,
	Mobilita Booleanint,
	Gor Booleanint,
	EmersioneDal Date,
	EmersioneAl Date,
Constraint pk_Dmag_Impresa Primary Key (IdDichiarazione,IdImpresa)
);

Create Table Dmag_Lavoratore  (
	IdDichiarazione Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdLavoratore Integer NOT NULL,
	IdTipoManodopera Smallint,
	IdTipoClassific Smallint,
	IdTipoCategoria Smallint,
	IdImpresaSomm Integer,
	IdImpresaCodatrice Integer,
	AccantParziale Currency,
	AccantTot Currency,
	CisoaTicket Varchar(40),
	CisoaAut Varchar(10),
	PrecRetribGiornaliera Currency,
	PrecGiorniLavorati Smallint,
Constraint pk_Dmag_Lavoratore Primary Key (IdDichiarazione,IdImpresa,IdLavoratore)
);

Create Table Dmag_TipoClassific  (
	IdTipoClassific Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_TipoClassific Primary Key (IdTipoClassific)
);

Create Table Dmag_TipoQualifica  (
	IdTipoQualifica Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_TipoQualifica Primary Key (IdTipoQualifica)
);

Create Table Dmag_Arealav  (
	IdAreaLav Smallint NOT NULL,
	Descrizione Varchar(500),
Constraint pk_Dmag_Arealav Primary Key (IdAreaLav)
);

Create Table Dmag_Zt  (
	IdZt Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Dmag_Zt Primary Key (IdZt)
);

Create Table Dmag_ZtRiclass  (
	IdZtRiclass Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_ZtRiclass Primary Key (IdZtRiclass)
);

Create Table Dmag_TipoLav  (
	IdTipoLav Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_TipoLav Primary Key (IdTipoLav)
);

Create Table Dmag_TipoManodoperaDic  (
	IdTipoManodoperaDic Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_TipoManodoperaDic Primary Key (IdTipoManodoperaDic)
);

Create Table Dmag_TipoRetribuzione2  (
	IdTipoRetribuzione2 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_TipoRetribuzione2 Primary Key (IdTipoRetribuzione2)
);

Create Table Inps_CodConv  (
	IdCodConv Varchar(5) NOT NULL,
	Descrizione Note,
	F24CodConv Varchar(5),
	IdBaseImponibile Smallint,
Constraint pk_Inps_CodConv Primary Key (IdCodConv)
);

Create Table Dmag_ImpresaProfilo  (
	IdImpresa Integer NOT NULL,
	IdTipoManodopera Smallint,
	IdAssCategoria Smallint,
	IdTipoDitta1 Smallint,
	IdTipoDitta2 Smallint,
Constraint pk_Dmag_ImpresaProfilo Primary Key (IdImpresa)
);

Create Table Dmag_LavoratoreProfilo  (
	IdLavoratore Integer NOT NULL,
	IdTipoManodopera Smallint,
	IdTipoClassific Smallint,
	IdTipoContratto Smallint,
	IdTipoLav Smallint,
	IdTipoRetribuzione1 Varchar(2),
	IdTipoRetribuzione2 Smallint,
	IdAreaLav Smallint,
	IdZt Smallint,
	IdTipoCategoria Smallint,
	IdTipoPartTimeGor Varchar(2),
	IdTipoAgevolaz Varchar(3),
	RetribTeorica Currency,
	IdImpresaCodatrice Integer,
	IdImpresaSomm Integer,
Constraint pk_Dmag_LavoratoreProfilo Primary Key (IdLavoratore)
);

Create Table FormazCig  (
	IdDatoRetributivo Integer NOT NULL,
	ImponibileFcc Currency,
	ContributoFcc Currency,
	ImponibileFca Currency,
	ContributoFca Currency,
Constraint pk_FormazCig Primary Key (IdDatoRetributivo)
);

Create Table Inail_Riepilogo  (
	IdImpresa Integer NOT NULL,
	Pat Varchar(20) NOT NULL,
	Anno Integer NOT NULL,
	F_1 Currency,
	F_1A Currency,
	F_1C Currency,
	F_1D Currency,
	F_1G Currency,
	F_1I Currency,
	F_2 Currency,
	F_2A Currency,
	F_2C Currency,
	F_2D Currency,
	F_2G Currency,
	F_1L Currency,
	F_2H Currency,
Constraint pk_Inail_Riepilogo Primary Key (IdImpresa,Pat,Anno)
);

Create Table Inail_Sconto2  (
	IdSconto Smallint NOT NULL,
	Descrizione Varchar(200),
	Percentuale Percentage,
	Anno Integer,
Constraint pk_Inail_Sconto2 Primary Key (IdSconto)
);

Create Table Inps_TipoRegolarizzaz  (
	IdTipoRegolarizzaz Varchar(3) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_TipoRegolarizzaz Primary Key (IdTipoRegolarizzaz)
);

Create Table Giorno  (
	IdDatoRetributivo Integer NOT NULL,
	Gg Smallint NOT NULL,
	Lavorato Booleanint,
Constraint pk_Giorno Primary Key (IdDatoRetributivo,Gg)
);

Create Table Inps_TipoEventoCig  (
	IdTipoEventoCig Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_TipoEventoCig Primary Key (IdTipoEventoCig)
);

Create Table EventoCig  (
	IdDatoRetributivo Integer NOT NULL,
	IdEventoCig Varchar(20) NOT NULL,
	IdTipoEventoCig Varchar(2),
Constraint pk_EventoCig Primary Key (IdDatoRetributivo,IdEventoCig)
);

Create Table PagDiretto  (
	IdDatoRetributivo Integer NOT NULL,
	IdEventoCig Varchar(20) NOT NULL,
	IdPosizioneBancaria Integer,
	IdTipoSindacato Varchar(5),
	ImpAnf Currency,
	TrattPens Currency,
	DetrazLavDip Booleanint,
	DetrazCarichiFam Booleanint,
Constraint pk_PagDiretto Primary Key (IdDatoRetributivo,IdEventoCig)
);

Create Table ConguaglioCig  (
	IdDenunciaAziendale Integer NOT NULL,
Constraint pk_ConguaglioCig Primary Key (IdDenunciaAziendale)
);

Create Table CigAutorizzata  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	IdTipo Smallint,
	NumAutorizzazione Varchar(50),
Constraint pk_CigAutorizzata Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table CigOrd  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
Constraint pk_CigOrd Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table CigStraord  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
Constraint pk_CigStraord Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table CigInDeroga  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
Constraint pk_CigInDeroga Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table Solidarieta  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
Constraint pk_Solidarieta Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table CongCigdADebito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	IdCausale Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_CongCigdADebito Primary Key (IdDenunciaAziendale,IdCigAutorizzata,IdCausale)
);

Create Table CongCigdACredito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	Importo Currency,
Constraint pk_CongCigdACredito Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table CongCigsADebito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	IdCausale Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_CongCigsADebito Primary Key (IdDenunciaAziendale,IdCigAutorizzata,IdCausale)
);

Create Table CongCigsACredito  (
	IdCigAutorizzata Smallint NOT NULL,
	IdDenunciaAziendale Integer NOT NULL,
	Importo Currency,
Constraint pk_CongCigsACredito Primary Key (IdCigAutorizzata,IdDenunciaAziendale)
);

Create Table CongCigdAltro  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	IdCausale Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_CongCigdAltro Primary Key (IdDenunciaAziendale,IdCigAutorizzata,IdCausale)
);

Create Table CongCigoADebito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	IdCausale Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_CongCigoADebito Primary Key (IdDenunciaAziendale,IdCigAutorizzata,IdCausale)
);

Create Table CongSolAltro  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	IdCausale Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_CongSolAltro Primary Key (IdDenunciaAziendale,IdCigAutorizzata,IdCausale)
);

Create Table CongSolACredito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	Importo Currency,
Constraint pk_CongSolACredito Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table CongSolAltCaus  (
	IdCausale Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CongSolAltCaus Primary Key (IdCausale)
);

Create Table CongCigdAltCaus  (
	IdCausale Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CongCigdAltCaus Primary Key (IdCausale)
);

Create Table CongCigdCausAdd  (
	IdCausale Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CongCigdCausAdd Primary Key (IdCausale)
);

Create Table CongCigoACredito  (
	IdCigAutorizzata Smallint NOT NULL,
	IdDenunciaAziendale Integer NOT NULL,
	Importo Currency,
Constraint pk_CongCigoACredito Primary Key (IdCigAutorizzata,IdDenunciaAziendale)
);

Create Table CongCigoCausAdd  (
	IdCausale Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CongCigoCausAdd Primary Key (IdCausale)
);

Create Table CongCigoAltro  (
	IdCigAutorizzata Smallint NOT NULL,
	IdDenunciaAziendale Integer NOT NULL,
	IdCausale Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_CongCigoAltro Primary Key (IdCigAutorizzata,IdDenunciaAziendale,IdCausale)
);

Create Table CongCigoAltCaus  (
	IdCausale Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CongCigoAltCaus Primary Key (IdCausale)
);

Create Table CongCigsCausAdd  (
	IdCausale Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CongCigsCausAdd Primary Key (IdCausale)
);

Create Table CongCigsAltro  (
	IdCigAutorizzata Smallint NOT NULL,
	IdCausale Varchar(5) NOT NULL,
	IdDenunciaAziendale Integer NOT NULL,
	Importo Currency,
Constraint pk_CongCigsAltro Primary Key (IdCigAutorizzata,IdCausale,IdDenunciaAziendale)
);

Create Table CongCigsAltCaus  (
	IdCausale Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CongCigsAltCaus Primary Key (IdCausale)
);

Create Table ProfiloImpresa  (
	IdImpresa Integer NOT NULL,
	MeseCongIrpef Smallint,
	RateAddizComSaldo Smallint,
	RateAddizComAcconto Smallint,
	RateAddizRegSaldo Smallint,
Constraint pk_ProfiloImpresa Primary Key (IdImpresa)
);

Create Table AssenzaOpzione  (
	IdOpzione Smallint NOT NULL,
	Descrizione Note NOT NULL,
Constraint pk_AssenzaOpzione Primary Key (IdOpzione)
);

Create Table CategoriaAssenza  (
	IdCategoria Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CategoriaAssenza Primary Key (IdCategoria)
);

Create Table ContrattoMalattia  (
	IdContrattoDettaglio Integer NOT NULL,
	Gg1 Smallint,
	Gg2 Smallint,
	IndennitaInps1 Percentage,
	IndennitaInps2 Percentage,
	IntegrazioneDatore1 Percentage,
	IntegrazioneDatore2 Percentage,
	Descrizione Varchar(200),
	Note Note,
	Custom Booleanint,
Constraint pk_ContrattoMalattia Primary Key (IdContrattoDettaglio)
);

Create Table ContrattoInfortunio  (
	IdInfortunio Smallint NOT NULL,
	Gg1 Smallint,
	Gg2 Smallint,
	IndennitaInps1 Percentage,
	IndennitaInps2 Percentage,
	IntegrazioneDatore1 Percentage,
	IntegrazioneDatore2 Percentage,
	Descrizione Varchar(200),
	Note Note,
	Custom Booleanint,
Constraint pk_ContrattoInfortunio Primary Key (IdInfortunio)
);

Create Table ExIpost  (
	IdDatoRetributivo Integer NOT NULL,
Constraint pk_ExIpost Primary Key (IdDatoRetributivo)
);

Create Table ExIpost_Retrib  (
	IdTipo Smallint NOT NULL,
	IdDatoRetributivo Integer NOT NULL,
	GiorniRetribuiti Smallint,
	GiorniUtili Smallint,
	Retribuzione177 Currency,
	Tredicesima Currency,
	CompetenzeAccessorie Currency,
	IndennitaIntegrSpec Currency,
	UltimoGgBenefici336 Currency,
Constraint pk_ExIpost_Retrib Primary Key (IdTipo,IdDatoRetributivo)
);

Create Table ExIpost_Anno  (
	IdDatoRetributivo Integer NOT NULL,
	IdTipo Smallint NOT NULL,
	Anno Integer NOT NULL,
	Retribuzione177 Currency,
	Tredicesima Currency,
Constraint pk_ExIpost_Anno Primary Key (IdDatoRetributivo,IdTipo,Anno)
);

Create Table ExIpost_Tipo  (
	IdTipo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_ExIpost_Tipo Primary Key (IdTipo)
);

Create Table Uniemens_Impresa  (
	IdDichiarazione Integer NOT NULL,
	IdImpresa Integer NOT NULL,
Constraint pk_Uniemens_Impresa Primary Key (IdDichiarazione,IdImpresa)
);

Create Table Cnce_PosizioneLavoratore  (
	IdPosizione Integer NOT NULL,
	IdLavoratore Integer,
	IdImpresa Smallint,
	IdCassaEdile Varchar(5),
	IdTipoAssunzione Smallint,
	IdTipoCessazione Smallint,
	IdLivelloQualifica Varchar(2),
	IdMansione Varchar(2),
	IdTIpoRapporto Smallint,
	IdEsenzioneLimiteCcnl Smallint,
	IdCantiere Smallint,
	OreSettimanali Smallint,
	PartTimeOrario Percentage,
Constraint pk_Cnce_PosizioneLavoratore Primary Key (IdPosizione)
);

Create Table Cnce_EsenzioneLimiteCcnl  (
	IdEsenzioneLimiteCcnl Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_EsenzioneLimiteCcnl Primary Key (IdEsenzioneLimiteCcnl)
);

Create Table Cnce_TipoRapporto  (
	IdTIpoRapporto Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_TipoRapporto Primary Key (IdTIpoRapporto)
);

Create Table Cnce_OpzioneTfr  (
	IdTipoTfr Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_OpzioneTfr Primary Key (IdTipoTfr)
);

Create Table Cnce_ElementoPaga  (
	IdPosizione Integer NOT NULL,
	PagaOraria Currency,
	SuperminimoOrario Currency,
	MaggCaposquadra Currency,
	Cottimo Currency,
	SuperminimoMensile Currency,
Constraint pk_Cnce_ElementoPaga Primary Key (IdPosizione)
);

Create Table Cnce_Imponibile  (
	IdPosizione Integer NOT NULL,
	ImponibileGnf Currency,
	ImponibileContrib Currency,
	ImponibileContrSanz Currency,
	ImponibileTfr Currency,
	ImponibileInps Currency,
Constraint pk_Cnce_Imponibile Primary Key (IdPosizione)
);

Create Table Cnce_OreLavorate  (
	IdPosizione Integer NOT NULL,
	OreCarenza Smallint,
	OreMalattia Smallint,
	OreInfortunio Smallint,
	OrePermessiNonRetrib Smallint,
	OreRiduzOrario Smallint,
	OreMaltempo Smallint,
	OreCig Smallint,
	OreTotCongedo Smallint,
	OreTotGiustificate Smallint,
	OreTotSanzionabili Smallint,
	OreFerie Smallint,
	OreFerieAc Smallint,
	OreFerieResidueAp Smallint,
	OreFerieSanzionabili Smallint,
Constraint pk_Cnce_OreLavorate Primary Key (IdPosizione)
);

Create Table Cnce_Accantonamento  (
	IdPosizione Integer NOT NULL,
	AccantonGnf Currency,
	AccantonGnfMalInf Currency,
	AccantonRiposiAnnui Currency,
	AccantonFerie Currency,
	AnticipoAccanton Currency,
Constraint pk_Cnce_Accantonamento Primary Key (IdPosizione)
);

Create Table Cnce_PrevComp  (
	IdPosizione Integer NOT NULL,
	AdesioneFondo Booleanint,
	IdTipoAdesione Varchar(1),
	IdTipoAdesione2 Smallint,
	IdDataAdesione Smallint,
	ContribLavoratore Currency,
	ContribVolontario Currency,
	ContribDitta Currency,
	QuotaTfr Currency,
Constraint pk_Cnce_PrevComp Primary Key (IdPosizione)
);

Create Table Cnce_OpzionePrevComp  (
	IdPosizione Integer NOT NULL,
	IdTipoTfr Varchar(2),
	CodFondo Varchar(3),
	NumAlboCovip Integer,
	DataSottoscrTfr Date,
Constraint pk_Cnce_OpzionePrevComp Primary Key (IdPosizione)
);

Create Table Cnce_DatiistitutoTfr  (
	IdPosizione Integer NOT NULL,
	TfrDaVersare Currency,
	OreFigurative Smallint,
	GiorniLavorabili Smallint,
	ImportoFap Currency,
	ImportoAumDim Currency,
	OreUtili Smallint,
	PagaOraria Currency,
Constraint pk_Cnce_DatiistitutoTfr Primary Key (IdPosizione)
);

Create Table Cnce_LavCantiere  (
	IdPosizione Integer NOT NULL,
	IdCantiere Smallint NOT NULL,
	Prevalente Booleanint,
	OreOrdinarie Arithmetic,
	OreFestivita Arithmetic,
	ImponibileGnf Currency,
	ImponibileContrib Currency,
	AccantonGnf Currency,
	AccantonFerie Currency,
Constraint pk_Cnce_LavCantiere Primary Key (IdPosizione,IdCantiere)
);

Create Table Cnce_Malattia  (
	IdPosizione Integer NOT NULL,
	IdTipo Smallint NOT NULL,
	DataInizio Date NOT NULL,
	GiornoFine Smallint,
	Continuaz Booleanint,
	Ricaduta Smallint,
	GiornoInizio Smallint,
	OreCarenza Arithmetic,
	OreMalattiaInfort Arithmetic,
	OreAssenzaIngiust Arithmetic,
	ConguaglioRimborso Currency,
Constraint pk_Cnce_Malattia Primary Key (IdPosizione,IdTipo,DataInizio)
);

Create Table MalattiaInfortunio  (
	IdAssenza Integer NOT NULL,
	Ricaduta Booleanint,
	IdTipo Smallint,
	OreCarenza Arithmetic,
	GiorniCarenza Arithmetic,
	DataInizioAssoluto Date,
	DataFineAssoluta Date,
	DataInizioMese Date,
	DataFineMese Date,
Constraint pk_MalattiaInfortunio Primary Key (IdAssenza)
);

Create Table Cnce_RecuperoPrevCompl  (
	IdPosizione Integer NOT NULL,
	Mese Smallint NOT NULL,
	Anno Integer NOT NULL,
	ContribLavoratore Currency,
	ContribVolontario Currency,
	ContribDitta Currency,
	QuotaTfr Currency,
	Rivalutazione Currency,
Constraint pk_Cnce_RecuperoPrevCompl Primary Key (IdPosizione,Mese,Anno)
);

Create Table Mut_Riepilogo  (
	IdDichiarazione Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	PercContrib Percentage,
	ImportoContrib Currency,
	PercContrAssImpr Percentage,
	ImportoContrAssImpr Currency,
	PercContrAssImprFp Percentage,
	ImportoContrAssImprFp Currency,
	ImportoConguaglio Currency,
	ImportoCreditoPrec Currency,
	ImportoDebitoPrec Currency,
	ImportoAltriDebiti Currency,
	TotaleDaVersare Currency,
	TotaleACredito Currency,
Constraint pk_Mut_Riepilogo Primary Key (IdDichiarazione,IdImpresa)
);

Create Table Cnce_AltroContributo  (
	IdPosizione Integer NOT NULL,
	IdAltroContributo Varchar(5) NOT NULL,
	Percentuale Percentage,
	Importo Currency,
Constraint pk_Cnce_AltroContributo Primary Key (IdPosizione,IdAltroContributo)
);

Create Table Cnce_TipoAltroContributo  (
	IdAltroContributo Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_TipoAltroContributo Primary Key (IdAltroContributo)
);

Create Table Mut  (
	IdDichiarazione Integer NOT NULL,
	IdDocumento Integer,
	IdExport Integer,
Constraint pk_Mut Primary Key (IdDichiarazione)
);

Create Table Mut_Impresa  (
	IdDichiarazione Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	CodCassaEdile Varchar(9),
	DestinazCe Varchar(5),
	IdSituazione Smallint,
	GiornoSituazione Smallint,
Constraint pk_Mut_Impresa Primary Key (IdDichiarazione,IdImpresa)
);

Create Table Mut_CantiereSituazione  (
	IdDichiarazione Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdCantiere Smallint NOT NULL,
	IdSituazione Smallint,
	GiornoSituazione Smallint,
	Trasfertisti Booleanint,
	Interinali Booleanint,
	Subappalti Booleanint,
Constraint pk_Mut_CantiereSituazione Primary Key (IdDichiarazione,IdImpresa,IdCantiere)
);

Create Table Cnce_TipoMalattia  (
	IdTipo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_TipoMalattia Primary Key (IdTipo)
);

Create Table Cnce_PrevCompTipo1  (
	IdTipoAdesione Varchar(1) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_PrevCompTipo1 Primary Key (IdTipoAdesione)
);

Create Table Cnce_PrevCompTipo2  (
	IdTipoAdesione2 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Cnce_PrevCompTipo2 Primary Key (IdTipoAdesione2)
);

Create Table Config  (
	IdConfig Smallint NOT NULL,
	Valore Varchar(200),
Constraint pk_Config Primary Key (IdConfig)
);

Create Table ConguaglioAsoCred  (
	IdDenunciaAziendale Integer NOT NULL,
	NumApprovazione Varchar(20) NOT NULL,
	Credito Currency,
	Debito Currency,
Constraint pk_ConguaglioAsoCred Primary Key (IdDenunciaAziendale,NumApprovazione)
);

Create Table PremioRis  (
	IdDatoRetributivo Integer NOT NULL,
	PremioRisAz Currency,
	PremioRisTerr Currency,
	CongNegPrAz Currency,
	CongNegPrTerr Currency,
Constraint pk_PremioRis Primary Key (IdDatoRetributivo)
);

Create Table TipoCalcoloMalattia1  (
	IdTipoMalattia1 Smallint NOT NULL,
	Descrizione Varchar(200),
	Descrizione2 Note,
Constraint pk_TipoCalcoloMalattia1 Primary Key (IdTipoMalattia1)
);

Create Table TipoCalcoloMalattia2  (
	IdTipoMalattia2 Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_TipoCalcoloMalattia2 Primary Key (IdTipoMalattia2)
);

Create Table Legge68  (
	IdAssunzione Integer NOT NULL,
	AttoData Date,
	AttoNum Varchar(20),
Constraint pk_Legge68 Primary Key (IdAssunzione)
);

Create Table Inail_TipoMalattia  (
	IdTipoMalattia Varchar(5) NOT NULL,
	IdGruppo Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Inail_TipoMalattia Primary Key (IdTipoMalattia,IdGruppo)
);

Create Table Mut_Lavoratore  (
	IdDichiarazione Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdLavoratore Integer NOT NULL,
Constraint pk_Mut_Lavoratore Primary Key (IdDichiarazione,IdImpresa,IdLavoratore)
);

Create Table Pa_PosizioneSubordinato  (
	IdPosizione Integer NOT NULL,
	IdTipoIscrFondoPrevCompl Smallint,
	IdTipoAliquotaPosPrec Smallint,
	IdTipoVariazione Smallint,
	IdTipoUtilizzo Smallint,
	SilenzioAssenso Booleanint,
	GiornoOpzioneTfr Date,
Constraint pk_Pa_PosizioneSubordinato Primary Key (IdPosizione)
);

Create Table Mut_PosizioneLav  (
	IdPosizione Integer NOT NULL,
	Accantonamento Currency,
Constraint pk_Mut_PosizioneLav Primary Key (IdPosizione)
);

Create Table Pa_TipoCessazione  (
	IdPaTipoCessazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoCessazione Primary Key (IdPaTipoCessazione)
);

Create Table Pa_Qualifica  (
	IdPaQualifica Varchar(7) NOT NULL,
	IdPaContratto Varchar(5) NOT NULL,
	Descrizione Varchar(200),
	Dal Date,
	Al Date,
Constraint pk_Pa_Qualifica Primary Key (IdPaQualifica,IdPaContratto)
);

Create Table Pa_Contratto  (
	IdPaContratto Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_Contratto Primary Key (IdPaContratto)
);

Create Table Pa_TipoImpiego  (
	IdTipoImpiego Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Pa_TipoImpiego Primary Key (IdTipoImpiego)
);

Create Table Pa_RegimeFineServizio  (
	IdRegimeFineServ Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_RegimeFineServizio Primary Key (IdRegimeFineServ)
);

Create Table Pa_TipoServizio  (
	IdTipoServizio Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Pa_TipoServizio Primary Key (IdTipoServizio)
);

Create Table Pa_Inquadramento  (
	IdPaPeriodo Integer NOT NULL,
	IdPaContratto Varchar(5),
	IdPaQualifica Varchar(7),
	IdTipoImpiego Smallint,
	IdTipoServizio Smallint,
	IdRegimeFineServ Smallint,
	PercRetribuzione Percentage,
	PercAspettativa Percentage,
	OreSettPersScuolaR Arithmetic,
	OreSettPersScuolaC Arithmetic,
	IdServizioAltroEnte Integer,
	IdTipoServizioAltro1 Smallint,
	IdDipendAltroEnte Integer,
	IdTipoServizioAltro2 Smallint,
Constraint pk_Pa_Inquadramento Primary Key (IdPaPeriodo)
);

Create Table Pa_PosizionePeriodo  (
	IdPaPeriodo Integer NOT NULL,
	IdPosizione Integer NOT NULL,
	IdPaTipoCessazione Smallint,
	Dal Date,
	Al Date,
	Mensilita Smallint,
	RetribTeoricaTabTfr Currency,
	RetribValutabileTfr Currency,
	FineBeneficioCalamita Date,
	CongImporto Currency,
	CongContribPens Currency,
	CongContribCred Currency,
Constraint pk_Pa_PosizionePeriodo Primary Key (IdPaPeriodo)
);

Create Table Pa_TipoServizioAltro  (
	IdTipoServizioAltro Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoServizioAltro Primary Key (IdTipoServizioAltro)
);

Create Table Pa_ProfiloLavoratore  (
	IdProfilo Integer NOT NULL,
	IdTipoIscrFondoPrevCompl Smallint,
	SilenzioAssenso Booleanint,
	GiornoOpzioneTfr Date,
Constraint pk_Pa_ProfiloLavoratore Primary Key (IdProfilo)
);

Create Table Pa_TipoIscrFondoPrevCompl  (
	IdTipoIscrFondoPrevCompl Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Pa_TipoIscrFondoPrevCompl Primary Key (IdTipoIscrFondoPrevCompl)
);

Create Table Pa_Gestione  (
	IdPaPeriodo Integer NOT NULL,
	IdGestione Smallint NOT NULL,
	IdTipoGestione Smallint NOT NULL,
	IdGestPensionistica Integer,
	IdGestEndep Integer,
	IdGestPrevidenziale Integer,
	IdGestEnam Integer,
	IdGestCredito Integer,
Constraint pk_Pa_Gestione Primary Key (IdPaPeriodo,IdGestione)
);

Create Table Pa_GestPrevidenziale  (
	IdGestPrevidenziale Integer NOT NULL,
	ImponibileTfr Currency,
	ContributoTfr Currency,
	ImponibileTfrEccMass Currency,
	ImponibileTfs Currency,
	ContributoTfs Currency,
	ImponibileTfsEccMass Currency,
	ContributoSospesoPrev Currency,
Constraint pk_Pa_GestPrevidenziale Primary Key (IdGestPrevidenziale)
);

Create Table Pa_GestCredito  (
	IdGestCredito Integer NOT NULL,
	AderenteCreditoDm45_2007 Smallint,
	Imponibile Currency,
	Contributo Currency,
	ImponibileEccMass Currency,
Constraint pk_Pa_GestCredito Primary Key (IdGestCredito)
);

Create Table Pa_GestEndep  (
	IdGestEndep Integer NOT NULL,
	Imponibile Currency,
	Contributo Currency,
Constraint pk_Pa_GestEndep Primary Key (IdGestEndep)
);

Create Table Pa_GestPensionistica  (
	IdGestPensionistica Integer NOT NULL,
	Imponibile Currency,
	Contributo Currency,
	ImponibileEccMass Currency,
	Contrib1Perc Currency,
	MaggBasePensL165_97 Percentage,
	GiorniUtili Smallint,
	RetribVirtuale Currency,
	ContribSospCalam Currency,
	StipendioTabellare Currency,
	RetribIndivAnzianita Currency,
	QuotaDatoreL166_91 Currency,
	ContributoL166_91 Currency,
	VoloImportoInd Currency,
	VoloCodInd Smallint,
	MaggCod1 Smallint,
	MaggGiorni1 Smallint,
	MaggCod2 Smallint,
	MaggGiorni2 Smallint,
	MaggCod3 Smallint,
	MaggGiorni3 Smallint,
	RecuperoSgraviCod1 Varchar(2),
	RecuperoSgravi1 Currency,
	RecuperoSgravi1Anno Integer,
	RecuperoSgraviCod2 Varchar(2),
	RecuperoSgravi2 Currency,
	RecuperoSgravi2Anno Integer,
Constraint pk_Pa_GestPensionistica Primary Key (IdGestPensionistica)
);

Create Table Pa_GestEnam  (
	IdGestEnam Integer NOT NULL,
	Imponibile Currency,
	Contributo Currency,
Constraint pk_Pa_GestEnam Primary Key (IdGestEnam)
);

Create Table Pa_AltroEnteVersante  (
	IdPaPeriodo Integer NOT NULL,
	IdTipoContributoAltroEnte Smallint NOT NULL,
	IdEnte Integer,
	Imponibile Currency,
	Contributo Currency,
Constraint pk_Pa_AltroEnteVersante Primary Key (IdPaPeriodo)
);

Create Table Pa_FondoPensCompl  (
	IdPosizione Integer NOT NULL,
	IdFondoPensComp Smallint NOT NULL,
	IdFondo Smallint,
	IdComparto Smallint,
	ContribVersNonDich Booleanint,
	Sottoscrizione Date,
	Dal Date,
	Al Date,
	AliquotaLav Percentage,
	AliquotaDl Percentage,
	PercTfr Percentage,
	CessazData Date,
	IdTipoCessazFondo Smallint,
	IdTipoSospensFondo Smallint,
	RetribSoggAContrib Currency,
	ConguaglioFiscale Currency,
	ContribLav Currency,
	ContribDl Currency,
	ContribAg Currency,
	QuotaReintegrazione Currency,
	QuotaIscrizLav Currency,
	QuotaIscrizDl Currency,
	VersTfrAPrevCompl Currency,
	IdAltroEnteVersante Integer,
Constraint pk_Pa_FondoPensCompl Primary Key (IdPosizione,IdFondoPensComp)
);

Create Table Pa_Ammortamento  (
	IdPosizione Integer NOT NULL,
	IdAmmortamento Smallint NOT NULL,
	Anno Integer,
	Mese Smallint,
	IdTipoGestione Smallint,
	IdTipoPiano Smallint,
	Dal Date,
	Al Date,
	Scadenza Date,
	Rata Smallint,
	TotaleRate Smallint,
	DataRipristino Date,
	AnteSubentro Booleanint,
	Importo Currency,
	IdTipoOperazione Varchar(1),
	IdAltroEnteVersante Integer,
Constraint pk_Pa_Ammortamento Primary Key (IdPosizione,IdAmmortamento)
);

Create Table Pa_FondoContribOmessi  (
	IdPosizione Integer NOT NULL,
	IdFondoPensComp Smallint NOT NULL,
	Dal Date,
	Al Date,
	ContribLav Currency,
	ImportoSanzione Currency,
	ImportoRifusioneDanno Currency,
	ContribDl Currency,
	ContribIndebitoDl Currency,
	ContribIndebitoLav Currency,
Constraint pk_Pa_FondoContribOmessi Primary Key (IdPosizione,IdFondoPensComp)
);

Create Table Pa_TipoMaggiorazione  (
	IdTipoMaggiorazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoMaggiorazione Primary Key (IdTipoMaggiorazione)
);

Create Table Pa_TipoRecupero  (
	IdTipoRecupero Varchar(2) NOT NULL,
	Descrizione Note,
Constraint pk_Pa_TipoRecupero Primary Key (IdTipoRecupero)
);

Create Table Pa_TipoGestione  (
	IdTipoGestione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoGestione Primary Key (IdTipoGestione)
);

Create Table Pa_TipoContributoAltroEnte  (
	IdTipoContributoAltroEnte Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoContributoAltroEnte Primary Key (IdTipoContributoAltroEnte)
);

Create Table Pa_CompartoPensione  (
	IdFondo Smallint NOT NULL,
	IdComparto Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_CompartoPensione Primary Key (IdFondo,IdComparto)
);

Create Table Pa_FondoPensione  (
	IdFondo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_FondoPensione Primary Key (IdFondo)
);

Create Table Pa_TipoCessazFondo  (
	IdTipoCessazFondo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoCessazFondo Primary Key (IdTipoCessazFondo)
);

Create Table Pa_TipoSospensFondo  (
	IdTipoSospensFondo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoSospensFondo Primary Key (IdTipoSospensFondo)
);

Create Table Pa_TipoPianoAmmortamento  (
	IdTipoPiano Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoPianoAmmortamento Primary Key (IdTipoPiano)
);

Create Table Pa_TipoOperazione  (
	IdTipoOperazione Varchar(1) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoOperazione Primary Key (IdTipoOperazione)
);

Create Table Pa_TipoVariazione  (
	IdTipoVariazione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoVariazione Primary Key (IdTipoVariazione)
);

Create Table Pa_AltroImporto  (
	IdDichiarazione Integer NOT NULL,
	IdTipoAltroImporto Smallint NOT NULL,
	IdTipoGestione Smallint,
	Importo Currency,
Constraint pk_Pa_AltroImporto Primary Key (IdDichiarazione,IdTipoAltroImporto)
);

Create Table Pa_TipoAltroImporto  (
	IdTipoAltroImporto Smallint NOT NULL,
	Descrizione Varchar(200),
	ValidoAl Date,
Constraint pk_Pa_TipoAltroImporto Primary Key (IdTipoAltroImporto)
);

Create Table Pa_TipoAliquotaPosPrec  (
	IdTipoAliquotaPosPrec Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoAliquotaPosPrec Primary Key (IdTipoAliquotaPosPrec)
);

Create Table Inps_TipoApprendistato  (
	IdInpsTipoApprendistato Varchar(4) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_TipoApprendistato Primary Key (IdInpsTipoApprendistato)
);

Create Table CudField  (
	IdDichiarazione Integer NOT NULL,
	Field Integer NOT NULL,
	Value1 Varchar(200),
	Value2 Currency,
	Value3 Integer,
Constraint pk_CudField Primary Key (IdDichiarazione,Field)
);

Create Table ProfiloContrattIndividuale2  (
	IdProfilo Integer NOT NULL,
	IdElemento Integer NOT NULL,
	Importo Currency,
	Quantita Arithmetic,
	Percentuale Percentage,
	Calcolato Booleanint,
	Dal Date,
	Al Date,
	Note Note,
Constraint pk_ProfiloContrattIndividuale2 Primary Key (IdProfilo,IdElemento)
);

Create Table Sp_PosizioneSubordinato  (
	IdPosizione Integer NOT NULL,
	IdProvinciaLuogoLavoro Varchar(4),
	RetribPrecedente Currency,
	GiorniFascia Smallint,
Constraint pk_Sp_PosizioneSubordinato Primary Key (IdPosizione)
);

Create Table Sp_DatoRetribuzione  (
	IdPosizione Integer NOT NULL,
	IdDatoRetribuzione Smallint NOT NULL,
	IdAliquota Varchar(2),
	IdAgevolazione Varchar(7),
	IdQualifica Smallint,
	IdTipoRapporto Smallint,
	IdTipoRetribuzione Varchar(2),
	Dal Date,
	Al Date,
	GgLavorati Smallint,
	ImportoRetribuzione Currency,
	ImportoAgevolazione Currency,
	ContributoNormale Currency,
	ContributoAggiuntivo Currency,
	ContributoSolidarieta Currency,
	TrattenutePensioni Currency,
	RetribuzionePrec Currency,
	GiorniFascia Smallint,
	IdBrano Varchar(12),
Constraint pk_Sp_DatoRetribuzione Primary Key (IdPosizione,IdDatoRetribuzione)
);

Create Table Sp_Qualifica  (
	IdQualifica Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Sp_Qualifica Primary Key (IdQualifica)
);

Create Table Sp_TipoRapporto  (
	IdTipoRapporto Smallint NOT NULL,
	Descrizione Varchar(200),
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Sp_TipoRapporto Primary Key (IdTipoRapporto)
);

Create Table Sp_TipoRetribuzione  (
	IdTipoRetribuzione Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Sp_TipoRetribuzione Primary Key (IdTipoRetribuzione)
);

Create Table Sp_ProfiloLavoratore  (
	IdProfilo Integer NOT NULL,
	IdQualifica Smallint,
	IdTipoRapporto Smallint,
	IdTipoRetribuzione Varchar(2),
	IdAliquota Varchar(2),
	IdAgevolazione Varchar(7),
	ImportoAgevolazione Currency,
Constraint pk_Sp_ProfiloLavoratore Primary Key (IdProfilo)
);

Create Table Sp_Aliquota  (
	IdAliquota Varchar(2) NOT NULL,
	Descrizione Varchar(200),
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Sp_Aliquota Primary Key (IdAliquota)
);

Create Table Sp_Agevolazione  (
	IdAgevolazione Varchar(7) NOT NULL,
	Descrizione Varchar(200),
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Sp_Agevolazione Primary Key (IdAgevolazione)
);

Create Table Sp_CausaleExtraContrib  (
	IdPosizione Integer NOT NULL,
	IdTipoExtraContrib Varchar(3),
	IdAliquota Varchar(2),
	ImportoDare Currency,
	ImportoAvere Currency,
	ImportoRiferimento Currency,
	Dal Date,
	Al Date,
Constraint pk_Sp_CausaleExtraContrib Primary Key (IdPosizione)
);

Create Table Sp_TipoExtraContrib  (
	IdTipoExtraContrib Varchar(3) NOT NULL,
	Descrizione Varchar(200),
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Sp_TipoExtraContrib Primary Key (IdTipoExtraContrib)
);

Create Table Pa_TipoUtilizzo  (
	IdTipoUtilizzo Smallint NOT NULL,
	Descrizione Note,
Constraint pk_Pa_TipoUtilizzo Primary Key (IdTipoUtilizzo)
);

Create Table Pa_MotivoUtilizzo  (
	IdPosizione Integer NOT NULL,
	AttoData Date,
	AttoId Varchar(50),
	NumRegistro Varchar(50),
	IdOrgano Smallint,
	SedeGeoOrgano Varchar(50),
Constraint pk_Pa_MotivoUtilizzo Primary Key (IdPosizione)
);

Create Table Cnce_CassaEdilePerc  (
	IdCassaEdile Varchar(5) NOT NULL,
	IdCarico Smallint NOT NULL,
	Ape Percentage,
	FormazioneProf Percentage,
	AdesioneContrattNaz Percentage,
	AdesioneContrattTerr Percentage,
	PrevidenzaSociale Percentage,
	FondoSicurezza Percentage,
	FondoIntegrGaranzia Percentage,
	Vestiario Percentage,
	LavoriUsuranti Percentage,
	PrevediImpresa Percentage,
	PrevediOperai Percentage,
	FondoRegolarita Percentage,
	FondoNormaPremiale Percentage,
	FondoRlst Percentage,
	ScuolaEdile Percentage,
	FondoCigApprendisti Percentage,
	FondoIncentivoOccupazione Percentage,
	FondoPrepensionamento Percentage,
	FondoSanitario Percentage,
	FondoSanitarioImpiegati Percentage,
	ValidoDal Date,
	ValidoAl Date,
Constraint pk_Cnce_CassaEdilePerc Primary Key (IdCassaEdile,IdCarico)
);

Create Table Cnce_CassaEdileConfig  (
	IdCassaEdile Varchar(5) NOT NULL,
	PercCassaEdileAReddito Percentage,
Constraint pk_Cnce_CassaEdileConfig Primary Key (IdCassaEdile)
);

Create Table PosizioneFiscaleAnnoPagato  (
	IdLavoratore Integer NOT NULL,
	AnnoRiferimento Integer NOT NULL,
	AddizRegionale Currency,
	AddizComunale1 Currency,
	AddizComunale2 Currency,
	ImpostaNetta Currency,
	ImpostaSostitutivaNetta Currency,
	RedditoImponibileNetto Currency,
	GgLavoro Smallint,
	GgPensione Smallint,
	DetrazRedditoLavoro Currency,
	DetrazConiuge Currency,
	DetrazFigli Currency,
	DetrazFamigliaNumerosa Currency,
	DetrazAltriFamiliari Currency,
	DetrazAltre Currency,
	DetrazRedditoAltro Currency,
	DeduzAbitazione Currency,
	DeduzOneri Currency,
	DeduzAltre Currency,
	CreditoRenzi Currency,
	Note Varchar(500),
	UltimaModificaUser Varchar(50),
	UltimaModifica Timestamp,
Constraint pk_PosizioneFiscaleAnnoPagato Primary Key (IdLavoratore,AnnoRiferimento)
);

Create Table Scadenzario  (
	IdScadenzario Smallint NOT NULL,
	NotificaGg Smallint,
Constraint pk_Scadenzario Primary Key (IdScadenzario)
);

Create Table Dmag_TipoPartTimeGor  (
	IdTipoPartTimeGor Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_TipoPartTimeGor Primary Key (IdTipoPartTimeGor)
);

Create Table Dmag_TipoAgevolaz  (
	IdTipoAgevolaz Varchar(3) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dmag_TipoAgevolaz Primary Key (IdTipoAgevolaz)
);

Create Table Dmag  (
	IdDichiarazione Integer NOT NULL,
	IdTipoDichiaraz Varchar(4),
Constraint pk_Dmag Primary Key (IdDichiarazione)
);

Create Table Dmag_AzSomm  (
	IdDichiarazione Integer NOT NULL,
	IdImpresaSomm Integer,
Constraint pk_Dmag_AzSomm Primary Key (IdDichiarazione)
);

Create Table Dmag_DatoRetrib  (
	IdDichiarazione Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdLavoratore Integer NOT NULL,
	IdTipoContratto Smallint,
	IdTipoRetribuzione1 Varchar(2),
	IdTipoRetribuzione2 Smallint,
	IdAreaLav Smallint,
	IdZt Smallint,
	IdTipoCategoria Smallint,
	IdTipoPartTimeGor Varchar(2),
	IdTipoAgevolaz Varchar(3),
	GiorniLavorati Arithmetic,
	OrePartTimeGor Arithmetic,
	Retribuzione Currency,
	Riallineamento Booleanint,
	Emersione Varchar(2),
	Dimissioni Booleanint,
	IdComuneFondo Varchar(8),
	PercRetrib Percentage,
	Livello Varchar(3),
	RetribTeorica Currency,
	RetribTeoricaPersa Currency,
	GiornoInizio Smallint,
	GiornoFine Smallint,
	GiorniPersi Smallint,
Constraint pk_Dmag_DatoRetrib Primary Key (IdDichiarazione,IdImpresa,IdLavoratore)
);

Create Table ProfiloApprendistato  (
	IdProfilo Integer NOT NULL,
Constraint pk_ProfiloApprendistato Primary Key (IdProfilo)
);

Create Table PosizioneApprendistato  (
	IdPosizione Integer NOT NULL,
Constraint pk_PosizioneApprendistato Primary Key (IdPosizione)
);

Create Table Volo  (
	IdDatoRetributivo Integer NOT NULL,
	ImportoInd50PerCento Currency,
	IndennGiaDichiarata Booleanint,
	ImportoIndArr Currency,
	RecContribIndArr Currency,
Constraint pk_Volo Primary Key (IdDatoRetributivo)
);

Create Table ProfiloConfig  (
	IdProfilo Integer NOT NULL,
	IdOpzione Smallint NOT NULL,
	Valore Varchar(200),
Constraint pk_ProfiloConfig Primary Key (IdProfilo,IdOpzione)
);

Create Table ProfiloOpzione  (
	IdOpzione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_ProfiloOpzione Primary Key (IdOpzione)
);

Create Table Pa_TipoConguaglio  (
	IdTipoConguaglio Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Pa_TipoConguaglio Primary Key (IdTipoConguaglio)
);

Create Table Pa_AltroImportoACong  (
	IdDichiarazione Integer NOT NULL,
	IdTipoConguaglio Smallint,
	Importo Currency,
Constraint pk_Pa_AltroImportoACong Primary Key (IdDichiarazione)
);

Create Table Pa  (
	IdDichiarazione Integer NOT NULL,
Constraint pk_Pa Primary Key (IdDichiarazione)
);

Create Table M730Anno  (
	IdLavoratore Integer NOT NULL,
	AnnoRiferimento Integer NOT NULL,
	IdTipo Smallint NOT NULL,
	Rate Smallint,
	Debito Currency,
	Credito Currency,
Constraint pk_M730Anno Primary Key (IdLavoratore,AnnoRiferimento,IdTipo)
);

Create Table M730Mese  (
	IdLavoratore Integer NOT NULL,
	AnnoRiferimento Integer NOT NULL,
	IdTipo Smallint NOT NULL,
	Mese Smallint NOT NULL,
	Credito Currency,
	Debito Currency,
	Interessi Currency,
Constraint pk_M730Mese Primary Key (IdLavoratore,AnnoRiferimento,IdTipo,Mese)
);

Create Table M730Tipo  (
	IdTipo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_M730Tipo Primary Key (IdTipo)
);

Create Table ElementoRetrib_F24Tributo  (
	IdElemento Integer NOT NULL,
	Tributo Varchar(4) NOT NULL,
Constraint pk_ElementoRetrib_F24Tributo Primary Key (IdElemento,Tributo)
);

Create Table Conguaglio730  (
	IdLavoratore Integer NOT NULL,
	Anno Integer NOT NULL,
	Rif730 Varchar(6) NOT NULL,
	Importo Currency,
	Tributo Varchar(4),
	Rate Smallint,
	MesePrimaRata Smallint,
	Quadro730 Varchar(6),
	Campo730 Varchar(6),
Constraint pk_Conguaglio730 Primary Key (IdLavoratore,Anno,Rif730)
);

Create Table Conguaglio730_PosLav  (
	IdLavoratore Integer NOT NULL,
	Anno Integer NOT NULL,
	Rif730 Varchar(6) NOT NULL,
	IdPosizione Integer NOT NULL,
	Rata Smallint,
	Tributo Varchar(4),
	Importo Currency,
Constraint pk_Conguaglio730_PosLav Primary Key (IdLavoratore,Anno,Rif730,IdPosizione)
);

Create Table Sp_TipoCopertura  (
	IdTipoCopertura Varchar(2) NOT NULL,
	Descrizione Varchar(300),
	DataScadenza Date,
Constraint pk_Sp_TipoCopertura Primary Key (IdTipoCopertura)
);

Create Table Sp_TipoRapportoLav  (
	IdTipoRapportoLav Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Sp_TipoRapportoLav Primary Key (IdTipoRapportoLav)
);

Create Table Sp_Fascia  (
	IdFascia Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Sp_Fascia Primary Key (IdFascia)
);

Create Table Sp_CausaleRetrSpec  (
	IdCausaleRetrSpec Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Sp_CausaleRetrSpec Primary Key (IdCausaleRetrSpec)
);

Create Table CuGruppo  (
	Anno Integer NOT NULL,
	IdCuGruppo Integer NOT NULL,
	IdFornitore Integer,
	IdIntermediario Integer,
	Export blob sub_type 0 segment size 80,
	IdAnnullamento Varchar(17),
	DataImpegno Date,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_CuGruppo Primary Key (Anno,IdCuGruppo)
);

Create Table CuImpresa  (
	Anno Integer NOT NULL,
	IdCuGruppo Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdFirmatario Integer,
Constraint pk_CuImpresa Primary Key (Anno,IdCuGruppo,IdImpresa)
);

Create Table CuLavRecord  (
	Anno Integer NOT NULL,
	IdCuGruppo Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdLavoratore Integer NOT NULL,
	AnnoCuRecord Integer NOT NULL,
	IdCuSezione Smallint NOT NULL,
	IdCuRecord Smallint NOT NULL,
	Valore Varchar(20),
Constraint pk_CuLavRecord Primary Key (Anno,IdCuGruppo,IdImpresa,IdLavoratore,AnnoCuRecord,IdCuSezione,IdCuRecord)
);

Create Table CuRecord  (
	Anno Integer NOT NULL,
	IdCuSezione Smallint NOT NULL,
	IdCuRecord Smallint NOT NULL,
	Descrizione Note,
	IdTipoRecord Smallint,
Constraint pk_CuRecord Primary Key (Anno,IdCuSezione,IdCuRecord)
);

Create Table CuLavoratore  (
	Anno Integer NOT NULL,
	IdCuGruppo Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdLavoratore Integer NOT NULL,
	IdAnnullamento Varchar(6),
	DataFirma Date,
Constraint pk_CuLavoratore Primary Key (Anno,IdCuGruppo,IdImpresa,IdLavoratore)
);

Create Table CuRecordSezione  (
	Anno Integer NOT NULL,
	IdCuSezione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_CuRecordSezione Primary Key (Anno,IdCuSezione)
);

Create Table CuAnnotazione  (
	Anno Integer NOT NULL,
	IdCuAnnotaz Varchar(3) NOT NULL,
	Descrizione Note2,
Constraint pk_CuAnnotazione Primary Key (Anno,IdCuAnnotaz)
);

Create Table CuLavAnnotaz  (
	Anno Integer NOT NULL,
	IdCuGruppo Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdLavoratore Integer NOT NULL,
	AnnoAnnotaz Integer NOT NULL,
	IdCuAnnotaz Varchar(3) NOT NULL,
	Annotazione Note2,
Constraint pk_CuLavAnnotaz Primary Key (Anno,IdCuGruppo,IdImpresa,IdLavoratore,AnnoAnnotaz,IdCuAnnotaz)
);

Create Table Inail_QualificaCu  (
	IdInailQualificaCu Varchar(2) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inail_QualificaCu Primary Key (IdInailQualificaCu)
);

Create Table Rs_Contratto  (
	IdRsContratto Varchar(7) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Rs_Contratto Primary Key (IdRsContratto)
);

Create Table Rs_FederazSind  (
	IdRsFederazSind Varchar(7) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Rs_FederazSind Primary Key (IdRsFederazSind)
);

Create Table Inps_AliquotaLavDomestico  (
	RetribDomDa Currency NOT NULL,
	IdTipoContribDom Smallint NOT NULL,
	TempoDeterminato Booleanint NOT NULL,
	Anno Integer NOT NULL,
	RetribDomA Currency,
	RetribConv Currency,
	Cuaf Currency,
	NoCuaf Currency,
	CuafLav Currency,
	NoCuafLav Currency,
	Descrizione Varchar(200),
Constraint pk_Inps_AliquotaLavDomestico Primary Key (RetribDomDa,IdTipoContribDom,TempoDeterminato,Anno)
);

Create Table ContrattoApprendistato  (
	IdContrattoDettaglio Integer NOT NULL,
	IdLivello Varchar(5) NOT NULL,
	IdInpsTipoApprendistato Varchar(4) NOT NULL,
	IdPeriodoApprendistato Smallint NOT NULL,
	MeseDa Smallint,
	MeseA Smallint,
	Percentuale Percentage,
	Descrizione Varchar(200),
Constraint pk_ContrattoApprendistato Primary Key (IdContrattoDettaglio,IdLivello,IdInpsTipoApprendistato,IdPeriodoApprendistato)
);

Create Table Inps_AliquotaAddiz  (
	IdAliquotaAddiz Smallint NOT NULL,
	Valore Percentage,
	ValidoDal Date,
	ValidoAl Date,
	Descrizione Varchar(200),
Constraint pk_Inps_AliquotaAddiz Primary Key (IdAliquotaAddiz)
);

Create Table Tfr_AziendaAnno  (
	IdImpresa Integer NOT NULL,
	Anno Integer NOT NULL,
	ImpostaSuRivalutazAcconto Currency,
	ImpostaSuRivalutazSaldo Currency,
	UltimaModificaUser IdUser,
	UltimaModifica Timestamp,
	NoRecalc Booleanint,
Constraint pk_Tfr_AziendaAnno Primary Key (IdImpresa,Anno)
);

Create Table IncentivoValore  (
	IdTipoIncentivo Varchar(5) NOT NULL,
	Anno Integer NOT NULL,
	Importo Currency,
	Percentuale Percentage,
	IncentivoMaxMese Currency,
	IncentivoMaxAnno Currency,
Constraint pk_IncentivoValore Primary Key (IdTipoIncentivo,Anno)
);

Create Table M770Gruppo  (
	Anno Integer NOT NULL,
	IdM770Gruppo Integer NOT NULL,
	IdFornitore Integer,
	IdIntermediario Integer,
	Export blob sub_type 0 segment size 80,
	IdAnnullamento Varchar(17),
	DataImpegno Date,
	UltimaModifica Timestamp,
	UltimaModificaUser IdUser,
Constraint pk_M770Gruppo Primary Key (Anno,IdM770Gruppo)
);

Create Table M770Impresa  (
	Anno Integer NOT NULL,
	IdM770Gruppo Integer NOT NULL,
	IdImpresa Integer NOT NULL,
	IdFirmatario Integer,
Constraint pk_M770Impresa Primary Key (Anno,IdM770Gruppo,IdImpresa)
);

Create Table M770RecordSezione  (
	Anno Integer NOT NULL,
	IdM770Sezione Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_M770RecordSezione Primary Key (Anno,IdM770Sezione)
);

Create Table M770Record  (
	Anno Integer NOT NULL,
	IdM770Sezione Smallint NOT NULL,
	IdM770Record Varchar(7) NOT NULL,
	Descrizione Note,
Constraint pk_M770Record Primary Key (Anno,IdM770Sezione,IdM770Record)
);

Create Table ProfiloPrev_DrTipoIncentivo  (
	IdProfilo Integer NOT NULL,
	IdTipoIncentivo Varchar(5) NOT NULL,
	IdEnteFinanziatore Varchar(4) NOT NULL,
Constraint pk_ProfiloPrev_DrTipoIncentivo Primary Key (IdProfilo,IdTipoIncentivo,IdEnteFinanziatore)
);

Create Table ProfiloPrev_InpsCodConv  (
	IdProfilo Integer NOT NULL,
	IdCodConv Varchar(5) NOT NULL,
Constraint pk_ProfiloPrev_InpsCodConv Primary Key (IdProfilo,IdCodConv)
);

Create Table ProfiloPrev_DrCausaleACredito  (
	IdProfilo Integer NOT NULL,
	IdCausaleACredito Varchar(5) NOT NULL,
Constraint pk_ProfiloPrev_DrCausaleACredit Primary Key (IdProfilo,IdCausaleACredito)
);

Create Table F24_Imu  (
	IdDichiarazione Integer NOT NULL,
	IdF24Imu Smallint NOT NULL,
	CodEnte Varchar(4),
	CodTributo Varchar(4),
	Mese Smallint,
	Anno Integer,
	ImportoDebito Currency,
	ImportoCredito Currency,
Constraint pk_F24_Imu Primary Key (IdDichiarazione,IdF24Imu)
);

Create Table Tfr_Liquidato  (
	IdPosizione Integer NOT NULL,
	IdTipoLiquidazione Smallint,
	TfrLordo Currency,
	Aliquota Percentage,
	ImpostaOrd Currency,
	ImponibilePre Currency,
	ImponibilePost Currency,
	Deduzioni Currency,
	ImpostaSostLorda Currency,
	Detrazioni Currency,
	ImpostaSostNetta Currency,
Constraint pk_Tfr_Liquidato Primary Key (IdPosizione)
);

Create Table Inps_CodConvValore  (
	IdCodConv Varchar(5) NOT NULL,
	IdInpsContratto Varchar(4) NOT NULL,
	PercDat Percentage,
	PercLav Percentage,
	ImportoDat Currency,
	ImportoLav Currency,
Constraint pk_Inps_CodConvValore Primary Key (IdCodConv,IdInpsContratto)
);

Create Table Inps_Tiporapporto_Aliquota  (
	IdInpsTipoRapporto Varchar(3) NOT NULL,
	IdInpsAliquota Varchar(5) NOT NULL,
	InpsAliquotaAnno Integer NOT NULL,
Constraint pk_Inps_Tiporapporto_Aliquota Primary Key (IdInpsTipoRapporto,IdInpsAliquota,InpsAliquotaAnno)
);

Create Table Da_CongFSolACredito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	IdCongFSolCausaleACredito Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_Da_CongFSolACredito Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table Da_CongFSolCausaleADebito  (
	IdCongFSolCausaleADebito Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_CongFSolCausaleADebito Primary Key (IdCongFSolCausaleADebito)
);

Create Table Da_CongFSolCausaleACredito  (
	IdCongFSolCausaleACredito Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Da_CongFSolCausaleACredito Primary Key (IdCongFSolCausaleACredito)
);

Create Table Da_CongFSolADebito  (
	IdDenunciaAziendale Integer NOT NULL,
	IdCigAutorizzata Smallint NOT NULL,
	IdCongFSolCausaleADebito Varchar(5) NOT NULL,
	Importo Currency,
Constraint pk_Da_CongFSolADebito Primary Key (IdDenunciaAziendale,IdCigAutorizzata)
);

Create Table Inps_IntegrazioneSalariale  (
	Anno Integer NOT NULL,
	IdTipo Smallint NOT NULL,
	RetribDa Currency NOT NULL,
	RetribA Currency,
	Importo Currency,
	Riduzione Percentage,
Constraint pk_Inps_IntegrazioneSalariale Primary Key (Anno,IdTipo,RetribDa)
);

Create Table Inps_TipoIntegrazioneSalariale  (
	IdTipo Smallint NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Inps_TipoIntegrazioneSalaria Primary Key (IdTipo)
);

Create Table EventoGiorno  (
	IdDatoRetributivo Integer NOT NULL,
	Gg Smallint NOT NULL,
	IdInpsEvento Varchar(4) NOT NULL,
	IdTipoEventoCig Varchar(2) NOT NULL,
	IdEventoCig Varchar(20),
	Ore Arithmetic,
	NumApprovASOCred Varchar(16),
	InfoAggEvento Varchar(30),
	IdTipoInfoAggEvento Varchar(3),
Constraint pk_EventoGiorno Primary Key (IdDatoRetributivo,Gg,IdInpsEvento)
);

Create Table TipoRetrMal  (
	IdTipoRetrMal Smallint NOT NULL,
	Descrizione Varchar(500),
Constraint pk_TipoRetrMal Primary Key (IdTipoRetrMal)
);

Create Table ProfiloPrevidenzialePensione  (
	IdProfilo Integer NOT NULL,
	AssegnoNonComulabile Currency,
Constraint pk_ProfiloPrevidenzialePensione Primary Key (IdProfilo)
);

Create Table Dr_CausaleContribAgg  (
	IdDatoRetributivo Integer NOT NULL,
	IdCausale Varchar(5) NOT NULL,
	Motivo Varchar(50),
	Anno Integer,
	Mese Smallint,
	ImportoAnnoMeseRif Currency,
Constraint pk_Dr_CausaleContribAgg Primary Key (IdDatoRetributivo,IdCausale)
);

Create Table Dr_TipoCausaleContribAgg  (
	IdCausale Varchar(5) NOT NULL,
	Descrizione Varchar(200),
Constraint pk_Dr_TipoCausaleContribAgg Primary Key (IdCausale)
);

COMMIT WORK;

/******************************************************************************/
/****                            Relationships                             ****/
/******************************************************************************/


Alter Table PosizioneSubordinato add Constraint Relationship45 Foreign Key (IdInpsQualifica1) references Inps_Qualifica1 (IdInpsQualifica1) on update no action on delete no action ;
Alter Table Inail_LimiteContributivo add Constraint Relationship834 Foreign Key (IdInpsQualifica1) references Inps_Qualifica1 (IdInpsQualifica1) on update no action on delete no action ;
Alter Table Inail_RetribConvenzionale add Constraint Relationship837 Foreign Key (IdInpsQualifica1) references Inps_Qualifica1 (IdInpsQualifica1) on update no action on delete no action ;
Alter Table Inquadramento add Constraint Relationship948 Foreign Key (IdInpsQualifica1) references Inps_Qualifica1 (IdInpsQualifica1) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship46 Foreign Key (IdInpsQualifica2) references Inps_Qualifica2 (IdInpsQualifica2) on update no action on delete no action ;
Alter Table Inquadramento add Constraint Relationship949 Foreign Key (IdInpsQualifica2) references Inps_Qualifica2 (IdInpsQualifica2) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship47 Foreign Key (IdInpsQualifica3) references Inps_Qualifica3 (IdInpsQualifica3) on update no action on delete no action ;
Alter Table Inquadramento add Constraint Relationship950 Foreign Key (IdInpsQualifica3) references Inps_Qualifica3 (IdInpsQualifica3) on update no action on delete no action ;
Alter Table Assunzione add Constraint Relationship536 Foreign Key (IdInpsTipoAssunzione) references Inps_TipoAssunzione (IdInpsTipoAssunzione) on update no action on delete no action ;
Alter Table Cessazione add Constraint Relationship535 Foreign Key (IdInpsTipoCessazione) references Inps_TipoCessazione (IdInpsTipoCessazione) on update no action on delete no action ;
Alter Table DatoRetributivo add Constraint Relationship54 Foreign Key (IdInpsTipoLavoratore) references Inps_TipoLavoratore (IdInpsTipoLavoratore) on update no action on delete no action ;
Alter Table Inps_TipoLavoratore_Fondo add Constraint Relationship699 Foreign Key (IdInpsTipoLavoratore) references Inps_TipoLavoratore (IdInpsTipoLavoratore) on update no action on delete no action ;
Alter Table AliquotaPrevidenziale add Constraint Relationship812 Foreign Key (IdInpsTipoLavoratore) references Inps_TipoLavoratore (IdInpsTipoLavoratore) on update no action on delete no action ;
Alter Table Settimana add Constraint Relationship17 Foreign Key (IdInpsTipoCopertura) references Inps_TipoCopertura (IdInpsTipoCopertura) on update no action on delete no action ;
Alter Table Settimana_Evento add Constraint Relationship163 Foreign Key (IdInpsEvento) references Inps_Evento (IdInpsEvento) on update no action on delete no action ;
Alter Table ContrattoAssenza add Constraint Relationship719 Foreign Key (IdInpsEvento) references Inps_Evento (IdInpsEvento) on update no action on delete no action ;
Alter Table TipoAssenza add Constraint Relationship829 Foreign Key (IdInpsEvento) references Inps_Evento (IdInpsEvento) on update no action on delete no action ;
Alter Table DiffAccredito add Constraint Relationship962 Foreign Key (IdInpsEvento) references Inps_Evento (IdInpsEvento) on update no action on delete no action ;
Alter Table EventoGiorno add Constraint Relationship1393 Foreign Key (IdInpsEvento) references Inps_Evento (IdInpsEvento) on update no action on delete no action ;
Alter Table PosizioneParasubordinato add Constraint Relationship217 Foreign Key (IdInpsAttivita) references Inps_Attivita (IdInpsAttivita) on update no action on delete no action ;
Alter Table PosizioneParasubordinato add Constraint Relationship216 Foreign Key (IdInpsAltreAss) references Inps_AltreAss (IdInpsAltreAss) on update no action on delete no action ;
Alter Table PosizioneParasubordinato add Constraint Relationship204 Foreign Key (IdInpsAliquota,InpsAliquotaAnno) references Inps_AliquotaCollaboratore (IdInpsAliquota,InpsAliquotaAnno) on update no action on delete no action ;
Alter Table Inps_AliquotaCollDettaglio add Constraint Relationship499 Foreign Key (IdInpsAliquota,InpsAliquotaAnno) references Inps_AliquotaCollaboratore (IdInpsAliquota,InpsAliquotaAnno) on update no action on delete no action ;
Alter Table Inps_Tiporapporto_Aliquota add Constraint Relationship1382 Foreign Key (IdInpsAliquota,InpsAliquotaAnno) references Inps_AliquotaCollaboratore (IdInpsAliquota,InpsAliquotaAnno) on update no action on delete no action ;
Alter Table PosizioneParasubordinato add Constraint Relationship205 Foreign Key (IdInpsTipoRapporto) references Inps_TipoRapporto (IdInpsTipoRapporto) on update no action on delete no action ;
Alter Table Inps_Tiporapporto_Aliquota add Constraint Relationship1383 Foreign Key (IdInpsTipoRapporto) references Inps_TipoRapporto (IdInpsTipoRapporto) on update no action on delete no action ;
Alter Table Inps_TipoAnf2 add Constraint Relationship521 Foreign Key (IdInpsTipoAnf) references Inps_TipoAnf (IdInpsTipoAnf) on update no action on delete no action ;
Alter Table ProfiloAnf add Constraint Relationship1018 Foreign Key (IdInpsTipoAnf) references Inps_TipoAnf (IdInpsTipoAnf) on update no action on delete no action ;
Alter Table Inps_ClasseAnf add Constraint Relationship1020 Foreign Key (IdInpsTipoAnf) references Inps_TipoAnf (IdInpsTipoAnf) on update no action on delete no action ;
Alter Table Inps_AnfNota add Constraint Relationship1021 Foreign Key (IdInpsTipoAnf) references Inps_TipoAnf (IdInpsTipoAnf) on update no action on delete no action ;
Alter Table PosizioneParasubordinato add Constraint Relationship218 Foreign Key (IdInpsCalamita) references Inps_Calamita (IdInpsCalamita) on update no action on delete no action ;
Alter Table PosizioneParasubordinato add Constraint Relationship219 Foreign Key (IdInpsCertificazione) references Inps_Certificazione (IdInpsCertificazione) on update no action on delete no action ;
Alter Table Agevolazione add Constraint Relationship76 Foreign Key (IdTipo) references Inps_TipoAgevolazione (IdInpsTipoAgevolazione) on update no action on delete no action ;
Alter Table Inps_Settore_Contratto add Constraint Relationship18 Foreign Key (IdInpsSettore) references Inps_Settore (IdInpsSettore) on update no action on delete no action ;
Alter Table ContrattazioneIntegrativa add Constraint Relationship270 Foreign Key (IdInpsSettore) references Inps_Settore (IdInpsSettore) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship368 Foreign Key (IdInpsSettore) references Inps_Settore (IdInpsSettore) on update no action on delete no action ;
Alter Table ProfiloLavoratore add Constraint Relationship646 Foreign Key (IdInpsSettore) references Inps_Settore (IdInpsSettore) on update no action on delete no action ;
Alter Table Impresa_Contratto add Constraint Relationship648 Foreign Key (IdInpsSettore) references Inps_Settore (IdInpsSettore) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship48 Foreign Key (IdInpsTipoContribuzione) references Inps_TipoContribuzione (IdInpsTipoContribuzione) on update no action on delete no action ;
Alter Table Inquadramento add Constraint Relationship951 Foreign Key (IdInpsTipoContribuzione) references Inps_TipoContribuzione (IdInpsTipoContribuzione) on update no action on delete no action ;
Alter Table Inps_Settore_Contratto add Constraint Relationship19 Foreign Key (IdInpsContratto) references Inps_Contratto (IdInpsContratto) on update no action on delete no action ;
Alter Table ContrattoDettaglio add Constraint Relationship220 Foreign Key (IdInpsContratto) references Inps_Contratto (IdInpsContratto) on update no action on delete no action ;
Alter Table ContrattazioneIntegrativa add Constraint Relationship271 Foreign Key (IdInpsContratto) references Inps_Contratto (IdInpsContratto) on update no action on delete no action ;
Alter Table Inps_Contratto_Gruppo add Constraint Relationship439 Foreign Key (IdInpsContratto) references Inps_Contratto (IdInpsContratto) on update no action on delete no action ;
Alter Table ElementoBaseImponibile add Constraint Relationship605 Foreign Key (IdInpsContratto) references Inps_Contratto (IdInpsContratto) on update no action on delete no action ;
Alter Table Inps_CodConvValore add Constraint Relationship1381 Foreign Key (IdInpsContratto) references Inps_Contratto (IdInpsContratto) on update no action on delete no action ;
Alter Table Cedolino add Constraint Relationship264 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoDettaglioLivello add Constraint Relationship352 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoDettaglioVoce add Constraint Relationship370 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoCoefficiente add Constraint Relationship405 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoScatto add Constraint Relationship419 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoFerie add Constraint Relationship420 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoDett_Elemento add Constraint Relationship422 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoMaggiorazione add Constraint Relationship445 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoOrario add Constraint Relationship450 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table Impresa_Contratto add Constraint Relationship528 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoIndennita add Constraint Relationship585 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoAssenza add Constraint Relationship604 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ElementoBaseImponibile add Constraint Relationship611 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ProfiloLavoratore add Constraint Relationship647 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoNota add Constraint Relationship700 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table Contratto_Festivita add Constraint Relationship734 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoRateo add Constraint Relationship738 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoAnzianita add Constraint Relationship742 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ApprendistatoGruppo add Constraint Relationship989 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoFestivitaRetrib add Constraint Relationship1285 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoMalattia add Constraint Relationship1287 Foreign Key (IdContrattoDettaglio) references ContrattoDettaglio (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table Settimana_Evento add Constraint Relationship162 Foreign Key (IdDatoRetributivo,IdSettimana) references Settimana (IdDatoRetributivo,IdSettimana) on update no action on delete cascade ;
Alter Table DatoParticolare add Constraint Relationship57 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table Settimana add Constraint Relationship159 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table DiffAccredito add Constraint Relationship547 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Cedolino_Elemento add Constraint Relationship664 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Assenza add Constraint Relationship713 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_ContribAggiuntiva add Constraint Relationship852 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_FondoIntegrativo add Constraint Relationship853 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_Malattia add Constraint Relationship854 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_Maternita add Constraint Relationship858 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table GestioneAnf add Constraint Relationship867 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table GestioneCig add Constraint Relationship875 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table LavPensionato add Constraint Relationship890 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table LavDivAbile add Constraint Relationship895 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table AltreACredito add Constraint Relationship902 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table AltreADebito add Constraint Relationship903 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table VariabileRetributiva add Constraint Relationship956 Foreign Key (IdInquadrDatoRetrib) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table VariabileRetributiva add Constraint Relationship961 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_Incentivo add Constraint Relationship1001 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Giorno add Constraint Relationship1079 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table EventoCig add Constraint Relationship1087 Foreign Key (IdDatoRetributivo) references DatoRetributivo (IdDatoRetributivo) on update no action on delete no action ;
Alter Table ContribSindacalista add Constraint Relationship33 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table Estero add Constraint Relationship84 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table LavDomicilio add Constraint Relationship87 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table FondoSpeciale add Constraint Relationship88 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table Preavviso add Constraint Relationship167 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table ContribAtipica add Constraint Relationship169 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table Bonus add Constraint Relationship170 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table ContrattoRiallineamento add Constraint Relationship171 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete cascade ;
Alter Table DispIntermittente add Constraint Relationship324 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete no action ;
Alter Table DispSomministrati add Constraint Relationship945 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete no action ;
Alter Table EccedenzaMassimale add Constraint Relationship955 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Convenzbilaterale add Constraint Relationship1036 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FormazCig add Constraint Relationship1075 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete no action ;
Alter Table PremioRis add Constraint Relationship1188 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Volo add Constraint Relationship1315 Foreign Key (IdDatoRetributivo) references DatoParticolare (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoPrevMarinara add Constraint Relationship285 Foreign Key (IdDatoRetributivo) references FondoSpeciale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoAnte95 add Constraint Relationship286 Foreign Key (IdDatoRetributivo) references FondoSpeciale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoDaziere add Constraint Relationship287 Foreign Key (IdDatoRetributivo) references FondoSpeciale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoGas add Constraint Relationship288 Foreign Key (IdDatoRetributivo) references FondoSpeciale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoEsattoriale add Constraint Relationship289 Foreign Key (IdDatoRetributivo) references FondoSpeciale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoPortuale add Constraint Relationship290 Foreign Key (IdDatoRetributivo) references FondoSpeciale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoFs add Constraint Relationship291 Foreign Key (IdDatoRetributivo) references FondoSpeciale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table ExIpost add Constraint Relationship1123 Foreign Key (IdDatoRetributivo) references FondoSpeciale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Anf add Constraint Relationship55 Foreign Key (IdPosizione) references PosizioneSubordinato (IdPosizione) on update no action on delete cascade ;
Alter Table Tfr_Mese add Constraint Relationship480 Foreign Key (IdPosizione) references PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Assenza add Constraint Relationship712 Foreign Key (IdPosizione) references PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneIndennita add Constraint Relationship990 Foreign Key (IdPosizione) references PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneContrattIndividuale add Constraint Relationship1006 Foreign Key (IdPosizione) references PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Pa_PosizioneSubordinato add Constraint Relationship1211 Foreign Key (IdPosizione) references PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Sp_PosizioneSubordinato add Constraint Relationship1263 Foreign Key (IdPosizione) references PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneApprendistato add Constraint Relationship1313 Foreign Key (IdPosizione) references PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneParasub_Agevolazione add Constraint Relationship200 Foreign Key (IdAgevolazione) references Agevolazione (IdAgevolazione) on update no action on delete cascade ;
Alter Table Cedolino_Elemento add Constraint Relationship102 Foreign Key (IdPosizione,IdTipoFoglio) references Cedolino (IdPosizione,IdTipoFoglio) on update no action on delete cascade ;
Alter Table ContrattoDettaglioVoce_Cedolino add Constraint Relationship438 Foreign Key (IdPosizione,IdTipoFoglio) references Cedolino (IdPosizione,IdTipoFoglio) on update no action on delete no action ;
Alter Table NumerazioneUnica add Constraint Relationship981 Foreign Key (IdPosizione,IdTipoFoglio) references Cedolino (IdPosizione,IdTipoFoglio) on update no action on delete no action ;
Alter Table ContrattoDettaglioLivelloVoce add Constraint Relationship359 Foreign Key (IdVoce) references ContrattoVoce (IdVoce) on update no action on delete no action ;
Alter Table ContrattoDettaglioVoce add Constraint Relationship371 Foreign Key (IdVoce) references ContrattoVoce (IdVoce) on update no action on delete no action ;
Alter Table ContrattoDett_Elemento add Constraint Relationship505 Foreign Key (IdVoce) references ContrattoVoce (IdVoce) on update no action on delete no action ;
Alter Table ContrattoVoce_BaseImp add Constraint Relationship551 Foreign Key (IdVoce) references ContrattoVoce (IdVoce) on update no action on delete no action ;
Alter Table PosizioneContrattIndividuale add Constraint Relationship1007 Foreign Key (IdVoce) references ContrattoVoce (IdVoce) on update no action on delete no action ;
Alter Table ProfiloContrattIndividuale add Constraint Relationship1008 Foreign Key (IdVoce) references ContrattoVoce (IdVoce) on update no action on delete no action ;
Alter Table Cedolino_Elemento add Constraint Relationship279 Foreign Key (IdElemento) references ElementoRetributivo (IdElemento) on update no action on delete no action ;
Alter Table ContrIntegrativa_AltroElem add Constraint Relationship408 Foreign Key (IdElemento) references ElementoRetributivo (IdElemento) on update no action on delete no action ;
Alter Table ContrattoDett_Elemento add Constraint Relationship421 Foreign Key (IdElemento) references ElementoRetributivo (IdElemento) on update no action on delete no action ;
Alter Table ElementoRetribLimite add Constraint Relationship825 Foreign Key (IdElemento) references ElementoRetributivo (IdElemento) on update no action on delete no action ;
Alter Table ProfiloContrattIndividuale2 add Constraint Relationship1262 Foreign Key (IdElemento) references ElementoRetributivo (IdElemento) on update no action on delete no action ;
Alter Table ElementoRetrib_F24Tributo add Constraint Relationship1330 Foreign Key (IdElemento) references ElementoRetributivo (IdElemento) on update no action on delete no action ;
Alter Table ElementoRetributivo add Constraint Relationship131 Foreign Key (IdFrequenza) references Frequenza (IdFrequenza) on update no action on delete no action ;
Alter Table ContrattoIndennita add Constraint Relationship452 Foreign Key (IdFrequenza) references Frequenza (IdFrequenza) on update no action on delete no action ;
Alter Table Inps_TipoAnf2 add Constraint Relationship522 Foreign Key (IdFrequenza) references Frequenza (IdFrequenza) on update no action on delete no action ;
Alter Table Scadenza add Constraint Relationship525 Foreign Key (IdFrequenza) references Frequenza (IdFrequenza) on update no action on delete no action ;
Alter Table Inps_LimiteImponibile add Constraint Relationship692 Foreign Key (IdFrequenza) references Frequenza (IdFrequenza) on update no action on delete no action ;
Alter Table MalattiaInfortunio add Constraint Relationship1158 Foreign Key (IdAssenza) references Assenza (IdAssenza) on update no action on delete no action ;
Alter Table Cedolino_Elemento add Constraint Relationship1283 Foreign Key (IdAssenza) references Assenza (IdAssenza) on update no action on delete no action ;
Alter Table Assenza add Constraint Relationship808 Foreign Key (IdTipoAssenza) references TipoAssenza (IdTipoAssenza) on update no action on delete no action ;
Alter Table PosizioneParasub_Agevolazione add Constraint Relationship199 Foreign Key (IdPosizione) references PosizioneParasubordinato (IdPosizione) on update no action on delete cascade ;
Alter Table ContrattoVoce add Constraint Relationship361 Foreign Key (IdCategoria1) references CategoriaContrattoVoce1 (IdCategoria1) on update no action on delete no action ;
Alter Table HelpTariffePremiInail add Constraint Relationship236 Foreign Key (IdSettore) references HelpGrandiGruppi (IdSettore) on update no action on delete no action ;
Alter Table Inail_LimiteContributivo2 add Constraint Relationship839 Foreign Key (IdLimiteContrib) references Inail_LimiteContributivo (IdLimiteContrib) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship844 Foreign Key (IdLimiteContrib) references Inail_LimiteContributivo (IdLimiteContrib) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship846 Foreign Key (IdLimiteContrib) references Inail_LimiteContributivo (IdLimiteContrib) on update no action on delete no action ;
Alter Table Dmag_CompatibCodDitta add Constraint Relationship238 Foreign Key (IdDitta1) references Dmag_TipoDitta1 (IdTipoDitta1) on update no action on delete no action ;
Alter Table Dmag_Impresa add Constraint Relationship1045 Foreign Key (IdTipoDitta1) references Dmag_TipoDitta1 (IdTipoDitta1) on update no action on delete no action ;
Alter Table Dmag_ImpresaProfilo add Constraint Relationship1063 Foreign Key (IdTipoDitta1) references Dmag_TipoDitta1 (IdTipoDitta1) on update no action on delete no action ;
Alter Table Dmag_CompatibCodDitta add Constraint Relationship239 Foreign Key (IdDitta2) references Dmag_TipoDitta2 (IdTipoDitta2) on update no action on delete no action ;
Alter Table Dmag_Impresa add Constraint Relationship1046 Foreign Key (IdTipoDitta2) references Dmag_TipoDitta2 (IdTipoDitta2) on update no action on delete no action ;
Alter Table Dmag_ImpresaProfilo add Constraint Relationship1071 Foreign Key (IdTipoDitta2) references Dmag_TipoDitta2 (IdTipoDitta2) on update no action on delete no action ;
Alter Table Dmag_Impresa add Constraint Relationship1058 Foreign Key (IdTipoManodopera) references Dmag_TipoManodopera (IdTipoManodopera) on update no action on delete no action ;
Alter Table Dmag_ImpresaProfilo add Constraint Relationship1060 Foreign Key (IdTipoManodopera) references Dmag_TipoManodopera (IdTipoManodopera) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1309 Foreign Key (IdTipoManodopera) references Dmag_TipoManodopera (IdTipoManodopera) on update no action on delete no action ;
Alter Table Dmag_Lavoratore add Constraint Relationship1321 Foreign Key (IdTipoManodopera) references Dmag_TipoManodopera (IdTipoManodopera) on update no action on delete no action ;
Alter Table Dmag_Impresa add Constraint Relationship1048 Foreign Key (IdTipoDichiaraz) references Dmag_TipoDichiaraz (IdTipoDichiaraz) on update no action on delete no action ;
Alter Table Dmag add Constraint Relationship1290 Foreign Key (IdTipoDichiaraz) references Dmag_TipoDichiaraz (IdTipoDichiaraz) on update no action on delete no action ;
Alter Table Dmag_Lavoratore add Constraint Relationship1208 Foreign Key (IdTipoCategoria) references Dmag_TipoCategoria (IdTipoCategoria) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1303 Foreign Key (IdTipoCategoria) references Dmag_TipoCategoria (IdTipoCategoria) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1306 Foreign Key (IdTipoCategoria) references Dmag_TipoCategoria (IdTipoCategoria) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1066 Foreign Key (IdTipoContratto) references Dmag_TipoContratto (IdTipoContratto) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1297 Foreign Key (IdTipoContratto) references Dmag_TipoContratto (IdTipoContratto) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1067 Foreign Key (IdTipoRetribuzione1) references Dmag_TipoRetribuzione1 (IdTipoRetribuzione1) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1298 Foreign Key (IdTipoRetribuzione1) references Dmag_TipoRetribuzione1 (IdTipoRetribuzione1) on update no action on delete no action ;
Alter Table Estero add Constraint Relationship543 Foreign Key (IdTipoContribEstero) references TipoContribEstero (IdTipoContribEstero) on update no action on delete no action ;
Alter Table ContrIntegrativa_AltroElem add Constraint Relationship407 Foreign Key (IdContrIntegrativa) references ContrattazioneIntegrativa (IdContrIntegrativa) on update no action on delete no action ;
Alter Table ElementoRetributivo add Constraint Relationship276 Foreign Key (IdTipoElemento) references TipoElementoRetributivo (IdTipoElemento) on update no action on delete no action ;
Alter Table ContrattoMaggiorazione add Constraint Relationship663 Foreign Key (IdTipoElemento) references TipoElementoRetributivo (IdTipoElemento) on update no action on delete no action ;
Alter Table TipoAssenza add Constraint Relationship830 Foreign Key (IdTipoElemento) references TipoElementoRetributivo (IdTipoElemento) on update no action on delete no action ;
Alter Table TipoElementoRetributivo add Constraint Relationship1331 Foreign Key (IdTipoElemPadre) references TipoElementoRetributivo (IdTipoElemento) on update no action on delete no action ;
Alter Table FondoAnte95_Arretrato add Constraint Relationship293 Foreign Key (IdDatoRetributivo) references FondoAnte95 (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoAnte95_ContribSindAnno add Constraint Relationship301 Foreign Key (IdDatoRetributivo) references FondoAnte95 (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoAnte95_PartPens add Constraint Relationship831 Foreign Key (IdDatoRetributivo) references FondoAnte95 (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoGas_Preavviso add Constraint Relationship295 Foreign Key (IdDatoRetributivo) references FondoGas (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoGas_Riscatto add Constraint Relationship296 Foreign Key (IdDatoRetributivo) references FondoGas (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoEsattoriale_Arretrato add Constraint Relationship298 Foreign Key (IdDatoRetributivo) references FondoEsattoriale (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoFs_Mese add Constraint Relationship311 Foreign Key (IdDatoRetributivo) references FondoFs (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoFs_Preavviso add Constraint Relationship312 Foreign Key (IdDatoRetributivo) references FondoFs (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoFs_ContribSindAnno add Constraint Relationship313 Foreign Key (IdDatoRetributivo) references FondoFs (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoFs_Maggiorazione add Constraint Relationship307 Foreign Key (IdDatoRetributivo) references FondoFs_Mese (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondoFs_Maggiorazione add Constraint Relationship310 Foreign Key (IdTipoMaggiorazione) references FondoFs_TipoMaggiorazione (IdTipoMaggiorazione) on update no action on delete no action ;
Alter Table PosizioneParasubordinato add Constraint Relationship336 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship337 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cedolino add Constraint Relationship458 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Uniemens_Posizione add Constraint Relationship658 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneRateo add Constraint Relationship728 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table ProgressivoAnno add Constraint Relationship729 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table NucleoFamiliare add Constraint Relationship745 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table PosizionePrevidenziale add Constraint Relationship768 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship779 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table DatoRetributivo add Constraint Relationship805 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneFamiliare add Constraint Relationship821 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneFiscale add Constraint Relationship826 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table PosizioneScatto add Constraint Relationship984 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table PosizionePrevidenzialeAltro add Constraint Relationship994 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_PosizioneLavoratore add Constraint Relationship1154 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Mut_PosizioneLav add Constraint Relationship1209 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Conguaglio730_PosLav add Constraint Relationship1335 Foreign Key (IdPosizione) references PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table ContrattoDettaglioLivelloVoce add Constraint Relationship358 Foreign Key (IdContrattoDettaglio,IdLivello) references ContrattoDettaglioLivello (IdContrattoDettaglio,IdLivello) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship369 Foreign Key (IdContrattoDettaglio,IdLivello) references ContrattoDettaglioLivello (IdContrattoDettaglio,IdLivello) on update no action on delete no action ;
Alter Table ContrattoDettaglioLivello add Constraint Relationship1191 Foreign Key (IdContrattoDettFinale,IdLivelloFinale) references ContrattoDettaglioLivello (IdContrattoDettaglio,IdLivello) on update no action on delete no action ;
Alter Table ContrattoApprendistato add Constraint Relationship1349 Foreign Key (IdContrattoDettaglio,IdLivello) references ContrattoDettaglioLivello (IdContrattoDettaglio,IdLivello) on update no action on delete no action ;
Alter Table ContrattoDettaglioLivelloVoce add Constraint Relationship1192 Foreign Key (IdContrattoDettRif,IdLivelloRif,IdVoceRif,ValidoDalRif) references ContrattoDettaglioLivelloVoce (IdContrattoDettaglio,IdLivello,IdVoce,ValidoDal) on update no action on delete no action ;
Alter Table ContrattoDettaglioVoce_Cedolino add Constraint Relationship437 Foreign Key (IdContrattoDettaglio,IdVoce) references ContrattoDettaglioVoce (IdContrattoDettaglio,IdVoce) on update no action on delete no action ;
Alter Table Inps_AliquotaArea add Constraint Relationship378 Foreign Key (IdGruppo) references Inps_AliquotaGruppo (IdGruppo) on update no action on delete no action ;
Alter Table Inps_Contratto_Gruppo add Constraint Relationship440 Foreign Key (IdGruppo) references Inps_AliquotaGruppo (IdGruppo) on update no action on delete no action ;
Alter Table Inps_AliquotaArea_Lavoratore add Constraint Relationship391 Foreign Key (IdArea) references Inps_AliquotaArea (IdArea) on update no action on delete no action ;
Alter Table Impresa_Contratto add Constraint Relationship526 Foreign Key (IdArea) references Inps_AliquotaArea (IdArea) on update no action on delete no action ;
Alter Table RiduzioneInps add Constraint Relationship638 Foreign Key (IdArea) references Inps_AliquotaArea (IdArea) on update no action on delete no action ;
Alter Table AliquotaPrevidenziale add Constraint Relationship389 Foreign Key (IdArea) references Inps_AliquotaArea (IdArea) on update no action on delete no action ;
Alter Table Inps_AliquotaArea_Lavoratore add Constraint Relationship390 Foreign Key (IdAliquotaTipoLav) references Inps_AliquotaTipoLavoratore (IdAliquotaTipoLav) on update no action on delete no action ;
Alter Table AliquotaPrevidenziale add Constraint Relationship386 Foreign Key (IdAliquotaTipoLav) references Inps_AliquotaTipoLavoratore (IdAliquotaTipoLav) on update no action on delete no action ;
Alter Table Istat_Contratti add Constraint Relationship381 Foreign Key (IdSettore) references Istat_SettoreContratto (IdSettore) on update no action on delete no action ;
Alter Table Istat_SettoreContratto add Constraint Relationship383 Foreign Key (IdSettorePadre) references Istat_SettoreContratto (IdSettore) on update no action on delete no action ;
Alter Table PosizioneScatto add Constraint Relationship999 Foreign Key (IdContrattoDettaglio,IdScatto) references ContrattoScatto (IdContrattoDettaglio,IdScatto) on update no action on delete no action ;
Alter Table ProfiloScatto add Constraint Relationship1000 Foreign Key (IdContrattoDettaglio,IdScatto) references ContrattoScatto (IdContrattoDettaglio,IdScatto) on update no action on delete no action ;
Alter Table ContrattoIndennita_Livello add Constraint Relationship542 Foreign Key (IdIndennita,IdContrattoDettaglio) references ContrattoIndennita (IdIndennita,IdContrattoDettaglio) on update no action on delete no action ;
Alter Table PosizioneIndennita add Constraint Relationship991 Foreign Key (IdIndennita,IdContrattoDettaglio) references ContrattoIndennita (IdIndennita,IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ProfiloIndennita add Constraint Relationship996 Foreign Key (IdIndennita,IdContrattoDettaglio) references ContrattoIndennita (IdIndennita,IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoIndennita add Constraint Relationship449 Foreign Key (IdTipoIndennita) references TipoIndennita (IdTipoIndennita) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship791 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloFiscale add Constraint Relationship792 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloPrevidenziale add Constraint Relationship794 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table PosizioneLavoratore add Constraint Relationship814 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloScatto add Constraint Relationship997 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloContrattIndividuale add Constraint Relationship1009 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloIndennita add Constraint Relationship1010 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloPrevidenzialeAltro add Constraint Relationship1012 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloAnf add Constraint Relationship1015 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table Pa_ProfiloLavoratore add Constraint Relationship1226 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table Tfr_Destinazione add Constraint Relationship1258 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloContrattIndividuale2 add Constraint Relationship1261 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table Sp_ProfiloLavoratore add Constraint Relationship1268 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloApprendistato add Constraint Relationship1312 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloConfig add Constraint Relationship1320 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloPrevidenzialePensione add Constraint Relationship1396 Foreign Key (IdProfilo) references ProfiloLavoratore (IdProfilo) on update no action on delete no action ;
Alter Table PosizioneParasubordinato add Constraint Relationship511 Foreign Key (IdInailAliquota,InailAliquotaAnno) references Inail_Aliquota (IdInailAliquota,InailAliquotaAnno) on update no action on delete no action ;
Alter Table Tfr_MeseTesoreria add Constraint Relationship693 Foreign Key (IdPosizione) references Tfr_Mese (IdPosizione) on update no action on delete no action ;
Alter Table Tfr_Fondinps add Constraint Relationship694 Foreign Key (IdPosizione) references Tfr_Mese (IdPosizione) on update no action on delete no action ;
Alter Table Tfr_MisureCompensative add Constraint Relationship909 Foreign Key (IdPosizione) references Tfr_Mese (IdPosizione) on update no action on delete no action ;
Alter Table Tfr_Liquidato add Constraint Relationship1372 Foreign Key (IdPosizione) references Tfr_Mese (IdPosizione) on update no action on delete no action ;
Alter Table Tfr_SceltaDestinazione add Constraint Relationship695 Foreign Key (IdProfilo,DataScelta) references Tfr_Destinazione (IdProfilo,DataScelta) on update no action on delete no action ;
Alter Table Tfr_Destinazione add Constraint Relationship467 Foreign Key (IdTipoScelta) references Tfr_TipoScelta (IdTipoScelta) on update no action on delete no action ;
Alter Table Tfr_Destinazione add Constraint Relationship485 Foreign Key (IdPrevObbl) references Tfr_IscrizionePrevObbl (IdPrevObbl) on update no action on delete no action ;
Alter Table Tfr_Destinazione add Constraint Relationship486 Foreign Key (IdPrevCompl) references Tfr_IscrizionePrevCompl (IdPrevCompl) on update no action on delete no action ;
Alter Table Tfr_SceltaDestinazione add Constraint Relationship489 Foreign Key (IdTipoQuotaPrevCompl) references Tfr_TipoQuota (IdTipoQuotaPrevCompl) on update no action on delete no action ;
Alter Table Tfr_SceltaDestinazione add Constraint Relationship490 Foreign Key (IdFormaPrevCompl) references AlboCovip (IdFormaPrevCompl) on update no action on delete no action ;
Alter Table Tfr_Mese add Constraint Relationship1374 Foreign Key (IdFormaPrevCompl) references AlboCovip (IdFormaPrevCompl) on update no action on delete no action ;
Alter Table Tfr_Prestazione add Constraint Relationship696 Foreign Key (IdPosizione) references Tfr_MeseTesoreria (IdPosizione) on update no action on delete no action ;
Alter Table Tfr_Contribuzione add Constraint Relationship697 Foreign Key (IdPosizione) references Tfr_MeseTesoreria (IdPosizione) on update no action on delete no action ;
Alter Table Tfr_ContribImpPreg add Constraint Relationship907 Foreign Key (IdPosizione) references Tfr_Contribuzione (IdPosizione) on update no action on delete no action ;
Alter Table Tfr_SceltaDestinazione add Constraint Relationship493 Foreign Key (IdFondoTesoreria) references Tfr_FondoTesoreria (IdFondoTesoreria) on update no action on delete no action ;
Alter Table ProfiloPrevidenziale add Constraint Relationship761 Foreign Key (IdLimiteImponibile) references Inps_LimiteImponibile (IdLimiteImponibile) on update no action on delete no action ;
Alter Table PosizionePrevidenziale add Constraint Relationship813 Foreign Key (IdLimiteImponibile) references Inps_LimiteImponibile (IdLimiteImponibile) on update no action on delete no action ;
Alter Table Inps_LimiteImponibile add Constraint Relationship512 Foreign Key (IdLimiteCategoria) references Inps_LimiteCategoria (IdLimiteCategoria) on update no action on delete no action ;
Alter Table Impresa_Contratto add Constraint Relationship527 Foreign Key (IdLimiteCategoria) references Inps_LimiteCategoria (IdLimiteCategoria) on update no action on delete no action ;
Alter Table Inps_LimiteImponibile add Constraint Relationship513 Foreign Key (IdLimiteQualifica) references Inps_LimiteQualifica (IdLimiteQualifica) on update no action on delete no action ;
Alter Table Inps_LimiteCategoria add Constraint Relationship514 Foreign Key (IdLimiteCategoria2) references Inps_LimiteCategoria2 (IdLimiteCategoria2) on update no action on delete no action ;
Alter Table Anf add Constraint Relationship517 Foreign Key (IdClasseAnf,IdInpsTipoAnf,ValidoDal) references Inps_ClasseAnf (IdClasseAnf,IdInpsTipoAnf,ValidoDal) on update no action on delete no action ;
Alter Table Inps_ClasseAnf add Constraint Relationship1019 Foreign Key (IdInpsTipoAnf2) references Inps_TipoAnf2 (IdInpsTipoAnf2) on update no action on delete no action ;
Alter Table F24_AltroEnte add Constraint Relationship957 Foreign Key (IdDichiarazione) references F24 (IdDichiarazione) on update no action on delete no action ;
Alter Table F24_Erario add Constraint Relationship958 Foreign Key (IdDichiarazione) references F24 (IdDichiarazione) on update no action on delete no action ;
Alter Table F24_Regione add Constraint Relationship959 Foreign Key (IdDichiarazione) references F24 (IdDichiarazione) on update no action on delete no action ;
Alter Table F24_Inps add Constraint Relationship960 Foreign Key (IdDichiarazione) references F24 (IdDichiarazione) on update no action on delete no action ;
Alter Table F24_Imu add Constraint Relationship1370 Foreign Key (IdDichiarazione) references F24 (IdDichiarazione) on update no action on delete no action ;
Alter Table CudField add Constraint Relationship1260 Foreign Key (IdDichiarazione) references Cud (IdDichiarazione) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship540 Foreign Key (IdAssunzione) references Assunzione (IdAssunzione) on update no action on delete no action ;
Alter Table Legge68 add Constraint Relationship1197 Foreign Key (IdAssunzione) references Assunzione (IdAssunzione) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship539 Foreign Key (IdCessazione) references Cessazione (IdCessazione) on update no action on delete no action ;
Alter Table ContrattoVoce_BaseImp add Constraint Relationship552 Foreign Key (IdBaseImponibile) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ContrattoAssenza add Constraint Relationship606 Foreign Key (IdBaseImponibile) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ContrattoIndennita add Constraint Relationship608 Foreign Key (IdBaseImponibile) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ElementoRetributivo add Constraint Relationship609 Foreign Key (IdBaseImponibile) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ContrattoMaggiorazione add Constraint Relationship612 Foreign Key (IdBaseImponibile) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ContrattoScatto add Constraint Relationship613 Foreign Key (IdBaseImponibile) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ElementoBaseImp_BaseImp add Constraint Relationship622 Foreign Key (IdBaseImponibile1) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ElementoBaseImp_BaseImp add Constraint Relationship623 Foreign Key (IdBaseImponibile2) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ContrattoDett_Elemento add Constraint Relationship642 Foreign Key (IdBaseImponibile) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ContrattoDettaglioVoce add Constraint Relationship828 Foreign Key (IdBaseImponibile) references ElementoBaseImponibile (IdBaseImponibile) on update no action on delete no action ;
Alter Table ContrattoAssenzaLivello add Constraint Relationship602 Foreign Key (IdAssenza,IdContrattoDettaglio) references ContrattoAssenza (IdAssenza,IdContrattoDettaglio) on update no action on delete no action ;
Alter Table Uniemens_Posizione add Constraint Relationship657 Foreign Key (IdDichiarazione) references Uniemens (IdDichiarazione) on update no action on delete no action ;
Alter Table DenunciaAziendale add Constraint Relationship1032 Foreign Key (IdDichiarazione) references Uniemens (IdDichiarazione) on update no action on delete no action ;
Alter Table Uniemens_Impresa add Constraint Relationship1132 Foreign Key (IdDichiarazione) references Uniemens (IdDichiarazione) on update no action on delete no action ;
Alter Table Cnce_PosizioneLavoratore add Constraint Relationship1156 Foreign Key (IdTipoAssunzione) references Cnce_TipoAssunzione (IdTipoAssunzione) on update no action on delete no action ;
Alter Table Cnce_PosizioneLavoratore add Constraint Relationship1155 Foreign Key (IdTipoCessazione) references Cnce_TipoCessazione (IdTipoCessazione) on update no action on delete no action ;
Alter Table Cnce_PosizioneLavoratore add Constraint Relationship1137 Foreign Key (IdLivelloQualifica) references Cnce_LivelloQualifica (IdLivelloQualifica) on update no action on delete no action ;
Alter Table Cnce_PosizioneLavoratore add Constraint Relationship1134 Foreign Key (IdMansione) references Cnce_Mansione (IdMansione) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship974 Foreign Key (IdInailContratto) references Inail_Contratto (IdContratto) on update no action on delete no action ;
Alter Table ProfiloInailImpresa add Constraint Relationship1035 Foreign Key (IdContratto) references Inail_Contratto (IdContratto) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship971 Foreign Key (IdInailProfessione) references Inail_Professione (IdInailProfessione) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship975 Foreign Key (IdInailProfessione) references Inail_Professione (IdInailProfessione) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship972 Foreign Key (IdInailQualifica) references Inail_Qualifica (IdInailQualifica) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship976 Foreign Key (IdInailQualifica) references Inail_Qualifica (IdInailQualifica) on update no action on delete no action ;
Alter Table Posizione_RiduzioneInps add Constraint Relationship636 Foreign Key (IdRiduzioneInps) references RiduzioneInps (IdRiduzioneInps) on update no action on delete no action ;
Alter Table ProfiloPrevidenziale add Constraint Relationship799 Foreign Key (IdRiduzioneInps) references RiduzioneInps (IdRiduzioneInps) on update no action on delete no action ;
Alter Table PosizionePrevidenziale add Constraint Relationship800 Foreign Key (IdRiduzioneInps) references RiduzioneInps (IdRiduzioneInps) on update no action on delete no action ;
Alter Table Dichiarazione add Constraint Relationship677 Foreign Key (IdStatoDichiarazione) references StatoDichiarazione (IdStatoDichiarazione) on update no action on delete no action ;
Alter Table Co add Constraint Relationship666 Foreign Key (IdEntePrevidenziale) references Co_EntePrevidenziale (IdEntePrevidenziale) on update no action on delete no action ;
Alter Table AliquotaPrevidenziale add Constraint Relationship811 Foreign Key (IdEntePrevidenziale) references Co_EntePrevidenziale (IdEntePrevidenziale) on update no action on delete no action ;
Alter Table ElementoRetributivo add Constraint Relationship1011 Foreign Key (IdEntePrevidenziale) references Co_EntePrevidenziale (IdEntePrevidenziale) on update no action on delete no action ;
Alter Table ProfiloPrevidenzialeAltro add Constraint Relationship1013 Foreign Key (IdEntePrevidenziale) references Co_EntePrevidenziale (IdEntePrevidenziale) on update no action on delete no action ;
Alter Table PosizionePrevidenzialeAltro add Constraint Relationship1014 Foreign Key (IdEntePrevidenziale) references Co_EntePrevidenziale (IdEntePrevidenziale) on update no action on delete no action ;
Alter Table Co add Constraint Relationship668 Foreign Key (IdTipoCessazione) references Co_TipoCessazione (IdTipoCessazione) on update no action on delete no action ;
Alter Table Cessazione add Constraint Relationship1196 Foreign Key (IdCoTipoCessazione) references Co_TipoCessazione (IdTipoCessazione) on update no action on delete no action ;
Alter Table Co add Constraint Relationship670 Foreign Key (IdTipoContratto) references Co_TipoContratto (IdTipoContratto) on update no action on delete no action ;
Alter Table Assunzione add Constraint Relationship1198 Foreign Key (IdTipoContratto) references Co_TipoContratto (IdTipoContratto) on update no action on delete no action ;
Alter Table Co add Constraint Relationship669 Foreign Key (IdTrasformazione) references Co_Trasformazione (IdTrasformazione) on update no action on delete no action ;
Alter Table Co add Constraint Relationship672 Foreign Key (IdTipoCo) references Co_Tipo (IdTipoCo) on update no action on delete no action ;
Alter Table Co add Constraint Relationship673 Foreign Key (IdArgomento) references Co_Argomento (IdArgomento) on update no action on delete no action ;
Alter Table Co add Constraint Relationship674 Foreign Key (IdTipoComunicazione) references Co_TipoComunicazione (IdTipoComunicazione) on update no action on delete no action ;
Alter Table Co add Constraint Relationship675 Foreign Key (IdTipoTrasferimento) references Co_TipoTrasferimento (IdTipoTrasferimento) on update no action on delete no action ;
Alter Table Cud add Constraint Relationship679 Foreign Key (IdDichiarazione) references Dichiarazione (IdDichiarazione) on update no action on delete no action ;
Alter Table M770 add Constraint Relationship680 Foreign Key (IdDichiarazione) references Dichiarazione (IdDichiarazione) on update no action on delete no action ;
Alter Table Uniemens add Constraint Relationship681 Foreign Key (IdDichiarazione) references Dichiarazione (IdDichiarazione) on update no action on delete no action ;
Alter Table F24 add Constraint Relationship682 Foreign Key (IdDichiarazione) references Dichiarazione (IdDichiarazione) on update no action on delete no action ;
Alter Table Co add Constraint Relationship684 Foreign Key (IdDichiarazione) references Dichiarazione (IdDichiarazione) on update no action on delete no action ;
Alter Table Mut add Constraint Relationship1161 Foreign Key (IdDichiarazione) references Dichiarazione (IdDichiarazione) on update no action on delete no action ;
Alter Table Dmag add Constraint Relationship1293 Foreign Key (IdDichiarazione) references Dichiarazione (IdDichiarazione) on update no action on delete no action ;
Alter Table Pa add Constraint Relationship1326 Foreign Key (IdDichiarazione) references Dichiarazione (IdDichiarazione) on update no action on delete no action ;
Alter Table Dichiarazione add Constraint Relationship678 Foreign Key (IdTipoDichiarazione) references TipoDichiarazione (IdTipoDichiarazione) on update no action on delete no action ;
Alter Table Dmag_Impresa add Constraint Relationship1050 Foreign Key (IdAssCategoria) references Dmag_AssCategoria (IdAssCategoria) on update no action on delete no action ;
Alter Table Dmag_ImpresaProfilo add Constraint Relationship1064 Foreign Key (IdAssCategoria) references Dmag_AssCategoria (IdAssCategoria) on update no action on delete no action ;
Alter Table Inps_TipoLavoratore_Fondo add Constraint Relationship698 Foreign Key (IdFondoSpeciale) references Inps_FondoSpeciale (IdFondoSpeciale) on update no action on delete no action ;
Alter Table ContrattoNota add Constraint Relationship701 Foreign Key (IdTipoNota) references ContrattoTipoNota (IdTipoNota) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship702 Foreign Key (IdTipoCalcolo) references TipoCalcolo (IdTipoCalcolo) on update no action on delete no action ;
Alter Table ProfiloLavoratore add Constraint Relationship703 Foreign Key (IdTipoCalcolo) references TipoCalcolo (IdTipoCalcolo) on update no action on delete no action ;
Alter Table ContrattoFestivitaRetrib2 add Constraint Relationship741 Foreign Key (IdContrattoDettaglio) references ContrattoFestivitaRetrib (IdContrattoDettaglio) on update no action on delete no action ;
Alter Table ContrattoVoce add Constraint Relationship721 Foreign Key (IdCategoria2) references CategoriaContrattoVoce2 (IdCategoria2) on update no action on delete no action ;
Alter Table PosizioneRateo add Constraint Relationship724 Foreign Key (IdTipoRateo) references TipoRateo (IdTipoRateo) on update no action on delete no action ;
Alter Table ContrattoRateoValore add Constraint Relationship739 Foreign Key (IdTipoRateo) references TipoRateo (IdTipoRateo) on update no action on delete no action ;
Alter Table ContrattoRateoValore add Constraint Relationship740 Foreign Key (IdContrattoDettaglio,IdRateo) references ContrattoRateo (IdContrattoDettaglio,IdRateo) on update no action on delete no action ;
Alter Table Cedolino_Elemento add Constraint Relationship743 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table ContrattoRateoValore add Constraint Relationship744 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table PosizioneRateo add Constraint Relationship822 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table ContrattoDettaglio add Constraint Relationship827 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table ContrattoCoefficiente add Constraint Relationship833 Foreign Key (MensilitaAggIdUm) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table Inps_LimiteImponibile add Constraint Relationship838 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table Inail_RetribConvenzionale2 add Constraint Relationship841 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table Inail_LimiteContributivo2 add Constraint Relationship842 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table ContrattoRateoValore add Constraint Relationship965 Foreign Key (IdUnitaMisura2) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table PosizioneScatto add Constraint Relationship986 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table ContrattoIndennita add Constraint Relationship995 Foreign Key (IdUnitaMisura) references UnitaMisura (IdUnitaMisura) on update no action on delete no action ;
Alter Table Tfr_Situazione_Detrazione add Constraint Relationship754 Foreign Key (IdLavoratore,Anno) references Tfr_Anno (IdLavoratore,Anno) on update no action on delete no action ;
Alter Table Tfr_Situazione_Detrazione add Constraint Relationship753 Foreign Key (IdDetrazioneTfr) references Tfr_Detrazione (IdDetrazioneTfr) on update no action on delete no action ;
Alter Table Tfr_Detrazione add Constraint Relationship756 Foreign Key (IdTipoDetrazione) references Tfr_TipoDetrazione (IdTipoDetrazione) on update no action on delete no action ;
Alter Table ProfiloPrev_DrTipoIncentivo add Constraint Relationship1362 Foreign Key (IdProfilo) references ProfiloPrevidenziale (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloPrev_InpsCodConv add Constraint Relationship1363 Foreign Key (IdProfilo) references ProfiloPrevidenziale (IdProfilo) on update no action on delete no action ;
Alter Table ProfiloPrev_DrCausaleACredito add Constraint Relationship1364 Foreign Key (IdProfilo) references ProfiloPrevidenziale (IdProfilo) on update no action on delete no action ;
Alter Table Posizione_RiduzioneInps add Constraint Relationship798 Foreign Key (IdPosizione,IdTipoFoglio) references PosizionePrevidenziale (IdPosizione,IdTipoFoglio) on update no action on delete no action ;
Alter Table PosizionePrevidenziale add Constraint Relationship810 Foreign Key (IdAliquotaPrevidenziale) references AliquotaPrevidenziale (IdAliquotaPrevidenziale) on update no action on delete no action ;
Alter Table ProfiloPrevidenziale add Constraint Relationship760 Foreign Key (IdAliquotaPrevidenziale) references AliquotaPrevidenziale (IdAliquotaPrevidenziale) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship973 Foreign Key (IdInailTipoRapporto) references Inail_TipoRapporto (IdInailTipoRapporto) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship977 Foreign Key (IdInailTipoRapporto) references Inail_TipoRapporto (IdInailTipoRapporto) on update no action on delete no action ;
Alter Table Inail_Gruppo2 add Constraint Relationship804 Foreign Key (IdGruppo) references Inail_Gruppo (IdGruppo) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship848 Foreign Key (IdGruppo2,IdGruppo) references Inail_Gruppo2 (IdGruppo2,IdGruppo) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship849 Foreign Key (IdGruppo2,IdGruppo) references Inail_Gruppo2 (IdGruppo2,IdGruppo) on update no action on delete no action ;
Alter Table ProfiloInailImpresa add Constraint Relationship1034 Foreign Key (IdGruppo2,IdGruppo) references Inail_Gruppo2 (IdGruppo2,IdGruppo) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship850 Foreign Key (IdPat) references Inail_Pat (IdPat) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship851 Foreign Key (IdPat) references Inail_Pat (IdPat) on update no action on delete no action ;
Alter Table PosizioneLavoratore add Constraint Relationship816 Foreign Key (IdStatoPosizione) references StatoPosizione (IdStatoPosizione) on update no action on delete no action ;
Alter Table Inps_LimiteImponibile add Constraint Relationship815 Foreign Key (IdTipoLimite) references TipoLimite (IdTipoLimite) on update no action on delete no action ;
Alter Table Inail_RetribConvenzionale2 add Constraint Relationship840 Foreign Key (IdRetribConv) references Inail_RetribConvenzionale (IdRetribConv) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship845 Foreign Key (IdRetribConv) references Inail_RetribConvenzionale (IdRetribConv) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship847 Foreign Key (IdRetribConv) references Inail_RetribConvenzionale (IdRetribConv) on update no action on delete no action ;
Alter Table Uniemens add Constraint Relationship914 Foreign Key (IdTipoComposizione) references TipoUniemens (IdTipoComposizione) on update no action on delete no action ;
Alter Table Dr_MalattiaADebito add Constraint Relationship866 Foreign Key (IdCausaleVersMal) references Dr_CausaleVersMal (IdCausaleVersMal) on update no action on delete no action ;
Alter Table Dr_MalattiaACreditoAltre add Constraint Relationship864 Foreign Key (IdCausaleRecMal) references Dr_CausaleRecMal (IdCausaleRecMal) on update no action on delete no action ;
Alter Table AnfADebito add Constraint Relationship872 Foreign Key (IdCausaleRestituzAnf) references Dr_CausaleRestituzAnf (IdCausaleRestituzAnf) on update no action on delete no action ;
Alter Table AnfACreditoAltre add Constraint Relationship874 Foreign Key (IdCausaleRecAnf) references Dr_CausaleRecAnf (IdCausaleRecAnf) on update no action on delete no action ;
Alter Table CigoADebito add Constraint Relationship881 Foreign Key (IdCausaleContribAddCigo) references Dr_CausaleContribAddCigo (IdCausaleContribAddCigo) on update no action on delete no action ;
Alter Table CigoACredAltre add Constraint Relationship884 Foreign Key (IdCausaleCongCigo) references Dr_CausaleCongCigo (IdCausaleCongCigo) on update no action on delete no action ;
Alter Table CigsADebito add Constraint Relationship885 Foreign Key (IdCausaleContribAddCigs) references Dr_CausaleContribAddCigs (IdCausaleContribAddCigs) on update no action on delete no action ;
Alter Table CigsACredAltre add Constraint Relationship888 Foreign Key (IdCausaleCongCigs) references Dr_CausaleCongCigs (IdCausaleCongCigs) on update no action on delete no action ;
Alter Table CigsDatiStat add Constraint Relationship889 Foreign Key (IdCausaleStatCigs) references Dr_CausaleStatCigs (IdCausaleStatCigs) on update no action on delete no action ;
Alter Table FondiDiversi add Constraint Relationship894 Foreign Key (IdCausaleTrattPens) references Dr_CausaleTrattPens (IdCausaleTrattPens) on update no action on delete no action ;
Alter Table LavDivAbile add Constraint Relationship898 Foreign Key (IdCausaleStatDivAbile) references Dr_CausaleStatDivAbile (IdCausaleStatDivAbile) on update no action on delete no action ;
Alter Table LavDivAbile add Constraint Relationship943 Foreign Key (IdBeneficioDivAbileReg) references Dr_BeneficioDivAbileRegione (IdBeneficioDivAbileReg) on update no action on delete no action ;
Alter Table AltreADebito add Constraint Relationship900 Foreign Key (IdCausaleADebito) references Dr_CausaleADebito (IdCausaleADebito) on update no action on delete no action ;
Alter Table AltreACredito add Constraint Relationship901 Foreign Key (IdCausaleACredito) references Dr_CausaleACredito (IdCausaleACredito) on update no action on delete no action ;
Alter Table ProfiloPrev_DrCausaleACredito add Constraint Relationship1369 Foreign Key (IdCausaleACredito) references Dr_CausaleACredito (IdCausaleACredito) on update no action on delete no action ;
Alter Table VariabileRetributiva add Constraint Relationship1022 Foreign Key (IdTipoVarRetr) references TipoVarRetr (IdTipoVarRetr) on update no action on delete no action ;
Alter Table Tfr_MisCompADebito add Constraint Relationship913 Foreign Key (IdCausaleMcADeb) references Tfr_CausaleMcADeb (IdCausaleMcADeb) on update no action on delete no action ;
Alter Table Tfr_MisCompACredito add Constraint Relationship912 Foreign Key (IdCausaleMcACred) references Tfr_CausaleMcACred (IdCausaleMcACred) on update no action on delete no action ;
Alter Table Dr_MaternitaADebito add Constraint Relationship865 Foreign Key (IdCausaleVersMat) references Dr_CausaleVersMat (IdCausaleVersMat) on update no action on delete no action ;
Alter Table Dr_MaternitaACreditoAltre add Constraint Relationship863 Foreign Key (IdCausaleRecMat) references Dr_CausaleRecMat (IdCausaleRecMat) on update no action on delete no action ;
Alter Table Dr_MalattiaADebito add Constraint Relationship855 Foreign Key (IdDatoRetributivo) references Dr_Malattia (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_MalattiaACredito add Constraint Relationship856 Foreign Key (IdDatoRetributivo) references Dr_Malattia (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_MalattiaACreditoAltre add Constraint Relationship857 Foreign Key (IdDatoRetributivo) references Dr_MalattiaACredito (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_MaternitaADebito add Constraint Relationship859 Foreign Key (IdDatoRetributivo) references Dr_Maternita (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_MaternitaACredito add Constraint Relationship860 Foreign Key (IdDatoRetributivo) references Dr_Maternita (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Dr_MaternitaACreditoAltre add Constraint Relationship861 Foreign Key (IdDatoRetributivo) references Dr_MaternitaACredito (IdDatoRetributivo) on update no action on delete no action ;
Alter Table AnfACredito add Constraint Relationship868 Foreign Key (IdDatoRetributivo) references GestioneAnf (IdDatoRetributivo) on update no action on delete no action ;
Alter Table AnfADebito add Constraint Relationship869 Foreign Key (IdDatoRetributivo) references GestioneAnf (IdDatoRetributivo) on update no action on delete no action ;
Alter Table AnfT4 add Constraint Relationship944 Foreign Key (IdDatoRetributivo) references GestioneAnf (IdDatoRetributivo) on update no action on delete no action ;
Alter Table AnfACreditoAltre add Constraint Relationship873 Foreign Key (IdDatoRetributivo) references AnfACredito (IdDatoRetributivo) on update no action on delete no action ;
Alter Table CigoADebito add Constraint Relationship876 Foreign Key (IdDatoRetributivo) references GestioneCig (IdDatoRetributivo) on update no action on delete no action ;
Alter Table CigoACredito add Constraint Relationship877 Foreign Key (IdDatoRetributivo) references GestioneCig (IdDatoRetributivo) on update no action on delete no action ;
Alter Table CigsDatiStat add Constraint Relationship878 Foreign Key (IdDatoRetributivo) references GestioneCig (IdDatoRetributivo) on update no action on delete no action ;
Alter Table CigsADebito add Constraint Relationship879 Foreign Key (IdDatoRetributivo) references GestioneCig (IdDatoRetributivo) on update no action on delete no action ;
Alter Table CigsACredito add Constraint Relationship880 Foreign Key (IdDatoRetributivo) references GestioneCig (IdDatoRetributivo) on update no action on delete no action ;
Alter Table CigoACredAltre add Constraint Relationship882 Foreign Key (IdDatoRetributivo) references CigoACredito (IdDatoRetributivo) on update no action on delete no action ;
Alter Table OreCongCigo add Constraint Relationship883 Foreign Key (IdDatoRetributivo) references CigoACredito (IdDatoRetributivo) on update no action on delete no action ;
Alter Table CigsACredAltre add Constraint Relationship886 Foreign Key (IdDatoRetributivo) references CigsACredito (IdDatoRetributivo) on update no action on delete no action ;
Alter Table OreCongCigs add Constraint Relationship887 Foreign Key (IdDatoRetributivo) references CigsACredito (IdDatoRetributivo) on update no action on delete no action ;
Alter Table LavPensTrattenuta add Constraint Relationship891 Foreign Key (IdDatoRetributivo) references LavPensionato (IdDatoRetributivo) on update no action on delete no action ;
Alter Table LavPensRimborso add Constraint Relationship892 Foreign Key (IdDatoRetributivo) references LavPensionato (IdDatoRetributivo) on update no action on delete no action ;
Alter Table FondiDiversi add Constraint Relationship893 Foreign Key (IdDatoRetributivo) references LavPensTrattenuta (IdDatoRetributivo) on update no action on delete no action ;
Alter Table Estero add Constraint Relationship906 Foreign Key (IdEsteroTipoImp) references Inps_EsteroTipoImp (IdEsteroTipoImp) on update no action on delete no action ;
Alter Table Tfr_ContribImpPreg add Constraint Relationship908 Foreign Key (IdTipoImpPregCmt) references Tfr_TipoImpPregCmt (IdTipoImpPregCmt) on update no action on delete no action ;
Alter Table Tfr_MisCompADebito add Constraint Relationship910 Foreign Key (IdPosizione) references Tfr_MisureCompensative (IdPosizione) on update no action on delete no action ;
Alter Table Tfr_MisCompACredito add Constraint Relationship911 Foreign Key (IdPosizione) references Tfr_MisureCompensative (IdPosizione) on update no action on delete no action ;
Alter Table Da_FondoInterprof add Constraint Relationship922 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_InfoStat add Constraint Relationship925 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_ContribAssistContrat add Constraint Relationship926 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_AziendaTfr add Constraint Relationship928 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_PrestazBancari add Constraint Relationship931 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_AltrePartiteADebito add Constraint Relationship937 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_AltrePartiteACredito add Constraint Relationship938 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_RecuperoPrestFondiSol add Constraint Relationship941 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_DatiQuadraturaRetrContr add Constraint Relationship942 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table ConguaglioCig add Constraint Relationship1088 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table ConguaglioAsoCred add Constraint Relationship1187 Foreign Key (IdDenunciaAziendale) references DenunciaAziendale (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_InfoStat add Constraint Relationship924 Foreign Key (IdTipoInfoStat) references TipoInfoStat (IdTipoInfoStat) on update no action on delete no action ;
Alter Table DenunciaAziendale add Constraint Relationship916 Foreign Key (IdTrattQuotaLav) references Da_TrattQuotaLav (IdTrattQuotaLav) on update no action on delete no action ;
Alter Table Da_FondoInterprof add Constraint Relationship917 Foreign Key (IdFondoInterRevoca2) references Da_FondoInterRevoca (IdFondoInterRevoca) on update no action on delete no action ;
Alter Table Da_FondoInterprof add Constraint Relationship920 Foreign Key (IdFondoInterRevoca1) references Da_FondoInterRevoca (IdFondoInterRevoca) on update no action on delete no action ;
Alter Table Da_FondoInterprof add Constraint Relationship918 Foreign Key (IdFondoInterAdesione1) references Da_FondoInterAdesione (IdFondoInterAdesione) on update no action on delete no action ;
Alter Table Da_FondoInterprof add Constraint Relationship919 Foreign Key (IdFondoInterAdesione2) references Da_FondoInterAdesione (IdFondoInterAdesione) on update no action on delete no action ;
Alter Table Da_ContribAssistContrat add Constraint Relationship923 Foreign Key (IdTipoContribAssist) references Da_TipoContribAssist (IdTipoContribAssist) on update no action on delete no action ;
Alter Table Da_RecuperoTfr add Constraint Relationship927 Foreign Key (IdDenunciaAziendale) references Da_AziendaTfr (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_AziendaTfr add Constraint Relationship929 Foreign Key (IdCausaleVers1) references Tfr_CausaleVers (IdCausaleVers) on update no action on delete no action ;
Alter Table Da_AziendaTfr add Constraint Relationship946 Foreign Key (IdCausaleVers2) references Tfr_CausaleVers (IdCausaleVers) on update no action on delete no action ;
Alter Table Da_RecuperoTfr add Constraint Relationship930 Foreign Key (IdCausaleRec) references Tfr_CausaleRec (IdCausaleRec) on update no action on delete no action ;
Alter Table Da_VersPensBancari add Constraint Relationship932 Foreign Key (IdDenunciaAziendale) references Da_PrestazBancari (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_RecuperoPensBancari add Constraint Relationship933 Foreign Key (IdDenunciaAziendale) references Da_PrestazBancari (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Da_RecuperoPensBancari add Constraint Relationship935 Foreign Key (IdCausaleRecPens) references Da_CausaleRecPens (IdCausaleRecPens) on update no action on delete no action ;
Alter Table Da_VersPensBancari add Constraint Relationship934 Foreign Key (IdCausaleVersPens) references Da_CausaleVersPens (IdCausaleVersPens) on update no action on delete no action ;
Alter Table Da_AltrePartiteACredito add Constraint Relationship939 Foreign Key (IdCausaleACredito) references Da_CausaleACredito (IdCausaleACredito) on update no action on delete no action ;
Alter Table Da_AltrePartiteADebito add Constraint Relationship936 Foreign Key (IdCausaleADebito) references Da_CausaleADebito (IdCausaleADebito) on update no action on delete no action ;
Alter Table Da_RecuperoPrestFondiSol add Constraint Relationship940 Foreign Key (IdCausaleRecPrest) references Da_CausaleRecPrest (IdCausaleRecPrest) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship1031 Foreign Key (IdInquadramento) references Inquadramento (IdInquadramento) on update no action on delete no action ;
Alter Table Inail_SilAsb add Constraint Relationship966 Foreign Key (IdImpresa,Pat,Anno) references Inail_PosizioneImpresa (IdImpresa,Pat,Anno) on update no action on delete no action ;
Alter Table Inail_InfMal add Constraint Relationship967 Foreign Key (IdImpresa,Pat,Anno) references Inail_PosizioneImpresa (IdImpresa,Pat,Anno) on update no action on delete no action ;
Alter Table Inail_Artigiano add Constraint Relationship968 Foreign Key (IdImpresa,Pat,Anno) references Inail_PosizioneImpresa (IdImpresa,Pat,Anno) on update no action on delete no action ;
Alter Table Inail_Sconto add Constraint Relationship969 Foreign Key (IdImpresa,Pat,Anno) references Inail_PosizioneImpresa (IdImpresa,Pat,Anno) on update no action on delete no action ;
Alter Table Inail_ContribAssociativo add Constraint Relationship970 Foreign Key (IdImpresa,Pat,Anno) references Inail_PosizioneImpresa (IdImpresa,Pat,Anno) on update no action on delete no action ;
Alter Table Inail_Riepilogo add Constraint Relationship1076 Foreign Key (IdImpresa,Pat,Anno) references Inail_PosizioneImpresa (IdImpresa,Pat,Anno) on update no action on delete no action ;
Alter Table Cedolino add Constraint Relationship980 Foreign Key (IdTipoFoglio) references TipoFoglio (IdTipoFoglio) on update no action on delete no action ;
Alter Table PosizionePrevidenziale add Constraint Relationship1072 Foreign Key (IdTipoFoglio) references TipoFoglio (IdTipoFoglio) on update no action on delete no action ;
Alter Table PosizioneFiscale add Constraint Relationship1073 Foreign Key (IdTipoFoglio) references TipoFoglio (IdTipoFoglio) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship1074 Foreign Key (IdTipoFoglio) references TipoFoglio (IdTipoFoglio) on update no action on delete no action ;
Alter Table PosizionePrevidenzialeAltro add Constraint Relationship1122 Foreign Key (IdTipoFoglio) references TipoFoglio (IdTipoFoglio) on update no action on delete no action ;
Alter Table ApprendistatoDettaglio add Constraint Relationship988 Foreign Key (IdContrattoDettaglio,IdGruppo) references ApprendistatoGruppo (IdContrattoDettaglio,IdGruppo) on update no action on delete no action ;
Alter Table ElementoRetributivo add Constraint Relationship992 Foreign Key (IdTipoElemento2) references TipoElementoRetributivo2 (IdTipoElemento2) on update no action on delete no action ;
Alter Table Dr_Incentivo add Constraint Relationship1002 Foreign Key (IdTipoIncentivo) references Dr_TipoIncentivo (IdTipoIncentivo) on update no action on delete no action ;
Alter Table ProfiloPrevidenziale add Constraint Relationship1350 Foreign Key (IdTipoIncentivo) references Dr_TipoIncentivo (IdTipoIncentivo) on update no action on delete no action ;
Alter Table IncentivoValore add Constraint Relationship1359 Foreign Key (IdTipoIncentivo) references Dr_TipoIncentivo (IdTipoIncentivo) on update no action on delete no action ;
Alter Table ProfiloPrev_DrTipoIncentivo add Constraint Relationship1366 Foreign Key (IdTipoIncentivo) references Dr_TipoIncentivo (IdTipoIncentivo) on update no action on delete no action ;
Alter Table Dr_Incentivo add Constraint Relationship1003 Foreign Key (IdEnteFinanziatore) references Dr_EnteFinanziatore (IdEnteFinanziatore) on update no action on delete no action ;
Alter Table ProfiloPrevidenziale add Constraint Relationship1358 Foreign Key (IdEnteFinanziatore) references Dr_EnteFinanziatore (IdEnteFinanziatore) on update no action on delete no action ;
Alter Table ProfiloPrev_DrTipoIncentivo add Constraint Relationship1367 Foreign Key (IdEnteFinanziatore) references Dr_EnteFinanziatore (IdEnteFinanziatore) on update no action on delete no action ;
Alter Table Dmag_Lavoratore add Constraint Relationship1042 Foreign Key (IdDichiarazione,IdImpresa) references Dmag_Impresa (IdDichiarazione,IdImpresa) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1322 Foreign Key (IdDichiarazione,IdImpresa,IdLavoratore) references Dmag_Lavoratore (IdDichiarazione,IdImpresa,IdLavoratore) on update no action on delete no action ;
Alter Table Dmag_Lavoratore add Constraint Relationship1055 Foreign Key (IdTipoClassific) references Dmag_TipoClassific (IdTipoClassific) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1310 Foreign Key (IdTipoClassific) references Dmag_TipoClassific (IdTipoClassific) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1069 Foreign Key (IdAreaLav) references Dmag_Arealav (IdAreaLav) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1305 Foreign Key (IdAreaLav) references Dmag_Arealav (IdAreaLav) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1070 Foreign Key (IdZt) references Dmag_Zt (IdZt) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1300 Foreign Key (IdZt) references Dmag_Zt (IdZt) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1065 Foreign Key (IdTipoLav) references Dmag_TipoLav (IdTipoLav) on update no action on delete no action ;
Alter Table Dmag_Impresa add Constraint Relationship1049 Foreign Key (IdTipoManodoperaDic) references Dmag_TipoManodoperaDic (IdTipoManodoperaDic) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1068 Foreign Key (IdTipoRetribuzione2) references Dmag_TipoRetribuzione2 (IdTipoRetribuzione2) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1299 Foreign Key (IdTipoRetribuzione2) references Dmag_TipoRetribuzione2 (IdTipoRetribuzione2) on update no action on delete no action ;
Alter Table Convenzbilaterale add Constraint Relationship1059 Foreign Key (IdCodConv) references Inps_CodConv (IdCodConv) on update no action on delete no action ;
Alter Table ProfiloPrev_InpsCodConv add Constraint Relationship1368 Foreign Key (IdCodConv) references Inps_CodConv (IdCodConv) on update no action on delete no action ;
Alter Table Inps_CodConvValore add Constraint Relationship1380 Foreign Key (IdCodConv) references Inps_CodConv (IdCodConv) on update no action on delete no action ;
Alter Table Inail_Sconto add Constraint Relationship1077 Foreign Key (IdScontoReg) references Inail_Sconto2 (IdSconto) on update no action on delete no action ;
Alter Table Inail_Sconto add Constraint Relationship1078 Foreign Key (IdScontoRata) references Inail_Sconto2 (IdSconto) on update no action on delete no action ;
Alter Table Uniemens_Posizione add Constraint Relationship1131 Foreign Key (IdTipoRegolarizzaz) references Inps_TipoRegolarizzaz (IdTipoRegolarizzaz) on update no action on delete no action ;
Alter Table DenunciaAziendale add Constraint Relationship1316 Foreign Key (IdTipoRegolarizzaz) references Inps_TipoRegolarizzaz (IdTipoRegolarizzaz) on update no action on delete no action ;
Alter Table EventoGiorno add Constraint Relationship1391 Foreign Key (IdDatoRetributivo,Gg) references Giorno (IdDatoRetributivo,Gg) on update no action on delete no action ;
Alter Table EventoCig add Constraint Relationship1085 Foreign Key (IdTipoEventoCig) references Inps_TipoEventoCig (IdTipoEventoCig) on update no action on delete no action ;
Alter Table EventoGiorno add Constraint Relationship1392 Foreign Key (IdTipoEventoCig) references Inps_TipoEventoCig (IdTipoEventoCig) on update no action on delete no action ;
Alter Table PagDiretto add Constraint Relationship1084 Foreign Key (IdDatoRetributivo,IdEventoCig) references EventoCig (IdDatoRetributivo,IdEventoCig) on update no action on delete no action ;
Alter Table CigAutorizzata add Constraint Relationship1089 Foreign Key (IdDenunciaAziendale) references ConguaglioCig (IdDenunciaAziendale) on update no action on delete no action ;
Alter Table Solidarieta add Constraint Relationship1092 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigAutorizzata (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CigInDeroga add Constraint Relationship1099 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigAutorizzata (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CigOrd add Constraint Relationship1101 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigAutorizzata (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CigStraord add Constraint Relationship1108 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigAutorizzata (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongCigoACredito add Constraint Relationship1102 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigOrd (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongCigoADebito add Constraint Relationship1103 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigOrd (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongCigsADebito add Constraint Relationship1106 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigStraord (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongCigsACredito add Constraint Relationship1107 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigStraord (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongCigdADebito add Constraint Relationship1097 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigInDeroga (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongCigdACredito add Constraint Relationship1098 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CigInDeroga (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongSolACredito add Constraint Relationship1091 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references Solidarieta (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table Da_CongFSolADebito add Constraint Relationship1384 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references Solidarieta (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table Da_CongFSolACredito add Constraint Relationship1385 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references Solidarieta (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongCigdAltro add Constraint Relationship1095 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CongCigdACredito (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongCigsAltro add Constraint Relationship1110 Foreign Key (IdCigAutorizzata,IdDenunciaAziendale) references CongCigsACredito (IdCigAutorizzata,IdDenunciaAziendale) on update no action on delete no action ;
Alter Table CongSolAltro add Constraint Relationship1090 Foreign Key (IdDenunciaAziendale,IdCigAutorizzata) references CongSolACredito (IdDenunciaAziendale,IdCigAutorizzata) on update no action on delete no action ;
Alter Table CongSolAltro add Constraint Relationship1093 Foreign Key (IdCausale) references CongSolAltCaus (IdCausale) on update no action on delete no action ;
Alter Table CongCigdAltro add Constraint Relationship1094 Foreign Key (IdCausale) references CongCigdAltCaus (IdCausale) on update no action on delete no action ;
Alter Table CongCigdADebito add Constraint Relationship1096 Foreign Key (IdCausale) references CongCigdCausAdd (IdCausale) on update no action on delete no action ;
Alter Table CongCigoAltro add Constraint Relationship1104 Foreign Key (IdCigAutorizzata,IdDenunciaAziendale) references CongCigoACredito (IdCigAutorizzata,IdDenunciaAziendale) on update no action on delete no action ;
Alter Table CongCigoADebito add Constraint Relationship1100 Foreign Key (IdCausale) references CongCigoCausAdd (IdCausale) on update no action on delete no action ;
Alter Table CongCigoAltro add Constraint Relationship1105 Foreign Key (IdCausale) references CongCigoAltCaus (IdCausale) on update no action on delete no action ;
Alter Table CongCigsADebito add Constraint Relationship1109 Foreign Key (IdCausale) references CongCigsCausAdd (IdCausale) on update no action on delete no action ;
Alter Table CongCigsAltro add Constraint Relationship1111 Foreign Key (IdCausale) references CongCigsAltCaus (IdCausale) on update no action on delete no action ;
Alter Table Assenza add Constraint Relationship1112 Foreign Key (IdOpzione) references AssenzaOpzione (IdOpzione) on update no action on delete no action ;
Alter Table TipoAssenza add Constraint Relationship1116 Foreign Key (IdCategoria) references CategoriaAssenza (IdCategoria) on update no action on delete no action ;
Alter Table ContrattoDettaglio add Constraint Relationship1129 Foreign Key (IdInfortunio) references ContrattoInfortunio (IdInfortunio) on update no action on delete no action ;
Alter Table ExIpost_Retrib add Constraint Relationship1124 Foreign Key (IdDatoRetributivo) references ExIpost (IdDatoRetributivo) on update no action on delete no action ;
Alter Table ExIpost_Anno add Constraint Relationship1126 Foreign Key (IdTipo,IdDatoRetributivo) references ExIpost_Retrib (IdTipo,IdDatoRetributivo) on update no action on delete no action ;
Alter Table ExIpost_Retrib add Constraint Relationship1125 Foreign Key (IdTipo) references ExIpost_Tipo (IdTipo) on update no action on delete no action ;
Alter Table Cnce_OreLavorate add Constraint Relationship1157 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_ElementoPaga add Constraint Relationship1167 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_Imponibile add Constraint Relationship1168 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_Accantonamento add Constraint Relationship1169 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_PrevComp add Constraint Relationship1170 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_OpzionePrevComp add Constraint Relationship1171 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_RecuperoPrevCompl add Constraint Relationship1172 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_DatiistitutoTfr add Constraint Relationship1174 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_Malattia add Constraint Relationship1183 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_LavCantiere add Constraint Relationship1184 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_AltroContributo add Constraint Relationship1204 Foreign Key (IdPosizione) references Cnce_PosizioneLavoratore (IdPosizione) on update no action on delete no action ;
Alter Table Cnce_PosizioneLavoratore add Constraint Relationship1136 Foreign Key (IdEsenzioneLimiteCcnl) references Cnce_EsenzioneLimiteCcnl (IdEsenzioneLimiteCcnl) on update no action on delete no action ;
Alter Table Cnce_PosizioneLavoratore add Constraint Relationship1135 Foreign Key (IdTIpoRapporto) references Cnce_TipoRapporto (IdTIpoRapporto) on update no action on delete no action ;
Alter Table Cnce_OpzionePrevComp add Constraint Relationship1186 Foreign Key (IdTipoTfr) references Cnce_OpzioneTfr (IdTipoTfr) on update no action on delete no action ;
Alter Table Cnce_AltroContributo add Constraint Relationship1160 Foreign Key (IdAltroContributo) references Cnce_TipoAltroContributo (IdAltroContributo) on update no action on delete no action ;
Alter Table Mut_Impresa add Constraint Relationship1163 Foreign Key (IdDichiarazione) references Mut (IdDichiarazione) on update no action on delete no action ;
Alter Table Mut_CantiereSituazione add Constraint Relationship1165 Foreign Key (IdDichiarazione,IdImpresa) references Mut_Impresa (IdDichiarazione,IdImpresa) on update no action on delete no action ;
Alter Table Mut_Lavoratore add Constraint Relationship1202 Foreign Key (IdDichiarazione,IdImpresa) references Mut_Impresa (IdDichiarazione,IdImpresa) on update no action on delete no action ;
Alter Table Mut_Riepilogo add Constraint Relationship1203 Foreign Key (IdDichiarazione,IdImpresa) references Mut_Impresa (IdDichiarazione,IdImpresa) on update no action on delete no action ;
Alter Table Cnce_Malattia add Constraint Relationship1177 Foreign Key (IdTipo) references Cnce_TipoMalattia (IdTipo) on update no action on delete no action ;
Alter Table Cnce_PrevComp add Constraint Relationship1178 Foreign Key (IdTipoAdesione) references Cnce_PrevCompTipo1 (IdTipoAdesione) on update no action on delete no action ;
Alter Table Cnce_PrevComp add Constraint Relationship1179 Foreign Key (IdTipoAdesione2) references Cnce_PrevCompTipo2 (IdTipoAdesione2) on update no action on delete no action ;
Alter Table ProfiloLavoratore add Constraint Relationship1193 Foreign Key (IdTipoMalattia1) references TipoCalcoloMalattia1 (IdTipoMalattia1) on update no action on delete no action ;
Alter Table PosizioneLavoratore add Constraint Relationship1195 Foreign Key (IdTipoMalattia1) references TipoCalcoloMalattia1 (IdTipoMalattia1) on update no action on delete no action ;
Alter Table ProfiloLavoratore add Constraint Relationship1194 Foreign Key (IdTipoMalattia2) references TipoCalcoloMalattia2 (IdTipoMalattia2) on update no action on delete no action ;
Alter Table Pa_PosizionePeriodo add Constraint Relationship1219 Foreign Key (IdPosizione) references Pa_PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Pa_FondoPensCompl add Constraint Relationship1235 Foreign Key (IdPosizione) references Pa_PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Pa_Ammortamento add Constraint Relationship1236 Foreign Key (IdPosizione) references Pa_PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Pa_MotivoUtilizzo add Constraint Relationship1279 Foreign Key (IdPosizione) references Pa_PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Pa_PosizionePeriodo add Constraint Relationship1227 Foreign Key (IdPaTipoCessazione) references Pa_TipoCessazione (IdPaTipoCessazione) on update no action on delete no action ;
Alter Table Pa_Inquadramento add Constraint Relationship1214 Foreign Key (IdPaQualifica,IdPaContratto) references Pa_Qualifica (IdPaQualifica,IdPaContratto) on update no action on delete no action ;
Alter Table Pa_Qualifica add Constraint Relationship1212 Foreign Key (IdPaContratto) references Pa_Contratto (IdPaContratto) on update no action on delete no action ;
Alter Table Pa_Inquadramento add Constraint Relationship1215 Foreign Key (IdTipoImpiego) references Pa_TipoImpiego (IdTipoImpiego) on update no action on delete no action ;
Alter Table Pa_Inquadramento add Constraint Relationship1216 Foreign Key (IdRegimeFineServ) references Pa_RegimeFineServizio (IdRegimeFineServ) on update no action on delete no action ;
Alter Table Pa_Inquadramento add Constraint Relationship1217 Foreign Key (IdTipoServizio) references Pa_TipoServizio (IdTipoServizio) on update no action on delete no action ;
Alter Table Pa_Inquadramento add Constraint Relationship1220 Foreign Key (IdPaPeriodo) references Pa_PosizionePeriodo (IdPaPeriodo) on update no action on delete no action ;
Alter Table Pa_Gestione add Constraint Relationship1233 Foreign Key (IdPaPeriodo) references Pa_PosizionePeriodo (IdPaPeriodo) on update no action on delete no action ;
Alter Table Pa_AltroEnteVersante add Constraint Relationship1234 Foreign Key (IdPaPeriodo) references Pa_PosizionePeriodo (IdPaPeriodo) on update no action on delete no action ;
Alter Table Pa_Inquadramento add Constraint Relationship1222 Foreign Key (IdTipoServizioAltro1) references Pa_TipoServizioAltro (IdTipoServizioAltro) on update no action on delete no action ;
Alter Table Pa_Inquadramento add Constraint Relationship1223 Foreign Key (IdTipoServizioAltro2) references Pa_TipoServizioAltro (IdTipoServizioAltro) on update no action on delete no action ;
Alter Table Pa_PosizioneSubordinato add Constraint Relationship1224 Foreign Key (IdTipoIscrFondoPrevCompl) references Pa_TipoIscrFondoPrevCompl (IdTipoIscrFondoPrevCompl) on update no action on delete no action ;
Alter Table Pa_ProfiloLavoratore add Constraint Relationship1225 Foreign Key (IdTipoIscrFondoPrevCompl) references Pa_TipoIscrFondoPrevCompl (IdTipoIscrFondoPrevCompl) on update no action on delete no action ;
Alter Table Pa_Gestione add Constraint Relationship1230 Foreign Key (IdGestPrevidenziale) references Pa_GestPrevidenziale (IdGestPrevidenziale) on update no action on delete no action ;
Alter Table Pa_Gestione add Constraint Relationship1232 Foreign Key (IdGestCredito) references Pa_GestCredito (IdGestCredito) on update no action on delete no action ;
Alter Table Pa_Gestione add Constraint Relationship1228 Foreign Key (IdGestEndep) references Pa_GestEndep (IdGestEndep) on update no action on delete no action ;
Alter Table Pa_Gestione add Constraint Relationship1229 Foreign Key (IdGestPensionistica) references Pa_GestPensionistica (IdGestPensionistica) on update no action on delete no action ;
Alter Table Pa_Gestione add Constraint Relationship1231 Foreign Key (IdGestEnam) references Pa_GestEnam (IdGestEnam) on update no action on delete no action ;
Alter Table Pa_FondoContribOmessi add Constraint Relationship1237 Foreign Key (IdPosizione,IdFondoPensComp) references Pa_FondoPensCompl (IdPosizione,IdFondoPensComp) on update no action on delete no action ;
Alter Table Pa_GestPensionistica add Constraint Relationship1238 Foreign Key (MaggCod1) references Pa_TipoMaggiorazione (IdTipoMaggiorazione) on update no action on delete no action ;
Alter Table Pa_GestPensionistica add Constraint Relationship1239 Foreign Key (MaggCod2) references Pa_TipoMaggiorazione (IdTipoMaggiorazione) on update no action on delete no action ;
Alter Table Pa_GestPensionistica add Constraint Relationship1240 Foreign Key (MaggCod3) references Pa_TipoMaggiorazione (IdTipoMaggiorazione) on update no action on delete no action ;
Alter Table Pa_GestPensionistica add Constraint Relationship1241 Foreign Key (RecuperoSgraviCod2) references Pa_TipoRecupero (IdTipoRecupero) on update no action on delete no action ;
Alter Table Pa_GestPensionistica add Constraint Relationship1242 Foreign Key (RecuperoSgraviCod1) references Pa_TipoRecupero (IdTipoRecupero) on update no action on delete no action ;
Alter Table Pa_Gestione add Constraint Relationship1245 Foreign Key (IdTipoGestione) references Pa_TipoGestione (IdTipoGestione) on update no action on delete no action ;
Alter Table Pa_Ammortamento add Constraint Relationship1252 Foreign Key (IdTipoGestione) references Pa_TipoGestione (IdTipoGestione) on update no action on delete no action ;
Alter Table Pa_AltroImporto add Constraint Relationship1255 Foreign Key (IdTipoGestione) references Pa_TipoGestione (IdTipoGestione) on update no action on delete no action ;
Alter Table Pa_AltroEnteVersante add Constraint Relationship1246 Foreign Key (IdTipoContributoAltroEnte) references Pa_TipoContributoAltroEnte (IdTipoContributoAltroEnte) on update no action on delete no action ;
Alter Table Pa_FondoPensCompl add Constraint Relationship1247 Foreign Key (IdFondo,IdComparto) references Pa_CompartoPensione (IdFondo,IdComparto) on update no action on delete no action ;
Alter Table Pa_CompartoPensione add Constraint Relationship1248 Foreign Key (IdFondo) references Pa_FondoPensione (IdFondo) on update no action on delete no action ;
Alter Table Pa_FondoPensCompl add Constraint Relationship1249 Foreign Key (IdTipoCessazFondo) references Pa_TipoCessazFondo (IdTipoCessazFondo) on update no action on delete no action ;
Alter Table Pa_FondoPensCompl add Constraint Relationship1250 Foreign Key (IdTipoSospensFondo) references Pa_TipoSospensFondo (IdTipoSospensFondo) on update no action on delete no action ;
Alter Table Pa_Ammortamento add Constraint Relationship1251 Foreign Key (IdTipoPiano) references Pa_TipoPianoAmmortamento (IdTipoPiano) on update no action on delete no action ;
Alter Table Pa_Ammortamento add Constraint Relationship1253 Foreign Key (IdTipoOperazione) references Pa_TipoOperazione (IdTipoOperazione) on update no action on delete no action ;
Alter Table Pa_PosizioneSubordinato add Constraint Relationship1254 Foreign Key (IdTipoVariazione) references Pa_TipoVariazione (IdTipoVariazione) on update no action on delete no action ;
Alter Table Pa_AltroImporto add Constraint Relationship1256 Foreign Key (IdTipoAltroImporto) references Pa_TipoAltroImporto (IdTipoAltroImporto) on update no action on delete no action ;
Alter Table Pa_PosizioneSubordinato add Constraint Relationship1257 Foreign Key (IdTipoAliquotaPosPrec) references Pa_TipoAliquotaPosPrec (IdTipoAliquotaPosPrec) on update no action on delete no action ;
Alter Table ContrattoApprendistato add Constraint Relationship1348 Foreign Key (IdInpsTipoApprendistato) references Inps_TipoApprendistato (IdInpsTipoApprendistato) on update no action on delete no action ;
Alter Table PosizioneSubordinato add Constraint Relationship1356 Foreign Key (IdInpsTipoApprendistato) references Inps_TipoApprendistato (IdInpsTipoApprendistato) on update no action on delete no action ;
Alter Table ProfiloLavoratore add Constraint Relationship1357 Foreign Key (IdInpsTipoApprendistato) references Inps_TipoApprendistato (IdInpsTipoApprendistato) on update no action on delete no action ;
Alter Table Sp_DatoRetribuzione add Constraint Relationship1264 Foreign Key (IdPosizione) references Sp_PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Sp_CausaleExtraContrib add Constraint Relationship1276 Foreign Key (IdPosizione) references Sp_PosizioneSubordinato (IdPosizione) on update no action on delete no action ;
Alter Table Sp_DatoRetribuzione add Constraint Relationship1265 Foreign Key (IdQualifica) references Sp_Qualifica (IdQualifica) on update no action on delete no action ;
Alter Table Sp_ProfiloLavoratore add Constraint Relationship1269 Foreign Key (IdQualifica) references Sp_Qualifica (IdQualifica) on update no action on delete no action ;
Alter Table Sp_DatoRetribuzione add Constraint Relationship1266 Foreign Key (IdTipoRapporto) references Sp_TipoRapporto (IdTipoRapporto) on update no action on delete no action ;
Alter Table Sp_ProfiloLavoratore add Constraint Relationship1270 Foreign Key (IdTipoRapporto) references Sp_TipoRapporto (IdTipoRapporto) on update no action on delete no action ;
Alter Table Sp_DatoRetribuzione add Constraint Relationship1267 Foreign Key (IdTipoRetribuzione) references Sp_TipoRetribuzione (IdTipoRetribuzione) on update no action on delete no action ;
Alter Table Sp_ProfiloLavoratore add Constraint Relationship1271 Foreign Key (IdTipoRetribuzione) references Sp_TipoRetribuzione (IdTipoRetribuzione) on update no action on delete no action ;
Alter Table Sp_DatoRetribuzione add Constraint Relationship1272 Foreign Key (IdAliquota) references Sp_Aliquota (IdAliquota) on update no action on delete no action ;
Alter Table Sp_ProfiloLavoratore add Constraint Relationship1273 Foreign Key (IdAliquota) references Sp_Aliquota (IdAliquota) on update no action on delete no action ;
Alter Table Sp_CausaleExtraContrib add Constraint Relationship1278 Foreign Key (IdAliquota) references Sp_Aliquota (IdAliquota) on update no action on delete no action ;
Alter Table Sp_ProfiloLavoratore add Constraint Relationship1274 Foreign Key (IdAgevolazione) references Sp_Agevolazione (IdAgevolazione) on update no action on delete no action ;
Alter Table Sp_DatoRetribuzione add Constraint Relationship1275 Foreign Key (IdAgevolazione) references Sp_Agevolazione (IdAgevolazione) on update no action on delete no action ;
Alter Table Sp_CausaleExtraContrib add Constraint Relationship1277 Foreign Key (IdTipoExtraContrib) references Sp_TipoExtraContrib (IdTipoExtraContrib) on update no action on delete no action ;
Alter Table Pa_PosizioneSubordinato add Constraint Relationship1280 Foreign Key (IdTipoUtilizzo) references Pa_TipoUtilizzo (IdTipoUtilizzo) on update no action on delete no action ;
Alter Table Cnce_CassaEdilePerc add Constraint Relationship1281 Foreign Key (IdCassaEdile) references Cnce_CassaEdileConfig (IdCassaEdile) on update no action on delete no action ;
Alter Table Cnce_PosizioneLavoratore add Constraint Relationship1282 Foreign Key (IdCassaEdile) references Cnce_CassaEdileConfig (IdCassaEdile) on update no action on delete no action ;
Alter Table Scadenza add Constraint Relationship1286 Foreign Key (IdScadenzario) references Scadenzario (IdScadenzario) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1302 Foreign Key (IdTipoPartTimeGor) references Dmag_TipoPartTimeGor (IdTipoPartTimeGor) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1307 Foreign Key (IdTipoPartTimeGor) references Dmag_TipoPartTimeGor (IdTipoPartTimeGor) on update no action on delete no action ;
Alter Table Dmag_DatoRetrib add Constraint Relationship1304 Foreign Key (IdTipoAgevolaz) references Dmag_TipoAgevolaz (IdTipoAgevolaz) on update no action on delete no action ;
Alter Table Dmag_LavoratoreProfilo add Constraint Relationship1308 Foreign Key (IdTipoAgevolaz) references Dmag_TipoAgevolaz (IdTipoAgevolaz) on update no action on delete no action ;
Alter Table Dmag_AzSomm add Constraint Relationship1288 Foreign Key (IdDichiarazione) references Dmag (IdDichiarazione) on update no action on delete no action ;
Alter Table Dmag_Impresa add Constraint Relationship1325 Foreign Key (IdDichiarazione) references Dmag (IdDichiarazione) on update no action on delete no action ;
Alter Table ProfiloConfig add Constraint Relationship1318 Foreign Key (IdOpzione) references ProfiloOpzione (IdOpzione) on update no action on delete no action ;
Alter Table Pa_AltroImportoACong add Constraint Relationship1323 Foreign Key (IdTipoConguaglio) references Pa_TipoConguaglio (IdTipoConguaglio) on update no action on delete no action ;
Alter Table Pa_AltroImportoACong add Constraint Relationship1327 Foreign Key (IdDichiarazione) references Pa (IdDichiarazione) on update no action on delete no action ;
Alter Table Pa_AltroImporto add Constraint Relationship1328 Foreign Key (IdDichiarazione) references Pa (IdDichiarazione) on update no action on delete no action ;
Alter Table Conguaglio730_PosLav add Constraint Relationship1334 Foreign Key (IdLavoratore,Anno,Rif730) references Conguaglio730 (IdLavoratore,Anno,Rif730) on update no action on delete no action ;
Alter Table CuImpresa add Constraint Relationship1336 Foreign Key (Anno,IdCuGruppo) references CuGruppo (Anno,IdCuGruppo) on update no action on delete no action ;
Alter Table CuLavoratore add Constraint Relationship1339 Foreign Key (Anno,IdCuGruppo,IdImpresa) references CuImpresa (Anno,IdCuGruppo,IdImpresa) on update no action on delete no action ;
Alter Table CuLavRecord add Constraint Relationship1338 Foreign Key (AnnoCuRecord,IdCuSezione,IdCuRecord) references CuRecord (Anno,IdCuSezione,IdCuRecord) on update no action on delete no action ;
Alter Table CuLavRecord add Constraint Relationship1340 Foreign Key (Anno,IdCuGruppo,IdImpresa,IdLavoratore) references CuLavoratore (Anno,IdCuGruppo,IdImpresa,IdLavoratore) on update no action on delete no action ;
Alter Table CuLavAnnotaz add Constraint Relationship1344 Foreign Key (Anno,IdCuGruppo,IdImpresa,IdLavoratore) references CuLavoratore (Anno,IdCuGruppo,IdImpresa,IdLavoratore) on update no action on delete no action ;
Alter Table CuRecord add Constraint Relationship1342 Foreign Key (Anno,IdCuSezione) references CuRecordSezione (Anno,IdCuSezione) on update no action on delete no action ;
Alter Table CuLavAnnotaz add Constraint Relationship1343 Foreign Key (AnnoAnnotaz,IdCuAnnotaz) references CuAnnotazione (Anno,IdCuAnnotaz) on update no action on delete no action ;
Alter Table PosizioneInail add Constraint Relationship1345 Foreign Key (IdInailQualificaCu) references Inail_QualificaCu (IdInailQualificaCu) on update no action on delete no action ;
Alter Table ProfiloInail add Constraint Relationship1346 Foreign Key (IdInailQualificaCu) references Inail_QualificaCu (IdInailQualificaCu) on update no action on delete no action ;
Alter Table ProfiloPrevidenziale add Constraint Relationship1352 Foreign Key (IdAliquotaAddizDat) references Inps_AliquotaAddiz (IdAliquotaAddiz) on update no action on delete no action ;
Alter Table ProfiloPrevidenziale add Constraint Relationship1353 Foreign Key (IdAliquotaAddizLav) references Inps_AliquotaAddiz (IdAliquotaAddiz) on update no action on delete no action ;
Alter Table PosizionePrevidenziale add Constraint Relationship1354 Foreign Key (IdAliquotaAddizDat) references Inps_AliquotaAddiz (IdAliquotaAddiz) on update no action on delete no action ;
Alter Table PosizionePrevidenziale add Constraint Relationship1355 Foreign Key (IdAliquotaAddizLav) references Inps_AliquotaAddiz (IdAliquotaAddiz) on update no action on delete no action ;
Alter Table M770Impresa add Constraint Relationship1360 Foreign Key (Anno,IdM770Gruppo) references M770Gruppo (Anno,IdM770Gruppo) on update no action on delete no action ;
Alter Table M770Record add Constraint Relationship1361 Foreign Key (Anno,IdM770Sezione) references M770RecordSezione (Anno,IdM770Sezione) on update no action on delete no action ;
Alter Table Da_CongFSolADebito add Constraint Relationship1387 Foreign Key (IdCongFSolCausaleADebito) references Da_CongFSolCausaleADebito (IdCongFSolCausaleADebito) on update no action on delete no action ;
Alter Table Da_CongFSolACredito add Constraint Relationship1388 Foreign Key (IdCongFSolCausaleACredito) references Da_CongFSolCausaleACredito (IdCongFSolCausaleACredito) on update no action on delete no action ;
Alter Table Inps_IntegrazioneSalariale add Constraint Relationship1389 Foreign Key (IdTipo) references Inps_TipoIntegrazioneSalariale (IdTipo) on update no action on delete no action ;
Alter Table ProfiloLavoratore add Constraint Relationship1394 Foreign Key (IdTipoRetrMal) references TipoRetrMal (IdTipoRetrMal) on update no action on delete no action ;
Alter Table PosizioneLavoratore add Constraint Relationship1395 Foreign Key (IdTipoRetrMal) references TipoRetrMal (IdTipoRetrMal) on update no action on delete no action ;
Alter Table Dr_CausaleContribAgg add Constraint Relationship1398 Foreign Key (IdCausale) references Dr_TipoCausaleContribAgg (IdCausale) on update no action on delete no action ;
Alter Table M730Anno add Constraint Relationship1400 Foreign Key (IdTipo) references M730Tipo (IdTipo) on update no action on delete no action ;
Alter Table M730Anno add Constraint Relationship1329 Foreign Key (IdLavoratore,AnnoRiferimento) references PosizioneFiscaleAnno (IdLavoratore,AnnoRiferimento) on update no action on delete no action ;
Alter Table M730Mese add Constraint Relationship1399 Foreign Key (IdLavoratore,AnnoRiferimento,IdTipo) references M730Anno (IdLavoratore,AnnoRiferimento,IdTipo) on update no action on delete no action ;

COMMIT WORK;

/******************************************************************************/
/****                                Views		                           ****/
/******************************************************************************/

CREATE VIEW VIEW_POSIZIONESUBORDINATO AS
SELECT POSIZIONELAVORATORE.IDPOSIZIONE, POSIZIONELAVORATORE.ANNORIFERIMENTO, POSIZIONELAVORATORE.MESERIFERIMENTO,
POSIZIONESUBORDINATO.IDINPSQUALIFICA1, INPS_QUALIFICA1.DESCRIZIONE AS QUALIFICA1,
POSIZIONESUBORDINATO.IDINPSQUALIFICA2, INPS_QUALIFICA2.DESCRIZIONE AS QUALIFICA2,
POSIZIONESUBORDINATO.IDINPSQUALIFICA3, INPS_QUALIFICA3.DESCRIZIONE AS QUALIFICA3,
POSIZIONESUBORDINATO.IDINPSTIPOCONTRIBUZIONE, INPS_TIPOCONTRIBUZIONE.DESCRIZIONE AS TIPOCONTRIBUZIONE,
POSIZIONESUBORDINATO.IDLIVELLO, POSIZIONESUBORDINATO.PARTTIMEORARIO, POSIZIONESUBORDINATO.PARTTIMECONTRATTO,
POSIZIONESUBORDINATO.IDTIPOCALCOLO, TIPOCALCOLO.DESCRIZIONE AS TIPOCALCOLO,
POSIZIONELAVORATORE.MATRICOLAINPS
FROM POSIZIONESUBORDINATO
LEFT JOIN POSIZIONELAVORATORE on POSIZIONELAVORATORE.IDPOSIZIONE = POSIZIONESUBORDINATO.IDPOSIZIONE
LEFT JOIN INPS_QUALIFICA1 on POSIZIONESUBORDINATO.IDINPSQUALIFICA1 = INPS_QUALIFICA1.IDINPSQUALIFICA1
LEFT JOIN INPS_QUALIFICA2 on POSIZIONESUBORDINATO.IDINPSQUALIFICA2 = INPS_QUALIFICA2.IDINPSQUALIFICA2
LEFT JOIN INPS_QUALIFICA3 on POSIZIONESUBORDINATO.IDINPSQUALIFICA3 = INPS_QUALIFICA3.IDINPSQUALIFICA3
LEFT JOIN INPS_TIPOCONTRIBUZIONE on POSIZIONESUBORDINATO.IDINPSTIPOCONTRIBUZIONE = INPS_TIPOCONTRIBUZIONE.IDINPSTIPOCONTRIBUZIONE
LEFT JOIN TIPOCALCOLO on POSIZIONESUBORDINATO.IDTIPOCALCOLO = TIPOCALCOLO.IDTIPOCALCOLO
ORDER BY POSIZIONELAVORATORE.ANNORIFERIMENTO, POSIZIONELAVORATORE.MESERIFERIMENTO;

COMMIT WORK;

/******************************************************************************/
/****                                Exceptions                            ****/
/******************************************************************************/

Create Exception except_del_p 'Children still exist in child table. Cannot delete parent.';
Create Exception except_ins_ch 'Parent does not exist. Cannot create child.';
Create Exception except_upd_ch 'Parent does not exist. Cannot update child.';
Create Exception except_upd_p 'Children still exist in child table. Cannot update parent.';
Create Exception except_ins_ch_card 'Maximum cardinality exceeded. Cannot insert into child.';
Create Exception except_upd_ch_card 'Maximum cardinality exceeded. Cannot update child.';


/******************************************************************************/
/****                                Users permissions                     ****/
/******************************************************************************/

Grant select on DbInfo to SYSDBA;
Grant update on DbInfo to SYSDBA;
Grant delete on DbInfo to SYSDBA;
Grant insert on DbInfo to SYSDBA;
Grant references on DbInfo to SYSDBA;

/******************************************************************************/
/****                                Done                                  ****/
/******************************************************************************/

COMMIT WORK;